/* chess-engine.c generated by valac 0.56.18, the Vala compiler
 * generated from chess-engine.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2014 Michael Catanzaro
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include "libengine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "libchess.h"
#include <glib-object.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CHESS_ENGINE_0_PROPERTY,
	CHESS_ENGINE_NUM_PROPERTIES
};
static GParamSpec* chess_engine_properties[CHESS_ENGINE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	CHESS_ENGINE_STARTING_SIGNAL,
	CHESS_ENGINE_MOVED_SIGNAL,
	CHESS_ENGINE_RESIGNED_SIGNAL,
	CHESS_ENGINE_STOPPED_UNEXPECTEDLY_SIGNAL,
	CHESS_ENGINE_ERROR_SIGNAL,
	CHESS_ENGINE_CLAIM_DRAW_SIGNAL,
	CHESS_ENGINE_OFFER_DRAW_SIGNAL,
	CHESS_ENGINE_NUM_SIGNALS
};
static guint chess_engine_signals[CHESS_ENGINE_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ChessEnginePrivate {
	gchar* binary;
	gchar** args;
	gint args_length1;
	gint _args_size_;
	guint delay_seconds;
	guint pending_move_source_id;
	GPid pid;
	gint stdin_fd;
	gint stderr_fd;
	GIOChannel* stdout_channel;
	guint stdout_watch_id;
	gboolean started;
};

static gint ChessEngine_private_offset;
static gpointer chess_engine_parent_class = NULL;

static void chess_engine_real_process_input (ChessEngine* self,
                                      gchar* data,
                                      gint data_length1);
static gchar** _vala_array_dup15 (gchar** self,
                           gssize length);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void chess_engine_engine_stopped_cb (ChessEngine* self,
                                     GPid pid);
static void _chess_engine_engine_stopped_cb_gchild_watch_func (GPid pid,
                                                        gint wait_status,
                                                        gpointer self);
static gboolean chess_engine_read_cb (ChessEngine* self,
                               GIOChannel* source,
                               GIOCondition condition);
static gboolean _chess_engine_read_cb_gio_func (GIOChannel* source,
                                         GIOCondition condition,
                                         gpointer self);
static void chess_engine_real_start_game (ChessEngine* self);
static void chess_engine_real_report_move (ChessEngine* self,
                                    ChessMove* move);
static void chess_engine_real_do_undo (ChessEngine* self);
static void chess_engine_real_request_move (ChessEngine* self);
static gboolean __lambda4_ (ChessEngine* self);
static gboolean ___lambda4__gsource_func (gpointer self);
static void chess_engine_finalize (GObject * obj);
static GType chess_engine_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
chess_engine_get_instance_private (ChessEngine* self)
{
	return G_STRUCT_MEMBER_P (self, ChessEngine_private_offset);
}

static void
chess_engine_real_process_input (ChessEngine* self,
                                 gchar* data,
                                 gint data_length1)
{
}

void
chess_engine_process_input (ChessEngine* self,
                            gchar* data,
                            gint data_length1)
{
	ChessEngineClass* _klass_;
#line 29 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 29 "../engine/chess-engine.vala"
	_klass_ = CHESS_ENGINE_GET_CLASS (self);
#line 29 "../engine/chess-engine.vala"
	if (_klass_->process_input) {
#line 29 "../engine/chess-engine.vala"
		_klass_->process_input (self, data, data_length1);
#line 149 "chess-engine.c"
	}
}

static gchar**
_vala_array_dup15 (gchar** self,
                   gssize length)
{
#line 42 "../engine/chess-engine.vala"
	if (length >= 0) {
#line 159 "chess-engine.c"
		gchar** result;
		gssize i;
#line 42 "../engine/chess-engine.vala"
		result = g_new0 (gchar*, length + 1);
#line 42 "../engine/chess-engine.vala"
		for (i = 0; i < length; i++) {
#line 166 "chess-engine.c"
			gchar* _tmp0_;
#line 42 "../engine/chess-engine.vala"
			_tmp0_ = g_strdup (self[i]);
#line 42 "../engine/chess-engine.vala"
			result[i] = _tmp0_;
#line 172 "chess-engine.c"
		}
#line 42 "../engine/chess-engine.vala"
		return result;
#line 176 "chess-engine.c"
	}
#line 42 "../engine/chess-engine.vala"
	return NULL;
#line 180 "chess-engine.c"
}

ChessEngine*
chess_engine_construct (GType object_type,
                        const gchar* binary,
                        gchar** args,
                        gint args_length1,
                        guint delay_seconds)
{
	ChessEngine * self = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 39 "../engine/chess-engine.vala"
	g_return_val_if_fail (binary != NULL, NULL);
#line 39 "../engine/chess-engine.vala"
	self = (ChessEngine*) g_object_new (object_type, NULL);
#line 41 "../engine/chess-engine.vala"
	_tmp0_ = g_strdup (binary);
#line 41 "../engine/chess-engine.vala"
	_g_free0 (self->priv->binary);
#line 41 "../engine/chess-engine.vala"
	self->priv->binary = _tmp0_;
#line 42 "../engine/chess-engine.vala"
	_tmp1_ = (args != NULL) ? _vala_array_dup15 (args, args_length1) : args;
#line 42 "../engine/chess-engine.vala"
	_tmp1__length1 = args_length1;
#line 42 "../engine/chess-engine.vala"
	self->priv->args = (_vala_array_free (self->priv->args, self->priv->args_length1, (GDestroyNotify) g_free), NULL);
#line 42 "../engine/chess-engine.vala"
	self->priv->args = _tmp1_;
#line 42 "../engine/chess-engine.vala"
	self->priv->args_length1 = _tmp1__length1;
#line 42 "../engine/chess-engine.vala"
	self->priv->_args_size_ = self->priv->args_length1;
#line 43 "../engine/chess-engine.vala"
	self->priv->delay_seconds = delay_seconds;
#line 39 "../engine/chess-engine.vala"
	return self;
#line 220 "chess-engine.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 60 "../engine/chess-engine.vala"
	if ((*length) == (*size)) {
#line 60 "../engine/chess-engine.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 60 "../engine/chess-engine.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 235 "chess-engine.c"
	}
#line 60 "../engine/chess-engine.vala"
	(*array)[(*length)++] = value;
#line 60 "../engine/chess-engine.vala"
	(*array)[*length] = NULL;
#line 241 "chess-engine.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 61 "../engine/chess-engine.vala"
	if ((*length) == (*size)) {
#line 61 "../engine/chess-engine.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 61 "../engine/chess-engine.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 256 "chess-engine.c"
	}
#line 61 "../engine/chess-engine.vala"
	(*array)[(*length)++] = value;
#line 61 "../engine/chess-engine.vala"
	(*array)[*length] = NULL;
#line 262 "chess-engine.c"
}

static void
_chess_engine_engine_stopped_cb_gchild_watch_func (GPid pid,
                                                   gint wait_status,
                                                   gpointer self)
{
#line 76 "../engine/chess-engine.vala"
	chess_engine_engine_stopped_cb ((ChessEngine*) self, pid);
#line 272 "chess-engine.c"
}

static gboolean
_chess_engine_read_cb_gio_func (GIOChannel* source,
                                GIOCondition condition,
                                gpointer self)
{
	gboolean result;
	result = chess_engine_read_cb ((ChessEngine*) self, source, condition);
#line 88 "../engine/chess-engine.vala"
	return result;
#line 284 "chess-engine.c"
}

gboolean
chess_engine_start (ChessEngine* self)
{
	gchar** argv = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint stdout_fd = 0;
	GIOChannel* _tmp16_;
	GIOChannel* _tmp22_;
	GIOChannel* _tmp23_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 51 "../engine/chess-engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../engine/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->pid == ((GPid) 0), "pid == 0", FALSE);
#line 51 "../engine/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->stdout_watch_id == ((guint) 0), "stdout_watch_id == 0", FALSE);
#line 51 "../engine/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->stdin_fd == -1, "stdin_fd == -1", FALSE);
#line 51 "../engine/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->stderr_fd == -1, "stderr_fd == -1", FALSE);
#line 51 "../engine/chess-engine.vala"
	_vala_return_val_if_fail (!self->priv->started, "!started", FALSE);
#line 58 "../engine/chess-engine.vala"
	_tmp0_ = self->priv->binary;
#line 58 "../engine/chess-engine.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 58 "../engine/chess-engine.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 58 "../engine/chess-engine.vala"
	_tmp2_[0] = _tmp1_;
#line 58 "../engine/chess-engine.vala"
	argv = _tmp2_;
#line 58 "../engine/chess-engine.vala"
	argv_length1 = 1;
#line 58 "../engine/chess-engine.vala"
	_argv_size_ = argv_length1;
#line 59 "../engine/chess-engine.vala"
	_tmp3_ = self->priv->args;
#line 59 "../engine/chess-engine.vala"
	_tmp3__length1 = self->priv->args_length1;
#line 334 "chess-engine.c"
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 59 "../engine/chess-engine.vala"
		arg_collection = _tmp3_;
#line 59 "../engine/chess-engine.vala"
		arg_collection_length1 = _tmp3__length1;
#line 59 "../engine/chess-engine.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 346 "chess-engine.c"
			gchar* _tmp4_;
			gchar* arg = NULL;
#line 59 "../engine/chess-engine.vala"
			_tmp4_ = g_strdup (arg_collection[arg_it]);
#line 59 "../engine/chess-engine.vala"
			arg = _tmp4_;
#line 353 "chess-engine.c"
			{
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 60 "../engine/chess-engine.vala"
				_tmp5_ = arg;
#line 60 "../engine/chess-engine.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 60 "../engine/chess-engine.vala"
				_vala_array_add1 (&argv, &argv_length1, &_argv_size_, _tmp6_);
#line 59 "../engine/chess-engine.vala"
				_g_free0 (arg);
#line 365 "chess-engine.c"
			}
		}
	}
#line 61 "../engine/chess-engine.vala"
	_vala_array_add2 (&argv, &argv_length1, &_argv_size_, NULL);
#line 371 "chess-engine.c"
	{
		gchar** _tmp7_;
		gint _tmp7__length1;
		GPid _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
#line 66 "../engine/chess-engine.vala"
		_tmp7_ = argv;
#line 66 "../engine/chess-engine.vala"
		_tmp7__length1 = argv_length1;
#line 66 "../engine/chess-engine.vala"
		g_spawn_async_with_pipes (NULL, _tmp7_, NULL, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 66 "../engine/chess-engine.vala"
		self->priv->pid = _tmp8_;
#line 66 "../engine/chess-engine.vala"
		self->priv->stdin_fd = _tmp9_;
#line 66 "../engine/chess-engine.vala"
		stdout_fd = _tmp10_;
#line 66 "../engine/chess-engine.vala"
		self->priv->stderr_fd = _tmp11_;
#line 66 "../engine/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 395 "chess-engine.c"
			gboolean _tmp12_ = FALSE;
#line 66 "../engine/chess-engine.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 399 "chess-engine.c"
				goto __catch0_g_spawn_error;
			}
#line 66 "../engine/chess-engine.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../engine/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 66 "../engine/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 66 "../engine/chess-engine.vala"
			return _tmp12_;
#line 410 "chess-engine.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 64 "../engine/chess-engine.vala"
		e = _inner_error0_;
#line 64 "../engine/chess-engine.vala"
		_inner_error0_ = NULL;
#line 72 "../engine/chess-engine.vala"
		_tmp13_ = e;
#line 72 "../engine/chess-engine.vala"
		_tmp14_ = _tmp13_->message;
#line 72 "../engine/chess-engine.vala"
		g_warning ("chess-engine.vala:72: Failed to execute chess engine: %s\n", _tmp14_);
#line 73 "../engine/chess-engine.vala"
		result = FALSE;
#line 73 "../engine/chess-engine.vala"
		_g_error_free0 (e);
#line 73 "../engine/chess-engine.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 73 "../engine/chess-engine.vala"
		return result;
#line 437 "chess-engine.c"
	}
	__finally0:
#line 64 "../engine/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 442 "chess-engine.c"
		gboolean _tmp15_ = FALSE;
#line 64 "../engine/chess-engine.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 64 "../engine/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../engine/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../engine/chess-engine.vala"
		return _tmp15_;
#line 452 "chess-engine.c"
	}
#line 76 "../engine/chess-engine.vala"
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, self->priv->pid, _chess_engine_engine_stopped_cb_gchild_watch_func, g_object_ref (self), g_object_unref);
#line 78 "../engine/chess-engine.vala"
	_tmp16_ = g_io_channel_unix_new (stdout_fd);
#line 78 "../engine/chess-engine.vala"
	_g_io_channel_unref0 (self->priv->stdout_channel);
#line 78 "../engine/chess-engine.vala"
	self->priv->stdout_channel = _tmp16_;
#line 462 "chess-engine.c"
	{
		GIOChannel* _tmp17_;
#line 81 "../engine/chess-engine.vala"
		_tmp17_ = self->priv->stdout_channel;
#line 81 "../engine/chess-engine.vala"
		g_io_channel_set_flags (_tmp17_, G_IO_FLAG_NONBLOCK, &_inner_error0_);
#line 81 "../engine/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 471 "chess-engine.c"
			gboolean _tmp18_ = FALSE;
#line 81 "../engine/chess-engine.vala"
			if (_inner_error0_->domain == G_IO_CHANNEL_ERROR) {
#line 475 "chess-engine.c"
				goto __catch1_g_io_channel_error;
			}
#line 81 "../engine/chess-engine.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../engine/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../engine/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 81 "../engine/chess-engine.vala"
			return _tmp18_;
#line 486 "chess-engine.c"
		}
	}
	goto __finally1;
	__catch1_g_io_channel_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 79 "../engine/chess-engine.vala"
		e = _inner_error0_;
#line 79 "../engine/chess-engine.vala"
		_inner_error0_ = NULL;
#line 85 "../engine/chess-engine.vala"
		_tmp19_ = e;
#line 85 "../engine/chess-engine.vala"
		_tmp20_ = _tmp19_->message;
#line 85 "../engine/chess-engine.vala"
		g_warning ("chess-engine.vala:85: Failed to set input from chess engine to non-blo" \
"cking: %s", _tmp20_);
#line 79 "../engine/chess-engine.vala"
		_g_error_free0 (e);
#line 507 "chess-engine.c"
	}
	__finally1:
#line 79 "../engine/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 512 "chess-engine.c"
		gboolean _tmp21_ = FALSE;
#line 79 "../engine/chess-engine.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 79 "../engine/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../engine/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 79 "../engine/chess-engine.vala"
		return _tmp21_;
#line 522 "chess-engine.c"
	}
#line 87 "../engine/chess-engine.vala"
	_tmp22_ = self->priv->stdout_channel;
#line 87 "../engine/chess-engine.vala"
	g_io_channel_set_close_on_unref (_tmp22_, TRUE);
#line 88 "../engine/chess-engine.vala"
	_tmp23_ = self->priv->stdout_channel;
#line 88 "../engine/chess-engine.vala"
	self->priv->stdout_watch_id = g_io_add_watch (_tmp23_, G_IO_IN, _chess_engine_read_cb_gio_func, self);
#line 90 "../engine/chess-engine.vala"
	self->priv->started = TRUE;
#line 91 "../engine/chess-engine.vala"
	g_signal_emit (self, chess_engine_signals[CHESS_ENGINE_STARTING_SIGNAL], 0);
#line 93 "../engine/chess-engine.vala"
	result = TRUE;
#line 93 "../engine/chess-engine.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 93 "../engine/chess-engine.vala"
	return result;
#line 542 "chess-engine.c"
}

static void
chess_engine_engine_stopped_cb (ChessEngine* self,
                                GPid pid)
{
#line 96 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 102 "../engine/chess-engine.vala"
	g_spawn_close_pid (pid);
#line 104 "../engine/chess-engine.vala"
	if (self->priv->pid == pid) {
#line 106 "../engine/chess-engine.vala"
		chess_engine_stop (self, FALSE);
#line 107 "../engine/chess-engine.vala"
		g_signal_emit (self, chess_engine_signals[CHESS_ENGINE_STOPPED_UNEXPECTEDLY_SIGNAL], 0);
#line 559 "chess-engine.c"
	}
}

static void
chess_engine_real_start_game (ChessEngine* self)
{
#line 111 "../engine/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_start_game'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 111 "../engine/chess-engine.vala"
	return;
#line 570 "chess-engine.c"
}

void
chess_engine_start_game (ChessEngine* self)
{
	ChessEngineClass* _klass_;
#line 111 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 111 "../engine/chess-engine.vala"
	_klass_ = CHESS_ENGINE_GET_CLASS (self);
#line 111 "../engine/chess-engine.vala"
	if (_klass_->start_game) {
#line 111 "../engine/chess-engine.vala"
		_klass_->start_game (self);
#line 585 "chess-engine.c"
	}
}

static void
chess_engine_real_report_move (ChessEngine* self,
                               ChessMove* move)
{
#line 113 "../engine/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_report_move'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 113 "../engine/chess-engine.vala"
	return;
#line 597 "chess-engine.c"
}

void
chess_engine_report_move (ChessEngine* self,
                          ChessMove* move)
{
	ChessEngineClass* _klass_;
#line 113 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 113 "../engine/chess-engine.vala"
	_klass_ = CHESS_ENGINE_GET_CLASS (self);
#line 113 "../engine/chess-engine.vala"
	if (_klass_->report_move) {
#line 113 "../engine/chess-engine.vala"
		_klass_->report_move (self, move);
#line 613 "chess-engine.c"
	}
}

static void
chess_engine_real_do_undo (ChessEngine* self)
{
#line 115 "../engine/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_do_undo'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 115 "../engine/chess-engine.vala"
	return;
#line 624 "chess-engine.c"
}

void
chess_engine_do_undo (ChessEngine* self)
{
	ChessEngineClass* _klass_;
#line 115 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 115 "../engine/chess-engine.vala"
	_klass_ = CHESS_ENGINE_GET_CLASS (self);
#line 115 "../engine/chess-engine.vala"
	if (_klass_->do_undo) {
#line 115 "../engine/chess-engine.vala"
		_klass_->do_undo (self);
#line 639 "chess-engine.c"
	}
}

static void
chess_engine_real_request_move (ChessEngine* self)
{
#line 117 "../engine/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_request_move'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 117 "../engine/chess-engine.vala"
	return;
#line 650 "chess-engine.c"
}

void
chess_engine_request_move (ChessEngine* self)
{
	ChessEngineClass* _klass_;
#line 117 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 117 "../engine/chess-engine.vala"
	_klass_ = CHESS_ENGINE_GET_CLASS (self);
#line 117 "../engine/chess-engine.vala"
	if (_klass_->request_move) {
#line 117 "../engine/chess-engine.vala"
		_klass_->request_move (self);
#line 665 "chess-engine.c"
	}
}

static gboolean
__lambda4_ (ChessEngine* self)
{
	gboolean result;
#line 122 "../engine/chess-engine.vala"
	self->priv->pending_move_source_id = (guint) 0;
#line 123 "../engine/chess-engine.vala"
	chess_engine_request_move (self);
#line 124 "../engine/chess-engine.vala"
	result = G_SOURCE_REMOVE;
#line 124 "../engine/chess-engine.vala"
	return result;
#line 681 "chess-engine.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((ChessEngine*) self);
#line 121 "../engine/chess-engine.vala"
	return result;
#line 691 "chess-engine.c"
}

void
chess_engine_move (ChessEngine* self)
{
#line 119 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 121 "../engine/chess-engine.vala"
	self->priv->pending_move_source_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, self->priv->delay_seconds, ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 701 "chess-engine.c"
}

void
chess_engine_undo (ChessEngine* self)
{
#line 128 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 130 "../engine/chess-engine.vala"
	if (self->priv->pending_move_source_id != ((guint) 0)) {
#line 132 "../engine/chess-engine.vala"
		g_source_remove (self->priv->pending_move_source_id);
#line 133 "../engine/chess-engine.vala"
		self->priv->pending_move_source_id = (guint) 0;
#line 715 "chess-engine.c"
	}
#line 136 "../engine/chess-engine.vala"
	chess_engine_do_undo (self);
#line 719 "chess-engine.c"
}

void
chess_engine_stop (ChessEngine* self,
                   gboolean kill_engine)
{
	GIOChannel* _tmp0_;
	gboolean _tmp6_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 139 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 139 "../engine/chess-engine.vala"
	_tmp0_ = self->priv->stdout_channel;
#line 139 "../engine/chess-engine.vala"
	_vala_return_if_fail ((!self->priv->started) || (_tmp0_ != NULL), "!started || stdout_channel != null");
#line 139 "../engine/chess-engine.vala"
	_vala_return_if_fail ((!self->priv->started) || (self->priv->stdin_fd != -1), "!started || stdin_fd != -1");
#line 139 "../engine/chess-engine.vala"
	_vala_return_if_fail ((!self->priv->started) || (self->priv->stderr_fd != -1), "!started || stderr_fd != -1");
#line 139 "../engine/chess-engine.vala"
	_vala_return_if_fail ((!self->priv->started) || (self->priv->pid != ((GPid) 0)), "!started || pid != 0");
#line 145 "../engine/chess-engine.vala"
	if (!self->priv->started) {
#line 146 "../engine/chess-engine.vala"
		return;
#line 745 "chess-engine.c"
	}
#line 147 "../engine/chess-engine.vala"
	self->priv->started = FALSE;
#line 150 "../engine/chess-engine.vala"
	if (self->priv->stdout_watch_id != ((guint) 0)) {
#line 151 "../engine/chess-engine.vala"
		g_source_remove (self->priv->stdout_watch_id);
#line 152 "../engine/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 755 "chess-engine.c"
	}
	{
		GIOChannel* _tmp1_;
#line 157 "../engine/chess-engine.vala"
		_tmp1_ = self->priv->stdout_channel;
#line 157 "../engine/chess-engine.vala"
		g_io_channel_shutdown (_tmp1_, FALSE, &_inner_error0_);
#line 157 "../engine/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../engine/chess-engine.vala"
			if (_inner_error0_->domain == G_IO_CHANNEL_ERROR) {
#line 767 "chess-engine.c"
				goto __catch0_g_io_channel_error;
			}
#line 157 "../engine/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 157 "../engine/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 157 "../engine/chess-engine.vala"
			return;
#line 776 "chess-engine.c"
		}
	}
	goto __finally0;
	__catch0_g_io_channel_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 155 "../engine/chess-engine.vala"
		e = _inner_error0_;
#line 155 "../engine/chess-engine.vala"
		_inner_error0_ = NULL;
#line 161 "../engine/chess-engine.vala"
		_tmp2_ = e;
#line 161 "../engine/chess-engine.vala"
		_tmp3_ = _tmp2_->message;
#line 161 "../engine/chess-engine.vala"
		g_warning ("chess-engine.vala:161: Failed to close channel to engine's stdout: %s", _tmp3_);
#line 155 "../engine/chess-engine.vala"
		_g_error_free0 (e);
#line 797 "chess-engine.c"
	}
	__finally0:
#line 155 "../engine/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "../engine/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 155 "../engine/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 155 "../engine/chess-engine.vala"
		return;
#line 808 "chess-engine.c"
	}
#line 163 "../engine/chess-engine.vala"
	_g_io_channel_unref0 (self->priv->stdout_channel);
#line 163 "../engine/chess-engine.vala"
	self->priv->stdout_channel = NULL;
#line 165 "../engine/chess-engine.vala"
	if (close (self->priv->stdin_fd) == -1) {
#line 816 "chess-engine.c"
		const gchar* _tmp4_;
#line 166 "../engine/chess-engine.vala"
		_tmp4_ = g_strerror (errno);
#line 166 "../engine/chess-engine.vala"
		g_warning ("chess-engine.vala:166: Failed to close pipe to engine's stdin: %s", _tmp4_);
#line 822 "chess-engine.c"
	}
#line 167 "../engine/chess-engine.vala"
	self->priv->stdin_fd = -1;
#line 169 "../engine/chess-engine.vala"
	if (close (self->priv->stderr_fd) == -1) {
#line 828 "chess-engine.c"
		const gchar* _tmp5_;
#line 170 "../engine/chess-engine.vala"
		_tmp5_ = g_strerror (errno);
#line 170 "../engine/chess-engine.vala"
		g_warning ("chess-engine.vala:170: Failed to close pipe to engine's stderr: %s", _tmp5_);
#line 834 "chess-engine.c"
	}
#line 171 "../engine/chess-engine.vala"
	self->priv->stderr_fd = -1;
#line 173 "../engine/chess-engine.vala"
	if (kill_engine) {
#line 173 "../engine/chess-engine.vala"
		_tmp6_ = kill ((pid_t) self->priv->pid, (gint) SIGTERM) == -1;
#line 842 "chess-engine.c"
	} else {
#line 173 "../engine/chess-engine.vala"
		_tmp6_ = FALSE;
#line 846 "chess-engine.c"
	}
#line 173 "../engine/chess-engine.vala"
	if (_tmp6_) {
#line 850 "chess-engine.c"
		const gchar* _tmp7_;
#line 174 "../engine/chess-engine.vala"
		_tmp7_ = g_strerror (errno);
#line 174 "../engine/chess-engine.vala"
		g_warning ("chess-engine.vala:174: Failed to kill engine: %s", _tmp7_);
#line 856 "chess-engine.c"
	}
#line 175 "../engine/chess-engine.vala"
	self->priv->pid = (GPid) 0;
#line 860 "chess-engine.c"
}

static gboolean
chess_engine_read_cb (ChessEngine* self,
                      GIOChannel* source,
                      GIOCondition condition)
{
	gchar* buf = NULL;
	gint buf_length1 = 0;
	gint _buf_size_ = 0;
	gsize n_read = 0UL;
	GIOStatus status = 0;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 178 "../engine/chess-engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 178 "../engine/chess-engine.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 178 "../engine/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->stdout_watch_id != ((guint) 0), "stdout_watch_id != 0", FALSE);
#line 185 "../engine/chess-engine.vala"
	_tmp0_ = g_new0 (gchar, 1024);
#line 185 "../engine/chess-engine.vala"
	buf = (g_free (buf), NULL);
#line 185 "../engine/chess-engine.vala"
	buf = _tmp0_;
#line 185 "../engine/chess-engine.vala"
	buf_length1 = 1024;
#line 185 "../engine/chess-engine.vala"
	_buf_size_ = buf_length1;
#line 892 "chess-engine.c"
	{
		GIOStatus _tmp1_ = 0;
		gchar* _tmp2_;
		gint _tmp2__length1;
		gsize _tmp3_ = 0UL;
		GIOStatus _tmp4_;
#line 188 "../engine/chess-engine.vala"
		_tmp2_ = buf;
#line 188 "../engine/chess-engine.vala"
		_tmp2__length1 = buf_length1;
#line 188 "../engine/chess-engine.vala"
		_tmp4_ = g_io_channel_read_chars (source, _tmp2_, (gint) _tmp2__length1, &_tmp3_, &_inner_error0_);
#line 188 "../engine/chess-engine.vala"
		n_read = _tmp3_;
#line 188 "../engine/chess-engine.vala"
		_tmp1_ = _tmp4_;
#line 188 "../engine/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 911 "chess-engine.c"
			gboolean _tmp5_ = FALSE;
#line 188 "../engine/chess-engine.vala"
			if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 915 "chess-engine.c"
				goto __catch0_g_convert_error;
			}
#line 188 "../engine/chess-engine.vala"
			if (_inner_error0_->domain == G_IO_CHANNEL_ERROR) {
#line 920 "chess-engine.c"
				goto __catch0_g_io_channel_error;
			}
#line 188 "../engine/chess-engine.vala"
			buf = (g_free (buf), NULL);
#line 188 "../engine/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../engine/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 188 "../engine/chess-engine.vala"
			return _tmp5_;
#line 931 "chess-engine.c"
		}
#line 188 "../engine/chess-engine.vala"
		status = _tmp1_;
#line 935 "chess-engine.c"
	}
	goto __finally0;
	__catch0_g_convert_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 186 "../engine/chess-engine.vala"
		e = _inner_error0_;
#line 186 "../engine/chess-engine.vala"
		_inner_error0_ = NULL;
#line 192 "../engine/chess-engine.vala"
		_tmp6_ = e;
#line 192 "../engine/chess-engine.vala"
		_tmp7_ = _tmp6_->message;
#line 192 "../engine/chess-engine.vala"
		g_warning ("chess-engine.vala:192: Failed to read from engine: %s", _tmp7_);
#line 193 "../engine/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 194 "../engine/chess-engine.vala"
		result = FALSE;
#line 194 "../engine/chess-engine.vala"
		_g_error_free0 (e);
#line 194 "../engine/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 194 "../engine/chess-engine.vala"
		return result;
#line 963 "chess-engine.c"
	}
	goto __finally0;
	__catch0_g_io_channel_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 186 "../engine/chess-engine.vala"
		e = _inner_error0_;
#line 186 "../engine/chess-engine.vala"
		_inner_error0_ = NULL;
#line 198 "../engine/chess-engine.vala"
		_tmp8_ = e;
#line 198 "../engine/chess-engine.vala"
		_tmp9_ = _tmp8_->message;
#line 198 "../engine/chess-engine.vala"
		g_warning ("chess-engine.vala:198: Failed to read from engine: %s", _tmp9_);
#line 199 "../engine/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 200 "../engine/chess-engine.vala"
		result = FALSE;
#line 200 "../engine/chess-engine.vala"
		_g_error_free0 (e);
#line 200 "../engine/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 200 "../engine/chess-engine.vala"
		return result;
#line 991 "chess-engine.c"
	}
	__finally0:
#line 186 "../engine/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 996 "chess-engine.c"
		gboolean _tmp10_ = FALSE;
#line 186 "../engine/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 186 "../engine/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 186 "../engine/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 186 "../engine/chess-engine.vala"
		return _tmp10_;
#line 1006 "chess-engine.c"
	}
#line 203 "../engine/chess-engine.vala"
	if (status == G_IO_STATUS_EOF) {
#line 205 "../engine/chess-engine.vala"
		g_debug ("chess-engine.vala:205: EOF");
#line 206 "../engine/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 207 "../engine/chess-engine.vala"
		result = FALSE;
#line 207 "../engine/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 207 "../engine/chess-engine.vala"
		return result;
#line 1020 "chess-engine.c"
	}
#line 209 "../engine/chess-engine.vala"
	if (status == G_IO_STATUS_NORMAL) {
#line 1024 "chess-engine.c"
		gint _tmp11_;
		gchar* _tmp12_;
		gint _tmp12__length1;
#line 211 "../engine/chess-engine.vala"
		_tmp11_ = (gint) n_read;
#line 211 "../engine/chess-engine.vala"
		buf = g_renew (gchar, buf, (gint) n_read);
#line 211 "../engine/chess-engine.vala"
		(_tmp11_ > buf_length1) ? memset (buf + buf_length1, 0, sizeof (gchar) * (_tmp11_ - buf_length1)) : NULL;
#line 211 "../engine/chess-engine.vala"
		buf_length1 = _tmp11_;
#line 211 "../engine/chess-engine.vala"
		_buf_size_ = _tmp11_;
#line 212 "../engine/chess-engine.vala"
		_tmp12_ = buf;
#line 212 "../engine/chess-engine.vala"
		_tmp12__length1 = buf_length1;
#line 212 "../engine/chess-engine.vala"
		chess_engine_process_input (self, _tmp12_, (gint) _tmp12__length1);
#line 1044 "chess-engine.c"
	}
#line 215 "../engine/chess-engine.vala"
	result = TRUE;
#line 215 "../engine/chess-engine.vala"
	buf = (g_free (buf), NULL);
#line 215 "../engine/chess-engine.vala"
	return result;
#line 1052 "chess-engine.c"
}

void
chess_engine_write (ChessEngine* self,
                    gchar* data,
                    gint data_length1)
{
	gsize offset = 0UL;
	gsize n_written = 0UL;
#line 218 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 220 "../engine/chess-engine.vala"
	offset = (gsize) 0;
#line 221 "../engine/chess-engine.vala"
	n_written = (gsize) 0;
#line 1068 "chess-engine.c"
	{
		gboolean _tmp0_ = FALSE;
#line 223 "../engine/chess-engine.vala"
		_tmp0_ = TRUE;
#line 223 "../engine/chess-engine.vala"
		while (TRUE) {
#line 223 "../engine/chess-engine.vala"
			if (!_tmp0_) {
#line 1077 "chess-engine.c"
				gboolean _tmp1_ = FALSE;
#line 227 "../engine/chess-engine.vala"
				if (n_written > ((gsize) 0)) {
#line 227 "../engine/chess-engine.vala"
					_tmp1_ = offset < ((gsize) data_length1);
#line 1083 "chess-engine.c"
				} else {
#line 227 "../engine/chess-engine.vala"
					_tmp1_ = FALSE;
#line 1087 "chess-engine.c"
				}
#line 227 "../engine/chess-engine.vala"
				if (!_tmp1_) {
#line 227 "../engine/chess-engine.vala"
					break;
#line 1093 "chess-engine.c"
				}
			}
#line 223 "../engine/chess-engine.vala"
			_tmp0_ = FALSE;
#line 225 "../engine/chess-engine.vala"
			n_written = (gsize) write (self->priv->stdin_fd, &data[offset], data_length1 - offset);
#line 226 "../engine/chess-engine.vala"
			offset += n_written;
#line 1102 "chess-engine.c"
		}
	}
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1616 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1617 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1617 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1617 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1618 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1618 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1618 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1618 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1620 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1621 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1621 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1621 "glib-2.0.vapi"
	if (result_length1) {
#line 1621 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 1152 "chess-engine.c"
	}
#line 1621 "glib-2.0.vapi"
	result = _tmp4_;
#line 1621 "glib-2.0.vapi"
	return result;
#line 1158 "chess-engine.c"
}

void
chess_engine_write_line (ChessEngine* self,
                         const gchar* line)
{
	gchar* l = NULL;
	gchar* _tmp0_;
	gchar* d = NULL;
	const gchar* _tmp1_;
	gint _tmp2_ = 0;
	gchar* _tmp3_;
	gint d_length1;
	gint _d_size_;
	gchar* _tmp4_;
	gint _tmp4__length1;
#line 230 "../engine/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 230 "../engine/chess-engine.vala"
	g_return_if_fail (line != NULL);
#line 232 "../engine/chess-engine.vala"
	_tmp0_ = g_strconcat (line, "\n", NULL);
#line 232 "../engine/chess-engine.vala"
	l = _tmp0_;
#line 233 "../engine/chess-engine.vala"
	g_debug ("chess-engine.vala:233: Writing line to engine: '%s'", line);
#line 234 "../engine/chess-engine.vala"
	_tmp1_ = l;
#line 234 "../engine/chess-engine.vala"
	_tmp3_ = string_to_utf8 (_tmp1_, &_tmp2_);
#line 234 "../engine/chess-engine.vala"
	d = _tmp3_;
#line 234 "../engine/chess-engine.vala"
	d_length1 = _tmp2_;
#line 234 "../engine/chess-engine.vala"
	_d_size_ = d_length1;
#line 235 "../engine/chess-engine.vala"
	_tmp4_ = d;
#line 235 "../engine/chess-engine.vala"
	_tmp4__length1 = d_length1;
#line 235 "../engine/chess-engine.vala"
	if (_tmp4_ != NULL) {
#line 1201 "chess-engine.c"
		gchar* _tmp5_;
		gint _tmp5__length1;
#line 236 "../engine/chess-engine.vala"
		_tmp5_ = d;
#line 236 "../engine/chess-engine.vala"
		_tmp5__length1 = d_length1;
#line 236 "../engine/chess-engine.vala"
		chess_engine_write (self, _tmp5_, (gint) _tmp5__length1);
#line 1210 "chess-engine.c"
	}
#line 230 "../engine/chess-engine.vala"
	d = (g_free (d), NULL);
#line 230 "../engine/chess-engine.vala"
	_g_free0 (l);
#line 1216 "chess-engine.c"
}

static void
chess_engine_class_init (ChessEngineClass * klass,
                         gpointer klass_data)
{
#line 14 "../engine/chess-engine.vala"
	chess_engine_parent_class = g_type_class_peek_parent (klass);
#line 14 "../engine/chess-engine.vala"
	g_type_class_adjust_private_offset (klass, &ChessEngine_private_offset);
#line 14 "../engine/chess-engine.vala"
	((ChessEngineClass *) klass)->process_input = (void (*) (ChessEngine*, gchar*, gint)) chess_engine_real_process_input;
#line 14 "../engine/chess-engine.vala"
	((ChessEngineClass *) klass)->start_game = (void (*) (ChessEngine*)) chess_engine_real_start_game;
#line 14 "../engine/chess-engine.vala"
	((ChessEngineClass *) klass)->report_move = (void (*) (ChessEngine*, ChessMove*)) chess_engine_real_report_move;
#line 14 "../engine/chess-engine.vala"
	((ChessEngineClass *) klass)->do_undo = (void (*) (ChessEngine*)) chess_engine_real_do_undo;
#line 14 "../engine/chess-engine.vala"
	((ChessEngineClass *) klass)->request_move = (void (*) (ChessEngine*)) chess_engine_real_request_move;
#line 14 "../engine/chess-engine.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_engine_finalize;
#line 14 "../engine/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_STARTING_SIGNAL] = g_signal_new ("starting", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../engine/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 14 "../engine/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_RESIGNED_SIGNAL] = g_signal_new ("resigned", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../engine/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_STOPPED_UNEXPECTEDLY_SIGNAL] = g_signal_new ("stopped-unexpectedly", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../engine/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_ERROR_SIGNAL] = g_signal_new ("error", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../engine/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_CLAIM_DRAW_SIGNAL] = g_signal_new ("claim-draw", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../engine/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_OFFER_DRAW_SIGNAL] = g_signal_new ("offer-draw", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1253 "chess-engine.c"
}

static void
chess_engine_instance_init (ChessEngine * self,
                            gpointer klass)
{
#line 14 "../engine/chess-engine.vala"
	self->priv = chess_engine_get_instance_private (self);
#line 22 "../engine/chess-engine.vala"
	self->priv->pid = (GPid) 0;
#line 23 "../engine/chess-engine.vala"
	self->priv->stdin_fd = -1;
#line 24 "../engine/chess-engine.vala"
	self->priv->stderr_fd = -1;
#line 26 "../engine/chess-engine.vala"
	self->priv->stdout_watch_id = (guint) 0;
#line 27 "../engine/chess-engine.vala"
	self->priv->started = FALSE;
#line 1272 "chess-engine.c"
}

static void
chess_engine_finalize (GObject * obj)
{
	ChessEngine * self;
#line 14 "../engine/chess-engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_ENGINE, ChessEngine);
#line 48 "../engine/chess-engine.vala"
	_vala_assert (!self->priv->started, "!started");
#line 16 "../engine/chess-engine.vala"
	_g_free0 (self->priv->binary);
#line 17 "../engine/chess-engine.vala"
	self->priv->args = (_vala_array_free (self->priv->args, self->priv->args_length1, (GDestroyNotify) g_free), NULL);
#line 25 "../engine/chess-engine.vala"
	_g_io_channel_unref0 (self->priv->stdout_channel);
#line 14 "../engine/chess-engine.vala"
	G_OBJECT_CLASS (chess_engine_parent_class)->finalize (obj);
#line 1291 "chess-engine.c"
}

static GType
chess_engine_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessEngineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_engine_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessEngine), 0, (GInstanceInitFunc) chess_engine_instance_init, NULL };
	GType chess_engine_type_id;
	chess_engine_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessEngine", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	ChessEngine_private_offset = g_type_add_instance_private (chess_engine_type_id, sizeof (ChessEnginePrivate));
	return chess_engine_type_id;
}

GType
chess_engine_get_type (void)
{
	static volatile gsize chess_engine_type_id__once = 0;
	if (g_once_init_enter (&chess_engine_type_id__once)) {
		GType chess_engine_type_id;
		chess_engine_type_id = chess_engine_get_type_once ();
		g_once_init_leave (&chess_engine_type_id__once, chess_engine_type_id);
	}
	return chess_engine_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

