/* chess-move.c generated by valac 0.56.18, the Vala compiler
 * generated from chess-move.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2016 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include "libchess.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CHESS_MOVE_0_PROPERTY,
	CHESS_MOVE_NUM_PROPERTIES
};
static GParamSpec* chess_move_properties[CHESS_MOVE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

static gpointer chess_move_parent_class = NULL;

static gchar* chess_move_make_san (ChessMove* self,
                            gchar** piece_names,
                            gint piece_names_length1);
static void chess_move_finalize (GObject * obj);
static GType chess_move_get_type_once (void);

gchar*
chess_move_get_lan (ChessMove* self)
{
	ChessPiece* _tmp0_;
	GString* builder = NULL;
	GString* _tmp3_;
	ChessPiece* _tmp4_;
#line 44 "../lib/chess-move.vala"
	static const gchar promotion_symbols[6] = {' ', 'R', 'N', 'B', 'Q', 'K'};
#line 56 "chess-move.c"
	ChessPiece* _tmp7_;
	GString* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* result;
#line 28 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../lib/chess-move.vala"
	_tmp0_ = self->castling_rook;
#line 30 "../lib/chess-move.vala"
	if (_tmp0_ != NULL) {
#line 32 "../lib/chess-move.vala"
		if (self->f1 > self->f0) {
#line 70 "chess-move.c"
			gchar* _tmp1_;
#line 33 "../lib/chess-move.vala"
			_tmp1_ = g_strdup ("O-O");
#line 33 "../lib/chess-move.vala"
			result = _tmp1_;
#line 33 "../lib/chess-move.vala"
			return result;
#line 78 "chess-move.c"
		} else {
			gchar* _tmp2_;
#line 35 "../lib/chess-move.vala"
			_tmp2_ = g_strdup ("O-O-O");
#line 35 "../lib/chess-move.vala"
			result = _tmp2_;
#line 35 "../lib/chess-move.vala"
			return result;
#line 87 "chess-move.c"
		}
	}
#line 38 "../lib/chess-move.vala"
	_tmp3_ = g_string_new ("");
#line 38 "../lib/chess-move.vala"
	builder = _tmp3_;
#line 39 "../lib/chess-move.vala"
	_tmp4_ = self->victim;
#line 39 "../lib/chess-move.vala"
	if (_tmp4_ != NULL) {
#line 98 "chess-move.c"
		GString* _tmp5_;
#line 40 "../lib/chess-move.vala"
		_tmp5_ = builder;
#line 40 "../lib/chess-move.vala"
		g_string_append_printf (_tmp5_, "%c%dx%c%d", 'a' + self->f0, self->r0 + 1, 'a' + self->f1, self->r1 + 1);
#line 104 "chess-move.c"
	} else {
		GString* _tmp6_;
#line 42 "../lib/chess-move.vala"
		_tmp6_ = builder;
#line 42 "../lib/chess-move.vala"
		g_string_append_printf (_tmp6_, "%c%d-%c%d", 'a' + self->f0, self->r0 + 1, 'a' + self->f1, self->r1 + 1);
#line 111 "chess-move.c"
	}
#line 45 "../lib/chess-move.vala"
	_tmp7_ = self->promotion_piece;
#line 45 "../lib/chess-move.vala"
	if (_tmp7_ != NULL) {
#line 117 "chess-move.c"
		GString* _tmp8_;
		ChessPiece* _tmp9_;
		gchar _tmp10_;
#line 46 "../lib/chess-move.vala"
		_tmp8_ = builder;
#line 46 "../lib/chess-move.vala"
		_tmp9_ = self->promotion_piece;
#line 46 "../lib/chess-move.vala"
		_tmp10_ = promotion_symbols[_tmp9_->type];
#line 46 "../lib/chess-move.vala"
		g_string_append_printf (_tmp8_, "=%c", (gint) _tmp10_);
#line 129 "chess-move.c"
	}
#line 48 "../lib/chess-move.vala"
	switch (self->check_state) {
#line 48 "../lib/chess-move.vala"
		case CHECK_STATE_CHECK:
#line 135 "chess-move.c"
		{
			GString* _tmp11_;
#line 51 "../lib/chess-move.vala"
			_tmp11_ = builder;
#line 51 "../lib/chess-move.vala"
			g_string_append_c (_tmp11_, '+');
#line 52 "../lib/chess-move.vala"
			break;
#line 144 "chess-move.c"
		}
#line 48 "../lib/chess-move.vala"
		case CHECK_STATE_CHECKMATE:
#line 148 "chess-move.c"
		{
			GString* _tmp12_;
#line 54 "../lib/chess-move.vala"
			_tmp12_ = builder;
#line 54 "../lib/chess-move.vala"
			g_string_append_c (_tmp12_, '#');
#line 55 "../lib/chess-move.vala"
			break;
#line 157 "chess-move.c"
		}
		default:
		{
#line 57 "../lib/chess-move.vala"
			break;
#line 163 "chess-move.c"
		}
	}
#line 60 "../lib/chess-move.vala"
	_tmp13_ = builder;
#line 60 "../lib/chess-move.vala"
	_tmp14_ = _tmp13_->str;
#line 60 "../lib/chess-move.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 60 "../lib/chess-move.vala"
	result = _tmp15_;
#line 60 "../lib/chess-move.vala"
	_g_string_free0 (builder);
#line 60 "../lib/chess-move.vala"
	return result;
#line 178 "chess-move.c"
}

gchar*
chess_move_get_san (ChessMove* self)
{
#line 65 "../lib/chess-move.vala"
	static const gchar* piece_names[6] = {"", "R", "N", "B", "Q", "K"};
#line 186 "chess-move.c"
	gchar* _tmp0_;
	gchar* result;
#line 63 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../lib/chess-move.vala"
	_tmp0_ = chess_move_make_san (self, (gchar**) piece_names, (gint) ((G_N_ELEMENTS (piece_names) * sizeof (const gchar*)) / sizeof (gchar*)));
#line 66 "../lib/chess-move.vala"
	result = _tmp0_;
#line 66 "../lib/chess-move.vala"
	return result;
#line 197 "chess-move.c"
}

gchar*
chess_move_get_fan (ChessMove* self)
{
#line 71 "../lib/chess-move.vala"
	static const gchar* white_piece_names[6] = {"", "♖", "♘", "♗", "♕", "♔"};
#line 72 "../lib/chess-move.vala"
	static const gchar* black_piece_names[6] = {"", "♜", "♞", "♝", "♛", "♚"};
#line 207 "chess-move.c"
	ChessPiece* _tmp0_;
	Color _tmp1_;
	Color _tmp2_;
	gchar* result;
#line 69 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../lib/chess-move.vala"
	_tmp0_ = self->piece;
#line 73 "../lib/chess-move.vala"
	_tmp1_ = chess_piece_get_color (_tmp0_);
#line 73 "../lib/chess-move.vala"
	_tmp2_ = _tmp1_;
#line 73 "../lib/chess-move.vala"
	if (_tmp2_ == COLOR_WHITE) {
#line 222 "chess-move.c"
		gchar* _tmp3_;
#line 74 "../lib/chess-move.vala"
		_tmp3_ = chess_move_make_san (self, (gchar**) white_piece_names, (gint) ((G_N_ELEMENTS (white_piece_names) * sizeof (const gchar*)) / sizeof (gchar*)));
#line 74 "../lib/chess-move.vala"
		result = _tmp3_;
#line 74 "../lib/chess-move.vala"
		return result;
#line 230 "chess-move.c"
	} else {
		gchar* _tmp4_;
#line 76 "../lib/chess-move.vala"
		_tmp4_ = chess_move_make_san (self, (gchar**) black_piece_names, (gint) ((G_N_ELEMENTS (black_piece_names) * sizeof (const gchar*)) / sizeof (gchar*)));
#line 76 "../lib/chess-move.vala"
		result = _tmp4_;
#line 76 "../lib/chess-move.vala"
		return result;
#line 239 "chess-move.c"
	}
}

static gchar*
chess_move_make_san (ChessMove* self,
                     gchar** piece_names,
                     gint piece_names_length1)
{
	ChessPiece* _tmp0_;
	GString* builder = NULL;
	GString* _tmp3_;
	GString* _tmp4_;
	ChessPiece* _tmp5_;
	const gchar* _tmp6_;
	ChessPiece* _tmp9_;
	GString* _tmp11_;
	ChessPiece* _tmp12_;
	GString* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* result;
#line 79 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "../lib/chess-move.vala"
	_tmp0_ = self->castling_rook;
#line 81 "../lib/chess-move.vala"
	if (_tmp0_ != NULL) {
#line 83 "../lib/chess-move.vala"
		if (self->f1 > self->f0) {
#line 269 "chess-move.c"
			gchar* _tmp1_;
#line 84 "../lib/chess-move.vala"
			_tmp1_ = g_strdup ("O-O");
#line 84 "../lib/chess-move.vala"
			result = _tmp1_;
#line 84 "../lib/chess-move.vala"
			return result;
#line 277 "chess-move.c"
		} else {
			gchar* _tmp2_;
#line 86 "../lib/chess-move.vala"
			_tmp2_ = g_strdup ("O-O-O");
#line 86 "../lib/chess-move.vala"
			result = _tmp2_;
#line 86 "../lib/chess-move.vala"
			return result;
#line 286 "chess-move.c"
		}
	}
#line 89 "../lib/chess-move.vala"
	_tmp3_ = g_string_new ("");
#line 89 "../lib/chess-move.vala"
	builder = _tmp3_;
#line 90 "../lib/chess-move.vala"
	_tmp4_ = builder;
#line 90 "../lib/chess-move.vala"
	_tmp5_ = self->piece;
#line 90 "../lib/chess-move.vala"
	_tmp6_ = piece_names[_tmp5_->type];
#line 90 "../lib/chess-move.vala"
	g_string_append (_tmp4_, _tmp6_);
#line 91 "../lib/chess-move.vala"
	if (self->ambiguous_file) {
#line 303 "chess-move.c"
		GString* _tmp7_;
#line 92 "../lib/chess-move.vala"
		_tmp7_ = builder;
#line 92 "../lib/chess-move.vala"
		g_string_append_printf (_tmp7_, "%c", 'a' + self->f0);
#line 309 "chess-move.c"
	}
#line 93 "../lib/chess-move.vala"
	if (self->ambiguous_rank) {
#line 313 "chess-move.c"
		GString* _tmp8_;
#line 94 "../lib/chess-move.vala"
		_tmp8_ = builder;
#line 94 "../lib/chess-move.vala"
		g_string_append_printf (_tmp8_, "%d", self->r0 + 1);
#line 319 "chess-move.c"
	}
#line 95 "../lib/chess-move.vala"
	_tmp9_ = self->victim;
#line 95 "../lib/chess-move.vala"
	if (_tmp9_ != NULL) {
#line 325 "chess-move.c"
		GString* _tmp10_;
#line 96 "../lib/chess-move.vala"
		_tmp10_ = builder;
#line 96 "../lib/chess-move.vala"
		g_string_append (_tmp10_, "x");
#line 331 "chess-move.c"
	}
#line 97 "../lib/chess-move.vala"
	_tmp11_ = builder;
#line 97 "../lib/chess-move.vala"
	g_string_append_printf (_tmp11_, "%c%d", 'a' + self->f1, self->r1 + 1);
#line 99 "../lib/chess-move.vala"
	_tmp12_ = self->promotion_piece;
#line 99 "../lib/chess-move.vala"
	if (_tmp12_ != NULL) {
#line 341 "chess-move.c"
		GString* _tmp13_;
		ChessPiece* _tmp14_;
		const gchar* _tmp15_;
#line 100 "../lib/chess-move.vala"
		_tmp13_ = builder;
#line 100 "../lib/chess-move.vala"
		_tmp14_ = self->promotion_piece;
#line 100 "../lib/chess-move.vala"
		_tmp15_ = piece_names[_tmp14_->type];
#line 100 "../lib/chess-move.vala"
		g_string_append_printf (_tmp13_, "=%s", _tmp15_);
#line 353 "chess-move.c"
	}
#line 102 "../lib/chess-move.vala"
	switch (self->check_state) {
#line 102 "../lib/chess-move.vala"
		case CHECK_STATE_CHECK:
#line 359 "chess-move.c"
		{
			GString* _tmp16_;
#line 105 "../lib/chess-move.vala"
			_tmp16_ = builder;
#line 105 "../lib/chess-move.vala"
			g_string_append_c (_tmp16_, '+');
#line 106 "../lib/chess-move.vala"
			break;
#line 368 "chess-move.c"
		}
#line 102 "../lib/chess-move.vala"
		case CHECK_STATE_CHECKMATE:
#line 372 "chess-move.c"
		{
			GString* _tmp17_;
#line 108 "../lib/chess-move.vala"
			_tmp17_ = builder;
#line 108 "../lib/chess-move.vala"
			g_string_append_c (_tmp17_, '#');
#line 109 "../lib/chess-move.vala"
			break;
#line 381 "chess-move.c"
		}
		default:
		{
#line 111 "../lib/chess-move.vala"
			break;
#line 387 "chess-move.c"
		}
	}
#line 114 "../lib/chess-move.vala"
	_tmp18_ = builder;
#line 114 "../lib/chess-move.vala"
	_tmp19_ = _tmp18_->str;
#line 114 "../lib/chess-move.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 114 "../lib/chess-move.vala"
	result = _tmp20_;
#line 114 "../lib/chess-move.vala"
	_g_string_free0 (builder);
#line 114 "../lib/chess-move.vala"
	return result;
#line 402 "chess-move.c"
}

gchar*
chess_move_get_engine (ChessMove* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
#line 121 "../lib/chess-move.vala"
	static const gchar promotion_symbols[6] = {' ', 'r', 'n', 'b', 'q', ' '};
#line 412 "chess-move.c"
	ChessPiece* _tmp1_;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 118 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "../lib/chess-move.vala"
	_tmp0_ = g_string_new ("");
#line 120 "../lib/chess-move.vala"
	builder = _tmp0_;
#line 122 "../lib/chess-move.vala"
	_tmp1_ = self->promotion_piece;
#line 122 "../lib/chess-move.vala"
	if (_tmp1_ != NULL) {
#line 428 "chess-move.c"
		GString* _tmp2_;
		ChessPiece* _tmp3_;
		gchar _tmp4_;
#line 123 "../lib/chess-move.vala"
		_tmp2_ = builder;
#line 123 "../lib/chess-move.vala"
		_tmp3_ = self->promotion_piece;
#line 123 "../lib/chess-move.vala"
		_tmp4_ = promotion_symbols[_tmp3_->type];
#line 123 "../lib/chess-move.vala"
		g_string_append_printf (_tmp2_, "%c%d%c%d%c", 'a' + self->f0, self->r0 + 1, 'a' + self->f1, self->r1 + 1, (gint) _tmp4_);
#line 440 "chess-move.c"
	} else {
		GString* _tmp5_;
#line 125 "../lib/chess-move.vala"
		_tmp5_ = builder;
#line 125 "../lib/chess-move.vala"
		g_string_append_printf (_tmp5_, "%c%d%c%d", 'a' + self->f0, self->r0 + 1, 'a' + self->f1, self->r1 + 1);
#line 447 "chess-move.c"
	}
#line 126 "../lib/chess-move.vala"
	_tmp6_ = builder;
#line 126 "../lib/chess-move.vala"
	_tmp7_ = _tmp6_->str;
#line 126 "../lib/chess-move.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 126 "../lib/chess-move.vala"
	result = _tmp8_;
#line 126 "../lib/chess-move.vala"
	_g_string_free0 (builder);
#line 126 "../lib/chess-move.vala"
	return result;
#line 461 "chess-move.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 133 "../lib/chess-move.vala"
	return self ? g_object_ref (self) : NULL;
#line 469 "chess-move.c"
}

ChessMove*
chess_move_copy (ChessMove* self)
{
	ChessMove* move = NULL;
	ChessMove* _tmp0_;
	ChessPiece* _tmp1_;
	ChessPiece* _tmp2_;
	ChessPiece* _tmp3_;
	ChessPiece* _tmp4_;
	ChessPiece* _tmp5_;
	ChessPiece* _tmp6_;
	ChessPiece* _tmp7_;
	ChessPiece* _tmp8_;
	ChessMove* result;
#line 129 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 131 "../lib/chess-move.vala"
	_tmp0_ = chess_move_new ();
#line 131 "../lib/chess-move.vala"
	move = _tmp0_;
#line 132 "../lib/chess-move.vala"
	move->number = self->number;
#line 133 "../lib/chess-move.vala"
	_tmp1_ = self->piece;
#line 133 "../lib/chess-move.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 133 "../lib/chess-move.vala"
	_g_object_unref0 (move->piece);
#line 133 "../lib/chess-move.vala"
	move->piece = _tmp2_;
#line 134 "../lib/chess-move.vala"
	_tmp3_ = self->promotion_piece;
#line 134 "../lib/chess-move.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 134 "../lib/chess-move.vala"
	_g_object_unref0 (move->promotion_piece);
#line 134 "../lib/chess-move.vala"
	move->promotion_piece = _tmp4_;
#line 135 "../lib/chess-move.vala"
	_tmp5_ = self->castling_rook;
#line 135 "../lib/chess-move.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 135 "../lib/chess-move.vala"
	_g_object_unref0 (move->castling_rook);
#line 135 "../lib/chess-move.vala"
	move->castling_rook = _tmp6_;
#line 136 "../lib/chess-move.vala"
	_tmp7_ = self->victim;
#line 136 "../lib/chess-move.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 136 "../lib/chess-move.vala"
	_g_object_unref0 (move->victim);
#line 136 "../lib/chess-move.vala"
	move->victim = _tmp8_;
#line 137 "../lib/chess-move.vala"
	move->r0 = self->r0;
#line 138 "../lib/chess-move.vala"
	move->f0 = self->f0;
#line 139 "../lib/chess-move.vala"
	move->r1 = self->r1;
#line 140 "../lib/chess-move.vala"
	move->f1 = self->f1;
#line 141 "../lib/chess-move.vala"
	move->ambiguous_rank = self->ambiguous_rank;
#line 142 "../lib/chess-move.vala"
	move->ambiguous_file = self->ambiguous_file;
#line 143 "../lib/chess-move.vala"
	move->en_passant = self->en_passant;
#line 144 "../lib/chess-move.vala"
	move->check_state = self->check_state;
#line 145 "../lib/chess-move.vala"
	result = move;
#line 145 "../lib/chess-move.vala"
	return result;
#line 546 "chess-move.c"
}

ChessMove*
chess_move_construct (GType object_type)
{
	ChessMove * self = NULL;
#line 12 "../lib/chess-move.vala"
	self = (ChessMove*) g_object_new (object_type, NULL);
#line 12 "../lib/chess-move.vala"
	return self;
#line 557 "chess-move.c"
}

ChessMove*
chess_move_new (void)
{
#line 12 "../lib/chess-move.vala"
	return chess_move_construct (TYPE_CHESS_MOVE);
#line 565 "chess-move.c"
}

static void
chess_move_class_init (ChessMoveClass * klass,
                       gpointer klass_data)
{
#line 12 "../lib/chess-move.vala"
	chess_move_parent_class = g_type_class_peek_parent (klass);
#line 12 "../lib/chess-move.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_move_finalize;
#line 576 "chess-move.c"
}

static void
chess_move_instance_init (ChessMove * self,
                          gpointer klass)
{
}

static void
chess_move_finalize (GObject * obj)
{
	ChessMove * self;
#line 12 "../lib/chess-move.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_MOVE, ChessMove);
#line 15 "../lib/chess-move.vala"
	_g_object_unref0 (self->piece);
#line 16 "../lib/chess-move.vala"
	_g_object_unref0 (self->promotion_piece);
#line 17 "../lib/chess-move.vala"
	_g_object_unref0 (self->castling_rook);
#line 18 "../lib/chess-move.vala"
	_g_object_unref0 (self->victim);
#line 12 "../lib/chess-move.vala"
	G_OBJECT_CLASS (chess_move_parent_class)->finalize (obj);
#line 601 "chess-move.c"
}

static GType
chess_move_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessMoveClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_move_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessMove), 0, (GInstanceInitFunc) chess_move_instance_init, NULL };
	GType chess_move_type_id;
	chess_move_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessMove", &g_define_type_info, 0);
	return chess_move_type_id;
}

GType
chess_move_get_type (void)
{
	static volatile gsize chess_move_type_id__once = 0;
	if (g_once_init_enter (&chess_move_type_id__once)) {
		GType chess_move_type_id;
		chess_move_type_id = chess_move_get_type_once ();
		g_once_init_leave (&chess_move_type_id__once, chess_move_type_id);
	}
	return chess_move_type_id__once;
}

