/* chess-piece.c generated by valac 0.56.18, the Vala compiler
 * generated from chess-piece.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2016 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include "libchess.h"
#include <glib-object.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CHESS_PIECE_0_PROPERTY,
	CHESS_PIECE_COLOR_PROPERTY,
	CHESS_PIECE_SYMBOL_PROPERTY,
	CHESS_PIECE_NUM_PROPERTIES
};
static GParamSpec* chess_piece_properties[CHESS_PIECE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	CHESS_PIECE_MOVED_SIGNAL,
	CHESS_PIECE_PROMOTED_SIGNAL,
	CHESS_PIECE_DIED_SIGNAL,
	CHESS_PIECE_NUM_SIGNALS
};
static guint chess_piece_signals[CHESS_PIECE_NUM_SIGNALS] = {0};

static gpointer chess_piece_parent_class = NULL;

static void chess_piece_finalize (GObject * obj);
static GType chess_piece_get_type_once (void);
static void _vala_chess_piece_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);

static GType
piece_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PIECE_TYPE_PAWN, "PIECE_TYPE_PAWN", "pawn"}, {PIECE_TYPE_ROOK, "PIECE_TYPE_ROOK", "rook"}, {PIECE_TYPE_KNIGHT, "PIECE_TYPE_KNIGHT", "knight"}, {PIECE_TYPE_BISHOP, "PIECE_TYPE_BISHOP", "bishop"}, {PIECE_TYPE_QUEEN, "PIECE_TYPE_QUEEN", "queen"}, {PIECE_TYPE_KING, "PIECE_TYPE_KING", "king"}, {0, NULL, NULL}};
	GType piece_type_type_id;
	piece_type_type_id = g_enum_register_static ("PieceType", values);
	return piece_type_type_id;
}

GType
piece_type_get_type (void)
{
	static volatile gsize piece_type_type_id__once = 0;
	if (g_once_init_enter (&piece_type_type_id__once)) {
		GType piece_type_type_id;
		piece_type_type_id = piece_type_get_type_once ();
		g_once_init_leave (&piece_type_type_id__once, piece_type_type_id);
	}
	return piece_type_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 70 "../lib/chess-piece.vala"
	return self ? g_object_ref (self) : NULL;
#line 80 "chess-piece.c"
}

ChessPiece*
chess_piece_construct (GType object_type,
                       ChessPlayer* player,
                       PieceType type)
{
	ChessPiece * self = NULL;
	ChessPlayer* _tmp0_;
#line 68 "../lib/chess-piece.vala"
	g_return_val_if_fail (player != NULL, NULL);
#line 68 "../lib/chess-piece.vala"
	self = (ChessPiece*) g_object_new (object_type, NULL);
#line 70 "../lib/chess-piece.vala"
	_tmp0_ = _g_object_ref0 (player);
#line 70 "../lib/chess-piece.vala"
	_g_object_unref0 (self->player);
#line 70 "../lib/chess-piece.vala"
	self->player = _tmp0_;
#line 71 "../lib/chess-piece.vala"
	self->type = type;
#line 68 "../lib/chess-piece.vala"
	return self;
#line 104 "chess-piece.c"
}

ChessPiece*
chess_piece_new (ChessPlayer* player,
                 PieceType type)
{
#line 68 "../lib/chess-piece.vala"
	return chess_piece_construct (TYPE_CHESS_PIECE, player, type);
#line 113 "chess-piece.c"
}

Color
chess_piece_get_color (ChessPiece* self)
{
	Color result;
	ChessPlayer* _tmp0_;
#line 33 "../lib/chess-piece.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 33 "../lib/chess-piece.vala"
	_tmp0_ = self->player;
#line 33 "../lib/chess-piece.vala"
	result = _tmp0_->color;
#line 33 "../lib/chess-piece.vala"
	return result;
#line 129 "chess-piece.c"
}

gunichar
chess_piece_get_symbol (ChessPiece* self)
{
	gunichar result;
	gunichar c = 0U;
	ChessPlayer* _tmp0_;
#line 38 "../lib/chess-piece.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 40 "../lib/chess-piece.vala"
	c = (gunichar) ' ';
#line 41 "../lib/chess-piece.vala"
	switch (self->type) {
#line 41 "../lib/chess-piece.vala"
		case PIECE_TYPE_PAWN:
#line 146 "chess-piece.c"
		{
#line 44 "../lib/chess-piece.vala"
			c = (gunichar) 'p';
#line 45 "../lib/chess-piece.vala"
			break;
#line 152 "chess-piece.c"
		}
#line 41 "../lib/chess-piece.vala"
		case PIECE_TYPE_ROOK:
#line 156 "chess-piece.c"
		{
#line 47 "../lib/chess-piece.vala"
			c = (gunichar) 'r';
#line 48 "../lib/chess-piece.vala"
			break;
#line 162 "chess-piece.c"
		}
#line 41 "../lib/chess-piece.vala"
		case PIECE_TYPE_KNIGHT:
#line 166 "chess-piece.c"
		{
#line 50 "../lib/chess-piece.vala"
			c = (gunichar) 'n';
#line 51 "../lib/chess-piece.vala"
			break;
#line 172 "chess-piece.c"
		}
#line 41 "../lib/chess-piece.vala"
		case PIECE_TYPE_BISHOP:
#line 176 "chess-piece.c"
		{
#line 53 "../lib/chess-piece.vala"
			c = (gunichar) 'b';
#line 54 "../lib/chess-piece.vala"
			break;
#line 182 "chess-piece.c"
		}
#line 41 "../lib/chess-piece.vala"
		case PIECE_TYPE_QUEEN:
#line 186 "chess-piece.c"
		{
#line 56 "../lib/chess-piece.vala"
			c = (gunichar) 'q';
#line 57 "../lib/chess-piece.vala"
			break;
#line 192 "chess-piece.c"
		}
#line 41 "../lib/chess-piece.vala"
		case PIECE_TYPE_KING:
#line 196 "chess-piece.c"
		{
#line 59 "../lib/chess-piece.vala"
			c = (gunichar) 'k';
#line 60 "../lib/chess-piece.vala"
			break;
#line 202 "chess-piece.c"
		}
		default:
#line 41 "../lib/chess-piece.vala"
		break;
#line 207 "chess-piece.c"
	}
#line 62 "../lib/chess-piece.vala"
	_tmp0_ = self->player;
#line 62 "../lib/chess-piece.vala"
	if (_tmp0_->color == COLOR_WHITE) {
#line 63 "../lib/chess-piece.vala"
		c = g_unichar_toupper (c);
#line 215 "chess-piece.c"
	}
#line 64 "../lib/chess-piece.vala"
	result = c;
#line 64 "../lib/chess-piece.vala"
	return result;
#line 221 "chess-piece.c"
}

static void
chess_piece_class_init (ChessPieceClass * klass,
                        gpointer klass_data)
{
#line 22 "../lib/chess-piece.vala"
	chess_piece_parent_class = g_type_class_peek_parent (klass);
#line 22 "../lib/chess-piece.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_piece_get_property;
#line 22 "../lib/chess-piece.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_piece_finalize;
#line 22 "../lib/chess-piece.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_PIECE_COLOR_PROPERTY, chess_piece_properties[CHESS_PIECE_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", TYPE_COLOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../lib/chess-piece.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_PIECE_SYMBOL_PROPERTY, chess_piece_properties[CHESS_PIECE_SYMBOL_PROPERTY] = g_param_spec_uint ("symbol", "symbol", "symbol", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../lib/chess-piece.vala"
	chess_piece_signals[CHESS_PIECE_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_CHESS_PIECE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../lib/chess-piece.vala"
	chess_piece_signals[CHESS_PIECE_PROMOTED_SIGNAL] = g_signal_new ("promoted", TYPE_CHESS_PIECE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../lib/chess-piece.vala"
	chess_piece_signals[CHESS_PIECE_DIED_SIGNAL] = g_signal_new ("died", TYPE_CHESS_PIECE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 244 "chess-piece.c"
}

static void
chess_piece_instance_init (ChessPiece * self,
                           gpointer klass)
{
}

static void
chess_piece_finalize (GObject * obj)
{
	ChessPiece * self;
#line 22 "../lib/chess-piece.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_PIECE, ChessPiece);
#line 24 "../lib/chess-piece.vala"
	_g_object_unref0 (self->player);
#line 22 "../lib/chess-piece.vala"
	G_OBJECT_CLASS (chess_piece_parent_class)->finalize (obj);
#line 263 "chess-piece.c"
}

static GType
chess_piece_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessPieceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_piece_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessPiece), 0, (GInstanceInitFunc) chess_piece_instance_init, NULL };
	GType chess_piece_type_id;
	chess_piece_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessPiece", &g_define_type_info, 0);
	return chess_piece_type_id;
}

GType
chess_piece_get_type (void)
{
	static volatile gsize chess_piece_type_id__once = 0;
	if (g_once_init_enter (&chess_piece_type_id__once)) {
		GType chess_piece_type_id;
		chess_piece_type_id = chess_piece_get_type_once ();
		g_once_init_leave (&chess_piece_type_id__once, chess_piece_type_id);
	}
	return chess_piece_type_id__once;
}

static void
_vala_chess_piece_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessPiece * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_PIECE, ChessPiece);
#line 22 "../lib/chess-piece.vala"
	switch (property_id) {
#line 22 "../lib/chess-piece.vala"
		case CHESS_PIECE_COLOR_PROPERTY:
#line 22 "../lib/chess-piece.vala"
		g_value_set_enum (value, chess_piece_get_color (self));
#line 22 "../lib/chess-piece.vala"
		break;
#line 22 "../lib/chess-piece.vala"
		case CHESS_PIECE_SYMBOL_PROPERTY:
#line 22 "../lib/chess-piece.vala"
		g_value_set_uint (value, chess_piece_get_symbol (self));
#line 22 "../lib/chess-piece.vala"
		break;
#line 309 "chess-piece.c"
		default:
#line 22 "../lib/chess-piece.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../lib/chess-piece.vala"
		break;
#line 315 "chess-piece.c"
	}
}

