/* chess-scene.c generated by valac 0.56.18, the Vala compiler
 * generated from chess-scene.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include "libchess.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CHESS_MODEL (chess_model_get_type ())
#define CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MODEL, ChessModel))
#define CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MODEL, ChessModelClass))
#define IS_CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MODEL))
#define IS_CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MODEL))
#define CHESS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MODEL, ChessModelClass))

typedef struct _ChessModel ChessModel;
typedef struct _ChessModelClass ChessModelClass;
typedef struct _ChessModelPrivate ChessModelPrivate;
enum  {
	CHESS_MODEL_0_PROPERTY,
	CHESS_MODEL_MOVING_PROPERTY,
	CHESS_MODEL_NUM_PROPERTIES
};
static GParamSpec* chess_model_properties[CHESS_MODEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
typedef struct _ChessScenePrivate ChessScenePrivate;
enum  {
	CHESS_SCENE_0_PROPERTY,
	CHESS_SCENE_GAME_PROPERTY,
	CHESS_SCENE_MOVE_NUMBER_PROPERTY,
	CHESS_SCENE_SHOW_NUMBERING_PROPERTY,
	CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY,
	CHESS_SCENE_THEME_NAME_PROPERTY,
	CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY,
	CHESS_SCENE_BOARD_SIDE_PROPERTY,
	CHESS_SCENE_BOARD_ANGLE_PROPERTY,
	CHESS_SCENE_MOVE_FORMAT_PROPERTY,
	CHESS_SCENE_NUM_PROPERTIES
};
static GParamSpec* chess_scene_properties[CHESS_SCENE_NUM_PROPERTIES];
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
typedef void (*ChessScenePromotionTypeCompletionHandler) (PieceType* type, gpointer user_data);
enum  {
	CHESS_SCENE_IS_HUMAN_SIGNAL,
	CHESS_SCENE_CHANGED_SIGNAL,
	CHESS_SCENE_CHOOSE_PROMOTION_TYPE_SIGNAL,
	CHESS_SCENE_NUM_SIGNALS
};
static guint chess_scene_signals[CHESS_SCENE_NUM_SIGNALS] = {0};

struct _ChessModel {
	GObject parent_instance;
	ChessModelPrivate * priv;
	ChessPiece* piece;
	gdouble x;
	gdouble y;
	gdouble target_x;
	gdouble target_y;
	gboolean under_threat;
	gboolean is_selected;
};

struct _ChessModelClass {
	GObjectClass parent_class;
};

struct _ChessScene {
	GObject parent_instance;
	ChessScenePrivate * priv;
	GList* pieces;
	gboolean animating;
	gint selected_rank;
	gint selected_file;
};

struct _ChessSceneClass {
	GObjectClass parent_class;
};

struct _ChessScenePrivate {
	gboolean _can_move[64];
	GTimer* animation_timer;
	gdouble animation_time;
	guint animate_timeout_id;
	ChessGame* _game;
	gint _move_number;
	gboolean _show_numbering;
	gboolean _show_move_hints;
	gchar* _theme_name;
	gboolean _show_3d_smooth;
	gchar* _board_side;
	gchar* _move_format;
};

struct _Block1Data {
	int _ref_count_;
	ChessScene* self;
	gint file;
	gint rank;
};

static gpointer chess_model_parent_class = NULL;
static gint ChessScene_private_offset;
static gpointer chess_scene_parent_class = NULL;

VALA_EXTERN GType chess_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessModel, g_object_unref)
VALA_EXTERN ChessModel* chess_model_new (ChessPiece* piece,
                             gdouble x,
                             gdouble y);
VALA_EXTERN ChessModel* chess_model_construct (GType object_type,
                                   ChessPiece* piece,
                                   gdouble x,
                                   gdouble y);
VALA_EXTERN gboolean chess_model_move_to (ChessModel* self,
                              gdouble x,
                              gdouble y);
VALA_EXTERN gboolean chess_model_animate (ChessModel* self,
                              gdouble timestep);
VALA_EXTERN gboolean chess_model_get_moving (ChessModel* self);
static gdouble chess_model_update_position (ChessModel* self,
                                     gdouble timestep,
                                     gdouble value,
                                     gdouble target);
static void chess_model_finalize (GObject * obj);
static GType chess_model_get_type_once (void);
static void _vala_chess_model_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
VALA_EXTERN GType chess_scene_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessScene, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN ChessPiece* chess_scene_get_selected_piece (ChessScene* self);
VALA_EXTERN ChessGame* chess_scene_get_game (ChessScene* self);
VALA_EXTERN gint chess_scene_get_move_number (ChessScene* self);
VALA_EXTERN ChessScene* chess_scene_new (void);
VALA_EXTERN ChessScene* chess_scene_construct (GType object_type);
VALA_EXTERN void chess_scene_select_square (ChessScene* self,
                                gint file,
                                gint rank);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void ______lambda4_ (Block1Data* _data1_,
                     PieceType* promotion_selection);
static void chess_scene_update_board (ChessScene* self);
static void _______lambda4__chess_scene_promotion_type_completion_handler (PieceType* type,
                                                                    gpointer self);
static void chess_scene_moved_cb (ChessScene* self,
                           ChessGame* game,
                           ChessMove* move);
static void chess_scene_paused_cb (ChessScene* self,
                            ChessGame* game);
static void chess_scene_unpaused_cb (ChessScene* self,
                              ChessGame* game);
static void chess_scene_undo_cb (ChessScene* self,
                          ChessGame* game);
static ChessModel* chess_scene_find_model (ChessScene* self,
                                    ChessPiece* piece);
static gboolean chess_scene_animate_cb (ChessScene* self);
static gboolean _chess_scene_animate_cb_gsource_func (gpointer self);
VALA_EXTERN gboolean chess_scene_can_move (ChessScene* self,
                               gint rank,
                               gint file);
VALA_EXTERN void chess_scene_set_game (ChessScene* self,
                           ChessGame* value);
static void _chess_scene_moved_cb_chess_game_moved (ChessGame* _sender,
                                             ChessMove* move,
                                             gpointer self);
static void _chess_scene_paused_cb_chess_game_paused (ChessGame* _sender,
                                               gpointer self);
static void _chess_scene_unpaused_cb_chess_game_unpaused (ChessGame* _sender,
                                                   gpointer self);
static void _chess_scene_undo_cb_chess_game_undo (ChessGame* _sender,
                                           gpointer self);
VALA_EXTERN void chess_scene_set_move_number (ChessScene* self,
                                  gint value);
VALA_EXTERN gboolean chess_scene_get_show_numbering (ChessScene* self);
VALA_EXTERN void chess_scene_set_show_numbering (ChessScene* self,
                                     gboolean value);
VALA_EXTERN gboolean chess_scene_get_show_move_hints (ChessScene* self);
VALA_EXTERN void chess_scene_set_show_move_hints (ChessScene* self,
                                      gboolean value);
VALA_EXTERN const gchar* chess_scene_get_theme_name (ChessScene* self);
VALA_EXTERN void chess_scene_set_theme_name (ChessScene* self,
                                 const gchar* value);
VALA_EXTERN gboolean chess_scene_get_show_3d_smooth (ChessScene* self);
VALA_EXTERN void chess_scene_set_show_3d_smooth (ChessScene* self,
                                     gboolean value);
VALA_EXTERN const gchar* chess_scene_get_board_side (ChessScene* self);
VALA_EXTERN void chess_scene_set_board_side (ChessScene* self,
                                 const gchar* value);
VALA_EXTERN gdouble chess_scene_get_board_angle (ChessScene* self);
VALA_EXTERN const gchar* chess_scene_get_move_format (ChessScene* self);
VALA_EXTERN void chess_scene_set_move_format (ChessScene* self,
                                  const gchar* value);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__POINTER_POINTER_POINTER (GClosure * closure,
                                                            GValue * return_value,
                                                            guint n_param_values,
                                                            const GValue * param_values,
                                                            gpointer invocation_hint,
                                                            gpointer marshal_data);
static void chess_scene_finalize (GObject * obj);
static GType chess_scene_get_type_once (void);
static void _vala_chess_scene_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_chess_scene_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/chess-scene.vala"
	return self ? g_object_ref (self) : NULL;
#line 272 "chess-scene.c"
}

ChessModel*
chess_model_construct (GType object_type,
                       ChessPiece* piece,
                       gdouble x,
                       gdouble y)
{
	ChessModel * self = NULL;
	ChessPiece* _tmp0_;
#line 28 "../src/chess-scene.vala"
	g_return_val_if_fail (piece != NULL, NULL);
#line 28 "../src/chess-scene.vala"
	self = (ChessModel*) g_object_new (object_type, NULL);
#line 30 "../src/chess-scene.vala"
	_tmp0_ = _g_object_ref0 (piece);
#line 30 "../src/chess-scene.vala"
	_g_object_unref0 (self->piece);
#line 30 "../src/chess-scene.vala"
	self->piece = _tmp0_;
#line 31 "../src/chess-scene.vala"
	self->target_x = x;
#line 31 "../src/chess-scene.vala"
	self->x = self->target_x;
#line 32 "../src/chess-scene.vala"
	self->target_y = y;
#line 32 "../src/chess-scene.vala"
	self->y = self->target_y;
#line 28 "../src/chess-scene.vala"
	return self;
#line 303 "chess-scene.c"
}

ChessModel*
chess_model_new (ChessPiece* piece,
                 gdouble x,
                 gdouble y)
{
#line 28 "../src/chess-scene.vala"
	return chess_model_construct (TYPE_CHESS_MODEL, piece, x, y);
#line 313 "chess-scene.c"
}

gboolean
chess_model_move_to (ChessModel* self,
                     gdouble x,
                     gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 35 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "../src/chess-scene.vala"
	if (self->target_x == x) {
#line 37 "../src/chess-scene.vala"
		_tmp0_ = self->target_y == y;
#line 329 "chess-scene.c"
	} else {
#line 37 "../src/chess-scene.vala"
		_tmp0_ = FALSE;
#line 333 "chess-scene.c"
	}
#line 37 "../src/chess-scene.vala"
	if (_tmp0_) {
#line 38 "../src/chess-scene.vala"
		result = FALSE;
#line 38 "../src/chess-scene.vala"
		return result;
#line 341 "chess-scene.c"
	}
#line 40 "../src/chess-scene.vala"
	self->target_x = x;
#line 41 "../src/chess-scene.vala"
	self->target_y = y;
#line 43 "../src/chess-scene.vala"
	result = TRUE;
#line 43 "../src/chess-scene.vala"
	return result;
#line 351 "chess-scene.c"
}

gboolean
chess_model_animate (ChessModel* self,
                     gdouble timestep)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 46 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/chess-scene.vala"
	_tmp0_ = chess_model_get_moving (self);
#line 48 "../src/chess-scene.vala"
	_tmp1_ = _tmp0_;
#line 48 "../src/chess-scene.vala"
	if (!_tmp1_) {
#line 49 "../src/chess-scene.vala"
		result = FALSE;
#line 49 "../src/chess-scene.vala"
		return result;
#line 373 "chess-scene.c"
	}
#line 51 "../src/chess-scene.vala"
	self->x = chess_model_update_position (self, timestep, self->x, self->target_x);
#line 52 "../src/chess-scene.vala"
	self->y = chess_model_update_position (self, timestep, self->y, self->target_y);
#line 53 "../src/chess-scene.vala"
	result = TRUE;
#line 53 "../src/chess-scene.vala"
	return result;
#line 383 "chess-scene.c"
}

static gdouble
chess_model_update_position (ChessModel* self,
                             gdouble timestep,
                             gdouble value,
                             gdouble target)
{
	gdouble distance = 0.0;
	gdouble step = 0.0;
	gdouble result;
#line 56 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 58 "../src/chess-scene.vala"
	distance = fabs (target - value);
#line 59 "../src/chess-scene.vala"
	step = timestep * 4.0;
#line 61 "../src/chess-scene.vala"
	if (step > distance) {
#line 62 "../src/chess-scene.vala"
		step = distance;
#line 405 "chess-scene.c"
	}
#line 64 "../src/chess-scene.vala"
	if (target > value) {
#line 65 "../src/chess-scene.vala"
		result = value + step;
#line 65 "../src/chess-scene.vala"
		return result;
#line 413 "chess-scene.c"
	} else {
#line 67 "../src/chess-scene.vala"
		result = value - step;
#line 67 "../src/chess-scene.vala"
		return result;
#line 419 "chess-scene.c"
	}
}

gboolean
chess_model_get_moving (ChessModel* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 25 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/chess-scene.vala"
	if (self->x != self->target_x) {
#line 25 "../src/chess-scene.vala"
		_tmp0_ = TRUE;
#line 434 "chess-scene.c"
	} else {
#line 25 "../src/chess-scene.vala"
		_tmp0_ = self->y != self->target_y;
#line 438 "chess-scene.c"
	}
#line 25 "../src/chess-scene.vala"
	result = _tmp0_;
#line 25 "../src/chess-scene.vala"
	return result;
#line 444 "chess-scene.c"
}

static void
chess_model_class_init (ChessModelClass * klass,
                        gpointer klass_data)
{
#line 13 "../src/chess-scene.vala"
	chess_model_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_model_get_property;
#line 13 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_model_finalize;
#line 13 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_MODEL_MOVING_PROPERTY, chess_model_properties[CHESS_MODEL_MOVING_PROPERTY] = g_param_spec_boolean ("moving", "moving", "moving", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 459 "chess-scene.c"
}

static void
chess_model_instance_init (ChessModel * self,
                           gpointer klass)
{
}

static void
chess_model_finalize (GObject * obj)
{
	ChessModel * self;
#line 13 "../src/chess-scene.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_MODEL, ChessModel);
#line 15 "../src/chess-scene.vala"
	_g_object_unref0 (self->piece);
#line 13 "../src/chess-scene.vala"
	G_OBJECT_CLASS (chess_model_parent_class)->finalize (obj);
#line 478 "chess-scene.c"
}

static GType
chess_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessModel), 0, (GInstanceInitFunc) chess_model_instance_init, NULL };
	GType chess_model_type_id;
	chess_model_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessModel", &g_define_type_info, 0);
	return chess_model_type_id;
}

GType
chess_model_get_type (void)
{
	static volatile gsize chess_model_type_id__once = 0;
	if (g_once_init_enter (&chess_model_type_id__once)) {
		GType chess_model_type_id;
		chess_model_type_id = chess_model_get_type_once ();
		g_once_init_leave (&chess_model_type_id__once, chess_model_type_id);
	}
	return chess_model_type_id__once;
}

static void
_vala_chess_model_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_MODEL, ChessModel);
#line 13 "../src/chess-scene.vala"
	switch (property_id) {
#line 13 "../src/chess-scene.vala"
		case CHESS_MODEL_MOVING_PROPERTY:
#line 13 "../src/chess-scene.vala"
		g_value_set_boolean (value, chess_model_get_moving (self));
#line 13 "../src/chess-scene.vala"
		break;
#line 518 "chess-scene.c"
		default:
#line 13 "../src/chess-scene.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/chess-scene.vala"
		break;
#line 524 "chess-scene.c"
	}
}

static inline gpointer
chess_scene_get_instance_private (ChessScene* self)
{
	return G_STRUCT_MEMBER_P (self, ChessScene_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 73 "../src/chess-scene.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 539 "chess-scene.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 73 "../src/chess-scene.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 547 "chess-scene.c"
}

ChessPiece*
chess_scene_get_selected_piece (ChessScene* self)
{
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessGame* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	ChessPiece* _tmp7_;
	ChessPiece* result;
#line 127 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 129 "../src/chess-scene.vala"
	_tmp1_ = chess_scene_get_game (self);
#line 129 "../src/chess-scene.vala"
	_tmp2_ = _tmp1_;
#line 129 "../src/chess-scene.vala"
	if (_tmp2_ == NULL) {
#line 129 "../src/chess-scene.vala"
		_tmp0_ = TRUE;
#line 572 "chess-scene.c"
	} else {
#line 129 "../src/chess-scene.vala"
		_tmp0_ = self->selected_rank < 0;
#line 576 "chess-scene.c"
	}
#line 129 "../src/chess-scene.vala"
	if (_tmp0_) {
#line 130 "../src/chess-scene.vala"
		result = NULL;
#line 130 "../src/chess-scene.vala"
		return result;
#line 584 "chess-scene.c"
	}
#line 131 "../src/chess-scene.vala"
	_tmp3_ = chess_scene_get_game (self);
#line 131 "../src/chess-scene.vala"
	_tmp4_ = _tmp3_;
#line 131 "../src/chess-scene.vala"
	_tmp5_ = chess_scene_get_move_number (self);
#line 131 "../src/chess-scene.vala"
	_tmp6_ = _tmp5_;
#line 131 "../src/chess-scene.vala"
	_tmp7_ = chess_game_get_piece (_tmp4_, self->selected_rank, self->selected_file, _tmp6_);
#line 131 "../src/chess-scene.vala"
	result = _tmp7_;
#line 131 "../src/chess-scene.vala"
	return result;
#line 600 "chess-scene.c"
}

ChessScene*
chess_scene_construct (GType object_type)
{
	ChessScene * self = NULL;
	GTimer* _tmp0_;
#line 211 "../src/chess-scene.vala"
	self = (ChessScene*) g_object_new (object_type, NULL);
#line 213 "../src/chess-scene.vala"
	_tmp0_ = g_timer_new ();
#line 213 "../src/chess-scene.vala"
	_g_timer_destroy0 (self->priv->animation_timer);
#line 213 "../src/chess-scene.vala"
	self->priv->animation_timer = _tmp0_;
#line 211 "../src/chess-scene.vala"
	return self;
#line 618 "chess-scene.c"
}

ChessScene*
chess_scene_new (void)
{
#line 211 "../src/chess-scene.vala"
	return chess_scene_construct (TYPE_CHESS_SCENE);
#line 626 "chess-scene.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 216 "../src/chess-scene.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 216 "../src/chess-scene.vala"
	return _data1_;
#line 636 "chess-scene.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 216 "../src/chess-scene.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 646 "chess-scene.c"
		ChessScene* self;
#line 216 "../src/chess-scene.vala"
		self = _data1_->self;
#line 216 "../src/chess-scene.vala"
		_g_object_unref0 (self);
#line 216 "../src/chess-scene.vala"
		g_slice_free (Block1Data, _data1_);
#line 654 "chess-scene.c"
	}
}

static void
______lambda4_ (Block1Data* _data1_,
                PieceType* promotion_selection)
{
	ChessScene* self;
#line 248 "../src/chess-scene.vala"
	self = _data1_->self;
#line 249 "../src/chess-scene.vala"
	if (promotion_selection != NULL) {
#line 667 "chess-scene.c"
		ChessGame* _tmp0_;
		ChessGame* _tmp1_;
		ChessPlayer* _tmp2_;
		ChessPlayer* _tmp3_;
#line 251 "../src/chess-scene.vala"
		_tmp0_ = chess_scene_get_game (self);
#line 251 "../src/chess-scene.vala"
		_tmp1_ = _tmp0_;
#line 251 "../src/chess-scene.vala"
		_tmp2_ = chess_game_get_current_player (_tmp1_);
#line 251 "../src/chess-scene.vala"
		_tmp3_ = _tmp2_;
#line 251 "../src/chess-scene.vala"
		chess_player_move_with_coords (_tmp3_, self->selected_rank, self->selected_file, _data1_->rank, _data1_->file, TRUE, *promotion_selection);
#line 255 "../src/chess-scene.vala"
		self->selected_file = -1;
#line 255 "../src/chess-scene.vala"
		self->selected_rank = self->selected_file;
#line 257 "../src/chess-scene.vala"
		chess_scene_update_board (self);
#line 258 "../src/chess-scene.vala"
		g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 690 "chess-scene.c"
	}
}

static void
_______lambda4__chess_scene_promotion_type_completion_handler (PieceType* type,
                                                               gpointer self)
{
#line 248 "../src/chess-scene.vala"
	______lambda4_ (self, type);
#line 700 "chess-scene.c"
}

void
chess_scene_select_square (ChessScene* self,
                           gint file,
                           gint rank)
{
	Block1Data* _data1_;
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	ChessGame* _tmp2_;
	gint _tmp9_;
	gint _tmp10_;
	ChessPiece* piece = NULL;
	ChessGame* _tmp11_;
	ChessGame* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	ChessPiece* _tmp15_;
	gboolean _tmp16_ = FALSE;
#line 216 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/chess-scene.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 216 "../src/chess-scene.vala"
	_data1_->_ref_count_ = 1;
#line 216 "../src/chess-scene.vala"
	_data1_->self = g_object_ref (self);
#line 216 "../src/chess-scene.vala"
	_data1_->file = file;
#line 216 "../src/chess-scene.vala"
	_data1_->rank = rank;
#line 218 "../src/chess-scene.vala"
	_tmp1_ = chess_scene_get_game (self);
#line 218 "../src/chess-scene.vala"
	_tmp2_ = _tmp1_;
#line 218 "../src/chess-scene.vala"
	if (_tmp2_ == NULL) {
#line 218 "../src/chess-scene.vala"
		_tmp0_ = TRUE;
#line 741 "chess-scene.c"
	} else {
		ChessGame* _tmp3_;
		ChessGame* _tmp4_;
		ChessPlayer* _tmp5_;
		ChessPlayer* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 218 "../src/chess-scene.vala"
		_tmp3_ = chess_scene_get_game (self);
#line 218 "../src/chess-scene.vala"
		_tmp4_ = _tmp3_;
#line 218 "../src/chess-scene.vala"
		_tmp5_ = chess_game_get_current_player (_tmp4_);
#line 218 "../src/chess-scene.vala"
		_tmp6_ = _tmp5_;
#line 218 "../src/chess-scene.vala"
		_tmp7_ = chess_player_get_local_human (_tmp6_);
#line 218 "../src/chess-scene.vala"
		_tmp8_ = _tmp7_;
#line 218 "../src/chess-scene.vala"
		_tmp0_ = !_tmp8_;
#line 763 "chess-scene.c"
	}
#line 218 "../src/chess-scene.vala"
	if (_tmp0_) {
#line 219 "../src/chess-scene.vala"
		block1_data_unref (_data1_);
#line 219 "../src/chess-scene.vala"
		_data1_ = NULL;
#line 219 "../src/chess-scene.vala"
		return;
#line 773 "chess-scene.c"
	}
#line 222 "../src/chess-scene.vala"
	_tmp9_ = chess_scene_get_move_number (self);
#line 222 "../src/chess-scene.vala"
	_tmp10_ = _tmp9_;
#line 222 "../src/chess-scene.vala"
	if (_tmp10_ != -1) {
#line 223 "../src/chess-scene.vala"
		block1_data_unref (_data1_);
#line 223 "../src/chess-scene.vala"
		_data1_ = NULL;
#line 223 "../src/chess-scene.vala"
		return;
#line 787 "chess-scene.c"
	}
#line 225 "../src/chess-scene.vala"
	_tmp11_ = chess_scene_get_game (self);
#line 225 "../src/chess-scene.vala"
	_tmp12_ = _tmp11_;
#line 225 "../src/chess-scene.vala"
	_tmp13_ = chess_scene_get_move_number (self);
#line 225 "../src/chess-scene.vala"
	_tmp14_ = _tmp13_;
#line 225 "../src/chess-scene.vala"
	_tmp15_ = chess_game_get_piece (_tmp12_, _data1_->rank, _data1_->file, _tmp14_);
#line 225 "../src/chess-scene.vala"
	piece = _tmp15_;
#line 228 "../src/chess-scene.vala"
	if (_data1_->file == self->selected_file) {
#line 228 "../src/chess-scene.vala"
		_tmp16_ = _data1_->rank == self->selected_rank;
#line 805 "chess-scene.c"
	} else {
#line 228 "../src/chess-scene.vala"
		_tmp16_ = FALSE;
#line 809 "chess-scene.c"
	}
#line 228 "../src/chess-scene.vala"
	if (_tmp16_) {
#line 230 "../src/chess-scene.vala"
		self->selected_file = -1;
#line 230 "../src/chess-scene.vala"
		self->selected_rank = self->selected_file;
#line 817 "chess-scene.c"
	} else {
		gboolean _tmp17_ = FALSE;
		ChessPiece* _tmp18_;
#line 233 "../src/chess-scene.vala"
		_tmp18_ = piece;
#line 233 "../src/chess-scene.vala"
		if (_tmp18_ != NULL) {
#line 825 "chess-scene.c"
			ChessPiece* _tmp19_;
			ChessPlayer* _tmp20_;
			ChessGame* _tmp21_;
			ChessGame* _tmp22_;
			ChessPlayer* _tmp23_;
			ChessPlayer* _tmp24_;
#line 233 "../src/chess-scene.vala"
			_tmp19_ = piece;
#line 233 "../src/chess-scene.vala"
			_tmp20_ = _tmp19_->player;
#line 233 "../src/chess-scene.vala"
			_tmp21_ = chess_scene_get_game (self);
#line 233 "../src/chess-scene.vala"
			_tmp22_ = _tmp21_;
#line 233 "../src/chess-scene.vala"
			_tmp23_ = chess_game_get_current_player (_tmp22_);
#line 233 "../src/chess-scene.vala"
			_tmp24_ = _tmp23_;
#line 233 "../src/chess-scene.vala"
			_tmp17_ = _tmp20_ == _tmp24_;
#line 846 "chess-scene.c"
		} else {
#line 233 "../src/chess-scene.vala"
			_tmp17_ = FALSE;
#line 850 "chess-scene.c"
		}
#line 233 "../src/chess-scene.vala"
		if (_tmp17_) {
#line 235 "../src/chess-scene.vala"
			self->selected_rank = _data1_->rank;
#line 236 "../src/chess-scene.vala"
			self->selected_file = _data1_->file;
#line 858 "chess-scene.c"
		} else {
#line 239 "../src/chess-scene.vala"
			if (self->selected_file != -1) {
#line 862 "chess-scene.c"
				gboolean can_move = FALSE;
				ChessGame* _tmp25_;
				ChessGame* _tmp26_;
				ChessPlayer* _tmp27_;
				ChessPlayer* _tmp28_;
				gboolean _tmp29_ = FALSE;
				gboolean _tmp30_ = FALSE;
				ChessGame* _tmp34_;
				ChessGame* _tmp35_;
				ChessPlayer* _tmp36_;
				ChessPlayer* _tmp37_;
#line 241 "../src/chess-scene.vala"
				_tmp25_ = chess_scene_get_game (self);
#line 241 "../src/chess-scene.vala"
				_tmp26_ = _tmp25_;
#line 241 "../src/chess-scene.vala"
				_tmp27_ = chess_game_get_current_player (_tmp26_);
#line 241 "../src/chess-scene.vala"
				_tmp28_ = _tmp27_;
#line 241 "../src/chess-scene.vala"
				can_move = chess_player_move_with_coords (_tmp28_, self->selected_rank, self->selected_file, _data1_->rank, _data1_->file, FALSE, PIECE_TYPE_QUEEN);
#line 244 "../src/chess-scene.vala"
				if (can_move) {
#line 886 "chess-scene.c"
					ChessPiece* _tmp31_;
					ChessPiece* _tmp32_;
#line 244 "../src/chess-scene.vala"
					_tmp31_ = chess_scene_get_selected_piece (self);
#line 244 "../src/chess-scene.vala"
					_tmp32_ = _tmp31_;
#line 244 "../src/chess-scene.vala"
					_tmp30_ = _tmp32_->type == PIECE_TYPE_PAWN;
#line 244 "../src/chess-scene.vala"
					_g_object_unref0 (_tmp32_);
#line 897 "chess-scene.c"
				} else {
#line 244 "../src/chess-scene.vala"
					_tmp30_ = FALSE;
#line 901 "chess-scene.c"
				}
#line 244 "../src/chess-scene.vala"
				if (_tmp30_) {
#line 905 "chess-scene.c"
					gboolean _tmp33_ = FALSE;
#line 245 "../src/chess-scene.vala"
					if (_data1_->rank == 0) {
#line 245 "../src/chess-scene.vala"
						_tmp33_ = TRUE;
#line 911 "chess-scene.c"
					} else {
#line 245 "../src/chess-scene.vala"
						_tmp33_ = _data1_->rank == 7;
#line 915 "chess-scene.c"
					}
#line 245 "../src/chess-scene.vala"
					_tmp29_ = _tmp33_;
#line 919 "chess-scene.c"
				} else {
#line 244 "../src/chess-scene.vala"
					_tmp29_ = FALSE;
#line 923 "chess-scene.c"
				}
#line 244 "../src/chess-scene.vala"
				if (_tmp29_) {
#line 248 "../src/chess-scene.vala"
					g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHOOSE_PROMOTION_TYPE_SIGNAL], 0, _______lambda4__chess_scene_promotion_type_completion_handler, block1_data_ref (_data1_), block1_data_unref);
#line 261 "../src/chess-scene.vala"
					_g_object_unref0 (piece);
#line 261 "../src/chess-scene.vala"
					block1_data_unref (_data1_);
#line 261 "../src/chess-scene.vala"
					_data1_ = NULL;
#line 261 "../src/chess-scene.vala"
					return;
#line 937 "chess-scene.c"
				}
#line 264 "../src/chess-scene.vala"
				_tmp34_ = chess_scene_get_game (self);
#line 264 "../src/chess-scene.vala"
				_tmp35_ = _tmp34_;
#line 264 "../src/chess-scene.vala"
				_tmp36_ = chess_game_get_current_player (_tmp35_);
#line 264 "../src/chess-scene.vala"
				_tmp37_ = _tmp36_;
#line 264 "../src/chess-scene.vala"
				if (chess_player_move_with_coords (_tmp37_, self->selected_rank, self->selected_file, _data1_->rank, _data1_->file, TRUE, PIECE_TYPE_QUEEN)) {
#line 265 "../src/chess-scene.vala"
					self->selected_file = -1;
#line 265 "../src/chess-scene.vala"
					self->selected_rank = self->selected_file;
#line 953 "chess-scene.c"
				}
			}
		}
	}
#line 268 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 269 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 216 "../src/chess-scene.vala"
	_g_object_unref0 (piece);
#line 216 "../src/chess-scene.vala"
	block1_data_unref (_data1_);
#line 216 "../src/chess-scene.vala"
	_data1_ = NULL;
#line 968 "chess-scene.c"
}

static void
chess_scene_moved_cb (ChessScene* self,
                      ChessGame* game,
                      ChessMove* move)
{
#line 272 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/chess-scene.vala"
	g_return_if_fail (game != NULL);
#line 272 "../src/chess-scene.vala"
	g_return_if_fail (move != NULL);
#line 274 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 984 "chess-scene.c"
}

static void
chess_scene_paused_cb (ChessScene* self,
                       ChessGame* game)
{
#line 277 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 277 "../src/chess-scene.vala"
	g_return_if_fail (game != NULL);
#line 279 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 997 "chess-scene.c"
}

static void
chess_scene_unpaused_cb (ChessScene* self,
                         ChessGame* game)
{
#line 282 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/chess-scene.vala"
	g_return_if_fail (game != NULL);
#line 284 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 1010 "chess-scene.c"
}

static void
chess_scene_undo_cb (ChessScene* self,
                     ChessGame* game)
{
#line 287 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/chess-scene.vala"
	g_return_if_fail (game != NULL);
#line 289 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 1023 "chess-scene.c"
}

static ChessModel*
chess_scene_find_model (ChessScene* self,
                        ChessPiece* piece)
{
	GList* _tmp0_;
	ChessModel* result;
#line 292 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 292 "../src/chess-scene.vala"
	g_return_val_if_fail (piece != NULL, NULL);
#line 294 "../src/chess-scene.vala"
	_tmp0_ = self->pieces;
#line 1038 "chess-scene.c"
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
#line 294 "../src/chess-scene.vala"
		model_collection = _tmp0_;
#line 294 "../src/chess-scene.vala"
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
#line 1046 "chess-scene.c"
			ChessModel* _tmp1_;
			ChessModel* model = NULL;
#line 294 "../src/chess-scene.vala"
			_tmp1_ = _g_object_ref0 ((ChessModel*) model_it->data);
#line 294 "../src/chess-scene.vala"
			model = _tmp1_;
#line 1053 "chess-scene.c"
			{
				ChessModel* _tmp2_;
				ChessPiece* _tmp3_;
#line 295 "../src/chess-scene.vala"
				_tmp2_ = model;
#line 295 "../src/chess-scene.vala"
				_tmp3_ = _tmp2_->piece;
#line 295 "../src/chess-scene.vala"
				if (_tmp3_ == piece) {
#line 296 "../src/chess-scene.vala"
					result = model;
#line 296 "../src/chess-scene.vala"
					return result;
#line 1067 "chess-scene.c"
				}
#line 294 "../src/chess-scene.vala"
				_g_object_unref0 (model);
#line 1071 "chess-scene.c"
			}
		}
	}
#line 297 "../src/chess-scene.vala"
	result = NULL;
#line 297 "../src/chess-scene.vala"
	return result;
#line 1079 "chess-scene.c"
}

static gboolean
_chess_scene_animate_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = chess_scene_animate_cb ((ChessScene*) self);
#line 364 "../src/chess-scene.vala"
	return result;
#line 1089 "chess-scene.c"
}

static void
chess_scene_update_board (ChessScene* self)
{
	ChessGame* _tmp0_;
	ChessGame* _tmp1_;
	gboolean board_changed = FALSE;
	gboolean need_animation = FALSE;
	GList* new_pieces = NULL;
	GList* _tmp35_;
	GList* _tmp36_;
	GList* _tmp37_;
	gboolean _tmp41_ = FALSE;
#line 300 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 302 "../src/chess-scene.vala"
	_tmp0_ = chess_scene_get_game (self);
#line 302 "../src/chess-scene.vala"
	_tmp1_ = _tmp0_;
#line 302 "../src/chess-scene.vala"
	if (_tmp1_ == NULL) {
#line 303 "../src/chess-scene.vala"
		return;
#line 1114 "chess-scene.c"
	}
#line 305 "../src/chess-scene.vala"
	board_changed = FALSE;
#line 306 "../src/chess-scene.vala"
	need_animation = FALSE;
#line 307 "../src/chess-scene.vala"
	new_pieces = NULL;
#line 1122 "chess-scene.c"
	{
		gint rank = 0;
#line 308 "../src/chess-scene.vala"
		rank = 0;
#line 1127 "chess-scene.c"
		{
			gboolean _tmp2_ = FALSE;
#line 308 "../src/chess-scene.vala"
			_tmp2_ = TRUE;
#line 308 "../src/chess-scene.vala"
			while (TRUE) {
#line 308 "../src/chess-scene.vala"
				if (!_tmp2_) {
#line 1136 "chess-scene.c"
					gint _tmp3_;
#line 308 "../src/chess-scene.vala"
					_tmp3_ = rank;
#line 308 "../src/chess-scene.vala"
					rank = _tmp3_ + 1;
#line 1142 "chess-scene.c"
				}
#line 308 "../src/chess-scene.vala"
				_tmp2_ = FALSE;
#line 308 "../src/chess-scene.vala"
				if (!(rank < 8)) {
#line 308 "../src/chess-scene.vala"
					break;
#line 1150 "chess-scene.c"
				}
				{
					gint file = 0;
#line 310 "../src/chess-scene.vala"
					file = 0;
#line 1156 "chess-scene.c"
					{
						gboolean _tmp4_ = FALSE;
#line 310 "../src/chess-scene.vala"
						_tmp4_ = TRUE;
#line 310 "../src/chess-scene.vala"
						while (TRUE) {
#line 1163 "chess-scene.c"
							gboolean can_move = FALSE;
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							ChessPiece* piece = NULL;
							ChessGame* _tmp14_;
							ChessGame* _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							ChessPiece* _tmp18_;
							ChessPiece* _tmp19_;
							ChessModel* model = NULL;
							ChessPiece* _tmp20_;
							ChessModel* _tmp21_;
							ChessModel* _tmp22_;
							ChessModel* _tmp25_;
							ChessModel* _tmp26_;
							gboolean _tmp27_ = FALSE;
							gboolean _tmp28_ = FALSE;
							gint _tmp29_;
							gint _tmp30_;
							ChessModel* _tmp33_;
							ChessModel* _tmp34_;
#line 310 "../src/chess-scene.vala"
							if (!_tmp4_) {
#line 1188 "chess-scene.c"
								gint _tmp5_;
#line 310 "../src/chess-scene.vala"
								_tmp5_ = file;
#line 310 "../src/chess-scene.vala"
								file = _tmp5_ + 1;
#line 1194 "chess-scene.c"
							}
#line 310 "../src/chess-scene.vala"
							_tmp4_ = FALSE;
#line 310 "../src/chess-scene.vala"
							if (!(file < 8)) {
#line 310 "../src/chess-scene.vala"
								break;
#line 1202 "chess-scene.c"
							}
#line 312 "../src/chess-scene.vala"
							can_move = FALSE;
#line 313 "../src/chess-scene.vala"
							if (self->selected_rank >= 0) {
#line 1208 "chess-scene.c"
								gint _tmp8_;
								gint _tmp9_;
#line 313 "../src/chess-scene.vala"
								_tmp8_ = chess_scene_get_move_number (self);
#line 313 "../src/chess-scene.vala"
								_tmp9_ = _tmp8_;
#line 313 "../src/chess-scene.vala"
								_tmp7_ = _tmp9_ == -1;
#line 1217 "chess-scene.c"
							} else {
#line 313 "../src/chess-scene.vala"
								_tmp7_ = FALSE;
#line 1221 "chess-scene.c"
							}
#line 313 "../src/chess-scene.vala"
							if (_tmp7_) {
#line 1225 "chess-scene.c"
								ChessGame* _tmp10_;
								ChessGame* _tmp11_;
								ChessPlayer* _tmp12_;
								ChessPlayer* _tmp13_;
#line 314 "../src/chess-scene.vala"
								_tmp10_ = chess_scene_get_game (self);
#line 314 "../src/chess-scene.vala"
								_tmp11_ = _tmp10_;
#line 314 "../src/chess-scene.vala"
								_tmp12_ = chess_game_get_current_player (_tmp11_);
#line 314 "../src/chess-scene.vala"
								_tmp13_ = _tmp12_;
#line 314 "../src/chess-scene.vala"
								_tmp6_ = chess_player_move_with_coords (_tmp13_, self->selected_rank, self->selected_file, rank, file, FALSE, PIECE_TYPE_QUEEN);
#line 1240 "chess-scene.c"
							} else {
#line 313 "../src/chess-scene.vala"
								_tmp6_ = FALSE;
#line 1244 "chess-scene.c"
							}
#line 313 "../src/chess-scene.vala"
							if (_tmp6_) {
#line 315 "../src/chess-scene.vala"
								can_move = TRUE;
#line 1250 "chess-scene.c"
							}
#line 316 "../src/chess-scene.vala"
							self->priv->_can_move[(rank * 8) + file] = can_move;
#line 318 "../src/chess-scene.vala"
							_tmp14_ = chess_scene_get_game (self);
#line 318 "../src/chess-scene.vala"
							_tmp15_ = _tmp14_;
#line 318 "../src/chess-scene.vala"
							_tmp16_ = chess_scene_get_move_number (self);
#line 318 "../src/chess-scene.vala"
							_tmp17_ = _tmp16_;
#line 318 "../src/chess-scene.vala"
							_tmp18_ = chess_game_get_piece (_tmp15_, rank, file, _tmp17_);
#line 318 "../src/chess-scene.vala"
							piece = _tmp18_;
#line 319 "../src/chess-scene.vala"
							_tmp19_ = piece;
#line 319 "../src/chess-scene.vala"
							if (_tmp19_ == NULL) {
#line 320 "../src/chess-scene.vala"
								_g_object_unref0 (piece);
#line 320 "../src/chess-scene.vala"
								continue;
#line 1274 "chess-scene.c"
							}
#line 321 "../src/chess-scene.vala"
							_tmp20_ = piece;
#line 321 "../src/chess-scene.vala"
							_tmp21_ = chess_scene_find_model (self, _tmp20_);
#line 321 "../src/chess-scene.vala"
							model = _tmp21_;
#line 322 "../src/chess-scene.vala"
							_tmp22_ = model;
#line 322 "../src/chess-scene.vala"
							if (_tmp22_ == NULL) {
#line 1286 "chess-scene.c"
								ChessPiece* _tmp23_;
								ChessModel* _tmp24_;
#line 324 "../src/chess-scene.vala"
								_tmp23_ = piece;
#line 324 "../src/chess-scene.vala"
								_tmp24_ = chess_model_new (_tmp23_, (gdouble) file, (gdouble) rank);
#line 324 "../src/chess-scene.vala"
								_g_object_unref0 (model);
#line 324 "../src/chess-scene.vala"
								model = _tmp24_;
#line 325 "../src/chess-scene.vala"
								board_changed = TRUE;
#line 1299 "chess-scene.c"
							}
#line 327 "../src/chess-scene.vala"
							_tmp25_ = model;
#line 327 "../src/chess-scene.vala"
							_tmp25_->under_threat = can_move;
#line 329 "../src/chess-scene.vala"
							_tmp26_ = model;
#line 329 "../src/chess-scene.vala"
							if (chess_model_move_to (_tmp26_, (gdouble) file, (gdouble) rank)) {
#line 331 "../src/chess-scene.vala"
								board_changed = TRUE;
#line 332 "../src/chess-scene.vala"
								need_animation = TRUE;
#line 1313 "chess-scene.c"
							}
#line 335 "../src/chess-scene.vala"
							_tmp29_ = chess_scene_get_move_number (self);
#line 335 "../src/chess-scene.vala"
							_tmp30_ = _tmp29_;
#line 335 "../src/chess-scene.vala"
							if (_tmp30_ == -1) {
#line 335 "../src/chess-scene.vala"
								_tmp28_ = rank == self->selected_rank;
#line 1323 "chess-scene.c"
							} else {
#line 335 "../src/chess-scene.vala"
								_tmp28_ = FALSE;
#line 1327 "chess-scene.c"
							}
#line 335 "../src/chess-scene.vala"
							if (_tmp28_) {
#line 335 "../src/chess-scene.vala"
								_tmp27_ = file == self->selected_file;
#line 1333 "chess-scene.c"
							} else {
#line 335 "../src/chess-scene.vala"
								_tmp27_ = FALSE;
#line 1337 "chess-scene.c"
							}
#line 335 "../src/chess-scene.vala"
							if (_tmp27_) {
#line 1341 "chess-scene.c"
								ChessModel* _tmp31_;
#line 336 "../src/chess-scene.vala"
								_tmp31_ = model;
#line 336 "../src/chess-scene.vala"
								_tmp31_->is_selected = TRUE;
#line 1347 "chess-scene.c"
							} else {
								ChessModel* _tmp32_;
#line 338 "../src/chess-scene.vala"
								_tmp32_ = model;
#line 338 "../src/chess-scene.vala"
								_tmp32_->is_selected = FALSE;
#line 1354 "chess-scene.c"
							}
#line 340 "../src/chess-scene.vala"
							_tmp33_ = model;
#line 340 "../src/chess-scene.vala"
							_tmp34_ = _g_object_ref0 (_tmp33_);
#line 340 "../src/chess-scene.vala"
							new_pieces = g_list_append (new_pieces, _tmp34_);
#line 310 "../src/chess-scene.vala"
							_g_object_unref0 (model);
#line 310 "../src/chess-scene.vala"
							_g_object_unref0 (piece);
#line 1366 "chess-scene.c"
						}
					}
				}
			}
		}
	}
#line 344 "../src/chess-scene.vala"
	_tmp35_ = new_pieces;
#line 344 "../src/chess-scene.vala"
	_tmp36_ = self->pieces;
#line 344 "../src/chess-scene.vala"
	if (g_list_length (_tmp35_) != g_list_length (_tmp36_)) {
#line 345 "../src/chess-scene.vala"
		board_changed = TRUE;
#line 1381 "chess-scene.c"
	}
#line 347 "../src/chess-scene.vala"
	if (!board_changed) {
#line 348 "../src/chess-scene.vala"
		(new_pieces == NULL) ? NULL : (new_pieces = (_g_list_free__g_object_unref0_ (new_pieces), NULL));
#line 348 "../src/chess-scene.vala"
		return;
#line 1389 "chess-scene.c"
	}
#line 351 "../src/chess-scene.vala"
	(self->pieces == NULL) ? NULL : (self->pieces = (_g_list_free__g_object_unref0_ (self->pieces), NULL));
#line 351 "../src/chess-scene.vala"
	self->pieces = NULL;
#line 352 "../src/chess-scene.vala"
	_tmp37_ = new_pieces;
#line 1397 "chess-scene.c"
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
#line 352 "../src/chess-scene.vala"
		model_collection = _tmp37_;
#line 352 "../src/chess-scene.vala"
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
#line 1405 "chess-scene.c"
			ChessModel* _tmp38_;
			ChessModel* model = NULL;
#line 352 "../src/chess-scene.vala"
			_tmp38_ = _g_object_ref0 ((ChessModel*) model_it->data);
#line 352 "../src/chess-scene.vala"
			model = _tmp38_;
#line 1412 "chess-scene.c"
			{
				ChessModel* _tmp39_;
				ChessModel* _tmp40_;
#line 353 "../src/chess-scene.vala"
				_tmp39_ = model;
#line 353 "../src/chess-scene.vala"
				_tmp40_ = _g_object_ref0 (_tmp39_);
#line 353 "../src/chess-scene.vala"
				self->pieces = g_list_append (self->pieces, _tmp40_);
#line 352 "../src/chess-scene.vala"
				_g_object_unref0 (model);
#line 1424 "chess-scene.c"
			}
		}
	}
#line 354 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 356 "../src/chess-scene.vala"
	if (need_animation) {
#line 356 "../src/chess-scene.vala"
		_tmp41_ = !self->animating;
#line 1434 "chess-scene.c"
	} else {
#line 356 "../src/chess-scene.vala"
		_tmp41_ = FALSE;
#line 1438 "chess-scene.c"
	}
#line 356 "../src/chess-scene.vala"
	if (_tmp41_) {
#line 1442 "chess-scene.c"
		GTimer* _tmp42_;
		ChessGame* _tmp43_;
		ChessGame* _tmp44_;
#line 358 "../src/chess-scene.vala"
		self->animating = TRUE;
#line 359 "../src/chess-scene.vala"
		_tmp42_ = self->priv->animation_timer;
#line 359 "../src/chess-scene.vala"
		g_timer_start (_tmp42_);
#line 360 "../src/chess-scene.vala"
		self->priv->animation_time = (gdouble) 0;
#line 361 "../src/chess-scene.vala"
		_tmp43_ = chess_scene_get_game (self);
#line 361 "../src/chess-scene.vala"
		_tmp44_ = _tmp43_;
#line 361 "../src/chess-scene.vala"
		chess_game_add_hold (_tmp44_);
#line 364 "../src/chess-scene.vala"
		self->priv->animate_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT_IDLE, (guint) 10, _chess_scene_animate_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1462 "chess-scene.c"
	}
#line 300 "../src/chess-scene.vala"
	(new_pieces == NULL) ? NULL : (new_pieces = (_g_list_free__g_object_unref0_ (new_pieces), NULL));
#line 1466 "chess-scene.c"
}

gboolean
chess_scene_can_move (ChessScene* self,
                      gint rank,
                      gint file)
{
	gboolean _tmp0_;
	gboolean result;
#line 368 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 370 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_can_move[(rank * 8) + file];
#line 370 "../src/chess-scene.vala"
	result = _tmp0_;
#line 370 "../src/chess-scene.vala"
	return result;
#line 1484 "chess-scene.c"
}

static gboolean
chess_scene_animate_cb (ChessScene* self)
{
	gdouble old_time = 0.0;
	GTimer* _tmp0_;
	gdouble timestep = 0.0;
	gint animate_count = 0;
	GList* _tmp1_;
	ChessGame* _tmp5_;
	ChessGame* _tmp6_;
	gboolean result;
#line 373 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 376 "../src/chess-scene.vala"
	old_time = self->priv->animation_time;
#line 377 "../src/chess-scene.vala"
	_tmp0_ = self->priv->animation_timer;
#line 377 "../src/chess-scene.vala"
	self->priv->animation_time = g_timer_elapsed (_tmp0_, NULL);
#line 378 "../src/chess-scene.vala"
	timestep = self->priv->animation_time - old_time;
#line 380 "../src/chess-scene.vala"
	animate_count = 0;
#line 381 "../src/chess-scene.vala"
	_tmp1_ = self->pieces;
#line 1512 "chess-scene.c"
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
#line 381 "../src/chess-scene.vala"
		model_collection = _tmp1_;
#line 381 "../src/chess-scene.vala"
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
#line 1520 "chess-scene.c"
			ChessModel* _tmp2_;
			ChessModel* model = NULL;
#line 381 "../src/chess-scene.vala"
			_tmp2_ = _g_object_ref0 ((ChessModel*) model_it->data);
#line 381 "../src/chess-scene.vala"
			model = _tmp2_;
#line 1527 "chess-scene.c"
			{
				ChessModel* _tmp3_;
#line 383 "../src/chess-scene.vala"
				_tmp3_ = model;
#line 383 "../src/chess-scene.vala"
				if (chess_model_animate (_tmp3_, timestep)) {
#line 1534 "chess-scene.c"
					gint _tmp4_;
#line 384 "../src/chess-scene.vala"
					_tmp4_ = animate_count;
#line 384 "../src/chess-scene.vala"
					animate_count = _tmp4_ + 1;
#line 1540 "chess-scene.c"
				}
#line 381 "../src/chess-scene.vala"
				_g_object_unref0 (model);
#line 1544 "chess-scene.c"
			}
		}
	}
#line 386 "../src/chess-scene.vala"
	self->animating = animate_count > 0;
#line 388 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 390 "../src/chess-scene.vala"
	if (self->animating) {
#line 391 "../src/chess-scene.vala"
		result = G_SOURCE_CONTINUE;
#line 391 "../src/chess-scene.vala"
		return result;
#line 1558 "chess-scene.c"
	}
#line 393 "../src/chess-scene.vala"
	_tmp5_ = chess_scene_get_game (self);
#line 393 "../src/chess-scene.vala"
	_tmp6_ = _tmp5_;
#line 393 "../src/chess-scene.vala"
	chess_game_remove_hold (_tmp6_);
#line 394 "../src/chess-scene.vala"
	self->priv->animate_timeout_id = (guint) 0;
#line 395 "../src/chess-scene.vala"
	result = G_SOURCE_REMOVE;
#line 395 "../src/chess-scene.vala"
	return result;
#line 1572 "chess-scene.c"
}

ChessGame*
chess_scene_get_game (ChessScene* self)
{
	ChessGame* result;
	ChessGame* _tmp0_;
#line 94 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_game;
#line 94 "../src/chess-scene.vala"
	result = _tmp0_;
#line 94 "../src/chess-scene.vala"
	return result;
#line 1588 "chess-scene.c"
}

static void
_chess_scene_moved_cb_chess_game_moved (ChessGame* _sender,
                                        ChessMove* move,
                                        gpointer self)
{
#line 106 "../src/chess-scene.vala"
	chess_scene_moved_cb ((ChessScene*) self, _sender, move);
#line 1598 "chess-scene.c"
}

static void
_chess_scene_paused_cb_chess_game_paused (ChessGame* _sender,
                                          gpointer self)
{
#line 107 "../src/chess-scene.vala"
	chess_scene_paused_cb ((ChessScene*) self, _sender);
#line 1607 "chess-scene.c"
}

static void
_chess_scene_unpaused_cb_chess_game_unpaused (ChessGame* _sender,
                                              gpointer self)
{
#line 108 "../src/chess-scene.vala"
	chess_scene_unpaused_cb ((ChessScene*) self, _sender);
#line 1616 "chess-scene.c"
}

static void
_chess_scene_undo_cb_chess_game_undo (ChessGame* _sender,
                                      gpointer self)
{
#line 109 "../src/chess-scene.vala"
	chess_scene_undo_cb ((ChessScene*) self, _sender);
#line 1625 "chess-scene.c"
}

void
chess_scene_set_game (ChessScene* self,
                      ChessGame* value)
{
	ChessGame* _tmp0_;
	ChessGame* _tmp9_;
	ChessGame* _tmp10_;
	ChessGame* _tmp11_;
	ChessGame* _tmp12_;
	ChessGame* _tmp13_;
#line 95 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/chess-scene.vala"
	if (self->priv->animate_timeout_id != ((guint) 0)) {
#line 99 "../src/chess-scene.vala"
		g_source_remove (self->priv->animate_timeout_id);
#line 100 "../src/chess-scene.vala"
		self->priv->animate_timeout_id = (guint) 0;
#line 101 "../src/chess-scene.vala"
		self->animating = FALSE;
#line 1648 "chess-scene.c"
	}
#line 104 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_game;
#line 104 "../src/chess-scene.vala"
	if (_tmp0_ != NULL) {
#line 1654 "chess-scene.c"
		ChessGame* _tmp1_;
		guint _tmp2_;
		ChessGame* _tmp3_;
		guint _tmp4_;
		ChessGame* _tmp5_;
		guint _tmp6_;
		ChessGame* _tmp7_;
		guint _tmp8_;
#line 106 "../src/chess-scene.vala"
		_tmp1_ = self->priv->_game;
#line 106 "../src/chess-scene.vala"
		g_signal_parse_name ("moved", TYPE_CHESS_GAME, &_tmp2_, NULL, FALSE);
#line 106 "../src/chess-scene.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _chess_scene_moved_cb_chess_game_moved, self);
#line 107 "../src/chess-scene.vala"
		_tmp3_ = self->priv->_game;
#line 107 "../src/chess-scene.vala"
		g_signal_parse_name ("paused", TYPE_CHESS_GAME, &_tmp4_, NULL, FALSE);
#line 107 "../src/chess-scene.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _chess_scene_paused_cb_chess_game_paused, self);
#line 108 "../src/chess-scene.vala"
		_tmp5_ = self->priv->_game;
#line 108 "../src/chess-scene.vala"
		g_signal_parse_name ("unpaused", TYPE_CHESS_GAME, &_tmp6_, NULL, FALSE);
#line 108 "../src/chess-scene.vala"
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _chess_scene_unpaused_cb_chess_game_unpaused, self);
#line 109 "../src/chess-scene.vala"
		_tmp7_ = self->priv->_game;
#line 109 "../src/chess-scene.vala"
		g_signal_parse_name ("undo", TYPE_CHESS_GAME, &_tmp8_, NULL, FALSE);
#line 109 "../src/chess-scene.vala"
		g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _chess_scene_undo_cb_chess_game_undo, self);
#line 1687 "chess-scene.c"
	}
#line 112 "../src/chess-scene.vala"
	_tmp9_ = _g_object_ref0 (value);
#line 112 "../src/chess-scene.vala"
	_g_object_unref0 (self->priv->_game);
#line 112 "../src/chess-scene.vala"
	self->priv->_game = _tmp9_;
#line 114 "../src/chess-scene.vala"
	_tmp10_ = self->priv->_game;
#line 114 "../src/chess-scene.vala"
	g_signal_connect_object (_tmp10_, "moved", (GCallback) _chess_scene_moved_cb_chess_game_moved, self, 0);
#line 115 "../src/chess-scene.vala"
	_tmp11_ = self->priv->_game;
#line 115 "../src/chess-scene.vala"
	g_signal_connect_object (_tmp11_, "paused", (GCallback) _chess_scene_paused_cb_chess_game_paused, self, 0);
#line 116 "../src/chess-scene.vala"
	_tmp12_ = self->priv->_game;
#line 116 "../src/chess-scene.vala"
	g_signal_connect_object (_tmp12_, "unpaused", (GCallback) _chess_scene_unpaused_cb_chess_game_unpaused, self, 0);
#line 117 "../src/chess-scene.vala"
	_tmp13_ = self->priv->_game;
#line 117 "../src/chess-scene.vala"
	g_signal_connect_object (_tmp13_, "undo", (GCallback) _chess_scene_undo_cb_chess_game_undo, self, 0);
#line 119 "../src/chess-scene.vala"
	self->priv->_move_number = -1;
#line 120 "../src/chess-scene.vala"
	self->selected_rank = -1;
#line 121 "../src/chess-scene.vala"
	self->selected_file = -1;
#line 123 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 95 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_GAME_PROPERTY]);
#line 1721 "chess-scene.c"
}

gint
chess_scene_get_move_number (ChessScene* self)
{
	gint result;
#line 137 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 137 "../src/chess-scene.vala"
	result = self->priv->_move_number;
#line 137 "../src/chess-scene.vala"
	return result;
#line 1734 "chess-scene.c"
}

void
chess_scene_set_move_number (ChessScene* self,
                             gint value)
{
#line 138 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/chess-scene.vala"
	if (self->priv->_move_number == value) {
#line 141 "../src/chess-scene.vala"
		return;
#line 1747 "chess-scene.c"
	}
#line 142 "../src/chess-scene.vala"
	self->priv->_move_number = value;
#line 143 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 138 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_MOVE_NUMBER_PROPERTY]);
#line 1755 "chess-scene.c"
}

gboolean
chess_scene_get_show_numbering (ChessScene* self)
{
	gboolean result;
#line 150 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 150 "../src/chess-scene.vala"
	result = self->priv->_show_numbering;
#line 150 "../src/chess-scene.vala"
	return result;
#line 1768 "chess-scene.c"
}

void
chess_scene_set_show_numbering (ChessScene* self,
                                gboolean value)
{
#line 151 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/chess-scene.vala"
	self->priv->_show_numbering = value;
#line 151 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 151 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_SHOW_NUMBERING_PROPERTY]);
#line 1783 "chess-scene.c"
}

gboolean
chess_scene_get_show_move_hints (ChessScene* self)
{
	gboolean result;
#line 157 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 157 "../src/chess-scene.vala"
	result = self->priv->_show_move_hints;
#line 157 "../src/chess-scene.vala"
	return result;
#line 1796 "chess-scene.c"
}

void
chess_scene_set_show_move_hints (ChessScene* self,
                                 gboolean value)
{
#line 158 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/chess-scene.vala"
	self->priv->_show_move_hints = value;
#line 158 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 158 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY]);
#line 1811 "chess-scene.c"
}

const gchar*
chess_scene_get_theme_name (ChessScene* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 164 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_theme_name;
#line 164 "../src/chess-scene.vala"
	result = _tmp0_;
#line 164 "../src/chess-scene.vala"
	return result;
#line 1827 "chess-scene.c"
}

void
chess_scene_set_theme_name (ChessScene* self,
                            const gchar* value)
{
	gchar* _tmp0_;
#line 165 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/chess-scene.vala"
	_tmp0_ = g_strdup (value);
#line 165 "../src/chess-scene.vala"
	_g_free0 (self->priv->_theme_name);
#line 165 "../src/chess-scene.vala"
	self->priv->_theme_name = _tmp0_;
#line 165 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 165 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_THEME_NAME_PROPERTY]);
#line 1847 "chess-scene.c"
}

gboolean
chess_scene_get_show_3d_smooth (ChessScene* self)
{
	gboolean result;
#line 171 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/chess-scene.vala"
	result = self->priv->_show_3d_smooth;
#line 171 "../src/chess-scene.vala"
	return result;
#line 1860 "chess-scene.c"
}

void
chess_scene_set_show_3d_smooth (ChessScene* self,
                                gboolean value)
{
#line 172 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/chess-scene.vala"
	self->priv->_show_3d_smooth = value;
#line 172 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 172 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY]);
#line 1875 "chess-scene.c"
}

const gchar*
chess_scene_get_board_side (ChessScene* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 178 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_board_side;
#line 178 "../src/chess-scene.vala"
	result = _tmp0_;
#line 178 "../src/chess-scene.vala"
	return result;
#line 1891 "chess-scene.c"
}

void
chess_scene_set_board_side (ChessScene* self,
                            const gchar* value)
{
	gchar* _tmp0_;
#line 179 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/chess-scene.vala"
	_tmp0_ = g_strdup (value);
#line 179 "../src/chess-scene.vala"
	_g_free0 (self->priv->_board_side);
#line 179 "../src/chess-scene.vala"
	self->priv->_board_side = _tmp0_;
#line 179 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 179 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_BOARD_SIDE_PROPERTY]);
#line 1911 "chess-scene.c"
}

gdouble
chess_scene_get_board_angle (ChessScene* self)
{
	gdouble result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
#line 186 "../src/chess-scene.vala"
	static GQuark _tmp3_label0 = 0;
#line 186 "../src/chess-scene.vala"
	static GQuark _tmp3_label1 = 0;
#line 186 "../src/chess-scene.vala"
	static GQuark _tmp3_label2 = 0;
#line 184 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 186 "../src/chess-scene.vala"
	_tmp0_ = chess_scene_get_board_side (self);
#line 186 "../src/chess-scene.vala"
	_tmp1_ = _tmp0_;
#line 186 "../src/chess-scene.vala"
	_tmp2_ = _tmp1_;
#line 186 "../src/chess-scene.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 186 "../src/chess-scene.vala"
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("black")))) {
#line 186 "../src/chess-scene.vala"
		switch (0) {
#line 1942 "chess-scene.c"
			default:
			{
#line 192 "../src/chess-scene.vala"
				result = 180.0;
#line 192 "../src/chess-scene.vala"
				return result;
#line 1949 "chess-scene.c"
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("human")))) {
#line 186 "../src/chess-scene.vala"
		switch (0) {
#line 1955 "chess-scene.c"
			default:
			{
				ChessGame* _tmp5_;
				ChessGame* _tmp6_;
				ChessPlayer* _tmp7_;
				ChessPlayer* _tmp8_;
				gboolean _tmp9_ = FALSE;
#line 194 "../src/chess-scene.vala"
				_tmp5_ = chess_scene_get_game (self);
#line 194 "../src/chess-scene.vala"
				_tmp6_ = _tmp5_;
#line 194 "../src/chess-scene.vala"
				_tmp7_ = chess_game_get_black (_tmp6_);
#line 194 "../src/chess-scene.vala"
				_tmp8_ = _tmp7_;
#line 194 "../src/chess-scene.vala"
				g_signal_emit (self, chess_scene_signals[CHESS_SCENE_IS_HUMAN_SIGNAL], 0, _tmp8_, &_tmp9_);
#line 194 "../src/chess-scene.vala"
				if (_tmp9_) {
#line 195 "../src/chess-scene.vala"
					result = 180.0;
#line 195 "../src/chess-scene.vala"
					return result;
#line 1979 "chess-scene.c"
				} else {
#line 197 "../src/chess-scene.vala"
					result = 0.0;
#line 197 "../src/chess-scene.vala"
					return result;
#line 1985 "chess-scene.c"
				}
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("current")))) {
#line 186 "../src/chess-scene.vala"
		switch (0) {
#line 1992 "chess-scene.c"
			default:
			{
				gdouble _tmp10_ = 0.0;
				ChessGame* _tmp11_;
				ChessGame* _tmp12_;
				ChessPlayer* _tmp13_;
				ChessPlayer* _tmp14_;
#line 199 "../src/chess-scene.vala"
				_tmp11_ = chess_scene_get_game (self);
#line 199 "../src/chess-scene.vala"
				_tmp12_ = _tmp11_;
#line 199 "../src/chess-scene.vala"
				_tmp13_ = chess_game_get_current_player (_tmp12_);
#line 199 "../src/chess-scene.vala"
				_tmp14_ = _tmp13_;
#line 199 "../src/chess-scene.vala"
				if (_tmp14_->color == COLOR_WHITE) {
#line 199 "../src/chess-scene.vala"
					_tmp10_ = 0.0;
#line 2012 "chess-scene.c"
				} else {
#line 199 "../src/chess-scene.vala"
					_tmp10_ = 180.0;
#line 2016 "chess-scene.c"
				}
#line 199 "../src/chess-scene.vala"
				result = _tmp10_;
#line 199 "../src/chess-scene.vala"
				return result;
#line 2022 "chess-scene.c"
			}
		}
	} else {
#line 186 "../src/chess-scene.vala"
		switch (0) {
#line 2028 "chess-scene.c"
			default:
			{
#line 190 "../src/chess-scene.vala"
				result = 0.0;
#line 190 "../src/chess-scene.vala"
				return result;
#line 2035 "chess-scene.c"
			}
		}
	}
}

const gchar*
chess_scene_get_move_format (ChessScene* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 207 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 207 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_move_format;
#line 207 "../src/chess-scene.vala"
	result = _tmp0_;
#line 207 "../src/chess-scene.vala"
	return result;
#line 2054 "chess-scene.c"
}

void
chess_scene_set_move_format (ChessScene* self,
                             const gchar* value)
{
	gchar* _tmp0_;
#line 208 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/chess-scene.vala"
	_tmp0_ = g_strdup (value);
#line 208 "../src/chess-scene.vala"
	_g_free0 (self->priv->_move_format);
#line 208 "../src/chess-scene.vala"
	self->priv->_move_format = _tmp0_;
#line 208 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 208 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_MOVE_FORMAT_PROPERTY]);
#line 2074 "chess-scene.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 71 "../src/chess-scene.vala"
	g_return_if_fail (return_value != NULL);
#line 71 "../src/chess-scene.vala"
	g_return_if_fail (n_param_values == 2);
#line 71 "../src/chess-scene.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 71 "../src/chess-scene.vala"
		data1 = closure->data;
#line 71 "../src/chess-scene.vala"
		data2 = param_values->data[0].v_pointer;
#line 2102 "chess-scene.c"
	} else {
#line 71 "../src/chess-scene.vala"
		data1 = param_values->data[0].v_pointer;
#line 71 "../src/chess-scene.vala"
		data2 = closure->data;
#line 2108 "chess-scene.c"
	}
#line 71 "../src/chess-scene.vala"
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 71 "../src/chess-scene.vala"
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
#line 71 "../src/chess-scene.vala"
	g_value_set_boolean (return_value, v_return);
#line 2116 "chess-scene.c"
}

static void
g_cclosure_user_marshal_VOID__POINTER_POINTER_POINTER (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_POINTER_POINTER) (gpointer data1, gpointer arg_1, gpointer arg_2, GDestroyNotify arg_3, gpointer data2);
	register GMarshalFunc_VOID__POINTER_POINTER_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 71 "../src/chess-scene.vala"
	g_return_if_fail (n_param_values == 4);
#line 71 "../src/chess-scene.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 71 "../src/chess-scene.vala"
		data1 = closure->data;
#line 71 "../src/chess-scene.vala"
		data2 = param_values->data[0].v_pointer;
#line 2141 "chess-scene.c"
	} else {
#line 71 "../src/chess-scene.vala"
		data1 = param_values->data[0].v_pointer;
#line 71 "../src/chess-scene.vala"
		data2 = closure->data;
#line 2147 "chess-scene.c"
	}
#line 71 "../src/chess-scene.vala"
	callback = (GMarshalFunc_VOID__POINTER_POINTER_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 71 "../src/chess-scene.vala"
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_pointer (param_values + 2), g_value_get_pointer (param_values + 3), data2);
#line 2153 "chess-scene.c"
}

static void
chess_scene_class_init (ChessSceneClass * klass,
                        gpointer klass_data)
{
#line 71 "../src/chess-scene.vala"
	chess_scene_parent_class = g_type_class_peek_parent (klass);
#line 71 "../src/chess-scene.vala"
	g_type_class_adjust_private_offset (klass, &ChessScene_private_offset);
#line 71 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_scene_get_property;
#line 71 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_scene_set_property;
#line 71 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_scene_finalize;
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_GAME_PROPERTY, chess_scene_properties[CHESS_SCENE_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_CHESS_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_MOVE_NUMBER_PROPERTY, chess_scene_properties[CHESS_SCENE_MOVE_NUMBER_PROPERTY] = g_param_spec_int ("move-number", "move-number", "move-number", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_SHOW_NUMBERING_PROPERTY, chess_scene_properties[CHESS_SCENE_SHOW_NUMBERING_PROPERTY] = g_param_spec_boolean ("show-numbering", "show-numbering", "show-numbering", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY, chess_scene_properties[CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY] = g_param_spec_boolean ("show-move-hints", "show-move-hints", "show-move-hints", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_THEME_NAME_PROPERTY, chess_scene_properties[CHESS_SCENE_THEME_NAME_PROPERTY] = g_param_spec_string ("theme-name", "theme-name", "theme-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY, chess_scene_properties[CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY] = g_param_spec_boolean ("show-3d-smooth", "show-3d-smooth", "show-3d-smooth", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_BOARD_SIDE_PROPERTY, chess_scene_properties[CHESS_SCENE_BOARD_SIDE_PROPERTY] = g_param_spec_string ("board-side", "board-side", "board-side", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_BOARD_ANGLE_PROPERTY, chess_scene_properties[CHESS_SCENE_BOARD_ANGLE_PROPERTY] = g_param_spec_double ("board-angle", "board-angle", "board-angle", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_MOVE_FORMAT_PROPERTY, chess_scene_properties[CHESS_SCENE_MOVE_FORMAT_PROPERTY] = g_param_spec_string ("move-format", "move-format", "move-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	chess_scene_signals[CHESS_SCENE_IS_HUMAN_SIGNAL] = g_signal_new ("is-human", TYPE_CHESS_SCENE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, TYPE_CHESS_PLAYER);
#line 71 "../src/chess-scene.vala"
	chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_CHESS_SCENE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 71 "../src/chess-scene.vala"
	chess_scene_signals[CHESS_SCENE_CHOOSE_PROMOTION_TYPE_SIGNAL] = g_signal_new ("choose-promotion-type", TYPE_CHESS_SCENE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_POINTER_POINTER, G_TYPE_NONE, 3, G_TYPE_POINTER, G_TYPE_POINTER, G_TYPE_POINTER);
#line 2194 "chess-scene.c"
}

static void
chess_scene_instance_init (ChessScene * self,
                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 71 "../src/chess-scene.vala"
	self->priv = chess_scene_get_instance_private (self);
#line 73 "../src/chess-scene.vala"
	self->pieces = NULL;
#line 76 "../src/chess-scene.vala"
	self->animating = FALSE;
#line 86 "../src/chess-scene.vala"
	self->selected_rank = -1;
#line 87 "../src/chess-scene.vala"
	self->selected_file = -1;
#line 89 "../src/chess-scene.vala"
	self->priv->animate_timeout_id = (guint) 0;
#line 91 "../src/chess-scene.vala"
	self->priv->_game = NULL;
#line 134 "../src/chess-scene.vala"
	self->priv->_move_number = -1;
#line 147 "../src/chess-scene.vala"
	self->priv->_show_numbering = TRUE;
#line 154 "../src/chess-scene.vala"
	self->priv->_show_move_hints = TRUE;
#line 161 "../src/chess-scene.vala"
	_tmp0_ = g_strdup ("simple");
#line 161 "../src/chess-scene.vala"
	self->priv->_theme_name = _tmp0_;
#line 168 "../src/chess-scene.vala"
	self->priv->_show_3d_smooth = FALSE;
#line 175 "../src/chess-scene.vala"
	_tmp1_ = g_strdup ("human");
#line 175 "../src/chess-scene.vala"
	self->priv->_board_side = _tmp1_;
#line 204 "../src/chess-scene.vala"
	_tmp2_ = g_strdup ("human");
#line 204 "../src/chess-scene.vala"
	self->priv->_move_format = _tmp2_;
#line 2238 "chess-scene.c"
}

static void
chess_scene_finalize (GObject * obj)
{
	ChessScene * self;
#line 71 "../src/chess-scene.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_SCENE, ChessScene);
#line 73 "../src/chess-scene.vala"
	(self->pieces == NULL) ? NULL : (self->pieces = (_g_list_free__g_object_unref0_ (self->pieces), NULL));
#line 77 "../src/chess-scene.vala"
	_g_timer_destroy0 (self->priv->animation_timer);
#line 91 "../src/chess-scene.vala"
	_g_object_unref0 (self->priv->_game);
#line 161 "../src/chess-scene.vala"
	_g_free0 (self->priv->_theme_name);
#line 175 "../src/chess-scene.vala"
	_g_free0 (self->priv->_board_side);
#line 204 "../src/chess-scene.vala"
	_g_free0 (self->priv->_move_format);
#line 71 "../src/chess-scene.vala"
	G_OBJECT_CLASS (chess_scene_parent_class)->finalize (obj);
#line 2261 "chess-scene.c"
}

static GType
chess_scene_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessSceneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_scene_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessScene), 0, (GInstanceInitFunc) chess_scene_instance_init, NULL };
	GType chess_scene_type_id;
	chess_scene_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessScene", &g_define_type_info, 0);
	ChessScene_private_offset = g_type_add_instance_private (chess_scene_type_id, sizeof (ChessScenePrivate));
	return chess_scene_type_id;
}

GType
chess_scene_get_type (void)
{
	static volatile gsize chess_scene_type_id__once = 0;
	if (g_once_init_enter (&chess_scene_type_id__once)) {
		GType chess_scene_type_id;
		chess_scene_type_id = chess_scene_get_type_once ();
		g_once_init_leave (&chess_scene_type_id__once, chess_scene_type_id);
	}
	return chess_scene_type_id__once;
}

static void
_vala_chess_scene_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessScene * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_SCENE, ChessScene);
#line 71 "../src/chess-scene.vala"
	switch (property_id) {
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_GAME_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_object (value, chess_scene_get_game (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_MOVE_NUMBER_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_int (value, chess_scene_get_move_number (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_NUMBERING_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_boolean (value, chess_scene_get_show_numbering (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_boolean (value, chess_scene_get_show_move_hints (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_THEME_NAME_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_string (value, chess_scene_get_theme_name (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_boolean (value, chess_scene_get_show_3d_smooth (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_BOARD_SIDE_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_string (value, chess_scene_get_board_side (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_BOARD_ANGLE_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_double (value, chess_scene_get_board_angle (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_MOVE_FORMAT_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_string (value, chess_scene_get_move_format (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 2350 "chess-scene.c"
		default:
#line 71 "../src/chess-scene.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 71 "../src/chess-scene.vala"
		break;
#line 2356 "chess-scene.c"
	}
}

static void
_vala_chess_scene_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ChessScene * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_SCENE, ChessScene);
#line 71 "../src/chess-scene.vala"
	switch (property_id) {
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_GAME_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_game (self, g_value_get_object (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_MOVE_NUMBER_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_move_number (self, g_value_get_int (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_NUMBERING_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_show_numbering (self, g_value_get_boolean (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_show_move_hints (self, g_value_get_boolean (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_THEME_NAME_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_theme_name (self, g_value_get_string (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_show_3d_smooth (self, g_value_get_boolean (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_BOARD_SIDE_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_board_side (self, g_value_get_string (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_MOVE_FORMAT_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_move_format (self, g_value_get_string (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 2418 "chess-scene.c"
		default:
#line 71 "../src/chess-scene.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 71 "../src/chess-scene.vala"
		break;
#line 2424 "chess-scene.c"
	}
}

