/* chess-window.c generated by valac 0.56.18, the Vala compiler
 * generated from chess-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2024 Michael Catanzaro
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include "libchess.h"
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>

#define HISTORY_GO_FIRST_ACTION_NAME "go-first"
#define HISTORY_GO_PREVIOUS_ACTION_NAME "go-previous"
#define HISTORY_GO_NEXT_ACTION_NAME "go-next"
#define HISTORY_GO_LAST_ACTION_NAME "go-last"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CHESS_WINDOW (chess_window_get_type ())
#define CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_WINDOW, ChessWindow))
#define CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_WINDOW, ChessWindowClass))
#define IS_CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_WINDOW))
#define IS_CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_WINDOW))
#define CHESS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_WINDOW, ChessWindowClass))

typedef struct _ChessWindow ChessWindow;
typedef struct _ChessWindowClass ChessWindowClass;
typedef struct _ChessWindowPrivate ChessWindowPrivate;

#define TYPE_CHESS_VIEW (chess_view_get_type ())
#define CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_VIEW, ChessView))
#define CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_VIEW, ChessViewClass))
#define IS_CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_VIEW))
#define IS_CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_VIEW))
#define CHESS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_VIEW, ChessViewClass))

typedef struct _ChessView ChessView;
typedef struct _ChessViewClass ChessViewClass;

#define TYPE_CHESS_APPLICATION (chess_application_get_type ())
#define CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_APPLICATION, ChessApplication))
#define CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_APPLICATION, ChessApplicationClass))
#define IS_CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_APPLICATION))
#define IS_CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_APPLICATION))
#define CHESS_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_APPLICATION, ChessApplicationClass))

typedef struct _ChessApplication ChessApplication;
typedef struct _ChessApplicationClass ChessApplicationClass;
enum  {
	CHESS_WINDOW_0_PROPERTY,
	CHESS_WINDOW_VIEW_PROPERTY,
	CHESS_WINDOW_SCENE_PROPERTY,
	CHESS_WINDOW_GAME_PROPERTY,
	CHESS_WINDOW_NUM_PROPERTIES
};
static GParamSpec* chess_window_properties[CHESS_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _Block2Data Block2Data;
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ChessWindow {
	AdwApplicationWindow parent_instance;
	ChessWindowPrivate * priv;
};

struct _ChessWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _ChessWindowPrivate {
	ChessView* _view;
	ChessApplication* app;
	AdwToastOverlay* toast_overlay;
	GtkButton* pause_resume_button;
	GtkDropDown* history_dropdown;
	GtkStringList* history_model;
	GtkBox* clock_box;
	GtkDrawingArea* white_time_label;
	GtkDrawingArea* black_time_label;
};

struct _Block2Data {
	int _ref_count_;
	ChessWindow* self;
	GtkWidget* widget;
	cairo_t* c;
};

static gint ChessWindow_private_offset;
static gpointer chess_window_parent_class = NULL;

VALA_EXTERN GType chess_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessWindow, g_object_unref)
VALA_EXTERN GType chess_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessView, g_object_unref)
VALA_EXTERN GType chess_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessApplication, g_object_unref)
VALA_EXTERN ChessWindow* chess_window_new (ChessApplication* app);
VALA_EXTERN ChessWindow* chess_window_construct (GType object_type,
                                     ChessApplication* app);
VALA_EXTERN GType chess_scene_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessScene, g_object_unref)
VALA_EXTERN ChessScene* chess_scene_new (void);
VALA_EXTERN ChessScene* chess_scene_construct (GType object_type);
static void __lambda40_ (ChessWindow* self);
VALA_EXTERN void chess_window_update_history_panel (ChessWindow* self);
static void ___lambda40__chess_scene_changed (ChessScene* _sender,
                                       gpointer self);
VALA_EXTERN ChessView* chess_view_new (ChessScene* scene);
VALA_EXTERN ChessView* chess_view_construct (GType object_type,
                                 ChessScene* scene);
static void chess_window_set_view (ChessWindow* self,
                            ChessView* value);
VALA_EXTERN ChessView* chess_window_get_view (ChessWindow* self);
VALA_EXTERN void chess_window_update_pause_resume_button (ChessWindow* self);
static void chess_window_draw_white_time_label (ChessWindow* self,
                                         GtkDrawingArea* drawing_area,
                                         cairo_t* c,
                                         gint width,
                                         gint height);
static void _chess_window_draw_white_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                     cairo_t* cr,
                                                                     gint width,
                                                                     gint height,
                                                                     gpointer self);
static void chess_window_draw_black_time_label (ChessWindow* self,
                                         GtkDrawingArea* drawing_area,
                                         cairo_t* c,
                                         gint width,
                                         gint height);
static void _chess_window_draw_black_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                     cairo_t* cr,
                                                                     gint width,
                                                                     gint height,
                                                                     gpointer self);
static void chess_window_history_dropdown_button_setup_cb (ChessWindow* self,
                                                    GtkSignalListItemFactory* factory,
                                                    GObject* object);
static void _chess_window_history_dropdown_button_setup_cb_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                                        GObject* object,
                                                                                        gpointer self);
static void chess_window_history_dropdown_button_bind_cb (ChessWindow* self,
                                                   GtkSignalListItemFactory* factory,
                                                   GObject* object);
static void _chess_window_history_dropdown_button_bind_cb_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                                      GObject* object,
                                                                                      gpointer self);
VALA_EXTERN void chess_window_update_game_status (ChessWindow* self,
                                      const gchar* title,
                                      const gchar* info);
VALA_EXTERN gchar* chess_application_compute_current_title (ChessApplication* self);
VALA_EXTERN gchar* chess_application_compute_status_info (ChessApplication* self);
VALA_EXTERN ChessScene* chess_window_get_scene (ChessWindow* self);
VALA_EXTERN ChessGame* chess_scene_get_game (ChessScene* self);
VALA_EXTERN ChessGame* chess_window_get_game (ChessWindow* self);
VALA_EXTERN gint chess_scene_get_move_number (ChessScene* self);
VALA_EXTERN void chess_application_enable_action (ChessApplication* self,
                                      const gchar* name);
VALA_EXTERN void chess_application_disable_action (ChessApplication* self,
                                       const gchar* name);
VALA_EXTERN gchar* chess_window_get_move_text (ChessWindow* self,
                                   ChessMove* move);
VALA_EXTERN void chess_window_set_clock_visible (ChessWindow* self,
                                     gboolean visible);
static gint chess_window_compute_time_label_width_request (ChessWindow* self,
                                                    cairo_t* c);
static void chess_window_draw_time (ChessWindow* self,
                             GtkWidget* widget,
                             cairo_t* c,
                             gint width,
                             gint height,
                             const gchar* text,
                             gdouble* fg,
                             gint fg_length1,
                             gdouble* bg,
                             gint bg_length1);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ___lambda41_ (Block2Data* _data2_);
static gboolean ____lambda41__gsource_func (gpointer self);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static gchar* chess_window_make_clock_text (ChessWindow* self,
                                     ChessClock* clock,
                                     Color color);
static void chess_window_history_dropdown_selection_changed_cb (ChessWindow* self);
VALA_EXTERN void chess_scene_set_move_number (ChessScene* self,
                                  gint value);
static void _chess_window_history_dropdown_selection_changed_cb_g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self);
VALA_EXTERN const gchar* chess_scene_get_move_format (ChessScene* self);
VALA_EXTERN void chess_window_start_game (ChessWindow* self);
static void ___lambda31_ (ChessWindow* self);
static void ____lambda31__chess_clock_tick (ChessClock* _sender,
                                     gpointer self);
VALA_EXTERN void chess_window_move (ChessWindow* self,
                        ChessMove* m);
VALA_EXTERN void chess_window_undo (ChessWindow* self);
VALA_EXTERN void chess_window_end_game (ChessWindow* self);
VALA_EXTERN ChessScene* chess_view_get_scene (ChessView* self);
static void chess_window_finalize (GObject * obj);
static GType chess_window_get_type_once (void);
static void _vala_chess_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_chess_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
chess_window_get_instance_private (ChessWindow* self)
{
	return G_STRUCT_MEMBER_P (self, ChessWindow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../src/chess-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 280 "chess-window.c"
}

static void
__lambda40_ (ChessWindow* self)
{
#line 53 "../src/chess-window.vala"
	chess_window_update_history_panel (self);
#line 288 "chess-window.c"
}

static void
___lambda40__chess_scene_changed (ChessScene* _sender,
                                  gpointer self)
{
#line 53 "../src/chess-window.vala"
	__lambda40_ ((ChessWindow*) self);
#line 297 "chess-window.c"
}

static void
_chess_window_draw_white_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                cairo_t* cr,
                                                                gint width,
                                                                gint height,
                                                                gpointer self)
{
#line 60 "../src/chess-window.vala"
	chess_window_draw_white_time_label ((ChessWindow*) self, drawing_area, cr, width, height);
#line 309 "chess-window.c"
}

static void
_chess_window_draw_black_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                cairo_t* cr,
                                                                gint width,
                                                                gint height,
                                                                gpointer self)
{
#line 61 "../src/chess-window.vala"
	chess_window_draw_black_time_label ((ChessWindow*) self, drawing_area, cr, width, height);
#line 321 "chess-window.c"
}

static void
_chess_window_history_dropdown_button_setup_cb_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                                   GObject* object,
                                                                                   gpointer self)
{
#line 66 "../src/chess-window.vala"
	chess_window_history_dropdown_button_setup_cb ((ChessWindow*) self, _sender, object);
#line 331 "chess-window.c"
}

static void
_chess_window_history_dropdown_button_bind_cb_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                                 GObject* object,
                                                                                 gpointer self)
{
#line 67 "../src/chess-window.vala"
	chess_window_history_dropdown_button_bind_cb ((ChessWindow*) self, _sender, object);
#line 341 "chess-window.c"
}

ChessWindow*
chess_window_construct (GType object_type,
                        ChessApplication* app)
{
	ChessWindow * self = NULL;
	ChessApplication* _tmp0_;
	ChessScene* scene = NULL;
	ChessScene* _tmp1_;
	ChessView* _tmp2_;
	ChessView* _tmp3_;
	AdwToastOverlay* _tmp4_;
	ChessView* _tmp5_;
	GtkDrawingArea* _tmp6_;
	GtkDrawingArea* _tmp7_;
	GtkListItemFactory* list_factory = NULL;
	GtkDropDown* _tmp8_;
	GtkListItemFactory* _tmp9_;
	GtkListItemFactory* _tmp10_;
	GtkSignalListItemFactory* button_factory = NULL;
	GtkSignalListItemFactory* _tmp11_;
	GtkDropDown* _tmp12_;
	GtkDropDown* _tmp13_;
#line 48 "../src/chess-window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 48 "../src/chess-window.vala"
	self = (ChessWindow*) g_object_new (object_type, NULL);
#line 50 "../src/chess-window.vala"
	_tmp0_ = _g_object_ref0 (app);
#line 50 "../src/chess-window.vala"
	_g_object_unref0 (self->priv->app);
#line 50 "../src/chess-window.vala"
	self->priv->app = _tmp0_;
#line 52 "../src/chess-window.vala"
	_tmp1_ = chess_scene_new ();
#line 52 "../src/chess-window.vala"
	scene = _tmp1_;
#line 53 "../src/chess-window.vala"
	g_signal_connect_object (scene, "changed", (GCallback) ___lambda40__chess_scene_changed, self, 0);
#line 55 "../src/chess-window.vala"
	_tmp2_ = chess_view_new (scene);
#line 55 "../src/chess-window.vala"
	g_object_ref_sink (_tmp2_);
#line 55 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 55 "../src/chess-window.vala"
	chess_window_set_view (self, _tmp3_);
#line 55 "../src/chess-window.vala"
	_g_object_unref0 (_tmp3_);
#line 56 "../src/chess-window.vala"
	_tmp4_ = self->priv->toast_overlay;
#line 56 "../src/chess-window.vala"
	_tmp5_ = self->priv->_view;
#line 56 "../src/chess-window.vala"
	adw_toast_overlay_set_child (_tmp4_, (GtkWidget*) _tmp5_);
#line 58 "../src/chess-window.vala"
	chess_window_update_pause_resume_button (self);
#line 60 "../src/chess-window.vala"
	_tmp6_ = self->priv->white_time_label;
#line 60 "../src/chess-window.vala"
	gtk_drawing_area_set_draw_func (_tmp6_, _chess_window_draw_white_time_label_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 61 "../src/chess-window.vala"
	_tmp7_ = self->priv->black_time_label;
#line 61 "../src/chess-window.vala"
	gtk_drawing_area_set_draw_func (_tmp7_, _chess_window_draw_black_time_label_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 63 "../src/chess-window.vala"
	_tmp8_ = self->priv->history_dropdown;
#line 63 "../src/chess-window.vala"
	_tmp9_ = gtk_drop_down_get_factory (_tmp8_);
#line 63 "../src/chess-window.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 63 "../src/chess-window.vala"
	list_factory = _tmp10_;
#line 64 "../src/chess-window.vala"
	_tmp11_ = (GtkSignalListItemFactory*) gtk_signal_list_item_factory_new ();
#line 64 "../src/chess-window.vala"
	button_factory = _tmp11_;
#line 66 "../src/chess-window.vala"
	g_signal_connect_object (button_factory, "setup", (GCallback) _chess_window_history_dropdown_button_setup_cb_gtk_signal_list_item_factory_setup, self, 0);
#line 67 "../src/chess-window.vala"
	g_signal_connect_object (button_factory, "bind", (GCallback) _chess_window_history_dropdown_button_bind_cb_gtk_signal_list_item_factory_bind, self, 0);
#line 69 "../src/chess-window.vala"
	_tmp12_ = self->priv->history_dropdown;
#line 69 "../src/chess-window.vala"
	gtk_drop_down_set_factory (_tmp12_, (GtkListItemFactory*) button_factory);
#line 70 "../src/chess-window.vala"
	_tmp13_ = self->priv->history_dropdown;
#line 70 "../src/chess-window.vala"
	gtk_drop_down_set_list_factory (_tmp13_, list_factory);
#line 48 "../src/chess-window.vala"
	_g_object_unref0 (button_factory);
#line 48 "../src/chess-window.vala"
	_g_object_unref0 (list_factory);
#line 48 "../src/chess-window.vala"
	_g_object_unref0 (scene);
#line 48 "../src/chess-window.vala"
	return self;
#line 440 "chess-window.c"
}

ChessWindow*
chess_window_new (ChessApplication* app)
{
#line 48 "../src/chess-window.vala"
	return chess_window_construct (TYPE_CHESS_WINDOW, app);
#line 448 "chess-window.c"
}

void
chess_window_update_game_status (ChessWindow* self,
                                 const gchar* title,
                                 const gchar* info)
{
	gchar* _tmp0_ = NULL;
	gchar* toast = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp8_;
#line 73 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/chess-window.vala"
	if (title != NULL) {
#line 465 "chess-window.c"
		gchar* _tmp1_;
#line 75 "../src/chess-window.vala"
		_tmp1_ = g_strdup (title);
#line 75 "../src/chess-window.vala"
		_g_free0 (_tmp0_);
#line 75 "../src/chess-window.vala"
		_tmp0_ = _tmp1_;
#line 473 "chess-window.c"
	} else {
		ChessApplication* _tmp2_;
		gchar* _tmp3_;
#line 75 "../src/chess-window.vala"
		_tmp2_ = self->priv->app;
#line 75 "../src/chess-window.vala"
		_tmp3_ = chess_application_compute_current_title (_tmp2_);
#line 75 "../src/chess-window.vala"
		_g_free0 (_tmp0_);
#line 75 "../src/chess-window.vala"
		_tmp0_ = _tmp3_;
#line 485 "chess-window.c"
	}
#line 75 "../src/chess-window.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp0_);
#line 77 "../src/chess-window.vala"
	_tmp4_ = g_strdup (info);
#line 77 "../src/chess-window.vala"
	toast = _tmp4_;
#line 78 "../src/chess-window.vala"
	_tmp5_ = toast;
#line 78 "../src/chess-window.vala"
	if (_tmp5_ == NULL) {
#line 497 "chess-window.c"
		ChessApplication* _tmp6_;
		gchar* _tmp7_;
#line 79 "../src/chess-window.vala"
		_tmp6_ = self->priv->app;
#line 79 "../src/chess-window.vala"
		_tmp7_ = chess_application_compute_status_info (_tmp6_);
#line 79 "../src/chess-window.vala"
		_g_free0 (toast);
#line 79 "../src/chess-window.vala"
		toast = _tmp7_;
#line 508 "chess-window.c"
	}
#line 80 "../src/chess-window.vala"
	_tmp8_ = toast;
#line 80 "../src/chess-window.vala"
	if (_tmp8_ != NULL) {
#line 514 "chess-window.c"
		AdwToastOverlay* _tmp9_;
		const gchar* _tmp10_;
		AdwToast* _tmp11_;
#line 81 "../src/chess-window.vala"
		_tmp9_ = self->priv->toast_overlay;
#line 81 "../src/chess-window.vala"
		_tmp10_ = toast;
#line 81 "../src/chess-window.vala"
		_tmp11_ = adw_toast_new (_tmp10_);
#line 81 "../src/chess-window.vala"
		adw_toast_overlay_add_toast (_tmp9_, _tmp11_);
#line 526 "chess-window.c"
	}
#line 73 "../src/chess-window.vala"
	_g_free0 (toast);
#line 73 "../src/chess-window.vala"
	_g_free0 (_tmp0_);
#line 532 "chess-window.c"
}

void
chess_window_update_pause_resume_button (ChessWindow* self)
{
	ChessGame* game = NULL;
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessGame* _tmp4_;
	gboolean _tmp5_ = FALSE;
	ChessGame* _tmp6_;
	gboolean _tmp12_ = FALSE;
	ChessGame* _tmp13_;
#line 84 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 86 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 86 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 86 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 86 "../src/chess-window.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 86 "../src/chess-window.vala"
	game = _tmp4_;
#line 88 "../src/chess-window.vala"
	_tmp6_ = game;
#line 88 "../src/chess-window.vala"
	if (_tmp6_ != NULL) {
#line 566 "chess-window.c"
		ChessGame* _tmp7_;
		ChessClock* _tmp8_;
		ChessClock* _tmp9_;
#line 88 "../src/chess-window.vala"
		_tmp7_ = game;
#line 88 "../src/chess-window.vala"
		_tmp8_ = chess_game_get_clock (_tmp7_);
#line 88 "../src/chess-window.vala"
		_tmp9_ = _tmp8_;
#line 88 "../src/chess-window.vala"
		_tmp5_ = _tmp9_ == NULL;
#line 578 "chess-window.c"
	} else {
#line 88 "../src/chess-window.vala"
		_tmp5_ = FALSE;
#line 582 "chess-window.c"
	}
#line 88 "../src/chess-window.vala"
	if (_tmp5_) {
#line 586 "chess-window.c"
		GtkButton* _tmp10_;
#line 89 "../src/chess-window.vala"
		_tmp10_ = self->priv->pause_resume_button;
#line 89 "../src/chess-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 592 "chess-window.c"
	} else {
		GtkButton* _tmp11_;
#line 91 "../src/chess-window.vala"
		_tmp11_ = self->priv->pause_resume_button;
#line 91 "../src/chess-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp11_);
#line 599 "chess-window.c"
	}
#line 93 "../src/chess-window.vala"
	_tmp13_ = game;
#line 93 "../src/chess-window.vala"
	if (_tmp13_ != NULL) {
#line 605 "chess-window.c"
		ChessGame* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 93 "../src/chess-window.vala"
		_tmp14_ = game;
#line 93 "../src/chess-window.vala"
		_tmp15_ = chess_game_get_is_paused (_tmp14_);
#line 93 "../src/chess-window.vala"
		_tmp16_ = _tmp15_;
#line 93 "../src/chess-window.vala"
		_tmp12_ = _tmp16_;
#line 617 "chess-window.c"
	} else {
#line 93 "../src/chess-window.vala"
		_tmp12_ = FALSE;
#line 621 "chess-window.c"
	}
#line 93 "../src/chess-window.vala"
	if (_tmp12_) {
#line 625 "chess-window.c"
		GtkButton* _tmp17_;
		GtkButton* _tmp18_;
#line 95 "../src/chess-window.vala"
		_tmp17_ = self->priv->pause_resume_button;
#line 95 "../src/chess-window.vala"
		gtk_button_set_icon_name (_tmp17_, "media-playback-start-symbolic");
#line 96 "../src/chess-window.vala"
		_tmp18_ = self->priv->pause_resume_button;
#line 96 "../src/chess-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp18_, _ ("Unpause the game"));
#line 636 "chess-window.c"
	} else {
		GtkButton* _tmp19_;
		GtkButton* _tmp20_;
#line 100 "../src/chess-window.vala"
		_tmp19_ = self->priv->pause_resume_button;
#line 100 "../src/chess-window.vala"
		gtk_button_set_icon_name (_tmp19_, "media-playback-pause-symbolic");
#line 101 "../src/chess-window.vala"
		_tmp20_ = self->priv->pause_resume_button;
#line 101 "../src/chess-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp20_, _ ("Pause the game"));
#line 648 "chess-window.c"
	}
#line 84 "../src/chess-window.vala"
	_g_object_unref0 (game);
#line 652 "chess-window.c"
}

void
chess_window_update_history_panel (ChessWindow* self)
{
	ChessGame* _tmp0_;
	ChessGame* _tmp1_;
	gint move_number = 0;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint n_moves = 0;
	ChessGame* _tmp6_;
	ChessGame* _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	GtkDropDown* _tmp40_;
	ChessGame* _tmp41_;
	ChessGame* _tmp42_;
	gboolean _tmp43_;
	gboolean _tmp44_;
	gint i = 0;
	gchar** moves = NULL;
	gchar** _tmp45_;
	gint moves_length1;
	gint _moves_size_;
	ChessGame* _tmp46_;
	ChessGame* _tmp47_;
	GList* _tmp48_;
	GtkDropDown* _tmp60_;
#line 105 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_game (self);
#line 107 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 107 "../src/chess-window.vala"
	if (_tmp1_ == NULL) {
#line 108 "../src/chess-window.vala"
		return;
#line 700 "chess-window.c"
	}
#line 110 "../src/chess-window.vala"
	_tmp2_ = chess_window_get_scene (self);
#line 110 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 110 "../src/chess-window.vala"
	_tmp4_ = chess_scene_get_move_number (_tmp3_);
#line 110 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 110 "../src/chess-window.vala"
	move_number = _tmp5_;
#line 111 "../src/chess-window.vala"
	_tmp6_ = chess_window_get_game (self);
#line 111 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 111 "../src/chess-window.vala"
	_tmp8_ = chess_game_get_n_moves (_tmp7_);
#line 111 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 111 "../src/chess-window.vala"
	n_moves = (gint) _tmp9_;
#line 112 "../src/chess-window.vala"
	if (move_number < 0) {
#line 113 "../src/chess-window.vala"
		move_number += 1 + n_moves;
#line 726 "chess-window.c"
	}
#line 115 "../src/chess-window.vala"
	if (n_moves > 0) {
#line 115 "../src/chess-window.vala"
		_tmp11_ = move_number != 0;
#line 732 "chess-window.c"
	} else {
#line 115 "../src/chess-window.vala"
		_tmp11_ = FALSE;
#line 736 "chess-window.c"
	}
#line 115 "../src/chess-window.vala"
	if (_tmp11_) {
#line 740 "chess-window.c"
		ChessGame* _tmp12_;
		ChessGame* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
#line 115 "../src/chess-window.vala"
		_tmp12_ = chess_window_get_game (self);
#line 115 "../src/chess-window.vala"
		_tmp13_ = _tmp12_;
#line 115 "../src/chess-window.vala"
		_tmp14_ = chess_game_get_is_paused (_tmp13_);
#line 115 "../src/chess-window.vala"
		_tmp15_ = _tmp14_;
#line 115 "../src/chess-window.vala"
		_tmp10_ = !_tmp15_;
#line 755 "chess-window.c"
	} else {
#line 115 "../src/chess-window.vala"
		_tmp10_ = FALSE;
#line 759 "chess-window.c"
	}
#line 115 "../src/chess-window.vala"
	if (_tmp10_) {
#line 763 "chess-window.c"
		ChessApplication* _tmp16_;
#line 116 "../src/chess-window.vala"
		_tmp16_ = self->priv->app;
#line 116 "../src/chess-window.vala"
		chess_application_enable_action (_tmp16_, HISTORY_GO_FIRST_ACTION_NAME);
#line 769 "chess-window.c"
	} else {
		ChessApplication* _tmp17_;
#line 118 "../src/chess-window.vala"
		_tmp17_ = self->priv->app;
#line 118 "../src/chess-window.vala"
		chess_application_disable_action (_tmp17_, HISTORY_GO_FIRST_ACTION_NAME);
#line 776 "chess-window.c"
	}
#line 120 "../src/chess-window.vala"
	if (move_number > 0) {
#line 780 "chess-window.c"
		ChessGame* _tmp19_;
		ChessGame* _tmp20_;
		gboolean _tmp21_;
		gboolean _tmp22_;
#line 120 "../src/chess-window.vala"
		_tmp19_ = chess_window_get_game (self);
#line 120 "../src/chess-window.vala"
		_tmp20_ = _tmp19_;
#line 120 "../src/chess-window.vala"
		_tmp21_ = chess_game_get_is_paused (_tmp20_);
#line 120 "../src/chess-window.vala"
		_tmp22_ = _tmp21_;
#line 120 "../src/chess-window.vala"
		_tmp18_ = !_tmp22_;
#line 795 "chess-window.c"
	} else {
#line 120 "../src/chess-window.vala"
		_tmp18_ = FALSE;
#line 799 "chess-window.c"
	}
#line 120 "../src/chess-window.vala"
	if (_tmp18_) {
#line 803 "chess-window.c"
		ChessApplication* _tmp23_;
#line 121 "../src/chess-window.vala"
		_tmp23_ = self->priv->app;
#line 121 "../src/chess-window.vala"
		chess_application_enable_action (_tmp23_, HISTORY_GO_PREVIOUS_ACTION_NAME);
#line 809 "chess-window.c"
	} else {
		ChessApplication* _tmp24_;
#line 123 "../src/chess-window.vala"
		_tmp24_ = self->priv->app;
#line 123 "../src/chess-window.vala"
		chess_application_disable_action (_tmp24_, HISTORY_GO_PREVIOUS_ACTION_NAME);
#line 816 "chess-window.c"
	}
#line 125 "../src/chess-window.vala"
	if (move_number < n_moves) {
#line 820 "chess-window.c"
		ChessGame* _tmp26_;
		ChessGame* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
#line 125 "../src/chess-window.vala"
		_tmp26_ = chess_window_get_game (self);
#line 125 "../src/chess-window.vala"
		_tmp27_ = _tmp26_;
#line 125 "../src/chess-window.vala"
		_tmp28_ = chess_game_get_is_paused (_tmp27_);
#line 125 "../src/chess-window.vala"
		_tmp29_ = _tmp28_;
#line 125 "../src/chess-window.vala"
		_tmp25_ = !_tmp29_;
#line 835 "chess-window.c"
	} else {
#line 125 "../src/chess-window.vala"
		_tmp25_ = FALSE;
#line 839 "chess-window.c"
	}
#line 125 "../src/chess-window.vala"
	if (_tmp25_) {
#line 843 "chess-window.c"
		ChessApplication* _tmp30_;
#line 126 "../src/chess-window.vala"
		_tmp30_ = self->priv->app;
#line 126 "../src/chess-window.vala"
		chess_application_enable_action (_tmp30_, HISTORY_GO_NEXT_ACTION_NAME);
#line 849 "chess-window.c"
	} else {
		ChessApplication* _tmp31_;
#line 128 "../src/chess-window.vala"
		_tmp31_ = self->priv->app;
#line 128 "../src/chess-window.vala"
		chess_application_disable_action (_tmp31_, HISTORY_GO_NEXT_ACTION_NAME);
#line 856 "chess-window.c"
	}
#line 130 "../src/chess-window.vala"
	if (n_moves > 0) {
#line 130 "../src/chess-window.vala"
		_tmp33_ = move_number != n_moves;
#line 862 "chess-window.c"
	} else {
#line 130 "../src/chess-window.vala"
		_tmp33_ = FALSE;
#line 866 "chess-window.c"
	}
#line 130 "../src/chess-window.vala"
	if (_tmp33_) {
#line 870 "chess-window.c"
		ChessGame* _tmp34_;
		ChessGame* _tmp35_;
		gboolean _tmp36_;
		gboolean _tmp37_;
#line 130 "../src/chess-window.vala"
		_tmp34_ = chess_window_get_game (self);
#line 130 "../src/chess-window.vala"
		_tmp35_ = _tmp34_;
#line 130 "../src/chess-window.vala"
		_tmp36_ = chess_game_get_is_paused (_tmp35_);
#line 130 "../src/chess-window.vala"
		_tmp37_ = _tmp36_;
#line 130 "../src/chess-window.vala"
		_tmp32_ = !_tmp37_;
#line 885 "chess-window.c"
	} else {
#line 130 "../src/chess-window.vala"
		_tmp32_ = FALSE;
#line 889 "chess-window.c"
	}
#line 130 "../src/chess-window.vala"
	if (_tmp32_) {
#line 893 "chess-window.c"
		ChessApplication* _tmp38_;
#line 131 "../src/chess-window.vala"
		_tmp38_ = self->priv->app;
#line 131 "../src/chess-window.vala"
		chess_application_enable_action (_tmp38_, HISTORY_GO_LAST_ACTION_NAME);
#line 899 "chess-window.c"
	} else {
		ChessApplication* _tmp39_;
#line 133 "../src/chess-window.vala"
		_tmp39_ = self->priv->app;
#line 133 "../src/chess-window.vala"
		chess_application_disable_action (_tmp39_, HISTORY_GO_LAST_ACTION_NAME);
#line 906 "chess-window.c"
	}
#line 135 "../src/chess-window.vala"
	_tmp40_ = self->priv->history_dropdown;
#line 135 "../src/chess-window.vala"
	_tmp41_ = chess_window_get_game (self);
#line 135 "../src/chess-window.vala"
	_tmp42_ = _tmp41_;
#line 135 "../src/chess-window.vala"
	_tmp43_ = chess_game_get_is_paused (_tmp42_);
#line 135 "../src/chess-window.vala"
	_tmp44_ = _tmp43_;
#line 135 "../src/chess-window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp40_, !_tmp44_);
#line 138 "../src/chess-window.vala"
	i = 0;
#line 139 "../src/chess-window.vala"
	_tmp45_ = g_new0 (gchar*, n_moves + 1);
#line 139 "../src/chess-window.vala"
	moves = _tmp45_;
#line 139 "../src/chess-window.vala"
	moves_length1 = n_moves;
#line 139 "../src/chess-window.vala"
	_moves_size_ = moves_length1;
#line 140 "../src/chess-window.vala"
	_tmp46_ = chess_window_get_game (self);
#line 140 "../src/chess-window.vala"
	_tmp47_ = _tmp46_;
#line 140 "../src/chess-window.vala"
	_tmp48_ = _tmp47_->move_stack;
#line 936 "chess-window.c"
	{
		GList* state_collection = NULL;
		GList* state_it = NULL;
#line 140 "../src/chess-window.vala"
		state_collection = _tmp48_;
#line 140 "../src/chess-window.vala"
		for (state_it = state_collection; state_it != NULL; state_it = state_it->next) {
#line 944 "chess-window.c"
			ChessState* _tmp49_;
			ChessState* state = NULL;
#line 140 "../src/chess-window.vala"
			_tmp49_ = _g_object_ref0 ((ChessState*) state_it->data);
#line 140 "../src/chess-window.vala"
			state = _tmp49_;
#line 951 "chess-window.c"
			{
				ChessMove* move = NULL;
				ChessState* _tmp50_;
				ChessMove* _tmp51_;
				ChessMove* _tmp52_;
				gchar* _tmp53_ = NULL;
				ChessMove* _tmp54_;
				gchar** _tmp57_;
				gint _tmp57__length1;
				gint _tmp58_;
				gchar* _tmp59_;
#line 142 "../src/chess-window.vala"
				_tmp50_ = state;
#line 142 "../src/chess-window.vala"
				_tmp51_ = _tmp50_->last_move;
#line 142 "../src/chess-window.vala"
				_tmp52_ = _g_object_ref0 (_tmp51_);
#line 142 "../src/chess-window.vala"
				move = _tmp52_;
#line 143 "../src/chess-window.vala"
				_tmp54_ = move;
#line 143 "../src/chess-window.vala"
				if (_tmp54_ != NULL) {
#line 975 "chess-window.c"
					ChessMove* _tmp55_;
					gchar* _tmp56_;
#line 143 "../src/chess-window.vala"
					_tmp55_ = move;
#line 143 "../src/chess-window.vala"
					_tmp56_ = chess_window_get_move_text (self, _tmp55_);
#line 143 "../src/chess-window.vala"
					_g_free0 (_tmp53_);
#line 143 "../src/chess-window.vala"
					_tmp53_ = _tmp56_;
#line 986 "chess-window.c"
				} else {
#line 143 "../src/chess-window.vala"
					_g_free0 (_tmp53_);
#line 143 "../src/chess-window.vala"
					_tmp53_ = NULL;
#line 992 "chess-window.c"
				}
#line 143 "../src/chess-window.vala"
				_tmp57_ = moves;
#line 143 "../src/chess-window.vala"
				_tmp57__length1 = moves_length1;
#line 143 "../src/chess-window.vala"
				_tmp58_ = i;
#line 143 "../src/chess-window.vala"
				i = _tmp58_ + 1;
#line 143 "../src/chess-window.vala"
				_tmp59_ = g_strdup (_tmp53_);
#line 143 "../src/chess-window.vala"
				_g_free0 (_tmp57_[_tmp58_]);
#line 143 "../src/chess-window.vala"
				_tmp57_[_tmp58_] = _tmp59_;
#line 140 "../src/chess-window.vala"
				_g_free0 (_tmp53_);
#line 140 "../src/chess-window.vala"
				_g_object_unref0 (move);
#line 140 "../src/chess-window.vala"
				_g_object_unref0 (state);
#line 1014 "chess-window.c"
			}
		}
	}
#line 146 "../src/chess-window.vala"
	_tmp60_ = self->priv->history_dropdown;
#line 146 "../src/chess-window.vala"
	gtk_drop_down_set_selected (_tmp60_, (guint) move_number);
#line 105 "../src/chess-window.vala"
	moves = (_vala_array_free (moves, moves_length1, (GDestroyNotify) g_free), NULL);
#line 1024 "chess-window.c"
}

void
chess_window_set_clock_visible (ChessWindow* self,
                                gboolean visible)
{
	GtkBox* _tmp0_;
#line 149 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/chess-window.vala"
	_tmp0_ = self->priv->clock_box;
#line 151 "../src/chess-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, visible);
#line 1038 "chess-window.c"
}

static gint
chess_window_compute_time_label_width_request (ChessWindow* self,
                                               cairo_t* c)
{
	cairo_text_extents_t extents = {0};
	gdouble max = 0.0;
	cairo_text_extents_t _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	cairo_text_extents_t _tmp6_;
	cairo_text_extents_t _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	cairo_text_extents_t _tmp10_;
	cairo_text_extents_t _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	cairo_text_extents_t _tmp14_;
	cairo_text_extents_t _tmp16_ = {0};
	gdouble _tmp17_ = 0.0;
	cairo_text_extents_t _tmp18_;
	cairo_text_extents_t _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	cairo_text_extents_t _tmp22_;
	cairo_text_extents_t _tmp24_ = {0};
	gdouble _tmp25_ = 0.0;
	cairo_text_extents_t _tmp26_;
	cairo_text_extents_t _tmp28_ = {0};
	gdouble _tmp29_ = 0.0;
	cairo_text_extents_t _tmp30_;
	cairo_text_extents_t _tmp32_ = {0};
	gdouble _tmp33_ = 0.0;
	cairo_text_extents_t _tmp34_;
	cairo_text_extents_t _tmp36_ = {0};
	gdouble _tmp37_ = 0.0;
	cairo_text_extents_t _tmp38_;
	gint result;
#line 158 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 158 "../src/chess-window.vala"
	g_return_val_if_fail (c != NULL, 0);
#line 162 "../src/chess-window.vala"
	max = (gdouble) 0;
#line 164 "../src/chess-window.vala"
	cairo_text_extents (c, "000∶00", &_tmp0_);
#line 164 "../src/chess-window.vala"
	extents = _tmp0_;
#line 165 "../src/chess-window.vala"
	_tmp2_ = extents;
#line 165 "../src/chess-window.vala"
	if (max > _tmp2_.width) {
#line 165 "../src/chess-window.vala"
		_tmp1_ = max;
#line 1094 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp3_;
#line 165 "../src/chess-window.vala"
		_tmp3_ = extents;
#line 165 "../src/chess-window.vala"
		_tmp1_ = _tmp3_.width;
#line 1101 "chess-window.c"
	}
#line 165 "../src/chess-window.vala"
	max = _tmp1_;
#line 166 "../src/chess-window.vala"
	cairo_text_extents (c, "111∶11", &_tmp4_);
#line 166 "../src/chess-window.vala"
	extents = _tmp4_;
#line 167 "../src/chess-window.vala"
	_tmp6_ = extents;
#line 167 "../src/chess-window.vala"
	if (max > _tmp6_.width) {
#line 167 "../src/chess-window.vala"
		_tmp5_ = max;
#line 1115 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp7_;
#line 167 "../src/chess-window.vala"
		_tmp7_ = extents;
#line 167 "../src/chess-window.vala"
		_tmp5_ = _tmp7_.width;
#line 1122 "chess-window.c"
	}
#line 167 "../src/chess-window.vala"
	max = _tmp5_;
#line 168 "../src/chess-window.vala"
	cairo_text_extents (c, "222∶22", &_tmp8_);
#line 168 "../src/chess-window.vala"
	extents = _tmp8_;
#line 169 "../src/chess-window.vala"
	_tmp10_ = extents;
#line 169 "../src/chess-window.vala"
	if (max > _tmp10_.width) {
#line 169 "../src/chess-window.vala"
		_tmp9_ = max;
#line 1136 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp11_;
#line 169 "../src/chess-window.vala"
		_tmp11_ = extents;
#line 169 "../src/chess-window.vala"
		_tmp9_ = _tmp11_.width;
#line 1143 "chess-window.c"
	}
#line 169 "../src/chess-window.vala"
	max = _tmp9_;
#line 170 "../src/chess-window.vala"
	cairo_text_extents (c, "333∶33", &_tmp12_);
#line 170 "../src/chess-window.vala"
	extents = _tmp12_;
#line 171 "../src/chess-window.vala"
	_tmp14_ = extents;
#line 171 "../src/chess-window.vala"
	if (max > _tmp14_.width) {
#line 171 "../src/chess-window.vala"
		_tmp13_ = max;
#line 1157 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp15_;
#line 171 "../src/chess-window.vala"
		_tmp15_ = extents;
#line 171 "../src/chess-window.vala"
		_tmp13_ = _tmp15_.width;
#line 1164 "chess-window.c"
	}
#line 171 "../src/chess-window.vala"
	max = _tmp13_;
#line 172 "../src/chess-window.vala"
	cairo_text_extents (c, "444∶44", &_tmp16_);
#line 172 "../src/chess-window.vala"
	extents = _tmp16_;
#line 173 "../src/chess-window.vala"
	_tmp18_ = extents;
#line 173 "../src/chess-window.vala"
	if (max > _tmp18_.width) {
#line 173 "../src/chess-window.vala"
		_tmp17_ = max;
#line 1178 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp19_;
#line 173 "../src/chess-window.vala"
		_tmp19_ = extents;
#line 173 "../src/chess-window.vala"
		_tmp17_ = _tmp19_.width;
#line 1185 "chess-window.c"
	}
#line 173 "../src/chess-window.vala"
	max = _tmp17_;
#line 174 "../src/chess-window.vala"
	cairo_text_extents (c, "555∶55", &_tmp20_);
#line 174 "../src/chess-window.vala"
	extents = _tmp20_;
#line 175 "../src/chess-window.vala"
	_tmp22_ = extents;
#line 175 "../src/chess-window.vala"
	if (max > _tmp22_.width) {
#line 175 "../src/chess-window.vala"
		_tmp21_ = max;
#line 1199 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp23_;
#line 175 "../src/chess-window.vala"
		_tmp23_ = extents;
#line 175 "../src/chess-window.vala"
		_tmp21_ = _tmp23_.width;
#line 1206 "chess-window.c"
	}
#line 175 "../src/chess-window.vala"
	max = _tmp21_;
#line 176 "../src/chess-window.vala"
	cairo_text_extents (c, "666∶66", &_tmp24_);
#line 176 "../src/chess-window.vala"
	extents = _tmp24_;
#line 177 "../src/chess-window.vala"
	_tmp26_ = extents;
#line 177 "../src/chess-window.vala"
	if (max > _tmp26_.width) {
#line 177 "../src/chess-window.vala"
		_tmp25_ = max;
#line 1220 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp27_;
#line 177 "../src/chess-window.vala"
		_tmp27_ = extents;
#line 177 "../src/chess-window.vala"
		_tmp25_ = _tmp27_.width;
#line 1227 "chess-window.c"
	}
#line 177 "../src/chess-window.vala"
	max = _tmp25_;
#line 178 "../src/chess-window.vala"
	cairo_text_extents (c, "777∶77", &_tmp28_);
#line 178 "../src/chess-window.vala"
	extents = _tmp28_;
#line 179 "../src/chess-window.vala"
	_tmp30_ = extents;
#line 179 "../src/chess-window.vala"
	if (max > _tmp30_.width) {
#line 179 "../src/chess-window.vala"
		_tmp29_ = max;
#line 1241 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp31_;
#line 179 "../src/chess-window.vala"
		_tmp31_ = extents;
#line 179 "../src/chess-window.vala"
		_tmp29_ = _tmp31_.width;
#line 1248 "chess-window.c"
	}
#line 179 "../src/chess-window.vala"
	max = _tmp29_;
#line 180 "../src/chess-window.vala"
	cairo_text_extents (c, "888∶88", &_tmp32_);
#line 180 "../src/chess-window.vala"
	extents = _tmp32_;
#line 181 "../src/chess-window.vala"
	_tmp34_ = extents;
#line 181 "../src/chess-window.vala"
	if (max > _tmp34_.width) {
#line 181 "../src/chess-window.vala"
		_tmp33_ = max;
#line 1262 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp35_;
#line 181 "../src/chess-window.vala"
		_tmp35_ = extents;
#line 181 "../src/chess-window.vala"
		_tmp33_ = _tmp35_.width;
#line 1269 "chess-window.c"
	}
#line 181 "../src/chess-window.vala"
	max = _tmp33_;
#line 182 "../src/chess-window.vala"
	cairo_text_extents (c, "999∶99", &_tmp36_);
#line 182 "../src/chess-window.vala"
	extents = _tmp36_;
#line 183 "../src/chess-window.vala"
	_tmp38_ = extents;
#line 183 "../src/chess-window.vala"
	if (max > _tmp38_.width) {
#line 183 "../src/chess-window.vala"
		_tmp37_ = max;
#line 1283 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp39_;
#line 183 "../src/chess-window.vala"
		_tmp39_ = extents;
#line 183 "../src/chess-window.vala"
		_tmp37_ = _tmp39_.width;
#line 1290 "chess-window.c"
	}
#line 183 "../src/chess-window.vala"
	max = _tmp37_;
#line 186 "../src/chess-window.vala"
	result = ((gint) ceil (max)) + 6;
#line 186 "../src/chess-window.vala"
	_vala_warn_if_fail (result > 0, "result > 0");
#line 186 "../src/chess-window.vala"
	return result;
#line 1300 "chess-window.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 189 "../src/chess-window.vala"
	return self ? cairo_reference (self) : NULL;
#line 1308 "chess-window.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 189 "../src/chess-window.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 189 "../src/chess-window.vala"
	return _data2_;
#line 1318 "chess-window.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 189 "../src/chess-window.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1328 "chess-window.c"
		ChessWindow* self;
#line 189 "../src/chess-window.vala"
		self = _data2_->self;
#line 189 "../src/chess-window.vala"
		_g_object_unref0 (_data2_->widget);
#line 189 "../src/chess-window.vala"
		_cairo_destroy0 (_data2_->c);
#line 189 "../src/chess-window.vala"
		_g_object_unref0 (self);
#line 189 "../src/chess-window.vala"
		g_slice_free (Block2Data, _data2_);
#line 1340 "chess-window.c"
	}
}

static gboolean
___lambda41_ (Block2Data* _data2_)
{
	ChessWindow* self;
	gboolean result;
#line 199 "../src/chess-window.vala"
	self = _data2_->self;
#line 200 "../src/chess-window.vala"
	gtk_widget_set_size_request (_data2_->widget, chess_window_compute_time_label_width_request (self, _data2_->c), -1);
#line 201 "../src/chess-window.vala"
	gtk_widget_queue_draw (_data2_->widget);
#line 202 "../src/chess-window.vala"
	result = G_SOURCE_REMOVE;
#line 202 "../src/chess-window.vala"
	return result;
#line 1359 "chess-window.c"
}

static gboolean
____lambda41__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda41_ (self);
#line 199 "../src/chess-window.vala"
	return result;
#line 1369 "chess-window.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 216 "../src/chess-window.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 1377 "chess-window.c"
}

static void
chess_window_draw_time (ChessWindow* self,
                        GtkWidget* widget,
                        cairo_t* c,
                        gint width,
                        gint height,
                        const gchar* text,
                        gdouble* fg,
                        gint fg_length1,
                        gdouble* bg,
                        gint bg_length1)
{
	Block2Data* _data2_;
	GtkWidget* _tmp0_;
	cairo_t* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble alpha = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	PangoContext* pango_context = NULL;
	PangoContext* _tmp7_;
	PangoContext* _tmp8_;
	cairo_font_options_t* _tmp9_;
	PangoLayout* layout = NULL;
	PangoContext* _tmp10_;
	PangoLayout* _tmp11_;
	PangoLayout* _tmp12_;
	PangoFontDescription* _tmp13_;
	PangoFontDescription* _tmp14_;
	PangoLayout* _tmp15_;
	PangoAttrList* attributes = NULL;
	PangoAttrList* _tmp16_;
	PangoAttrList* _tmp17_;
	PangoAttrFontFeatures* _tmp18_;
	PangoLayout* _tmp19_;
	PangoAttrList* _tmp20_;
	gint layout_width = 0;
	gint layout_height = 0;
	PangoLayout* _tmp21_;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	PangoLayout* _tmp27_;
#line 189 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/chess-window.vala"
	g_return_if_fail (widget != NULL);
#line 189 "../src/chess-window.vala"
	g_return_if_fail (c != NULL);
#line 189 "../src/chess-window.vala"
	g_return_if_fail (text != NULL);
#line 189 "../src/chess-window.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 189 "../src/chess-window.vala"
	_data2_->_ref_count_ = 1;
#line 189 "../src/chess-window.vala"
	_data2_->self = g_object_ref (self);
#line 189 "../src/chess-window.vala"
	_tmp0_ = _g_object_ref0 (widget);
#line 189 "../src/chess-window.vala"
	_g_object_unref0 (_data2_->widget);
#line 189 "../src/chess-window.vala"
	_data2_->widget = _tmp0_;
#line 189 "../src/chess-window.vala"
	_tmp1_ = _cairo_reference0 (c);
#line 189 "../src/chess-window.vala"
	_cairo_destroy0 (_data2_->c);
#line 189 "../src/chess-window.vala"
	_data2_->c = _tmp1_;
#line 197 "../src/chess-window.vala"
	g_object_get (_data2_->widget, "width-request", &_tmp2_, NULL);
#line 197 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 197 "../src/chess-window.vala"
	if (_tmp3_ == -1) {
#line 199 "../src/chess-window.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda41__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 204 "../src/chess-window.vala"
		block2_data_unref (_data2_);
#line 204 "../src/chess-window.vala"
		_data2_ = NULL;
#line 204 "../src/chess-window.vala"
		return;
#line 1467 "chess-window.c"
	}
#line 207 "../src/chess-window.vala"
	alpha = 1.0;
#line 208 "../src/chess-window.vala"
	if ((gtk_widget_get_state_flags (_data2_->widget) & GTK_STATE_FLAG_INSENSITIVE) != 0) {
#line 209 "../src/chess-window.vala"
		alpha = 0.5;
#line 1475 "chess-window.c"
	}
#line 210 "../src/chess-window.vala"
	_tmp4_ = bg[0];
#line 210 "../src/chess-window.vala"
	_tmp5_ = bg[1];
#line 210 "../src/chess-window.vala"
	_tmp6_ = bg[2];
#line 210 "../src/chess-window.vala"
	cairo_set_source_rgba (_data2_->c, _tmp4_, _tmp5_, _tmp6_, alpha);
#line 211 "../src/chess-window.vala"
	cairo_paint (_data2_->c);
#line 213 "../src/chess-window.vala"
	_tmp7_ = pango_cairo_create_context (_data2_->c);
#line 213 "../src/chess-window.vala"
	pango_context = _tmp7_;
#line 214 "../src/chess-window.vala"
	_tmp8_ = pango_context;
#line 214 "../src/chess-window.vala"
	_tmp9_ = gtk_widget_get_font_options ((GtkWidget*) self);
#line 214 "../src/chess-window.vala"
	pango_cairo_context_set_font_options (_tmp8_, _tmp9_);
#line 215 "../src/chess-window.vala"
	_tmp10_ = pango_context;
#line 215 "../src/chess-window.vala"
	_tmp11_ = pango_layout_new (_tmp10_);
#line 215 "../src/chess-window.vala"
	layout = _tmp11_;
#line 216 "../src/chess-window.vala"
	_tmp12_ = layout;
#line 216 "../src/chess-window.vala"
	_tmp13_ = pango_font_description_from_string ("Sans Bold 14");
#line 216 "../src/chess-window.vala"
	_tmp14_ = _tmp13_;
#line 216 "../src/chess-window.vala"
	pango_layout_set_font_description (_tmp12_, _tmp14_);
#line 216 "../src/chess-window.vala"
	__vala_PangoFontDescription_free0 (_tmp14_);
#line 217 "../src/chess-window.vala"
	_tmp15_ = layout;
#line 217 "../src/chess-window.vala"
	pango_layout_set_text (_tmp15_, text, -1);
#line 220 "../src/chess-window.vala"
	_tmp16_ = pango_attr_list_new ();
#line 220 "../src/chess-window.vala"
	attributes = _tmp16_;
#line 221 "../src/chess-window.vala"
	_tmp17_ = attributes;
#line 221 "../src/chess-window.vala"
	_tmp18_ = (PangoAttrFontFeatures*) pango_attr_font_features_new ("tnum=1");
#line 221 "../src/chess-window.vala"
	pango_attr_list_insert (_tmp17_, (PangoAttribute*) _tmp18_);
#line 222 "../src/chess-window.vala"
	_tmp19_ = layout;
#line 222 "../src/chess-window.vala"
	_tmp20_ = attributes;
#line 222 "../src/chess-window.vala"
	pango_layout_set_attributes (_tmp19_, _tmp20_);
#line 226 "../src/chess-window.vala"
	_tmp21_ = layout;
#line 226 "../src/chess-window.vala"
	pango_layout_get_size (_tmp21_, &_tmp22_, &_tmp23_);
#line 226 "../src/chess-window.vala"
	layout_width = _tmp22_;
#line 226 "../src/chess-window.vala"
	layout_height = _tmp23_;
#line 227 "../src/chess-window.vala"
	layout_width /= PANGO_SCALE;
#line 228 "../src/chess-window.vala"
	layout_height /= PANGO_SCALE;
#line 229 "../src/chess-window.vala"
	cairo_move_to (_data2_->c, (gdouble) ((gtk_widget_get_width (_data2_->widget) - layout_width) / 2), (gdouble) ((gtk_widget_get_height (_data2_->widget) - layout_height) / 2));
#line 231 "../src/chess-window.vala"
	_tmp24_ = fg[0];
#line 231 "../src/chess-window.vala"
	_tmp25_ = fg[1];
#line 231 "../src/chess-window.vala"
	_tmp26_ = fg[2];
#line 231 "../src/chess-window.vala"
	cairo_set_source_rgba (_data2_->c, _tmp24_, _tmp25_, _tmp26_, alpha);
#line 232 "../src/chess-window.vala"
	_tmp27_ = layout;
#line 232 "../src/chess-window.vala"
	pango_cairo_show_layout (_data2_->c, _tmp27_);
#line 189 "../src/chess-window.vala"
	_pango_attr_list_unref0 (attributes);
#line 189 "../src/chess-window.vala"
	_g_object_unref0 (layout);
#line 189 "../src/chess-window.vala"
	_g_object_unref0 (pango_context);
#line 189 "../src/chess-window.vala"
	block2_data_unref (_data2_);
#line 189 "../src/chess-window.vala"
	_data2_ = NULL;
#line 1569 "chess-window.c"
}

static gchar*
chess_window_make_clock_text (ChessWindow* self,
                              ChessClock* clock,
                              Color color)
{
	gint time = 0;
	gchar* result;
#line 235 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 235 "../src/chess-window.vala"
	_vala_return_val_if_fail (clock != NULL, "clock != null", NULL);
#line 239 "../src/chess-window.vala"
	if (color == COLOR_WHITE) {
#line 1585 "chess-window.c"
		gint _tmp0_;
		gint _tmp1_;
#line 240 "../src/chess-window.vala"
		_tmp0_ = chess_clock_get_white_remaining_seconds (clock);
#line 240 "../src/chess-window.vala"
		_tmp1_ = _tmp0_;
#line 240 "../src/chess-window.vala"
		time = _tmp1_;
#line 1594 "chess-window.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 242 "../src/chess-window.vala"
		_tmp2_ = chess_clock_get_black_remaining_seconds (clock);
#line 242 "../src/chess-window.vala"
		_tmp3_ = _tmp2_;
#line 242 "../src/chess-window.vala"
		time = _tmp3_;
#line 1604 "chess-window.c"
	}
#line 245 "../src/chess-window.vala"
	if (time >= 60) {
#line 1608 "chess-window.c"
		gchar* _tmp4_;
#line 246 "../src/chess-window.vala"
		_tmp4_ = g_strdup_printf ("%d∶\xE2\x80\x8E%02d", time / 60, time % 60);
#line 246 "../src/chess-window.vala"
		result = _tmp4_;
#line 246 "../src/chess-window.vala"
		return result;
#line 1616 "chess-window.c"
	} else {
		gchar* _tmp5_;
#line 248 "../src/chess-window.vala"
		_tmp5_ = g_strdup_printf ("∶\xE2\x80\x8E%02d", time);
#line 248 "../src/chess-window.vala"
		result = _tmp5_;
#line 248 "../src/chess-window.vala"
		return result;
#line 1625 "chess-window.c"
	}
}

static void
chess_window_draw_white_time_label (ChessWindow* self,
                                    GtkDrawingArea* drawing_area,
                                    cairo_t* c,
                                    gint width,
                                    gint height)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessClock* _tmp4_;
	ChessClock* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gdouble* _tmp8_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble* _tmp10_;
	gdouble* _tmp11_;
	gint _tmp11__length1;
#line 251 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/chess-window.vala"
	g_return_if_fail (drawing_area != NULL);
#line 251 "../src/chess-window.vala"
	g_return_if_fail (c != NULL);
#line 253 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 253 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 253 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 253 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 253 "../src/chess-window.vala"
	_tmp4_ = chess_game_get_clock (_tmp3_);
#line 253 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 253 "../src/chess-window.vala"
	_tmp6_ = chess_window_make_clock_text (self, _tmp5_, COLOR_WHITE);
#line 253 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 253 "../src/chess-window.vala"
	_tmp8_ = g_new0 (gdouble, 3);
#line 253 "../src/chess-window.vala"
	_tmp8_[0] = 0.0;
#line 253 "../src/chess-window.vala"
	_tmp8_[1] = 0.0;
#line 253 "../src/chess-window.vala"
	_tmp8_[2] = 0.0;
#line 253 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 253 "../src/chess-window.vala"
	_tmp9__length1 = 3;
#line 253 "../src/chess-window.vala"
	_tmp10_ = g_new0 (gdouble, 3);
#line 253 "../src/chess-window.vala"
	_tmp10_[0] = 1.0;
#line 253 "../src/chess-window.vala"
	_tmp10_[1] = 1.0;
#line 253 "../src/chess-window.vala"
	_tmp10_[2] = 1.0;
#line 253 "../src/chess-window.vala"
	_tmp11_ = _tmp10_;
#line 253 "../src/chess-window.vala"
	_tmp11__length1 = 3;
#line 253 "../src/chess-window.vala"
	chess_window_draw_time (self, (GtkWidget*) drawing_area, c, width, height, _tmp7_, _tmp9_, (gint) 3, _tmp11_, (gint) 3);
#line 253 "../src/chess-window.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 253 "../src/chess-window.vala"
	_tmp9_ = (g_free (_tmp9_), NULL);
#line 253 "../src/chess-window.vala"
	_g_free0 (_tmp7_);
#line 1704 "chess-window.c"
}

static void
chess_window_draw_black_time_label (ChessWindow* self,
                                    GtkDrawingArea* drawing_area,
                                    cairo_t* c,
                                    gint width,
                                    gint height)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessClock* _tmp4_;
	ChessClock* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gdouble* _tmp8_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble* _tmp10_;
	gdouble* _tmp11_;
	gint _tmp11__length1;
#line 256 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/chess-window.vala"
	g_return_if_fail (drawing_area != NULL);
#line 256 "../src/chess-window.vala"
	g_return_if_fail (c != NULL);
#line 258 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 258 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 258 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 258 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 258 "../src/chess-window.vala"
	_tmp4_ = chess_game_get_clock (_tmp3_);
#line 258 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 258 "../src/chess-window.vala"
	_tmp6_ = chess_window_make_clock_text (self, _tmp5_, COLOR_BLACK);
#line 258 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 258 "../src/chess-window.vala"
	_tmp8_ = g_new0 (gdouble, 3);
#line 258 "../src/chess-window.vala"
	_tmp8_[0] = 1.0;
#line 258 "../src/chess-window.vala"
	_tmp8_[1] = 1.0;
#line 258 "../src/chess-window.vala"
	_tmp8_[2] = 1.0;
#line 258 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 258 "../src/chess-window.vala"
	_tmp9__length1 = 3;
#line 258 "../src/chess-window.vala"
	_tmp10_ = g_new0 (gdouble, 3);
#line 258 "../src/chess-window.vala"
	_tmp10_[0] = 0.0;
#line 258 "../src/chess-window.vala"
	_tmp10_[1] = 0.0;
#line 258 "../src/chess-window.vala"
	_tmp10_[2] = 0.0;
#line 258 "../src/chess-window.vala"
	_tmp11_ = _tmp10_;
#line 258 "../src/chess-window.vala"
	_tmp11__length1 = 3;
#line 258 "../src/chess-window.vala"
	chess_window_draw_time (self, (GtkWidget*) drawing_area, c, width, height, _tmp7_, _tmp9_, (gint) 3, _tmp11_, (gint) 3);
#line 258 "../src/chess-window.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 258 "../src/chess-window.vala"
	_tmp9_ = (g_free (_tmp9_), NULL);
#line 258 "../src/chess-window.vala"
	_g_free0 (_tmp7_);
#line 1782 "chess-window.c"
}

static void
chess_window_history_dropdown_button_setup_cb (ChessWindow* self,
                                               GtkSignalListItemFactory* factory,
                                               GObject* object)
{
	GtkListItem* list_item = NULL;
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
#line 261 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/chess-window.vala"
	g_return_if_fail (factory != NULL);
#line 261 "../src/chess-window.vala"
	g_return_if_fail (object != NULL);
#line 262 "../src/chess-window.vala"
	list_item = G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_list_item_get_type ()) ? ((GtkListItem*) object) : NULL;
#line 264 "../src/chess-window.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 264 "../src/chess-window.vala"
	gtk_label_set_ellipsize (_tmp0_, PANGO_ELLIPSIZE_END);
#line 264 "../src/chess-window.vala"
	gtk_label_set_xalign (_tmp0_, (gfloat) 0);
#line 264 "../src/chess-window.vala"
	g_object_ref_sink (_tmp0_);
#line 264 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 264 "../src/chess-window.vala"
	gtk_list_item_set_child (list_item, (GtkWidget*) _tmp1_);
#line 264 "../src/chess-window.vala"
	_g_object_unref0 (_tmp1_);
#line 1815 "chess-window.c"
}

static void
chess_window_history_dropdown_button_bind_cb (ChessWindow* self,
                                              GtkSignalListItemFactory* factory,
                                              GObject* object)
{
	GtkListItem* list_item = NULL;
	GtkStringObject* string_object = NULL;
	GObject* _tmp0_;
	GObject* _tmp1_;
	GtkLabel* label = NULL;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 270 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/chess-window.vala"
	g_return_if_fail (factory != NULL);
#line 270 "../src/chess-window.vala"
	g_return_if_fail (object != NULL);
#line 271 "../src/chess-window.vala"
	list_item = G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_list_item_get_type ()) ? ((GtkListItem*) object) : NULL;
#line 272 "../src/chess-window.vala"
	_tmp0_ = gtk_list_item_get_item (list_item);
#line 272 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 272 "../src/chess-window.vala"
	string_object = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_string_object_get_type ()) ? ((GtkStringObject*) _tmp1_) : NULL;
#line 273 "../src/chess-window.vala"
	_tmp2_ = gtk_list_item_get_child (list_item);
#line 273 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 273 "../src/chess-window.vala"
	label = G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp3_) : NULL;
#line 275 "../src/chess-window.vala"
	_tmp4_ = gtk_string_object_get_string (string_object);
#line 275 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 275 "../src/chess-window.vala"
	gtk_label_set_label (label, _tmp5_);
#line 1858 "chess-window.c"
}

static void
chess_window_history_dropdown_selection_changed_cb (ChessWindow* self)
{
	gint move_number = 0;
	GtkDropDown* _tmp0_;
	gboolean _tmp1_ = FALSE;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
#line 279 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/chess-window.vala"
	_tmp0_ = self->priv->history_dropdown;
#line 281 "../src/chess-window.vala"
	move_number = (gint) gtk_drop_down_get_selected (_tmp0_);
#line 282 "../src/chess-window.vala"
	if (((guint) move_number) == GTK_INVALID_LIST_POSITION) {
#line 283 "../src/chess-window.vala"
		return;
#line 1879 "chess-window.c"
	}
#line 285 "../src/chess-window.vala"
	_tmp2_ = chess_window_get_game (self);
#line 285 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 285 "../src/chess-window.vala"
	if (_tmp3_ == NULL) {
#line 285 "../src/chess-window.vala"
		_tmp1_ = TRUE;
#line 1889 "chess-window.c"
	} else {
		ChessGame* _tmp4_;
		ChessGame* _tmp5_;
		guint _tmp6_;
		guint _tmp7_;
#line 285 "../src/chess-window.vala"
		_tmp4_ = chess_window_get_game (self);
#line 285 "../src/chess-window.vala"
		_tmp5_ = _tmp4_;
#line 285 "../src/chess-window.vala"
		_tmp6_ = chess_game_get_n_moves (_tmp5_);
#line 285 "../src/chess-window.vala"
		_tmp7_ = _tmp6_;
#line 285 "../src/chess-window.vala"
		_tmp1_ = ((guint) move_number) == _tmp7_;
#line 1905 "chess-window.c"
	}
#line 285 "../src/chess-window.vala"
	if (_tmp1_) {
#line 1909 "chess-window.c"
		ChessScene* _tmp8_;
		ChessScene* _tmp9_;
#line 286 "../src/chess-window.vala"
		_tmp8_ = chess_window_get_scene (self);
#line 286 "../src/chess-window.vala"
		_tmp9_ = _tmp8_;
#line 286 "../src/chess-window.vala"
		chess_scene_set_move_number (_tmp9_, -1);
#line 1918 "chess-window.c"
	} else {
		ChessScene* _tmp10_;
		ChessScene* _tmp11_;
#line 288 "../src/chess-window.vala"
		_tmp10_ = chess_window_get_scene (self);
#line 288 "../src/chess-window.vala"
		_tmp11_ = _tmp10_;
#line 288 "../src/chess-window.vala"
		chess_scene_set_move_number (_tmp11_, move_number);
#line 1928 "chess-window.c"
	}
}

static void
_chess_window_history_dropdown_selection_changed_cb_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self)
{
#line 14 "../src/chess-window.vala"
	chess_window_history_dropdown_selection_changed_cb ((ChessWindow*) self);
#line 1939 "chess-window.c"
}

gchar*
chess_window_get_move_text (ChessWindow* self,
                            ChessMove* move)
{
#line 294 "../src/chess-window.vala"
	static const gchar* human_descriptions[72] = {N_ ("White pawn moves from %1$s to %2$s"), N_ ("White pawn at %1$s takes the black pawn at %2$s"), N_ ("White pawn at %1$s takes the black rook at %2$s"), N_ ("White pawn at %1$s takes the black knight at %2$s"), N_ ("White pawn at %1$s takes the black bishop at %2$s"), N_ ("White pawn at %1$s takes the black queen at %2$s"), N_ ("White rook moves from %1$s to %2$s"), N_ ("White rook at %1$s takes the black pawn at %2$s"), N_ ("White rook at %1$s takes the black rook at %2$s"), N_ ("White rook at %1$s takes the black knight at %2$s"), N_ ("White rook at %1$s takes the black bishop at %2$s"), N_ ("White rook at %1$s takes the black queen at %2$s"), N_ ("White knight moves from %1$s to %2$s"), N_ ("White knight at %1$s takes the black pawn at %2$s"), N_ ("White knight at %1$s takes the black rook at %2$s"), N_ ("White knight at %1$s takes the black knight at %2$s"), N_ ("White knight at %1$s takes the black bishop at %2$s"), N_ ("White knight at %1$s takes the black queen at %2$s"), N_ ("White bishop moves from %1$s to %2$s"), N_ ("White bishop at %1$s takes the black pawn at %2$s"), N_ ("White bishop at %1$s takes the black rook at %2$s"), N_ ("White bishop at %1$s takes the black knight at %2$s"), N_ ("White bishop at %1$s takes the black bishop at %2$s"), N_ ("White bishop at %1$s takes the black queen at %2$s"), N_ ("White queen moves from %1$s to %2$s"), N_ ("White queen at %1$s takes the black pawn at %2$s"), N_ ("White queen at %1$s takes the black rook at %2$s"), N_ ("White queen at %1$s takes the black knight at %2$s"), N_ ("White queen at %1$s takes the black bishop at %2$s"), N_ ("White queen at %1$s takes the black queen at %2$s"), N_ ("White king moves from %1$s to %2$s"), N_ ("White king at %1$s takes the black pawn at %2$s"), N_ ("White king at %1$s takes the black rook at %2$s"), N_ ("White king at %1$s takes the black knight at %2$s"), N_ ("White king at %1$s takes the black bishop at %2$s"), N_ ("White king at %1$s takes the black queen at %2$s"), N_ ("Black pawn moves from %1$s to %2$s"), N_ ("Black pawn at %1$s takes the white pawn at %2$s"), N_ ("Black pawn at %1$s takes the white rook at %2$s"), N_ ("Black pawn at %1$s takes the white knight at %2$s"), N_ ("Black pawn at %1$s takes the white bishop at %2$s"), N_ ("Black pawn at %1$s takes the white queen at %2$s"), N_ ("Black rook moves from %1$s to %2$s"), N_ ("Black rook at %1$s takes the white pawn at %2$s"), N_ ("Black rook at %1$s takes the white rook at %2$s"), N_ ("Black rook at %1$s takes the white knight at %2$s"), N_ ("Black rook at %1$s takes the white bishop at %2$s"), N_ ("Black rook at %1$s takes the white queen at %2$s"), N_ ("Black knight moves from %1$s to %2$s"), N_ ("Black knight at %1$s takes the white pawn at %2$s"), N_ ("Black knight at %1$s takes the white rook at %2$s"), N_ ("Black knight at %1$s takes the white knight at %2$s"), N_ ("Black knight at %1$s takes the white bishop at %2$s"), N_ ("Black knight at %1$s takes the white queen at %2$s"), N_ ("Black bishop moves from %1$s to %2$s"), N_ ("Black bishop at %1$s takes the white pawn at %2$s"), N_ ("Black bishop at %1$s takes the white rook at %2$s"), N_ ("Black bishop at %1$s takes the white knight at %2$s"), N_ ("Black bishop at %1$s takes the white bishop at %2$s"), N_ ("Black bishop at %1$s takes the white queen at %2$s"), N_ ("Black queen moves from %1$s to %2$s"), N_ ("Black queen at %1$s takes the white pawn at %2$s"), N_ ("Black queen at %1$s takes the white rook at %2$s"), N_ ("Black queen at %1$s takes the white knight at %2$s"), N_ ("Black queen at %1$s takes the white bishop at %2$s"), N_ ("Black queen at %1$s takes the white queen at %2$s"), N_ ("Black king moves from %1$s to %2$s"), N_ ("Black king at %1$s takes the white pawn at %2$s"), N_ ("Black king at %1$s takes the white rook at %2$s"), N_ ("Black king at %1$s takes the white knight at %2$s"), N_ ("Black king at %1$s takes the white bishop at %2$s"), N_ ("Black king at %1$s takes the white queen at %2$s")};
#line 1948 "chess-window.c"
	gchar* move_text = NULL;
	gchar* _tmp0_;
	ChessScene* _tmp1_;
	ChessScene* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
#line 440 "../src/chess-window.vala"
	static GQuark _tmp6_label0 = 0;
#line 440 "../src/chess-window.vala"
	static GQuark _tmp6_label1 = 0;
#line 440 "../src/chess-window.vala"
	static GQuark _tmp6_label2 = 0;
#line 1963 "chess-window.c"
	gchar _tmp35_ = '\0';
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* result;
#line 291 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 291 "../src/chess-window.vala"
	g_return_val_if_fail (move != NULL, NULL);
#line 439 "../src/chess-window.vala"
	_tmp0_ = g_strdup ("");
#line 439 "../src/chess-window.vala"
	move_text = _tmp0_;
#line 440 "../src/chess-window.vala"
	_tmp1_ = chess_window_get_scene (self);
#line 440 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 440 "../src/chess-window.vala"
	_tmp3_ = chess_scene_get_move_format (_tmp2_);
#line 440 "../src/chess-window.vala"
	_tmp4_ = _tmp3_;
#line 440 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 440 "../src/chess-window.vala"
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
#line 440 "../src/chess-window.vala"
	if (_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("human")))) {
#line 440 "../src/chess-window.vala"
		switch (0) {
#line 1992 "chess-window.c"
			default:
			{
				ChessPiece* _tmp8_;
#line 443 "../src/chess-window.vala"
				_tmp8_ = move->castling_rook;
#line 443 "../src/chess-window.vala"
				if (_tmp8_ != NULL) {
#line 2000 "chess-window.c"
					gboolean _tmp9_ = FALSE;
#line 445 "../src/chess-window.vala"
					if (move->f0 < move->f1) {
#line 445 "../src/chess-window.vala"
						_tmp9_ = move->r0 == 0;
#line 2006 "chess-window.c"
					} else {
#line 445 "../src/chess-window.vala"
						_tmp9_ = FALSE;
#line 2010 "chess-window.c"
					}
#line 445 "../src/chess-window.vala"
					if (_tmp9_) {
#line 2014 "chess-window.c"
						gchar* _tmp10_;
#line 446 "../src/chess-window.vala"
						_tmp10_ = g_strdup (_ ("White castles kingside"));
#line 446 "../src/chess-window.vala"
						_g_free0 (move_text);
#line 446 "../src/chess-window.vala"
						move_text = _tmp10_;
#line 2022 "chess-window.c"
					} else {
						gboolean _tmp11_ = FALSE;
#line 447 "../src/chess-window.vala"
						if (move->f1 < move->f0) {
#line 447 "../src/chess-window.vala"
							_tmp11_ = move->r0 == 0;
#line 2029 "chess-window.c"
						} else {
#line 447 "../src/chess-window.vala"
							_tmp11_ = FALSE;
#line 2033 "chess-window.c"
						}
#line 447 "../src/chess-window.vala"
						if (_tmp11_) {
#line 2037 "chess-window.c"
							gchar* _tmp12_;
#line 448 "../src/chess-window.vala"
							_tmp12_ = g_strdup (_ ("White castles queenside"));
#line 448 "../src/chess-window.vala"
							_g_free0 (move_text);
#line 448 "../src/chess-window.vala"
							move_text = _tmp12_;
#line 2045 "chess-window.c"
						} else {
							gboolean _tmp13_ = FALSE;
#line 449 "../src/chess-window.vala"
							if (move->f0 < move->f1) {
#line 449 "../src/chess-window.vala"
								_tmp13_ = move->r0 == 7;
#line 2052 "chess-window.c"
							} else {
#line 449 "../src/chess-window.vala"
								_tmp13_ = FALSE;
#line 2056 "chess-window.c"
							}
#line 449 "../src/chess-window.vala"
							if (_tmp13_) {
#line 2060 "chess-window.c"
								gchar* _tmp14_;
#line 450 "../src/chess-window.vala"
								_tmp14_ = g_strdup (_ ("Black castles kingside"));
#line 450 "../src/chess-window.vala"
								_g_free0 (move_text);
#line 450 "../src/chess-window.vala"
								move_text = _tmp14_;
#line 2068 "chess-window.c"
							} else {
								gboolean _tmp15_ = FALSE;
#line 451 "../src/chess-window.vala"
								if (move->f1 < move->f0) {
#line 451 "../src/chess-window.vala"
									_tmp15_ = move->r0 == 7;
#line 2075 "chess-window.c"
								} else {
#line 451 "../src/chess-window.vala"
									_tmp15_ = FALSE;
#line 2079 "chess-window.c"
								}
#line 451 "../src/chess-window.vala"
								if (_tmp15_) {
#line 2083 "chess-window.c"
									gchar* _tmp16_;
#line 452 "../src/chess-window.vala"
									_tmp16_ = g_strdup (_ ("Black castles queenside"));
#line 452 "../src/chess-window.vala"
									_g_free0 (move_text);
#line 452 "../src/chess-window.vala"
									move_text = _tmp16_;
#line 2091 "chess-window.c"
								} else {
#line 454 "../src/chess-window.vala"
									g_assert_not_reached ();
#line 2095 "chess-window.c"
								}
							}
						}
					}
				} else {
					gint index = 0;
					ChessPiece* _tmp17_;
					ChessPiece* _tmp19_;
					ChessPiece* _tmp20_;
					ChessPlayer* _tmp21_;
					gchar* start = NULL;
					gchar* _tmp22_;
					gchar* end = NULL;
					gchar* _tmp23_;
					gchar* template = NULL;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					const gchar* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
#line 459 "../src/chess-window.vala"
					_tmp17_ = move->victim;
#line 459 "../src/chess-window.vala"
					if (_tmp17_ == NULL) {
#line 460 "../src/chess-window.vala"
						index = 0;
#line 2123 "chess-window.c"
					} else {
						ChessPiece* _tmp18_;
#line 462 "../src/chess-window.vala"
						_tmp18_ = move->victim;
#line 462 "../src/chess-window.vala"
						index = (gint) (_tmp18_->type + 1);
#line 2130 "chess-window.c"
					}
#line 463 "../src/chess-window.vala"
					_tmp19_ = move->piece;
#line 463 "../src/chess-window.vala"
					index += (gint) (_tmp19_->type * 6);
#line 464 "../src/chess-window.vala"
					_tmp20_ = move->piece;
#line 464 "../src/chess-window.vala"
					_tmp21_ = _tmp20_->player;
#line 464 "../src/chess-window.vala"
					if (_tmp21_->color == COLOR_BLACK) {
#line 465 "../src/chess-window.vala"
						index += 36;
#line 2144 "chess-window.c"
					}
#line 467 "../src/chess-window.vala"
					_tmp22_ = g_strdup_printf ("%c%d", 'a' + move->f0, move->r0 + 1);
#line 467 "../src/chess-window.vala"
					start = _tmp22_;
#line 468 "../src/chess-window.vala"
					_tmp23_ = g_strdup_printf ("%c%d", 'a' + move->f1, move->r1 + 1);
#line 468 "../src/chess-window.vala"
					end = _tmp23_;
#line 469 "../src/chess-window.vala"
					_tmp24_ = human_descriptions[index];
#line 469 "../src/chess-window.vala"
					_tmp25_ = g_strdup (_ (_tmp24_));
#line 469 "../src/chess-window.vala"
					template = _tmp25_;
#line 470 "../src/chess-window.vala"
					if (move->en_passant) {
#line 472 "../src/chess-window.vala"
						if (move->r0 < move->r1) {
#line 2164 "chess-window.c"
							gchar* _tmp26_;
#line 474 "../src/chess-window.vala"
							_tmp26_ = g_strdup (_ ("White pawn at %1$s takes the black pawn at %2$s en passant"));
#line 474 "../src/chess-window.vala"
							_g_free0 (template);
#line 474 "../src/chess-window.vala"
							template = _tmp26_;
#line 2172 "chess-window.c"
						} else {
							gchar* _tmp27_;
#line 478 "../src/chess-window.vala"
							_tmp27_ = g_strdup (_ ("Black pawn at %1$s takes white pawn at %2$s en passant"));
#line 478 "../src/chess-window.vala"
							_g_free0 (template);
#line 478 "../src/chess-window.vala"
							template = _tmp27_;
#line 2181 "chess-window.c"
						}
					}
#line 481 "../src/chess-window.vala"
					_tmp28_ = template;
#line 481 "../src/chess-window.vala"
					_tmp29_ = start;
#line 481 "../src/chess-window.vala"
					_tmp30_ = end;
#line 481 "../src/chess-window.vala"
					_tmp31_ = g_strdup_printf (_tmp28_, _tmp29_, _tmp30_);
#line 481 "../src/chess-window.vala"
					_g_free0 (move_text);
#line 481 "../src/chess-window.vala"
					move_text = _tmp31_;
#line 443 "../src/chess-window.vala"
					_g_free0 (template);
#line 443 "../src/chess-window.vala"
					_g_free0 (end);
#line 443 "../src/chess-window.vala"
					_g_free0 (start);
#line 2202 "chess-window.c"
				}
#line 483 "../src/chess-window.vala"
				break;
#line 2206 "chess-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("san")))) {
#line 440 "../src/chess-window.vala"
		switch (0) {
#line 2212 "chess-window.c"
			default:
			{
				gchar* _tmp32_;
#line 486 "../src/chess-window.vala"
				_tmp32_ = chess_move_get_san (move);
#line 486 "../src/chess-window.vala"
				_g_free0 (move_text);
#line 486 "../src/chess-window.vala"
				move_text = _tmp32_;
#line 487 "../src/chess-window.vala"
				break;
#line 2224 "chess-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("fan")))) {
#line 440 "../src/chess-window.vala"
		switch (0) {
#line 2230 "chess-window.c"
			default:
			{
				gchar* _tmp33_;
#line 490 "../src/chess-window.vala"
				_tmp33_ = chess_move_get_fan (move);
#line 490 "../src/chess-window.vala"
				_g_free0 (move_text);
#line 490 "../src/chess-window.vala"
				move_text = _tmp33_;
#line 491 "../src/chess-window.vala"
				break;
#line 2242 "chess-window.c"
			}
		}
	} else {
#line 440 "../src/chess-window.vala"
		switch (0) {
#line 2248 "chess-window.c"
			default:
			{
				gchar* _tmp34_;
#line 495 "../src/chess-window.vala"
				_tmp34_ = chess_move_get_lan (move);
#line 495 "../src/chess-window.vala"
				_g_free0 (move_text);
#line 495 "../src/chess-window.vala"
				move_text = _tmp34_;
#line 496 "../src/chess-window.vala"
				break;
#line 2260 "chess-window.c"
			}
		}
	}
#line 499 "../src/chess-window.vala"
	if ((move->number % 2) == 0) {
#line 499 "../src/chess-window.vala"
		_tmp35_ = 'b';
#line 2268 "chess-window.c"
	} else {
#line 499 "../src/chess-window.vala"
		_tmp35_ = 'a';
#line 2272 "chess-window.c"
	}
#line 499 "../src/chess-window.vala"
	_tmp36_ = move_text;
#line 499 "../src/chess-window.vala"
	_tmp37_ = g_strdup_printf ("%u%c. %s", (guint) ((move->number + 1) / 2), (gint) _tmp35_, _tmp36_);
#line 499 "../src/chess-window.vala"
	result = _tmp37_;
#line 499 "../src/chess-window.vala"
	_g_free0 (move_text);
#line 499 "../src/chess-window.vala"
	return result;
#line 2284 "chess-window.c"
}

static void
___lambda31_ (ChessWindow* self)
{
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
#line 515 "../src/chess-window.vala"
	_tmp0_ = self->priv->white_time_label;
#line 515 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 516 "../src/chess-window.vala"
	_tmp1_ = self->priv->black_time_label;
#line 516 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 2300 "chess-window.c"
}

static void
____lambda31__chess_clock_tick (ChessClock* _sender,
                                gpointer self)
{
#line 514 "../src/chess-window.vala"
	___lambda31_ ((ChessWindow*) self);
#line 2309 "chess-window.c"
}

void
chess_window_start_game (ChessWindow* self)
{
	GtkStringList* _tmp0_;
	GtkStringList* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	GtkStringList* _tmp4_;
	GtkDropDown* _tmp5_;
	GtkDrawingArea* _tmp6_;
	GtkDrawingArea* _tmp7_;
	ChessGame* _tmp8_;
	ChessGame* _tmp9_;
	ChessClock* _tmp10_;
	ChessClock* _tmp11_;
#line 502 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 505 "../src/chess-window.vala"
	_tmp0_ = self->priv->history_model;
#line 505 "../src/chess-window.vala"
	_tmp1_ = self->priv->history_model;
#line 505 "../src/chess-window.vala"
	g_object_get (_tmp1_, "n-items", &_tmp2_, NULL);
#line 505 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 505 "../src/chess-window.vala"
	gtk_string_list_splice (_tmp0_, (guint) 0, _tmp3_, NULL);
#line 506 "../src/chess-window.vala"
	_tmp4_ = self->priv->history_model;
#line 506 "../src/chess-window.vala"
	gtk_string_list_append (_tmp4_, _ ("Game Start"));
#line 507 "../src/chess-window.vala"
	_tmp5_ = self->priv->history_dropdown;
#line 507 "../src/chess-window.vala"
	gtk_drop_down_set_selected (_tmp5_, (guint) 0);
#line 509 "../src/chess-window.vala"
	_tmp6_ = self->priv->white_time_label;
#line 509 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp6_);
#line 510 "../src/chess-window.vala"
	_tmp7_ = self->priv->black_time_label;
#line 510 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp7_);
#line 512 "../src/chess-window.vala"
	_tmp8_ = chess_window_get_game (self);
#line 512 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 512 "../src/chess-window.vala"
	_tmp10_ = chess_game_get_clock (_tmp9_);
#line 512 "../src/chess-window.vala"
	_tmp11_ = _tmp10_;
#line 512 "../src/chess-window.vala"
	if (_tmp11_ != NULL) {
#line 2365 "chess-window.c"
		ChessGame* _tmp12_;
		ChessGame* _tmp13_;
		ChessClock* _tmp14_;
		ChessClock* _tmp15_;
#line 514 "../src/chess-window.vala"
		_tmp12_ = chess_window_get_game (self);
#line 514 "../src/chess-window.vala"
		_tmp13_ = _tmp12_;
#line 514 "../src/chess-window.vala"
		_tmp14_ = chess_game_get_clock (_tmp13_);
#line 514 "../src/chess-window.vala"
		_tmp15_ = _tmp14_;
#line 514 "../src/chess-window.vala"
		g_signal_connect_object (_tmp15_, "tick", (GCallback) ____lambda31__chess_clock_tick, self, 0);
#line 2380 "chess-window.c"
	}
}

void
chess_window_move (ChessWindow* self,
                   ChessMove* m)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	GtkStringList* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	ChessGame* _tmp5_;
	ChessGame* _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
#line 521 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 521 "../src/chess-window.vala"
	g_return_if_fail (m != NULL);
#line 524 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 524 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 524 "../src/chess-window.vala"
	chess_scene_set_move_number (_tmp1_, -1);
#line 526 "../src/chess-window.vala"
	_tmp2_ = self->priv->history_model;
#line 526 "../src/chess-window.vala"
	_tmp3_ = chess_window_get_move_text (self, m);
#line 526 "../src/chess-window.vala"
	_tmp4_ = _tmp3_;
#line 526 "../src/chess-window.vala"
	gtk_string_list_append (_tmp2_, _tmp4_);
#line 526 "../src/chess-window.vala"
	_g_free0 (_tmp4_);
#line 529 "../src/chess-window.vala"
	_tmp5_ = chess_window_get_game (self);
#line 529 "../src/chess-window.vala"
	_tmp6_ = _tmp5_;
#line 529 "../src/chess-window.vala"
	_tmp7_ = chess_game_get_n_moves (_tmp6_);
#line 529 "../src/chess-window.vala"
	_tmp8_ = _tmp7_;
#line 529 "../src/chess-window.vala"
	if (((guint) m->number) == _tmp8_) {
#line 2427 "chess-window.c"
		GtkDropDown* _tmp9_;
#line 530 "../src/chess-window.vala"
		_tmp9_ = self->priv->history_dropdown;
#line 530 "../src/chess-window.vala"
		gtk_drop_down_set_selected (_tmp9_, (guint) m->number);
#line 2433 "chess-window.c"
	}
}

void
chess_window_undo (ChessWindow* self)
{
	GtkStringList* _tmp0_;
	GtkStringList* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	ChessScene* _tmp4_;
	ChessScene* _tmp5_;
	GtkDropDown* _tmp6_;
	GtkStringList* _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	ChessView* _tmp10_;
#line 533 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 536 "../src/chess-window.vala"
	_tmp0_ = self->priv->history_model;
#line 536 "../src/chess-window.vala"
	_tmp1_ = self->priv->history_model;
#line 536 "../src/chess-window.vala"
	g_object_get (_tmp1_, "n-items", &_tmp2_, NULL);
#line 536 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 536 "../src/chess-window.vala"
	gtk_string_list_remove (_tmp0_, _tmp3_ - 1);
#line 539 "../src/chess-window.vala"
	_tmp4_ = chess_window_get_scene (self);
#line 539 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 539 "../src/chess-window.vala"
	chess_scene_set_move_number (_tmp5_, -1);
#line 542 "../src/chess-window.vala"
	_tmp6_ = self->priv->history_dropdown;
#line 542 "../src/chess-window.vala"
	_tmp7_ = self->priv->history_model;
#line 542 "../src/chess-window.vala"
	g_object_get (_tmp7_, "n-items", &_tmp8_, NULL);
#line 542 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 542 "../src/chess-window.vala"
	gtk_drop_down_set_selected (_tmp6_, _tmp9_ - 1);
#line 543 "../src/chess-window.vala"
	_tmp10_ = self->priv->_view;
#line 543 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp10_);
#line 2483 "chess-window.c"
}

void
chess_window_end_game (ChessWindow* self)
{
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
#line 546 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 548 "../src/chess-window.vala"
	_tmp0_ = self->priv->white_time_label;
#line 548 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 549 "../src/chess-window.vala"
	_tmp1_ = self->priv->black_time_label;
#line 549 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 2501 "chess-window.c"
}

ChessView*
chess_window_get_view (ChessWindow* self)
{
	ChessView* result;
	ChessView* _tmp0_;
#line 18 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/chess-window.vala"
	_tmp0_ = self->priv->_view;
#line 18 "../src/chess-window.vala"
	result = _tmp0_;
#line 18 "../src/chess-window.vala"
	return result;
#line 2517 "chess-window.c"
}

static void
chess_window_set_view (ChessWindow* self,
                       ChessView* value)
{
	ChessView* old_value;
#line 18 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/chess-window.vala"
	old_value = chess_window_get_view (self);
#line 18 "../src/chess-window.vala"
	if (old_value != value) {
#line 2531 "chess-window.c"
		ChessView* _tmp0_;
#line 18 "../src/chess-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/chess-window.vala"
		_g_object_unref0 (self->priv->_view);
#line 18 "../src/chess-window.vala"
		self->priv->_view = _tmp0_;
#line 18 "../src/chess-window.vala"
		g_object_notify_by_pspec ((GObject *) self, chess_window_properties[CHESS_WINDOW_VIEW_PROPERTY]);
#line 2541 "chess-window.c"
	}
}

ChessScene*
chess_window_get_scene (ChessWindow* self)
{
	ChessScene* result;
	ChessView* _tmp0_;
	ChessScene* _tmp1_;
	ChessScene* _tmp2_;
#line 23 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/chess-window.vala"
	_tmp0_ = self->priv->_view;
#line 23 "../src/chess-window.vala"
	_tmp1_ = chess_view_get_scene (_tmp0_);
#line 23 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 23 "../src/chess-window.vala"
	result = _tmp2_;
#line 23 "../src/chess-window.vala"
	return result;
#line 2564 "chess-window.c"
}

ChessGame*
chess_window_get_game (ChessWindow* self)
{
	ChessGame* result;
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
#line 28 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 28 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 28 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 28 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 28 "../src/chess-window.vala"
	result = _tmp3_;
#line 28 "../src/chess-window.vala"
	return result;
#line 2589 "chess-window.c"
}

static void
chess_window_class_init (ChessWindowClass * klass,
                         gpointer klass_data)
{
#line 14 "../src/chess-window.vala"
	chess_window_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/chess-window.vala"
	g_type_class_adjust_private_offset (klass, &ChessWindow_private_offset);
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_window_get_property;
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_window_set_property;
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_window_finalize;
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_VIEW_PROPERTY, chess_window_properties[CHESS_WINDOW_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_CHESS_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_SCENE_PROPERTY, chess_window_properties[CHESS_WINDOW_SCENE_PROPERTY] = g_param_spec_object ("scene", "scene", "scene", TYPE_CHESS_SCENE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_GAME_PROPERTY, chess_window_properties[CHESS_WINDOW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_CHESS_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Chess/ui/chess-window.ui");
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toast_overlay", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, toast_overlay));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pause_resume_button", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, pause_resume_button));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "history_dropdown", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, history_dropdown));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "history_model", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, history_model));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_box", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, clock_box));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "white_time_label", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, white_time_label));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "black_time_label", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, black_time_label));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "history_dropdown_selection_changed_cb", G_CALLBACK(_chess_window_history_dropdown_selection_changed_cb_g_object_notify));
#line 2630 "chess-window.c"
}

static void
chess_window_instance_init (ChessWindow * self,
                            gpointer klass)
{
#line 14 "../src/chess-window.vala"
	self->priv = chess_window_get_instance_private (self);
#line 14 "../src/chess-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2641 "chess-window.c"
}

static void
chess_window_finalize (GObject * obj)
{
	ChessWindow * self;
#line 14 "../src/chess-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_WINDOW, ChessWindow);
#line 16 "../src/chess-window.vala"
	_g_object_unref0 (self->priv->_view);
#line 31 "../src/chess-window.vala"
	_g_object_unref0 (self->priv->app);
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (chess_window_parent_class)->finalize (obj);
#line 2656 "chess-window.c"
}

static GType
chess_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessWindow), 0, (GInstanceInitFunc) chess_window_instance_init, NULL };
	GType chess_window_type_id;
	chess_window_type_id = g_type_register_static (adw_application_window_get_type (), "ChessWindow", &g_define_type_info, 0);
	ChessWindow_private_offset = g_type_add_instance_private (chess_window_type_id, sizeof (ChessWindowPrivate));
	return chess_window_type_id;
}

GType
chess_window_get_type (void)
{
	static volatile gsize chess_window_type_id__once = 0;
	if (g_once_init_enter (&chess_window_type_id__once)) {
		GType chess_window_type_id;
		chess_window_type_id = chess_window_get_type_once ();
		g_once_init_leave (&chess_window_type_id__once, chess_window_type_id);
	}
	return chess_window_type_id__once;
}

static void
_vala_chess_window_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ChessWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_WINDOW, ChessWindow);
#line 14 "../src/chess-window.vala"
	switch (property_id) {
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_VIEW_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_object (value, chess_window_get_view (self));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_SCENE_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_object (value, chess_window_get_scene (self));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_GAME_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_object (value, chess_window_get_game (self));
#line 14 "../src/chess-window.vala"
		break;
#line 2709 "chess-window.c"
		default:
#line 14 "../src/chess-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-window.vala"
		break;
#line 2715 "chess-window.c"
	}
}

static void
_vala_chess_window_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ChessWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_WINDOW, ChessWindow);
#line 14 "../src/chess-window.vala"
	switch (property_id) {
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_VIEW_PROPERTY:
#line 14 "../src/chess-window.vala"
		chess_window_set_view (self, g_value_get_object (value));
#line 14 "../src/chess-window.vala"
		break;
#line 2735 "chess-window.c"
		default:
#line 14 "../src/chess-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-window.vala"
		break;
#line 2741 "chess-window.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

