/* preferences.c generated by valac 0.56.18, the Vala compiler
 * generated from preferences.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2022 Nils Lück
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include "libengine.h"
#include <gobject/gvaluecollector.h>

#define WIDTH_SETTINGS_KEY "width"
#define HEIGHT_SETTINGS_KEY "height"
#define MAXIMIZED_SETTINGS_KEY "maximized"
#define PIECE_STYLE_SETTINGS_KEY "piece-theme"
#define SHOW_MOVE_HINTS_SETTINGS_KEY "show-move-hints"
#define SHOW_BOARD_NUMBERING_SETTINGS_KEY "show-numbering"
#define MOVE_FORMAT_SETTINGS_KEY "move-format"
#define BOARD_ORIENTATION_SETTINGS_KEY "board-side"
#define DURATION_SETTINGS_KEY "duration"
#define CLOCK_TYPE_SETTINGS_KEY "clock-type"
#define INCREMENT_SETTINGS_KEY "timer-increment"
#define PLAY_AS_SETTINGS_KEY "play-as"
#define LAST_PLAYED_AS_SETTINGS_KEY "last-played-as"
#define OPPONENT_SETTINGS_KEY "opponent"
#define DIFFICULTY_SETTINGS_KEY "difficulty"
#define OPPONENT_HUMAN_NAME "human"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PREFERENCES (preferences_get_type ())
#define PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES, Preferences))
#define PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES, PreferencesClass))
#define IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES))
#define IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES))
#define PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES, PreferencesClass))

typedef struct _Preferences Preferences;
typedef struct _PreferencesClass PreferencesClass;
typedef struct _PreferencesPrivate PreferencesPrivate;
typedef enum  {
	BOARD_ORIENTATION_HUMAN_SIDE,
	BOARD_ORIENTATION_WHITE_SIDE,
	BOARD_ORIENTATION_BLACK_SIDE,
	BOARD_ORIENTATION_CURRENT_PLAYER
} BoardOrientation;

#define TYPE_BOARD_ORIENTATION (board_orientation_get_type ())
typedef enum  {
	MOVE_FORMAT_HUMAN,
	MOVE_FORMAT_STANDARD_ALGEBRAIC,
	MOVE_FORMAT_LONG_ALGEBRAIC,
	MOVE_FORMAT_FIGURINE
} MoveFormat;

#define TYPE_MOVE_FORMAT (move_format_get_type ())
typedef enum  {
	PIECE_STYLE_SIMPLE,
	PIECE_STYLE_FANCY
} PieceStyle;

#define TYPE_PIECE_STYLE (piece_style_get_type ())

#define TYPE_OPPONENT (opponent_get_type ())
#define OPPONENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OPPONENT, Opponent))
#define OPPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_OPPONENT, OpponentClass))
#define IS_OPPONENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_OPPONENT))
#define IS_OPPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_OPPONENT))
#define OPPONENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_OPPONENT, OpponentClass))

typedef struct _Opponent Opponent;
typedef struct _OpponentClass OpponentClass;
typedef enum  {
	PLAY_AS_WHITE,
	PLAY_AS_BLACK,
	PLAY_AS_ALTERNATE
} PlayAs;

#define TYPE_PLAY_AS (play_as_get_type ())
typedef enum  {
	DIFFICULTY_EASY,
	DIFFICULTY_NORMAL,
	DIFFICULTY_HARD
} Difficulty;

#define TYPE_DIFFICULTY (difficulty_get_type ())

#define TYPE_TIME_LIMIT (time_limit_get_type ())
#define TIME_LIMIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIME_LIMIT, TimeLimit))
#define TIME_LIMIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIME_LIMIT, TimeLimitClass))
#define IS_TIME_LIMIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIME_LIMIT))
#define IS_TIME_LIMIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIME_LIMIT))
#define TIME_LIMIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIME_LIMIT, TimeLimitClass))

typedef struct _TimeLimit TimeLimit;
typedef struct _TimeLimitClass TimeLimitClass;
enum  {
	PREFERENCES_0_PROPERTY,
	PREFERENCES_BOARD_ORIENTATION_PROPERTY,
	PREFERENCES_MOVE_FORMAT_PROPERTY,
	PREFERENCES_PIECE_STYLE_PROPERTY,
	PREFERENCES_SHOW_BOARD_NUMBERING_PROPERTY,
	PREFERENCES_SHOW_MOVE_HINTS_PROPERTY,
	PREFERENCES_OPPONENT_PROPERTY,
	PREFERENCES_PLAY_AS_PROPERTY,
	PREFERENCES_DIFFICULTY_PROPERTY,
	PREFERENCES_TIME_LIMIT_PROPERTY,
	PREFERENCES_NUM_PROPERTIES
};
static GParamSpec* preferences_properties[PREFERENCES_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _time_limit_unref0(var) ((var == NULL) ? NULL : (var = (time_limit_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef enum  {
	CLOCK_TYPE_FISCHER,
	CLOCK_TYPE_BRONSTEIN
} ClockType;

#define TYPE_CLOCK_TYPE (clock_type_get_type ())
typedef struct _OpponentPrivate OpponentPrivate;
enum  {
	OPPONENT_0_PROPERTY,
	OPPONENT_NAME_PROPERTY,
	OPPONENT_DISPLAY_NAME_PROPERTY,
	OPPONENT_IS_HUMAN_PROPERTY,
	OPPONENT_NUM_PROPERTIES
};
static GParamSpec* opponent_properties[OPPONENT_NUM_PROPERTIES];
typedef struct _TimeLimitPrivate TimeLimitPrivate;
typedef struct _ParamSpecTimeLimit ParamSpecTimeLimit;

struct _Preferences {
	GObject parent_instance;
	PreferencesPrivate * priv;
};

struct _PreferencesClass {
	GObjectClass parent_class;
};

struct _PreferencesPrivate {
	GSettings* settings;
	BoardOrientation _board_orientation;
	MoveFormat _move_format;
	PieceStyle _piece_style;
	gboolean _show_board_numbering;
	gboolean _show_move_hints;
	Opponent* _opponent;
	PlayAs _play_as;
	Difficulty _difficulty;
	gboolean syncing_time_limit;
	TimeLimit* _time_limit;
};

struct _Opponent {
	GObject parent_instance;
	OpponentPrivate * priv;
};

struct _OpponentClass {
	GObjectClass parent_class;
};

struct _OpponentPrivate {
	gchar* _name;
	gchar* _display_name;
};

struct _TimeLimit {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TimeLimitPrivate * priv;
};

struct _TimeLimitClass {
	GTypeClass parent_class;
	void (*finalize) (TimeLimit *self);
};

struct _TimeLimitPrivate {
	gint _duration_in_seconds;
	gint _increment_in_seconds;
	ClockType _clock_type;
};

struct _ParamSpecTimeLimit {
	GParamSpec parent_instance;
};

static gint Preferences_private_offset;
static gpointer preferences_parent_class = NULL;
static gint Opponent_private_offset;
static gpointer opponent_parent_class = NULL;
static Opponent* opponent__human;
static Opponent* opponent__human = NULL;
static gint TimeLimit_private_offset;
static gpointer time_limit_parent_class = NULL;

VALA_EXTERN GType preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Preferences, g_object_unref)
VALA_EXTERN GType board_orientation_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType move_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType piece_style_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType opponent_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Opponent, g_object_unref)
VALA_EXTERN GType play_as_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer time_limit_ref (gpointer instance);
VALA_EXTERN void time_limit_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_time_limit (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_time_limit (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_time_limit (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_time_limit (const GValue* value);
VALA_EXTERN GType time_limit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TimeLimit, time_limit_unref)
VALA_EXTERN Preferences* preferences_new (GSettings* settings);
VALA_EXTERN Preferences* preferences_construct (GType object_type,
                                    GSettings* settings);
static gboolean __lambda5_ (GValue* to_value,
                     GVariant* from_value,
                     void* user_data);
VALA_EXTERN BoardOrientation* board_orientation_from_setting (const gchar* s);
static BoardOrientation* _board_orientation_dup (BoardOrientation* self);
static gboolean ___lambda5__gsettings_bind_get_mapping (GValue* value,
                                                 GVariant* variant,
                                                 void* user_data);
static GVariant* __lambda6_ (GValue* from_value,
                      const GVariantType* expected_type,
                      void* user_data);
VALA_EXTERN gchar* board_orientation_to_setting (BoardOrientation self);
static GVariant* ___lambda6__gsettings_bind_set_mapping (GValue* value,
                                                  const GVariantType* expected_type,
                                                  void* user_data);
static gboolean __lambda7_ (GValue* to_value,
                     GVariant* from_value,
                     void* user_data);
VALA_EXTERN MoveFormat* move_format_from_setting (const gchar* s);
static MoveFormat* _move_format_dup (MoveFormat* self);
static gboolean ___lambda7__gsettings_bind_get_mapping (GValue* value,
                                                 GVariant* variant,
                                                 void* user_data);
static GVariant* __lambda8_ (GValue* from_value,
                      const GVariantType* expected_type,
                      void* user_data);
VALA_EXTERN gchar* move_format_to_setting (MoveFormat self);
static GVariant* ___lambda8__gsettings_bind_set_mapping (GValue* value,
                                                  const GVariantType* expected_type,
                                                  void* user_data);
static gboolean __lambda9_ (GValue* to_value,
                     GVariant* from_value,
                     void* user_data);
VALA_EXTERN PieceStyle* piece_style_from_setting (const gchar* s);
static PieceStyle* _piece_style_dup (PieceStyle* self);
static gboolean ___lambda9__gsettings_bind_get_mapping (GValue* value,
                                                 GVariant* variant,
                                                 void* user_data);
static GVariant* __lambda10_ (GValue* from_value,
                       const GVariantType* expected_type,
                       void* user_data);
VALA_EXTERN gchar* piece_style_to_setting (PieceStyle self);
static GVariant* ___lambda10__gsettings_bind_set_mapping (GValue* value,
                                                   const GVariantType* expected_type,
                                                   void* user_data);
static gboolean __lambda11_ (GValue* to_value,
                      GVariant* from_value,
                      void* user_data);
VALA_EXTERN PlayAs* play_as_from_setting (const gchar* s);
static PlayAs* _play_as_dup (PlayAs* self);
static gboolean ___lambda11__gsettings_bind_get_mapping (GValue* value,
                                                  GVariant* variant,
                                                  void* user_data);
static GVariant* __lambda12_ (GValue* from_value,
                       const GVariantType* expected_type,
                       void* user_data);
VALA_EXTERN gchar* play_as_to_setting (PlayAs self);
static GVariant* ___lambda12__gsettings_bind_set_mapping (GValue* value,
                                                   const GVariantType* expected_type,
                                                   void* user_data);
static gboolean __lambda13_ (GValue* to_value,
                      GVariant* from_value,
                      void* user_data);
VALA_EXTERN Difficulty* difficulty_from_setting (const gchar* s);
static Difficulty* _difficulty_dup (Difficulty* self);
static gboolean ___lambda13__gsettings_bind_get_mapping (GValue* value,
                                                  GVariant* variant,
                                                  void* user_data);
static GVariant* __lambda14_ (GValue* from_value,
                       const GVariantType* expected_type,
                       void* user_data);
VALA_EXTERN gchar* difficulty_to_setting (Difficulty self);
static GVariant* ___lambda14__gsettings_bind_set_mapping (GValue* value,
                                                   const GVariantType* expected_type,
                                                   void* user_data);
static gboolean __lambda15_ (GValue* to_value,
                      GVariant* from_value,
                      void* user_data);
VALA_EXTERN Opponent* opponent_from_setting (const gchar* s);
VALA_EXTERN Opponent* opponent_get_human (void);
static gboolean ___lambda15__gsettings_bind_get_mapping (GValue* value,
                                                  GVariant* variant,
                                                  void* user_data);
static GVariant* __lambda16_ (GValue* from_value,
                       const GVariantType* expected_type,
                       void* user_data);
VALA_EXTERN gchar* opponent_to_setting (Opponent* self);
static GVariant* ___lambda16__gsettings_bind_set_mapping (GValue* value,
                                                   const GVariantType* expected_type,
                                                   void* user_data);
static void preferences_time_limit_settings_changed_cb (Preferences* self);
static void _preferences_time_limit_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                                     const gchar* key,
                                                                     gpointer self);
static void preferences_time_limit_preferences_changed_cb (Preferences* self);
static void _preferences_time_limit_preferences_changed_cb_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
VALA_EXTERN TimeLimit* time_limit_from_settings (gint duration_setting,
                                     gint increment_setting,
                                     const gchar* clock_type_setting);
VALA_EXTERN void preferences_set_time_limit (Preferences* self,
                                 TimeLimit* value);
VALA_EXTERN void time_limit_to_settings (TimeLimit* time_limit,
                             gint* duration,
                             gint* increment,
                             gchar** clock_type);
VALA_EXTERN TimeLimit* preferences_get_time_limit (Preferences* self);
VALA_EXTERN BoardOrientation preferences_get_board_orientation (Preferences* self);
VALA_EXTERN void preferences_set_board_orientation (Preferences* self,
                                        BoardOrientation value);
VALA_EXTERN MoveFormat preferences_get_move_format (Preferences* self);
VALA_EXTERN void preferences_set_move_format (Preferences* self,
                                  MoveFormat value);
VALA_EXTERN PieceStyle preferences_get_piece_style (Preferences* self);
VALA_EXTERN void preferences_set_piece_style (Preferences* self,
                                  PieceStyle value);
VALA_EXTERN gboolean preferences_get_show_board_numbering (Preferences* self);
VALA_EXTERN void preferences_set_show_board_numbering (Preferences* self,
                                           gboolean value);
VALA_EXTERN gboolean preferences_get_show_move_hints (Preferences* self);
VALA_EXTERN void preferences_set_show_move_hints (Preferences* self,
                                      gboolean value);
VALA_EXTERN Opponent* preferences_get_opponent (Preferences* self);
VALA_EXTERN void preferences_set_opponent (Preferences* self,
                               Opponent* value);
VALA_EXTERN PlayAs preferences_get_play_as (Preferences* self);
VALA_EXTERN void preferences_set_play_as (Preferences* self,
                              PlayAs value);
VALA_EXTERN Difficulty preferences_get_difficulty (Preferences* self);
VALA_EXTERN void preferences_set_difficulty (Preferences* self,
                                 Difficulty value);
static void preferences_finalize (GObject * obj);
static GType preferences_get_type_once (void);
static void _vala_preferences_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_preferences_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
VALA_EXTERN gchar* board_orientation_display_name (BoardOrientation self);
VALA_EXTERN gchar* move_format_display_name (MoveFormat self);
VALA_EXTERN gchar* piece_style_display_name (PieceStyle self);
VALA_EXTERN gchar* play_as_display_name (PlayAs self);
VALA_EXTERN gchar* difficulty_display_name (Difficulty self);
VALA_EXTERN GType clock_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* clock_type_display_name (ClockType self);
VALA_EXTERN gchar* clock_type_to_setting (ClockType self);
VALA_EXTERN ClockType* clock_type_from_setting (const gchar* s);
static ClockType* _clock_type_dup (ClockType* self);
VALA_EXTERN Opponent* opponent_new (const gchar* name,
                        const gchar* display_name);
VALA_EXTERN Opponent* opponent_construct (GType object_type,
                              const gchar* name,
                              const gchar* display_name);
static void opponent_set_name (Opponent* self,
                        const gchar* value);
static void opponent_set_display_name (Opponent* self,
                                const gchar* value);
VALA_EXTERN const gchar* opponent_get_name (Opponent* self);
VALA_EXTERN Opponent* opponent_from_ai_profile (AIProfile* ai_profile);
VALA_EXTERN const gchar* opponent_get_display_name (Opponent* self);
VALA_EXTERN gboolean opponent_get_is_human (Opponent* self);
static void opponent_finalize (GObject * obj);
static GType opponent_get_type_once (void);
static void _vala_opponent_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_opponent_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);
VALA_EXTERN TimeLimit* time_limit_new (gint duration_in_seconds,
                           gint increment_in_seconds,
                           ClockType clock_type);
VALA_EXTERN TimeLimit* time_limit_construct (GType object_type,
                                 gint duration_in_seconds,
                                 gint increment_in_seconds,
                                 ClockType clock_type);
static void time_limit_set_duration_in_seconds (TimeLimit* self,
                                         gint value);
static void time_limit_set_increment_in_seconds (TimeLimit* self,
                                          gint value);
static void time_limit_set_clock_type (TimeLimit* self,
                                ClockType value);
VALA_EXTERN gint time_limit_get_duration_in_seconds (TimeLimit* self);
VALA_EXTERN gint time_limit_get_increment_in_seconds (TimeLimit* self);
VALA_EXTERN ClockType time_limit_get_clock_type (TimeLimit* self);
static void time_limit_finalize (TimeLimit * obj);
static GType time_limit_get_type_once (void);

static inline gpointer
preferences_get_instance_private (Preferences* self)
{
	return G_STRUCT_MEMBER_P (self, Preferences_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/preferences.vala"
	return self ? g_object_ref (self) : NULL;
#line 458 "preferences.c"
}

static BoardOrientation*
_board_orientation_dup (BoardOrientation* self)
{
	BoardOrientation* dup;
#line 59 "../src/preferences.vala"
	dup = g_new0 (BoardOrientation, 1);
#line 59 "../src/preferences.vala"
	memcpy (dup, self, sizeof (BoardOrientation));
#line 59 "../src/preferences.vala"
	return dup;
#line 471 "preferences.c"
}

static gpointer
__board_orientation_dup0 (gpointer self)
{
#line 59 "../src/preferences.vala"
	return self ? _board_orientation_dup (self) : NULL;
#line 479 "preferences.c"
}

static gboolean
__lambda5_ (GValue* to_value,
            GVariant* from_value,
            void* user_data)
{
	BoardOrientation* _tmp0_ = NULL;
	const gchar* _tmp1_;
	BoardOrientation* _tmp2_;
	BoardOrientation* value = NULL;
	BoardOrientation* _tmp5_;
	gboolean result;
#line 57 "../src/preferences.vala"
	g_return_val_if_fail (to_value != NULL, FALSE);
#line 57 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, FALSE);
#line 59 "../src/preferences.vala"
	_tmp1_ = g_variant_get_string (from_value, NULL);
#line 59 "../src/preferences.vala"
	_tmp2_ = board_orientation_from_setting (_tmp1_);
#line 59 "../src/preferences.vala"
	_tmp0_ = _tmp2_;
#line 59 "../src/preferences.vala"
	if (_tmp0_ == NULL) {
#line 505 "preferences.c"
		BoardOrientation _tmp3_;
		BoardOrientation* _tmp4_;
#line 59 "../src/preferences.vala"
		_tmp3_ = BOARD_ORIENTATION_HUMAN_SIDE;
#line 59 "../src/preferences.vala"
		_tmp4_ = __board_orientation_dup0 (&_tmp3_);
#line 59 "../src/preferences.vala"
		_g_free0 (_tmp0_);
#line 59 "../src/preferences.vala"
		_tmp0_ = _tmp4_;
#line 516 "preferences.c"
	}
#line 59 "../src/preferences.vala"
	_tmp5_ = _tmp0_;
#line 59 "../src/preferences.vala"
	_tmp0_ = NULL;
#line 59 "../src/preferences.vala"
	value = _tmp5_;
#line 60 "../src/preferences.vala"
	g_value_set_enum (to_value, *value);
#line 61 "../src/preferences.vala"
	result = TRUE;
#line 61 "../src/preferences.vala"
	_g_free0 (value);
#line 61 "../src/preferences.vala"
	_g_free0 (_tmp0_);
#line 61 "../src/preferences.vala"
	return result;
#line 534 "preferences.c"
}

static gboolean
___lambda5__gsettings_bind_get_mapping (GValue* value,
                                        GVariant* variant,
                                        void* user_data)
{
	gboolean result;
	result = __lambda5_ (value, variant, user_data);
#line 52 "../src/preferences.vala"
	return result;
#line 546 "preferences.c"
}

static GVariant*
__lambda6_ (GValue* from_value,
            const GVariantType* expected_type,
            void* user_data)
{
	BoardOrientation value = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
#line 63 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, NULL);
#line 63 "../src/preferences.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 65 "../src/preferences.vala"
	value = (BoardOrientation) g_value_get_enum (from_value);
#line 66 "../src/preferences.vala"
	_tmp0_ = board_orientation_to_setting (value);
#line 66 "../src/preferences.vala"
	_tmp1_ = _tmp0_;
#line 66 "../src/preferences.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 66 "../src/preferences.vala"
	g_variant_ref_sink (_tmp2_);
#line 66 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 66 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 66 "../src/preferences.vala"
	result = _tmp3_;
#line 66 "../src/preferences.vala"
	return result;
#line 582 "preferences.c"
}

static GVariant*
___lambda6__gsettings_bind_set_mapping (GValue* value,
                                        const GVariantType* expected_type,
                                        void* user_data)
{
	GVariant* result;
	result = __lambda6_ (value, expected_type, user_data);
#line 52 "../src/preferences.vala"
	return result;
#line 594 "preferences.c"
}

static MoveFormat*
_move_format_dup (MoveFormat* self)
{
	MoveFormat* dup;
#line 78 "../src/preferences.vala"
	dup = g_new0 (MoveFormat, 1);
#line 78 "../src/preferences.vala"
	memcpy (dup, self, sizeof (MoveFormat));
#line 78 "../src/preferences.vala"
	return dup;
#line 607 "preferences.c"
}

static gpointer
__move_format_dup0 (gpointer self)
{
#line 78 "../src/preferences.vala"
	return self ? _move_format_dup (self) : NULL;
#line 615 "preferences.c"
}

static gboolean
__lambda7_ (GValue* to_value,
            GVariant* from_value,
            void* user_data)
{
	MoveFormat* _tmp0_ = NULL;
	const gchar* _tmp1_;
	MoveFormat* _tmp2_;
	MoveFormat* value = NULL;
	MoveFormat* _tmp5_;
	gboolean result;
#line 76 "../src/preferences.vala"
	g_return_val_if_fail (to_value != NULL, FALSE);
#line 76 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, FALSE);
#line 78 "../src/preferences.vala"
	_tmp1_ = g_variant_get_string (from_value, NULL);
#line 78 "../src/preferences.vala"
	_tmp2_ = move_format_from_setting (_tmp1_);
#line 78 "../src/preferences.vala"
	_tmp0_ = _tmp2_;
#line 78 "../src/preferences.vala"
	if (_tmp0_ == NULL) {
#line 641 "preferences.c"
		MoveFormat _tmp3_;
		MoveFormat* _tmp4_;
#line 78 "../src/preferences.vala"
		_tmp3_ = MOVE_FORMAT_HUMAN;
#line 78 "../src/preferences.vala"
		_tmp4_ = __move_format_dup0 (&_tmp3_);
#line 78 "../src/preferences.vala"
		_g_free0 (_tmp0_);
#line 78 "../src/preferences.vala"
		_tmp0_ = _tmp4_;
#line 652 "preferences.c"
	}
#line 78 "../src/preferences.vala"
	_tmp5_ = _tmp0_;
#line 78 "../src/preferences.vala"
	_tmp0_ = NULL;
#line 78 "../src/preferences.vala"
	value = _tmp5_;
#line 79 "../src/preferences.vala"
	g_value_set_enum (to_value, *value);
#line 80 "../src/preferences.vala"
	result = TRUE;
#line 80 "../src/preferences.vala"
	_g_free0 (value);
#line 80 "../src/preferences.vala"
	_g_free0 (_tmp0_);
#line 80 "../src/preferences.vala"
	return result;
#line 670 "preferences.c"
}

static gboolean
___lambda7__gsettings_bind_get_mapping (GValue* value,
                                        GVariant* variant,
                                        void* user_data)
{
	gboolean result;
	result = __lambda7_ (value, variant, user_data);
#line 71 "../src/preferences.vala"
	return result;
#line 682 "preferences.c"
}

static GVariant*
__lambda8_ (GValue* from_value,
            const GVariantType* expected_type,
            void* user_data)
{
	MoveFormat value = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
#line 82 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, NULL);
#line 82 "../src/preferences.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 84 "../src/preferences.vala"
	value = (MoveFormat) g_value_get_enum (from_value);
#line 85 "../src/preferences.vala"
	_tmp0_ = move_format_to_setting (value);
#line 85 "../src/preferences.vala"
	_tmp1_ = _tmp0_;
#line 85 "../src/preferences.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 85 "../src/preferences.vala"
	g_variant_ref_sink (_tmp2_);
#line 85 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 85 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 85 "../src/preferences.vala"
	result = _tmp3_;
#line 85 "../src/preferences.vala"
	return result;
#line 718 "preferences.c"
}

static GVariant*
___lambda8__gsettings_bind_set_mapping (GValue* value,
                                        const GVariantType* expected_type,
                                        void* user_data)
{
	GVariant* result;
	result = __lambda8_ (value, expected_type, user_data);
#line 71 "../src/preferences.vala"
	return result;
#line 730 "preferences.c"
}

static PieceStyle*
_piece_style_dup (PieceStyle* self)
{
	PieceStyle* dup;
#line 97 "../src/preferences.vala"
	dup = g_new0 (PieceStyle, 1);
#line 97 "../src/preferences.vala"
	memcpy (dup, self, sizeof (PieceStyle));
#line 97 "../src/preferences.vala"
	return dup;
#line 743 "preferences.c"
}

static gpointer
__piece_style_dup0 (gpointer self)
{
#line 97 "../src/preferences.vala"
	return self ? _piece_style_dup (self) : NULL;
#line 751 "preferences.c"
}

static gboolean
__lambda9_ (GValue* to_value,
            GVariant* from_value,
            void* user_data)
{
	PieceStyle* _tmp0_ = NULL;
	const gchar* _tmp1_;
	PieceStyle* _tmp2_;
	PieceStyle* value = NULL;
	PieceStyle* _tmp5_;
	gboolean result;
#line 95 "../src/preferences.vala"
	g_return_val_if_fail (to_value != NULL, FALSE);
#line 95 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, FALSE);
#line 97 "../src/preferences.vala"
	_tmp1_ = g_variant_get_string (from_value, NULL);
#line 97 "../src/preferences.vala"
	_tmp2_ = piece_style_from_setting (_tmp1_);
#line 97 "../src/preferences.vala"
	_tmp0_ = _tmp2_;
#line 97 "../src/preferences.vala"
	if (_tmp0_ == NULL) {
#line 777 "preferences.c"
		PieceStyle _tmp3_;
		PieceStyle* _tmp4_;
#line 97 "../src/preferences.vala"
		_tmp3_ = PIECE_STYLE_SIMPLE;
#line 97 "../src/preferences.vala"
		_tmp4_ = __piece_style_dup0 (&_tmp3_);
#line 97 "../src/preferences.vala"
		_g_free0 (_tmp0_);
#line 97 "../src/preferences.vala"
		_tmp0_ = _tmp4_;
#line 788 "preferences.c"
	}
#line 97 "../src/preferences.vala"
	_tmp5_ = _tmp0_;
#line 97 "../src/preferences.vala"
	_tmp0_ = NULL;
#line 97 "../src/preferences.vala"
	value = _tmp5_;
#line 98 "../src/preferences.vala"
	g_value_set_enum (to_value, *value);
#line 99 "../src/preferences.vala"
	result = TRUE;
#line 99 "../src/preferences.vala"
	_g_free0 (value);
#line 99 "../src/preferences.vala"
	_g_free0 (_tmp0_);
#line 99 "../src/preferences.vala"
	return result;
#line 806 "preferences.c"
}

static gboolean
___lambda9__gsettings_bind_get_mapping (GValue* value,
                                        GVariant* variant,
                                        void* user_data)
{
	gboolean result;
	result = __lambda9_ (value, variant, user_data);
#line 90 "../src/preferences.vala"
	return result;
#line 818 "preferences.c"
}

static GVariant*
__lambda10_ (GValue* from_value,
             const GVariantType* expected_type,
             void* user_data)
{
	PieceStyle value = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
#line 101 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, NULL);
#line 101 "../src/preferences.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 103 "../src/preferences.vala"
	value = (PieceStyle) g_value_get_enum (from_value);
#line 104 "../src/preferences.vala"
	_tmp0_ = piece_style_to_setting (value);
#line 104 "../src/preferences.vala"
	_tmp1_ = _tmp0_;
#line 104 "../src/preferences.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 104 "../src/preferences.vala"
	g_variant_ref_sink (_tmp2_);
#line 104 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 104 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 104 "../src/preferences.vala"
	result = _tmp3_;
#line 104 "../src/preferences.vala"
	return result;
#line 854 "preferences.c"
}

static GVariant*
___lambda10__gsettings_bind_set_mapping (GValue* value,
                                         const GVariantType* expected_type,
                                         void* user_data)
{
	GVariant* result;
	result = __lambda10_ (value, expected_type, user_data);
#line 90 "../src/preferences.vala"
	return result;
#line 866 "preferences.c"
}

static PlayAs*
_play_as_dup (PlayAs* self)
{
	PlayAs* dup;
#line 116 "../src/preferences.vala"
	dup = g_new0 (PlayAs, 1);
#line 116 "../src/preferences.vala"
	memcpy (dup, self, sizeof (PlayAs));
#line 116 "../src/preferences.vala"
	return dup;
#line 879 "preferences.c"
}

static gpointer
__play_as_dup0 (gpointer self)
{
#line 116 "../src/preferences.vala"
	return self ? _play_as_dup (self) : NULL;
#line 887 "preferences.c"
}

static gboolean
__lambda11_ (GValue* to_value,
             GVariant* from_value,
             void* user_data)
{
	PlayAs* _tmp0_ = NULL;
	const gchar* _tmp1_;
	PlayAs* _tmp2_;
	PlayAs* value = NULL;
	PlayAs* _tmp5_;
	gboolean result;
#line 114 "../src/preferences.vala"
	g_return_val_if_fail (to_value != NULL, FALSE);
#line 114 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, FALSE);
#line 116 "../src/preferences.vala"
	_tmp1_ = g_variant_get_string (from_value, NULL);
#line 116 "../src/preferences.vala"
	_tmp2_ = play_as_from_setting (_tmp1_);
#line 116 "../src/preferences.vala"
	_tmp0_ = _tmp2_;
#line 116 "../src/preferences.vala"
	if (_tmp0_ == NULL) {
#line 913 "preferences.c"
		PlayAs _tmp3_;
		PlayAs* _tmp4_;
#line 116 "../src/preferences.vala"
		_tmp3_ = PLAY_AS_WHITE;
#line 116 "../src/preferences.vala"
		_tmp4_ = __play_as_dup0 (&_tmp3_);
#line 116 "../src/preferences.vala"
		_g_free0 (_tmp0_);
#line 116 "../src/preferences.vala"
		_tmp0_ = _tmp4_;
#line 924 "preferences.c"
	}
#line 116 "../src/preferences.vala"
	_tmp5_ = _tmp0_;
#line 116 "../src/preferences.vala"
	_tmp0_ = NULL;
#line 116 "../src/preferences.vala"
	value = _tmp5_;
#line 117 "../src/preferences.vala"
	g_value_set_enum (to_value, *value);
#line 118 "../src/preferences.vala"
	result = TRUE;
#line 118 "../src/preferences.vala"
	_g_free0 (value);
#line 118 "../src/preferences.vala"
	_g_free0 (_tmp0_);
#line 118 "../src/preferences.vala"
	return result;
#line 942 "preferences.c"
}

static gboolean
___lambda11__gsettings_bind_get_mapping (GValue* value,
                                         GVariant* variant,
                                         void* user_data)
{
	gboolean result;
	result = __lambda11_ (value, variant, user_data);
#line 109 "../src/preferences.vala"
	return result;
#line 954 "preferences.c"
}

static GVariant*
__lambda12_ (GValue* from_value,
             const GVariantType* expected_type,
             void* user_data)
{
	PlayAs value = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
#line 120 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, NULL);
#line 120 "../src/preferences.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 122 "../src/preferences.vala"
	value = (PlayAs) g_value_get_enum (from_value);
#line 123 "../src/preferences.vala"
	_tmp0_ = play_as_to_setting (value);
#line 123 "../src/preferences.vala"
	_tmp1_ = _tmp0_;
#line 123 "../src/preferences.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 123 "../src/preferences.vala"
	g_variant_ref_sink (_tmp2_);
#line 123 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 123 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 123 "../src/preferences.vala"
	result = _tmp3_;
#line 123 "../src/preferences.vala"
	return result;
#line 990 "preferences.c"
}

static GVariant*
___lambda12__gsettings_bind_set_mapping (GValue* value,
                                         const GVariantType* expected_type,
                                         void* user_data)
{
	GVariant* result;
	result = __lambda12_ (value, expected_type, user_data);
#line 109 "../src/preferences.vala"
	return result;
#line 1002 "preferences.c"
}

static Difficulty*
_difficulty_dup (Difficulty* self)
{
	Difficulty* dup;
#line 135 "../src/preferences.vala"
	dup = g_new0 (Difficulty, 1);
#line 135 "../src/preferences.vala"
	memcpy (dup, self, sizeof (Difficulty));
#line 135 "../src/preferences.vala"
	return dup;
#line 1015 "preferences.c"
}

static gpointer
__difficulty_dup0 (gpointer self)
{
#line 135 "../src/preferences.vala"
	return self ? _difficulty_dup (self) : NULL;
#line 1023 "preferences.c"
}

static gboolean
__lambda13_ (GValue* to_value,
             GVariant* from_value,
             void* user_data)
{
	Difficulty* _tmp0_ = NULL;
	const gchar* _tmp1_;
	Difficulty* _tmp2_;
	Difficulty* value = NULL;
	Difficulty* _tmp5_;
	gboolean result;
#line 133 "../src/preferences.vala"
	g_return_val_if_fail (to_value != NULL, FALSE);
#line 133 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, FALSE);
#line 135 "../src/preferences.vala"
	_tmp1_ = g_variant_get_string (from_value, NULL);
#line 135 "../src/preferences.vala"
	_tmp2_ = difficulty_from_setting (_tmp1_);
#line 135 "../src/preferences.vala"
	_tmp0_ = _tmp2_;
#line 135 "../src/preferences.vala"
	if (_tmp0_ == NULL) {
#line 1049 "preferences.c"
		Difficulty _tmp3_;
		Difficulty* _tmp4_;
#line 135 "../src/preferences.vala"
		_tmp3_ = DIFFICULTY_EASY;
#line 135 "../src/preferences.vala"
		_tmp4_ = __difficulty_dup0 (&_tmp3_);
#line 135 "../src/preferences.vala"
		_g_free0 (_tmp0_);
#line 135 "../src/preferences.vala"
		_tmp0_ = _tmp4_;
#line 1060 "preferences.c"
	}
#line 135 "../src/preferences.vala"
	_tmp5_ = _tmp0_;
#line 135 "../src/preferences.vala"
	_tmp0_ = NULL;
#line 135 "../src/preferences.vala"
	value = _tmp5_;
#line 136 "../src/preferences.vala"
	g_value_set_enum (to_value, *value);
#line 137 "../src/preferences.vala"
	result = TRUE;
#line 137 "../src/preferences.vala"
	_g_free0 (value);
#line 137 "../src/preferences.vala"
	_g_free0 (_tmp0_);
#line 137 "../src/preferences.vala"
	return result;
#line 1078 "preferences.c"
}

static gboolean
___lambda13__gsettings_bind_get_mapping (GValue* value,
                                         GVariant* variant,
                                         void* user_data)
{
	gboolean result;
	result = __lambda13_ (value, variant, user_data);
#line 128 "../src/preferences.vala"
	return result;
#line 1090 "preferences.c"
}

static GVariant*
__lambda14_ (GValue* from_value,
             const GVariantType* expected_type,
             void* user_data)
{
	Difficulty value = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
#line 139 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, NULL);
#line 139 "../src/preferences.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 141 "../src/preferences.vala"
	value = (Difficulty) g_value_get_enum (from_value);
#line 142 "../src/preferences.vala"
	_tmp0_ = difficulty_to_setting (value);
#line 142 "../src/preferences.vala"
	_tmp1_ = _tmp0_;
#line 142 "../src/preferences.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 142 "../src/preferences.vala"
	g_variant_ref_sink (_tmp2_);
#line 142 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 142 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 142 "../src/preferences.vala"
	result = _tmp3_;
#line 142 "../src/preferences.vala"
	return result;
#line 1126 "preferences.c"
}

static GVariant*
___lambda14__gsettings_bind_set_mapping (GValue* value,
                                         const GVariantType* expected_type,
                                         void* user_data)
{
	GVariant* result;
	result = __lambda14_ (value, expected_type, user_data);
#line 128 "../src/preferences.vala"
	return result;
#line 1138 "preferences.c"
}

static gboolean
__lambda15_ (GValue* to_value,
             GVariant* from_value,
             void* user_data)
{
	Opponent* _tmp0_ = NULL;
	const gchar* _tmp1_;
	Opponent* _tmp2_;
	Opponent* value = NULL;
	Opponent* _tmp6_;
	gboolean result;
#line 152 "../src/preferences.vala"
	g_return_val_if_fail (to_value != NULL, FALSE);
#line 152 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, FALSE);
#line 154 "../src/preferences.vala"
	_tmp1_ = g_variant_get_string (from_value, NULL);
#line 154 "../src/preferences.vala"
	_tmp2_ = opponent_from_setting (_tmp1_);
#line 154 "../src/preferences.vala"
	_tmp0_ = _tmp2_;
#line 154 "../src/preferences.vala"
	if (_tmp0_ == NULL) {
#line 1164 "preferences.c"
		Opponent* _tmp3_;
		Opponent* _tmp4_;
		Opponent* _tmp5_;
#line 154 "../src/preferences.vala"
		_tmp3_ = opponent_get_human ();
#line 154 "../src/preferences.vala"
		_tmp4_ = _tmp3_;
#line 154 "../src/preferences.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 154 "../src/preferences.vala"
		_g_object_unref0 (_tmp0_);
#line 154 "../src/preferences.vala"
		_tmp0_ = _tmp5_;
#line 1178 "preferences.c"
	}
#line 154 "../src/preferences.vala"
	_tmp6_ = _tmp0_;
#line 154 "../src/preferences.vala"
	_tmp0_ = NULL;
#line 154 "../src/preferences.vala"
	value = _tmp6_;
#line 155 "../src/preferences.vala"
	g_value_set_object (to_value, (GObject*) value);
#line 156 "../src/preferences.vala"
	result = TRUE;
#line 156 "../src/preferences.vala"
	_g_object_unref0 (value);
#line 156 "../src/preferences.vala"
	_g_object_unref0 (_tmp0_);
#line 156 "../src/preferences.vala"
	return result;
#line 1196 "preferences.c"
}

static gboolean
___lambda15__gsettings_bind_get_mapping (GValue* value,
                                         GVariant* variant,
                                         void* user_data)
{
	gboolean result;
	result = __lambda15_ (value, variant, user_data);
#line 147 "../src/preferences.vala"
	return result;
#line 1208 "preferences.c"
}

static GVariant*
__lambda16_ (GValue* from_value,
             const GVariantType* expected_type,
             void* user_data)
{
	Opponent* value = NULL;
	GObject* _tmp0_;
	Opponent* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GVariant* result;
#line 158 "../src/preferences.vala"
	g_return_val_if_fail (from_value != NULL, NULL);
#line 158 "../src/preferences.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 160 "../src/preferences.vala"
	_tmp0_ = g_value_get_object (from_value);
#line 160 "../src/preferences.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_OPPONENT, Opponent));
#line 160 "../src/preferences.vala"
	value = _tmp1_;
#line 161 "../src/preferences.vala"
	_tmp2_ = opponent_to_setting (value);
#line 161 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 161 "../src/preferences.vala"
	_tmp4_ = g_variant_new_string (_tmp3_);
#line 161 "../src/preferences.vala"
	g_variant_ref_sink (_tmp4_);
#line 161 "../src/preferences.vala"
	_tmp5_ = _tmp4_;
#line 161 "../src/preferences.vala"
	_g_free0 (_tmp3_);
#line 161 "../src/preferences.vala"
	result = _tmp5_;
#line 161 "../src/preferences.vala"
	_g_object_unref0 (value);
#line 161 "../src/preferences.vala"
	return result;
#line 1252 "preferences.c"
}

static GVariant*
___lambda16__gsettings_bind_set_mapping (GValue* value,
                                         const GVariantType* expected_type,
                                         void* user_data)
{
	GVariant* result;
	result = __lambda16_ (value, expected_type, user_data);
#line 147 "../src/preferences.vala"
	return result;
#line 1264 "preferences.c"
}

static void
_preferences_time_limit_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self)
{
#line 167 "../src/preferences.vala"
	preferences_time_limit_settings_changed_cb ((Preferences*) self);
#line 1274 "preferences.c"
}

static void
_preferences_time_limit_preferences_changed_cb_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
#line 170 "../src/preferences.vala"
	preferences_time_limit_preferences_changed_cb ((Preferences*) self);
#line 1284 "preferences.c"
}

Preferences*
preferences_construct (GType object_type,
                       GSettings* settings)
{
	Preferences * self = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 45 "../src/preferences.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 45 "../src/preferences.vala"
	self = (Preferences*) g_object_new (object_type, NULL);
#line 47 "../src/preferences.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 47 "../src/preferences.vala"
	_g_object_unref0 (self->priv->settings);
#line 47 "../src/preferences.vala"
	self->priv->settings = _tmp0_;
#line 49 "../src/preferences.vala"
	g_settings_bind (settings, SHOW_BOARD_NUMBERING_SETTINGS_KEY, (GObject*) self, "show-board-numbering", G_SETTINGS_BIND_DEFAULT);
#line 50 "../src/preferences.vala"
	g_settings_bind (settings, SHOW_MOVE_HINTS_SETTINGS_KEY, (GObject*) self, "show-move-hints", G_SETTINGS_BIND_DEFAULT);
#line 52 "../src/preferences.vala"
	g_settings_bind_with_mapping (settings, BOARD_ORIENTATION_SETTINGS_KEY, (GObject*) self, "board-orientation", G_SETTINGS_BIND_DEFAULT, ___lambda5__gsettings_bind_get_mapping, ___lambda6__gsettings_bind_set_mapping, NULL, NULL);
#line 71 "../src/preferences.vala"
	g_settings_bind_with_mapping (settings, MOVE_FORMAT_SETTINGS_KEY, (GObject*) self, "move-format", G_SETTINGS_BIND_DEFAULT, ___lambda7__gsettings_bind_get_mapping, ___lambda8__gsettings_bind_set_mapping, NULL, NULL);
#line 90 "../src/preferences.vala"
	g_settings_bind_with_mapping (settings, PIECE_STYLE_SETTINGS_KEY, (GObject*) self, "piece-style", G_SETTINGS_BIND_DEFAULT, ___lambda9__gsettings_bind_get_mapping, ___lambda10__gsettings_bind_set_mapping, NULL, NULL);
#line 109 "../src/preferences.vala"
	g_settings_bind_with_mapping (settings, PLAY_AS_SETTINGS_KEY, (GObject*) self, "play-as", G_SETTINGS_BIND_DEFAULT, ___lambda11__gsettings_bind_get_mapping, ___lambda12__gsettings_bind_set_mapping, NULL, NULL);
#line 128 "../src/preferences.vala"
	g_settings_bind_with_mapping (settings, DIFFICULTY_SETTINGS_KEY, (GObject*) self, "difficulty", G_SETTINGS_BIND_DEFAULT, ___lambda13__gsettings_bind_get_mapping, ___lambda14__gsettings_bind_set_mapping, NULL, NULL);
#line 147 "../src/preferences.vala"
	g_settings_bind_with_mapping (settings, OPPONENT_SETTINGS_KEY, (GObject*) self, "opponent", G_SETTINGS_BIND_DEFAULT, ___lambda15__gsettings_bind_get_mapping, ___lambda16__gsettings_bind_set_mapping, NULL, NULL);
#line 166 "../src/preferences.vala"
	preferences_time_limit_settings_changed_cb (self);
#line 167 "../src/preferences.vala"
	_tmp1_ = g_strconcat ("changed::", DURATION_SETTINGS_KEY, NULL);
#line 167 "../src/preferences.vala"
	g_signal_connect_object (settings, _tmp1_, (GCallback) _preferences_time_limit_settings_changed_cb_g_settings_changed, self, 0);
#line 167 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 168 "../src/preferences.vala"
	_tmp2_ = g_strconcat ("changed::", INCREMENT_SETTINGS_KEY, NULL);
#line 168 "../src/preferences.vala"
	g_signal_connect_object (settings, _tmp2_, (GCallback) _preferences_time_limit_settings_changed_cb_g_settings_changed, self, 0);
#line 168 "../src/preferences.vala"
	_g_free0 (_tmp2_);
#line 169 "../src/preferences.vala"
	_tmp3_ = g_strconcat ("changed::", CLOCK_TYPE_SETTINGS_KEY, NULL);
#line 169 "../src/preferences.vala"
	g_signal_connect_object (settings, _tmp3_, (GCallback) _preferences_time_limit_settings_changed_cb_g_settings_changed, self, 0);
#line 169 "../src/preferences.vala"
	_g_free0 (_tmp3_);
#line 170 "../src/preferences.vala"
	g_signal_connect_object ((GObject*) self, "notify::time-limit", (GCallback) _preferences_time_limit_preferences_changed_cb_g_object_notify, self, 0);
#line 45 "../src/preferences.vala"
	return self;
#line 1346 "preferences.c"
}

Preferences*
preferences_new (GSettings* settings)
{
#line 45 "../src/preferences.vala"
	return preferences_construct (TYPE_PREFERENCES, settings);
#line 1354 "preferences.c"
}

static void
preferences_time_limit_settings_changed_cb (Preferences* self)
{
	gint duration = 0;
	GSettings* _tmp0_;
	gint increment = 0;
	GSettings* _tmp1_;
	gchar* clock_type = NULL;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	TimeLimit* _tmp5_;
	TimeLimit* _tmp6_;
#line 173 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/preferences.vala"
	if (self->priv->syncing_time_limit) {
#line 176 "../src/preferences.vala"
		return;
#line 1376 "preferences.c"
	}
#line 177 "../src/preferences.vala"
	self->priv->syncing_time_limit = TRUE;
#line 179 "../src/preferences.vala"
	_tmp0_ = self->priv->settings;
#line 179 "../src/preferences.vala"
	duration = g_settings_get_int (_tmp0_, DURATION_SETTINGS_KEY);
#line 180 "../src/preferences.vala"
	_tmp1_ = self->priv->settings;
#line 180 "../src/preferences.vala"
	increment = g_settings_get_int (_tmp1_, INCREMENT_SETTINGS_KEY);
#line 181 "../src/preferences.vala"
	_tmp2_ = self->priv->settings;
#line 181 "../src/preferences.vala"
	_tmp3_ = g_settings_get_string (_tmp2_, CLOCK_TYPE_SETTINGS_KEY);
#line 181 "../src/preferences.vala"
	clock_type = _tmp3_;
#line 182 "../src/preferences.vala"
	_tmp4_ = clock_type;
#line 182 "../src/preferences.vala"
	_tmp5_ = time_limit_from_settings (duration, increment, _tmp4_);
#line 182 "../src/preferences.vala"
	_tmp6_ = _tmp5_;
#line 182 "../src/preferences.vala"
	preferences_set_time_limit (self, _tmp6_);
#line 182 "../src/preferences.vala"
	_time_limit_unref0 (_tmp6_);
#line 184 "../src/preferences.vala"
	self->priv->syncing_time_limit = FALSE;
#line 173 "../src/preferences.vala"
	_g_free0 (clock_type);
#line 1408 "preferences.c"
}

static void
preferences_time_limit_preferences_changed_cb (Preferences* self)
{
	gint duration = 0;
	gint increment = 0;
	gchar* clock_type = NULL;
	TimeLimit* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gchar* _tmp3_ = NULL;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	const gchar* _tmp7_;
#line 187 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/preferences.vala"
	if (self->priv->syncing_time_limit) {
#line 190 "../src/preferences.vala"
		return;
#line 1431 "preferences.c"
	}
#line 191 "../src/preferences.vala"
	self->priv->syncing_time_limit = TRUE;
#line 196 "../src/preferences.vala"
	_tmp0_ = self->priv->_time_limit;
#line 196 "../src/preferences.vala"
	time_limit_to_settings (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 196 "../src/preferences.vala"
	duration = _tmp1_;
#line 196 "../src/preferences.vala"
	increment = _tmp2_;
#line 196 "../src/preferences.vala"
	_g_free0 (clock_type);
#line 196 "../src/preferences.vala"
	clock_type = _tmp3_;
#line 197 "../src/preferences.vala"
	_tmp4_ = self->priv->settings;
#line 197 "../src/preferences.vala"
	g_settings_set_int (_tmp4_, DURATION_SETTINGS_KEY, duration);
#line 198 "../src/preferences.vala"
	_tmp5_ = self->priv->settings;
#line 198 "../src/preferences.vala"
	g_settings_set_int (_tmp5_, INCREMENT_SETTINGS_KEY, increment);
#line 199 "../src/preferences.vala"
	_tmp6_ = self->priv->settings;
#line 199 "../src/preferences.vala"
	_tmp7_ = clock_type;
#line 199 "../src/preferences.vala"
	g_settings_set_string (_tmp6_, CLOCK_TYPE_SETTINGS_KEY, _tmp7_);
#line 201 "../src/preferences.vala"
	self->priv->syncing_time_limit = FALSE;
#line 187 "../src/preferences.vala"
	_g_free0 (clock_type);
#line 1465 "preferences.c"
}

BoardOrientation
preferences_get_board_orientation (Preferences* self)
{
	BoardOrientation result;
#line 32 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 32 "../src/preferences.vala"
	result = self->priv->_board_orientation;
#line 32 "../src/preferences.vala"
	return result;
#line 1478 "preferences.c"
}

void
preferences_set_board_orientation (Preferences* self,
                                   BoardOrientation value)
{
	BoardOrientation old_value;
#line 32 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/preferences.vala"
	old_value = preferences_get_board_orientation (self);
#line 32 "../src/preferences.vala"
	if (old_value != value) {
#line 32 "../src/preferences.vala"
		self->priv->_board_orientation = value;
#line 32 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_properties[PREFERENCES_BOARD_ORIENTATION_PROPERTY]);
#line 1496 "preferences.c"
	}
}

MoveFormat
preferences_get_move_format (Preferences* self)
{
	MoveFormat result;
#line 33 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 33 "../src/preferences.vala"
	result = self->priv->_move_format;
#line 33 "../src/preferences.vala"
	return result;
#line 1510 "preferences.c"
}

void
preferences_set_move_format (Preferences* self,
                             MoveFormat value)
{
	MoveFormat old_value;
#line 33 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/preferences.vala"
	old_value = preferences_get_move_format (self);
#line 33 "../src/preferences.vala"
	if (old_value != value) {
#line 33 "../src/preferences.vala"
		self->priv->_move_format = value;
#line 33 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_properties[PREFERENCES_MOVE_FORMAT_PROPERTY]);
#line 1528 "preferences.c"
	}
}

PieceStyle
preferences_get_piece_style (Preferences* self)
{
	PieceStyle result;
#line 34 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "../src/preferences.vala"
	result = self->priv->_piece_style;
#line 34 "../src/preferences.vala"
	return result;
#line 1542 "preferences.c"
}

void
preferences_set_piece_style (Preferences* self,
                             PieceStyle value)
{
	PieceStyle old_value;
#line 34 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/preferences.vala"
	old_value = preferences_get_piece_style (self);
#line 34 "../src/preferences.vala"
	if (old_value != value) {
#line 34 "../src/preferences.vala"
		self->priv->_piece_style = value;
#line 34 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_properties[PREFERENCES_PIECE_STYLE_PROPERTY]);
#line 1560 "preferences.c"
	}
}

gboolean
preferences_get_show_board_numbering (Preferences* self)
{
	gboolean result;
#line 35 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../src/preferences.vala"
	result = self->priv->_show_board_numbering;
#line 35 "../src/preferences.vala"
	return result;
#line 1574 "preferences.c"
}

void
preferences_set_show_board_numbering (Preferences* self,
                                      gboolean value)
{
	gboolean old_value;
#line 35 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/preferences.vala"
	old_value = preferences_get_show_board_numbering (self);
#line 35 "../src/preferences.vala"
	if (old_value != value) {
#line 35 "../src/preferences.vala"
		self->priv->_show_board_numbering = value;
#line 35 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_properties[PREFERENCES_SHOW_BOARD_NUMBERING_PROPERTY]);
#line 1592 "preferences.c"
	}
}

gboolean
preferences_get_show_move_hints (Preferences* self)
{
	gboolean result;
#line 36 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/preferences.vala"
	result = self->priv->_show_move_hints;
#line 36 "../src/preferences.vala"
	return result;
#line 1606 "preferences.c"
}

void
preferences_set_show_move_hints (Preferences* self,
                                 gboolean value)
{
	gboolean old_value;
#line 36 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/preferences.vala"
	old_value = preferences_get_show_move_hints (self);
#line 36 "../src/preferences.vala"
	if (old_value != value) {
#line 36 "../src/preferences.vala"
		self->priv->_show_move_hints = value;
#line 36 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_properties[PREFERENCES_SHOW_MOVE_HINTS_PROPERTY]);
#line 1624 "preferences.c"
	}
}

Opponent*
preferences_get_opponent (Preferences* self)
{
	Opponent* result;
	Opponent* _tmp0_;
#line 38 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/preferences.vala"
	_tmp0_ = self->priv->_opponent;
#line 38 "../src/preferences.vala"
	result = _tmp0_;
#line 38 "../src/preferences.vala"
	return result;
#line 1641 "preferences.c"
}

void
preferences_set_opponent (Preferences* self,
                          Opponent* value)
{
	Opponent* old_value;
#line 38 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/preferences.vala"
	old_value = preferences_get_opponent (self);
#line 38 "../src/preferences.vala"
	if (old_value != value) {
#line 1655 "preferences.c"
		Opponent* _tmp0_;
#line 38 "../src/preferences.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/preferences.vala"
		_g_object_unref0 (self->priv->_opponent);
#line 38 "../src/preferences.vala"
		self->priv->_opponent = _tmp0_;
#line 38 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_properties[PREFERENCES_OPPONENT_PROPERTY]);
#line 1665 "preferences.c"
	}
}

PlayAs
preferences_get_play_as (Preferences* self)
{
	PlayAs result;
#line 39 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../src/preferences.vala"
	result = self->priv->_play_as;
#line 39 "../src/preferences.vala"
	return result;
#line 1679 "preferences.c"
}

void
preferences_set_play_as (Preferences* self,
                         PlayAs value)
{
	PlayAs old_value;
#line 39 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/preferences.vala"
	old_value = preferences_get_play_as (self);
#line 39 "../src/preferences.vala"
	if (old_value != value) {
#line 39 "../src/preferences.vala"
		self->priv->_play_as = value;
#line 39 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_properties[PREFERENCES_PLAY_AS_PROPERTY]);
#line 1697 "preferences.c"
	}
}

Difficulty
preferences_get_difficulty (Preferences* self)
{
	Difficulty result;
#line 40 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../src/preferences.vala"
	result = self->priv->_difficulty;
#line 40 "../src/preferences.vala"
	return result;
#line 1711 "preferences.c"
}

void
preferences_set_difficulty (Preferences* self,
                            Difficulty value)
{
	Difficulty old_value;
#line 40 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/preferences.vala"
	old_value = preferences_get_difficulty (self);
#line 40 "../src/preferences.vala"
	if (old_value != value) {
#line 40 "../src/preferences.vala"
		self->priv->_difficulty = value;
#line 40 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_properties[PREFERENCES_DIFFICULTY_PROPERTY]);
#line 1729 "preferences.c"
	}
}

TimeLimit*
preferences_get_time_limit (Preferences* self)
{
	TimeLimit* result;
	TimeLimit* _tmp0_;
#line 43 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/preferences.vala"
	_tmp0_ = self->priv->_time_limit;
#line 43 "../src/preferences.vala"
	result = _tmp0_;
#line 43 "../src/preferences.vala"
	return result;
#line 1746 "preferences.c"
}

static gpointer
_time_limit_ref0 (gpointer self)
{
#line 43 "../src/preferences.vala"
	return self ? time_limit_ref (self) : NULL;
#line 1754 "preferences.c"
}

void
preferences_set_time_limit (Preferences* self,
                            TimeLimit* value)
{
	TimeLimit* old_value;
#line 43 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/preferences.vala"
	old_value = preferences_get_time_limit (self);
#line 43 "../src/preferences.vala"
	if (old_value != value) {
#line 1768 "preferences.c"
		TimeLimit* _tmp0_;
#line 43 "../src/preferences.vala"
		_tmp0_ = _time_limit_ref0 (value);
#line 43 "../src/preferences.vala"
		_time_limit_unref0 (self->priv->_time_limit);
#line 43 "../src/preferences.vala"
		self->priv->_time_limit = _tmp0_;
#line 43 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_properties[PREFERENCES_TIME_LIMIT_PROPERTY]);
#line 1778 "preferences.c"
	}
}

static void
preferences_class_init (PreferencesClass * klass,
                        gpointer klass_data)
{
#line 28 "../src/preferences.vala"
	preferences_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/preferences.vala"
	g_type_class_adjust_private_offset (klass, &Preferences_private_offset);
#line 28 "../src/preferences.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_preferences_get_property;
#line 28 "../src/preferences.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_preferences_set_property;
#line 28 "../src/preferences.vala"
	G_OBJECT_CLASS (klass)->finalize = preferences_finalize;
#line 28 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_BOARD_ORIENTATION_PROPERTY, preferences_properties[PREFERENCES_BOARD_ORIENTATION_PROPERTY] = g_param_spec_enum ("board-orientation", "board-orientation", "board-orientation", TYPE_BOARD_ORIENTATION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_MOVE_FORMAT_PROPERTY, preferences_properties[PREFERENCES_MOVE_FORMAT_PROPERTY] = g_param_spec_enum ("move-format", "move-format", "move-format", TYPE_MOVE_FORMAT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_PIECE_STYLE_PROPERTY, preferences_properties[PREFERENCES_PIECE_STYLE_PROPERTY] = g_param_spec_enum ("piece-style", "piece-style", "piece-style", TYPE_PIECE_STYLE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_SHOW_BOARD_NUMBERING_PROPERTY, preferences_properties[PREFERENCES_SHOW_BOARD_NUMBERING_PROPERTY] = g_param_spec_boolean ("show-board-numbering", "show-board-numbering", "show-board-numbering", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_SHOW_MOVE_HINTS_PROPERTY, preferences_properties[PREFERENCES_SHOW_MOVE_HINTS_PROPERTY] = g_param_spec_boolean ("show-move-hints", "show-move-hints", "show-move-hints", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_OPPONENT_PROPERTY, preferences_properties[PREFERENCES_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_OPPONENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_PLAY_AS_PROPERTY, preferences_properties[PREFERENCES_PLAY_AS_PROPERTY] = g_param_spec_enum ("play-as", "play-as", "play-as", TYPE_PLAY_AS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_DIFFICULTY_PROPERTY, preferences_properties[PREFERENCES_DIFFICULTY_PROPERTY] = g_param_spec_enum ("difficulty", "difficulty", "difficulty", TYPE_DIFFICULTY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_TIME_LIMIT_PROPERTY, preferences_properties[PREFERENCES_TIME_LIMIT_PROPERTY] = param_spec_time_limit ("time-limit", "time-limit", "time-limit", TYPE_TIME_LIMIT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1814 "preferences.c"
}

static void
preferences_instance_init (Preferences * self,
                           gpointer klass)
{
#line 28 "../src/preferences.vala"
	self->priv = preferences_get_instance_private (self);
#line 42 "../src/preferences.vala"
	self->priv->syncing_time_limit = FALSE;
#line 1825 "preferences.c"
}

static void
preferences_finalize (GObject * obj)
{
	Preferences * self;
#line 28 "../src/preferences.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES, Preferences);
#line 30 "../src/preferences.vala"
	_g_object_unref0 (self->priv->settings);
#line 38 "../src/preferences.vala"
	_g_object_unref0 (self->priv->_opponent);
#line 43 "../src/preferences.vala"
	_time_limit_unref0 (self->priv->_time_limit);
#line 28 "../src/preferences.vala"
	G_OBJECT_CLASS (preferences_parent_class)->finalize (obj);
#line 1842 "preferences.c"
}

static GType
preferences_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Preferences), 0, (GInstanceInitFunc) preferences_instance_init, NULL };
	GType preferences_type_id;
	preferences_type_id = g_type_register_static (G_TYPE_OBJECT, "Preferences", &g_define_type_info, 0);
	Preferences_private_offset = g_type_add_instance_private (preferences_type_id, sizeof (PreferencesPrivate));
	return preferences_type_id;
}

GType
preferences_get_type (void)
{
	static volatile gsize preferences_type_id__once = 0;
	if (g_once_init_enter (&preferences_type_id__once)) {
		GType preferences_type_id;
		preferences_type_id = preferences_get_type_once ();
		g_once_init_leave (&preferences_type_id__once, preferences_type_id);
	}
	return preferences_type_id__once;
}

static void
_vala_preferences_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	Preferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PREFERENCES, Preferences);
#line 28 "../src/preferences.vala"
	switch (property_id) {
#line 28 "../src/preferences.vala"
		case PREFERENCES_BOARD_ORIENTATION_PROPERTY:
#line 28 "../src/preferences.vala"
		g_value_set_enum (value, preferences_get_board_orientation (self));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_MOVE_FORMAT_PROPERTY:
#line 28 "../src/preferences.vala"
		g_value_set_enum (value, preferences_get_move_format (self));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_PIECE_STYLE_PROPERTY:
#line 28 "../src/preferences.vala"
		g_value_set_enum (value, preferences_get_piece_style (self));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_SHOW_BOARD_NUMBERING_PROPERTY:
#line 28 "../src/preferences.vala"
		g_value_set_boolean (value, preferences_get_show_board_numbering (self));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_SHOW_MOVE_HINTS_PROPERTY:
#line 28 "../src/preferences.vala"
		g_value_set_boolean (value, preferences_get_show_move_hints (self));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_OPPONENT_PROPERTY:
#line 28 "../src/preferences.vala"
		g_value_set_object (value, preferences_get_opponent (self));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_PLAY_AS_PROPERTY:
#line 28 "../src/preferences.vala"
		g_value_set_enum (value, preferences_get_play_as (self));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_DIFFICULTY_PROPERTY:
#line 28 "../src/preferences.vala"
		g_value_set_enum (value, preferences_get_difficulty (self));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_TIME_LIMIT_PROPERTY:
#line 28 "../src/preferences.vala"
		value_set_time_limit (value, preferences_get_time_limit (self));
#line 28 "../src/preferences.vala"
		break;
#line 1931 "preferences.c"
		default:
#line 28 "../src/preferences.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/preferences.vala"
		break;
#line 1937 "preferences.c"
	}
}

static void
_vala_preferences_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	Preferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PREFERENCES, Preferences);
#line 28 "../src/preferences.vala"
	switch (property_id) {
#line 28 "../src/preferences.vala"
		case PREFERENCES_BOARD_ORIENTATION_PROPERTY:
#line 28 "../src/preferences.vala"
		preferences_set_board_orientation (self, g_value_get_enum (value));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_MOVE_FORMAT_PROPERTY:
#line 28 "../src/preferences.vala"
		preferences_set_move_format (self, g_value_get_enum (value));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_PIECE_STYLE_PROPERTY:
#line 28 "../src/preferences.vala"
		preferences_set_piece_style (self, g_value_get_enum (value));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_SHOW_BOARD_NUMBERING_PROPERTY:
#line 28 "../src/preferences.vala"
		preferences_set_show_board_numbering (self, g_value_get_boolean (value));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_SHOW_MOVE_HINTS_PROPERTY:
#line 28 "../src/preferences.vala"
		preferences_set_show_move_hints (self, g_value_get_boolean (value));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_OPPONENT_PROPERTY:
#line 28 "../src/preferences.vala"
		preferences_set_opponent (self, g_value_get_object (value));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_PLAY_AS_PROPERTY:
#line 28 "../src/preferences.vala"
		preferences_set_play_as (self, g_value_get_enum (value));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_DIFFICULTY_PROPERTY:
#line 28 "../src/preferences.vala"
		preferences_set_difficulty (self, g_value_get_enum (value));
#line 28 "../src/preferences.vala"
		break;
#line 28 "../src/preferences.vala"
		case PREFERENCES_TIME_LIMIT_PROPERTY:
#line 28 "../src/preferences.vala"
		preferences_set_time_limit (self, value_get_time_limit (value));
#line 28 "../src/preferences.vala"
		break;
#line 2005 "preferences.c"
		default:
#line 28 "../src/preferences.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/preferences.vala"
		break;
#line 2011 "preferences.c"
	}
}

gchar*
board_orientation_display_name (BoardOrientation self)
{
	gchar* result;
#line 214 "../src/preferences.vala"
	switch (self) {
#line 214 "../src/preferences.vala"
		case BOARD_ORIENTATION_WHITE_SIDE:
#line 2023 "preferences.c"
		{
			gchar* _tmp0_;
#line 217 "../src/preferences.vala"
			_tmp0_ = g_strdup (C_ ("chess-side", "White Side"));
#line 217 "../src/preferences.vala"
			result = _tmp0_;
#line 217 "../src/preferences.vala"
			return result;
#line 2032 "preferences.c"
		}
#line 214 "../src/preferences.vala"
		case BOARD_ORIENTATION_BLACK_SIDE:
#line 2036 "preferences.c"
		{
			gchar* _tmp1_;
#line 219 "../src/preferences.vala"
			_tmp1_ = g_strdup (C_ ("chess-side", "Black Side"));
#line 219 "../src/preferences.vala"
			result = _tmp1_;
#line 219 "../src/preferences.vala"
			return result;
#line 2045 "preferences.c"
		}
#line 214 "../src/preferences.vala"
		case BOARD_ORIENTATION_HUMAN_SIDE:
#line 2049 "preferences.c"
		{
			gchar* _tmp2_;
#line 221 "../src/preferences.vala"
			_tmp2_ = g_strdup (C_ ("chess-side", "Human Side"));
#line 221 "../src/preferences.vala"
			result = _tmp2_;
#line 221 "../src/preferences.vala"
			return result;
#line 2058 "preferences.c"
		}
#line 214 "../src/preferences.vala"
		case BOARD_ORIENTATION_CURRENT_PLAYER:
#line 2062 "preferences.c"
		{
			gchar* _tmp3_;
#line 223 "../src/preferences.vala"
			_tmp3_ = g_strdup (C_ ("chess-side", "Current Player"));
#line 223 "../src/preferences.vala"
			result = _tmp3_;
#line 223 "../src/preferences.vala"
			return result;
#line 2071 "preferences.c"
		}
		default:
		{
#line 225 "../src/preferences.vala"
			g_assert_not_reached ();
#line 2077 "preferences.c"
		}
	}
}

gchar*
board_orientation_to_setting (BoardOrientation self)
{
	gchar* result;
#line 231 "../src/preferences.vala"
	switch (self) {
#line 231 "../src/preferences.vala"
		case BOARD_ORIENTATION_WHITE_SIDE:
#line 2090 "preferences.c"
		{
			gchar* _tmp0_;
#line 234 "../src/preferences.vala"
			_tmp0_ = g_strdup ("white");
#line 234 "../src/preferences.vala"
			result = _tmp0_;
#line 234 "../src/preferences.vala"
			return result;
#line 2099 "preferences.c"
		}
#line 231 "../src/preferences.vala"
		case BOARD_ORIENTATION_BLACK_SIDE:
#line 2103 "preferences.c"
		{
			gchar* _tmp1_;
#line 236 "../src/preferences.vala"
			_tmp1_ = g_strdup ("black");
#line 236 "../src/preferences.vala"
			result = _tmp1_;
#line 236 "../src/preferences.vala"
			return result;
#line 2112 "preferences.c"
		}
#line 231 "../src/preferences.vala"
		case BOARD_ORIENTATION_HUMAN_SIDE:
#line 2116 "preferences.c"
		{
			gchar* _tmp2_;
#line 238 "../src/preferences.vala"
			_tmp2_ = g_strdup ("human");
#line 238 "../src/preferences.vala"
			result = _tmp2_;
#line 238 "../src/preferences.vala"
			return result;
#line 2125 "preferences.c"
		}
#line 231 "../src/preferences.vala"
		case BOARD_ORIENTATION_CURRENT_PLAYER:
#line 2129 "preferences.c"
		{
			gchar* _tmp3_;
#line 240 "../src/preferences.vala"
			_tmp3_ = g_strdup ("current");
#line 240 "../src/preferences.vala"
			result = _tmp3_;
#line 240 "../src/preferences.vala"
			return result;
#line 2138 "preferences.c"
		}
		default:
		{
#line 242 "../src/preferences.vala"
			g_assert_not_reached ();
#line 2144 "preferences.c"
		}
	}
}

BoardOrientation*
board_orientation_from_setting (const gchar* s)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 248 "../src/preferences.vala"
	static GQuark _tmp1_label0 = 0;
#line 248 "../src/preferences.vala"
	static GQuark _tmp1_label1 = 0;
#line 248 "../src/preferences.vala"
	static GQuark _tmp1_label2 = 0;
#line 248 "../src/preferences.vala"
	static GQuark _tmp1_label3 = 0;
#line 2162 "preferences.c"
	BoardOrientation* result;
#line 246 "../src/preferences.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 248 "../src/preferences.vala"
	_tmp0_ = s;
#line 248 "../src/preferences.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 248 "../src/preferences.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("white")))) {
#line 248 "../src/preferences.vala"
		switch (0) {
#line 2174 "preferences.c"
			default:
			{
				BoardOrientation _tmp3_;
				BoardOrientation* _tmp4_;
#line 251 "../src/preferences.vala"
				_tmp3_ = BOARD_ORIENTATION_WHITE_SIDE;
#line 251 "../src/preferences.vala"
				_tmp4_ = __board_orientation_dup0 (&_tmp3_);
#line 251 "../src/preferences.vala"
				result = _tmp4_;
#line 251 "../src/preferences.vala"
				return result;
#line 2187 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("black")))) {
#line 248 "../src/preferences.vala"
		switch (0) {
#line 2193 "preferences.c"
			default:
			{
				BoardOrientation _tmp5_;
				BoardOrientation* _tmp6_;
#line 253 "../src/preferences.vala"
				_tmp5_ = BOARD_ORIENTATION_BLACK_SIDE;
#line 253 "../src/preferences.vala"
				_tmp6_ = __board_orientation_dup0 (&_tmp5_);
#line 253 "../src/preferences.vala"
				result = _tmp6_;
#line 253 "../src/preferences.vala"
				return result;
#line 2206 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("human")))) {
#line 248 "../src/preferences.vala"
		switch (0) {
#line 2212 "preferences.c"
			default:
			{
				BoardOrientation _tmp7_;
				BoardOrientation* _tmp8_;
#line 255 "../src/preferences.vala"
				_tmp7_ = BOARD_ORIENTATION_HUMAN_SIDE;
#line 255 "../src/preferences.vala"
				_tmp8_ = __board_orientation_dup0 (&_tmp7_);
#line 255 "../src/preferences.vala"
				result = _tmp8_;
#line 255 "../src/preferences.vala"
				return result;
#line 2225 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("current")))) {
#line 248 "../src/preferences.vala"
		switch (0) {
#line 2231 "preferences.c"
			default:
			{
				BoardOrientation _tmp9_;
				BoardOrientation* _tmp10_;
#line 257 "../src/preferences.vala"
				_tmp9_ = BOARD_ORIENTATION_CURRENT_PLAYER;
#line 257 "../src/preferences.vala"
				_tmp10_ = __board_orientation_dup0 (&_tmp9_);
#line 257 "../src/preferences.vala"
				result = _tmp10_;
#line 257 "../src/preferences.vala"
				return result;
#line 2244 "preferences.c"
			}
		}
	} else {
#line 248 "../src/preferences.vala"
		switch (0) {
#line 2250 "preferences.c"
			default:
			{
#line 259 "../src/preferences.vala"
				result = NULL;
#line 259 "../src/preferences.vala"
				return result;
#line 2257 "preferences.c"
			}
		}
	}
}

static GType
board_orientation_get_type_once (void)
{
	static const GEnumValue values[] = {{BOARD_ORIENTATION_HUMAN_SIDE, "BOARD_ORIENTATION_HUMAN_SIDE", "human-side"}, {BOARD_ORIENTATION_WHITE_SIDE, "BOARD_ORIENTATION_WHITE_SIDE", "white-side"}, {BOARD_ORIENTATION_BLACK_SIDE, "BOARD_ORIENTATION_BLACK_SIDE", "black-side"}, {BOARD_ORIENTATION_CURRENT_PLAYER, "BOARD_ORIENTATION_CURRENT_PLAYER", "current-player"}, {0, NULL, NULL}};
	GType board_orientation_type_id;
	board_orientation_type_id = g_enum_register_static ("BoardOrientation", values);
	return board_orientation_type_id;
}

GType
board_orientation_get_type (void)
{
	static volatile gsize board_orientation_type_id__once = 0;
	if (g_once_init_enter (&board_orientation_type_id__once)) {
		GType board_orientation_type_id;
		board_orientation_type_id = board_orientation_get_type_once ();
		g_once_init_leave (&board_orientation_type_id__once, board_orientation_type_id);
	}
	return board_orientation_type_id__once;
}

gchar*
move_format_display_name (MoveFormat self)
{
	gchar* result;
#line 273 "../src/preferences.vala"
	switch (self) {
#line 273 "../src/preferences.vala"
		case MOVE_FORMAT_HUMAN:
#line 2292 "preferences.c"
		{
			gchar* _tmp0_;
#line 276 "../src/preferences.vala"
			_tmp0_ = g_strdup (C_ ("chess-move-format", "Human"));
#line 276 "../src/preferences.vala"
			result = _tmp0_;
#line 276 "../src/preferences.vala"
			return result;
#line 2301 "preferences.c"
		}
#line 273 "../src/preferences.vala"
		case MOVE_FORMAT_STANDARD_ALGEBRAIC:
#line 2305 "preferences.c"
		{
			gchar* _tmp1_;
#line 278 "../src/preferences.vala"
			_tmp1_ = g_strdup (C_ ("chess-move-format", "Standard Algebraic"));
#line 278 "../src/preferences.vala"
			result = _tmp1_;
#line 278 "../src/preferences.vala"
			return result;
#line 2314 "preferences.c"
		}
#line 273 "../src/preferences.vala"
		case MOVE_FORMAT_LONG_ALGEBRAIC:
#line 2318 "preferences.c"
		{
			gchar* _tmp2_;
#line 280 "../src/preferences.vala"
			_tmp2_ = g_strdup (C_ ("chess-move-format", "Long Algebraic"));
#line 280 "../src/preferences.vala"
			result = _tmp2_;
#line 280 "../src/preferences.vala"
			return result;
#line 2327 "preferences.c"
		}
#line 273 "../src/preferences.vala"
		case MOVE_FORMAT_FIGURINE:
#line 2331 "preferences.c"
		{
			gchar* _tmp3_;
#line 282 "../src/preferences.vala"
			_tmp3_ = g_strdup (C_ ("chess-move-format", "Figurine"));
#line 282 "../src/preferences.vala"
			result = _tmp3_;
#line 282 "../src/preferences.vala"
			return result;
#line 2340 "preferences.c"
		}
		default:
		{
#line 284 "../src/preferences.vala"
			g_assert_not_reached ();
#line 2346 "preferences.c"
		}
	}
}

gchar*
move_format_to_setting (MoveFormat self)
{
	gchar* result;
#line 290 "../src/preferences.vala"
	switch (self) {
#line 290 "../src/preferences.vala"
		case MOVE_FORMAT_HUMAN:
#line 2359 "preferences.c"
		{
			gchar* _tmp0_;
#line 293 "../src/preferences.vala"
			_tmp0_ = g_strdup ("human");
#line 293 "../src/preferences.vala"
			result = _tmp0_;
#line 293 "../src/preferences.vala"
			return result;
#line 2368 "preferences.c"
		}
#line 290 "../src/preferences.vala"
		case MOVE_FORMAT_STANDARD_ALGEBRAIC:
#line 2372 "preferences.c"
		{
			gchar* _tmp1_;
#line 295 "../src/preferences.vala"
			_tmp1_ = g_strdup ("san");
#line 295 "../src/preferences.vala"
			result = _tmp1_;
#line 295 "../src/preferences.vala"
			return result;
#line 2381 "preferences.c"
		}
#line 290 "../src/preferences.vala"
		case MOVE_FORMAT_LONG_ALGEBRAIC:
#line 2385 "preferences.c"
		{
			gchar* _tmp2_;
#line 297 "../src/preferences.vala"
			_tmp2_ = g_strdup ("lan");
#line 297 "../src/preferences.vala"
			result = _tmp2_;
#line 297 "../src/preferences.vala"
			return result;
#line 2394 "preferences.c"
		}
#line 290 "../src/preferences.vala"
		case MOVE_FORMAT_FIGURINE:
#line 2398 "preferences.c"
		{
			gchar* _tmp3_;
#line 299 "../src/preferences.vala"
			_tmp3_ = g_strdup ("fan");
#line 299 "../src/preferences.vala"
			result = _tmp3_;
#line 299 "../src/preferences.vala"
			return result;
#line 2407 "preferences.c"
		}
		default:
		{
#line 301 "../src/preferences.vala"
			g_assert_not_reached ();
#line 2413 "preferences.c"
		}
	}
}

MoveFormat*
move_format_from_setting (const gchar* s)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 307 "../src/preferences.vala"
	static GQuark _tmp1_label0 = 0;
#line 307 "../src/preferences.vala"
	static GQuark _tmp1_label1 = 0;
#line 307 "../src/preferences.vala"
	static GQuark _tmp1_label2 = 0;
#line 307 "../src/preferences.vala"
	static GQuark _tmp1_label3 = 0;
#line 2431 "preferences.c"
	MoveFormat* result;
#line 305 "../src/preferences.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 307 "../src/preferences.vala"
	_tmp0_ = s;
#line 307 "../src/preferences.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 307 "../src/preferences.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("human")))) {
#line 307 "../src/preferences.vala"
		switch (0) {
#line 2443 "preferences.c"
			default:
			{
				MoveFormat _tmp3_;
				MoveFormat* _tmp4_;
#line 310 "../src/preferences.vala"
				_tmp3_ = MOVE_FORMAT_HUMAN;
#line 310 "../src/preferences.vala"
				_tmp4_ = __move_format_dup0 (&_tmp3_);
#line 310 "../src/preferences.vala"
				result = _tmp4_;
#line 310 "../src/preferences.vala"
				return result;
#line 2456 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("san")))) {
#line 307 "../src/preferences.vala"
		switch (0) {
#line 2462 "preferences.c"
			default:
			{
				MoveFormat _tmp5_;
				MoveFormat* _tmp6_;
#line 312 "../src/preferences.vala"
				_tmp5_ = MOVE_FORMAT_STANDARD_ALGEBRAIC;
#line 312 "../src/preferences.vala"
				_tmp6_ = __move_format_dup0 (&_tmp5_);
#line 312 "../src/preferences.vala"
				result = _tmp6_;
#line 312 "../src/preferences.vala"
				return result;
#line 2475 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("lan")))) {
#line 307 "../src/preferences.vala"
		switch (0) {
#line 2481 "preferences.c"
			default:
			{
				MoveFormat _tmp7_;
				MoveFormat* _tmp8_;
#line 314 "../src/preferences.vala"
				_tmp7_ = MOVE_FORMAT_LONG_ALGEBRAIC;
#line 314 "../src/preferences.vala"
				_tmp8_ = __move_format_dup0 (&_tmp7_);
#line 314 "../src/preferences.vala"
				result = _tmp8_;
#line 314 "../src/preferences.vala"
				return result;
#line 2494 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("fan")))) {
#line 307 "../src/preferences.vala"
		switch (0) {
#line 2500 "preferences.c"
			default:
			{
				MoveFormat _tmp9_;
				MoveFormat* _tmp10_;
#line 316 "../src/preferences.vala"
				_tmp9_ = MOVE_FORMAT_FIGURINE;
#line 316 "../src/preferences.vala"
				_tmp10_ = __move_format_dup0 (&_tmp9_);
#line 316 "../src/preferences.vala"
				result = _tmp10_;
#line 316 "../src/preferences.vala"
				return result;
#line 2513 "preferences.c"
			}
		}
	} else {
#line 307 "../src/preferences.vala"
		switch (0) {
#line 2519 "preferences.c"
			default:
			{
#line 318 "../src/preferences.vala"
				result = NULL;
#line 318 "../src/preferences.vala"
				return result;
#line 2526 "preferences.c"
			}
		}
	}
}

static GType
move_format_get_type_once (void)
{
	static const GEnumValue values[] = {{MOVE_FORMAT_HUMAN, "MOVE_FORMAT_HUMAN", "human"}, {MOVE_FORMAT_STANDARD_ALGEBRAIC, "MOVE_FORMAT_STANDARD_ALGEBRAIC", "standard-algebraic"}, {MOVE_FORMAT_LONG_ALGEBRAIC, "MOVE_FORMAT_LONG_ALGEBRAIC", "long-algebraic"}, {MOVE_FORMAT_FIGURINE, "MOVE_FORMAT_FIGURINE", "figurine"}, {0, NULL, NULL}};
	GType move_format_type_id;
	move_format_type_id = g_enum_register_static ("MoveFormat", values);
	return move_format_type_id;
}

GType
move_format_get_type (void)
{
	static volatile gsize move_format_type_id__once = 0;
	if (g_once_init_enter (&move_format_type_id__once)) {
		GType move_format_type_id;
		move_format_type_id = move_format_get_type_once ();
		g_once_init_leave (&move_format_type_id__once, move_format_type_id);
	}
	return move_format_type_id__once;
}

gchar*
piece_style_display_name (PieceStyle self)
{
	gchar* result;
#line 330 "../src/preferences.vala"
	switch (self) {
#line 330 "../src/preferences.vala"
		case PIECE_STYLE_SIMPLE:
#line 2561 "preferences.c"
		{
			gchar* _tmp0_;
#line 333 "../src/preferences.vala"
			_tmp0_ = g_strdup (C_ ("chess-piece-style", "Simple"));
#line 333 "../src/preferences.vala"
			result = _tmp0_;
#line 333 "../src/preferences.vala"
			return result;
#line 2570 "preferences.c"
		}
#line 330 "../src/preferences.vala"
		case PIECE_STYLE_FANCY:
#line 2574 "preferences.c"
		{
			gchar* _tmp1_;
#line 335 "../src/preferences.vala"
			_tmp1_ = g_strdup (C_ ("chess-piece-style", "Fancy"));
#line 335 "../src/preferences.vala"
			result = _tmp1_;
#line 335 "../src/preferences.vala"
			return result;
#line 2583 "preferences.c"
		}
		default:
		{
#line 337 "../src/preferences.vala"
			g_assert_not_reached ();
#line 2589 "preferences.c"
		}
	}
}

gchar*
piece_style_to_setting (PieceStyle self)
{
	gchar* result;
#line 343 "../src/preferences.vala"
	switch (self) {
#line 343 "../src/preferences.vala"
		case PIECE_STYLE_SIMPLE:
#line 2602 "preferences.c"
		{
			gchar* _tmp0_;
#line 346 "../src/preferences.vala"
			_tmp0_ = g_strdup ("simple");
#line 346 "../src/preferences.vala"
			result = _tmp0_;
#line 346 "../src/preferences.vala"
			return result;
#line 2611 "preferences.c"
		}
#line 343 "../src/preferences.vala"
		case PIECE_STYLE_FANCY:
#line 2615 "preferences.c"
		{
			gchar* _tmp1_;
#line 348 "../src/preferences.vala"
			_tmp1_ = g_strdup ("fancy");
#line 348 "../src/preferences.vala"
			result = _tmp1_;
#line 348 "../src/preferences.vala"
			return result;
#line 2624 "preferences.c"
		}
		default:
		{
#line 350 "../src/preferences.vala"
			g_assert_not_reached ();
#line 2630 "preferences.c"
		}
	}
}

PieceStyle*
piece_style_from_setting (const gchar* s)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 356 "../src/preferences.vala"
	static GQuark _tmp1_label0 = 0;
#line 356 "../src/preferences.vala"
	static GQuark _tmp1_label1 = 0;
#line 2644 "preferences.c"
	PieceStyle* result;
#line 354 "../src/preferences.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 356 "../src/preferences.vala"
	_tmp0_ = s;
#line 356 "../src/preferences.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 356 "../src/preferences.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("simple")))) {
#line 356 "../src/preferences.vala"
		switch (0) {
#line 2656 "preferences.c"
			default:
			{
				PieceStyle _tmp3_;
				PieceStyle* _tmp4_;
#line 359 "../src/preferences.vala"
				_tmp3_ = PIECE_STYLE_SIMPLE;
#line 359 "../src/preferences.vala"
				_tmp4_ = __piece_style_dup0 (&_tmp3_);
#line 359 "../src/preferences.vala"
				result = _tmp4_;
#line 359 "../src/preferences.vala"
				return result;
#line 2669 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("fancy")))) {
#line 356 "../src/preferences.vala"
		switch (0) {
#line 2675 "preferences.c"
			default:
			{
				PieceStyle _tmp5_;
				PieceStyle* _tmp6_;
#line 361 "../src/preferences.vala"
				_tmp5_ = PIECE_STYLE_FANCY;
#line 361 "../src/preferences.vala"
				_tmp6_ = __piece_style_dup0 (&_tmp5_);
#line 361 "../src/preferences.vala"
				result = _tmp6_;
#line 361 "../src/preferences.vala"
				return result;
#line 2688 "preferences.c"
			}
		}
	} else {
#line 356 "../src/preferences.vala"
		switch (0) {
#line 2694 "preferences.c"
			default:
			{
#line 363 "../src/preferences.vala"
				result = NULL;
#line 363 "../src/preferences.vala"
				return result;
#line 2701 "preferences.c"
			}
		}
	}
}

static GType
piece_style_get_type_once (void)
{
	static const GEnumValue values[] = {{PIECE_STYLE_SIMPLE, "PIECE_STYLE_SIMPLE", "simple"}, {PIECE_STYLE_FANCY, "PIECE_STYLE_FANCY", "fancy"}, {0, NULL, NULL}};
	GType piece_style_type_id;
	piece_style_type_id = g_enum_register_static ("PieceStyle", values);
	return piece_style_type_id;
}

GType
piece_style_get_type (void)
{
	static volatile gsize piece_style_type_id__once = 0;
	if (g_once_init_enter (&piece_style_type_id__once)) {
		GType piece_style_type_id;
		piece_style_type_id = piece_style_get_type_once ();
		g_once_init_leave (&piece_style_type_id__once, piece_style_type_id);
	}
	return piece_style_type_id__once;
}

gchar*
play_as_display_name (PlayAs self)
{
	gchar* result;
#line 376 "../src/preferences.vala"
	switch (self) {
#line 376 "../src/preferences.vala"
		case PLAY_AS_WHITE:
#line 2736 "preferences.c"
		{
			gchar* _tmp0_;
#line 379 "../src/preferences.vala"
			_tmp0_ = g_strdup (C_ ("chess-player", "White"));
#line 379 "../src/preferences.vala"
			result = _tmp0_;
#line 379 "../src/preferences.vala"
			return result;
#line 2745 "preferences.c"
		}
#line 376 "../src/preferences.vala"
		case PLAY_AS_BLACK:
#line 2749 "preferences.c"
		{
			gchar* _tmp1_;
#line 381 "../src/preferences.vala"
			_tmp1_ = g_strdup (C_ ("chess-player", "Black"));
#line 381 "../src/preferences.vala"
			result = _tmp1_;
#line 381 "../src/preferences.vala"
			return result;
#line 2758 "preferences.c"
		}
#line 376 "../src/preferences.vala"
		case PLAY_AS_ALTERNATE:
#line 2762 "preferences.c"
		{
			gchar* _tmp2_;
#line 383 "../src/preferences.vala"
			_tmp2_ = g_strdup (C_ ("chess-player", "Alternate"));
#line 383 "../src/preferences.vala"
			result = _tmp2_;
#line 383 "../src/preferences.vala"
			return result;
#line 2771 "preferences.c"
		}
		default:
		{
#line 385 "../src/preferences.vala"
			g_assert_not_reached ();
#line 2777 "preferences.c"
		}
	}
}

gchar*
play_as_to_setting (PlayAs self)
{
	gchar* result;
#line 391 "../src/preferences.vala"
	switch (self) {
#line 391 "../src/preferences.vala"
		case PLAY_AS_WHITE:
#line 2790 "preferences.c"
		{
			gchar* _tmp0_;
#line 394 "../src/preferences.vala"
			_tmp0_ = g_strdup ("white");
#line 394 "../src/preferences.vala"
			result = _tmp0_;
#line 394 "../src/preferences.vala"
			return result;
#line 2799 "preferences.c"
		}
#line 391 "../src/preferences.vala"
		case PLAY_AS_BLACK:
#line 2803 "preferences.c"
		{
			gchar* _tmp1_;
#line 396 "../src/preferences.vala"
			_tmp1_ = g_strdup ("black");
#line 396 "../src/preferences.vala"
			result = _tmp1_;
#line 396 "../src/preferences.vala"
			return result;
#line 2812 "preferences.c"
		}
#line 391 "../src/preferences.vala"
		case PLAY_AS_ALTERNATE:
#line 2816 "preferences.c"
		{
			gchar* _tmp2_;
#line 398 "../src/preferences.vala"
			_tmp2_ = g_strdup ("alternate");
#line 398 "../src/preferences.vala"
			result = _tmp2_;
#line 398 "../src/preferences.vala"
			return result;
#line 2825 "preferences.c"
		}
		default:
		{
#line 400 "../src/preferences.vala"
			g_assert_not_reached ();
#line 2831 "preferences.c"
		}
	}
}

PlayAs*
play_as_from_setting (const gchar* s)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 406 "../src/preferences.vala"
	static GQuark _tmp1_label0 = 0;
#line 406 "../src/preferences.vala"
	static GQuark _tmp1_label1 = 0;
#line 406 "../src/preferences.vala"
	static GQuark _tmp1_label2 = 0;
#line 2847 "preferences.c"
	PlayAs* result;
#line 404 "../src/preferences.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 406 "../src/preferences.vala"
	_tmp0_ = s;
#line 406 "../src/preferences.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 406 "../src/preferences.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("white")))) {
#line 406 "../src/preferences.vala"
		switch (0) {
#line 2859 "preferences.c"
			default:
			{
				PlayAs _tmp3_;
				PlayAs* _tmp4_;
#line 409 "../src/preferences.vala"
				_tmp3_ = PLAY_AS_WHITE;
#line 409 "../src/preferences.vala"
				_tmp4_ = __play_as_dup0 (&_tmp3_);
#line 409 "../src/preferences.vala"
				result = _tmp4_;
#line 409 "../src/preferences.vala"
				return result;
#line 2872 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("black")))) {
#line 406 "../src/preferences.vala"
		switch (0) {
#line 2878 "preferences.c"
			default:
			{
				PlayAs _tmp5_;
				PlayAs* _tmp6_;
#line 411 "../src/preferences.vala"
				_tmp5_ = PLAY_AS_BLACK;
#line 411 "../src/preferences.vala"
				_tmp6_ = __play_as_dup0 (&_tmp5_);
#line 411 "../src/preferences.vala"
				result = _tmp6_;
#line 411 "../src/preferences.vala"
				return result;
#line 2891 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("alternate")))) {
#line 406 "../src/preferences.vala"
		switch (0) {
#line 2897 "preferences.c"
			default:
			{
				PlayAs _tmp7_;
				PlayAs* _tmp8_;
#line 413 "../src/preferences.vala"
				_tmp7_ = PLAY_AS_ALTERNATE;
#line 413 "../src/preferences.vala"
				_tmp8_ = __play_as_dup0 (&_tmp7_);
#line 413 "../src/preferences.vala"
				result = _tmp8_;
#line 413 "../src/preferences.vala"
				return result;
#line 2910 "preferences.c"
			}
		}
	} else {
#line 406 "../src/preferences.vala"
		switch (0) {
#line 2916 "preferences.c"
			default:
			{
#line 415 "../src/preferences.vala"
				result = NULL;
#line 415 "../src/preferences.vala"
				return result;
#line 2923 "preferences.c"
			}
		}
	}
}

static GType
play_as_get_type_once (void)
{
	static const GEnumValue values[] = {{PLAY_AS_WHITE, "PLAY_AS_WHITE", "white"}, {PLAY_AS_BLACK, "PLAY_AS_BLACK", "black"}, {PLAY_AS_ALTERNATE, "PLAY_AS_ALTERNATE", "alternate"}, {0, NULL, NULL}};
	GType play_as_type_id;
	play_as_type_id = g_enum_register_static ("PlayAs", values);
	return play_as_type_id;
}

GType
play_as_get_type (void)
{
	static volatile gsize play_as_type_id__once = 0;
	if (g_once_init_enter (&play_as_type_id__once)) {
		GType play_as_type_id;
		play_as_type_id = play_as_get_type_once ();
		g_once_init_leave (&play_as_type_id__once, play_as_type_id);
	}
	return play_as_type_id__once;
}

gchar*
difficulty_display_name (Difficulty self)
{
	gchar* result;
#line 428 "../src/preferences.vala"
	switch (self) {
#line 428 "../src/preferences.vala"
		case DIFFICULTY_EASY:
#line 2958 "preferences.c"
		{
			gchar* _tmp0_;
#line 431 "../src/preferences.vala"
			_tmp0_ = g_strdup (C_ ("difficulty", "Easy"));
#line 431 "../src/preferences.vala"
			result = _tmp0_;
#line 431 "../src/preferences.vala"
			return result;
#line 2967 "preferences.c"
		}
#line 428 "../src/preferences.vala"
		case DIFFICULTY_NORMAL:
#line 2971 "preferences.c"
		{
			gchar* _tmp1_;
#line 433 "../src/preferences.vala"
			_tmp1_ = g_strdup (C_ ("difficulty", "Normal"));
#line 433 "../src/preferences.vala"
			result = _tmp1_;
#line 433 "../src/preferences.vala"
			return result;
#line 2980 "preferences.c"
		}
#line 428 "../src/preferences.vala"
		case DIFFICULTY_HARD:
#line 2984 "preferences.c"
		{
			gchar* _tmp2_;
#line 435 "../src/preferences.vala"
			_tmp2_ = g_strdup (C_ ("difficulty", "Hard"));
#line 435 "../src/preferences.vala"
			result = _tmp2_;
#line 435 "../src/preferences.vala"
			return result;
#line 2993 "preferences.c"
		}
		default:
		{
#line 437 "../src/preferences.vala"
			g_assert_not_reached ();
#line 2999 "preferences.c"
		}
	}
}

gchar*
difficulty_to_setting (Difficulty self)
{
	gchar* result;
#line 443 "../src/preferences.vala"
	switch (self) {
#line 443 "../src/preferences.vala"
		case DIFFICULTY_EASY:
#line 3012 "preferences.c"
		{
			gchar* _tmp0_;
#line 446 "../src/preferences.vala"
			_tmp0_ = g_strdup ("easy");
#line 446 "../src/preferences.vala"
			result = _tmp0_;
#line 446 "../src/preferences.vala"
			return result;
#line 3021 "preferences.c"
		}
#line 443 "../src/preferences.vala"
		case DIFFICULTY_NORMAL:
#line 3025 "preferences.c"
		{
			gchar* _tmp1_;
#line 448 "../src/preferences.vala"
			_tmp1_ = g_strdup ("normal");
#line 448 "../src/preferences.vala"
			result = _tmp1_;
#line 448 "../src/preferences.vala"
			return result;
#line 3034 "preferences.c"
		}
#line 443 "../src/preferences.vala"
		case DIFFICULTY_HARD:
#line 3038 "preferences.c"
		{
			gchar* _tmp2_;
#line 450 "../src/preferences.vala"
			_tmp2_ = g_strdup ("hard");
#line 450 "../src/preferences.vala"
			result = _tmp2_;
#line 450 "../src/preferences.vala"
			return result;
#line 3047 "preferences.c"
		}
		default:
		{
#line 452 "../src/preferences.vala"
			g_assert_not_reached ();
#line 3053 "preferences.c"
		}
	}
}

Difficulty*
difficulty_from_setting (const gchar* s)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 458 "../src/preferences.vala"
	static GQuark _tmp1_label0 = 0;
#line 458 "../src/preferences.vala"
	static GQuark _tmp1_label1 = 0;
#line 458 "../src/preferences.vala"
	static GQuark _tmp1_label2 = 0;
#line 3069 "preferences.c"
	Difficulty* result;
#line 456 "../src/preferences.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 458 "../src/preferences.vala"
	_tmp0_ = s;
#line 458 "../src/preferences.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 458 "../src/preferences.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("easy")))) {
#line 458 "../src/preferences.vala"
		switch (0) {
#line 3081 "preferences.c"
			default:
			{
				Difficulty _tmp3_;
				Difficulty* _tmp4_;
#line 461 "../src/preferences.vala"
				_tmp3_ = DIFFICULTY_EASY;
#line 461 "../src/preferences.vala"
				_tmp4_ = __difficulty_dup0 (&_tmp3_);
#line 461 "../src/preferences.vala"
				result = _tmp4_;
#line 461 "../src/preferences.vala"
				return result;
#line 3094 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("normal")))) {
#line 458 "../src/preferences.vala"
		switch (0) {
#line 3100 "preferences.c"
			default:
			{
				Difficulty _tmp5_;
				Difficulty* _tmp6_;
#line 463 "../src/preferences.vala"
				_tmp5_ = DIFFICULTY_NORMAL;
#line 463 "../src/preferences.vala"
				_tmp6_ = __difficulty_dup0 (&_tmp5_);
#line 463 "../src/preferences.vala"
				result = _tmp6_;
#line 463 "../src/preferences.vala"
				return result;
#line 3113 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("hard")))) {
#line 458 "../src/preferences.vala"
		switch (0) {
#line 3119 "preferences.c"
			default:
			{
				Difficulty _tmp7_;
				Difficulty* _tmp8_;
#line 465 "../src/preferences.vala"
				_tmp7_ = DIFFICULTY_HARD;
#line 465 "../src/preferences.vala"
				_tmp8_ = __difficulty_dup0 (&_tmp7_);
#line 465 "../src/preferences.vala"
				result = _tmp8_;
#line 465 "../src/preferences.vala"
				return result;
#line 3132 "preferences.c"
			}
		}
	} else {
#line 458 "../src/preferences.vala"
		switch (0) {
#line 3138 "preferences.c"
			default:
			{
#line 467 "../src/preferences.vala"
				result = NULL;
#line 467 "../src/preferences.vala"
				return result;
#line 3145 "preferences.c"
			}
		}
	}
}

static GType
difficulty_get_type_once (void)
{
	static const GEnumValue values[] = {{DIFFICULTY_EASY, "DIFFICULTY_EASY", "easy"}, {DIFFICULTY_NORMAL, "DIFFICULTY_NORMAL", "normal"}, {DIFFICULTY_HARD, "DIFFICULTY_HARD", "hard"}, {0, NULL, NULL}};
	GType difficulty_type_id;
	difficulty_type_id = g_enum_register_static ("Difficulty", values);
	return difficulty_type_id;
}

GType
difficulty_get_type (void)
{
	static volatile gsize difficulty_type_id__once = 0;
	if (g_once_init_enter (&difficulty_type_id__once)) {
		GType difficulty_type_id;
		difficulty_type_id = difficulty_get_type_once ();
		g_once_init_leave (&difficulty_type_id__once, difficulty_type_id);
	}
	return difficulty_type_id__once;
}

gchar*
clock_type_display_name (ClockType self)
{
	gchar* result;
#line 479 "../src/preferences.vala"
	switch (self) {
#line 479 "../src/preferences.vala"
		case CLOCK_TYPE_FISCHER:
#line 3180 "preferences.c"
		{
			gchar* _tmp0_;
#line 482 "../src/preferences.vala"
			_tmp0_ = g_strdup (C_ ("clock-type", "Fischer"));
#line 482 "../src/preferences.vala"
			result = _tmp0_;
#line 482 "../src/preferences.vala"
			return result;
#line 3189 "preferences.c"
		}
#line 479 "../src/preferences.vala"
		case CLOCK_TYPE_BRONSTEIN:
#line 3193 "preferences.c"
		{
			gchar* _tmp1_;
#line 484 "../src/preferences.vala"
			_tmp1_ = g_strdup (C_ ("clock-type", "Bronstein"));
#line 484 "../src/preferences.vala"
			result = _tmp1_;
#line 484 "../src/preferences.vala"
			return result;
#line 3202 "preferences.c"
		}
		default:
		{
#line 486 "../src/preferences.vala"
			g_assert_not_reached ();
#line 3208 "preferences.c"
		}
	}
}

gchar*
clock_type_to_setting (ClockType self)
{
	gchar* result;
#line 492 "../src/preferences.vala"
	switch (self) {
#line 492 "../src/preferences.vala"
		case CLOCK_TYPE_FISCHER:
#line 3221 "preferences.c"
		{
			gchar* _tmp0_;
#line 495 "../src/preferences.vala"
			_tmp0_ = g_strdup ("fischer");
#line 495 "../src/preferences.vala"
			result = _tmp0_;
#line 495 "../src/preferences.vala"
			return result;
#line 3230 "preferences.c"
		}
#line 492 "../src/preferences.vala"
		case CLOCK_TYPE_BRONSTEIN:
#line 3234 "preferences.c"
		{
			gchar* _tmp1_;
#line 497 "../src/preferences.vala"
			_tmp1_ = g_strdup ("bronstein");
#line 497 "../src/preferences.vala"
			result = _tmp1_;
#line 497 "../src/preferences.vala"
			return result;
#line 3243 "preferences.c"
		}
		default:
		{
#line 499 "../src/preferences.vala"
			g_assert_not_reached ();
#line 3249 "preferences.c"
		}
	}
}

static ClockType*
_clock_type_dup (ClockType* self)
{
	ClockType* dup;
#line 508 "../src/preferences.vala"
	dup = g_new0 (ClockType, 1);
#line 508 "../src/preferences.vala"
	memcpy (dup, self, sizeof (ClockType));
#line 508 "../src/preferences.vala"
	return dup;
#line 3264 "preferences.c"
}

static gpointer
__clock_type_dup0 (gpointer self)
{
#line 508 "../src/preferences.vala"
	return self ? _clock_type_dup (self) : NULL;
#line 3272 "preferences.c"
}

ClockType*
clock_type_from_setting (const gchar* s)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 505 "../src/preferences.vala"
	static GQuark _tmp1_label0 = 0;
#line 505 "../src/preferences.vala"
	static GQuark _tmp1_label1 = 0;
#line 3284 "preferences.c"
	ClockType* result;
#line 503 "../src/preferences.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 505 "../src/preferences.vala"
	_tmp0_ = s;
#line 505 "../src/preferences.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 505 "../src/preferences.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("fischer")))) {
#line 505 "../src/preferences.vala"
		switch (0) {
#line 3296 "preferences.c"
			default:
			{
				ClockType _tmp3_;
				ClockType* _tmp4_;
#line 508 "../src/preferences.vala"
				_tmp3_ = CLOCK_TYPE_FISCHER;
#line 508 "../src/preferences.vala"
				_tmp4_ = __clock_type_dup0 (&_tmp3_);
#line 508 "../src/preferences.vala"
				result = _tmp4_;
#line 508 "../src/preferences.vala"
				return result;
#line 3309 "preferences.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("bronstein")))) {
#line 505 "../src/preferences.vala"
		switch (0) {
#line 3315 "preferences.c"
			default:
			{
				ClockType _tmp5_;
				ClockType* _tmp6_;
#line 510 "../src/preferences.vala"
				_tmp5_ = CLOCK_TYPE_BRONSTEIN;
#line 510 "../src/preferences.vala"
				_tmp6_ = __clock_type_dup0 (&_tmp5_);
#line 510 "../src/preferences.vala"
				result = _tmp6_;
#line 510 "../src/preferences.vala"
				return result;
#line 3328 "preferences.c"
			}
		}
	} else {
#line 505 "../src/preferences.vala"
		switch (0) {
#line 3334 "preferences.c"
			default:
			{
#line 512 "../src/preferences.vala"
				result = NULL;
#line 512 "../src/preferences.vala"
				return result;
#line 3341 "preferences.c"
			}
		}
	}
}

static GType
clock_type_get_type_once (void)
{
	static const GEnumValue values[] = {{CLOCK_TYPE_FISCHER, "CLOCK_TYPE_FISCHER", "fischer"}, {CLOCK_TYPE_BRONSTEIN, "CLOCK_TYPE_BRONSTEIN", "bronstein"}, {0, NULL, NULL}};
	GType clock_type_type_id;
	clock_type_type_id = g_enum_register_static ("ClockType", values);
	return clock_type_type_id;
}

GType
clock_type_get_type (void)
{
	static volatile gsize clock_type_type_id__once = 0;
	if (g_once_init_enter (&clock_type_type_id__once)) {
		GType clock_type_type_id;
		clock_type_type_id = clock_type_get_type_once ();
		g_once_init_leave (&clock_type_type_id__once, clock_type_type_id);
	}
	return clock_type_type_id__once;
}

static inline gpointer
opponent_get_instance_private (Opponent* self)
{
	return G_STRUCT_MEMBER_P (self, Opponent_private_offset);
}

Opponent*
opponent_construct (GType object_type,
                    const gchar* name,
                    const gchar* display_name)
{
	Opponent * self = NULL;
#line 536 "../src/preferences.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 536 "../src/preferences.vala"
	g_return_val_if_fail (display_name != NULL, NULL);
#line 536 "../src/preferences.vala"
	self = (Opponent*) g_object_new (object_type, NULL);
#line 538 "../src/preferences.vala"
	opponent_set_name (self, name);
#line 539 "../src/preferences.vala"
	opponent_set_display_name (self, display_name);
#line 536 "../src/preferences.vala"
	return self;
#line 3392 "preferences.c"
}

Opponent*
opponent_new (const gchar* name,
              const gchar* display_name)
{
#line 536 "../src/preferences.vala"
	return opponent_construct (TYPE_OPPONENT, name, display_name);
#line 3401 "preferences.c"
}

gchar*
opponent_to_setting (Opponent* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 542 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 544 "../src/preferences.vala"
	_tmp0_ = self->priv->_name;
#line 544 "../src/preferences.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 544 "../src/preferences.vala"
	result = _tmp1_;
#line 544 "../src/preferences.vala"
	return result;
#line 3420 "preferences.c"
}

Opponent*
opponent_from_setting (const gchar* s)
{
	Opponent* _tmp6_;
	Opponent* result;
#line 547 "../src/preferences.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 549 "../src/preferences.vala"
	if (g_strcmp0 (s, OPPONENT_HUMAN_NAME) == 0) {
#line 3432 "preferences.c"
		Opponent* _tmp0_;
		Opponent* _tmp1_;
		Opponent* _tmp2_;
#line 550 "../src/preferences.vala"
		_tmp0_ = opponent_get_human ();
#line 550 "../src/preferences.vala"
		_tmp1_ = _tmp0_;
#line 550 "../src/preferences.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 550 "../src/preferences.vala"
		result = _tmp2_;
#line 550 "../src/preferences.vala"
		return result;
#line 3446 "preferences.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 551 "../src/preferences.vala"
		if (s == NULL) {
#line 551 "../src/preferences.vala"
			_tmp3_ = TRUE;
#line 3453 "preferences.c"
		} else {
			gint _tmp4_;
			gint _tmp5_;
#line 551 "../src/preferences.vala"
			_tmp4_ = strlen (s);
#line 551 "../src/preferences.vala"
			_tmp5_ = _tmp4_;
#line 551 "../src/preferences.vala"
			_tmp3_ = _tmp5_ == 0;
#line 3463 "preferences.c"
		}
#line 551 "../src/preferences.vala"
		if (_tmp3_) {
#line 552 "../src/preferences.vala"
			result = NULL;
#line 552 "../src/preferences.vala"
			return result;
#line 3471 "preferences.c"
		}
	}
#line 553 "../src/preferences.vala"
	_tmp6_ = opponent_new (s, s);
#line 553 "../src/preferences.vala"
	result = _tmp6_;
#line 553 "../src/preferences.vala"
	return result;
#line 3480 "preferences.c"
}

Opponent*
opponent_from_ai_profile (AIProfile* ai_profile)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	Opponent* _tmp4_;
	Opponent* result;
#line 556 "../src/preferences.vala"
	g_return_val_if_fail (ai_profile != NULL, NULL);
#line 558 "../src/preferences.vala"
	_tmp0_ = ai_profile_get_name (ai_profile);
#line 558 "../src/preferences.vala"
	_tmp1_ = _tmp0_;
#line 558 "../src/preferences.vala"
	_tmp2_ = ai_profile_get_name (ai_profile);
#line 558 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 558 "../src/preferences.vala"
	_tmp4_ = opponent_new (_tmp1_, _tmp3_);
#line 558 "../src/preferences.vala"
	result = _tmp4_;
#line 558 "../src/preferences.vala"
	return result;
#line 3508 "preferences.c"
}

Opponent*
opponent_get_human (void)
{
	Opponent* result;
	Opponent* _tmp0_;
	Opponent* _tmp2_;
#line 526 "../src/preferences.vala"
	_tmp0_ = opponent__human;
#line 526 "../src/preferences.vala"
	if (_tmp0_ == NULL) {
#line 3521 "preferences.c"
		Opponent* _tmp1_;
#line 527 "../src/preferences.vala"
		_tmp1_ = opponent_new (OPPONENT_HUMAN_NAME, C_ ("chess-opponent", "Human"));
#line 527 "../src/preferences.vala"
		_g_object_unref0 (opponent__human);
#line 527 "../src/preferences.vala"
		opponent__human = _tmp1_;
#line 3529 "preferences.c"
	}
#line 528 "../src/preferences.vala"
	_tmp2_ = opponent__human;
#line 528 "../src/preferences.vala"
	result = _tmp2_;
#line 528 "../src/preferences.vala"
	return result;
#line 3537 "preferences.c"
}

const gchar*
opponent_get_name (Opponent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 532 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 532 "../src/preferences.vala"
	_tmp0_ = self->priv->_name;
#line 532 "../src/preferences.vala"
	result = _tmp0_;
#line 532 "../src/preferences.vala"
	return result;
#line 3553 "preferences.c"
}

static void
opponent_set_name (Opponent* self,
                   const gchar* value)
{
	gchar* old_value;
#line 532 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 532 "../src/preferences.vala"
	old_value = opponent_get_name (self);
#line 532 "../src/preferences.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3567 "preferences.c"
		gchar* _tmp0_;
#line 532 "../src/preferences.vala"
		_tmp0_ = g_strdup (value);
#line 532 "../src/preferences.vala"
		_g_free0 (self->priv->_name);
#line 532 "../src/preferences.vala"
		self->priv->_name = _tmp0_;
#line 532 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, opponent_properties[OPPONENT_NAME_PROPERTY]);
#line 3577 "preferences.c"
	}
}

const gchar*
opponent_get_display_name (Opponent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 533 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 533 "../src/preferences.vala"
	_tmp0_ = self->priv->_display_name;
#line 533 "../src/preferences.vala"
	result = _tmp0_;
#line 533 "../src/preferences.vala"
	return result;
#line 3594 "preferences.c"
}

static void
opponent_set_display_name (Opponent* self,
                           const gchar* value)
{
	gchar* old_value;
#line 533 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 533 "../src/preferences.vala"
	old_value = opponent_get_display_name (self);
#line 533 "../src/preferences.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3608 "preferences.c"
		gchar* _tmp0_;
#line 533 "../src/preferences.vala"
		_tmp0_ = g_strdup (value);
#line 533 "../src/preferences.vala"
		_g_free0 (self->priv->_display_name);
#line 533 "../src/preferences.vala"
		self->priv->_display_name = _tmp0_;
#line 533 "../src/preferences.vala"
		g_object_notify_by_pspec ((GObject *) self, opponent_properties[OPPONENT_DISPLAY_NAME_PROPERTY]);
#line 3618 "preferences.c"
	}
}

gboolean
opponent_get_is_human (Opponent* self)
{
	gboolean result;
	const gchar* _tmp0_;
#line 534 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 534 "../src/preferences.vala"
	_tmp0_ = self->priv->_name;
#line 534 "../src/preferences.vala"
	result = g_strcmp0 (_tmp0_, OPPONENT_HUMAN_NAME) == 0;
#line 534 "../src/preferences.vala"
	return result;
#line 3635 "preferences.c"
}

static void
opponent_class_init (OpponentClass * klass,
                     gpointer klass_data)
{
#line 517 "../src/preferences.vala"
	opponent_parent_class = g_type_class_peek_parent (klass);
#line 517 "../src/preferences.vala"
	g_type_class_adjust_private_offset (klass, &Opponent_private_offset);
#line 517 "../src/preferences.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_opponent_get_property;
#line 517 "../src/preferences.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_opponent_set_property;
#line 517 "../src/preferences.vala"
	G_OBJECT_CLASS (klass)->finalize = opponent_finalize;
#line 517 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OPPONENT_NAME_PROPERTY, opponent_properties[OPPONENT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 517 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OPPONENT_DISPLAY_NAME_PROPERTY, opponent_properties[OPPONENT_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 517 "../src/preferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OPPONENT_IS_HUMAN_PROPERTY, opponent_properties[OPPONENT_IS_HUMAN_PROPERTY] = g_param_spec_boolean ("is-human", "is-human", "is-human", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3658 "preferences.c"
}

static void
opponent_instance_init (Opponent * self,
                        gpointer klass)
{
#line 517 "../src/preferences.vala"
	self->priv = opponent_get_instance_private (self);
#line 3667 "preferences.c"
}

static void
opponent_finalize (GObject * obj)
{
	Opponent * self;
#line 517 "../src/preferences.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_OPPONENT, Opponent);
#line 532 "../src/preferences.vala"
	_g_free0 (self->priv->_name);
#line 533 "../src/preferences.vala"
	_g_free0 (self->priv->_display_name);
#line 517 "../src/preferences.vala"
	G_OBJECT_CLASS (opponent_parent_class)->finalize (obj);
#line 3682 "preferences.c"
}

static GType
opponent_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (OpponentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) opponent_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Opponent), 0, (GInstanceInitFunc) opponent_instance_init, NULL };
	GType opponent_type_id;
	opponent_type_id = g_type_register_static (G_TYPE_OBJECT, "Opponent", &g_define_type_info, 0);
	Opponent_private_offset = g_type_add_instance_private (opponent_type_id, sizeof (OpponentPrivate));
	return opponent_type_id;
}

GType
opponent_get_type (void)
{
	static volatile gsize opponent_type_id__once = 0;
	if (g_once_init_enter (&opponent_type_id__once)) {
		GType opponent_type_id;
		opponent_type_id = opponent_get_type_once ();
		g_once_init_leave (&opponent_type_id__once, opponent_type_id);
	}
	return opponent_type_id__once;
}

static void
_vala_opponent_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	Opponent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_OPPONENT, Opponent);
#line 517 "../src/preferences.vala"
	switch (property_id) {
#line 517 "../src/preferences.vala"
		case OPPONENT_NAME_PROPERTY:
#line 517 "../src/preferences.vala"
		g_value_set_string (value, opponent_get_name (self));
#line 517 "../src/preferences.vala"
		break;
#line 517 "../src/preferences.vala"
		case OPPONENT_DISPLAY_NAME_PROPERTY:
#line 517 "../src/preferences.vala"
		g_value_set_string (value, opponent_get_display_name (self));
#line 517 "../src/preferences.vala"
		break;
#line 517 "../src/preferences.vala"
		case OPPONENT_IS_HUMAN_PROPERTY:
#line 517 "../src/preferences.vala"
		g_value_set_boolean (value, opponent_get_is_human (self));
#line 517 "../src/preferences.vala"
		break;
#line 3735 "preferences.c"
		default:
#line 517 "../src/preferences.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 517 "../src/preferences.vala"
		break;
#line 3741 "preferences.c"
	}
}

static void
_vala_opponent_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	Opponent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_OPPONENT, Opponent);
#line 517 "../src/preferences.vala"
	switch (property_id) {
#line 517 "../src/preferences.vala"
		case OPPONENT_NAME_PROPERTY:
#line 517 "../src/preferences.vala"
		opponent_set_name (self, g_value_get_string (value));
#line 517 "../src/preferences.vala"
		break;
#line 517 "../src/preferences.vala"
		case OPPONENT_DISPLAY_NAME_PROPERTY:
#line 517 "../src/preferences.vala"
		opponent_set_display_name (self, g_value_get_string (value));
#line 517 "../src/preferences.vala"
		break;
#line 3767 "preferences.c"
		default:
#line 517 "../src/preferences.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 517 "../src/preferences.vala"
		break;
#line 3773 "preferences.c"
	}
}

static inline gpointer
time_limit_get_instance_private (TimeLimit* self)
{
	return G_STRUCT_MEMBER_P (self, TimeLimit_private_offset);
}

TimeLimit*
time_limit_construct (GType object_type,
                      gint duration_in_seconds,
                      gint increment_in_seconds,
                      ClockType clock_type)
{
	TimeLimit* self = NULL;
#line 568 "../src/preferences.vala"
	self = (TimeLimit*) g_type_create_instance (object_type);
#line 570 "../src/preferences.vala"
	g_assert_cmpint (duration_in_seconds, >, 0);
#line 571 "../src/preferences.vala"
	g_assert_cmpint (increment_in_seconds, >=, 0);
#line 572 "../src/preferences.vala"
	time_limit_set_duration_in_seconds (self, duration_in_seconds);
#line 573 "../src/preferences.vala"
	time_limit_set_increment_in_seconds (self, increment_in_seconds);
#line 574 "../src/preferences.vala"
	time_limit_set_clock_type (self, clock_type);
#line 568 "../src/preferences.vala"
	return self;
#line 3804 "preferences.c"
}

TimeLimit*
time_limit_new (gint duration_in_seconds,
                gint increment_in_seconds,
                ClockType clock_type)
{
#line 568 "../src/preferences.vala"
	return time_limit_construct (TYPE_TIME_LIMIT, duration_in_seconds, increment_in_seconds, clock_type);
#line 3814 "preferences.c"
}

void
time_limit_to_settings (TimeLimit* time_limit,
                        gint* duration,
                        gint* increment,
                        gchar** clock_type)
{
	gint _vala_duration = 0;
	gint _vala_increment = 0;
	gchar* _vala_clock_type = NULL;
	gint _tmp1_;
	gint _tmp2_;
#line 579 "../src/preferences.vala"
	if (time_limit == NULL) {
#line 3830 "preferences.c"
		gchar* _tmp0_;
#line 581 "../src/preferences.vala"
		_vala_duration = 0;
#line 582 "../src/preferences.vala"
		_vala_increment = 0;
#line 583 "../src/preferences.vala"
		_tmp0_ = g_strdup ("simple");
#line 583 "../src/preferences.vala"
		_g_free0 (_vala_clock_type);
#line 583 "../src/preferences.vala"
		_vala_clock_type = _tmp0_;
#line 584 "../src/preferences.vala"
		if (duration) {
#line 584 "../src/preferences.vala"
			*duration = _vala_duration;
#line 3846 "preferences.c"
		}
#line 584 "../src/preferences.vala"
		if (increment) {
#line 584 "../src/preferences.vala"
			*increment = _vala_increment;
#line 3852 "preferences.c"
		}
#line 584 "../src/preferences.vala"
		if (clock_type) {
#line 584 "../src/preferences.vala"
			*clock_type = _vala_clock_type;
#line 3858 "preferences.c"
		} else {
#line 584 "../src/preferences.vala"
			_g_free0 (_vala_clock_type);
#line 3862 "preferences.c"
		}
#line 584 "../src/preferences.vala"
		return;
#line 3866 "preferences.c"
	}
#line 587 "../src/preferences.vala"
	_tmp1_ = time_limit->priv->_duration_in_seconds;
#line 587 "../src/preferences.vala"
	_vala_duration = _tmp1_;
#line 588 "../src/preferences.vala"
	_tmp2_ = time_limit->priv->_increment_in_seconds;
#line 588 "../src/preferences.vala"
	_vala_increment = _tmp2_;
#line 590 "../src/preferences.vala"
	if (_vala_increment == 0) {
#line 3878 "preferences.c"
		gchar* _tmp3_;
#line 591 "../src/preferences.vala"
		_tmp3_ = g_strdup ("simple");
#line 591 "../src/preferences.vala"
		_g_free0 (_vala_clock_type);
#line 591 "../src/preferences.vala"
		_vala_clock_type = _tmp3_;
#line 3886 "preferences.c"
	} else {
		ClockType _tmp4_;
		gchar* _tmp5_;
#line 593 "../src/preferences.vala"
		_tmp4_ = time_limit->priv->_clock_type;
#line 593 "../src/preferences.vala"
		_tmp5_ = clock_type_to_setting (_tmp4_);
#line 593 "../src/preferences.vala"
		_g_free0 (_vala_clock_type);
#line 593 "../src/preferences.vala"
		_vala_clock_type = _tmp5_;
#line 3898 "preferences.c"
	}
#line 577 "../src/preferences.vala"
	if (duration) {
#line 577 "../src/preferences.vala"
		*duration = _vala_duration;
#line 3904 "preferences.c"
	}
#line 577 "../src/preferences.vala"
	if (increment) {
#line 577 "../src/preferences.vala"
		*increment = _vala_increment;
#line 3910 "preferences.c"
	}
#line 577 "../src/preferences.vala"
	if (clock_type) {
#line 577 "../src/preferences.vala"
		*clock_type = _vala_clock_type;
#line 3916 "preferences.c"
	} else {
#line 577 "../src/preferences.vala"
		_g_free0 (_vala_clock_type);
#line 3920 "preferences.c"
	}
}

TimeLimit*
time_limit_from_settings (gint duration_setting,
                          gint increment_setting,
                          const gchar* clock_type_setting)
{
	ClockType* clock_type = NULL;
	ClockType* _tmp0_;
	gboolean _tmp1_ = FALSE;
	ClockType* _tmp2_;
	ClockType* _tmp4_;
	TimeLimit* _tmp5_;
	TimeLimit* result;
#line 596 "../src/preferences.vala"
	g_return_val_if_fail (clock_type_setting != NULL, NULL);
#line 598 "../src/preferences.vala"
	if (duration_setting <= 0) {
#line 599 "../src/preferences.vala"
		result = NULL;
#line 599 "../src/preferences.vala"
		return result;
#line 3944 "preferences.c"
	}
#line 601 "../src/preferences.vala"
	_tmp0_ = clock_type_from_setting (clock_type_setting);
#line 601 "../src/preferences.vala"
	clock_type = _tmp0_;
#line 602 "../src/preferences.vala"
	_tmp2_ = clock_type;
#line 602 "../src/preferences.vala"
	if (_tmp2_ == NULL) {
#line 602 "../src/preferences.vala"
		_tmp1_ = TRUE;
#line 3956 "preferences.c"
	} else {
#line 602 "../src/preferences.vala"
		_tmp1_ = increment_setting <= 0;
#line 3960 "preferences.c"
	}
#line 602 "../src/preferences.vala"
	if (_tmp1_) {
#line 3964 "preferences.c"
		TimeLimit* _tmp3_;
#line 603 "../src/preferences.vala"
		_tmp3_ = time_limit_new (duration_setting, 0, CLOCK_TYPE_FISCHER);
#line 603 "../src/preferences.vala"
		result = _tmp3_;
#line 603 "../src/preferences.vala"
		_g_free0 (clock_type);
#line 603 "../src/preferences.vala"
		return result;
#line 3974 "preferences.c"
	}
#line 605 "../src/preferences.vala"
	_tmp4_ = clock_type;
#line 605 "../src/preferences.vala"
	_tmp5_ = time_limit_new (duration_setting, increment_setting, *_tmp4_);
#line 605 "../src/preferences.vala"
	result = _tmp5_;
#line 605 "../src/preferences.vala"
	_g_free0 (clock_type);
#line 605 "../src/preferences.vala"
	return result;
#line 3986 "preferences.c"
}

gint
time_limit_get_duration_in_seconds (TimeLimit* self)
{
	gint result;
#line 564 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 564 "../src/preferences.vala"
	result = self->priv->_duration_in_seconds;
#line 564 "../src/preferences.vala"
	return result;
#line 3999 "preferences.c"
}

static void
time_limit_set_duration_in_seconds (TimeLimit* self,
                                    gint value)
{
#line 564 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 564 "../src/preferences.vala"
	self->priv->_duration_in_seconds = value;
#line 4010 "preferences.c"
}

gint
time_limit_get_increment_in_seconds (TimeLimit* self)
{
	gint result;
#line 565 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 565 "../src/preferences.vala"
	result = self->priv->_increment_in_seconds;
#line 565 "../src/preferences.vala"
	return result;
#line 4023 "preferences.c"
}

static void
time_limit_set_increment_in_seconds (TimeLimit* self,
                                     gint value)
{
#line 565 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 565 "../src/preferences.vala"
	self->priv->_increment_in_seconds = value;
#line 4034 "preferences.c"
}

ClockType
time_limit_get_clock_type (TimeLimit* self)
{
	ClockType result;
#line 566 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 566 "../src/preferences.vala"
	result = self->priv->_clock_type;
#line 566 "../src/preferences.vala"
	return result;
#line 4047 "preferences.c"
}

static void
time_limit_set_clock_type (TimeLimit* self,
                           ClockType value)
{
#line 566 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 566 "../src/preferences.vala"
	self->priv->_clock_type = value;
#line 4058 "preferences.c"
}

static void
value_time_limit_init (GValue* value)
{
#line 562 "../src/preferences.vala"
	value->data[0].v_pointer = NULL;
#line 4066 "preferences.c"
}

static void
value_time_limit_free_value (GValue* value)
{
#line 562 "../src/preferences.vala"
	if (value->data[0].v_pointer) {
#line 562 "../src/preferences.vala"
		time_limit_unref (value->data[0].v_pointer);
#line 4076 "preferences.c"
	}
}

static void
value_time_limit_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 562 "../src/preferences.vala"
	if (src_value->data[0].v_pointer) {
#line 562 "../src/preferences.vala"
		dest_value->data[0].v_pointer = time_limit_ref (src_value->data[0].v_pointer);
#line 4088 "preferences.c"
	} else {
#line 562 "../src/preferences.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4092 "preferences.c"
	}
}

static gpointer
value_time_limit_peek_pointer (const GValue* value)
{
#line 562 "../src/preferences.vala"
	return value->data[0].v_pointer;
#line 4101 "preferences.c"
}

static gchar*
value_time_limit_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 562 "../src/preferences.vala"
	if (collect_values[0].v_pointer) {
#line 4112 "preferences.c"
		TimeLimit * object;
		object = collect_values[0].v_pointer;
#line 562 "../src/preferences.vala"
		if (object->parent_instance.g_class == NULL) {
#line 562 "../src/preferences.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4119 "preferences.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 562 "../src/preferences.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4123 "preferences.c"
		}
#line 562 "../src/preferences.vala"
		value->data[0].v_pointer = time_limit_ref (object);
#line 4127 "preferences.c"
	} else {
#line 562 "../src/preferences.vala"
		value->data[0].v_pointer = NULL;
#line 4131 "preferences.c"
	}
#line 562 "../src/preferences.vala"
	return NULL;
#line 4135 "preferences.c"
}

static gchar*
value_time_limit_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	TimeLimit ** object_p;
	object_p = collect_values[0].v_pointer;
#line 562 "../src/preferences.vala"
	if (!object_p) {
#line 562 "../src/preferences.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4150 "preferences.c"
	}
#line 562 "../src/preferences.vala"
	if (!value->data[0].v_pointer) {
#line 562 "../src/preferences.vala"
		*object_p = NULL;
#line 4156 "preferences.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 562 "../src/preferences.vala"
		*object_p = value->data[0].v_pointer;
#line 4160 "preferences.c"
	} else {
#line 562 "../src/preferences.vala"
		*object_p = time_limit_ref (value->data[0].v_pointer);
#line 4164 "preferences.c"
	}
#line 562 "../src/preferences.vala"
	return NULL;
#line 4168 "preferences.c"
}

GParamSpec*
param_spec_time_limit (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecTimeLimit* spec;
#line 562 "../src/preferences.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TIME_LIMIT), NULL);
#line 562 "../src/preferences.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 562 "../src/preferences.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 562 "../src/preferences.vala"
	return G_PARAM_SPEC (spec);
#line 4187 "preferences.c"
}

gpointer
value_get_time_limit (const GValue* value)
{
#line 562 "../src/preferences.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIME_LIMIT), NULL);
#line 562 "../src/preferences.vala"
	return value->data[0].v_pointer;
#line 4197 "preferences.c"
}

void
value_set_time_limit (GValue* value,
                      gpointer v_object)
{
	TimeLimit * old;
#line 562 "../src/preferences.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIME_LIMIT));
#line 562 "../src/preferences.vala"
	old = value->data[0].v_pointer;
#line 562 "../src/preferences.vala"
	if (v_object) {
#line 562 "../src/preferences.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TIME_LIMIT));
#line 562 "../src/preferences.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 562 "../src/preferences.vala"
		value->data[0].v_pointer = v_object;
#line 562 "../src/preferences.vala"
		time_limit_ref (value->data[0].v_pointer);
#line 4219 "preferences.c"
	} else {
#line 562 "../src/preferences.vala"
		value->data[0].v_pointer = NULL;
#line 4223 "preferences.c"
	}
#line 562 "../src/preferences.vala"
	if (old) {
#line 562 "../src/preferences.vala"
		time_limit_unref (old);
#line 4229 "preferences.c"
	}
}

void
value_take_time_limit (GValue* value,
                       gpointer v_object)
{
	TimeLimit * old;
#line 562 "../src/preferences.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIME_LIMIT));
#line 562 "../src/preferences.vala"
	old = value->data[0].v_pointer;
#line 562 "../src/preferences.vala"
	if (v_object) {
#line 562 "../src/preferences.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TIME_LIMIT));
#line 562 "../src/preferences.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 562 "../src/preferences.vala"
		value->data[0].v_pointer = v_object;
#line 4250 "preferences.c"
	} else {
#line 562 "../src/preferences.vala"
		value->data[0].v_pointer = NULL;
#line 4254 "preferences.c"
	}
#line 562 "../src/preferences.vala"
	if (old) {
#line 562 "../src/preferences.vala"
		time_limit_unref (old);
#line 4260 "preferences.c"
	}
}

static void
time_limit_class_init (TimeLimitClass * klass,
                       gpointer klass_data)
{
#line 562 "../src/preferences.vala"
	time_limit_parent_class = g_type_class_peek_parent (klass);
#line 562 "../src/preferences.vala"
	((TimeLimitClass *) klass)->finalize = time_limit_finalize;
#line 562 "../src/preferences.vala"
	g_type_class_adjust_private_offset (klass, &TimeLimit_private_offset);
#line 4274 "preferences.c"
}

static void
time_limit_instance_init (TimeLimit * self,
                          gpointer klass)
{
#line 562 "../src/preferences.vala"
	self->priv = time_limit_get_instance_private (self);
#line 562 "../src/preferences.vala"
	self->ref_count = 1;
#line 4285 "preferences.c"
}

static void
time_limit_finalize (TimeLimit * obj)
{
	TimeLimit * self;
#line 562 "../src/preferences.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIME_LIMIT, TimeLimit);
#line 562 "../src/preferences.vala"
	g_signal_handlers_destroy (self);
#line 4296 "preferences.c"
}

static GType
time_limit_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_time_limit_init, value_time_limit_free_value, value_time_limit_copy_value, value_time_limit_peek_pointer, "p", value_time_limit_collect_value, "p", value_time_limit_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TimeLimitClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) time_limit_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimeLimit), 0, (GInstanceInitFunc) time_limit_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType time_limit_type_id;
	time_limit_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TimeLimit", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TimeLimit_private_offset = g_type_add_instance_private (time_limit_type_id, sizeof (TimeLimitPrivate));
	return time_limit_type_id;
}

GType
time_limit_get_type (void)
{
	static volatile gsize time_limit_type_id__once = 0;
	if (g_once_init_enter (&time_limit_type_id__once)) {
		GType time_limit_type_id;
		time_limit_type_id = time_limit_get_type_once ();
		g_once_init_leave (&time_limit_type_id__once, time_limit_type_id);
	}
	return time_limit_type_id__once;
}

gpointer
time_limit_ref (gpointer instance)
{
	TimeLimit * self;
	self = instance;
#line 562 "../src/preferences.vala"
	g_atomic_int_inc (&self->ref_count);
#line 562 "../src/preferences.vala"
	return instance;
#line 4332 "preferences.c"
}

void
time_limit_unref (gpointer instance)
{
	TimeLimit * self;
	self = instance;
#line 562 "../src/preferences.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 562 "../src/preferences.vala"
		TIME_LIMIT_GET_CLASS (self)->finalize (self);
#line 562 "../src/preferences.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4346 "preferences.c"
	}
}

