/* chess-state.c generated by valac 0.56.18, the Vala compiler
 * generated from chess-state.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include "libchess.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CHESS_STATE_0_PROPERTY,
	CHESS_STATE_OPPONENT_PROPERTY,
	CHESS_STATE_NUM_PROPERTIES
};
static GParamSpec* chess_state_properties[CHESS_STATE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _ChessStatePrivate {
	guint64 piece_masks[2];
};

static gint ChessState_private_offset;
static gpointer chess_state_parent_class = NULL;

static ChessState* chess_state_new_empty (void);
static ChessState* chess_state_construct_empty (GType object_type);
static gboolean chess_state_decode_piece_type (ChessState* self,
                                        gunichar c,
                                        PieceType* type);
static CheckState chess_state_get_check_state (ChessState* self,
                                        ChessPlayer* player);
static gboolean chess_state_decode_move (ChessState* self,
                                  ChessPlayer* player,
                                  const gchar* move,
                                  gint* r0,
                                  gint* f0,
                                  gint* r1,
                                  gint* f1,
                                  PieceType* promotion_type);
static gboolean chess_state_is_in_checkmate (ChessState* self,
                                      ChessPlayer* player);
static void _vala_array_add1 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_array_add2 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static gint* _vala_array_dup1 (gint* self,
                        gssize length);
static gint* _vala_array_dup2 (gint* self,
                        gssize length);
static void chess_state_finalize (GObject * obj);
static GType chess_state_get_type_once (void);
static void _vala_chess_state_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const guint64 BIT_BOARD_set_location_masks[64];
VALA_EXTERN const guint64 BIT_BOARD_move_masks[768];
VALA_EXTERN const guint64 BIT_BOARD_over_masks[4096];
VALA_EXTERN const guint64 BIT_BOARD_clear_location_masks[64];

static GType
check_state_get_type_once (void)
{
	static const GEnumValue values[] = {{CHECK_STATE_NONE, "CHECK_STATE_NONE", "none"}, {CHECK_STATE_CHECK, "CHECK_STATE_CHECK", "check"}, {CHECK_STATE_CHECKMATE, "CHECK_STATE_CHECKMATE", "checkmate"}, {0, NULL, NULL}};
	GType check_state_type_id;
	check_state_type_id = g_enum_register_static ("CheckState", values);
	return check_state_type_id;
}

GType
check_state_get_type (void)
{
	static volatile gsize check_state_type_id__once = 0;
	if (g_once_init_enter (&check_state_type_id__once)) {
		GType check_state_type_id;
		check_state_type_id = check_state_get_type_once ();
		g_once_init_leave (&check_state_type_id__once, check_state_type_id);
	}
	return check_state_type_id__once;
}

static inline gpointer
chess_state_get_instance_private (ChessState* self)
{
	return G_STRUCT_MEMBER_P (self, ChessState_private_offset);
}

static ChessState*
chess_state_construct_empty (GType object_type)
{
	ChessState * self = NULL;
#line 41 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 41 "../lib/chess-state.vala"
	return self;
#line 134 "chess-state.c"
}

static ChessState*
chess_state_new_empty (void)
{
#line 41 "../lib/chess-state.vala"
	return chess_state_construct_empty (TYPE_CHESS_STATE);
#line 142 "chess-state.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 159 "chess-state.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../lib/chess-state.vala"
	return self ? g_object_ref (self) : NULL;
#line 167 "chess-state.c"
}

ChessState*
chess_state_construct (GType object_type,
                       const gchar* fen)
{
	ChessState * self = NULL;
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	gchar** fields = NULL;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint fields_length1;
	gint _fields_size_;
	gchar** ranks = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint ranks_length1;
	gint _ranks_size_;
	gchar** _tmp31_;
	gint _tmp31__length1;
	const gchar* _tmp32_;
	gchar** _tmp39_;
	gint _tmp39__length1;
	const gchar* _tmp40_;
	gchar** _tmp49_;
	gint _tmp49__length1;
	const gchar* _tmp50_;
	gchar** _tmp55_;
	gint _tmp55__length1;
	const gchar* _tmp56_;
	gchar** _tmp57_;
	gint _tmp57__length1;
	const gchar* _tmp58_;
	ChessPlayer* _tmp59_;
	ChessPlayer* _tmp61_;
#line 46 "../lib/chess-state.vala"
	g_return_val_if_fail (fen != NULL, NULL);
#line 46 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 48 "../lib/chess-state.vala"
	_tmp0_ = chess_player_new (COLOR_WHITE);
#line 48 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_WHITE]);
#line 48 "../lib/chess-state.vala"
	self->players[COLOR_WHITE] = _tmp0_;
#line 49 "../lib/chess-state.vala"
	_tmp1_ = chess_player_new (COLOR_BLACK);
#line 49 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_BLACK]);
#line 49 "../lib/chess-state.vala"
	self->players[COLOR_BLACK] = _tmp1_;
#line 223 "chess-state.c"
	{
		gint i = 0;
#line 50 "../lib/chess-state.vala"
		i = 0;
#line 228 "chess-state.c"
		{
			gboolean _tmp2_ = FALSE;
#line 50 "../lib/chess-state.vala"
			_tmp2_ = TRUE;
#line 50 "../lib/chess-state.vala"
			while (TRUE) {
#line 50 "../lib/chess-state.vala"
				if (!_tmp2_) {
#line 237 "chess-state.c"
					gint _tmp3_;
#line 50 "../lib/chess-state.vala"
					_tmp3_ = i;
#line 50 "../lib/chess-state.vala"
					i = _tmp3_ + 1;
#line 243 "chess-state.c"
				}
#line 50 "../lib/chess-state.vala"
				_tmp2_ = FALSE;
#line 50 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 50 "../lib/chess-state.vala"
					break;
#line 251 "chess-state.c"
				}
#line 51 "../lib/chess-state.vala"
				_g_object_unref0 (self->board[i]);
#line 51 "../lib/chess-state.vala"
				self->board[i] = NULL;
#line 257 "chess-state.c"
			}
		}
	}
#line 53 "../lib/chess-state.vala"
	_tmp5_ = _tmp4_ = g_strsplit (fen, " ", 0);
#line 53 "../lib/chess-state.vala"
	fields = _tmp5_;
#line 53 "../lib/chess-state.vala"
	fields_length1 = _vala_array_length (_tmp4_);
#line 53 "../lib/chess-state.vala"
	_fields_size_ = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp6_ = fields;
#line 58 "../lib/chess-state.vala"
	_tmp6__length1 = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp7_ = _tmp6_[0];
#line 58 "../lib/chess-state.vala"
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "/", 0);
#line 58 "../lib/chess-state.vala"
	ranks = _tmp9_;
#line 58 "../lib/chess-state.vala"
	ranks_length1 = _vala_array_length (_tmp8_);
#line 58 "../lib/chess-state.vala"
	_ranks_size_ = ranks_length1;
#line 283 "chess-state.c"
	{
		gint rank = 0;
#line 61 "../lib/chess-state.vala"
		rank = 0;
#line 288 "chess-state.c"
		{
			gboolean _tmp10_ = FALSE;
#line 61 "../lib/chess-state.vala"
			_tmp10_ = TRUE;
#line 61 "../lib/chess-state.vala"
			while (TRUE) {
#line 295 "chess-state.c"
				gchar* rank_string = NULL;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 61 "../lib/chess-state.vala"
				if (!_tmp10_) {
#line 303 "chess-state.c"
					gint _tmp11_;
#line 61 "../lib/chess-state.vala"
					_tmp11_ = rank;
#line 61 "../lib/chess-state.vala"
					rank = _tmp11_ + 1;
#line 309 "chess-state.c"
				}
#line 61 "../lib/chess-state.vala"
				_tmp10_ = FALSE;
#line 61 "../lib/chess-state.vala"
				if (!(rank < 8)) {
#line 61 "../lib/chess-state.vala"
					break;
#line 317 "chess-state.c"
				}
#line 63 "../lib/chess-state.vala"
				_tmp12_ = ranks;
#line 63 "../lib/chess-state.vala"
				_tmp12__length1 = ranks_length1;
#line 63 "../lib/chess-state.vala"
				_tmp13_ = _tmp12_[7 - rank];
#line 63 "../lib/chess-state.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 63 "../lib/chess-state.vala"
				rank_string = _tmp14_;
#line 329 "chess-state.c"
				{
					gint file = 0;
					gint offset = 0;
#line 64 "../lib/chess-state.vala"
					file = 0;
#line 64 "../lib/chess-state.vala"
					offset = 0;
#line 337 "chess-state.c"
					{
						gboolean _tmp15_ = FALSE;
#line 64 "../lib/chess-state.vala"
						_tmp15_ = TRUE;
#line 64 "../lib/chess-state.vala"
						while (TRUE) {
#line 344 "chess-state.c"
							gboolean _tmp17_ = FALSE;
							gchar c = '\0';
							const gchar* _tmp21_;
							gboolean _tmp22_ = FALSE;
							PieceType type = 0;
							Color _tmp23_ = 0;
							Color color = 0;
							PieceType _tmp24_ = 0;
							gint index = 0;
							ChessPiece* piece = NULL;
							ChessPlayer* _tmp25_;
							ChessPiece* _tmp26_;
							ChessPiece* _tmp27_;
							ChessPiece* _tmp28_;
							guint64 mask = 0ULL;
							guint64 _tmp29_;
							gint _tmp30_;
#line 64 "../lib/chess-state.vala"
							if (!_tmp15_) {
#line 364 "chess-state.c"
								gint _tmp16_;
#line 64 "../lib/chess-state.vala"
								_tmp16_ = offset;
#line 64 "../lib/chess-state.vala"
								offset = _tmp16_ + 1;
#line 370 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							_tmp15_ = FALSE;
#line 64 "../lib/chess-state.vala"
							if (file < 8) {
#line 376 "chess-state.c"
								const gchar* _tmp18_;
								gint _tmp19_;
								gint _tmp20_;
#line 64 "../lib/chess-state.vala"
								_tmp18_ = rank_string;
#line 64 "../lib/chess-state.vala"
								_tmp19_ = strlen (_tmp18_);
#line 64 "../lib/chess-state.vala"
								_tmp20_ = _tmp19_;
#line 64 "../lib/chess-state.vala"
								_tmp17_ = offset < _tmp20_;
#line 388 "chess-state.c"
							} else {
#line 64 "../lib/chess-state.vala"
								_tmp17_ = FALSE;
#line 392 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							if (!_tmp17_) {
#line 64 "../lib/chess-state.vala"
								break;
#line 398 "chess-state.c"
							}
#line 66 "../lib/chess-state.vala"
							_tmp21_ = rank_string;
#line 66 "../lib/chess-state.vala"
							c = string_get (_tmp21_, (glong) offset);
#line 67 "../lib/chess-state.vala"
							if (c >= '1') {
#line 67 "../lib/chess-state.vala"
								_tmp22_ = c <= '8';
#line 408 "chess-state.c"
							} else {
#line 67 "../lib/chess-state.vala"
								_tmp22_ = FALSE;
#line 412 "chess-state.c"
							}
#line 67 "../lib/chess-state.vala"
							if (_tmp22_) {
#line 69 "../lib/chess-state.vala"
								file += (gint) (c - '0');
#line 70 "../lib/chess-state.vala"
								continue;
#line 420 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							if (g_ascii_isupper (c)) {
#line 74 "../lib/chess-state.vala"
								_tmp23_ = COLOR_WHITE;
#line 426 "chess-state.c"
							} else {
#line 74 "../lib/chess-state.vala"
								_tmp23_ = COLOR_BLACK;
#line 430 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							color = _tmp23_;
#line 75 "../lib/chess-state.vala"
							chess_state_decode_piece_type (self, (gunichar) g_ascii_toupper (c), &_tmp24_);
#line 75 "../lib/chess-state.vala"
							type = _tmp24_;
#line 78 "../lib/chess-state.vala"
							index = chess_state_get_index (self, rank, file);
#line 79 "../lib/chess-state.vala"
							_tmp25_ = self->players[color];
#line 79 "../lib/chess-state.vala"
							_tmp26_ = chess_piece_new (_tmp25_, type);
#line 79 "../lib/chess-state.vala"
							piece = _tmp26_;
#line 80 "../lib/chess-state.vala"
							_tmp27_ = piece;
#line 80 "../lib/chess-state.vala"
							_tmp28_ = _g_object_ref0 (_tmp27_);
#line 80 "../lib/chess-state.vala"
							_g_object_unref0 (self->board[index]);
#line 80 "../lib/chess-state.vala"
							self->board[index] = _tmp28_;
#line 81 "../lib/chess-state.vala"
							_tmp29_ = BIT_BOARD_set_location_masks[index];
#line 81 "../lib/chess-state.vala"
							mask = _tmp29_;
#line 82 "../lib/chess-state.vala"
							self->priv->piece_masks[color] |= mask;
#line 83 "../lib/chess-state.vala"
							_tmp30_ = file;
#line 83 "../lib/chess-state.vala"
							file = _tmp30_ + 1;
#line 64 "../lib/chess-state.vala"
							_g_object_unref0 (piece);
#line 466 "chess-state.c"
						}
					}
				}
#line 61 "../lib/chess-state.vala"
				_g_free0 (rank_string);
#line 472 "chess-state.c"
			}
		}
	}
#line 88 "../lib/chess-state.vala"
	_tmp31_ = fields;
#line 88 "../lib/chess-state.vala"
	_tmp31__length1 = fields_length1;
#line 88 "../lib/chess-state.vala"
	_tmp32_ = _tmp31_[1];
#line 88 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp32_, "w") == 0) {
#line 484 "chess-state.c"
		ChessPlayer* _tmp33_;
		ChessPlayer* _tmp34_;
#line 89 "../lib/chess-state.vala"
		_tmp33_ = self->players[COLOR_WHITE];
#line 89 "../lib/chess-state.vala"
		_tmp34_ = _g_object_ref0 (_tmp33_);
#line 89 "../lib/chess-state.vala"
		_g_object_unref0 (self->current_player);
#line 89 "../lib/chess-state.vala"
		self->current_player = _tmp34_;
#line 495 "chess-state.c"
	} else {
		gchar** _tmp35_;
		gint _tmp35__length1;
		const gchar* _tmp36_;
#line 90 "../lib/chess-state.vala"
		_tmp35_ = fields;
#line 90 "../lib/chess-state.vala"
		_tmp35__length1 = fields_length1;
#line 90 "../lib/chess-state.vala"
		_tmp36_ = _tmp35_[1];
#line 90 "../lib/chess-state.vala"
		if (g_strcmp0 (_tmp36_, "b") == 0) {
#line 508 "chess-state.c"
			ChessPlayer* _tmp37_;
			ChessPlayer* _tmp38_;
#line 91 "../lib/chess-state.vala"
			_tmp37_ = self->players[COLOR_BLACK];
#line 91 "../lib/chess-state.vala"
			_tmp38_ = _g_object_ref0 (_tmp37_);
#line 91 "../lib/chess-state.vala"
			_g_object_unref0 (self->current_player);
#line 91 "../lib/chess-state.vala"
			self->current_player = _tmp38_;
#line 519 "chess-state.c"
		}
	}
#line 96 "../lib/chess-state.vala"
	_tmp39_ = fields;
#line 96 "../lib/chess-state.vala"
	_tmp39__length1 = fields_length1;
#line 96 "../lib/chess-state.vala"
	_tmp40_ = _tmp39_[2];
#line 96 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp40_, "-") != 0) {
#line 530 "chess-state.c"
		{
			gint i = 0;
#line 98 "../lib/chess-state.vala"
			i = 0;
#line 535 "chess-state.c"
			{
				gboolean _tmp41_ = FALSE;
#line 98 "../lib/chess-state.vala"
				_tmp41_ = TRUE;
#line 98 "../lib/chess-state.vala"
				while (TRUE) {
#line 542 "chess-state.c"
					gchar** _tmp43_;
					gint _tmp43__length1;
					const gchar* _tmp44_;
					gint _tmp45_;
					gint _tmp46_;
					gchar c = '\0';
					gchar** _tmp47_;
					gint _tmp47__length1;
					const gchar* _tmp48_;
#line 98 "../lib/chess-state.vala"
					if (!_tmp41_) {
#line 554 "chess-state.c"
						gint _tmp42_;
#line 98 "../lib/chess-state.vala"
						_tmp42_ = i;
#line 98 "../lib/chess-state.vala"
						i = _tmp42_ + 1;
#line 560 "chess-state.c"
					}
#line 98 "../lib/chess-state.vala"
					_tmp41_ = FALSE;
#line 98 "../lib/chess-state.vala"
					_tmp43_ = fields;
#line 98 "../lib/chess-state.vala"
					_tmp43__length1 = fields_length1;
#line 98 "../lib/chess-state.vala"
					_tmp44_ = _tmp43_[2];
#line 98 "../lib/chess-state.vala"
					_tmp45_ = strlen (_tmp44_);
#line 98 "../lib/chess-state.vala"
					_tmp46_ = _tmp45_;
#line 98 "../lib/chess-state.vala"
					if (!(i < _tmp46_)) {
#line 98 "../lib/chess-state.vala"
						break;
#line 578 "chess-state.c"
					}
#line 100 "../lib/chess-state.vala"
					_tmp47_ = fields;
#line 100 "../lib/chess-state.vala"
					_tmp47__length1 = fields_length1;
#line 100 "../lib/chess-state.vala"
					_tmp48_ = _tmp47_[2];
#line 100 "../lib/chess-state.vala"
					c = string_get (_tmp48_, (glong) i);
#line 101 "../lib/chess-state.vala"
					if (c == 'K') {
#line 102 "../lib/chess-state.vala"
						self->can_castle_kingside[COLOR_WHITE] = TRUE;
#line 592 "chess-state.c"
					} else {
#line 103 "../lib/chess-state.vala"
						if (c == 'Q') {
#line 104 "../lib/chess-state.vala"
							self->can_castle_queenside[COLOR_WHITE] = TRUE;
#line 598 "chess-state.c"
						} else {
#line 105 "../lib/chess-state.vala"
							if (c == 'k') {
#line 106 "../lib/chess-state.vala"
								self->can_castle_kingside[COLOR_BLACK] = TRUE;
#line 604 "chess-state.c"
							} else {
#line 107 "../lib/chess-state.vala"
								if (c == 'q') {
#line 108 "../lib/chess-state.vala"
									self->can_castle_queenside[COLOR_BLACK] = TRUE;
#line 610 "chess-state.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 115 "../lib/chess-state.vala"
	_tmp49_ = fields;
#line 115 "../lib/chess-state.vala"
	_tmp49__length1 = fields_length1;
#line 115 "../lib/chess-state.vala"
	_tmp50_ = _tmp49_[3];
#line 115 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp50_, "-") != 0) {
#line 627 "chess-state.c"
		gchar** _tmp51_;
		gint _tmp51__length1;
		const gchar* _tmp52_;
		gchar** _tmp53_;
		gint _tmp53__length1;
		const gchar* _tmp54_;
#line 119 "../lib/chess-state.vala"
		_tmp51_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp51__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp52_ = _tmp51_[3];
#line 119 "../lib/chess-state.vala"
		_tmp53_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp53__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp54_ = _tmp53_[3];
#line 119 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (gint) (string_get (_tmp52_, (glong) 1) - '1'), (gint) (string_get (_tmp54_, (glong) 0) - 'a'));
#line 648 "chess-state.c"
	}
#line 123 "../lib/chess-state.vala"
	_tmp55_ = fields;
#line 123 "../lib/chess-state.vala"
	_tmp55__length1 = fields_length1;
#line 123 "../lib/chess-state.vala"
	_tmp56_ = _tmp55_[4];
#line 123 "../lib/chess-state.vala"
	self->halfmove_clock = atoi (_tmp56_);
#line 126 "../lib/chess-state.vala"
	_tmp57_ = fields;
#line 126 "../lib/chess-state.vala"
	_tmp57__length1 = fields_length1;
#line 126 "../lib/chess-state.vala"
	_tmp58_ = _tmp57_[5];
#line 126 "../lib/chess-state.vala"
	self->number = (atoi (_tmp58_) - 1) * 2;
#line 127 "../lib/chess-state.vala"
	_tmp59_ = self->current_player;
#line 127 "../lib/chess-state.vala"
	if (_tmp59_->color == COLOR_BLACK) {
#line 670 "chess-state.c"
		gint _tmp60_;
#line 128 "../lib/chess-state.vala"
		_tmp60_ = self->number;
#line 128 "../lib/chess-state.vala"
		self->number = _tmp60_ + 1;
#line 676 "chess-state.c"
	}
#line 130 "../lib/chess-state.vala"
	_tmp61_ = self->current_player;
#line 130 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp61_);
#line 46 "../lib/chess-state.vala"
	ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	return self;
#line 688 "chess-state.c"
}

ChessState*
chess_state_new (const gchar* fen)
{
#line 46 "../lib/chess-state.vala"
	return chess_state_construct (TYPE_CHESS_STATE, fen);
#line 696 "chess-state.c"
}

ChessState*
chess_state_copy (ChessState* self)
{
	ChessState* state = NULL;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	ChessState* _tmp2_;
	ChessPlayer* _tmp3_;
	ChessPlayer* _tmp4_;
	ChessState* _tmp5_;
	ChessPlayer* _tmp6_;
	ChessPlayer* _tmp7_;
	ChessState* _tmp8_;
	ChessPlayer* _tmp9_;
	ChessPlayer* _tmp10_;
	ChessState* _tmp11_;
	gboolean _tmp12_;
	ChessState* _tmp13_;
	gboolean _tmp14_;
	ChessState* _tmp15_;
	gboolean _tmp16_;
	ChessState* _tmp17_;
	gboolean _tmp18_;
	ChessState* _tmp19_;
	ChessState* _tmp20_;
	ChessMove* _tmp21_;
	ChessState* _tmp30_;
	guint64 _tmp31_;
	ChessState* _tmp32_;
	guint64 _tmp33_;
	ChessState* _tmp34_;
	ChessState* result;
#line 133 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../lib/chess-state.vala"
	_tmp0_ = chess_state_new_empty ();
#line 135 "../lib/chess-state.vala"
	state = _tmp0_;
#line 137 "../lib/chess-state.vala"
	_tmp1_ = state;
#line 137 "../lib/chess-state.vala"
	_tmp1_->number = self->number;
#line 138 "../lib/chess-state.vala"
	_tmp2_ = state;
#line 138 "../lib/chess-state.vala"
	_tmp3_ = self->players[COLOR_WHITE];
#line 138 "../lib/chess-state.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 138 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp2_->players[COLOR_WHITE]);
#line 138 "../lib/chess-state.vala"
	_tmp2_->players[COLOR_WHITE] = _tmp4_;
#line 139 "../lib/chess-state.vala"
	_tmp5_ = state;
#line 139 "../lib/chess-state.vala"
	_tmp6_ = self->players[COLOR_BLACK];
#line 139 "../lib/chess-state.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 139 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp5_->players[COLOR_BLACK]);
#line 139 "../lib/chess-state.vala"
	_tmp5_->players[COLOR_BLACK] = _tmp7_;
#line 140 "../lib/chess-state.vala"
	_tmp8_ = state;
#line 140 "../lib/chess-state.vala"
	_tmp9_ = self->current_player;
#line 140 "../lib/chess-state.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 140 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp8_->current_player);
#line 140 "../lib/chess-state.vala"
	_tmp8_->current_player = _tmp10_;
#line 141 "../lib/chess-state.vala"
	_tmp11_ = state;
#line 141 "../lib/chess-state.vala"
	_tmp12_ = self->can_castle_kingside[COLOR_WHITE];
#line 141 "../lib/chess-state.vala"
	_tmp11_->can_castle_kingside[COLOR_WHITE] = _tmp12_;
#line 142 "../lib/chess-state.vala"
	_tmp13_ = state;
#line 142 "../lib/chess-state.vala"
	_tmp14_ = self->can_castle_queenside[COLOR_WHITE];
#line 142 "../lib/chess-state.vala"
	_tmp13_->can_castle_queenside[COLOR_WHITE] = _tmp14_;
#line 143 "../lib/chess-state.vala"
	_tmp15_ = state;
#line 143 "../lib/chess-state.vala"
	_tmp16_ = self->can_castle_kingside[COLOR_BLACK];
#line 143 "../lib/chess-state.vala"
	_tmp15_->can_castle_kingside[COLOR_BLACK] = _tmp16_;
#line 144 "../lib/chess-state.vala"
	_tmp17_ = state;
#line 144 "../lib/chess-state.vala"
	_tmp18_ = self->can_castle_queenside[COLOR_BLACK];
#line 144 "../lib/chess-state.vala"
	_tmp17_->can_castle_queenside[COLOR_BLACK] = _tmp18_;
#line 145 "../lib/chess-state.vala"
	_tmp19_ = state;
#line 145 "../lib/chess-state.vala"
	_tmp19_->en_passant_index = self->en_passant_index;
#line 146 "../lib/chess-state.vala"
	_tmp20_ = state;
#line 146 "../lib/chess-state.vala"
	_tmp20_->check_state = self->check_state;
#line 147 "../lib/chess-state.vala"
	_tmp21_ = self->last_move;
#line 147 "../lib/chess-state.vala"
	if (_tmp21_ != NULL) {
#line 807 "chess-state.c"
		ChessState* _tmp22_;
		ChessMove* _tmp23_;
		ChessMove* _tmp24_;
#line 148 "../lib/chess-state.vala"
		_tmp22_ = state;
#line 148 "../lib/chess-state.vala"
		_tmp23_ = self->last_move;
#line 148 "../lib/chess-state.vala"
		_tmp24_ = chess_move_copy (_tmp23_);
#line 148 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp22_->last_move);
#line 148 "../lib/chess-state.vala"
		_tmp22_->last_move = _tmp24_;
#line 821 "chess-state.c"
	}
	{
		gint i = 0;
#line 149 "../lib/chess-state.vala"
		i = 0;
#line 827 "chess-state.c"
		{
			gboolean _tmp25_ = FALSE;
#line 149 "../lib/chess-state.vala"
			_tmp25_ = TRUE;
#line 149 "../lib/chess-state.vala"
			while (TRUE) {
#line 834 "chess-state.c"
				ChessState* _tmp27_;
				ChessPiece* _tmp28_;
				ChessPiece* _tmp29_;
#line 149 "../lib/chess-state.vala"
				if (!_tmp25_) {
#line 840 "chess-state.c"
					gint _tmp26_;
#line 149 "../lib/chess-state.vala"
					_tmp26_ = i;
#line 149 "../lib/chess-state.vala"
					i = _tmp26_ + 1;
#line 846 "chess-state.c"
				}
#line 149 "../lib/chess-state.vala"
				_tmp25_ = FALSE;
#line 149 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 149 "../lib/chess-state.vala"
					break;
#line 854 "chess-state.c"
				}
#line 150 "../lib/chess-state.vala"
				_tmp27_ = state;
#line 150 "../lib/chess-state.vala"
				_tmp28_ = self->board[i];
#line 150 "../lib/chess-state.vala"
				_tmp29_ = _g_object_ref0 (_tmp28_);
#line 150 "../lib/chess-state.vala"
				_g_object_unref0 (_tmp27_->board[i]);
#line 150 "../lib/chess-state.vala"
				_tmp27_->board[i] = _tmp29_;
#line 866 "chess-state.c"
			}
		}
	}
#line 151 "../lib/chess-state.vala"
	_tmp30_ = state;
#line 151 "../lib/chess-state.vala"
	_tmp31_ = self->priv->piece_masks[COLOR_WHITE];
#line 151 "../lib/chess-state.vala"
	_tmp30_->priv->piece_masks[COLOR_WHITE] = _tmp31_;
#line 152 "../lib/chess-state.vala"
	_tmp32_ = state;
#line 152 "../lib/chess-state.vala"
	_tmp33_ = self->priv->piece_masks[COLOR_BLACK];
#line 152 "../lib/chess-state.vala"
	_tmp32_->priv->piece_masks[COLOR_BLACK] = _tmp33_;
#line 153 "../lib/chess-state.vala"
	_tmp34_ = state;
#line 153 "../lib/chess-state.vala"
	_tmp34_->halfmove_clock = self->halfmove_clock;
#line 155 "../lib/chess-state.vala"
	result = state;
#line 155 "../lib/chess-state.vala"
	return result;
#line 890 "chess-state.c"
}

gboolean
chess_state_equals (ChessState* self,
                    ChessState* state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	guint64 _tmp7_;
	guint64 _tmp8_;
	gboolean result;
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 168 "../lib/chess-state.vala"
	_tmp7_ = self->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	_tmp8_ = state->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	if (_tmp7_ != _tmp8_) {
#line 168 "../lib/chess-state.vala"
		_tmp6_ = TRUE;
#line 919 "chess-state.c"
	} else {
		guint64 _tmp9_;
		guint64 _tmp10_;
#line 169 "../lib/chess-state.vala"
		_tmp9_ = self->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp10_ = state->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp6_ = _tmp9_ != _tmp10_;
#line 929 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp6_) {
#line 168 "../lib/chess-state.vala"
		_tmp5_ = TRUE;
#line 935 "chess-state.c"
	} else {
		ChessPlayer* _tmp11_;
		ChessPlayer* _tmp12_;
#line 170 "../lib/chess-state.vala"
		_tmp11_ = self->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp12_ = state->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp5_ = _tmp11_->color != _tmp12_->color;
#line 945 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp5_) {
#line 168 "../lib/chess-state.vala"
		_tmp4_ = TRUE;
#line 951 "chess-state.c"
	} else {
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 171 "../lib/chess-state.vala"
		_tmp13_ = self->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp14_ = state->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp4_ = _tmp13_ != _tmp14_;
#line 961 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp4_) {
#line 168 "../lib/chess-state.vala"
		_tmp3_ = TRUE;
#line 967 "chess-state.c"
	} else {
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 172 "../lib/chess-state.vala"
		_tmp15_ = self->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp16_ = state->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp3_ = _tmp15_ != _tmp16_;
#line 977 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp3_) {
#line 168 "../lib/chess-state.vala"
		_tmp2_ = TRUE;
#line 983 "chess-state.c"
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 173 "../lib/chess-state.vala"
		_tmp17_ = self->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp18_ = state->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp2_ = _tmp17_ != _tmp18_;
#line 993 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp2_) {
#line 168 "../lib/chess-state.vala"
		_tmp1_ = TRUE;
#line 999 "chess-state.c"
	} else {
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 174 "../lib/chess-state.vala"
		_tmp19_ = self->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp20_ = state->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp1_ = _tmp19_ != _tmp20_;
#line 1009 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp1_) {
#line 168 "../lib/chess-state.vala"
		_tmp0_ = TRUE;
#line 1015 "chess-state.c"
	} else {
#line 175 "../lib/chess-state.vala"
		_tmp0_ = self->en_passant_index != state->en_passant_index;
#line 1019 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp0_) {
#line 176 "../lib/chess-state.vala"
		result = FALSE;
#line 176 "../lib/chess-state.vala"
		return result;
#line 1027 "chess-state.c"
	}
	{
		gint i = 0;
#line 179 "../lib/chess-state.vala"
		i = 0;
#line 1033 "chess-state.c"
		{
			gboolean _tmp21_ = FALSE;
#line 179 "../lib/chess-state.vala"
			_tmp21_ = TRUE;
#line 179 "../lib/chess-state.vala"
			while (TRUE) {
#line 1040 "chess-state.c"
				gboolean _tmp23_ = FALSE;
				ChessPiece* _tmp24_;
#line 179 "../lib/chess-state.vala"
				if (!_tmp21_) {
#line 1045 "chess-state.c"
					gint _tmp22_;
#line 179 "../lib/chess-state.vala"
					_tmp22_ = i;
#line 179 "../lib/chess-state.vala"
					i = _tmp22_ + 1;
#line 1051 "chess-state.c"
				}
#line 179 "../lib/chess-state.vala"
				_tmp21_ = FALSE;
#line 179 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 179 "../lib/chess-state.vala"
					break;
#line 1059 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				_tmp24_ = self->board[i];
#line 181 "../lib/chess-state.vala"
				if (_tmp24_ != NULL) {
#line 1065 "chess-state.c"
					ChessPiece* _tmp25_;
					ChessPiece* _tmp26_;
#line 181 "../lib/chess-state.vala"
					_tmp25_ = self->board[i];
#line 181 "../lib/chess-state.vala"
					_tmp26_ = state->board[i];
#line 181 "../lib/chess-state.vala"
					_tmp23_ = _tmp25_->type != _tmp26_->type;
#line 1074 "chess-state.c"
				} else {
#line 181 "../lib/chess-state.vala"
					_tmp23_ = FALSE;
#line 1078 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				if (_tmp23_) {
#line 182 "../lib/chess-state.vala"
					result = FALSE;
#line 182 "../lib/chess-state.vala"
					return result;
#line 1086 "chess-state.c"
				}
			}
		}
	}
#line 185 "../lib/chess-state.vala"
	result = TRUE;
#line 185 "../lib/chess-state.vala"
	return result;
#line 1095 "chess-state.c"
}

gchar*
chess_state_get_fen (ChessState* self)
{
	GString* value = NULL;
	GString* _tmp0_;
	GString* _tmp16_;
	ChessPlayer* _tmp17_;
	GString* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp23_;
	gboolean _tmp25_;
	gboolean _tmp27_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	GString* _tmp34_;
	GString* _tmp37_;
	GString* _tmp38_;
	GString* _tmp39_;
	ChessPlayer* _tmp40_;
	GString* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* result;
#line 188 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../lib/chess-state.vala"
	_tmp0_ = g_string_new ("");
#line 190 "../lib/chess-state.vala"
	value = _tmp0_;
#line 1129 "chess-state.c"
	{
		gint rank = 0;
#line 192 "../lib/chess-state.vala"
		rank = 7;
#line 1134 "chess-state.c"
		{
			gboolean _tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
			_tmp1_ = TRUE;
#line 192 "../lib/chess-state.vala"
			while (TRUE) {
#line 1141 "chess-state.c"
				gint skip_count = 0;
#line 192 "../lib/chess-state.vala"
				if (!_tmp1_) {
#line 1145 "chess-state.c"
					gint _tmp2_;
#line 192 "../lib/chess-state.vala"
					_tmp2_ = rank;
#line 192 "../lib/chess-state.vala"
					rank = _tmp2_ - 1;
#line 1151 "chess-state.c"
				}
#line 192 "../lib/chess-state.vala"
				_tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
				if (!(rank >= 0)) {
#line 192 "../lib/chess-state.vala"
					break;
#line 1159 "chess-state.c"
				}
#line 194 "../lib/chess-state.vala"
				skip_count = 0;
#line 1163 "chess-state.c"
				{
					gint file = 0;
#line 195 "../lib/chess-state.vala"
					file = 0;
#line 1168 "chess-state.c"
					{
						gboolean _tmp3_ = FALSE;
#line 195 "../lib/chess-state.vala"
						_tmp3_ = TRUE;
#line 195 "../lib/chess-state.vala"
						while (TRUE) {
#line 1175 "chess-state.c"
							ChessPiece* p = NULL;
							ChessPiece* _tmp5_;
							ChessPiece* _tmp6_;
							ChessPiece* _tmp7_;
#line 195 "../lib/chess-state.vala"
							if (!_tmp3_) {
#line 1182 "chess-state.c"
								gint _tmp4_;
#line 195 "../lib/chess-state.vala"
								_tmp4_ = file;
#line 195 "../lib/chess-state.vala"
								file = _tmp4_ + 1;
#line 1188 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_tmp3_ = FALSE;
#line 195 "../lib/chess-state.vala"
							if (!(file < 8)) {
#line 195 "../lib/chess-state.vala"
								break;
#line 1196 "chess-state.c"
							}
#line 197 "../lib/chess-state.vala"
							_tmp5_ = self->board[chess_state_get_index (self, rank, file)];
#line 197 "../lib/chess-state.vala"
							_tmp6_ = _g_object_ref0 (_tmp5_);
#line 197 "../lib/chess-state.vala"
							p = _tmp6_;
#line 198 "../lib/chess-state.vala"
							_tmp7_ = p;
#line 198 "../lib/chess-state.vala"
							if (_tmp7_ == NULL) {
#line 1208 "chess-state.c"
								gint _tmp8_;
#line 199 "../lib/chess-state.vala"
								_tmp8_ = skip_count;
#line 199 "../lib/chess-state.vala"
								skip_count = _tmp8_ + 1;
#line 1214 "chess-state.c"
							} else {
								GString* _tmp10_;
								ChessPiece* _tmp11_;
								gunichar _tmp12_;
								gunichar _tmp13_;
#line 202 "../lib/chess-state.vala"
								if (skip_count > 0) {
#line 1222 "chess-state.c"
									GString* _tmp9_;
#line 204 "../lib/chess-state.vala"
									_tmp9_ = value;
#line 204 "../lib/chess-state.vala"
									g_string_append_printf (_tmp9_, "%d", skip_count);
#line 205 "../lib/chess-state.vala"
									skip_count = 0;
#line 1230 "chess-state.c"
								}
#line 207 "../lib/chess-state.vala"
								_tmp10_ = value;
#line 207 "../lib/chess-state.vala"
								_tmp11_ = p;
#line 207 "../lib/chess-state.vala"
								_tmp12_ = chess_piece_get_symbol (_tmp11_);
#line 207 "../lib/chess-state.vala"
								_tmp13_ = _tmp12_;
#line 207 "../lib/chess-state.vala"
								g_string_append_printf (_tmp10_, "%c", (gint) _tmp13_);
#line 1242 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 1246 "chess-state.c"
						}
					}
				}
#line 210 "../lib/chess-state.vala"
				if (skip_count > 0) {
#line 1252 "chess-state.c"
					GString* _tmp14_;
#line 211 "../lib/chess-state.vala"
					_tmp14_ = value;
#line 211 "../lib/chess-state.vala"
					g_string_append_printf (_tmp14_, "%d", skip_count);
#line 1258 "chess-state.c"
				}
#line 212 "../lib/chess-state.vala"
				if (rank != 0) {
#line 1262 "chess-state.c"
					GString* _tmp15_;
#line 213 "../lib/chess-state.vala"
					_tmp15_ = value;
#line 213 "../lib/chess-state.vala"
					g_string_append_c (_tmp15_, '/');
#line 1268 "chess-state.c"
				}
			}
		}
	}
#line 216 "../lib/chess-state.vala"
	_tmp16_ = value;
#line 216 "../lib/chess-state.vala"
	g_string_append_c (_tmp16_, ' ');
#line 217 "../lib/chess-state.vala"
	_tmp17_ = self->current_player;
#line 217 "../lib/chess-state.vala"
	if (_tmp17_->color == COLOR_WHITE) {
#line 1281 "chess-state.c"
		GString* _tmp18_;
#line 218 "../lib/chess-state.vala"
		_tmp18_ = value;
#line 218 "../lib/chess-state.vala"
		g_string_append_c (_tmp18_, 'w');
#line 1287 "chess-state.c"
	} else {
		GString* _tmp19_;
#line 220 "../lib/chess-state.vala"
		_tmp19_ = value;
#line 220 "../lib/chess-state.vala"
		g_string_append_c (_tmp19_, 'b');
#line 1294 "chess-state.c"
	}
#line 222 "../lib/chess-state.vala"
	_tmp20_ = value;
#line 222 "../lib/chess-state.vala"
	g_string_append_c (_tmp20_, ' ');
#line 223 "../lib/chess-state.vala"
	_tmp21_ = self->can_castle_kingside[COLOR_WHITE];
#line 223 "../lib/chess-state.vala"
	if (_tmp21_) {
#line 1304 "chess-state.c"
		GString* _tmp22_;
#line 224 "../lib/chess-state.vala"
		_tmp22_ = value;
#line 224 "../lib/chess-state.vala"
		g_string_append_c (_tmp22_, 'K');
#line 1310 "chess-state.c"
	}
#line 225 "../lib/chess-state.vala"
	_tmp23_ = self->can_castle_queenside[COLOR_WHITE];
#line 225 "../lib/chess-state.vala"
	if (_tmp23_) {
#line 1316 "chess-state.c"
		GString* _tmp24_;
#line 226 "../lib/chess-state.vala"
		_tmp24_ = value;
#line 226 "../lib/chess-state.vala"
		g_string_append_c (_tmp24_, 'Q');
#line 1322 "chess-state.c"
	}
#line 227 "../lib/chess-state.vala"
	_tmp25_ = self->can_castle_kingside[COLOR_BLACK];
#line 227 "../lib/chess-state.vala"
	if (_tmp25_) {
#line 1328 "chess-state.c"
		GString* _tmp26_;
#line 228 "../lib/chess-state.vala"
		_tmp26_ = value;
#line 228 "../lib/chess-state.vala"
		g_string_append_c (_tmp26_, 'k');
#line 1334 "chess-state.c"
	}
#line 229 "../lib/chess-state.vala"
	_tmp27_ = self->can_castle_queenside[COLOR_BLACK];
#line 229 "../lib/chess-state.vala"
	if (_tmp27_) {
#line 1340 "chess-state.c"
		GString* _tmp28_;
#line 230 "../lib/chess-state.vala"
		_tmp28_ = value;
#line 230 "../lib/chess-state.vala"
		g_string_append_c (_tmp28_, 'q');
#line 1346 "chess-state.c"
	}
#line 231 "../lib/chess-state.vala"
	_tmp29_ = self->can_castle_kingside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp30_ = self->can_castle_queenside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp31_ = self->can_castle_kingside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	_tmp32_ = self->can_castle_queenside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	if (!(((_tmp29_ | _tmp30_) | _tmp31_) | _tmp32_)) {
#line 1358 "chess-state.c"
		GString* _tmp33_;
#line 232 "../lib/chess-state.vala"
		_tmp33_ = value;
#line 232 "../lib/chess-state.vala"
		g_string_append_c (_tmp33_, '-');
#line 1364 "chess-state.c"
	}
#line 234 "../lib/chess-state.vala"
	_tmp34_ = value;
#line 234 "../lib/chess-state.vala"
	g_string_append_c (_tmp34_, ' ');
#line 235 "../lib/chess-state.vala"
	if (self->en_passant_index >= 0) {
#line 1372 "chess-state.c"
		GString* _tmp35_;
#line 236 "../lib/chess-state.vala"
		_tmp35_ = value;
#line 236 "../lib/chess-state.vala"
		g_string_append_printf (_tmp35_, "%c%d", 'a' + chess_state_get_file (self, self->en_passant_index), chess_state_get_rank (self, self->en_passant_index) + 1);
#line 1378 "chess-state.c"
	} else {
		GString* _tmp36_;
#line 238 "../lib/chess-state.vala"
		_tmp36_ = value;
#line 238 "../lib/chess-state.vala"
		g_string_append_c (_tmp36_, '-');
#line 1385 "chess-state.c"
	}
#line 240 "../lib/chess-state.vala"
	_tmp37_ = value;
#line 240 "../lib/chess-state.vala"
	g_string_append_c (_tmp37_, ' ');
#line 241 "../lib/chess-state.vala"
	_tmp38_ = value;
#line 241 "../lib/chess-state.vala"
	g_string_append_printf (_tmp38_, "%d", self->halfmove_clock);
#line 243 "../lib/chess-state.vala"
	_tmp39_ = value;
#line 243 "../lib/chess-state.vala"
	g_string_append_c (_tmp39_, ' ');
#line 244 "../lib/chess-state.vala"
	_tmp40_ = self->current_player;
#line 244 "../lib/chess-state.vala"
	if (_tmp40_->color == COLOR_WHITE) {
#line 1403 "chess-state.c"
		GString* _tmp41_;
#line 245 "../lib/chess-state.vala"
		_tmp41_ = value;
#line 245 "../lib/chess-state.vala"
		g_string_append_printf (_tmp41_, "%d", self->number / 2);
#line 1409 "chess-state.c"
	} else {
		GString* _tmp42_;
#line 247 "../lib/chess-state.vala"
		_tmp42_ = value;
#line 247 "../lib/chess-state.vala"
		g_string_append_printf (_tmp42_, "%d", (self->number / 2) + 1);
#line 1416 "chess-state.c"
	}
#line 249 "../lib/chess-state.vala"
	_tmp43_ = value;
#line 249 "../lib/chess-state.vala"
	_tmp44_ = _tmp43_->str;
#line 249 "../lib/chess-state.vala"
	_tmp45_ = g_strdup (_tmp44_);
#line 249 "../lib/chess-state.vala"
	result = _tmp45_;
#line 249 "../lib/chess-state.vala"
	_g_string_free0 (value);
#line 249 "../lib/chess-state.vala"
	return result;
#line 1430 "chess-state.c"
}

gint
chess_state_get_index (ChessState* self,
                       gint rank,
                       gint file)
{
	gint result;
#line 252 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 254 "../lib/chess-state.vala"
	result = (rank * 8) + file;
#line 254 "../lib/chess-state.vala"
	return result;
#line 1445 "chess-state.c"
}

gint
chess_state_get_rank (ChessState* self,
                      gint index)
{
	gint result;
#line 257 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 259 "../lib/chess-state.vala"
	result = index / 8;
#line 259 "../lib/chess-state.vala"
	return result;
#line 1459 "chess-state.c"
}

gint
chess_state_get_file (ChessState* self,
                      gint index)
{
	gint result;
#line 262 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 264 "../lib/chess-state.vala"
	result = index % 8;
#line 264 "../lib/chess-state.vala"
	return result;
#line 1473 "chess-state.c"
}

gboolean
chess_state_move (ChessState* self,
                  const gchar* move,
                  gboolean apply)
{
	gint r0 = 0;
	gint f0 = 0;
	gint r1 = 0;
	gint f1 = 0;
	PieceType promotion_type = 0;
	ChessPlayer* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	PieceType _tmp5_ = 0;
	gboolean _tmp6_;
	ChessPlayer* _tmp7_;
	gboolean result;
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 272 "../lib/chess-state.vala"
	_tmp0_ = self->current_player;
#line 272 "../lib/chess-state.vala"
	_tmp6_ = chess_state_decode_move (self, _tmp0_, move, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 272 "../lib/chess-state.vala"
	r0 = _tmp1_;
#line 272 "../lib/chess-state.vala"
	f0 = _tmp2_;
#line 272 "../lib/chess-state.vala"
	r1 = _tmp3_;
#line 272 "../lib/chess-state.vala"
	f1 = _tmp4_;
#line 272 "../lib/chess-state.vala"
	promotion_type = _tmp5_;
#line 272 "../lib/chess-state.vala"
	if (!_tmp6_) {
#line 273 "../lib/chess-state.vala"
		result = FALSE;
#line 273 "../lib/chess-state.vala"
		return result;
#line 1519 "chess-state.c"
	}
#line 275 "../lib/chess-state.vala"
	_tmp7_ = self->current_player;
#line 275 "../lib/chess-state.vala"
	if (!chess_state_move_with_coords (self, _tmp7_, r0, f0, r1, f1, promotion_type, apply, TRUE)) {
#line 276 "../lib/chess-state.vala"
		result = FALSE;
#line 276 "../lib/chess-state.vala"
		return result;
#line 1529 "chess-state.c"
	}
#line 278 "../lib/chess-state.vala"
	result = TRUE;
#line 278 "../lib/chess-state.vala"
	return result;
#line 1535 "chess-state.c"
}

gboolean
chess_state_move_with_coords (ChessState* self,
                              ChessPlayer* player,
                              gint r0,
                              gint f0,
                              gint r1,
                              gint f1,
                              PieceType promotion_type,
                              gboolean apply,
                              gboolean test_check)
{
	gint start = 0;
	gint end = 0;
	Color color = 0;
	Color _tmp0_ = 0;
	Color opponent_color = 0;
	ChessPiece* piece = NULL;
	ChessPiece* _tmp1_;
	ChessPiece* _tmp2_;
	gboolean _tmp3_ = FALSE;
	ChessPiece* _tmp4_;
	guint64 end_mask = 0ULL;
	guint64 _tmp7_;
	guint64 move_mask = 0ULL;
	ChessPiece* _tmp8_;
	guint64 _tmp9_;
	guint64 over_mask = 0ULL;
	guint64 _tmp10_;
	guint64 _tmp11_;
	guint64 _tmp12_;
	ChessPiece* victim = NULL;
	ChessPiece* _tmp13_;
	ChessPiece* _tmp14_;
	gint victim_index = 0;
	gboolean _tmp15_ = FALSE;
	ChessPiece* _tmp16_;
	gint rook_start = 0;
	gint rook_end = 0;
	gboolean is_promotion = FALSE;
	gboolean en_passant = FALSE;
	gboolean ambiguous_rank = FALSE;
	gboolean ambiguous_file = FALSE;
	ChessPiece* _tmp19_;
	gboolean _tmp45_ = FALSE;
	guint64 old_white_mask = 0ULL;
	guint64 _tmp57_;
	guint64 old_black_mask = 0ULL;
	guint64 _tmp58_;
	gboolean old_white_can_castle_kingside = FALSE;
	gboolean _tmp59_;
	gboolean old_white_can_castle_queenside = FALSE;
	gboolean _tmp60_;
	gboolean old_black_can_castle_kingside = FALSE;
	gboolean _tmp61_;
	gboolean old_black_can_castle_queenside = FALSE;
	gboolean _tmp62_;
	gint old_en_passant_index = 0;
	gint old_halfmove_clock = 0;
	guint64 _tmp63_;
	guint64 _tmp64_;
	ChessPiece* _tmp65_;
	guint64 _tmp71_;
	ChessPiece* _tmp78_;
	gboolean _tmp85_ = FALSE;
	ChessPiece* _tmp86_;
	gboolean _tmp87_ = FALSE;
	ChessPiece* _tmp88_;
	gboolean _result_ = FALSE;
	gboolean _tmp91_ = FALSE;
	gboolean _tmp92_ = FALSE;
	ChessPlayer* _tmp102_ = NULL;
	ChessPlayer* _tmp105_;
	ChessPlayer* _tmp106_;
	ChessMove* _tmp107_;
	ChessMove* _tmp108_;
	ChessMove* _tmp109_;
	ChessPiece* _tmp110_;
	ChessPiece* _tmp111_;
	ChessMove* _tmp115_;
	ChessPiece* _tmp116_;
	ChessPiece* _tmp117_;
	ChessMove* _tmp121_;
	ChessMove* _tmp122_;
	ChessMove* _tmp123_;
	ChessMove* _tmp124_;
	ChessMove* _tmp125_;
	ChessMove* _tmp126_;
	ChessMove* _tmp127_;
	ChessMove* _tmp128_;
	gboolean result;
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 287 "../lib/chess-state.vala"
	start = chess_state_get_index (self, r0, f0);
#line 288 "../lib/chess-state.vala"
	end = chess_state_get_index (self, r1, f1);
#line 290 "../lib/chess-state.vala"
	color = player->color;
#line 291 "../lib/chess-state.vala"
	if (color == COLOR_WHITE) {
#line 291 "../lib/chess-state.vala"
		_tmp0_ = COLOR_BLACK;
#line 1642 "chess-state.c"
	} else {
#line 291 "../lib/chess-state.vala"
		_tmp0_ = COLOR_WHITE;
#line 1646 "chess-state.c"
	}
#line 291 "../lib/chess-state.vala"
	opponent_color = _tmp0_;
#line 294 "../lib/chess-state.vala"
	_tmp1_ = self->board[start];
#line 294 "../lib/chess-state.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 294 "../lib/chess-state.vala"
	piece = _tmp2_;
#line 295 "../lib/chess-state.vala"
	_tmp4_ = piece;
#line 295 "../lib/chess-state.vala"
	if (_tmp4_ == NULL) {
#line 295 "../lib/chess-state.vala"
		_tmp3_ = TRUE;
#line 1662 "chess-state.c"
	} else {
		ChessPiece* _tmp5_;
		ChessPlayer* _tmp6_;
#line 295 "../lib/chess-state.vala"
		_tmp5_ = piece;
#line 295 "../lib/chess-state.vala"
		_tmp6_ = _tmp5_->player;
#line 295 "../lib/chess-state.vala"
		_tmp3_ = _tmp6_ != player;
#line 1672 "chess-state.c"
	}
#line 295 "../lib/chess-state.vala"
	if (_tmp3_) {
#line 296 "../lib/chess-state.vala"
		result = FALSE;
#line 296 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 296 "../lib/chess-state.vala"
		return result;
#line 1682 "chess-state.c"
	}
#line 299 "../lib/chess-state.vala"
	_tmp7_ = BIT_BOARD_set_location_masks[end];
#line 299 "../lib/chess-state.vala"
	end_mask = _tmp7_;
#line 300 "../lib/chess-state.vala"
	_tmp8_ = piece;
#line 300 "../lib/chess-state.vala"
	_tmp9_ = BIT_BOARD_move_masks[(((color * 64) * 6) + (_tmp8_->type * 64)) + start];
#line 300 "../lib/chess-state.vala"
	move_mask = _tmp9_;
#line 301 "../lib/chess-state.vala"
	if ((end_mask & move_mask) == ((guint64) 0)) {
#line 302 "../lib/chess-state.vala"
		result = FALSE;
#line 302 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 302 "../lib/chess-state.vala"
		return result;
#line 1702 "chess-state.c"
	}
#line 305 "../lib/chess-state.vala"
	_tmp10_ = BIT_BOARD_over_masks[(start * 64) + end];
#line 305 "../lib/chess-state.vala"
	over_mask = _tmp10_;
#line 306 "../lib/chess-state.vala"
	_tmp11_ = self->priv->piece_masks[COLOR_WHITE];
#line 306 "../lib/chess-state.vala"
	_tmp12_ = self->priv->piece_masks[COLOR_BLACK];
#line 306 "../lib/chess-state.vala"
	if ((over_mask & (_tmp11_ | _tmp12_)) != ((guint64) 0)) {
#line 307 "../lib/chess-state.vala"
		result = FALSE;
#line 307 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 307 "../lib/chess-state.vala"
		return result;
#line 1720 "chess-state.c"
	}
#line 310 "../lib/chess-state.vala"
	_tmp13_ = self->board[end];
#line 310 "../lib/chess-state.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 310 "../lib/chess-state.vala"
	victim = _tmp14_;
#line 311 "../lib/chess-state.vala"
	victim_index = end;
#line 314 "../lib/chess-state.vala"
	_tmp16_ = victim;
#line 314 "../lib/chess-state.vala"
	if (_tmp16_ != NULL) {
#line 1734 "chess-state.c"
		ChessPiece* _tmp17_;
		ChessPlayer* _tmp18_;
#line 314 "../lib/chess-state.vala"
		_tmp17_ = victim;
#line 314 "../lib/chess-state.vala"
		_tmp18_ = _tmp17_->player;
#line 314 "../lib/chess-state.vala"
		_tmp15_ = _tmp18_ == player;
#line 1743 "chess-state.c"
	} else {
#line 314 "../lib/chess-state.vala"
		_tmp15_ = FALSE;
#line 1747 "chess-state.c"
	}
#line 314 "../lib/chess-state.vala"
	if (_tmp15_) {
#line 315 "../lib/chess-state.vala"
		result = FALSE;
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 315 "../lib/chess-state.vala"
		return result;
#line 1759 "chess-state.c"
	}
#line 318 "../lib/chess-state.vala"
	rook_start = -1;
#line 318 "../lib/chess-state.vala"
	rook_end = -1;
#line 319 "../lib/chess-state.vala"
	is_promotion = FALSE;
#line 320 "../lib/chess-state.vala"
	en_passant = FALSE;
#line 321 "../lib/chess-state.vala"
	ambiguous_rank = FALSE;
#line 322 "../lib/chess-state.vala"
	ambiguous_file = FALSE;
#line 323 "../lib/chess-state.vala"
	_tmp19_ = piece;
#line 323 "../lib/chess-state.vala"
	switch (_tmp19_->type) {
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_PAWN:
#line 1779 "chess-state.c"
		{
			gboolean _tmp20_ = FALSE;
			ChessPiece* _tmp21_;
			gboolean _tmp27_ = FALSE;
			ChessPiece* _tmp28_;
#line 327 "../lib/chess-state.vala"
			_tmp21_ = victim;
#line 327 "../lib/chess-state.vala"
			if (_tmp21_ == NULL) {
#line 327 "../lib/chess-state.vala"
				_tmp20_ = end == self->en_passant_index;
#line 1791 "chess-state.c"
			} else {
#line 327 "../lib/chess-state.vala"
				_tmp20_ = FALSE;
#line 1795 "chess-state.c"
			}
#line 327 "../lib/chess-state.vala"
			if (_tmp20_) {
#line 1799 "chess-state.c"
				gint _tmp22_ = 0;
				ChessPiece* _tmp23_;
				ChessPiece* _tmp24_;
#line 329 "../lib/chess-state.vala"
				en_passant = TRUE;
#line 330 "../lib/chess-state.vala"
				if (r1 == 2) {
#line 330 "../lib/chess-state.vala"
					_tmp22_ = 3;
#line 1809 "chess-state.c"
				} else {
#line 330 "../lib/chess-state.vala"
					_tmp22_ = 4;
#line 1813 "chess-state.c"
				}
#line 330 "../lib/chess-state.vala"
				victim_index = chess_state_get_index (self, _tmp22_, f1);
#line 331 "../lib/chess-state.vala"
				_tmp23_ = self->board[victim_index];
#line 331 "../lib/chess-state.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 331 "../lib/chess-state.vala"
				_g_object_unref0 (victim);
#line 331 "../lib/chess-state.vala"
				victim = _tmp24_;
#line 1825 "chess-state.c"
			}
#line 335 "../lib/chess-state.vala"
			if (f0 != f1) {
#line 1829 "chess-state.c"
				ChessPiece* _tmp25_;
#line 337 "../lib/chess-state.vala"
				_tmp25_ = victim;
#line 337 "../lib/chess-state.vala"
				if (_tmp25_ == NULL) {
#line 338 "../lib/chess-state.vala"
					result = FALSE;
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 338 "../lib/chess-state.vala"
					return result;
#line 1843 "chess-state.c"
				}
			} else {
				ChessPiece* _tmp26_;
#line 343 "../lib/chess-state.vala"
				_tmp26_ = victim;
#line 343 "../lib/chess-state.vala"
				if (_tmp26_ != NULL) {
#line 344 "../lib/chess-state.vala"
					result = FALSE;
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 344 "../lib/chess-state.vala"
					return result;
#line 1859 "chess-state.c"
				}
			}
#line 346 "../lib/chess-state.vala"
			if (r1 == 0) {
#line 346 "../lib/chess-state.vala"
				_tmp27_ = TRUE;
#line 1866 "chess-state.c"
			} else {
#line 346 "../lib/chess-state.vala"
				_tmp27_ = r1 == 7;
#line 1870 "chess-state.c"
			}
#line 346 "../lib/chess-state.vala"
			is_promotion = _tmp27_;
#line 349 "../lib/chess-state.vala"
			_tmp28_ = victim;
#line 349 "../lib/chess-state.vala"
			if (_tmp28_ != NULL) {
#line 350 "../lib/chess-state.vala"
				ambiguous_file = TRUE;
#line 1880 "chess-state.c"
			}
#line 351 "../lib/chess-state.vala"
			break;
#line 1884 "chess-state.c"
		}
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_KING:
#line 1888 "chess-state.c"
		{
#line 354 "../lib/chess-state.vala"
			if (abs (f0 - f1) > 1) {
#line 1892 "chess-state.c"
				gint _tmp29_ = 0;
				gint _tmp30_ = 0;
				ChessPiece* rook = NULL;
				ChessPiece* _tmp33_;
				ChessPiece* _tmp34_;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				ChessPiece* _tmp37_;
				guint64 rook_over_mask = 0ULL;
				guint64 _tmp42_;
				guint64 _tmp43_;
				guint64 _tmp44_;
#line 357 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 357 "../lib/chess-state.vala"
					_tmp29_ = 7;
#line 1909 "chess-state.c"
				} else {
#line 357 "../lib/chess-state.vala"
					_tmp29_ = 0;
#line 1913 "chess-state.c"
				}
#line 357 "../lib/chess-state.vala"
				rook_start = chess_state_get_index (self, r0, _tmp29_);
#line 358 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 358 "../lib/chess-state.vala"
					_tmp30_ = f1 - 1;
#line 1921 "chess-state.c"
				} else {
#line 358 "../lib/chess-state.vala"
					_tmp30_ = f1 + 1;
#line 1925 "chess-state.c"
				}
#line 358 "../lib/chess-state.vala"
				rook_end = chess_state_get_index (self, r0, _tmp30_);
#line 361 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 1931 "chess-state.c"
					gboolean _tmp31_;
#line 363 "../lib/chess-state.vala"
					_tmp31_ = self->can_castle_kingside[color];
#line 363 "../lib/chess-state.vala"
					if (!_tmp31_) {
#line 364 "../lib/chess-state.vala"
						result = FALSE;
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 364 "../lib/chess-state.vala"
						return result;
#line 1945 "chess-state.c"
					}
				} else {
					gboolean _tmp32_;
#line 368 "../lib/chess-state.vala"
					_tmp32_ = self->can_castle_queenside[color];
#line 368 "../lib/chess-state.vala"
					if (!_tmp32_) {
#line 369 "../lib/chess-state.vala"
						result = FALSE;
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 369 "../lib/chess-state.vala"
						return result;
#line 1961 "chess-state.c"
					}
				}
#line 372 "../lib/chess-state.vala"
				_tmp33_ = self->board[rook_start];
#line 372 "../lib/chess-state.vala"
				_tmp34_ = _g_object_ref0 (_tmp33_);
#line 372 "../lib/chess-state.vala"
				rook = _tmp34_;
#line 373 "../lib/chess-state.vala"
				_tmp37_ = rook;
#line 373 "../lib/chess-state.vala"
				if (_tmp37_ == NULL) {
#line 373 "../lib/chess-state.vala"
					_tmp36_ = TRUE;
#line 1976 "chess-state.c"
				} else {
					ChessPiece* _tmp38_;
#line 373 "../lib/chess-state.vala"
					_tmp38_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp36_ = _tmp38_->type != PIECE_TYPE_ROOK;
#line 1983 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp36_) {
#line 373 "../lib/chess-state.vala"
					_tmp35_ = TRUE;
#line 1989 "chess-state.c"
				} else {
					ChessPiece* _tmp39_;
					Color _tmp40_;
					Color _tmp41_;
#line 373 "../lib/chess-state.vala"
					_tmp39_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp40_ = chess_piece_get_color (_tmp39_);
#line 373 "../lib/chess-state.vala"
					_tmp41_ = _tmp40_;
#line 373 "../lib/chess-state.vala"
					_tmp35_ = _tmp41_ != color;
#line 2002 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp35_) {
#line 374 "../lib/chess-state.vala"
					result = FALSE;
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 374 "../lib/chess-state.vala"
					return result;
#line 2016 "chess-state.c"
				}
#line 377 "../lib/chess-state.vala"
				_tmp42_ = BIT_BOARD_over_masks[(rook_start * 64) + rook_end];
#line 377 "../lib/chess-state.vala"
				rook_over_mask = _tmp42_;
#line 378 "../lib/chess-state.vala"
				_tmp43_ = self->priv->piece_masks[COLOR_WHITE];
#line 378 "../lib/chess-state.vala"
				_tmp44_ = self->priv->piece_masks[COLOR_BLACK];
#line 378 "../lib/chess-state.vala"
				if ((rook_over_mask & (_tmp43_ | _tmp44_)) != ((guint64) 0)) {
#line 379 "../lib/chess-state.vala"
					result = FALSE;
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 379 "../lib/chess-state.vala"
					return result;
#line 2038 "chess-state.c"
				}
#line 382 "../lib/chess-state.vala"
				if (self->check_state == CHECK_STATE_CHECK) {
#line 383 "../lib/chess-state.vala"
					result = FALSE;
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 383 "../lib/chess-state.vala"
					return result;
#line 2052 "chess-state.c"
				}
#line 386 "../lib/chess-state.vala"
				if (!chess_state_move_with_coords (self, player, r0, f0, chess_state_get_rank (self, rook_end), chess_state_get_file (self, rook_end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 387 "../lib/chess-state.vala"
					result = FALSE;
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 387 "../lib/chess-state.vala"
					return result;
#line 2066 "chess-state.c"
				}
#line 354 "../lib/chess-state.vala"
				_g_object_unref0 (rook);
#line 2070 "chess-state.c"
			}
#line 389 "../lib/chess-state.vala"
			break;
#line 2074 "chess-state.c"
		}
		default:
		{
#line 391 "../lib/chess-state.vala"
			break;
#line 2080 "chess-state.c"
		}
	}
#line 394 "../lib/chess-state.vala"
	if (!apply) {
#line 394 "../lib/chess-state.vala"
		_tmp45_ = !test_check;
#line 2087 "chess-state.c"
	} else {
#line 394 "../lib/chess-state.vala"
		_tmp45_ = FALSE;
#line 2091 "chess-state.c"
	}
#line 394 "../lib/chess-state.vala"
	if (_tmp45_) {
#line 395 "../lib/chess-state.vala"
		result = TRUE;
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 395 "../lib/chess-state.vala"
		return result;
#line 2103 "chess-state.c"
	}
#line 398 "../lib/chess-state.vala"
	if (apply) {
#line 2107 "chess-state.c"
		{
			gint i = 0;
#line 400 "../lib/chess-state.vala"
			i = 0;
#line 2112 "chess-state.c"
			{
				gboolean _tmp46_ = FALSE;
#line 400 "../lib/chess-state.vala"
				_tmp46_ = TRUE;
#line 400 "../lib/chess-state.vala"
				while (TRUE) {
#line 2119 "chess-state.c"
					ChessPiece* p = NULL;
					ChessPiece* _tmp48_;
					ChessPiece* _tmp49_;
					gboolean _tmp50_ = FALSE;
					gboolean _tmp51_ = FALSE;
					ChessPiece* _tmp52_;
					gint r = 0;
					gint f = 0;
#line 400 "../lib/chess-state.vala"
					if (!_tmp46_) {
#line 2130 "chess-state.c"
						gint _tmp47_;
#line 400 "../lib/chess-state.vala"
						_tmp47_ = i;
#line 400 "../lib/chess-state.vala"
						i = _tmp47_ + 1;
#line 2136 "chess-state.c"
					}
#line 400 "../lib/chess-state.vala"
					_tmp46_ = FALSE;
#line 400 "../lib/chess-state.vala"
					if (!(i < 64)) {
#line 400 "../lib/chess-state.vala"
						break;
#line 2144 "chess-state.c"
					}
#line 403 "../lib/chess-state.vala"
					if (i == start) {
#line 404 "../lib/chess-state.vala"
						continue;
#line 2150 "chess-state.c"
					}
#line 407 "../lib/chess-state.vala"
					_tmp48_ = self->board[i];
#line 407 "../lib/chess-state.vala"
					_tmp49_ = _g_object_ref0 (_tmp48_);
#line 407 "../lib/chess-state.vala"
					p = _tmp49_;
#line 408 "../lib/chess-state.vala"
					_tmp52_ = p;
#line 408 "../lib/chess-state.vala"
					if (_tmp52_ == NULL) {
#line 408 "../lib/chess-state.vala"
						_tmp51_ = TRUE;
#line 2164 "chess-state.c"
					} else {
						ChessPiece* _tmp53_;
						ChessPlayer* _tmp54_;
#line 408 "../lib/chess-state.vala"
						_tmp53_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp54_ = _tmp53_->player;
#line 408 "../lib/chess-state.vala"
						_tmp51_ = _tmp54_ != player;
#line 2174 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp51_) {
#line 408 "../lib/chess-state.vala"
						_tmp50_ = TRUE;
#line 2180 "chess-state.c"
					} else {
						ChessPiece* _tmp55_;
						ChessPiece* _tmp56_;
#line 408 "../lib/chess-state.vala"
						_tmp55_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp56_ = piece;
#line 408 "../lib/chess-state.vala"
						_tmp50_ = _tmp55_->type != _tmp56_->type;
#line 2190 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp50_) {
#line 409 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 409 "../lib/chess-state.vala"
						continue;
#line 2198 "chess-state.c"
					}
#line 412 "../lib/chess-state.vala"
					r = chess_state_get_rank (self, i);
#line 413 "../lib/chess-state.vala"
					f = chess_state_get_file (self, i);
#line 414 "../lib/chess-state.vala"
					if (chess_state_move_with_coords (self, player, r, f, r1, f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 416 "../lib/chess-state.vala"
						if (r != r0) {
#line 417 "../lib/chess-state.vala"
							ambiguous_rank = TRUE;
#line 2210 "chess-state.c"
						}
#line 418 "../lib/chess-state.vala"
						if (f != f0) {
#line 419 "../lib/chess-state.vala"
							ambiguous_file = TRUE;
#line 2216 "chess-state.c"
						}
					}
#line 400 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 2221 "chess-state.c"
				}
			}
		}
	}
#line 424 "../lib/chess-state.vala"
	_tmp57_ = self->priv->piece_masks[COLOR_WHITE];
#line 424 "../lib/chess-state.vala"
	old_white_mask = _tmp57_;
#line 425 "../lib/chess-state.vala"
	_tmp58_ = self->priv->piece_masks[COLOR_BLACK];
#line 425 "../lib/chess-state.vala"
	old_black_mask = _tmp58_;
#line 426 "../lib/chess-state.vala"
	_tmp59_ = self->can_castle_kingside[COLOR_WHITE];
#line 426 "../lib/chess-state.vala"
	old_white_can_castle_kingside = _tmp59_;
#line 427 "../lib/chess-state.vala"
	_tmp60_ = self->can_castle_queenside[COLOR_WHITE];
#line 427 "../lib/chess-state.vala"
	old_white_can_castle_queenside = _tmp60_;
#line 428 "../lib/chess-state.vala"
	_tmp61_ = self->can_castle_kingside[COLOR_BLACK];
#line 428 "../lib/chess-state.vala"
	old_black_can_castle_kingside = _tmp61_;
#line 429 "../lib/chess-state.vala"
	_tmp62_ = self->can_castle_queenside[COLOR_BLACK];
#line 429 "../lib/chess-state.vala"
	old_black_can_castle_queenside = _tmp62_;
#line 430 "../lib/chess-state.vala"
	old_en_passant_index = self->en_passant_index;
#line 431 "../lib/chess-state.vala"
	old_halfmove_clock = self->halfmove_clock;
#line 434 "../lib/chess-state.vala"
	_g_object_unref0 (self->board[start]);
#line 434 "../lib/chess-state.vala"
	self->board[start] = NULL;
#line 435 "../lib/chess-state.vala"
	_tmp63_ = BIT_BOARD_clear_location_masks[start];
#line 435 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_WHITE] &= _tmp63_;
#line 436 "../lib/chess-state.vala"
	_tmp64_ = BIT_BOARD_clear_location_masks[start];
#line 436 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_BLACK] &= _tmp64_;
#line 437 "../lib/chess-state.vala"
	_tmp65_ = victim;
#line 437 "../lib/chess-state.vala"
	if (_tmp65_ != NULL) {
#line 2270 "chess-state.c"
		guint64 _tmp66_;
		guint64 _tmp67_;
#line 439 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[victim_index]);
#line 439 "../lib/chess-state.vala"
		self->board[victim_index] = NULL;
#line 440 "../lib/chess-state.vala"
		_tmp66_ = BIT_BOARD_clear_location_masks[victim_index];
#line 440 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] &= _tmp66_;
#line 441 "../lib/chess-state.vala"
		_tmp67_ = BIT_BOARD_clear_location_masks[victim_index];
#line 441 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] &= _tmp67_;
#line 2285 "chess-state.c"
	}
#line 443 "../lib/chess-state.vala"
	if (is_promotion) {
#line 2289 "chess-state.c"
		ChessPiece* _tmp68_;
#line 444 "../lib/chess-state.vala"
		_tmp68_ = chess_piece_new (player, promotion_type);
#line 444 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[end]);
#line 444 "../lib/chess-state.vala"
		self->board[end] = _tmp68_;
#line 2297 "chess-state.c"
	} else {
		ChessPiece* _tmp69_;
		ChessPiece* _tmp70_;
#line 446 "../lib/chess-state.vala"
		_tmp69_ = piece;
#line 446 "../lib/chess-state.vala"
		_tmp70_ = _g_object_ref0 (_tmp69_);
#line 446 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[end]);
#line 446 "../lib/chess-state.vala"
		self->board[end] = _tmp70_;
#line 2309 "chess-state.c"
	}
#line 447 "../lib/chess-state.vala"
	self->priv->piece_masks[color] |= end_mask;
#line 448 "../lib/chess-state.vala"
	_tmp71_ = BIT_BOARD_clear_location_masks[end];
#line 448 "../lib/chess-state.vala"
	self->priv->piece_masks[opponent_color] &= _tmp71_;
#line 449 "../lib/chess-state.vala"
	if (rook_start >= 0) {
#line 2319 "chess-state.c"
		ChessPiece* rook = NULL;
		ChessPiece* _tmp72_;
		ChessPiece* _tmp73_;
		guint64 _tmp74_;
		ChessPiece* _tmp75_;
		ChessPiece* _tmp76_;
		guint64 _tmp77_;
#line 451 "../lib/chess-state.vala"
		_tmp72_ = self->board[rook_start];
#line 451 "../lib/chess-state.vala"
		_tmp73_ = _g_object_ref0 (_tmp72_);
#line 451 "../lib/chess-state.vala"
		rook = _tmp73_;
#line 452 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[rook_start]);
#line 452 "../lib/chess-state.vala"
		self->board[rook_start] = NULL;
#line 453 "../lib/chess-state.vala"
		_tmp74_ = BIT_BOARD_clear_location_masks[rook_start];
#line 453 "../lib/chess-state.vala"
		self->priv->piece_masks[color] &= _tmp74_;
#line 454 "../lib/chess-state.vala"
		_tmp75_ = rook;
#line 454 "../lib/chess-state.vala"
		_tmp76_ = _g_object_ref0 (_tmp75_);
#line 454 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[rook_end]);
#line 454 "../lib/chess-state.vala"
		self->board[rook_end] = _tmp76_;
#line 455 "../lib/chess-state.vala"
		_tmp77_ = BIT_BOARD_set_location_masks[rook_end];
#line 455 "../lib/chess-state.vala"
		self->priv->piece_masks[color] |= _tmp77_;
#line 449 "../lib/chess-state.vala"
		_g_object_unref0 (rook);
#line 2355 "chess-state.c"
	}
#line 459 "../lib/chess-state.vala"
	_tmp78_ = piece;
#line 459 "../lib/chess-state.vala"
	if (_tmp78_->type == PIECE_TYPE_KING) {
#line 461 "../lib/chess-state.vala"
		self->can_castle_kingside[color] = FALSE;
#line 462 "../lib/chess-state.vala"
		self->can_castle_queenside[color] = FALSE;
#line 2365 "chess-state.c"
	} else {
		ChessPiece* _tmp79_;
#line 465 "../lib/chess-state.vala"
		_tmp79_ = piece;
#line 465 "../lib/chess-state.vala"
		if (_tmp79_->type == PIECE_TYPE_ROOK) {
#line 2372 "chess-state.c"
			gint _tmp80_ = 0;
			gint base_rank = 0;
#line 467 "../lib/chess-state.vala"
			if (color == COLOR_WHITE) {
#line 467 "../lib/chess-state.vala"
				_tmp80_ = 0;
#line 2379 "chess-state.c"
			} else {
#line 467 "../lib/chess-state.vala"
				_tmp80_ = 7;
#line 2383 "chess-state.c"
			}
#line 467 "../lib/chess-state.vala"
			base_rank = _tmp80_;
#line 468 "../lib/chess-state.vala"
			if (r0 == base_rank) {
#line 470 "../lib/chess-state.vala"
				if (f0 == 0) {
#line 471 "../lib/chess-state.vala"
					self->can_castle_queenside[color] = FALSE;
#line 2393 "chess-state.c"
				} else {
#line 472 "../lib/chess-state.vala"
					if (f0 == 7) {
#line 473 "../lib/chess-state.vala"
						self->can_castle_kingside[color] = FALSE;
#line 2399 "chess-state.c"
					}
				}
			}
		} else {
			gboolean _tmp81_ = FALSE;
			ChessPiece* _tmp82_;
#line 477 "../lib/chess-state.vala"
			_tmp82_ = victim;
#line 477 "../lib/chess-state.vala"
			if (_tmp82_ != NULL) {
#line 2410 "chess-state.c"
				ChessPiece* _tmp83_;
#line 477 "../lib/chess-state.vala"
				_tmp83_ = victim;
#line 477 "../lib/chess-state.vala"
				_tmp81_ = _tmp83_->type == PIECE_TYPE_ROOK;
#line 2416 "chess-state.c"
			} else {
#line 477 "../lib/chess-state.vala"
				_tmp81_ = FALSE;
#line 2420 "chess-state.c"
			}
#line 477 "../lib/chess-state.vala"
			if (_tmp81_) {
#line 2424 "chess-state.c"
				gint _tmp84_ = 0;
				gint base_rank = 0;
#line 479 "../lib/chess-state.vala"
				if (opponent_color == COLOR_WHITE) {
#line 479 "../lib/chess-state.vala"
					_tmp84_ = 0;
#line 2431 "chess-state.c"
				} else {
#line 479 "../lib/chess-state.vala"
					_tmp84_ = 7;
#line 2435 "chess-state.c"
				}
#line 479 "../lib/chess-state.vala"
				base_rank = _tmp84_;
#line 480 "../lib/chess-state.vala"
				if (r1 == base_rank) {
#line 482 "../lib/chess-state.vala"
					if (f1 == 0) {
#line 483 "../lib/chess-state.vala"
						self->can_castle_queenside[opponent_color] = FALSE;
#line 2445 "chess-state.c"
					} else {
#line 484 "../lib/chess-state.vala"
						if (f1 == 7) {
#line 485 "../lib/chess-state.vala"
							self->can_castle_kingside[opponent_color] = FALSE;
#line 2451 "chess-state.c"
						}
					}
				}
			}
		}
	}
#line 490 "../lib/chess-state.vala"
	_tmp86_ = piece;
#line 490 "../lib/chess-state.vala"
	if (_tmp86_->type == PIECE_TYPE_PAWN) {
#line 490 "../lib/chess-state.vala"
		_tmp85_ = over_mask != ((guint64) 0);
#line 2464 "chess-state.c"
	} else {
#line 490 "../lib/chess-state.vala"
		_tmp85_ = FALSE;
#line 2468 "chess-state.c"
	}
#line 490 "../lib/chess-state.vala"
	if (_tmp85_) {
#line 491 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (r0 + r1) / 2, f0);
#line 2474 "chess-state.c"
	} else {
#line 493 "../lib/chess-state.vala"
		self->en_passant_index = -1;
#line 2478 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	_tmp88_ = piece;
#line 496 "../lib/chess-state.vala"
	if (_tmp88_->type == PIECE_TYPE_PAWN) {
#line 496 "../lib/chess-state.vala"
		_tmp87_ = TRUE;
#line 2486 "chess-state.c"
	} else {
		ChessPiece* _tmp89_;
#line 496 "../lib/chess-state.vala"
		_tmp89_ = victim;
#line 496 "../lib/chess-state.vala"
		_tmp87_ = _tmp89_ != NULL;
#line 2493 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	if (_tmp87_) {
#line 497 "../lib/chess-state.vala"
		self->halfmove_clock = 0;
#line 2499 "chess-state.c"
	} else {
		gint _tmp90_;
#line 499 "../lib/chess-state.vala"
		_tmp90_ = self->halfmove_clock;
#line 499 "../lib/chess-state.vala"
		self->halfmove_clock = _tmp90_ + 1;
#line 2506 "chess-state.c"
	}
#line 502 "../lib/chess-state.vala"
	_result_ = TRUE;
#line 503 "../lib/chess-state.vala"
	if (test_check) {
#line 503 "../lib/chess-state.vala"
		_tmp91_ = chess_state_is_in_check (self, player);
#line 2514 "chess-state.c"
	} else {
#line 503 "../lib/chess-state.vala"
		_tmp91_ = FALSE;
#line 2518 "chess-state.c"
	}
#line 503 "../lib/chess-state.vala"
	if (_tmp91_) {
#line 504 "../lib/chess-state.vala"
		_result_ = FALSE;
#line 2524 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (!apply) {
#line 507 "../lib/chess-state.vala"
		_tmp92_ = TRUE;
#line 2530 "chess-state.c"
	} else {
#line 507 "../lib/chess-state.vala"
		_tmp92_ = !_result_;
#line 2534 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (_tmp92_) {
#line 2538 "chess-state.c"
		ChessPiece* _tmp93_;
		ChessPiece* _tmp94_;
		ChessPiece* _tmp95_;
#line 509 "../lib/chess-state.vala"
		_tmp93_ = piece;
#line 509 "../lib/chess-state.vala"
		_tmp94_ = _g_object_ref0 (_tmp93_);
#line 509 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[start]);
#line 509 "../lib/chess-state.vala"
		self->board[start] = _tmp94_;
#line 510 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[end]);
#line 510 "../lib/chess-state.vala"
		self->board[end] = NULL;
#line 511 "../lib/chess-state.vala"
		_tmp95_ = victim;
#line 511 "../lib/chess-state.vala"
		if (_tmp95_ != NULL) {
#line 2558 "chess-state.c"
			ChessPiece* _tmp96_;
			ChessPiece* _tmp97_;
#line 512 "../lib/chess-state.vala"
			_tmp96_ = victim;
#line 512 "../lib/chess-state.vala"
			_tmp97_ = _g_object_ref0 (_tmp96_);
#line 512 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[victim_index]);
#line 512 "../lib/chess-state.vala"
			self->board[victim_index] = _tmp97_;
#line 2569 "chess-state.c"
		}
#line 513 "../lib/chess-state.vala"
		if (rook_start >= 0) {
#line 2573 "chess-state.c"
			ChessPiece* rook = NULL;
			ChessPiece* _tmp98_;
			ChessPiece* _tmp99_;
			ChessPiece* _tmp100_;
			ChessPiece* _tmp101_;
#line 515 "../lib/chess-state.vala"
			_tmp98_ = self->board[rook_end];
#line 515 "../lib/chess-state.vala"
			_tmp99_ = _g_object_ref0 (_tmp98_);
#line 515 "../lib/chess-state.vala"
			rook = _tmp99_;
#line 516 "../lib/chess-state.vala"
			_tmp100_ = rook;
#line 516 "../lib/chess-state.vala"
			_tmp101_ = _g_object_ref0 (_tmp100_);
#line 516 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[rook_start]);
#line 516 "../lib/chess-state.vala"
			self->board[rook_start] = _tmp101_;
#line 517 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[rook_end]);
#line 517 "../lib/chess-state.vala"
			self->board[rook_end] = NULL;
#line 513 "../lib/chess-state.vala"
			_g_object_unref0 (rook);
#line 2599 "chess-state.c"
		}
#line 519 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] = old_white_mask;
#line 520 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] = old_black_mask;
#line 521 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_WHITE] = old_white_can_castle_kingside;
#line 522 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_WHITE] = old_white_can_castle_queenside;
#line 523 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_BLACK] = old_black_can_castle_kingside;
#line 524 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_BLACK] = old_black_can_castle_queenside;
#line 525 "../lib/chess-state.vala"
		self->en_passant_index = old_en_passant_index;
#line 526 "../lib/chess-state.vala"
		self->halfmove_clock = old_halfmove_clock;
#line 528 "../lib/chess-state.vala"
		result = _result_;
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 528 "../lib/chess-state.vala"
		return result;
#line 2625 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	if (color == COLOR_WHITE) {
#line 2629 "chess-state.c"
		ChessPlayer* _tmp103_;
#line 531 "../lib/chess-state.vala"
		_tmp103_ = self->players[COLOR_BLACK];
#line 531 "../lib/chess-state.vala"
		_tmp102_ = _tmp103_;
#line 2635 "chess-state.c"
	} else {
		ChessPlayer* _tmp104_;
#line 531 "../lib/chess-state.vala"
		_tmp104_ = self->players[COLOR_WHITE];
#line 531 "../lib/chess-state.vala"
		_tmp102_ = _tmp104_;
#line 2642 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	_tmp105_ = _g_object_ref0 (_tmp102_);
#line 531 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 531 "../lib/chess-state.vala"
	self->current_player = _tmp105_;
#line 532 "../lib/chess-state.vala"
	_tmp106_ = self->current_player;
#line 532 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp106_);
#line 534 "../lib/chess-state.vala"
	_tmp107_ = chess_move_new ();
#line 534 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 534 "../lib/chess-state.vala"
	self->last_move = _tmp107_;
#line 535 "../lib/chess-state.vala"
	_tmp108_ = self->last_move;
#line 535 "../lib/chess-state.vala"
	_tmp108_->number = self->number;
#line 536 "../lib/chess-state.vala"
	_tmp109_ = self->last_move;
#line 536 "../lib/chess-state.vala"
	_tmp110_ = piece;
#line 536 "../lib/chess-state.vala"
	_tmp111_ = _g_object_ref0 (_tmp110_);
#line 536 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp109_->piece);
#line 536 "../lib/chess-state.vala"
	_tmp109_->piece = _tmp111_;
#line 537 "../lib/chess-state.vala"
	if (is_promotion) {
#line 2676 "chess-state.c"
		ChessMove* _tmp112_;
		ChessPiece* _tmp113_;
		ChessPiece* _tmp114_;
#line 538 "../lib/chess-state.vala"
		_tmp112_ = self->last_move;
#line 538 "../lib/chess-state.vala"
		_tmp113_ = self->board[end];
#line 538 "../lib/chess-state.vala"
		_tmp114_ = _g_object_ref0 (_tmp113_);
#line 538 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp112_->promotion_piece);
#line 538 "../lib/chess-state.vala"
		_tmp112_->promotion_piece = _tmp114_;
#line 2690 "chess-state.c"
	}
#line 539 "../lib/chess-state.vala"
	_tmp115_ = self->last_move;
#line 539 "../lib/chess-state.vala"
	_tmp116_ = victim;
#line 539 "../lib/chess-state.vala"
	_tmp117_ = _g_object_ref0 (_tmp116_);
#line 539 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp115_->victim);
#line 539 "../lib/chess-state.vala"
	_tmp115_->victim = _tmp117_;
#line 540 "../lib/chess-state.vala"
	if (rook_end >= 0) {
#line 2704 "chess-state.c"
		ChessMove* _tmp118_;
		ChessPiece* _tmp119_;
		ChessPiece* _tmp120_;
#line 541 "../lib/chess-state.vala"
		_tmp118_ = self->last_move;
#line 541 "../lib/chess-state.vala"
		_tmp119_ = self->board[rook_end];
#line 541 "../lib/chess-state.vala"
		_tmp120_ = _g_object_ref0 (_tmp119_);
#line 541 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp118_->castling_rook);
#line 541 "../lib/chess-state.vala"
		_tmp118_->castling_rook = _tmp120_;
#line 2718 "chess-state.c"
	}
#line 542 "../lib/chess-state.vala"
	_tmp121_ = self->last_move;
#line 542 "../lib/chess-state.vala"
	_tmp121_->r0 = r0;
#line 543 "../lib/chess-state.vala"
	_tmp122_ = self->last_move;
#line 543 "../lib/chess-state.vala"
	_tmp122_->f0 = f0;
#line 544 "../lib/chess-state.vala"
	_tmp123_ = self->last_move;
#line 544 "../lib/chess-state.vala"
	_tmp123_->r1 = r1;
#line 545 "../lib/chess-state.vala"
	_tmp124_ = self->last_move;
#line 545 "../lib/chess-state.vala"
	_tmp124_->f1 = f1;
#line 546 "../lib/chess-state.vala"
	_tmp125_ = self->last_move;
#line 546 "../lib/chess-state.vala"
	_tmp125_->ambiguous_rank = ambiguous_rank;
#line 547 "../lib/chess-state.vala"
	_tmp126_ = self->last_move;
#line 547 "../lib/chess-state.vala"
	_tmp126_->ambiguous_file = ambiguous_file;
#line 548 "../lib/chess-state.vala"
	_tmp127_ = self->last_move;
#line 548 "../lib/chess-state.vala"
	_tmp127_->en_passant = en_passant;
#line 549 "../lib/chess-state.vala"
	_tmp128_ = self->last_move;
#line 549 "../lib/chess-state.vala"
	_tmp128_->check_state = self->check_state;
#line 551 "../lib/chess-state.vala"
	result = TRUE;
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (victim);
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (piece);
#line 551 "../lib/chess-state.vala"
	return result;
#line 2760 "chess-state.c"
}

ChessResult
chess_state_get_result (ChessState* self,
                        ChessRule* rule)
{
	ChessRule _vala_rule = 0;
	ChessPlayer* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	ChessMove* _tmp4_;
	ChessResult result;
#line 554 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 556 "../lib/chess-state.vala"
	_vala_rule = CHESS_RULE_CHECKMATE;
#line 557 "../lib/chess-state.vala"
	if (self->check_state == CHECK_STATE_CHECKMATE) {
#line 2779 "chess-state.c"
		ChessPlayer* _tmp0_;
#line 559 "../lib/chess-state.vala"
		_tmp0_ = self->current_player;
#line 559 "../lib/chess-state.vala"
		if (_tmp0_->color == COLOR_WHITE) {
#line 561 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 562 "../lib/chess-state.vala"
			result = CHESS_RESULT_BLACK_WON;
#line 562 "../lib/chess-state.vala"
			if (rule) {
#line 562 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 2793 "chess-state.c"
			}
#line 562 "../lib/chess-state.vala"
			return result;
#line 2797 "chess-state.c"
		} else {
#line 566 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 567 "../lib/chess-state.vala"
			result = CHESS_RESULT_WHITE_WON;
#line 567 "../lib/chess-state.vala"
			if (rule) {
#line 567 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 2807 "chess-state.c"
			}
#line 567 "../lib/chess-state.vala"
			return result;
#line 2811 "chess-state.c"
		}
	}
#line 571 "../lib/chess-state.vala"
	_tmp1_ = self->current_player;
#line 571 "../lib/chess-state.vala"
	if (!chess_state_can_move (self, _tmp1_)) {
#line 573 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_STALEMATE;
#line 574 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 574 "../lib/chess-state.vala"
		if (rule) {
#line 574 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 2826 "chess-state.c"
		}
#line 574 "../lib/chess-state.vala"
		return result;
#line 2830 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	_tmp4_ = self->last_move;
#line 577 "../lib/chess-state.vala"
	if (_tmp4_ != NULL) {
#line 2836 "chess-state.c"
		ChessMove* _tmp5_;
		ChessPiece* _tmp6_;
#line 577 "../lib/chess-state.vala"
		_tmp5_ = self->last_move;
#line 577 "../lib/chess-state.vala"
		_tmp6_ = _tmp5_->victim;
#line 577 "../lib/chess-state.vala"
		_tmp3_ = _tmp6_ != NULL;
#line 2845 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp3_ = FALSE;
#line 2849 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp3_) {
#line 577 "../lib/chess-state.vala"
		_tmp2_ = !chess_state_have_sufficient_material (self);
#line 2855 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp2_ = FALSE;
#line 2859 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp2_) {
#line 579 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_INSUFFICIENT_MATERIAL;
#line 580 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 580 "../lib/chess-state.vala"
		if (rule) {
#line 580 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 2871 "chess-state.c"
		}
#line 580 "../lib/chess-state.vala"
		return result;
#line 2875 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	result = CHESS_RESULT_IN_PROGRESS;
#line 583 "../lib/chess-state.vala"
	if (rule) {
#line 583 "../lib/chess-state.vala"
		*rule = _vala_rule;
#line 2883 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	return result;
#line 2887 "chess-state.c"
}

static CheckState
chess_state_get_check_state (ChessState* self,
                             ChessPlayer* player)
{
	CheckState result;
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, 0);
#line 588 "../lib/chess-state.vala"
	if (chess_state_is_in_check (self, player)) {
#line 590 "../lib/chess-state.vala"
		if (chess_state_is_in_checkmate (self, player)) {
#line 591 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECKMATE;
#line 591 "../lib/chess-state.vala"
			return result;
#line 2907 "chess-state.c"
		} else {
#line 593 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECK;
#line 593 "../lib/chess-state.vala"
			return result;
#line 2913 "chess-state.c"
		}
	}
#line 595 "../lib/chess-state.vala"
	result = CHECK_STATE_NONE;
#line 595 "../lib/chess-state.vala"
	return result;
#line 2920 "chess-state.c"
}

static void
_vala_array_add1 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 619 "../lib/chess-state.vala"
	if ((*length) == (*size)) {
#line 619 "../lib/chess-state.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 619 "../lib/chess-state.vala"
		*array = g_renew (gint, *array, *size);
#line 2935 "chess-state.c"
	}
#line 619 "../lib/chess-state.vala"
	(*array)[(*length)++] = value;
#line 2939 "chess-state.c"
}

static void
_vala_array_add2 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 620 "../lib/chess-state.vala"
	if ((*length) == (*size)) {
#line 620 "../lib/chess-state.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 620 "../lib/chess-state.vala"
		*array = g_renew (gint, *array, *size);
#line 2954 "chess-state.c"
	}
#line 620 "../lib/chess-state.vala"
	(*array)[(*length)++] = value;
#line 2958 "chess-state.c"
}

static gint*
_vala_array_dup1 (gint* self,
                  gssize length)
{
#line 625 "../lib/chess-state.vala"
	if (length > 0) {
#line 625 "../lib/chess-state.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 2969 "chess-state.c"
	}
#line 625 "../lib/chess-state.vala"
	return NULL;
#line 2973 "chess-state.c"
}

static gint*
_vala_array_dup2 (gint* self,
                  gssize length)
{
#line 626 "../lib/chess-state.vala"
	if (length > 0) {
#line 626 "../lib/chess-state.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 2984 "chess-state.c"
	}
#line 626 "../lib/chess-state.vala"
	return NULL;
#line 2988 "chess-state.c"
}

gboolean
chess_state_get_positions_threatening_king (ChessState* self,
                                            ChessPlayer* player,
                                            gint** rank,
                                            gint* rank_length1,
                                            gint** file,
                                            gint* file_length1)
{
	gint* _vala_rank = NULL;
	gint _vala_rank_length1 = 0;
	gint* _vala_file = NULL;
	gint _vala_file_length1 = 0;
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* opponent = NULL;
	ChessPlayer* _tmp3_;
	gboolean found = FALSE;
	gint* _tmp23_;
	gint* _tmp24_;
	gboolean result;
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 600 "../lib/chess-state.vala"
	if (player->color == COLOR_WHITE) {
#line 3016 "chess-state.c"
		ChessPlayer* _tmp1_;
#line 600 "../lib/chess-state.vala"
		_tmp1_ = self->players[COLOR_BLACK];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp1_;
#line 3022 "chess-state.c"
	} else {
		ChessPlayer* _tmp2_;
#line 600 "../lib/chess-state.vala"
		_tmp2_ = self->players[COLOR_WHITE];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp2_;
#line 3029 "chess-state.c"
	}
#line 600 "../lib/chess-state.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 600 "../lib/chess-state.vala"
	opponent = _tmp3_;
#line 601 "../lib/chess-state.vala"
	found = FALSE;
#line 3037 "chess-state.c"
	{
		gint king_index = 0;
#line 604 "../lib/chess-state.vala"
		king_index = 0;
#line 3042 "chess-state.c"
		{
			gboolean _tmp4_ = FALSE;
#line 604 "../lib/chess-state.vala"
			_tmp4_ = TRUE;
#line 604 "../lib/chess-state.vala"
			while (TRUE) {
#line 3049 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp6_;
				ChessPiece* _tmp7_;
				gboolean _tmp8_ = FALSE;
				gboolean _tmp9_ = FALSE;
				ChessPiece* _tmp10_;
#line 604 "../lib/chess-state.vala"
				if (!_tmp4_) {
#line 3058 "chess-state.c"
					gint _tmp5_;
#line 604 "../lib/chess-state.vala"
					_tmp5_ = king_index;
#line 604 "../lib/chess-state.vala"
					king_index = _tmp5_ + 1;
#line 3064 "chess-state.c"
				}
#line 604 "../lib/chess-state.vala"
				_tmp4_ = FALSE;
#line 604 "../lib/chess-state.vala"
				if (!(king_index < 64)) {
#line 604 "../lib/chess-state.vala"
					break;
#line 3072 "chess-state.c"
				}
#line 606 "../lib/chess-state.vala"
				_tmp6_ = self->board[king_index];
#line 606 "../lib/chess-state.vala"
				_tmp7_ = _g_object_ref0 (_tmp6_);
#line 606 "../lib/chess-state.vala"
				p = _tmp7_;
#line 607 "../lib/chess-state.vala"
				_tmp10_ = p;
#line 607 "../lib/chess-state.vala"
				if (_tmp10_ != NULL) {
#line 3084 "chess-state.c"
					ChessPiece* _tmp11_;
					ChessPlayer* _tmp12_;
#line 607 "../lib/chess-state.vala"
					_tmp11_ = p;
#line 607 "../lib/chess-state.vala"
					_tmp12_ = _tmp11_->player;
#line 607 "../lib/chess-state.vala"
					_tmp9_ = _tmp12_ == player;
#line 3093 "chess-state.c"
				} else {
#line 607 "../lib/chess-state.vala"
					_tmp9_ = FALSE;
#line 3097 "chess-state.c"
				}
#line 607 "../lib/chess-state.vala"
				if (_tmp9_) {
#line 3101 "chess-state.c"
					ChessPiece* _tmp13_;
#line 607 "../lib/chess-state.vala"
					_tmp13_ = p;
#line 607 "../lib/chess-state.vala"
					_tmp8_ = _tmp13_->type == PIECE_TYPE_KING;
#line 3107 "chess-state.c"
				} else {
#line 607 "../lib/chess-state.vala"
					_tmp8_ = FALSE;
#line 3111 "chess-state.c"
				}
#line 607 "../lib/chess-state.vala"
				if (_tmp8_) {
#line 3115 "chess-state.c"
					gint* ranks = NULL;
					gint* _tmp14_;
					gint ranks_length1;
					gint _ranks_size_;
					gint* files = NULL;
					gint* _tmp15_;
					gint files_length1;
					gint _files_size_;
					gint* _tmp19_;
					gint _tmp19__length1;
					gint* _tmp20_;
					gint _tmp20__length1;
					gint* _tmp21_;
					gint _tmp21__length1;
					gint* _tmp22_;
					gint _tmp22__length1;
#line 610 "../lib/chess-state.vala"
					_tmp14_ = g_new0 (gint, 0);
#line 610 "../lib/chess-state.vala"
					ranks = _tmp14_;
#line 610 "../lib/chess-state.vala"
					ranks_length1 = 0;
#line 610 "../lib/chess-state.vala"
					_ranks_size_ = ranks_length1;
#line 611 "../lib/chess-state.vala"
					_tmp15_ = g_new0 (gint, 0);
#line 611 "../lib/chess-state.vala"
					files = _tmp15_;
#line 611 "../lib/chess-state.vala"
					files_length1 = 0;
#line 611 "../lib/chess-state.vala"
					_files_size_ = files_length1;
#line 3148 "chess-state.c"
					{
						gint start = 0;
#line 612 "../lib/chess-state.vala"
						start = 0;
#line 3153 "chess-state.c"
						{
							gboolean _tmp16_ = FALSE;
#line 612 "../lib/chess-state.vala"
							_tmp16_ = TRUE;
#line 612 "../lib/chess-state.vala"
							while (TRUE) {
#line 3160 "chess-state.c"
								ChessPlayer* _tmp18_;
#line 612 "../lib/chess-state.vala"
								if (!_tmp16_) {
#line 3164 "chess-state.c"
									gint _tmp17_;
#line 612 "../lib/chess-state.vala"
									_tmp17_ = start;
#line 612 "../lib/chess-state.vala"
									start = _tmp17_ + 1;
#line 3170 "chess-state.c"
								}
#line 612 "../lib/chess-state.vala"
								_tmp16_ = FALSE;
#line 612 "../lib/chess-state.vala"
								if (!(start < 64)) {
#line 612 "../lib/chess-state.vala"
									break;
#line 3178 "chess-state.c"
								}
#line 614 "../lib/chess-state.vala"
								_tmp18_ = opponent;
#line 614 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, _tmp18_, chess_state_get_rank (self, start), chess_state_get_file (self, start), chess_state_get_rank (self, king_index), chess_state_get_file (self, king_index), PIECE_TYPE_QUEEN, FALSE, FALSE)) {
#line 619 "../lib/chess-state.vala"
									_vala_array_add1 (&ranks, &ranks_length1, &_ranks_size_, chess_state_get_rank (self, start));
#line 620 "../lib/chess-state.vala"
									_vala_array_add2 (&files, &files_length1, &_files_size_, chess_state_get_file (self, start));
#line 621 "../lib/chess-state.vala"
									found = TRUE;
#line 3190 "chess-state.c"
								}
							}
						}
					}
#line 625 "../lib/chess-state.vala"
					_tmp19_ = ranks;
#line 625 "../lib/chess-state.vala"
					_tmp19__length1 = ranks_length1;
#line 625 "../lib/chess-state.vala"
					_tmp20_ = (_tmp19_ != NULL) ? _vala_array_dup1 (_tmp19_, _tmp19__length1) : _tmp19_;
#line 625 "../lib/chess-state.vala"
					_tmp20__length1 = _tmp19__length1;
#line 625 "../lib/chess-state.vala"
					_vala_rank = (g_free (_vala_rank), NULL);
#line 625 "../lib/chess-state.vala"
					_vala_rank = _tmp20_;
#line 625 "../lib/chess-state.vala"
					_vala_rank_length1 = _tmp20__length1;
#line 626 "../lib/chess-state.vala"
					_tmp21_ = files;
#line 626 "../lib/chess-state.vala"
					_tmp21__length1 = files_length1;
#line 626 "../lib/chess-state.vala"
					_tmp22_ = (_tmp21_ != NULL) ? _vala_array_dup2 (_tmp21_, _tmp21__length1) : _tmp21_;
#line 626 "../lib/chess-state.vala"
					_tmp22__length1 = _tmp21__length1;
#line 626 "../lib/chess-state.vala"
					_vala_file = (g_free (_vala_file), NULL);
#line 626 "../lib/chess-state.vala"
					_vala_file = _tmp22_;
#line 626 "../lib/chess-state.vala"
					_vala_file_length1 = _tmp22__length1;
#line 628 "../lib/chess-state.vala"
					result = found;
#line 628 "../lib/chess-state.vala"
					files = (g_free (files), NULL);
#line 628 "../lib/chess-state.vala"
					ranks = (g_free (ranks), NULL);
#line 628 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 628 "../lib/chess-state.vala"
					_g_object_unref0 (opponent);
#line 628 "../lib/chess-state.vala"
					if (rank) {
#line 628 "../lib/chess-state.vala"
						*rank = _vala_rank;
#line 3237 "chess-state.c"
					} else {
#line 628 "../lib/chess-state.vala"
						_vala_rank = (g_free (_vala_rank), NULL);
#line 3241 "chess-state.c"
					}
#line 628 "../lib/chess-state.vala"
					if (rank_length1) {
#line 628 "../lib/chess-state.vala"
						*rank_length1 = _vala_rank_length1;
#line 3247 "chess-state.c"
					}
#line 628 "../lib/chess-state.vala"
					if (file) {
#line 628 "../lib/chess-state.vala"
						*file = _vala_file;
#line 3253 "chess-state.c"
					} else {
#line 628 "../lib/chess-state.vala"
						_vala_file = (g_free (_vala_file), NULL);
#line 3257 "chess-state.c"
					}
#line 628 "../lib/chess-state.vala"
					if (file_length1) {
#line 628 "../lib/chess-state.vala"
						*file_length1 = _vala_file_length1;
#line 3263 "chess-state.c"
					}
#line 628 "../lib/chess-state.vala"
					return result;
#line 3267 "chess-state.c"
				}
#line 604 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3271 "chess-state.c"
			}
		}
	}
#line 633 "../lib/chess-state.vala"
	_tmp23_ = g_new0 (gint, 0);
#line 633 "../lib/chess-state.vala"
	_vala_rank = (g_free (_vala_rank), NULL);
#line 633 "../lib/chess-state.vala"
	_vala_rank = _tmp23_;
#line 633 "../lib/chess-state.vala"
	_vala_rank_length1 = 0;
#line 634 "../lib/chess-state.vala"
	_tmp24_ = g_new0 (gint, 0);
#line 634 "../lib/chess-state.vala"
	_vala_file = (g_free (_vala_file), NULL);
#line 634 "../lib/chess-state.vala"
	_vala_file = _tmp24_;
#line 634 "../lib/chess-state.vala"
	_vala_file_length1 = 0;
#line 635 "../lib/chess-state.vala"
	result = FALSE;
#line 635 "../lib/chess-state.vala"
	_g_object_unref0 (opponent);
#line 635 "../lib/chess-state.vala"
	if (rank) {
#line 635 "../lib/chess-state.vala"
		*rank = _vala_rank;
#line 3299 "chess-state.c"
	} else {
#line 635 "../lib/chess-state.vala"
		_vala_rank = (g_free (_vala_rank), NULL);
#line 3303 "chess-state.c"
	}
#line 635 "../lib/chess-state.vala"
	if (rank_length1) {
#line 635 "../lib/chess-state.vala"
		*rank_length1 = _vala_rank_length1;
#line 3309 "chess-state.c"
	}
#line 635 "../lib/chess-state.vala"
	if (file) {
#line 635 "../lib/chess-state.vala"
		*file = _vala_file;
#line 3315 "chess-state.c"
	} else {
#line 635 "../lib/chess-state.vala"
		_vala_file = (g_free (_vala_file), NULL);
#line 3319 "chess-state.c"
	}
#line 635 "../lib/chess-state.vala"
	if (file_length1) {
#line 635 "../lib/chess-state.vala"
		*file_length1 = _vala_file_length1;
#line 3325 "chess-state.c"
	}
#line 635 "../lib/chess-state.vala"
	return result;
#line 3329 "chess-state.c"
}

gboolean
chess_state_is_in_check (ChessState* self,
                         ChessPlayer* player)
{
	gint* rank = NULL;
	gint rank_length1 = 0;
	gint _rank_size_ = 0;
	gint* file = NULL;
	gint file_length1 = 0;
	gint _file_size_ = 0;
	gint* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	gboolean result;
#line 638 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 638 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 641 "../lib/chess-state.vala"
	_tmp4_ = chess_state_get_positions_threatening_king (self, player, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 641 "../lib/chess-state.vala"
	rank = (g_free (rank), NULL);
#line 641 "../lib/chess-state.vala"
	rank = _tmp0_;
#line 641 "../lib/chess-state.vala"
	rank_length1 = _tmp1_;
#line 641 "../lib/chess-state.vala"
	_rank_size_ = rank_length1;
#line 641 "../lib/chess-state.vala"
	file = (g_free (file), NULL);
#line 641 "../lib/chess-state.vala"
	file = _tmp2_;
#line 641 "../lib/chess-state.vala"
	file_length1 = _tmp3_;
#line 641 "../lib/chess-state.vala"
	_file_size_ = file_length1;
#line 641 "../lib/chess-state.vala"
	result = _tmp4_;
#line 641 "../lib/chess-state.vala"
	file = (g_free (file), NULL);
#line 641 "../lib/chess-state.vala"
	rank = (g_free (rank), NULL);
#line 641 "../lib/chess-state.vala"
	return result;
#line 3378 "chess-state.c"
}

static gboolean
chess_state_is_in_checkmate (ChessState* self,
                             ChessPlayer* player)
{
	gboolean result;
#line 644 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 644 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 3390 "chess-state.c"
	{
		gint piece_index = 0;
#line 647 "../lib/chess-state.vala"
		piece_index = 0;
#line 3395 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 647 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 647 "../lib/chess-state.vala"
			while (TRUE) {
#line 3402 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				gboolean _tmp4_ = FALSE;
				ChessPiece* _tmp5_;
#line 647 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3410 "chess-state.c"
					gint _tmp1_;
#line 647 "../lib/chess-state.vala"
					_tmp1_ = piece_index;
#line 647 "../lib/chess-state.vala"
					piece_index = _tmp1_ + 1;
#line 3416 "chess-state.c"
				}
#line 647 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 647 "../lib/chess-state.vala"
				if (!(piece_index < 64)) {
#line 647 "../lib/chess-state.vala"
					break;
#line 3424 "chess-state.c"
				}
#line 649 "../lib/chess-state.vala"
				_tmp2_ = self->board[piece_index];
#line 649 "../lib/chess-state.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 649 "../lib/chess-state.vala"
				p = _tmp3_;
#line 650 "../lib/chess-state.vala"
				_tmp5_ = p;
#line 650 "../lib/chess-state.vala"
				if (_tmp5_ != NULL) {
#line 3436 "chess-state.c"
					ChessPiece* _tmp6_;
					ChessPlayer* _tmp7_;
#line 650 "../lib/chess-state.vala"
					_tmp6_ = p;
#line 650 "../lib/chess-state.vala"
					_tmp7_ = _tmp6_->player;
#line 650 "../lib/chess-state.vala"
					_tmp4_ = _tmp7_ == player;
#line 3445 "chess-state.c"
				} else {
#line 650 "../lib/chess-state.vala"
					_tmp4_ = FALSE;
#line 3449 "chess-state.c"
				}
#line 650 "../lib/chess-state.vala"
				if (_tmp4_) {
#line 3453 "chess-state.c"
					{
						gint end = 0;
#line 652 "../lib/chess-state.vala"
						end = 0;
#line 3458 "chess-state.c"
						{
							gboolean _tmp8_ = FALSE;
#line 652 "../lib/chess-state.vala"
							_tmp8_ = TRUE;
#line 652 "../lib/chess-state.vala"
							while (TRUE) {
#line 652 "../lib/chess-state.vala"
								if (!_tmp8_) {
#line 3467 "chess-state.c"
									gint _tmp9_;
#line 652 "../lib/chess-state.vala"
									_tmp9_ = end;
#line 652 "../lib/chess-state.vala"
									end = _tmp9_ + 1;
#line 3473 "chess-state.c"
								}
#line 652 "../lib/chess-state.vala"
								_tmp8_ = FALSE;
#line 652 "../lib/chess-state.vala"
								if (!(end < 64)) {
#line 652 "../lib/chess-state.vala"
									break;
#line 3481 "chess-state.c"
								}
#line 654 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, piece_index), chess_state_get_file (self, piece_index), chess_state_get_rank (self, end), chess_state_get_file (self, end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 658 "../lib/chess-state.vala"
									result = FALSE;
#line 658 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 658 "../lib/chess-state.vala"
									return result;
#line 3491 "chess-state.c"
								}
							}
						}
					}
				}
#line 647 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3499 "chess-state.c"
			}
		}
	}
#line 663 "../lib/chess-state.vala"
	result = TRUE;
#line 663 "../lib/chess-state.vala"
	return result;
#line 3507 "chess-state.c"
}

gboolean
chess_state_can_move (ChessState* self,
                      ChessPlayer* player)
{
	gboolean have_pieces = FALSE;
	gboolean result;
#line 666 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 666 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 668 "../lib/chess-state.vala"
	have_pieces = FALSE;
#line 3522 "chess-state.c"
	{
		gint start = 0;
#line 670 "../lib/chess-state.vala"
		start = 0;
#line 3527 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 670 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 670 "../lib/chess-state.vala"
			while (TRUE) {
#line 3534 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				gboolean _tmp4_ = FALSE;
				ChessPiece* _tmp5_;
#line 670 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3542 "chess-state.c"
					gint _tmp1_;
#line 670 "../lib/chess-state.vala"
					_tmp1_ = start;
#line 670 "../lib/chess-state.vala"
					start = _tmp1_ + 1;
#line 3548 "chess-state.c"
				}
#line 670 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 670 "../lib/chess-state.vala"
				if (!(start < 64)) {
#line 670 "../lib/chess-state.vala"
					break;
#line 3556 "chess-state.c"
				}
#line 672 "../lib/chess-state.vala"
				_tmp2_ = self->board[start];
#line 672 "../lib/chess-state.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 672 "../lib/chess-state.vala"
				p = _tmp3_;
#line 673 "../lib/chess-state.vala"
				_tmp5_ = p;
#line 673 "../lib/chess-state.vala"
				if (_tmp5_ != NULL) {
#line 3568 "chess-state.c"
					ChessPiece* _tmp6_;
					ChessPlayer* _tmp7_;
#line 673 "../lib/chess-state.vala"
					_tmp6_ = p;
#line 673 "../lib/chess-state.vala"
					_tmp7_ = _tmp6_->player;
#line 673 "../lib/chess-state.vala"
					_tmp4_ = _tmp7_ == player;
#line 3577 "chess-state.c"
				} else {
#line 673 "../lib/chess-state.vala"
					_tmp4_ = FALSE;
#line 3581 "chess-state.c"
				}
#line 673 "../lib/chess-state.vala"
				if (_tmp4_) {
#line 675 "../lib/chess-state.vala"
					have_pieces = TRUE;
#line 3587 "chess-state.c"
					{
						gint end = 0;
#line 678 "../lib/chess-state.vala"
						end = 0;
#line 3592 "chess-state.c"
						{
							gboolean _tmp8_ = FALSE;
#line 678 "../lib/chess-state.vala"
							_tmp8_ = TRUE;
#line 678 "../lib/chess-state.vala"
							while (TRUE) {
#line 678 "../lib/chess-state.vala"
								if (!_tmp8_) {
#line 3601 "chess-state.c"
									gint _tmp9_;
#line 678 "../lib/chess-state.vala"
									_tmp9_ = end;
#line 678 "../lib/chess-state.vala"
									end = _tmp9_ + 1;
#line 3607 "chess-state.c"
								}
#line 678 "../lib/chess-state.vala"
								_tmp8_ = FALSE;
#line 678 "../lib/chess-state.vala"
								if (!(end < 64)) {
#line 678 "../lib/chess-state.vala"
									break;
#line 3615 "chess-state.c"
								}
#line 680 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, start), chess_state_get_file (self, start), chess_state_get_rank (self, end), chess_state_get_file (self, end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 684 "../lib/chess-state.vala"
									result = TRUE;
#line 684 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 684 "../lib/chess-state.vala"
									return result;
#line 3625 "chess-state.c"
								}
							}
						}
					}
				}
#line 670 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3633 "chess-state.c"
			}
		}
	}
#line 690 "../lib/chess-state.vala"
	if (have_pieces) {
#line 691 "../lib/chess-state.vala"
		result = FALSE;
#line 691 "../lib/chess-state.vala"
		return result;
#line 3643 "chess-state.c"
	} else {
#line 693 "../lib/chess-state.vala"
		result = TRUE;
#line 693 "../lib/chess-state.vala"
		return result;
#line 3649 "chess-state.c"
	}
}

gboolean
chess_state_have_sufficient_material (ChessState* self)
{
	gint white_knight_count = 0;
	gint white_bishop_count = 0;
	gboolean white_bishop_on_white_square = FALSE;
	gboolean white_bishop_on_black_square = FALSE;
	gint black_knight_count = 0;
	gint black_bishop_count = 0;
	gboolean black_bishop_on_white_square = FALSE;
	gboolean black_bishop_on_black_square = FALSE;
	gboolean result;
#line 696 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 698 "../lib/chess-state.vala"
	white_knight_count = 0;
#line 699 "../lib/chess-state.vala"
	white_bishop_count = 0;
#line 700 "../lib/chess-state.vala"
	white_bishop_on_white_square = FALSE;
#line 701 "../lib/chess-state.vala"
	white_bishop_on_black_square = FALSE;
#line 702 "../lib/chess-state.vala"
	black_knight_count = 0;
#line 703 "../lib/chess-state.vala"
	black_bishop_count = 0;
#line 704 "../lib/chess-state.vala"
	black_bishop_on_white_square = FALSE;
#line 705 "../lib/chess-state.vala"
	black_bishop_on_black_square = FALSE;
#line 3683 "chess-state.c"
	{
		gint i = 0;
#line 707 "../lib/chess-state.vala"
		i = 0;
#line 3688 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 707 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 707 "../lib/chess-state.vala"
			while (TRUE) {
#line 3695 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				ChessPiece* _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
				ChessPiece* _tmp10_;
				ChessPiece* _tmp16_;
				gboolean _tmp22_ = FALSE;
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_ = FALSE;
				gboolean _tmp25_ = FALSE;
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_ = FALSE;
				gboolean _tmp28_ = FALSE;
				gboolean _tmp29_ = FALSE;
				gboolean _tmp30_ = FALSE;
				gboolean _tmp31_ = FALSE;
#line 707 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3717 "chess-state.c"
					gint _tmp1_;
#line 707 "../lib/chess-state.vala"
					_tmp1_ = i;
#line 707 "../lib/chess-state.vala"
					i = _tmp1_ + 1;
#line 3723 "chess-state.c"
				}
#line 707 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 707 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 707 "../lib/chess-state.vala"
					break;
#line 3731 "chess-state.c"
				}
#line 709 "../lib/chess-state.vala"
				_tmp2_ = self->board[i];
#line 709 "../lib/chess-state.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 709 "../lib/chess-state.vala"
				p = _tmp3_;
#line 710 "../lib/chess-state.vala"
				_tmp4_ = p;
#line 710 "../lib/chess-state.vala"
				if (_tmp4_ == NULL) {
#line 711 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 711 "../lib/chess-state.vala"
					continue;
#line 3747 "chess-state.c"
				}
#line 714 "../lib/chess-state.vala"
				_tmp7_ = p;
#line 714 "../lib/chess-state.vala"
				if (_tmp7_->type == PIECE_TYPE_PAWN) {
#line 714 "../lib/chess-state.vala"
					_tmp6_ = TRUE;
#line 3755 "chess-state.c"
				} else {
					ChessPiece* _tmp8_;
#line 714 "../lib/chess-state.vala"
					_tmp8_ = p;
#line 714 "../lib/chess-state.vala"
					_tmp6_ = _tmp8_->type == PIECE_TYPE_ROOK;
#line 3762 "chess-state.c"
				}
#line 714 "../lib/chess-state.vala"
				if (_tmp6_) {
#line 714 "../lib/chess-state.vala"
					_tmp5_ = TRUE;
#line 3768 "chess-state.c"
				} else {
					ChessPiece* _tmp9_;
#line 714 "../lib/chess-state.vala"
					_tmp9_ = p;
#line 714 "../lib/chess-state.vala"
					_tmp5_ = _tmp9_->type == PIECE_TYPE_QUEEN;
#line 3775 "chess-state.c"
				}
#line 714 "../lib/chess-state.vala"
				if (_tmp5_) {
#line 715 "../lib/chess-state.vala"
					result = TRUE;
#line 715 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 715 "../lib/chess-state.vala"
					return result;
#line 3785 "chess-state.c"
				}
#line 718 "../lib/chess-state.vala"
				_tmp10_ = p;
#line 718 "../lib/chess-state.vala"
				if (_tmp10_->type == PIECE_TYPE_KNIGHT) {
#line 3791 "chess-state.c"
					ChessPiece* _tmp11_;
					Color _tmp12_;
					Color _tmp13_;
#line 720 "../lib/chess-state.vala"
					_tmp11_ = p;
#line 720 "../lib/chess-state.vala"
					_tmp12_ = chess_piece_get_color (_tmp11_);
#line 720 "../lib/chess-state.vala"
					_tmp13_ = _tmp12_;
#line 720 "../lib/chess-state.vala"
					if (_tmp13_ == COLOR_WHITE) {
#line 3803 "chess-state.c"
						gint _tmp14_;
#line 721 "../lib/chess-state.vala"
						_tmp14_ = white_knight_count;
#line 721 "../lib/chess-state.vala"
						white_knight_count = _tmp14_ + 1;
#line 3809 "chess-state.c"
					} else {
						gint _tmp15_;
#line 723 "../lib/chess-state.vala"
						_tmp15_ = black_knight_count;
#line 723 "../lib/chess-state.vala"
						black_knight_count = _tmp15_ + 1;
#line 3816 "chess-state.c"
					}
				}
#line 726 "../lib/chess-state.vala"
				_tmp16_ = p;
#line 726 "../lib/chess-state.vala"
				if (_tmp16_->type == PIECE_TYPE_BISHOP) {
#line 3823 "chess-state.c"
					Color color = 0;
					ChessPiece* _tmp17_;
					Color _tmp18_;
					Color _tmp19_;
#line 728 "../lib/chess-state.vala"
					color = COLOR_BLACK;
#line 729 "../lib/chess-state.vala"
					if (((i + (i / 8)) % 2) != 0) {
#line 730 "../lib/chess-state.vala"
						color = COLOR_WHITE;
#line 3834 "chess-state.c"
					}
#line 732 "../lib/chess-state.vala"
					_tmp17_ = p;
#line 732 "../lib/chess-state.vala"
					_tmp18_ = chess_piece_get_color (_tmp17_);
#line 732 "../lib/chess-state.vala"
					_tmp19_ = _tmp18_;
#line 732 "../lib/chess-state.vala"
					if (_tmp19_ == COLOR_WHITE) {
#line 3844 "chess-state.c"
						gint _tmp20_;
#line 734 "../lib/chess-state.vala"
						if (color == COLOR_WHITE) {
#line 735 "../lib/chess-state.vala"
							white_bishop_on_white_square = TRUE;
#line 3850 "chess-state.c"
						} else {
#line 737 "../lib/chess-state.vala"
							white_bishop_on_black_square = TRUE;
#line 3854 "chess-state.c"
						}
#line 738 "../lib/chess-state.vala"
						_tmp20_ = white_bishop_count;
#line 738 "../lib/chess-state.vala"
						white_bishop_count = _tmp20_ + 1;
#line 3860 "chess-state.c"
					} else {
						gint _tmp21_;
#line 742 "../lib/chess-state.vala"
						if (color == COLOR_WHITE) {
#line 743 "../lib/chess-state.vala"
							black_bishop_on_white_square = TRUE;
#line 3867 "chess-state.c"
						} else {
#line 745 "../lib/chess-state.vala"
							black_bishop_on_black_square = TRUE;
#line 3871 "chess-state.c"
						}
#line 746 "../lib/chess-state.vala"
						_tmp21_ = black_bishop_count;
#line 746 "../lib/chess-state.vala"
						black_bishop_count = _tmp21_ + 1;
#line 3877 "chess-state.c"
					}
				}
#line 780 "../lib/chess-state.vala"
				if (white_knight_count > 1) {
#line 780 "../lib/chess-state.vala"
					_tmp22_ = TRUE;
#line 3884 "chess-state.c"
				} else {
#line 780 "../lib/chess-state.vala"
					_tmp22_ = black_knight_count > 1;
#line 3888 "chess-state.c"
				}
#line 780 "../lib/chess-state.vala"
				if (_tmp22_) {
#line 781 "../lib/chess-state.vala"
					result = TRUE;
#line 781 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 781 "../lib/chess-state.vala"
					return result;
#line 3898 "chess-state.c"
				}
#line 784 "../lib/chess-state.vala"
				if (white_bishop_count > 0) {
#line 784 "../lib/chess-state.vala"
					_tmp23_ = white_knight_count > 0;
#line 3904 "chess-state.c"
				} else {
#line 784 "../lib/chess-state.vala"
					_tmp23_ = FALSE;
#line 3908 "chess-state.c"
				}
#line 784 "../lib/chess-state.vala"
				if (_tmp23_) {
#line 785 "../lib/chess-state.vala"
					result = TRUE;
#line 785 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 785 "../lib/chess-state.vala"
					return result;
#line 3918 "chess-state.c"
				}
#line 786 "../lib/chess-state.vala"
				if (black_bishop_count > 0) {
#line 786 "../lib/chess-state.vala"
					_tmp24_ = black_knight_count > 0;
#line 3924 "chess-state.c"
				} else {
#line 786 "../lib/chess-state.vala"
					_tmp24_ = FALSE;
#line 3928 "chess-state.c"
				}
#line 786 "../lib/chess-state.vala"
				if (_tmp24_) {
#line 787 "../lib/chess-state.vala"
					result = TRUE;
#line 787 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 787 "../lib/chess-state.vala"
					return result;
#line 3938 "chess-state.c"
				}
#line 790 "../lib/chess-state.vala"
				if (white_bishop_on_white_square) {
#line 790 "../lib/chess-state.vala"
					_tmp25_ = white_bishop_on_black_square;
#line 3944 "chess-state.c"
				} else {
#line 790 "../lib/chess-state.vala"
					_tmp25_ = FALSE;
#line 3948 "chess-state.c"
				}
#line 790 "../lib/chess-state.vala"
				if (_tmp25_) {
#line 791 "../lib/chess-state.vala"
					result = TRUE;
#line 791 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 791 "../lib/chess-state.vala"
					return result;
#line 3958 "chess-state.c"
				}
#line 792 "../lib/chess-state.vala"
				if (black_bishop_on_white_square) {
#line 792 "../lib/chess-state.vala"
					_tmp26_ = black_bishop_on_black_square;
#line 3964 "chess-state.c"
				} else {
#line 792 "../lib/chess-state.vala"
					_tmp26_ = FALSE;
#line 3968 "chess-state.c"
				}
#line 792 "../lib/chess-state.vala"
				if (_tmp26_) {
#line 793 "../lib/chess-state.vala"
					result = TRUE;
#line 793 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 793 "../lib/chess-state.vala"
					return result;
#line 3978 "chess-state.c"
				}
#line 796 "../lib/chess-state.vala"
				if (white_bishop_count > 0) {
#line 796 "../lib/chess-state.vala"
					_tmp28_ = TRUE;
#line 3984 "chess-state.c"
				} else {
#line 796 "../lib/chess-state.vala"
					_tmp28_ = white_knight_count > 0;
#line 3988 "chess-state.c"
				}
#line 796 "../lib/chess-state.vala"
				if (_tmp28_) {
#line 796 "../lib/chess-state.vala"
					_tmp27_ = black_knight_count > 0;
#line 3994 "chess-state.c"
				} else {
#line 796 "../lib/chess-state.vala"
					_tmp27_ = FALSE;
#line 3998 "chess-state.c"
				}
#line 796 "../lib/chess-state.vala"
				if (_tmp27_) {
#line 797 "../lib/chess-state.vala"
					result = TRUE;
#line 797 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 797 "../lib/chess-state.vala"
					return result;
#line 4008 "chess-state.c"
				}
#line 798 "../lib/chess-state.vala"
				if (black_bishop_count > 0) {
#line 798 "../lib/chess-state.vala"
					_tmp30_ = TRUE;
#line 4014 "chess-state.c"
				} else {
#line 798 "../lib/chess-state.vala"
					_tmp30_ = black_knight_count > 0;
#line 4018 "chess-state.c"
				}
#line 798 "../lib/chess-state.vala"
				if (_tmp30_) {
#line 798 "../lib/chess-state.vala"
					_tmp29_ = white_knight_count > 0;
#line 4024 "chess-state.c"
				} else {
#line 798 "../lib/chess-state.vala"
					_tmp29_ = FALSE;
#line 4028 "chess-state.c"
				}
#line 798 "../lib/chess-state.vala"
				if (_tmp29_) {
#line 799 "../lib/chess-state.vala"
					result = TRUE;
#line 799 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 799 "../lib/chess-state.vala"
					return result;
#line 4038 "chess-state.c"
				}
#line 802 "../lib/chess-state.vala"
				if (white_bishop_count > 0) {
#line 802 "../lib/chess-state.vala"
					_tmp31_ = black_bishop_count > 0;
#line 4044 "chess-state.c"
				} else {
#line 802 "../lib/chess-state.vala"
					_tmp31_ = FALSE;
#line 4048 "chess-state.c"
				}
#line 802 "../lib/chess-state.vala"
				if (_tmp31_) {
#line 4052 "chess-state.c"
					gboolean _tmp32_ = FALSE;
#line 804 "../lib/chess-state.vala"
					if (white_bishop_on_white_square) {
#line 804 "../lib/chess-state.vala"
						_tmp32_ = black_bishop_on_black_square;
#line 4058 "chess-state.c"
					} else {
#line 804 "../lib/chess-state.vala"
						_tmp32_ = FALSE;
#line 4062 "chess-state.c"
					}
#line 804 "../lib/chess-state.vala"
					if (_tmp32_) {
#line 805 "../lib/chess-state.vala"
						result = TRUE;
#line 805 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 805 "../lib/chess-state.vala"
						return result;
#line 4072 "chess-state.c"
					} else {
						gboolean _tmp33_ = FALSE;
#line 806 "../lib/chess-state.vala"
						if (white_bishop_on_black_square) {
#line 806 "../lib/chess-state.vala"
							_tmp33_ = black_bishop_on_white_square;
#line 4079 "chess-state.c"
						} else {
#line 806 "../lib/chess-state.vala"
							_tmp33_ = FALSE;
#line 4083 "chess-state.c"
						}
#line 806 "../lib/chess-state.vala"
						if (_tmp33_) {
#line 807 "../lib/chess-state.vala"
							result = TRUE;
#line 807 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 807 "../lib/chess-state.vala"
							return result;
#line 4093 "chess-state.c"
						}
					}
				}
#line 707 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 4099 "chess-state.c"
			}
		}
	}
#line 811 "../lib/chess-state.vala"
	result = FALSE;
#line 811 "../lib/chess-state.vala"
	return result;
#line 4107 "chess-state.c"
}

static gboolean
chess_state_decode_piece_type (ChessState* self,
                               gunichar c,
                               PieceType* type)
{
	PieceType _vala_type = 0;
	gboolean result;
#line 814 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 816 "../lib/chess-state.vala"
	_vala_type = PIECE_TYPE_PAWN;
#line 817 "../lib/chess-state.vala"
	switch (c) {
#line 817 "../lib/chess-state.vala"
		case 'P':
#line 4125 "chess-state.c"
		{
#line 820 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_PAWN;
#line 821 "../lib/chess-state.vala"
			result = TRUE;
#line 821 "../lib/chess-state.vala"
			if (type) {
#line 821 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4135 "chess-state.c"
			}
#line 821 "../lib/chess-state.vala"
			return result;
#line 4139 "chess-state.c"
		}
#line 817 "../lib/chess-state.vala"
		case 'R':
#line 4143 "chess-state.c"
		{
#line 823 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_ROOK;
#line 824 "../lib/chess-state.vala"
			result = TRUE;
#line 824 "../lib/chess-state.vala"
			if (type) {
#line 824 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4153 "chess-state.c"
			}
#line 824 "../lib/chess-state.vala"
			return result;
#line 4157 "chess-state.c"
		}
#line 817 "../lib/chess-state.vala"
		case 'N':
#line 4161 "chess-state.c"
		{
#line 826 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KNIGHT;
#line 827 "../lib/chess-state.vala"
			result = TRUE;
#line 827 "../lib/chess-state.vala"
			if (type) {
#line 827 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4171 "chess-state.c"
			}
#line 827 "../lib/chess-state.vala"
			return result;
#line 4175 "chess-state.c"
		}
#line 817 "../lib/chess-state.vala"
		case 'B':
#line 4179 "chess-state.c"
		{
#line 829 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_BISHOP;
#line 830 "../lib/chess-state.vala"
			result = TRUE;
#line 830 "../lib/chess-state.vala"
			if (type) {
#line 830 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4189 "chess-state.c"
			}
#line 830 "../lib/chess-state.vala"
			return result;
#line 4193 "chess-state.c"
		}
#line 817 "../lib/chess-state.vala"
		case 'Q':
#line 4197 "chess-state.c"
		{
#line 832 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_QUEEN;
#line 833 "../lib/chess-state.vala"
			result = TRUE;
#line 833 "../lib/chess-state.vala"
			if (type) {
#line 833 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4207 "chess-state.c"
			}
#line 833 "../lib/chess-state.vala"
			return result;
#line 4211 "chess-state.c"
		}
#line 817 "../lib/chess-state.vala"
		case 'K':
#line 4215 "chess-state.c"
		{
#line 835 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KING;
#line 836 "../lib/chess-state.vala"
			result = TRUE;
#line 836 "../lib/chess-state.vala"
			if (type) {
#line 836 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4225 "chess-state.c"
			}
#line 836 "../lib/chess-state.vala"
			return result;
#line 4229 "chess-state.c"
		}
		default:
		{
#line 838 "../lib/chess-state.vala"
			result = FALSE;
#line 838 "../lib/chess-state.vala"
			if (type) {
#line 838 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4239 "chess-state.c"
			}
#line 838 "../lib/chess-state.vala"
			return result;
#line 4243 "chess-state.c"
		}
	}
}

static gboolean
chess_state_decode_move (ChessState* self,
                         ChessPlayer* player,
                         const gchar* move,
                         gint* r0,
                         gint* f0,
                         gint* r1,
                         gint* f1,
                         PieceType* promotion_type)
{
	gint _vala_r0 = 0;
	gint _vala_f0 = 0;
	gint _vala_r1 = 0;
	gint _vala_f1 = 0;
	PieceType _vala_promotion_type = 0;
	gint i = 0;
	gboolean result;
#line 842 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 842 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 842 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 844 "../lib/chess-state.vala"
	i = 0;
#line 846 "../lib/chess-state.vala"
	_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 847 "../lib/chess-state.vala"
	if (g_str_has_prefix (move, "O-O-O")) {
#line 4277 "chess-state.c"
		gint _tmp0_;
		gint _tmp1_;
#line 849 "../lib/chess-state.vala"
		if (player->color == COLOR_WHITE) {
#line 850 "../lib/chess-state.vala"
			_vala_r1 = 0;
#line 850 "../lib/chess-state.vala"
			_vala_r0 = _vala_r1;
#line 4286 "chess-state.c"
		} else {
#line 852 "../lib/chess-state.vala"
			_vala_r1 = 7;
#line 852 "../lib/chess-state.vala"
			_vala_r0 = _vala_r1;
#line 4292 "chess-state.c"
		}
#line 853 "../lib/chess-state.vala"
		_vala_f0 = 4;
#line 854 "../lib/chess-state.vala"
		_vala_f1 = 2;
#line 855 "../lib/chess-state.vala"
		_tmp0_ = strlen ("O-O-O");
#line 855 "../lib/chess-state.vala"
		_tmp1_ = _tmp0_;
#line 855 "../lib/chess-state.vala"
		i += (gint) _tmp1_;
#line 4304 "chess-state.c"
	} else {
#line 857 "../lib/chess-state.vala"
		if (g_str_has_prefix (move, "O-O")) {
#line 4308 "chess-state.c"
			gint _tmp2_;
			gint _tmp3_;
#line 859 "../lib/chess-state.vala"
			if (player->color == COLOR_WHITE) {
#line 860 "../lib/chess-state.vala"
				_vala_r1 = 0;
#line 860 "../lib/chess-state.vala"
				_vala_r0 = _vala_r1;
#line 4317 "chess-state.c"
			} else {
#line 862 "../lib/chess-state.vala"
				_vala_r1 = 7;
#line 862 "../lib/chess-state.vala"
				_vala_r0 = _vala_r1;
#line 4323 "chess-state.c"
			}
#line 863 "../lib/chess-state.vala"
			_vala_f0 = 4;
#line 864 "../lib/chess-state.vala"
			_vala_f1 = 6;
#line 865 "../lib/chess-state.vala"
			_tmp2_ = strlen ("O-O");
#line 865 "../lib/chess-state.vala"
			_tmp3_ = _tmp2_;
#line 865 "../lib/chess-state.vala"
			i += (gint) _tmp3_;
#line 4335 "chess-state.c"
		} else {
			PieceType type = 0;
			PieceType _tmp4_ = 0;
			gboolean _tmp5_;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp25_ = FALSE;
			gboolean _tmp26_ = FALSE;
#line 869 "../lib/chess-state.vala"
			type = PIECE_TYPE_PAWN;
#line 870 "../lib/chess-state.vala"
			_tmp5_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) i), &_tmp4_);
#line 870 "../lib/chess-state.vala"
			type = _tmp4_;
#line 870 "../lib/chess-state.vala"
			if (_tmp5_) {
#line 4355 "chess-state.c"
				gint _tmp6_;
#line 871 "../lib/chess-state.vala"
				_tmp6_ = i;
#line 871 "../lib/chess-state.vala"
				i = _tmp6_ + 1;
#line 4361 "chess-state.c"
			}
#line 873 "../lib/chess-state.vala"
			_vala_f1 = -1;
#line 873 "../lib/chess-state.vala"
			_vala_r1 = _vala_f1;
#line 873 "../lib/chess-state.vala"
			_vala_f0 = _vala_r1;
#line 873 "../lib/chess-state.vala"
			_vala_r0 = _vala_f0;
#line 874 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= 'a') {
#line 874 "../lib/chess-state.vala"
				_tmp7_ = string_get (move, (glong) i) <= 'h';
#line 4375 "chess-state.c"
			} else {
#line 874 "../lib/chess-state.vala"
				_tmp7_ = FALSE;
#line 4379 "chess-state.c"
			}
#line 874 "../lib/chess-state.vala"
			if (_tmp7_) {
#line 4383 "chess-state.c"
				gint _tmp8_;
#line 876 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) i) - 'a');
#line 877 "../lib/chess-state.vala"
				_tmp8_ = i;
#line 877 "../lib/chess-state.vala"
				i = _tmp8_ + 1;
#line 4391 "chess-state.c"
			}
#line 879 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= '1') {
#line 879 "../lib/chess-state.vala"
				_tmp9_ = string_get (move, (glong) i) <= '8';
#line 4397 "chess-state.c"
			} else {
#line 879 "../lib/chess-state.vala"
				_tmp9_ = FALSE;
#line 4401 "chess-state.c"
			}
#line 879 "../lib/chess-state.vala"
			if (_tmp9_) {
#line 4405 "chess-state.c"
				gint _tmp10_;
#line 881 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) i) - '1');
#line 882 "../lib/chess-state.vala"
				_tmp10_ = i;
#line 882 "../lib/chess-state.vala"
				i = _tmp10_ + 1;
#line 4413 "chess-state.c"
			}
#line 884 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) == 'x') {
#line 884 "../lib/chess-state.vala"
				_tmp11_ = TRUE;
#line 4419 "chess-state.c"
			} else {
#line 884 "../lib/chess-state.vala"
				_tmp11_ = string_get (move, (glong) i) == '-';
#line 4423 "chess-state.c"
			}
#line 884 "../lib/chess-state.vala"
			if (_tmp11_) {
#line 4427 "chess-state.c"
				gint _tmp12_;
#line 885 "../lib/chess-state.vala"
				_tmp12_ = i;
#line 885 "../lib/chess-state.vala"
				i = _tmp12_ + 1;
#line 4433 "chess-state.c"
			}
#line 886 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= 'a') {
#line 886 "../lib/chess-state.vala"
				_tmp13_ = string_get (move, (glong) i) <= 'h';
#line 4439 "chess-state.c"
			} else {
#line 886 "../lib/chess-state.vala"
				_tmp13_ = FALSE;
#line 4443 "chess-state.c"
			}
#line 886 "../lib/chess-state.vala"
			if (_tmp13_) {
#line 4447 "chess-state.c"
				gint _tmp14_;
#line 888 "../lib/chess-state.vala"
				_vala_f0 = _vala_f1;
#line 889 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) i) - 'a');
#line 890 "../lib/chess-state.vala"
				_tmp14_ = i;
#line 890 "../lib/chess-state.vala"
				i = _tmp14_ + 1;
#line 4457 "chess-state.c"
			}
#line 892 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= '1') {
#line 892 "../lib/chess-state.vala"
				_tmp15_ = string_get (move, (glong) i) <= '8';
#line 4463 "chess-state.c"
			} else {
#line 892 "../lib/chess-state.vala"
				_tmp15_ = FALSE;
#line 4467 "chess-state.c"
			}
#line 892 "../lib/chess-state.vala"
			if (_tmp15_) {
#line 4471 "chess-state.c"
				gint _tmp16_;
#line 894 "../lib/chess-state.vala"
				_vala_r0 = _vala_r1;
#line 895 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) i) - '1');
#line 896 "../lib/chess-state.vala"
				_tmp16_ = i;
#line 896 "../lib/chess-state.vala"
				i = _tmp16_ + 1;
#line 4481 "chess-state.c"
			}
#line 898 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) == '=') {
#line 4485 "chess-state.c"
				gint _tmp17_;
				PieceType _tmp18_ = 0;
				gboolean _tmp19_;
#line 900 "../lib/chess-state.vala"
				_tmp17_ = i;
#line 900 "../lib/chess-state.vala"
				i = _tmp17_ + 1;
#line 901 "../lib/chess-state.vala"
				_tmp19_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) i), &_tmp18_);
#line 901 "../lib/chess-state.vala"
				_vala_promotion_type = _tmp18_;
#line 901 "../lib/chess-state.vala"
				if (_tmp19_) {
#line 4499 "chess-state.c"
					gint _tmp20_;
#line 902 "../lib/chess-state.vala"
					_tmp20_ = i;
#line 902 "../lib/chess-state.vala"
					i = _tmp20_ + 1;
#line 4505 "chess-state.c"
				}
			} else {
#line 904 "../lib/chess-state.vala"
				if (string_get (move, (glong) i) != '\0') {
#line 906 "../lib/chess-state.vala"
					switch (string_get (move, (glong) i)) {
#line 906 "../lib/chess-state.vala"
						case 'q':
#line 906 "../lib/chess-state.vala"
						case 'Q':
#line 4516 "chess-state.c"
						{
							gint _tmp21_;
#line 910 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 911 "../lib/chess-state.vala"
							_tmp21_ = i;
#line 911 "../lib/chess-state.vala"
							i = _tmp21_ + 1;
#line 912 "../lib/chess-state.vala"
							break;
#line 4527 "chess-state.c"
						}
#line 906 "../lib/chess-state.vala"
						case 'n':
#line 906 "../lib/chess-state.vala"
						case 'N':
#line 4533 "chess-state.c"
						{
							gint _tmp22_;
#line 915 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_KNIGHT;
#line 916 "../lib/chess-state.vala"
							_tmp22_ = i;
#line 916 "../lib/chess-state.vala"
							i = _tmp22_ + 1;
#line 917 "../lib/chess-state.vala"
							break;
#line 4544 "chess-state.c"
						}
#line 906 "../lib/chess-state.vala"
						case 'r':
#line 906 "../lib/chess-state.vala"
						case 'R':
#line 4550 "chess-state.c"
						{
							gint _tmp23_;
#line 920 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_ROOK;
#line 921 "../lib/chess-state.vala"
							_tmp23_ = i;
#line 921 "../lib/chess-state.vala"
							i = _tmp23_ + 1;
#line 922 "../lib/chess-state.vala"
							break;
#line 4561 "chess-state.c"
						}
#line 906 "../lib/chess-state.vala"
						case 'b':
#line 906 "../lib/chess-state.vala"
						case 'B':
#line 4567 "chess-state.c"
						{
							gint _tmp24_;
#line 925 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_BISHOP;
#line 926 "../lib/chess-state.vala"
							_tmp24_ = i;
#line 926 "../lib/chess-state.vala"
							i = _tmp24_ + 1;
#line 927 "../lib/chess-state.vala"
							break;
#line 4578 "chess-state.c"
						}
						default:
#line 906 "../lib/chess-state.vala"
						break;
#line 4583 "chess-state.c"
					}
				}
			}
#line 932 "../lib/chess-state.vala"
			if (_vala_r1 < 0) {
#line 932 "../lib/chess-state.vala"
				_tmp25_ = TRUE;
#line 4591 "chess-state.c"
			} else {
#line 932 "../lib/chess-state.vala"
				_tmp25_ = _vala_f1 < 0;
#line 4595 "chess-state.c"
			}
#line 932 "../lib/chess-state.vala"
			if (_tmp25_) {
#line 934 "../lib/chess-state.vala"
				g_debug ("chess-state.vala:934: Move %s missing destination", move);
#line 935 "../lib/chess-state.vala"
				result = FALSE;
#line 935 "../lib/chess-state.vala"
				if (r0) {
#line 935 "../lib/chess-state.vala"
					*r0 = _vala_r0;
#line 4607 "chess-state.c"
				}
#line 935 "../lib/chess-state.vala"
				if (f0) {
#line 935 "../lib/chess-state.vala"
					*f0 = _vala_f0;
#line 4613 "chess-state.c"
				}
#line 935 "../lib/chess-state.vala"
				if (r1) {
#line 935 "../lib/chess-state.vala"
					*r1 = _vala_r1;
#line 4619 "chess-state.c"
				}
#line 935 "../lib/chess-state.vala"
				if (f1) {
#line 935 "../lib/chess-state.vala"
					*f1 = _vala_f1;
#line 4625 "chess-state.c"
				}
#line 935 "../lib/chess-state.vala"
				if (promotion_type) {
#line 935 "../lib/chess-state.vala"
					*promotion_type = _vala_promotion_type;
#line 4631 "chess-state.c"
				}
#line 935 "../lib/chess-state.vala"
				return result;
#line 4635 "chess-state.c"
			}
#line 939 "../lib/chess-state.vala"
			if (_vala_r0 < 0) {
#line 939 "../lib/chess-state.vala"
				_tmp26_ = TRUE;
#line 4641 "chess-state.c"
			} else {
#line 939 "../lib/chess-state.vala"
				_tmp26_ = _vala_f0 < 0;
#line 4645 "chess-state.c"
			}
#line 939 "../lib/chess-state.vala"
			if (_tmp26_) {
#line 4649 "chess-state.c"
				gint match_rank = 0;
				gint match_file = 0;
#line 941 "../lib/chess-state.vala"
				match_rank = -1;
#line 941 "../lib/chess-state.vala"
				match_file = -1;
#line 4656 "chess-state.c"
				{
					gint file = 0;
#line 943 "../lib/chess-state.vala"
					file = 0;
#line 4661 "chess-state.c"
					{
						gboolean _tmp27_ = FALSE;
#line 943 "../lib/chess-state.vala"
						_tmp27_ = TRUE;
#line 943 "../lib/chess-state.vala"
						while (TRUE) {
#line 4668 "chess-state.c"
							gboolean _tmp29_ = FALSE;
#line 943 "../lib/chess-state.vala"
							if (!_tmp27_) {
#line 4672 "chess-state.c"
								gint _tmp28_;
#line 943 "../lib/chess-state.vala"
								_tmp28_ = file;
#line 943 "../lib/chess-state.vala"
								file = _tmp28_ + 1;
#line 4678 "chess-state.c"
							}
#line 943 "../lib/chess-state.vala"
							_tmp27_ = FALSE;
#line 943 "../lib/chess-state.vala"
							if (!(file < 8)) {
#line 943 "../lib/chess-state.vala"
								break;
#line 4686 "chess-state.c"
							}
#line 945 "../lib/chess-state.vala"
							if (_vala_f0 >= 0) {
#line 945 "../lib/chess-state.vala"
								_tmp29_ = file != _vala_f0;
#line 4692 "chess-state.c"
							} else {
#line 945 "../lib/chess-state.vala"
								_tmp29_ = FALSE;
#line 4696 "chess-state.c"
							}
#line 945 "../lib/chess-state.vala"
							if (_tmp29_) {
#line 946 "../lib/chess-state.vala"
								continue;
#line 4702 "chess-state.c"
							}
							{
								gint rank = 0;
#line 948 "../lib/chess-state.vala"
								rank = 0;
#line 4708 "chess-state.c"
								{
									gboolean _tmp30_ = FALSE;
#line 948 "../lib/chess-state.vala"
									_tmp30_ = TRUE;
#line 948 "../lib/chess-state.vala"
									while (TRUE) {
#line 4715 "chess-state.c"
										gboolean _tmp32_ = FALSE;
										ChessPiece* piece = NULL;
										ChessPiece* _tmp33_;
										ChessPiece* _tmp34_;
										gboolean _tmp35_ = FALSE;
										gboolean _tmp36_ = FALSE;
										ChessPiece* _tmp37_;
#line 948 "../lib/chess-state.vala"
										if (!_tmp30_) {
#line 4725 "chess-state.c"
											gint _tmp31_;
#line 948 "../lib/chess-state.vala"
											_tmp31_ = rank;
#line 948 "../lib/chess-state.vala"
											rank = _tmp31_ + 1;
#line 4731 "chess-state.c"
										}
#line 948 "../lib/chess-state.vala"
										_tmp30_ = FALSE;
#line 948 "../lib/chess-state.vala"
										if (!(rank < 8)) {
#line 948 "../lib/chess-state.vala"
											break;
#line 4739 "chess-state.c"
										}
#line 950 "../lib/chess-state.vala"
										if (_vala_r0 >= 0) {
#line 950 "../lib/chess-state.vala"
											_tmp32_ = rank != _vala_r0;
#line 4745 "chess-state.c"
										} else {
#line 950 "../lib/chess-state.vala"
											_tmp32_ = FALSE;
#line 4749 "chess-state.c"
										}
#line 950 "../lib/chess-state.vala"
										if (_tmp32_) {
#line 951 "../lib/chess-state.vala"
											continue;
#line 4755 "chess-state.c"
										}
#line 954 "../lib/chess-state.vala"
										_tmp33_ = self->board[chess_state_get_index (self, rank, file)];
#line 954 "../lib/chess-state.vala"
										_tmp34_ = _g_object_ref0 (_tmp33_);
#line 954 "../lib/chess-state.vala"
										piece = _tmp34_;
#line 955 "../lib/chess-state.vala"
										_tmp37_ = piece;
#line 955 "../lib/chess-state.vala"
										if (_tmp37_ == NULL) {
#line 955 "../lib/chess-state.vala"
											_tmp36_ = TRUE;
#line 4769 "chess-state.c"
										} else {
											ChessPiece* _tmp38_;
#line 955 "../lib/chess-state.vala"
											_tmp38_ = piece;
#line 955 "../lib/chess-state.vala"
											_tmp36_ = _tmp38_->type != type;
#line 4776 "chess-state.c"
										}
#line 955 "../lib/chess-state.vala"
										if (_tmp36_) {
#line 955 "../lib/chess-state.vala"
											_tmp35_ = TRUE;
#line 4782 "chess-state.c"
										} else {
											ChessPiece* _tmp39_;
											ChessPlayer* _tmp40_;
#line 955 "../lib/chess-state.vala"
											_tmp39_ = piece;
#line 955 "../lib/chess-state.vala"
											_tmp40_ = _tmp39_->player;
#line 955 "../lib/chess-state.vala"
											_tmp35_ = _tmp40_ != player;
#line 4792 "chess-state.c"
										}
#line 955 "../lib/chess-state.vala"
										if (_tmp35_) {
#line 956 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 956 "../lib/chess-state.vala"
											continue;
#line 4800 "chess-state.c"
										}
#line 959 "../lib/chess-state.vala"
										if (!chess_state_move_with_coords (self, player, rank, file, _vala_r1, _vala_f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 960 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 960 "../lib/chess-state.vala"
											continue;
#line 4808 "chess-state.c"
										}
#line 963 "../lib/chess-state.vala"
										if (match_rank >= 0) {
#line 965 "../lib/chess-state.vala"
											g_debug ("chess-state.vala:965: Move %s is ambiguous", move);
#line 966 "../lib/chess-state.vala"
											result = FALSE;
#line 966 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 966 "../lib/chess-state.vala"
											if (r0) {
#line 966 "../lib/chess-state.vala"
												*r0 = _vala_r0;
#line 4822 "chess-state.c"
											}
#line 966 "../lib/chess-state.vala"
											if (f0) {
#line 966 "../lib/chess-state.vala"
												*f0 = _vala_f0;
#line 4828 "chess-state.c"
											}
#line 966 "../lib/chess-state.vala"
											if (r1) {
#line 966 "../lib/chess-state.vala"
												*r1 = _vala_r1;
#line 4834 "chess-state.c"
											}
#line 966 "../lib/chess-state.vala"
											if (f1) {
#line 966 "../lib/chess-state.vala"
												*f1 = _vala_f1;
#line 4840 "chess-state.c"
											}
#line 966 "../lib/chess-state.vala"
											if (promotion_type) {
#line 966 "../lib/chess-state.vala"
												*promotion_type = _vala_promotion_type;
#line 4846 "chess-state.c"
											}
#line 966 "../lib/chess-state.vala"
											return result;
#line 4850 "chess-state.c"
										}
#line 969 "../lib/chess-state.vala"
										match_rank = rank;
#line 970 "../lib/chess-state.vala"
										match_file = file;
#line 948 "../lib/chess-state.vala"
										_g_object_unref0 (piece);
#line 4858 "chess-state.c"
									}
								}
							}
						}
					}
				}
#line 974 "../lib/chess-state.vala"
				if (match_rank < 0) {
#line 976 "../lib/chess-state.vala"
					g_debug ("chess-state.vala:976: Move %s has no matches", move);
#line 977 "../lib/chess-state.vala"
					result = FALSE;
#line 977 "../lib/chess-state.vala"
					if (r0) {
#line 977 "../lib/chess-state.vala"
						*r0 = _vala_r0;
#line 4875 "chess-state.c"
					}
#line 977 "../lib/chess-state.vala"
					if (f0) {
#line 977 "../lib/chess-state.vala"
						*f0 = _vala_f0;
#line 4881 "chess-state.c"
					}
#line 977 "../lib/chess-state.vala"
					if (r1) {
#line 977 "../lib/chess-state.vala"
						*r1 = _vala_r1;
#line 4887 "chess-state.c"
					}
#line 977 "../lib/chess-state.vala"
					if (f1) {
#line 977 "../lib/chess-state.vala"
						*f1 = _vala_f1;
#line 4893 "chess-state.c"
					}
#line 977 "../lib/chess-state.vala"
					if (promotion_type) {
#line 977 "../lib/chess-state.vala"
						*promotion_type = _vala_promotion_type;
#line 4899 "chess-state.c"
					}
#line 977 "../lib/chess-state.vala"
					return result;
#line 4903 "chess-state.c"
				}
#line 980 "../lib/chess-state.vala"
				_vala_r0 = match_rank;
#line 981 "../lib/chess-state.vala"
				_vala_f0 = match_file;
#line 4909 "chess-state.c"
			}
		}
	}
#line 985 "../lib/chess-state.vala"
	if (string_get (move, (glong) i) == '+') {
#line 4915 "chess-state.c"
		gint _tmp41_;
#line 986 "../lib/chess-state.vala"
		_tmp41_ = i;
#line 986 "../lib/chess-state.vala"
		i = _tmp41_ + 1;
#line 4921 "chess-state.c"
	} else {
#line 987 "../lib/chess-state.vala"
		if (string_get (move, (glong) i) == '#') {
#line 4925 "chess-state.c"
			gint _tmp42_;
#line 988 "../lib/chess-state.vala"
			_tmp42_ = i;
#line 988 "../lib/chess-state.vala"
			i = _tmp42_ + 1;
#line 4931 "chess-state.c"
		}
	}
#line 990 "../lib/chess-state.vala"
	if (string_get (move, (glong) i) != '\0') {
#line 992 "../lib/chess-state.vala"
		g_debug ("chess-state.vala:992: Move %s has unexpected characters", move);
#line 993 "../lib/chess-state.vala"
		result = FALSE;
#line 993 "../lib/chess-state.vala"
		if (r0) {
#line 993 "../lib/chess-state.vala"
			*r0 = _vala_r0;
#line 4944 "chess-state.c"
		}
#line 993 "../lib/chess-state.vala"
		if (f0) {
#line 993 "../lib/chess-state.vala"
			*f0 = _vala_f0;
#line 4950 "chess-state.c"
		}
#line 993 "../lib/chess-state.vala"
		if (r1) {
#line 993 "../lib/chess-state.vala"
			*r1 = _vala_r1;
#line 4956 "chess-state.c"
		}
#line 993 "../lib/chess-state.vala"
		if (f1) {
#line 993 "../lib/chess-state.vala"
			*f1 = _vala_f1;
#line 4962 "chess-state.c"
		}
#line 993 "../lib/chess-state.vala"
		if (promotion_type) {
#line 993 "../lib/chess-state.vala"
			*promotion_type = _vala_promotion_type;
#line 4968 "chess-state.c"
		}
#line 993 "../lib/chess-state.vala"
		return result;
#line 4972 "chess-state.c"
	}
#line 996 "../lib/chess-state.vala"
	result = TRUE;
#line 996 "../lib/chess-state.vala"
	if (r0) {
#line 996 "../lib/chess-state.vala"
		*r0 = _vala_r0;
#line 4980 "chess-state.c"
	}
#line 996 "../lib/chess-state.vala"
	if (f0) {
#line 996 "../lib/chess-state.vala"
		*f0 = _vala_f0;
#line 4986 "chess-state.c"
	}
#line 996 "../lib/chess-state.vala"
	if (r1) {
#line 996 "../lib/chess-state.vala"
		*r1 = _vala_r1;
#line 4992 "chess-state.c"
	}
#line 996 "../lib/chess-state.vala"
	if (f1) {
#line 996 "../lib/chess-state.vala"
		*f1 = _vala_f1;
#line 4998 "chess-state.c"
	}
#line 996 "../lib/chess-state.vala"
	if (promotion_type) {
#line 996 "../lib/chess-state.vala"
		*promotion_type = _vala_promotion_type;
#line 5004 "chess-state.c"
	}
#line 996 "../lib/chess-state.vala"
	return result;
#line 5008 "chess-state.c"
}

ChessPlayer*
chess_state_get_opponent (ChessState* self)
{
	ChessPlayer* result;
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* _tmp1_;
#line 27 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/chess-state.vala"
	_tmp1_ = self->current_player;
#line 27 "../lib/chess-state.vala"
	if (_tmp1_->color == COLOR_WHITE) {
#line 5023 "chess-state.c"
		ChessPlayer* _tmp2_;
#line 27 "../lib/chess-state.vala"
		_tmp2_ = self->players[COLOR_BLACK];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp2_;
#line 5029 "chess-state.c"
	} else {
		ChessPlayer* _tmp3_;
#line 27 "../lib/chess-state.vala"
		_tmp3_ = self->players[COLOR_WHITE];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp3_;
#line 5036 "chess-state.c"
	}
#line 27 "../lib/chess-state.vala"
	result = _tmp0_;
#line 27 "../lib/chess-state.vala"
	return result;
#line 5042 "chess-state.c"
}

static void
chess_state_class_init (ChessStateClass * klass,
                        gpointer klass_data)
{
#line 20 "../lib/chess-state.vala"
	chess_state_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/chess-state.vala"
	g_type_class_adjust_private_offset (klass, &ChessState_private_offset);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_state_get_property;
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_state_finalize;
#line 20 "../lib/chess-state.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_STATE_OPPONENT_PROPERTY, chess_state_properties[CHESS_STATE_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5059 "chess-state.c"
}

static void
chess_state_instance_init (ChessState * self,
                           gpointer klass)
{
#line 20 "../lib/chess-state.vala"
	self->priv = chess_state_get_instance_private (self);
#line 22 "../lib/chess-state.vala"
	self->number = 0;
#line 31 "../lib/chess-state.vala"
	self->en_passant_index = -1;
#line 36 "../lib/chess-state.vala"
	self->last_move = NULL;
#line 5074 "chess-state.c"
}

static void
chess_state_finalize (GObject * obj)
{
	ChessState * self;
#line 20 "../lib/chess-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_STATE, ChessState);
#line 23 "../lib/chess-state.vala"
	_vala_array_destroy (self->players, 2, (GDestroyNotify) g_object_unref);
#line 24 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 35 "../lib/chess-state.vala"
	_vala_array_destroy (self->board, 64, (GDestroyNotify) g_object_unref);
#line 36 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (chess_state_parent_class)->finalize (obj);
#line 5093 "chess-state.c"
}

static GType
chess_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessState), 0, (GInstanceInitFunc) chess_state_instance_init, NULL };
	GType chess_state_type_id;
	chess_state_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessState", &g_define_type_info, 0);
	ChessState_private_offset = g_type_add_instance_private (chess_state_type_id, sizeof (ChessStatePrivate));
	return chess_state_type_id;
}

GType
chess_state_get_type (void)
{
	static volatile gsize chess_state_type_id__once = 0;
	if (g_once_init_enter (&chess_state_type_id__once)) {
		GType chess_state_type_id;
		chess_state_type_id = chess_state_get_type_once ();
		g_once_init_leave (&chess_state_type_id__once, chess_state_type_id);
	}
	return chess_state_type_id__once;
}

static void
_vala_chess_state_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_STATE, ChessState);
#line 20 "../lib/chess-state.vala"
	switch (property_id) {
#line 20 "../lib/chess-state.vala"
		case CHESS_STATE_OPPONENT_PROPERTY:
#line 20 "../lib/chess-state.vala"
		g_value_set_object (value, chess_state_get_opponent (self));
#line 20 "../lib/chess-state.vala"
		break;
#line 5134 "chess-state.c"
		default:
#line 20 "../lib/chess-state.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/chess-state.vala"
		break;
#line 5140 "chess-state.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

