/* gnome-chess.c generated by valac 0.56.18, the Vala compiler
 * generated from gnome-chess.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2024 Michael Catanzaro
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <adwaita.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "libchess.h"
#include "libengine.h"
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gdk/gdk.h>
#include <locale.h>

#define NEW_GAME_ACTION_NAME "new"
#define OPEN_GAME_ACTION_NAME "open"
#define SAVE_GAME_ACTION_NAME "save"
#define SAVE_GAME_AS_ACTION_NAME "save-as"
#define UNDO_MOVE_ACTION_NAME "undo"
#define RESIGN_ACTION_NAME "resign"
#define PAUSE_RESUME_ACTION_NAME "pause-resume"
#define HISTORY_GO_FIRST_ACTION_NAME "go-first"
#define HISTORY_GO_PREVIOUS_ACTION_NAME "go-previous"
#define HISTORY_GO_NEXT_ACTION_NAME "go-next"
#define HISTORY_GO_LAST_ACTION_NAME "go-last"
#define PREFERENCES_ACTION_NAME "preferences"
#define HELP_ACTION_NAME "help"
#define ABOUT_ACTION_NAME "about"
#define QUIT_ACTION_NAME "quit"
#define WIDTH_SETTINGS_KEY "width"
#define HEIGHT_SETTINGS_KEY "height"
#define MAXIMIZED_SETTINGS_KEY "maximized"
#define SHOW_MOVE_HINTS_SETTINGS_KEY "show-move-hints"
#define SHOW_BOARD_NUMBERING_SETTINGS_KEY "show-numbering"
#define PIECE_STYLE_SETTINGS_KEY "piece-theme"
#define MOVE_FORMAT_SETTINGS_KEY "move-format"
#define BOARD_ORIENTATION_SETTINGS_KEY "board-side"
#define INCREMENT_SETTINGS_KEY "timer-increment"
#define CLOCK_TYPE_SETTINGS_KEY "clock-type"
#define DURATION_SETTINGS_KEY "duration"
#define OPPONENT_SETTINGS_KEY "opponent"
#define DIFFICULTY_SETTINGS_KEY "difficulty"
#define PLAY_AS_SETTINGS_KEY "play-as"
#define LAST_PLAYED_AS_SETTINGS_KEY "last-played-as"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CHESS_APPLICATION (chess_application_get_type ())
#define CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_APPLICATION, ChessApplication))
#define CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_APPLICATION, ChessApplicationClass))
#define IS_CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_APPLICATION))
#define IS_CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_APPLICATION))
#define CHESS_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_APPLICATION, ChessApplicationClass))

typedef struct _ChessApplication ChessApplication;
typedef struct _ChessApplicationClass ChessApplicationClass;
typedef struct _ChessApplicationPrivate ChessApplicationPrivate;

#define TYPE_PREFERENCES (preferences_get_type ())
#define PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES, Preferences))
#define PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES, PreferencesClass))
#define IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES))
#define IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES))
#define PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES, PreferencesClass))

typedef struct _Preferences Preferences;
typedef struct _PreferencesClass PreferencesClass;

#define TYPE_CHESS_WINDOW (chess_window_get_type ())
#define CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_WINDOW, ChessWindow))
#define CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_WINDOW, ChessWindowClass))
#define IS_CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_WINDOW))
#define IS_CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_WINDOW))
#define CHESS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_WINDOW, ChessWindowClass))

typedef struct _ChessWindow ChessWindow;
typedef struct _ChessWindowClass ChessWindowClass;

#define TYPE_NEW_GAME_DIALOG (new_game_dialog_get_type ())
#define NEW_GAME_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_GAME_DIALOG, NewGameDialog))
#define NEW_GAME_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_GAME_DIALOG, NewGameDialogClass))
#define IS_NEW_GAME_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_GAME_DIALOG))
#define IS_NEW_GAME_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_GAME_DIALOG))
#define NEW_GAME_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_GAME_DIALOG, NewGameDialogClass))

typedef struct _NewGameDialog NewGameDialog;
typedef struct _NewGameDialogClass NewGameDialogClass;

#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
enum  {
	CHESS_APPLICATION_0_PROPERTY,
	CHESS_APPLICATION_WINDOW_PROPERTY,
	CHESS_APPLICATION_VIEW_PROPERTY,
	CHESS_APPLICATION_SCENE_PROPERTY,
	CHESS_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* chess_application_properties[CHESS_APPLICATION_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
typedef void (*ChessScenePromotionTypeCompletionHandler) (PieceType* type, gpointer user_data);
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;

#define TYPE_CHESS_VIEW (chess_view_get_type ())
#define CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_VIEW, ChessView))
#define CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_VIEW, ChessViewClass))
#define IS_CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_VIEW))
#define IS_CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_VIEW))
#define CHESS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_VIEW, ChessViewClass))

typedef struct _ChessView ChessView;
typedef struct _ChessViewClass ChessViewClass;
typedef void (*ChessApplicationPromptSaveGameCallback) (gboolean cancelled, gpointer user_data);
typedef struct _Block6Data Block6Data;
typedef void (*ChessApplicationPresentSaveDialogCallback) (gboolean saved, gpointer user_data);
typedef struct _ChessScenePrivate ChessScenePrivate;

#define TYPE_CHESS_MODEL (chess_model_get_type ())
#define CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MODEL, ChessModel))
#define CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MODEL, ChessModelClass))
#define IS_CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MODEL))
#define IS_CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MODEL))
#define CHESS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MODEL, ChessModelClass))

typedef struct _ChessModel ChessModel;
typedef struct _ChessModelClass ChessModelClass;

#define TYPE_PROMOTION_TYPE_SELECTOR_DIALOG (promotion_type_selector_dialog_get_type ())
#define PROMOTION_TYPE_SELECTOR_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG, PromotionTypeSelectorDialog))
#define PROMOTION_TYPE_SELECTOR_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG, PromotionTypeSelectorDialogClass))
#define IS_PROMOTION_TYPE_SELECTOR_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG))
#define IS_PROMOTION_TYPE_SELECTOR_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG))
#define PROMOTION_TYPE_SELECTOR_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG, PromotionTypeSelectorDialogClass))

typedef struct _PromotionTypeSelectorDialog PromotionTypeSelectorDialog;
typedef struct _PromotionTypeSelectorDialogClass PromotionTypeSelectorDialogClass;
typedef struct _Block7Data Block7Data;
typedef enum  {
	PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_QUEEN,
	PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_KNIGHT,
	PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_ROOK,
	PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_BISHOP
} PromotionTypeSelectorDialogSelectedType;

#define PROMOTION_TYPE_SELECTOR_DIALOG_TYPE_SELECTED_TYPE (promotion_type_selector_dialog_selected_type_get_type ())
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ChessApplication {
	AdwApplication parent_instance;
	ChessApplicationPrivate * priv;
};

struct _ChessApplicationClass {
	AdwApplicationClass parent_class;
};

struct _ChessApplicationPrivate {
	GSettings* settings;
	Preferences* preferences;
	ChessWindow* _window;
	NewGameDialog* new_game_dialog;
	PreferencesDialog* preferences_dialog;
	AdwAboutDialog* about_dialog;
	GtkFileDialog* open_dialog;
	GtkFileDialog* save_dialog;
	PGNGame* pgn_game;
	ChessGame* game;
	gchar* autosave_filename;
	GFile* game_file;
	gboolean game_needs_saving;
	gboolean starting;
	GList* ai_profiles;
	ChessPlayer* opponent;
	ChessPlayer* human_player;
	ChessEngine* opponent_engine;
	guint engine_timeout_source;
	gchar* copyrights;
};

struct _Block3Data {
	int _ref_count_;
	ChessApplication* self;
	ChessGame* original_game;
	ChessState* original_state;
	gchar* move;
};

struct _Block4Data {
	int _ref_count_;
	ChessApplication* self;
	ChessGame* original_game;
};

struct _Block5Data {
	int _ref_count_;
	ChessApplication* self;
	gboolean started;
	ChessGame* game;
	ChessMove* move;
};

struct _Block6Data {
	int _ref_count_;
	ChessApplication* self;
	ChessApplicationPromptSaveGameCallback callback;
	gpointer callback_target;
};

struct _ChessScene {
	GObject parent_instance;
	ChessScenePrivate * priv;
	GList* pieces;
	gboolean animating;
	gint selected_rank;
	gint selected_file;
};

struct _ChessSceneClass {
	GObjectClass parent_class;
};

struct _Block7Data {
	int _ref_count_;
	ChessApplication* self;
	PromotionTypeSelectorDialog* promotion_type_selector_dialog;
	ChessScenePromotionTypeCompletionHandler handler;
	gpointer handler_target;
	GDestroyNotify handler_target_destroy_notify;
};

struct _Block8Data {
	int _ref_count_;
	ChessApplication* self;
	AdwAlertDialog* invalid_pgn_dialog;
};

struct _Block9Data {
	int _ref_count_;
	ChessApplication* self;
	AdwAlertDialog* invalid_move_dialog;
};

struct _Block10Data {
	int _ref_count_;
	ChessApplication* self;
	ChessApplicationPresentSaveDialogCallback callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
};

static gint ChessApplication_private_offset;
static gpointer chess_application_parent_class = NULL;

VALA_EXTERN GType chess_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessApplication, g_object_unref)
VALA_EXTERN GType preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Preferences, g_object_unref)
VALA_EXTERN GType chess_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessWindow, g_object_unref)
VALA_EXTERN GType new_game_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewGameDialog, g_object_unref)
VALA_EXTERN GType preferences_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesDialog, g_object_unref)
VALA_EXTERN void chess_application_new_game_cb (ChessApplication* self);
static void _chess_application_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
VALA_EXTERN void chess_application_open_game_cb (ChessApplication* self);
static void _chess_application_open_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
VALA_EXTERN void chess_application_save_game_cb (ChessApplication* self);
static void _chess_application_save_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
VALA_EXTERN void chess_application_save_game_as_cb (ChessApplication* self);
static void _chess_application_save_game_as_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
VALA_EXTERN void chess_application_undo_move_cb (ChessApplication* self);
static void _chess_application_undo_move_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
VALA_EXTERN void chess_application_resign_cb (ChessApplication* self);
static void _chess_application_resign_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
VALA_EXTERN void chess_application_pause_resume_cb (ChessApplication* self);
static void _chess_application_pause_resume_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void chess_application_history_go_first_cb (ChessApplication* self);
static void _chess_application_history_go_first_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void chess_application_history_go_previous_cb (ChessApplication* self);
static void _chess_application_history_go_previous_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void chess_application_history_go_next_cb (ChessApplication* self);
static void _chess_application_history_go_next_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void chess_application_history_go_last_cb (ChessApplication* self);
static void _chess_application_history_go_last_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void chess_application_preferences_cb (ChessApplication* self);
static void _chess_application_preferences_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
VALA_EXTERN void chess_application_help_cb (ChessApplication* self);
static void _chess_application_help_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
VALA_EXTERN void chess_application_about_cb (ChessApplication* self);
static void _chess_application_about_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self);
VALA_EXTERN void chess_application_quit_cb (ChessApplication* self);
static void _chess_application_quit_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static ChessApplication* chess_application_new (void);
static ChessApplication* chess_application_construct (GType object_type);
static gint chess_application_real_handle_local_options (GApplication* base,
                                                  GVariantDict* options);
static void chess_application_real_startup (GApplication* base);
VALA_EXTERN Preferences* preferences_new (GSettings* settings);
VALA_EXTERN Preferences* preferences_construct (GType object_type,
                                    GSettings* settings);
VALA_EXTERN ChessWindow* chess_window_new (ChessApplication* app);
VALA_EXTERN ChessWindow* chess_window_construct (GType object_type,
                                     ChessApplication* app);
static void chess_application_set_window (ChessApplication* self,
                                   ChessWindow* value);
VALA_EXTERN ChessWindow* chess_application_get_window (ChessApplication* self);
VALA_EXTERN GType chess_scene_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessScene, g_object_unref)
VALA_EXTERN ChessScene* chess_application_get_scene (ChessApplication* self);
static gboolean __lambda38_ (ChessApplication* self,
                      ChessPlayer* p);
static gboolean ___lambda38__chess_scene_is_human (ChessScene* _sender,
                                            ChessPlayer* player,
                                            gpointer self);
static void chess_application_show_promotion_type_selector (ChessApplication* self,
                                                     ChessScenePromotionTypeCompletionHandler handler,
                                                     gpointer handler_target,
                                                     GDestroyNotify handler_target_destroy_notify);
static void _chess_application_show_promotion_type_selector_chess_scene_choose_promotion_type (ChessScene* _sender,
                                                                                        ChessScenePromotionTypeCompletionHandler handler,
                                                                                        gpointer handler_target,
                                                                                        GDestroyNotify handler_target_destroy_notify,
                                                                                        gpointer self);
static void chess_application_real_open (GApplication* base,
                                  GFile** files,
                                  gint files_length1,
                                  const gchar* hint);
static void chess_application_real_activate (GApplication* base);
static void chess_application_start_new_game (ChessApplication* self);
static void chess_application_load_game (ChessApplication* self,
                                  GFile* file);
static void chess_application_real_shutdown (GApplication* base);
static void chess_application_autosave (ChessApplication* self);
VALA_EXTERN void chess_application_quit_game (ChessApplication* self);
static void chess_application_update_pgn_time_remaining (ChessApplication* self);
static void chess_application_start_game (ChessApplication* self);
static void chess_application_game_turn_cb (ChessApplication* self,
                                     ChessGame* game,
                                     ChessPlayer* player);
static void _chess_application_game_turn_cb_chess_game_turn_started (ChessGame* _sender,
                                                              ChessPlayer* player,
                                                              gpointer self);
static void chess_application_game_move_cb (ChessApplication* self,
                                     ChessGame* game,
                                     ChessMove* move);
static void _chess_application_game_move_cb_chess_game_moved (ChessGame* _sender,
                                                       ChessMove* move,
                                                       gpointer self);
static void chess_application_game_undo_cb (ChessApplication* self,
                                     ChessGame* game);
static void _chess_application_game_undo_cb_chess_game_undo (ChessGame* _sender,
                                                      gpointer self);
static void chess_application_game_end_cb (ChessApplication* self);
static void _chess_application_game_end_cb_chess_game_ended (ChessGame* _sender,
                                                      gpointer self);
static void chess_application_show_invalid_move_dialog (ChessApplication* self,
                                                 const gchar* error_message);
static void chess_application_configure_new_game (ChessApplication* self);
VALA_EXTERN void chess_scene_set_game (ChessScene* self,
                           ChessGame* value);
VALA_EXTERN void chess_window_start_game (ChessWindow* self);
static void chess_application_engine_move_cb (ChessApplication* self,
                                       ChessEngine* engine,
                                       const gchar* move);
static void _chess_application_engine_move_cb_chess_engine_moved (ChessEngine* _sender,
                                                           const gchar* move,
                                                           gpointer self);
static void chess_application_engine_resigned_cb (ChessApplication* self,
                                           ChessEngine* engine);
static void _chess_application_engine_resigned_cb_chess_engine_resigned (ChessEngine* _sender,
                                                                  gpointer self);
static void chess_application_engine_stopped_unexpectedly_cb (ChessApplication* self,
                                                       ChessEngine* engine);
static void _chess_application_engine_stopped_unexpectedly_cb_chess_engine_stopped_unexpectedly (ChessEngine* _sender,
                                                                                          gpointer self);
static void chess_application_engine_error_cb (ChessApplication* self,
                                        ChessEngine* engine);
static void _chess_application_engine_error_cb_chess_engine_error (ChessEngine* _sender,
                                                            gpointer self);
static void chess_application_engine_claim_draw_cb (ChessApplication* self,
                                             ChessEngine* engine);
static void _chess_application_engine_claim_draw_cb_chess_engine_claim_draw (ChessEngine* _sender,
                                                                      gpointer self);
static void chess_application_engine_offer_draw_cb (ChessApplication* self,
                                             ChessEngine* engine);
static void _chess_application_engine_offer_draw_cb_chess_engine_offer_draw (ChessEngine* _sender,
                                                                      gpointer self);
static ChessEngine* chess_application_get_engine (ChessApplication* self,
                                           const gchar* name,
                                           const gchar* difficulty);
VALA_EXTERN void chess_application_disable_action (ChessApplication* self,
                                       const gchar* name);
VALA_EXTERN void chess_application_enable_action (ChessApplication* self,
                                      const gchar* name);
VALA_EXTERN void chess_window_set_clock_visible (ChessWindow* self,
                                     gboolean visible);
static void chess_application_update_action_status (ChessApplication* self);
VALA_EXTERN void chess_window_update_history_panel (ChessWindow* self);
VALA_EXTERN void chess_window_update_pause_resume_button (ChessWindow* self);
VALA_EXTERN void chess_window_update_game_status (ChessWindow* self,
                                      const gchar* title,
                                      const gchar* info);
static void chess_application_update_engine_timeout (ChessApplication* self);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup5 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup6 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup7 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup8 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup9 (gchar** self,
                          gssize length);
static void chess_application_do_engine_move (ChessApplication* self,
                                       const gchar* move);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean ___lambda32_ (Block3Data* _data3_);
static gboolean ____lambda32__gsource_func (gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda33_ (Block4Data* _data4_);
static gboolean ___lambda33__gsource_func (gpointer self);
static gboolean ___lambda29_ (ChessApplication* self);
static gboolean ____lambda29__gsource_func (gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN void chess_window_move (ChessWindow* self,
                        ChessMove* m);
VALA_EXTERN GType chess_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessView, g_object_unref)
VALA_EXTERN ChessView* chess_application_get_view (ChessApplication* self);
static gboolean __lambda27_ (Block5Data* _data5_);
static void chess_application_present_claim_draw_dialog (ChessApplication* self);
static gboolean ___lambda27__gsource_func (gpointer self);
VALA_EXTERN void chess_window_undo (ChessWindow* self);
VALA_EXTERN gchar* chess_application_compute_current_title (ChessApplication* self);
VALA_EXTERN gchar* chess_application_compute_status_info (ChessApplication* self);
VALA_EXTERN void chess_window_end_game (ChessWindow* self);
static void chess_application_prompt_save_game (ChessApplication* self,
                                         const gchar* prompt_text,
                                         ChessApplicationPromptSaveGameCallback callback,
                                         gpointer callback_target);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda21_ (Block6Data* _data6_,
                  AdwAlertDialog* dialog,
                  const gchar* response);
static void chess_application_present_save_dialog (ChessApplication* self,
                                            ChessApplicationPresentSaveDialogCallback callback,
                                            gpointer callback_target,
                                            GDestroyNotify callback_target_destroy_notify);
static void ____lambda24_ (Block6Data* _data6_,
                    gboolean saved);
static void _____lambda24__chess_application_present_save_dialog_callback (gboolean saved,
                                                                    gpointer self);
static void ___lambda21__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                             const gchar* response,
                                             gpointer self);
static void __lambda28_ (ChessApplication* self,
                  AdwAlertDialog* dialog,
                  const gchar* response);
static void ___lambda28__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                             const gchar* response,
                                             gpointer self);
static void __lambda25_ (ChessApplication* self,
                  gboolean cancelled);
static void ___lambda25__chess_application_prompt_save_game_callback (gboolean cancelled,
                                                               gpointer self);
static void __lambda37_ (ChessApplication* self,
                  AdwAlertDialog* dialog,
                  const gchar* response);
static void ___lambda37__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                             const gchar* response,
                                             gpointer self);
VALA_EXTERN GType chess_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessModel, g_object_unref)
VALA_EXTERN void chess_scene_set_move_number (ChessScene* self,
                                  gint value);
VALA_EXTERN gint chess_scene_get_move_number (ChessScene* self);
VALA_EXTERN NewGameDialog* new_game_dialog_new (Preferences* preferences,
                                    GList* ai_profiles);
VALA_EXTERN NewGameDialog* new_game_dialog_construct (GType object_type,
                                          Preferences* preferences,
                                          GList* ai_profiles);
static void __lambda26_ (ChessApplication* self);
static void ___lambda26__new_game_dialog_new_game_requested (NewGameDialog* _sender,
                                                      gpointer self);
VALA_EXTERN PreferencesDialog* preferences_dialog_new (Preferences* preferences);
VALA_EXTERN PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 Preferences* preferences);
VALA_EXTERN GType promotion_type_selector_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PromotionTypeSelectorDialog, g_object_unref)
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
VALA_EXTERN const gchar* chess_scene_get_theme_name (ChessScene* self);
VALA_EXTERN PromotionTypeSelectorDialog* promotion_type_selector_dialog_new (Color color,
                                                                 const gchar* theme);
VALA_EXTERN PromotionTypeSelectorDialog* promotion_type_selector_dialog_construct (GType object_type,
                                                                       Color color,
                                                                       const gchar* theme);
VALA_EXTERN GType promotion_type_selector_dialog_selected_type_get_type (void) G_GNUC_CONST ;
static void __lambda39_ (Block7Data* _data7_,
                  PromotionTypeSelectorDialogSelectedType selected_type);
static void ___lambda39__promotion_type_selector_dialog_piece_selected (PromotionTypeSelectorDialog* _sender,
                                                                 PromotionTypeSelectorDialogSelectedType type,
                                                                 gpointer self);
static void chess_application_run_invalid_pgn_dialog (ChessApplication* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda36_ (Block8Data* _data8_,
                  AdwAlertDialog* dialog,
                  const gchar* response);
static void ___lambda36__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                             const gchar* response,
                                             gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda30_ (Block9Data* _data9_,
                  AdwAlertDialog* dialog,
                  const gchar* response);
static void ___lambda30__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                             const gchar* response,
                                             gpointer self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda22_ (Block10Data* _data10_,
                  GObject* object,
                  GAsyncResult* _result_);
static void ___lambda23_ (Block10Data* _data10_,
                   AdwAlertDialog* dialog,
                   const gchar* response);
static void ____lambda23__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                              const gchar* response,
                                              gpointer self);
static void ___lambda22__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda34_ (ChessApplication* self,
                  gboolean cancelled);
static void __lambda35_ (ChessApplication* self,
                  GObject* object,
                  GAsyncResult* _result_);
static void ___lambda35__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ___lambda34__chess_application_prompt_save_game_callback (gboolean cancelled,
                                                               gpointer self);
static gint chess_application_main (gchar** args,
                             gint args_length1);
VALA_EXTERN ChessView* chess_window_get_view (ChessWindow* self);
VALA_EXTERN ChessScene* chess_view_get_scene (ChessView* self);
static void chess_application_finalize (GObject * obj);
static GType chess_application_get_type_once (void);
static void _vala_chess_application_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_chess_application_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry CHESS_APPLICATION_action_entries[15] = {{NEW_GAME_ACTION_NAME, _chess_application_new_game_cb_gsimple_action_activate_callback}, {OPEN_GAME_ACTION_NAME, _chess_application_open_game_cb_gsimple_action_activate_callback}, {SAVE_GAME_ACTION_NAME, _chess_application_save_game_cb_gsimple_action_activate_callback}, {SAVE_GAME_AS_ACTION_NAME, _chess_application_save_game_as_cb_gsimple_action_activate_callback}, {UNDO_MOVE_ACTION_NAME, _chess_application_undo_move_cb_gsimple_action_activate_callback}, {RESIGN_ACTION_NAME, _chess_application_resign_cb_gsimple_action_activate_callback}, {PAUSE_RESUME_ACTION_NAME, _chess_application_pause_resume_cb_gsimple_action_activate_callback}, {HISTORY_GO_FIRST_ACTION_NAME, _chess_application_history_go_first_cb_gsimple_action_activate_callback}, {HISTORY_GO_PREVIOUS_ACTION_NAME, _chess_application_history_go_previous_cb_gsimple_action_activate_callback}, {HISTORY_GO_NEXT_ACTION_NAME, _chess_application_history_go_next_cb_gsimple_action_activate_callback}, {HISTORY_GO_LAST_ACTION_NAME, _chess_application_history_go_last_cb_gsimple_action_activate_callback}, {PREFERENCES_ACTION_NAME, _chess_application_preferences_cb_gsimple_action_activate_callback}, {HELP_ACTION_NAME, _chess_application_help_cb_gsimple_action_activate_callback}, {ABOUT_ACTION_NAME, _chess_application_about_cb_gsimple_action_activate_callback}, {QUIT_ACTION_NAME, _chess_application_quit_cb_gsimple_action_activate_callback}};
static const GOptionEntry CHESS_APPLICATION_option_entries[2] = {{"version", 'v', (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Show release version"), NULL}, {NULL}};
static const gchar* CHESS_APPLICATION_authors[3] = {"Robert Ancell <robert.ancell@gmail.com>", "Michael Catanzaro <mcatanzaro@gnome.org>", NULL};
static const gchar* CHESS_APPLICATION_artists[3] = {"Max Froumentin", "Jakub Steiner", NULL};

static inline gpointer
chess_application_get_instance_private (ChessApplication* self)
{
	return G_STRUCT_MEMBER_P (self, ChessApplication_private_offset);
}

static void
_chess_application_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_new_game_cb ((ChessApplication*) self);
#line 690 "gnome-chess.c"
}

static void
_chess_application_open_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_open_game_cb ((ChessApplication*) self);
#line 700 "gnome-chess.c"
}

static void
_chess_application_save_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_save_game_cb ((ChessApplication*) self);
#line 710 "gnome-chess.c"
}

static void
_chess_application_save_game_as_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_save_game_as_cb ((ChessApplication*) self);
#line 720 "gnome-chess.c"
}

static void
_chess_application_undo_move_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_undo_move_cb ((ChessApplication*) self);
#line 730 "gnome-chess.c"
}

static void
_chess_application_resign_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_resign_cb ((ChessApplication*) self);
#line 740 "gnome-chess.c"
}

static void
_chess_application_pause_resume_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_pause_resume_cb ((ChessApplication*) self);
#line 750 "gnome-chess.c"
}

static void
_chess_application_history_go_first_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_history_go_first_cb ((ChessApplication*) self);
#line 760 "gnome-chess.c"
}

static void
_chess_application_history_go_previous_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_history_go_previous_cb ((ChessApplication*) self);
#line 770 "gnome-chess.c"
}

static void
_chess_application_history_go_next_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_history_go_next_cb ((ChessApplication*) self);
#line 780 "gnome-chess.c"
}

static void
_chess_application_history_go_last_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_history_go_last_cb ((ChessApplication*) self);
#line 790 "gnome-chess.c"
}

static void
_chess_application_preferences_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_preferences_cb ((ChessApplication*) self);
#line 800 "gnome-chess.c"
}

static void
_chess_application_help_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_help_cb ((ChessApplication*) self);
#line 810 "gnome-chess.c"
}

static void
_chess_application_about_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_about_cb ((ChessApplication*) self);
#line 820 "gnome-chess.c"
}

static void
_chess_application_quit_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 77 "../src/gnome-chess.vala"
	chess_application_quit_cb ((ChessApplication*) self);
#line 830 "gnome-chess.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 68 "../src/gnome-chess.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 838 "gnome-chess.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 68 "../src/gnome-chess.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 846 "gnome-chess.c"
}

static ChessApplication*
chess_application_construct (GType object_type)
{
	ChessApplication * self = NULL;
#line 107 "../src/gnome-chess.vala"
	self = (ChessApplication*) g_object_new (object_type, "application-id", "org.gnome.Chess", "flags", G_APPLICATION_HANDLES_OPEN, NULL);
#line 108 "../src/gnome-chess.vala"
	g_application_add_main_option_entries ((GApplication*) self, CHESS_APPLICATION_option_entries);
#line 105 "../src/gnome-chess.vala"
	return self;
#line 859 "gnome-chess.c"
}

static ChessApplication*
chess_application_new (void)
{
#line 105 "../src/gnome-chess.vala"
	return chess_application_construct (TYPE_CHESS_APPLICATION);
#line 867 "gnome-chess.c"
}

static gint
chess_application_real_handle_local_options (GApplication* base,
                                             GVariantDict* options)
{
	ChessApplication * self;
	gint result;
#line 111 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 111 "../src/gnome-chess.vala"
	g_return_val_if_fail (options != NULL, 0);
#line 113 "../src/gnome-chess.vala"
	if (g_variant_dict_contains (options, "version")) {
#line 882 "gnome-chess.c"
		FILE* _tmp0_;
#line 116 "../src/gnome-chess.vala"
		_tmp0_ = stderr;
#line 116 "../src/gnome-chess.vala"
		fprintf (_tmp0_, "gnome-chess %s\n", VERSION);
#line 117 "../src/gnome-chess.vala"
		result = EXIT_SUCCESS;
#line 117 "../src/gnome-chess.vala"
		return result;
#line 892 "gnome-chess.c"
	}
#line 121 "../src/gnome-chess.vala"
	result = -1;
#line 121 "../src/gnome-chess.vala"
	return result;
#line 898 "gnome-chess.c"
}

static gboolean
__lambda38_ (ChessApplication* self,
             ChessPlayer* p)
{
	ChessPlayer* _tmp0_;
	gboolean result;
#line 159 "../src/gnome-chess.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 159 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->human_player;
#line 159 "../src/gnome-chess.vala"
	result = p == _tmp0_;
#line 159 "../src/gnome-chess.vala"
	return result;
#line 915 "gnome-chess.c"
}

static gboolean
___lambda38__chess_scene_is_human (ChessScene* _sender,
                                   ChessPlayer* player,
                                   gpointer self)
{
	gboolean result;
	result = __lambda38_ ((ChessApplication*) self, player);
#line 159 "../src/gnome-chess.vala"
	return result;
#line 927 "gnome-chess.c"
}

static void
_chess_application_show_promotion_type_selector_chess_scene_choose_promotion_type (ChessScene* _sender,
                                                                                   ChessScenePromotionTypeCompletionHandler handler,
                                                                                   gpointer handler_target,
                                                                                   GDestroyNotify handler_target_destroy_notify,
                                                                                   gpointer self)
{
#line 160 "../src/gnome-chess.vala"
	chess_application_show_promotion_type_selector ((ChessApplication*) self, handler, handler_target, handler_target_destroy_notify);
#line 939 "gnome-chess.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 171 "../src/gnome-chess.vala"
	return self ? g_object_ref (self) : NULL;
#line 947 "gnome-chess.c"
}

static void
chess_application_real_startup (GApplication* base)
{
	ChessApplication * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	Preferences* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar** _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	gchar* _tmp22_;
	gchar** _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	gchar** _tmp26_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	gchar* _tmp28_;
	gchar** _tmp29_;
	gchar** _tmp30_;
	gint _tmp30__length1;
	gchar* _tmp31_;
	gchar** _tmp32_;
	gchar** _tmp33_;
	gint _tmp33__length1;
	gchar* _tmp34_;
	gchar** _tmp35_;
	gchar** _tmp36_;
	gint _tmp36__length1;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar** _tmp39_;
	gchar** _tmp40_;
	gint _tmp40__length1;
	ChessWindow* _tmp41_;
	ChessWindow* _tmp42_;
	ChessWindow* _tmp43_;
	GSettings* _tmp44_;
	GSettings* _tmp45_;
	GSettings* _tmp46_;
	ChessWindow* _tmp48_;
	GSettings* _tmp49_;
	ChessScene* _tmp50_;
	ChessScene* _tmp51_;
	GSettings* _tmp52_;
	ChessScene* _tmp53_;
	ChessScene* _tmp54_;
	GSettings* _tmp55_;
	ChessScene* _tmp56_;
	ChessScene* _tmp57_;
	GSettings* _tmp58_;
	ChessScene* _tmp59_;
	ChessScene* _tmp60_;
	GSettings* _tmp61_;
	ChessScene* _tmp62_;
	ChessScene* _tmp63_;
	ChessScene* _tmp64_;
	ChessScene* _tmp65_;
	ChessScene* _tmp66_;
	ChessScene* _tmp67_;
	gchar* system_engine_cfg = NULL;
	gchar* _tmp68_;
	gchar* user_engine_cfg = NULL;
	const gchar* _tmp69_;
	gchar* _tmp70_;
	const gchar* _tmp71_;
	GList* _tmp77_;
#line 124 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 126 "../src/gnome-chess.vala"
	G_APPLICATION_CLASS (chess_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_get_type (), AdwApplication));
#line 128 "../src/gnome-chess.vala"
	_tmp0_ = g_settings_new ("org.gnome.Chess");
#line 128 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->settings);
#line 128 "../src/gnome-chess.vala"
	self->priv->settings = _tmp0_;
#line 129 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->settings;
#line 129 "../src/gnome-chess.vala"
	_tmp2_ = preferences_new (_tmp1_);
#line 129 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->preferences);
#line 129 "../src/gnome-chess.vala"
	self->priv->preferences = _tmp2_;
#line 131 "../src/gnome-chess.vala"
	g_action_map_add_action_entries ((GActionMap*) self, CHESS_APPLICATION_action_entries, (gint) G_N_ELEMENTS (CHESS_APPLICATION_action_entries), self);
#line 132 "../src/gnome-chess.vala"
	_tmp3_ = g_strdup ("<Control>n");
#line 132 "../src/gnome-chess.vala"
	_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 132 "../src/gnome-chess.vala"
	_tmp4_[0] = _tmp3_;
#line 132 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 132 "../src/gnome-chess.vala"
	_tmp5__length1 = 1;
#line 132 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." NEW_GAME_ACTION_NAME, _tmp5_);
#line 132 "../src/gnome-chess.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 133 "../src/gnome-chess.vala"
	_tmp6_ = g_strdup ("<Control>o");
#line 133 "../src/gnome-chess.vala"
	_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 133 "../src/gnome-chess.vala"
	_tmp7_[0] = _tmp6_;
#line 133 "../src/gnome-chess.vala"
	_tmp8_ = _tmp7_;
#line 133 "../src/gnome-chess.vala"
	_tmp8__length1 = 1;
#line 133 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." OPEN_GAME_ACTION_NAME, _tmp8_);
#line 133 "../src/gnome-chess.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 134 "../src/gnome-chess.vala"
	_tmp9_ = g_strdup ("<Control>s");
#line 134 "../src/gnome-chess.vala"
	_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 134 "../src/gnome-chess.vala"
	_tmp10_[0] = _tmp9_;
#line 134 "../src/gnome-chess.vala"
	_tmp11_ = _tmp10_;
#line 134 "../src/gnome-chess.vala"
	_tmp11__length1 = 1;
#line 134 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." SAVE_GAME_ACTION_NAME, _tmp11_);
#line 134 "../src/gnome-chess.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 135 "../src/gnome-chess.vala"
	_tmp12_ = g_strdup ("<Shift><Control>s");
#line 135 "../src/gnome-chess.vala"
	_tmp13_ = g_new0 (gchar*, 1 + 1);
#line 135 "../src/gnome-chess.vala"
	_tmp13_[0] = _tmp12_;
#line 135 "../src/gnome-chess.vala"
	_tmp14_ = _tmp13_;
#line 135 "../src/gnome-chess.vala"
	_tmp14__length1 = 1;
#line 135 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." SAVE_GAME_AS_ACTION_NAME, _tmp14_);
#line 135 "../src/gnome-chess.vala"
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
#line 136 "../src/gnome-chess.vala"
	_tmp15_ = g_strdup ("<Control>z");
#line 136 "../src/gnome-chess.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 136 "../src/gnome-chess.vala"
	_tmp16_[0] = _tmp15_;
#line 136 "../src/gnome-chess.vala"
	_tmp17_ = _tmp16_;
#line 136 "../src/gnome-chess.vala"
	_tmp17__length1 = 1;
#line 136 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." UNDO_MOVE_ACTION_NAME, _tmp17_);
#line 136 "../src/gnome-chess.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 137 "../src/gnome-chess.vala"
	_tmp18_ = g_strdup ("<Control>p");
#line 137 "../src/gnome-chess.vala"
	_tmp19_ = g_strdup ("Pause");
#line 137 "../src/gnome-chess.vala"
	_tmp20_ = g_new0 (gchar*, 2 + 1);
#line 137 "../src/gnome-chess.vala"
	_tmp20_[0] = _tmp18_;
#line 137 "../src/gnome-chess.vala"
	_tmp20_[1] = _tmp19_;
#line 137 "../src/gnome-chess.vala"
	_tmp21_ = _tmp20_;
#line 137 "../src/gnome-chess.vala"
	_tmp21__length1 = 2;
#line 137 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." PAUSE_RESUME_ACTION_NAME, _tmp21_);
#line 137 "../src/gnome-chess.vala"
	_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 139 "../src/gnome-chess.vala"
	_tmp22_ = g_strdup ("Up");
#line 139 "../src/gnome-chess.vala"
	_tmp23_ = g_new0 (gchar*, 1 + 1);
#line 139 "../src/gnome-chess.vala"
	_tmp23_[0] = _tmp22_;
#line 139 "../src/gnome-chess.vala"
	_tmp24_ = _tmp23_;
#line 139 "../src/gnome-chess.vala"
	_tmp24__length1 = 1;
#line 139 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HISTORY_GO_FIRST_ACTION_NAME, _tmp24_);
#line 139 "../src/gnome-chess.vala"
	_tmp24_ = (_vala_array_free (_tmp24_, _tmp24__length1, (GDestroyNotify) g_free), NULL);
#line 140 "../src/gnome-chess.vala"
	_tmp25_ = g_strdup ("Left");
#line 140 "../src/gnome-chess.vala"
	_tmp26_ = g_new0 (gchar*, 1 + 1);
#line 140 "../src/gnome-chess.vala"
	_tmp26_[0] = _tmp25_;
#line 140 "../src/gnome-chess.vala"
	_tmp27_ = _tmp26_;
#line 140 "../src/gnome-chess.vala"
	_tmp27__length1 = 1;
#line 140 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HISTORY_GO_PREVIOUS_ACTION_NAME, _tmp27_);
#line 140 "../src/gnome-chess.vala"
	_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 141 "../src/gnome-chess.vala"
	_tmp28_ = g_strdup ("Right");
#line 141 "../src/gnome-chess.vala"
	_tmp29_ = g_new0 (gchar*, 1 + 1);
#line 141 "../src/gnome-chess.vala"
	_tmp29_[0] = _tmp28_;
#line 141 "../src/gnome-chess.vala"
	_tmp30_ = _tmp29_;
#line 141 "../src/gnome-chess.vala"
	_tmp30__length1 = 1;
#line 141 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HISTORY_GO_NEXT_ACTION_NAME, _tmp30_);
#line 141 "../src/gnome-chess.vala"
	_tmp30_ = (_vala_array_free (_tmp30_, _tmp30__length1, (GDestroyNotify) g_free), NULL);
#line 142 "../src/gnome-chess.vala"
	_tmp31_ = g_strdup ("Down");
#line 142 "../src/gnome-chess.vala"
	_tmp32_ = g_new0 (gchar*, 1 + 1);
#line 142 "../src/gnome-chess.vala"
	_tmp32_[0] = _tmp31_;
#line 142 "../src/gnome-chess.vala"
	_tmp33_ = _tmp32_;
#line 142 "../src/gnome-chess.vala"
	_tmp33__length1 = 1;
#line 142 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HISTORY_GO_LAST_ACTION_NAME, _tmp33_);
#line 142 "../src/gnome-chess.vala"
	_tmp33_ = (_vala_array_free (_tmp33_, _tmp33__length1, (GDestroyNotify) g_free), NULL);
#line 143 "../src/gnome-chess.vala"
	_tmp34_ = g_strdup ("F1");
#line 143 "../src/gnome-chess.vala"
	_tmp35_ = g_new0 (gchar*, 1 + 1);
#line 143 "../src/gnome-chess.vala"
	_tmp35_[0] = _tmp34_;
#line 143 "../src/gnome-chess.vala"
	_tmp36_ = _tmp35_;
#line 143 "../src/gnome-chess.vala"
	_tmp36__length1 = 1;
#line 143 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HELP_ACTION_NAME, _tmp36_);
#line 143 "../src/gnome-chess.vala"
	_tmp36_ = (_vala_array_free (_tmp36_, _tmp36__length1, (GDestroyNotify) g_free), NULL);
#line 144 "../src/gnome-chess.vala"
	_tmp37_ = g_strdup ("<Control>q");
#line 144 "../src/gnome-chess.vala"
	_tmp38_ = g_strdup ("<Control>w");
#line 144 "../src/gnome-chess.vala"
	_tmp39_ = g_new0 (gchar*, 2 + 1);
#line 144 "../src/gnome-chess.vala"
	_tmp39_[0] = _tmp37_;
#line 144 "../src/gnome-chess.vala"
	_tmp39_[1] = _tmp38_;
#line 144 "../src/gnome-chess.vala"
	_tmp40_ = _tmp39_;
#line 144 "../src/gnome-chess.vala"
	_tmp40__length1 = 2;
#line 144 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." QUIT_ACTION_NAME, _tmp40_);
#line 144 "../src/gnome-chess.vala"
	_tmp40_ = (_vala_array_free (_tmp40_, _tmp40__length1, (GDestroyNotify) g_free), NULL);
#line 147 "../src/gnome-chess.vala"
	_tmp41_ = chess_window_new (self);
#line 147 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp41_);
#line 147 "../src/gnome-chess.vala"
	_tmp42_ = _tmp41_;
#line 147 "../src/gnome-chess.vala"
	chess_application_set_window (self, _tmp42_);
#line 147 "../src/gnome-chess.vala"
	_g_object_unref0 (_tmp42_);
#line 148 "../src/gnome-chess.vala"
	_tmp43_ = self->priv->_window;
#line 148 "../src/gnome-chess.vala"
	_tmp44_ = self->priv->settings;
#line 148 "../src/gnome-chess.vala"
	_tmp45_ = self->priv->settings;
#line 148 "../src/gnome-chess.vala"
	gtk_window_set_default_size ((GtkWindow*) _tmp43_, g_settings_get_int (_tmp44_, WIDTH_SETTINGS_KEY), g_settings_get_int (_tmp45_, HEIGHT_SETTINGS_KEY));
#line 149 "../src/gnome-chess.vala"
	_tmp46_ = self->priv->settings;
#line 149 "../src/gnome-chess.vala"
	if (g_settings_get_boolean (_tmp46_, MAXIMIZED_SETTINGS_KEY)) {
#line 1258 "gnome-chess.c"
		ChessWindow* _tmp47_;
#line 150 "../src/gnome-chess.vala"
		_tmp47_ = self->priv->_window;
#line 150 "../src/gnome-chess.vala"
		gtk_window_maximize ((GtkWindow*) _tmp47_);
#line 1264 "gnome-chess.c"
	}
#line 151 "../src/gnome-chess.vala"
	_tmp48_ = self->priv->_window;
#line 151 "../src/gnome-chess.vala"
	gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp48_);
#line 153 "../src/gnome-chess.vala"
	_tmp49_ = self->priv->settings;
#line 153 "../src/gnome-chess.vala"
	_tmp50_ = chess_application_get_scene (self);
#line 153 "../src/gnome-chess.vala"
	_tmp51_ = _tmp50_;
#line 153 "../src/gnome-chess.vala"
	g_settings_bind (_tmp49_, SHOW_MOVE_HINTS_SETTINGS_KEY, (GObject*) _tmp51_, "show-move-hints", G_SETTINGS_BIND_GET);
#line 154 "../src/gnome-chess.vala"
	_tmp52_ = self->priv->settings;
#line 154 "../src/gnome-chess.vala"
	_tmp53_ = chess_application_get_scene (self);
#line 154 "../src/gnome-chess.vala"
	_tmp54_ = _tmp53_;
#line 154 "../src/gnome-chess.vala"
	g_settings_bind (_tmp52_, SHOW_BOARD_NUMBERING_SETTINGS_KEY, (GObject*) _tmp54_, "show-numbering", G_SETTINGS_BIND_GET);
#line 155 "../src/gnome-chess.vala"
	_tmp55_ = self->priv->settings;
#line 155 "../src/gnome-chess.vala"
	_tmp56_ = chess_application_get_scene (self);
#line 155 "../src/gnome-chess.vala"
	_tmp57_ = _tmp56_;
#line 155 "../src/gnome-chess.vala"
	g_settings_bind (_tmp55_, PIECE_STYLE_SETTINGS_KEY, (GObject*) _tmp57_, "theme-name", G_SETTINGS_BIND_GET);
#line 156 "../src/gnome-chess.vala"
	_tmp58_ = self->priv->settings;
#line 156 "../src/gnome-chess.vala"
	_tmp59_ = chess_application_get_scene (self);
#line 156 "../src/gnome-chess.vala"
	_tmp60_ = _tmp59_;
#line 156 "../src/gnome-chess.vala"
	g_settings_bind (_tmp58_, MOVE_FORMAT_SETTINGS_KEY, (GObject*) _tmp60_, "move-format", G_SETTINGS_BIND_GET);
#line 157 "../src/gnome-chess.vala"
	_tmp61_ = self->priv->settings;
#line 157 "../src/gnome-chess.vala"
	_tmp62_ = chess_application_get_scene (self);
#line 157 "../src/gnome-chess.vala"
	_tmp63_ = _tmp62_;
#line 157 "../src/gnome-chess.vala"
	g_settings_bind (_tmp61_, BOARD_ORIENTATION_SETTINGS_KEY, (GObject*) _tmp63_, "board-side", G_SETTINGS_BIND_GET);
#line 159 "../src/gnome-chess.vala"
	_tmp64_ = chess_application_get_scene (self);
#line 159 "../src/gnome-chess.vala"
	_tmp65_ = _tmp64_;
#line 159 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp65_, "is-human", (GCallback) ___lambda38__chess_scene_is_human, self, 0);
#line 160 "../src/gnome-chess.vala"
	_tmp66_ = chess_application_get_scene (self);
#line 160 "../src/gnome-chess.vala"
	_tmp67_ = _tmp66_;
#line 160 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp67_, "choose-promotion-type", (GCallback) _chess_application_show_promotion_type_selector_chess_scene_choose_promotion_type, self, 0);
#line 162 "../src/gnome-chess.vala"
	_tmp68_ = g_build_filename (SYSCONFDIR, "gnome-chess", "engines.conf", NULL, NULL);
#line 162 "../src/gnome-chess.vala"
	system_engine_cfg = _tmp68_;
#line 163 "../src/gnome-chess.vala"
	_tmp69_ = g_get_user_config_dir ();
#line 163 "../src/gnome-chess.vala"
	_tmp70_ = g_build_filename (_tmp69_, "gnome-chess", "engines.conf", NULL, NULL);
#line 163 "../src/gnome-chess.vala"
	user_engine_cfg = _tmp70_;
#line 164 "../src/gnome-chess.vala"
	_tmp71_ = user_engine_cfg;
#line 164 "../src/gnome-chess.vala"
	if (g_file_test (_tmp71_, G_FILE_TEST_EXISTS)) {
#line 1336 "gnome-chess.c"
		const gchar* _tmp72_;
		GList* _tmp73_;
#line 165 "../src/gnome-chess.vala"
		_tmp72_ = user_engine_cfg;
#line 165 "../src/gnome-chess.vala"
		_tmp73_ = ai_profile_load_ai_profiles (_tmp72_);
#line 165 "../src/gnome-chess.vala"
		(self->priv->ai_profiles == NULL) ? NULL : (self->priv->ai_profiles = (_g_list_free__g_object_unref0_ (self->priv->ai_profiles), NULL));
#line 165 "../src/gnome-chess.vala"
		self->priv->ai_profiles = _tmp73_;
#line 1347 "gnome-chess.c"
	} else {
		const gchar* _tmp74_;
#line 166 "../src/gnome-chess.vala"
		_tmp74_ = system_engine_cfg;
#line 166 "../src/gnome-chess.vala"
		if (g_file_test (_tmp74_, G_FILE_TEST_EXISTS)) {
#line 1354 "gnome-chess.c"
			const gchar* _tmp75_;
			GList* _tmp76_;
#line 167 "../src/gnome-chess.vala"
			_tmp75_ = system_engine_cfg;
#line 167 "../src/gnome-chess.vala"
			_tmp76_ = ai_profile_load_ai_profiles (_tmp75_);
#line 167 "../src/gnome-chess.vala"
			(self->priv->ai_profiles == NULL) ? NULL : (self->priv->ai_profiles = (_g_list_free__g_object_unref0_ (self->priv->ai_profiles), NULL));
#line 167 "../src/gnome-chess.vala"
			self->priv->ai_profiles = _tmp76_;
#line 1365 "gnome-chess.c"
		} else {
#line 169 "../src/gnome-chess.vala"
			g_warning ("gnome-chess.vala:169: engines.conf not found");
#line 1369 "gnome-chess.c"
		}
	}
#line 171 "../src/gnome-chess.vala"
	_tmp77_ = self->priv->ai_profiles;
#line 1374 "gnome-chess.c"
	{
		GList* profile_collection = NULL;
		GList* profile_it = NULL;
#line 171 "../src/gnome-chess.vala"
		profile_collection = _tmp77_;
#line 171 "../src/gnome-chess.vala"
		for (profile_it = profile_collection; profile_it != NULL; profile_it = profile_it->next) {
#line 1382 "gnome-chess.c"
			AIProfile* _tmp78_;
			AIProfile* profile = NULL;
#line 171 "../src/gnome-chess.vala"
			_tmp78_ = _g_object_ref0 ((AIProfile*) profile_it->data);
#line 171 "../src/gnome-chess.vala"
			profile = _tmp78_;
#line 1389 "gnome-chess.c"
			{
				AIProfile* _tmp79_;
				const gchar* _tmp80_;
				const gchar* _tmp81_;
				AIProfile* _tmp82_;
				const gchar* _tmp83_;
				const gchar* _tmp84_;
#line 172 "../src/gnome-chess.vala"
				_tmp79_ = profile;
#line 172 "../src/gnome-chess.vala"
				_tmp80_ = ai_profile_get_name (_tmp79_);
#line 172 "../src/gnome-chess.vala"
				_tmp81_ = _tmp80_;
#line 172 "../src/gnome-chess.vala"
				_tmp82_ = profile;
#line 172 "../src/gnome-chess.vala"
				_tmp83_ = ai_profile_get_path (_tmp82_);
#line 172 "../src/gnome-chess.vala"
				_tmp84_ = _tmp83_;
#line 172 "../src/gnome-chess.vala"
				g_debug ("gnome-chess.vala:172: Detected AI profile %s in %s", _tmp81_, _tmp84_);
#line 171 "../src/gnome-chess.vala"
				_g_object_unref0 (profile);
#line 1413 "gnome-chess.c"
			}
		}
	}
#line 124 "../src/gnome-chess.vala"
	_g_free0 (user_engine_cfg);
#line 124 "../src/gnome-chess.vala"
	_g_free0 (system_engine_cfg);
#line 1421 "gnome-chess.c"
}

static void
chess_application_real_open (GApplication* base,
                             GFile** files,
                             gint files_length1,
                             const gchar* hint)
{
	ChessApplication * self;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 175 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 175 "../src/gnome-chess.vala"
	g_return_if_fail (hint != NULL);
#line 177 "../src/gnome-chess.vala"
	if (files_length1 != 1) {
#line 180 "../src/gnome-chess.vala"
		g_warning ("gnome-chess.vala:180: %s", _ ("GNOME Chess can only open one PGN at a time."));
#line 1441 "gnome-chess.c"
	}
#line 183 "../src/gnome-chess.vala"
	_tmp0_ = files[0];
#line 183 "../src/gnome-chess.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 183 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->game_file);
#line 183 "../src/gnome-chess.vala"
	self->priv->game_file = _tmp1_;
#line 184 "../src/gnome-chess.vala"
	g_application_activate ((GApplication*) self);
#line 1453 "gnome-chess.c"
}

static void
chess_application_real_activate (GApplication* base)
{
	ChessApplication * self;
	ChessWindow* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ChessWindow* _tmp22_;
#line 187 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 189 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 189 "../src/gnome-chess.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 189 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 189 "../src/gnome-chess.vala"
	if (!_tmp2_) {
#line 1474 "gnome-chess.c"
		GFile* data_dir = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GFile* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_ = FALSE;
		GFile* _tmp16_;
		GFile* _tmp20_;
#line 191 "../src/gnome-chess.vala"
		_tmp3_ = g_get_user_data_dir ();
#line 191 "../src/gnome-chess.vala"
		_tmp4_ = g_build_filename (_tmp3_, "gnome-chess", NULL, NULL);
#line 191 "../src/gnome-chess.vala"
		_tmp5_ = _tmp4_;
#line 191 "../src/gnome-chess.vala"
		_tmp6_ = g_file_new_for_path (_tmp5_);
#line 191 "../src/gnome-chess.vala"
		_tmp7_ = _tmp6_;
#line 191 "../src/gnome-chess.vala"
		_g_free0 (_tmp5_);
#line 191 "../src/gnome-chess.vala"
		data_dir = _tmp7_;
#line 192 "../src/gnome-chess.vala"
		_tmp8_ = data_dir;
#line 192 "../src/gnome-chess.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 192 "../src/gnome-chess.vala"
		_tmp10_ = _tmp9_;
#line 192 "../src/gnome-chess.vala"
		g_mkdir_with_parents (_tmp10_, 0755);
#line 192 "../src/gnome-chess.vala"
		_g_free0 (_tmp10_);
#line 194 "../src/gnome-chess.vala"
		_tmp11_ = data_dir;
#line 194 "../src/gnome-chess.vala"
		_tmp12_ = g_file_get_path (_tmp11_);
#line 194 "../src/gnome-chess.vala"
		_tmp13_ = _tmp12_;
#line 194 "../src/gnome-chess.vala"
		_tmp14_ = g_strconcat (_tmp13_, "/autosave.pgn", NULL);
#line 194 "../src/gnome-chess.vala"
		_g_free0 (self->priv->autosave_filename);
#line 194 "../src/gnome-chess.vala"
		self->priv->autosave_filename = _tmp14_;
#line 194 "../src/gnome-chess.vala"
		_g_free0 (_tmp13_);
#line 197 "../src/gnome-chess.vala"
		_tmp16_ = self->priv->game_file;
#line 197 "../src/gnome-chess.vala"
		if (_tmp16_ == NULL) {
#line 1533 "gnome-chess.c"
			const gchar* _tmp17_;
#line 197 "../src/gnome-chess.vala"
			_tmp17_ = self->priv->autosave_filename;
#line 197 "../src/gnome-chess.vala"
			_tmp15_ = g_file_test (_tmp17_, G_FILE_TEST_EXISTS);
#line 1539 "gnome-chess.c"
		} else {
#line 197 "../src/gnome-chess.vala"
			_tmp15_ = FALSE;
#line 1543 "gnome-chess.c"
		}
#line 197 "../src/gnome-chess.vala"
		if (_tmp15_) {
#line 1547 "gnome-chess.c"
			const gchar* _tmp18_;
			GFile* _tmp19_;
#line 198 "../src/gnome-chess.vala"
			_tmp18_ = self->priv->autosave_filename;
#line 198 "../src/gnome-chess.vala"
			_tmp19_ = g_file_new_for_path (_tmp18_);
#line 198 "../src/gnome-chess.vala"
			_g_object_unref0 (self->priv->game_file);
#line 198 "../src/gnome-chess.vala"
			self->priv->game_file = _tmp19_;
#line 1558 "gnome-chess.c"
		}
#line 200 "../src/gnome-chess.vala"
		_tmp20_ = self->priv->game_file;
#line 200 "../src/gnome-chess.vala"
		if (_tmp20_ == NULL) {
#line 201 "../src/gnome-chess.vala"
			chess_application_start_new_game (self);
#line 1566 "gnome-chess.c"
		} else {
			GFile* _tmp21_;
#line 203 "../src/gnome-chess.vala"
			_tmp21_ = self->priv->game_file;
#line 203 "../src/gnome-chess.vala"
			chess_application_load_game (self, _tmp21_);
#line 1573 "gnome-chess.c"
		}
#line 189 "../src/gnome-chess.vala"
		_g_object_unref0 (data_dir);
#line 1577 "gnome-chess.c"
	}
#line 206 "../src/gnome-chess.vala"
	_tmp22_ = self->priv->_window;
#line 206 "../src/gnome-chess.vala"
	gtk_window_present ((GtkWindow*) _tmp22_);
#line 1583 "gnome-chess.c"
}

static void
chess_application_real_shutdown (GApplication* base)
{
	ChessApplication * self;
	ChessEngine* _tmp0_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	ChessWindow* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GSettings* _tmp7_;
	ChessWindow* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GSettings* _tmp11_;
	ChessWindow* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GSettings* _tmp15_;
#line 209 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 211 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent_engine;
#line 211 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 1611 "gnome-chess.c"
		ChessEngine* _tmp1_;
#line 212 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->opponent_engine;
#line 212 "../src/gnome-chess.vala"
		chess_engine_stop (_tmp1_, TRUE);
#line 1617 "gnome-chess.c"
	}
#line 214 "../src/gnome-chess.vala"
	chess_application_autosave (self);
#line 217 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->settings;
#line 217 "../src/gnome-chess.vala"
	g_settings_delay (_tmp2_);
#line 218 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->settings;
#line 218 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->_window;
#line 218 "../src/gnome-chess.vala"
	g_object_get ((GtkWindow*) _tmp4_, "default-width", &_tmp5_, NULL);
#line 218 "../src/gnome-chess.vala"
	_tmp6_ = _tmp5_;
#line 218 "../src/gnome-chess.vala"
	g_settings_set_int (_tmp3_, WIDTH_SETTINGS_KEY, _tmp6_);
#line 219 "../src/gnome-chess.vala"
	_tmp7_ = self->priv->settings;
#line 219 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->_window;
#line 219 "../src/gnome-chess.vala"
	g_object_get ((GtkWindow*) _tmp8_, "default-height", &_tmp9_, NULL);
#line 219 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 219 "../src/gnome-chess.vala"
	g_settings_set_int (_tmp7_, HEIGHT_SETTINGS_KEY, _tmp10_);
#line 220 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->settings;
#line 220 "../src/gnome-chess.vala"
	_tmp12_ = self->priv->_window;
#line 220 "../src/gnome-chess.vala"
	g_object_get ((GtkWindow*) _tmp12_, "maximized", &_tmp13_, NULL);
#line 220 "../src/gnome-chess.vala"
	_tmp14_ = _tmp13_;
#line 220 "../src/gnome-chess.vala"
	g_settings_set_boolean (_tmp11_, MAXIMIZED_SETTINGS_KEY, _tmp14_);
#line 221 "../src/gnome-chess.vala"
	_tmp15_ = self->priv->settings;
#line 221 "../src/gnome-chess.vala"
	g_settings_apply (_tmp15_);
#line 223 "../src/gnome-chess.vala"
	G_APPLICATION_CLASS (chess_application_parent_class)->shutdown ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_get_type (), AdwApplication));
#line 1661 "gnome-chess.c"
}

void
chess_application_quit_game (ChessApplication* self)
{
	ChessWindow* _tmp0_;
#line 226 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 228 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 228 "../src/gnome-chess.vala"
	gtk_window_destroy ((GtkWindow*) _tmp0_);
#line 1674 "gnome-chess.c"
}

static void
chess_application_autosave (ChessApplication* self)
{
	GError* _inner_error0_ = NULL;
#line 231 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/gnome-chess.vala"
	if (!self->priv->game_needs_saving) {
#line 1685 "gnome-chess.c"
		const gchar* _tmp0_;
#line 236 "../src/gnome-chess.vala"
		_tmp0_ = self->priv->autosave_filename;
#line 236 "../src/gnome-chess.vala"
		g_remove (_tmp0_);
#line 237 "../src/gnome-chess.vala"
		return;
#line 1693 "gnome-chess.c"
	}
	{
		GFile* autosave_file = NULL;
		const gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		PGNGame* _tmp6_;
		GFile* _tmp7_;
#line 242 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->autosave_filename;
#line 242 "../src/gnome-chess.vala"
		_tmp2_ = g_file_new_for_path (_tmp1_);
#line 242 "../src/gnome-chess.vala"
		autosave_file = _tmp2_;
#line 243 "../src/gnome-chess.vala"
		_tmp3_ = autosave_file;
#line 243 "../src/gnome-chess.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 243 "../src/gnome-chess.vala"
		_tmp5_ = _tmp4_;
#line 243 "../src/gnome-chess.vala"
		g_debug ("gnome-chess.vala:243: Writing current game to %s", _tmp5_);
#line 243 "../src/gnome-chess.vala"
		_g_free0 (_tmp5_);
#line 244 "../src/gnome-chess.vala"
		chess_application_update_pgn_time_remaining (self);
#line 245 "../src/gnome-chess.vala"
		_tmp6_ = self->priv->pgn_game;
#line 245 "../src/gnome-chess.vala"
		_tmp7_ = autosave_file;
#line 245 "../src/gnome-chess.vala"
		pgn_game_write (_tmp6_, _tmp7_, &_inner_error0_);
#line 245 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "../src/gnome-chess.vala"
			_g_object_unref0 (autosave_file);
#line 1732 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 240 "../src/gnome-chess.vala"
		_g_object_unref0 (autosave_file);
#line 1737 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 240 "../src/gnome-chess.vala"
		e = _inner_error0_;
#line 240 "../src/gnome-chess.vala"
		_inner_error0_ = NULL;
#line 249 "../src/gnome-chess.vala"
		_tmp8_ = e;
#line 249 "../src/gnome-chess.vala"
		_tmp9_ = _tmp8_->message;
#line 249 "../src/gnome-chess.vala"
		g_warning ("gnome-chess.vala:249: Failed to autosave: %s", _tmp9_);
#line 240 "../src/gnome-chess.vala"
		_g_error_free0 (e);
#line 1757 "gnome-chess.c"
	}
	__finally0:
#line 240 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 240 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 240 "../src/gnome-chess.vala"
		return;
#line 1768 "gnome-chess.c"
	}
}

static void
_chess_application_game_turn_cb_chess_game_turn_started (ChessGame* _sender,
                                                         ChessPlayer* player,
                                                         gpointer self)
{
#line 273 "../src/gnome-chess.vala"
	chess_application_game_turn_cb ((ChessApplication*) self, _sender, player);
#line 1779 "gnome-chess.c"
}

static void
_chess_application_game_move_cb_chess_game_moved (ChessGame* _sender,
                                                  ChessMove* move,
                                                  gpointer self)
{
#line 274 "../src/gnome-chess.vala"
	chess_application_game_move_cb ((ChessApplication*) self, _sender, move);
#line 1789 "gnome-chess.c"
}

static void
_chess_application_game_undo_cb_chess_game_undo (ChessGame* _sender,
                                                 gpointer self)
{
#line 275 "../src/gnome-chess.vala"
	chess_application_game_undo_cb ((ChessApplication*) self, _sender);
#line 1798 "gnome-chess.c"
}

static void
_chess_application_game_end_cb_chess_game_ended (ChessGame* _sender,
                                                 gpointer self)
{
#line 276 "../src/gnome-chess.vala"
	chess_application_game_end_cb ((ChessApplication*) self);
#line 1807 "gnome-chess.c"
}

static void
_chess_application_engine_move_cb_chess_engine_moved (ChessEngine* _sender,
                                                      const gchar* move,
                                                      gpointer self)
{
#line 330 "../src/gnome-chess.vala"
	chess_application_engine_move_cb ((ChessApplication*) self, _sender, move);
#line 1817 "gnome-chess.c"
}

static void
_chess_application_engine_resigned_cb_chess_engine_resigned (ChessEngine* _sender,
                                                             gpointer self)
{
#line 331 "../src/gnome-chess.vala"
	chess_application_engine_resigned_cb ((ChessApplication*) self, _sender);
#line 1826 "gnome-chess.c"
}

static void
_chess_application_engine_stopped_unexpectedly_cb_chess_engine_stopped_unexpectedly (ChessEngine* _sender,
                                                                                     gpointer self)
{
#line 332 "../src/gnome-chess.vala"
	chess_application_engine_stopped_unexpectedly_cb ((ChessApplication*) self, _sender);
#line 1835 "gnome-chess.c"
}

static void
_chess_application_engine_error_cb_chess_engine_error (ChessEngine* _sender,
                                                       gpointer self)
{
#line 333 "../src/gnome-chess.vala"
	chess_application_engine_error_cb ((ChessApplication*) self, _sender);
#line 1844 "gnome-chess.c"
}

static void
_chess_application_engine_claim_draw_cb_chess_engine_claim_draw (ChessEngine* _sender,
                                                                 gpointer self)
{
#line 334 "../src/gnome-chess.vala"
	chess_application_engine_claim_draw_cb ((ChessApplication*) self, _sender);
#line 1853 "gnome-chess.c"
}

static void
_chess_application_engine_offer_draw_cb_chess_engine_offer_draw (ChessEngine* _sender,
                                                                 gpointer self)
{
#line 335 "../src/gnome-chess.vala"
	chess_application_engine_offer_draw_cb ((ChessApplication*) self, _sender);
#line 1862 "gnome-chess.c"
}

static void
chess_application_start_game (ChessApplication* self)
{
	gchar* fen = NULL;
	gchar* _tmp0_;
	gchar** moves = NULL;
	PGNGame* _tmp1_;
	GList* _tmp2_;
	gchar** _tmp3_;
	gint moves_length1;
	gint _moves_size_;
	gint i = 0;
	PGNGame* _tmp4_;
	GList* _tmp5_;
	PGNGame* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	ChessGame* _tmp21_;
	gboolean _tmp36_ = FALSE;
	PGNGame* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	ChessGame* _tmp60_;
	ChessGame* _tmp61_;
	ChessGame* _tmp62_;
	ChessGame* _tmp63_;
	ChessScene* _tmp64_;
	ChessScene* _tmp65_;
	ChessGame* _tmp66_;
	ChessWindow* _tmp67_;
	gchar* white_engine = NULL;
	PGNGame* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* white_level = NULL;
	PGNGame* _tmp72_;
	const gchar* _tmp73_;
	const gchar* _tmp74_;
	gchar* _tmp75_;
	const gchar* _tmp76_;
	gchar* black_engine = NULL;
	PGNGame* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* black_level = NULL;
	PGNGame* _tmp82_;
	const gchar* _tmp83_;
	const gchar* _tmp84_;
	gchar* _tmp85_;
	const gchar* _tmp86_;
	ChessEngine* _tmp88_;
	const gchar* _tmp102_;
	ChessEngine* _tmp130_;
	gboolean _tmp157_ = FALSE;
	GFile* _tmp158_;
	ChessGame* _tmp163_;
	gint timer_increment_adj_value = 0;
	PGNGame* _tmp164_;
	const gchar* _tmp165_;
	const gchar* _tmp166_;
	ChessClockType clock_type = 0;
	PGNGame* _tmp174_;
	const gchar* _tmp175_;
	const gchar* _tmp176_;
	ChessWindow* _tmp186_;
	ChessGame* _tmp187_;
	ChessClock* _tmp188_;
	ChessClock* _tmp189_;
	ChessGame* _tmp190_;
	ChessClock* _tmp191_;
	ChessClock* _tmp192_;
	PGNGame* _tmp199_;
	const gchar* _tmp200_;
	const gchar* _tmp201_;
	const gchar* _tmp202_;
	ChessEngine* _tmp214_;
	gboolean _tmp216_ = FALSE;
	gchar** _tmp217_;
	gint _tmp217__length1;
	ChessWindow* _tmp224_;
	ChessWindow* _tmp225_;
	GList* _tmp226_;
	gboolean _tmp229_ = FALSE;
	gboolean _tmp230_ = FALSE;
	const gchar* _tmp231_;
	ChessGame* _tmp242_;
	GError* _inner_error0_ = NULL;
#line 253 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/gnome-chess.vala"
	self->priv->starting = TRUE;
#line 257 "../src/gnome-chess.vala"
	_tmp0_ = g_strdup (CHESS_GAME_STANDARD_SETUP);
#line 257 "../src/gnome-chess.vala"
	fen = _tmp0_;
#line 258 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->pgn_game;
#line 258 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_->moves;
#line 258 "../src/gnome-chess.vala"
	_tmp3_ = g_new0 (gchar*, g_list_length (_tmp2_) + 1);
#line 258 "../src/gnome-chess.vala"
	moves = _tmp3_;
#line 258 "../src/gnome-chess.vala"
	moves_length1 = g_list_length (_tmp2_);
#line 258 "../src/gnome-chess.vala"
	_moves_size_ = moves_length1;
#line 259 "../src/gnome-chess.vala"
	i = 0;
#line 260 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->pgn_game;
#line 260 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_->moves;
#line 1980 "gnome-chess.c"
	{
		GList* move_collection = NULL;
		GList* move_it = NULL;
#line 260 "../src/gnome-chess.vala"
		move_collection = _tmp5_;
#line 260 "../src/gnome-chess.vala"
		for (move_it = move_collection; move_it != NULL; move_it = move_it->next) {
#line 1988 "gnome-chess.c"
			gchar* _tmp6_;
			gchar* move = NULL;
#line 260 "../src/gnome-chess.vala"
			_tmp6_ = g_strdup ((const gchar*) move_it->data);
#line 260 "../src/gnome-chess.vala"
			move = _tmp6_;
#line 1995 "gnome-chess.c"
			{
				gchar** _tmp7_;
				gint _tmp7__length1;
				gint _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 261 "../src/gnome-chess.vala"
				_tmp7_ = moves;
#line 261 "../src/gnome-chess.vala"
				_tmp7__length1 = moves_length1;
#line 261 "../src/gnome-chess.vala"
				_tmp8_ = i;
#line 261 "../src/gnome-chess.vala"
				i = _tmp8_ + 1;
#line 261 "../src/gnome-chess.vala"
				_tmp9_ = move;
#line 261 "../src/gnome-chess.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 261 "../src/gnome-chess.vala"
				_g_free0 (_tmp7_[_tmp8_]);
#line 261 "../src/gnome-chess.vala"
				_tmp7_[_tmp8_] = _tmp10_;
#line 260 "../src/gnome-chess.vala"
				_g_free0 (move);
#line 2020 "gnome-chess.c"
			}
		}
	}
#line 263 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->pgn_game;
#line 263 "../src/gnome-chess.vala"
	_tmp12_ = pgn_game_get_set_up (_tmp11_);
#line 263 "../src/gnome-chess.vala"
	_tmp13_ = _tmp12_;
#line 263 "../src/gnome-chess.vala"
	if (_tmp13_) {
#line 2032 "gnome-chess.c"
		PGNGame* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 265 "../src/gnome-chess.vala"
		_tmp14_ = self->priv->pgn_game;
#line 265 "../src/gnome-chess.vala"
		_tmp15_ = pgn_game_get_fen (_tmp14_);
#line 265 "../src/gnome-chess.vala"
		_tmp16_ = _tmp15_;
#line 265 "../src/gnome-chess.vala"
		if (_tmp16_ != NULL) {
#line 2044 "gnome-chess.c"
			PGNGame* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 266 "../src/gnome-chess.vala"
			_tmp17_ = self->priv->pgn_game;
#line 266 "../src/gnome-chess.vala"
			_tmp18_ = pgn_game_get_fen (_tmp17_);
#line 266 "../src/gnome-chess.vala"
			_tmp19_ = _tmp18_;
#line 266 "../src/gnome-chess.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 266 "../src/gnome-chess.vala"
			_g_free0 (fen);
#line 266 "../src/gnome-chess.vala"
			fen = _tmp20_;
#line 2061 "gnome-chess.c"
		} else {
#line 268 "../src/gnome-chess.vala"
			g_warning ("gnome-chess.vala:268: Chess game has SetUp tag but no FEN tag");
#line 2065 "gnome-chess.c"
		}
	}
#line 271 "../src/gnome-chess.vala"
	_tmp21_ = self->priv->game;
#line 271 "../src/gnome-chess.vala"
	if (_tmp21_ != NULL) {
#line 2072 "gnome-chess.c"
		ChessGame* _tmp22_;
		guint _tmp23_;
		ChessGame* _tmp24_;
		guint _tmp25_;
		ChessGame* _tmp26_;
		guint _tmp27_;
		ChessGame* _tmp28_;
#line 273 "../src/gnome-chess.vala"
		_tmp22_ = self->priv->game;
#line 273 "../src/gnome-chess.vala"
		g_signal_parse_name ("turn-started", TYPE_CHESS_GAME, &_tmp23_, NULL, FALSE);
#line 273 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _chess_application_game_turn_cb_chess_game_turn_started, self);
#line 274 "../src/gnome-chess.vala"
		_tmp24_ = self->priv->game;
#line 274 "../src/gnome-chess.vala"
		g_signal_parse_name ("moved", TYPE_CHESS_GAME, &_tmp25_, NULL, FALSE);
#line 274 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _chess_application_game_move_cb_chess_game_moved, self);
#line 275 "../src/gnome-chess.vala"
		_tmp26_ = self->priv->game;
#line 275 "../src/gnome-chess.vala"
		g_signal_parse_name ("undo", TYPE_CHESS_GAME, &_tmp27_, NULL, FALSE);
#line 275 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp26_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp27_, 0, NULL, (GCallback) _chess_application_game_undo_cb_chess_game_undo, self);
#line 276 "../src/gnome-chess.vala"
		_tmp28_ = self->priv->game;
#line 276 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp28_, "ended", (GCallback) _chess_application_game_end_cb_chess_game_ended, self, 0);
#line 2102 "gnome-chess.c"
	}
	{
		ChessGame* _tmp29_ = NULL;
		const gchar* _tmp30_;
		gchar** _tmp31_;
		gint _tmp31__length1;
		ChessGame* _tmp32_;
		ChessGame* _tmp33_;
#line 281 "../src/gnome-chess.vala"
		_tmp30_ = fen;
#line 281 "../src/gnome-chess.vala"
		_tmp31_ = moves;
#line 281 "../src/gnome-chess.vala"
		_tmp31__length1 = moves_length1;
#line 281 "../src/gnome-chess.vala"
		_tmp32_ = chess_game_new (_tmp30_, _tmp31_, _tmp31__length1, &_inner_error0_);
#line 281 "../src/gnome-chess.vala"
		_tmp29_ = _tmp32_;
#line 281 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2123 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 281 "../src/gnome-chess.vala"
		_tmp33_ = _tmp29_;
#line 281 "../src/gnome-chess.vala"
		_tmp29_ = NULL;
#line 281 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->game);
#line 281 "../src/gnome-chess.vala"
		self->priv->game = _tmp33_;
#line 279 "../src/gnome-chess.vala"
		_g_object_unref0 (_tmp29_);
#line 2136 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp34_;
		const gchar* _tmp35_;
#line 279 "../src/gnome-chess.vala"
		e = _inner_error0_;
#line 279 "../src/gnome-chess.vala"
		_inner_error0_ = NULL;
#line 285 "../src/gnome-chess.vala"
		_tmp34_ = e;
#line 285 "../src/gnome-chess.vala"
		_tmp35_ = _tmp34_->message;
#line 285 "../src/gnome-chess.vala"
		chess_application_show_invalid_move_dialog (self, _tmp35_);
#line 286 "../src/gnome-chess.vala"
		chess_application_configure_new_game (self);
#line 287 "../src/gnome-chess.vala"
		_g_error_free0 (e);
#line 287 "../src/gnome-chess.vala"
		moves = (_vala_array_free (moves, moves_length1, (GDestroyNotify) g_free), NULL);
#line 287 "../src/gnome-chess.vala"
		_g_free0 (fen);
#line 287 "../src/gnome-chess.vala"
		return;
#line 2164 "gnome-chess.c"
	}
	__finally0:
#line 279 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 279 "../src/gnome-chess.vala"
		moves = (_vala_array_free (moves, moves_length1, (GDestroyNotify) g_free), NULL);
#line 279 "../src/gnome-chess.vala"
		_g_free0 (fen);
#line 279 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 279 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 279 "../src/gnome-chess.vala"
		return;
#line 2179 "gnome-chess.c"
	}
#line 294 "../src/gnome-chess.vala"
	_tmp37_ = self->priv->pgn_game;
#line 294 "../src/gnome-chess.vala"
	_tmp38_ = pgn_game_get_time_control (_tmp37_);
#line 294 "../src/gnome-chess.vala"
	_tmp39_ = _tmp38_;
#line 294 "../src/gnome-chess.vala"
	if (_tmp39_ != NULL) {
#line 2189 "gnome-chess.c"
		PGNGame* _tmp40_;
		const gchar* _tmp41_;
		const gchar* _tmp42_;
#line 294 "../src/gnome-chess.vala"
		_tmp40_ = self->priv->pgn_game;
#line 294 "../src/gnome-chess.vala"
		_tmp41_ = pgn_game_get_time_control (_tmp40_);
#line 294 "../src/gnome-chess.vala"
		_tmp42_ = _tmp41_;
#line 294 "../src/gnome-chess.vala"
		_tmp36_ = atoi (_tmp42_) != 0;
#line 2201 "gnome-chess.c"
	} else {
#line 294 "../src/gnome-chess.vala"
		_tmp36_ = FALSE;
#line 2205 "gnome-chess.c"
	}
#line 294 "../src/gnome-chess.vala"
	if (_tmp36_) {
#line 2209 "gnome-chess.c"
		gboolean _tmp43_ = FALSE;
		PGNGame* _tmp44_;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
#line 296 "../src/gnome-chess.vala"
		_tmp44_ = self->priv->pgn_game;
#line 296 "../src/gnome-chess.vala"
		_tmp45_ = pgn_game_get_white_time_left (_tmp44_);
#line 296 "../src/gnome-chess.vala"
		_tmp46_ = _tmp45_;
#line 296 "../src/gnome-chess.vala"
		if (_tmp46_ != NULL) {
#line 2222 "gnome-chess.c"
			PGNGame* _tmp47_;
			const gchar* _tmp48_;
			const gchar* _tmp49_;
#line 296 "../src/gnome-chess.vala"
			_tmp47_ = self->priv->pgn_game;
#line 296 "../src/gnome-chess.vala"
			_tmp48_ = pgn_game_get_black_time_left (_tmp47_);
#line 296 "../src/gnome-chess.vala"
			_tmp49_ = _tmp48_;
#line 296 "../src/gnome-chess.vala"
			_tmp43_ = _tmp49_ != NULL;
#line 2234 "gnome-chess.c"
		} else {
#line 296 "../src/gnome-chess.vala"
			_tmp43_ = FALSE;
#line 2238 "gnome-chess.c"
		}
#line 296 "../src/gnome-chess.vala"
		if (_tmp43_) {
#line 2242 "gnome-chess.c"
			gint white_seconds = 0;
			PGNGame* _tmp50_;
			const gchar* _tmp51_;
			const gchar* _tmp52_;
			gint black_seconds = 0;
			PGNGame* _tmp53_;
			const gchar* _tmp54_;
			const gchar* _tmp55_;
			gboolean _tmp56_ = FALSE;
#line 298 "../src/gnome-chess.vala"
			_tmp50_ = self->priv->pgn_game;
#line 298 "../src/gnome-chess.vala"
			_tmp51_ = pgn_game_get_white_time_left (_tmp50_);
#line 298 "../src/gnome-chess.vala"
			_tmp52_ = _tmp51_;
#line 298 "../src/gnome-chess.vala"
			white_seconds = atoi (_tmp52_);
#line 299 "../src/gnome-chess.vala"
			_tmp53_ = self->priv->pgn_game;
#line 299 "../src/gnome-chess.vala"
			_tmp54_ = pgn_game_get_black_time_left (_tmp53_);
#line 299 "../src/gnome-chess.vala"
			_tmp55_ = _tmp54_;
#line 299 "../src/gnome-chess.vala"
			black_seconds = atoi (_tmp55_);
#line 301 "../src/gnome-chess.vala"
			if (white_seconds >= 0) {
#line 301 "../src/gnome-chess.vala"
				_tmp56_ = black_seconds >= 0;
#line 2272 "gnome-chess.c"
			} else {
#line 301 "../src/gnome-chess.vala"
				_tmp56_ = FALSE;
#line 2276 "gnome-chess.c"
			}
#line 301 "../src/gnome-chess.vala"
			if (_tmp56_) {
#line 2280 "gnome-chess.c"
				ChessGame* _tmp57_;
				ChessClock* _tmp58_;
				ChessClock* _tmp59_;
#line 302 "../src/gnome-chess.vala"
				_tmp57_ = self->priv->game;
#line 302 "../src/gnome-chess.vala"
				_tmp58_ = chess_clock_new (white_seconds, black_seconds);
#line 302 "../src/gnome-chess.vala"
				_tmp59_ = _tmp58_;
#line 302 "../src/gnome-chess.vala"
				chess_game_set_clock (_tmp57_, _tmp59_);
#line 302 "../src/gnome-chess.vala"
				_g_object_unref0 (_tmp59_);
#line 2294 "gnome-chess.c"
			}
		}
	}
#line 306 "../src/gnome-chess.vala"
	_tmp60_ = self->priv->game;
#line 306 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp60_, "turn-started", (GCallback) _chess_application_game_turn_cb_chess_game_turn_started, self, 0);
#line 307 "../src/gnome-chess.vala"
	_tmp61_ = self->priv->game;
#line 307 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp61_, "moved", (GCallback) _chess_application_game_move_cb_chess_game_moved, self, 0);
#line 308 "../src/gnome-chess.vala"
	_tmp62_ = self->priv->game;
#line 308 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp62_, "undo", (GCallback) _chess_application_game_undo_cb_chess_game_undo, self, 0);
#line 309 "../src/gnome-chess.vala"
	_tmp63_ = self->priv->game;
#line 309 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp63_, "ended", (GCallback) _chess_application_game_end_cb_chess_game_ended, self, 0);
#line 311 "../src/gnome-chess.vala"
	_tmp64_ = chess_application_get_scene (self);
#line 311 "../src/gnome-chess.vala"
	_tmp65_ = _tmp64_;
#line 311 "../src/gnome-chess.vala"
	_tmp66_ = self->priv->game;
#line 311 "../src/gnome-chess.vala"
	chess_scene_set_game (_tmp65_, _tmp66_);
#line 313 "../src/gnome-chess.vala"
	_tmp67_ = self->priv->_window;
#line 313 "../src/gnome-chess.vala"
	chess_window_start_game (_tmp67_);
#line 315 "../src/gnome-chess.vala"
	_tmp68_ = self->priv->pgn_game;
#line 315 "../src/gnome-chess.vala"
	_tmp69_ = pgn_game_get_white_ai (_tmp68_);
#line 315 "../src/gnome-chess.vala"
	_tmp70_ = _tmp69_;
#line 315 "../src/gnome-chess.vala"
	_tmp71_ = g_strdup (_tmp70_);
#line 315 "../src/gnome-chess.vala"
	white_engine = _tmp71_;
#line 316 "../src/gnome-chess.vala"
	_tmp72_ = self->priv->pgn_game;
#line 316 "../src/gnome-chess.vala"
	_tmp73_ = pgn_game_get_white_level (_tmp72_);
#line 316 "../src/gnome-chess.vala"
	_tmp74_ = _tmp73_;
#line 316 "../src/gnome-chess.vala"
	_tmp75_ = g_strdup (_tmp74_);
#line 316 "../src/gnome-chess.vala"
	white_level = _tmp75_;
#line 317 "../src/gnome-chess.vala"
	_tmp76_ = white_level;
#line 317 "../src/gnome-chess.vala"
	if (_tmp76_ == NULL) {
#line 2350 "gnome-chess.c"
		gchar* _tmp77_;
#line 318 "../src/gnome-chess.vala"
		_tmp77_ = g_strdup ("normal");
#line 318 "../src/gnome-chess.vala"
		_g_free0 (white_level);
#line 318 "../src/gnome-chess.vala"
		white_level = _tmp77_;
#line 2358 "gnome-chess.c"
	}
#line 320 "../src/gnome-chess.vala"
	_tmp78_ = self->priv->pgn_game;
#line 320 "../src/gnome-chess.vala"
	_tmp79_ = pgn_game_get_black_ai (_tmp78_);
#line 320 "../src/gnome-chess.vala"
	_tmp80_ = _tmp79_;
#line 320 "../src/gnome-chess.vala"
	_tmp81_ = g_strdup (_tmp80_);
#line 320 "../src/gnome-chess.vala"
	black_engine = _tmp81_;
#line 321 "../src/gnome-chess.vala"
	_tmp82_ = self->priv->pgn_game;
#line 321 "../src/gnome-chess.vala"
	_tmp83_ = pgn_game_get_black_level (_tmp82_);
#line 321 "../src/gnome-chess.vala"
	_tmp84_ = _tmp83_;
#line 321 "../src/gnome-chess.vala"
	_tmp85_ = g_strdup (_tmp84_);
#line 321 "../src/gnome-chess.vala"
	black_level = _tmp85_;
#line 322 "../src/gnome-chess.vala"
	_tmp86_ = black_level;
#line 322 "../src/gnome-chess.vala"
	if (_tmp86_ == NULL) {
#line 2384 "gnome-chess.c"
		gchar* _tmp87_;
#line 323 "../src/gnome-chess.vala"
		_tmp87_ = g_strdup ("normal");
#line 323 "../src/gnome-chess.vala"
		_g_free0 (black_level);
#line 323 "../src/gnome-chess.vala"
		black_level = _tmp87_;
#line 2392 "gnome-chess.c"
	}
#line 325 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->human_player);
#line 325 "../src/gnome-chess.vala"
	self->priv->human_player = NULL;
#line 326 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->opponent);
#line 326 "../src/gnome-chess.vala"
	self->priv->opponent = NULL;
#line 327 "../src/gnome-chess.vala"
	_tmp88_ = self->priv->opponent_engine;
#line 327 "../src/gnome-chess.vala"
	if (_tmp88_ != NULL) {
#line 2406 "gnome-chess.c"
		ChessEngine* _tmp89_;
		ChessEngine* _tmp90_;
		guint _tmp91_;
		ChessEngine* _tmp92_;
		guint _tmp93_;
		ChessEngine* _tmp94_;
		guint _tmp95_;
		ChessEngine* _tmp96_;
		guint _tmp97_;
		ChessEngine* _tmp98_;
		guint _tmp99_;
		ChessEngine* _tmp100_;
		guint _tmp101_;
#line 329 "../src/gnome-chess.vala"
		_tmp89_ = self->priv->opponent_engine;
#line 329 "../src/gnome-chess.vala"
		chess_engine_stop (_tmp89_, TRUE);
#line 330 "../src/gnome-chess.vala"
		_tmp90_ = self->priv->opponent_engine;
#line 330 "../src/gnome-chess.vala"
		g_signal_parse_name ("moved", TYPE_CHESS_ENGINE, &_tmp91_, NULL, FALSE);
#line 330 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp90_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp91_, 0, NULL, (GCallback) _chess_application_engine_move_cb_chess_engine_moved, self);
#line 331 "../src/gnome-chess.vala"
		_tmp92_ = self->priv->opponent_engine;
#line 331 "../src/gnome-chess.vala"
		g_signal_parse_name ("resigned", TYPE_CHESS_ENGINE, &_tmp93_, NULL, FALSE);
#line 331 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp92_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp93_, 0, NULL, (GCallback) _chess_application_engine_resigned_cb_chess_engine_resigned, self);
#line 332 "../src/gnome-chess.vala"
		_tmp94_ = self->priv->opponent_engine;
#line 332 "../src/gnome-chess.vala"
		g_signal_parse_name ("stopped-unexpectedly", TYPE_CHESS_ENGINE, &_tmp95_, NULL, FALSE);
#line 332 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp94_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp95_, 0, NULL, (GCallback) _chess_application_engine_stopped_unexpectedly_cb_chess_engine_stopped_unexpectedly, self);
#line 333 "../src/gnome-chess.vala"
		_tmp96_ = self->priv->opponent_engine;
#line 333 "../src/gnome-chess.vala"
		g_signal_parse_name ("error", TYPE_CHESS_ENGINE, &_tmp97_, NULL, FALSE);
#line 333 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp96_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp97_, 0, NULL, (GCallback) _chess_application_engine_error_cb_chess_engine_error, self);
#line 334 "../src/gnome-chess.vala"
		_tmp98_ = self->priv->opponent_engine;
#line 334 "../src/gnome-chess.vala"
		g_signal_parse_name ("claim-draw", TYPE_CHESS_ENGINE, &_tmp99_, NULL, FALSE);
#line 334 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp98_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp99_, 0, NULL, (GCallback) _chess_application_engine_claim_draw_cb_chess_engine_claim_draw, self);
#line 335 "../src/gnome-chess.vala"
		_tmp100_ = self->priv->opponent_engine;
#line 335 "../src/gnome-chess.vala"
		g_signal_parse_name ("offer-draw", TYPE_CHESS_ENGINE, &_tmp101_, NULL, FALSE);
#line 335 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp100_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp101_, 0, NULL, (GCallback) _chess_application_engine_offer_draw_cb_chess_engine_offer_draw, self);
#line 336 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->opponent_engine);
#line 336 "../src/gnome-chess.vala"
		self->priv->opponent_engine = NULL;
#line 2464 "gnome-chess.c"
	}
#line 339 "../src/gnome-chess.vala"
	_tmp102_ = white_engine;
#line 339 "../src/gnome-chess.vala"
	if (_tmp102_ != NULL) {
#line 2470 "gnome-chess.c"
		ChessGame* _tmp103_;
		ChessPlayer* _tmp104_;
		ChessPlayer* _tmp105_;
		ChessPlayer* _tmp106_;
		ChessGame* _tmp107_;
		ChessPlayer* _tmp108_;
		ChessPlayer* _tmp109_;
		ChessPlayer* _tmp110_;
		const gchar* _tmp111_;
		const gchar* _tmp112_;
		ChessEngine* _tmp113_;
		ChessPlayer* _tmp114_;
		ChessPlayer* _tmp115_;
#line 341 "../src/gnome-chess.vala"
		_tmp103_ = self->priv->game;
#line 341 "../src/gnome-chess.vala"
		_tmp104_ = chess_game_get_white (_tmp103_);
#line 341 "../src/gnome-chess.vala"
		_tmp105_ = _tmp104_;
#line 341 "../src/gnome-chess.vala"
		_tmp106_ = _g_object_ref0 (_tmp105_);
#line 341 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->opponent);
#line 341 "../src/gnome-chess.vala"
		self->priv->opponent = _tmp106_;
#line 342 "../src/gnome-chess.vala"
		_tmp107_ = self->priv->game;
#line 342 "../src/gnome-chess.vala"
		_tmp108_ = chess_game_get_black (_tmp107_);
#line 342 "../src/gnome-chess.vala"
		_tmp109_ = _tmp108_;
#line 342 "../src/gnome-chess.vala"
		_tmp110_ = _g_object_ref0 (_tmp109_);
#line 342 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->human_player);
#line 342 "../src/gnome-chess.vala"
		self->priv->human_player = _tmp110_;
#line 343 "../src/gnome-chess.vala"
		_tmp111_ = white_engine;
#line 343 "../src/gnome-chess.vala"
		_tmp112_ = white_level;
#line 343 "../src/gnome-chess.vala"
		_tmp113_ = chess_application_get_engine (self, _tmp111_, _tmp112_);
#line 343 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->opponent_engine);
#line 343 "../src/gnome-chess.vala"
		self->priv->opponent_engine = _tmp113_;
#line 344 "../src/gnome-chess.vala"
		_tmp114_ = self->priv->opponent;
#line 344 "../src/gnome-chess.vala"
		chess_player_set_local_human (_tmp114_, FALSE);
#line 345 "../src/gnome-chess.vala"
		_tmp115_ = self->priv->human_player;
#line 345 "../src/gnome-chess.vala"
		chess_player_set_local_human (_tmp115_, TRUE);
#line 2526 "gnome-chess.c"
	} else {
		const gchar* _tmp116_;
#line 347 "../src/gnome-chess.vala"
		_tmp116_ = black_engine;
#line 347 "../src/gnome-chess.vala"
		if (_tmp116_ != NULL) {
#line 2533 "gnome-chess.c"
			ChessGame* _tmp117_;
			ChessPlayer* _tmp118_;
			ChessPlayer* _tmp119_;
			ChessPlayer* _tmp120_;
			ChessGame* _tmp121_;
			ChessPlayer* _tmp122_;
			ChessPlayer* _tmp123_;
			ChessPlayer* _tmp124_;
			const gchar* _tmp125_;
			const gchar* _tmp126_;
			ChessEngine* _tmp127_;
			ChessPlayer* _tmp128_;
			ChessPlayer* _tmp129_;
#line 349 "../src/gnome-chess.vala"
			_tmp117_ = self->priv->game;
#line 349 "../src/gnome-chess.vala"
			_tmp118_ = chess_game_get_black (_tmp117_);
#line 349 "../src/gnome-chess.vala"
			_tmp119_ = _tmp118_;
#line 349 "../src/gnome-chess.vala"
			_tmp120_ = _g_object_ref0 (_tmp119_);
#line 349 "../src/gnome-chess.vala"
			_g_object_unref0 (self->priv->opponent);
#line 349 "../src/gnome-chess.vala"
			self->priv->opponent = _tmp120_;
#line 350 "../src/gnome-chess.vala"
			_tmp121_ = self->priv->game;
#line 350 "../src/gnome-chess.vala"
			_tmp122_ = chess_game_get_white (_tmp121_);
#line 350 "../src/gnome-chess.vala"
			_tmp123_ = _tmp122_;
#line 350 "../src/gnome-chess.vala"
			_tmp124_ = _g_object_ref0 (_tmp123_);
#line 350 "../src/gnome-chess.vala"
			_g_object_unref0 (self->priv->human_player);
#line 350 "../src/gnome-chess.vala"
			self->priv->human_player = _tmp124_;
#line 351 "../src/gnome-chess.vala"
			_tmp125_ = black_engine;
#line 351 "../src/gnome-chess.vala"
			_tmp126_ = black_level;
#line 351 "../src/gnome-chess.vala"
			_tmp127_ = chess_application_get_engine (self, _tmp125_, _tmp126_);
#line 351 "../src/gnome-chess.vala"
			_g_object_unref0 (self->priv->opponent_engine);
#line 351 "../src/gnome-chess.vala"
			self->priv->opponent_engine = _tmp127_;
#line 352 "../src/gnome-chess.vala"
			_tmp128_ = self->priv->opponent;
#line 352 "../src/gnome-chess.vala"
			chess_player_set_local_human (_tmp128_, FALSE);
#line 353 "../src/gnome-chess.vala"
			_tmp129_ = self->priv->human_player;
#line 353 "../src/gnome-chess.vala"
			chess_player_set_local_human (_tmp129_, TRUE);
#line 2589 "gnome-chess.c"
		}
	}
#line 357 "../src/gnome-chess.vala"
	_tmp130_ = self->priv->opponent_engine;
#line 357 "../src/gnome-chess.vala"
	if (_tmp130_ == NULL) {
#line 2596 "gnome-chess.c"
		ChessGame* _tmp131_;
		ChessPlayer* _tmp132_;
		ChessPlayer* _tmp133_;
		ChessGame* _tmp134_;
		ChessPlayer* _tmp135_;
		ChessPlayer* _tmp136_;
#line 359 "../src/gnome-chess.vala"
		_tmp131_ = self->priv->game;
#line 359 "../src/gnome-chess.vala"
		_tmp132_ = chess_game_get_black (_tmp131_);
#line 359 "../src/gnome-chess.vala"
		_tmp133_ = _tmp132_;
#line 359 "../src/gnome-chess.vala"
		chess_player_set_local_human (_tmp133_, TRUE);
#line 360 "../src/gnome-chess.vala"
		_tmp134_ = self->priv->game;
#line 360 "../src/gnome-chess.vala"
		_tmp135_ = chess_game_get_white (_tmp134_);
#line 360 "../src/gnome-chess.vala"
		_tmp136_ = _tmp135_;
#line 360 "../src/gnome-chess.vala"
		chess_player_set_local_human (_tmp136_, TRUE);
#line 361 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->human_player);
#line 361 "../src/gnome-chess.vala"
		self->priv->human_player = NULL;
#line 2623 "gnome-chess.c"
	} else {
		ChessEngine* _tmp137_;
		ChessEngine* _tmp138_;
		ChessEngine* _tmp139_;
		ChessEngine* _tmp140_;
		ChessEngine* _tmp141_;
		ChessEngine* _tmp142_;
		ChessEngine* _tmp143_;
#line 365 "../src/gnome-chess.vala"
		_tmp137_ = self->priv->opponent_engine;
#line 365 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp137_, "moved", (GCallback) _chess_application_engine_move_cb_chess_engine_moved, self, 0);
#line 366 "../src/gnome-chess.vala"
		_tmp138_ = self->priv->opponent_engine;
#line 366 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp138_, "resigned", (GCallback) _chess_application_engine_resigned_cb_chess_engine_resigned, self, 0);
#line 367 "../src/gnome-chess.vala"
		_tmp139_ = self->priv->opponent_engine;
#line 367 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp139_, "stopped-unexpectedly", (GCallback) _chess_application_engine_stopped_unexpectedly_cb_chess_engine_stopped_unexpectedly, self, 0);
#line 368 "../src/gnome-chess.vala"
		_tmp140_ = self->priv->opponent_engine;
#line 368 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp140_, "error", (GCallback) _chess_application_engine_error_cb_chess_engine_error, self, 0);
#line 369 "../src/gnome-chess.vala"
		_tmp141_ = self->priv->opponent_engine;
#line 369 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp141_, "claim-draw", (GCallback) _chess_application_engine_claim_draw_cb_chess_engine_claim_draw, self, 0);
#line 370 "../src/gnome-chess.vala"
		_tmp142_ = self->priv->opponent_engine;
#line 370 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp142_, "offer-draw", (GCallback) _chess_application_engine_offer_draw_cb_chess_engine_offer_draw, self, 0);
#line 372 "../src/gnome-chess.vala"
		_tmp143_ = self->priv->opponent_engine;
#line 372 "../src/gnome-chess.vala"
		if (!chess_engine_start (_tmp143_)) {
#line 2660 "gnome-chess.c"
			ChessGame* _tmp144_;
			ChessGame* _tmp145_;
#line 374 "../src/gnome-chess.vala"
			chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 375 "../src/gnome-chess.vala"
			_tmp144_ = self->priv->game;
#line 375 "../src/gnome-chess.vala"
			_tmp144_->result = CHESS_RESULT_BUG;
#line 376 "../src/gnome-chess.vala"
			_tmp145_ = self->priv->game;
#line 376 "../src/gnome-chess.vala"
			_tmp145_->rule = CHESS_RULE_BUG;
#line 377 "../src/gnome-chess.vala"
			chess_application_game_end_cb (self);
#line 378 "../src/gnome-chess.vala"
			_g_free0 (black_level);
#line 378 "../src/gnome-chess.vala"
			_g_free0 (black_engine);
#line 378 "../src/gnome-chess.vala"
			_g_free0 (white_level);
#line 378 "../src/gnome-chess.vala"
			_g_free0 (white_engine);
#line 378 "../src/gnome-chess.vala"
			moves = (_vala_array_free (moves, moves_length1, (GDestroyNotify) g_free), NULL);
#line 378 "../src/gnome-chess.vala"
			_g_free0 (fen);
#line 378 "../src/gnome-chess.vala"
			return;
#line 2689 "gnome-chess.c"
		}
	}
	{
		gint j = 0;
		ChessGame* _tmp146_;
		GList* _tmp147_;
#line 383 "../src/gnome-chess.vala"
		_tmp146_ = self->priv->game;
#line 383 "../src/gnome-chess.vala"
		_tmp147_ = _tmp146_->move_stack;
#line 383 "../src/gnome-chess.vala"
		j = ((gint) g_list_length (_tmp147_)) - 2;
#line 2702 "gnome-chess.c"
		{
			gboolean _tmp148_ = FALSE;
#line 383 "../src/gnome-chess.vala"
			_tmp148_ = TRUE;
#line 383 "../src/gnome-chess.vala"
			while (TRUE) {
#line 2709 "gnome-chess.c"
				ChessState* state = NULL;
				ChessGame* _tmp150_;
				GList* _tmp151_;
				gconstpointer _tmp152_;
				ChessState* _tmp153_;
				ChessGame* _tmp154_;
				ChessState* _tmp155_;
				ChessMove* _tmp156_;
#line 383 "../src/gnome-chess.vala"
				if (!_tmp148_) {
#line 2720 "gnome-chess.c"
					gint _tmp149_;
#line 383 "../src/gnome-chess.vala"
					_tmp149_ = j;
#line 383 "../src/gnome-chess.vala"
					j = _tmp149_ - 1;
#line 2726 "gnome-chess.c"
				}
#line 383 "../src/gnome-chess.vala"
				_tmp148_ = FALSE;
#line 383 "../src/gnome-chess.vala"
				if (!(j >= 0)) {
#line 383 "../src/gnome-chess.vala"
					break;
#line 2734 "gnome-chess.c"
				}
#line 385 "../src/gnome-chess.vala"
				_tmp150_ = self->priv->game;
#line 385 "../src/gnome-chess.vala"
				_tmp151_ = _tmp150_->move_stack;
#line 385 "../src/gnome-chess.vala"
				_tmp152_ = g_list_nth_data (_tmp151_, (guint) j);
#line 385 "../src/gnome-chess.vala"
				_tmp153_ = _g_object_ref0 ((ChessState*) _tmp152_);
#line 385 "../src/gnome-chess.vala"
				state = _tmp153_;
#line 386 "../src/gnome-chess.vala"
				_tmp154_ = self->priv->game;
#line 386 "../src/gnome-chess.vala"
				_tmp155_ = state;
#line 386 "../src/gnome-chess.vala"
				_tmp156_ = _tmp155_->last_move;
#line 386 "../src/gnome-chess.vala"
				chess_application_game_move_cb (self, _tmp154_, _tmp156_);
#line 383 "../src/gnome-chess.vala"
				_g_object_unref0 (state);
#line 2756 "gnome-chess.c"
			}
		}
	}
#line 389 "../src/gnome-chess.vala"
	_tmp158_ = self->priv->game_file;
#line 389 "../src/gnome-chess.vala"
	if (_tmp158_ != NULL) {
#line 2764 "gnome-chess.c"
		GFile* _tmp159_;
		gchar* _tmp160_;
		gchar* _tmp161_;
		const gchar* _tmp162_;
#line 389 "../src/gnome-chess.vala"
		_tmp159_ = self->priv->game_file;
#line 389 "../src/gnome-chess.vala"
		_tmp160_ = g_file_get_path (_tmp159_);
#line 389 "../src/gnome-chess.vala"
		_tmp161_ = _tmp160_;
#line 389 "../src/gnome-chess.vala"
		_tmp162_ = self->priv->autosave_filename;
#line 389 "../src/gnome-chess.vala"
		_tmp157_ = g_strcmp0 (_tmp161_, _tmp162_) == 0;
#line 389 "../src/gnome-chess.vala"
		_g_free0 (_tmp161_);
#line 2781 "gnome-chess.c"
	} else {
#line 389 "../src/gnome-chess.vala"
		_tmp157_ = FALSE;
#line 2785 "gnome-chess.c"
	}
#line 389 "../src/gnome-chess.vala"
	if (_tmp157_) {
#line 391 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = TRUE;
#line 392 "../src/gnome-chess.vala"
		chess_application_enable_action (self, SAVE_GAME_ACTION_NAME);
#line 2793 "gnome-chess.c"
	} else {
#line 396 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = FALSE;
#line 397 "../src/gnome-chess.vala"
		chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 2799 "gnome-chess.c"
	}
#line 400 "../src/gnome-chess.vala"
	_tmp163_ = self->priv->game;
#line 400 "../src/gnome-chess.vala"
	chess_game_start (_tmp163_);
#line 402 "../src/gnome-chess.vala"
	timer_increment_adj_value = 0;
#line 403 "../src/gnome-chess.vala"
	_tmp164_ = self->priv->pgn_game;
#line 403 "../src/gnome-chess.vala"
	_tmp165_ = pgn_game_get_timer_increment (_tmp164_);
#line 403 "../src/gnome-chess.vala"
	_tmp166_ = _tmp165_;
#line 403 "../src/gnome-chess.vala"
	if (_tmp166_ != NULL) {
#line 2815 "gnome-chess.c"
		PGNGame* _tmp167_;
		const gchar* _tmp168_;
		const gchar* _tmp169_;
#line 404 "../src/gnome-chess.vala"
		_tmp167_ = self->priv->pgn_game;
#line 404 "../src/gnome-chess.vala"
		_tmp168_ = pgn_game_get_timer_increment (_tmp167_);
#line 404 "../src/gnome-chess.vala"
		_tmp169_ = _tmp168_;
#line 404 "../src/gnome-chess.vala"
		timer_increment_adj_value = atoi (_tmp169_);
#line 2827 "gnome-chess.c"
	} else {
		GSettings* _tmp170_;
		PGNGame* _tmp171_;
		gchar* _tmp172_;
		gchar* _tmp173_;
#line 407 "../src/gnome-chess.vala"
		_tmp170_ = self->priv->settings;
#line 407 "../src/gnome-chess.vala"
		timer_increment_adj_value = g_settings_get_int (_tmp170_, INCREMENT_SETTINGS_KEY);
#line 408 "../src/gnome-chess.vala"
		_tmp171_ = self->priv->pgn_game;
#line 408 "../src/gnome-chess.vala"
		_tmp172_ = g_strdup_printf ("%i", timer_increment_adj_value);
#line 408 "../src/gnome-chess.vala"
		_tmp173_ = _tmp172_;
#line 408 "../src/gnome-chess.vala"
		pgn_game_set_timer_increment (_tmp171_, _tmp173_);
#line 408 "../src/gnome-chess.vala"
		_g_free0 (_tmp173_);
#line 2847 "gnome-chess.c"
	}
#line 411 "../src/gnome-chess.vala"
	clock_type = CHESS_CLOCK_TYPE_SIMPLE;
#line 412 "../src/gnome-chess.vala"
	_tmp174_ = self->priv->pgn_game;
#line 412 "../src/gnome-chess.vala"
	_tmp175_ = pgn_game_get_clock_type (_tmp174_);
#line 412 "../src/gnome-chess.vala"
	_tmp176_ = _tmp175_;
#line 412 "../src/gnome-chess.vala"
	if (_tmp176_ != NULL) {
#line 2859 "gnome-chess.c"
		PGNGame* _tmp177_;
		const gchar* _tmp178_;
		const gchar* _tmp179_;
#line 413 "../src/gnome-chess.vala"
		_tmp177_ = self->priv->pgn_game;
#line 413 "../src/gnome-chess.vala"
		_tmp178_ = pgn_game_get_clock_type (_tmp177_);
#line 413 "../src/gnome-chess.vala"
		_tmp179_ = _tmp178_;
#line 413 "../src/gnome-chess.vala"
		clock_type = chess_clock_type_string_to_enum (_tmp179_);
#line 2871 "gnome-chess.c"
	} else {
		GSettings* _tmp180_;
		gchar* _tmp181_;
		gchar* _tmp182_;
		PGNGame* _tmp183_;
		gchar* _tmp184_;
		gchar* _tmp185_;
#line 416 "../src/gnome-chess.vala"
		_tmp180_ = self->priv->settings;
#line 416 "../src/gnome-chess.vala"
		_tmp181_ = g_settings_get_string (_tmp180_, CLOCK_TYPE_SETTINGS_KEY);
#line 416 "../src/gnome-chess.vala"
		_tmp182_ = _tmp181_;
#line 416 "../src/gnome-chess.vala"
		clock_type = chess_clock_type_string_to_enum (_tmp182_);
#line 416 "../src/gnome-chess.vala"
		_g_free0 (_tmp182_);
#line 417 "../src/gnome-chess.vala"
		_tmp183_ = self->priv->pgn_game;
#line 417 "../src/gnome-chess.vala"
		_tmp184_ = chess_clock_type_to_string (clock_type);
#line 417 "../src/gnome-chess.vala"
		_tmp185_ = _tmp184_;
#line 417 "../src/gnome-chess.vala"
		pgn_game_set_clock_type (_tmp183_, _tmp185_);
#line 417 "../src/gnome-chess.vala"
		_g_free0 (_tmp185_);
#line 2899 "gnome-chess.c"
	}
#line 420 "../src/gnome-chess.vala"
	_tmp186_ = self->priv->_window;
#line 420 "../src/gnome-chess.vala"
	_tmp187_ = self->priv->game;
#line 420 "../src/gnome-chess.vala"
	_tmp188_ = chess_game_get_clock (_tmp187_);
#line 420 "../src/gnome-chess.vala"
	_tmp189_ = _tmp188_;
#line 420 "../src/gnome-chess.vala"
	chess_window_set_clock_visible (_tmp186_, _tmp189_ != NULL);
#line 422 "../src/gnome-chess.vala"
	_tmp190_ = self->priv->game;
#line 422 "../src/gnome-chess.vala"
	_tmp191_ = chess_game_get_clock (_tmp190_);
#line 422 "../src/gnome-chess.vala"
	_tmp192_ = _tmp191_;
#line 422 "../src/gnome-chess.vala"
	if (_tmp192_ != NULL) {
#line 2919 "gnome-chess.c"
		ChessGame* _tmp193_;
		ChessClock* _tmp194_;
		ChessClock* _tmp195_;
		ChessGame* _tmp196_;
		ChessClock* _tmp197_;
		ChessClock* _tmp198_;
#line 424 "../src/gnome-chess.vala"
		_tmp193_ = self->priv->game;
#line 424 "../src/gnome-chess.vala"
		_tmp194_ = chess_game_get_clock (_tmp193_);
#line 424 "../src/gnome-chess.vala"
		_tmp195_ = _tmp194_;
#line 424 "../src/gnome-chess.vala"
		chess_clock_set_extra_seconds (_tmp195_, (gint) timer_increment_adj_value);
#line 425 "../src/gnome-chess.vala"
		_tmp196_ = self->priv->game;
#line 425 "../src/gnome-chess.vala"
		_tmp197_ = chess_game_get_clock (_tmp196_);
#line 425 "../src/gnome-chess.vala"
		_tmp198_ = _tmp197_;
#line 425 "../src/gnome-chess.vala"
		chess_clock_set_clock_type (_tmp198_, clock_type);
#line 2942 "gnome-chess.c"
	}
#line 429 "../src/gnome-chess.vala"
	_tmp199_ = self->priv->pgn_game;
#line 429 "../src/gnome-chess.vala"
	_tmp200_ = pgn_game_get_result (_tmp199_);
#line 429 "../src/gnome-chess.vala"
	_tmp201_ = _tmp200_;
#line 429 "../src/gnome-chess.vala"
	_tmp202_ = pgn_game_RESULT_WHITE;
#line 429 "../src/gnome-chess.vala"
	if (g_strcmp0 (_tmp201_, _tmp202_) == 0) {
#line 2954 "gnome-chess.c"
		ChessGame* _tmp203_;
#line 430 "../src/gnome-chess.vala"
		_tmp203_ = self->priv->game;
#line 430 "../src/gnome-chess.vala"
		_tmp203_->result = CHESS_RESULT_WHITE_WON;
#line 2960 "gnome-chess.c"
	} else {
		PGNGame* _tmp204_;
		const gchar* _tmp205_;
		const gchar* _tmp206_;
		const gchar* _tmp207_;
#line 431 "../src/gnome-chess.vala"
		_tmp204_ = self->priv->pgn_game;
#line 431 "../src/gnome-chess.vala"
		_tmp205_ = pgn_game_get_result (_tmp204_);
#line 431 "../src/gnome-chess.vala"
		_tmp206_ = _tmp205_;
#line 431 "../src/gnome-chess.vala"
		_tmp207_ = pgn_game_RESULT_BLACK;
#line 431 "../src/gnome-chess.vala"
		if (g_strcmp0 (_tmp206_, _tmp207_) == 0) {
#line 2976 "gnome-chess.c"
			ChessGame* _tmp208_;
#line 432 "../src/gnome-chess.vala"
			_tmp208_ = self->priv->game;
#line 432 "../src/gnome-chess.vala"
			_tmp208_->result = CHESS_RESULT_BLACK_WON;
#line 2982 "gnome-chess.c"
		} else {
			PGNGame* _tmp209_;
			const gchar* _tmp210_;
			const gchar* _tmp211_;
			const gchar* _tmp212_;
#line 433 "../src/gnome-chess.vala"
			_tmp209_ = self->priv->pgn_game;
#line 433 "../src/gnome-chess.vala"
			_tmp210_ = pgn_game_get_result (_tmp209_);
#line 433 "../src/gnome-chess.vala"
			_tmp211_ = _tmp210_;
#line 433 "../src/gnome-chess.vala"
			_tmp212_ = pgn_game_RESULT_DRAW;
#line 433 "../src/gnome-chess.vala"
			if (g_strcmp0 (_tmp211_, _tmp212_) == 0) {
#line 2998 "gnome-chess.c"
				ChessGame* _tmp213_;
#line 434 "../src/gnome-chess.vala"
				_tmp213_ = self->priv->game;
#line 434 "../src/gnome-chess.vala"
				_tmp213_->result = CHESS_RESULT_DRAW;
#line 3004 "gnome-chess.c"
			}
		}
	}
#line 436 "../src/gnome-chess.vala"
	_tmp214_ = self->priv->opponent_engine;
#line 436 "../src/gnome-chess.vala"
	if (_tmp214_ != NULL) {
#line 3012 "gnome-chess.c"
		ChessEngine* _tmp215_;
#line 437 "../src/gnome-chess.vala"
		_tmp215_ = self->priv->opponent_engine;
#line 437 "../src/gnome-chess.vala"
		chess_engine_start_game (_tmp215_);
#line 3018 "gnome-chess.c"
	}
#line 439 "../src/gnome-chess.vala"
	_tmp217_ = moves;
#line 439 "../src/gnome-chess.vala"
	_tmp217__length1 = moves_length1;
#line 439 "../src/gnome-chess.vala"
	if (_tmp217__length1 > 0) {
#line 3026 "gnome-chess.c"
		ChessGame* _tmp218_;
		ChessClock* _tmp219_;
		ChessClock* _tmp220_;
#line 439 "../src/gnome-chess.vala"
		_tmp218_ = self->priv->game;
#line 439 "../src/gnome-chess.vala"
		_tmp219_ = chess_game_get_clock (_tmp218_);
#line 439 "../src/gnome-chess.vala"
		_tmp220_ = _tmp219_;
#line 439 "../src/gnome-chess.vala"
		_tmp216_ = _tmp220_ != NULL;
#line 3038 "gnome-chess.c"
	} else {
#line 439 "../src/gnome-chess.vala"
		_tmp216_ = FALSE;
#line 3042 "gnome-chess.c"
	}
#line 439 "../src/gnome-chess.vala"
	if (_tmp216_) {
#line 3046 "gnome-chess.c"
		ChessGame* _tmp221_;
		ChessClock* _tmp222_;
		ChessClock* _tmp223_;
#line 441 "../src/gnome-chess.vala"
		_tmp221_ = self->priv->game;
#line 441 "../src/gnome-chess.vala"
		_tmp222_ = chess_game_get_clock (_tmp221_);
#line 441 "../src/gnome-chess.vala"
		_tmp223_ = _tmp222_;
#line 441 "../src/gnome-chess.vala"
		chess_clock_start (_tmp223_);
#line 442 "../src/gnome-chess.vala"
		chess_application_enable_action (self, PAUSE_RESUME_ACTION_NAME);
#line 3060 "gnome-chess.c"
	} else {
#line 446 "../src/gnome-chess.vala"
		chess_application_disable_action (self, PAUSE_RESUME_ACTION_NAME);
#line 3064 "gnome-chess.c"
	}
#line 449 "../src/gnome-chess.vala"
	chess_application_update_action_status (self);
#line 450 "../src/gnome-chess.vala"
	_tmp224_ = self->priv->_window;
#line 450 "../src/gnome-chess.vala"
	chess_window_update_history_panel (_tmp224_);
#line 451 "../src/gnome-chess.vala"
	_tmp225_ = self->priv->_window;
#line 451 "../src/gnome-chess.vala"
	chess_window_update_pause_resume_button (_tmp225_);
#line 453 "../src/gnome-chess.vala"
	_tmp226_ = self->priv->ai_profiles;
#line 453 "../src/gnome-chess.vala"
	if (_tmp226_ == NULL) {
#line 3080 "gnome-chess.c"
		ChessWindow* _tmp227_;
#line 455 "../src/gnome-chess.vala"
		_tmp227_ = self->priv->_window;
#line 455 "../src/gnome-chess.vala"
		chess_window_update_game_status (_tmp227_, NULL, _ ("No chess engine is installed. You will not be able to play against the" \
" computer."));
#line 3086 "gnome-chess.c"
	} else {
		ChessWindow* _tmp228_;
#line 461 "../src/gnome-chess.vala"
		_tmp228_ = self->priv->_window;
#line 461 "../src/gnome-chess.vala"
		chess_window_update_game_status (_tmp228_, NULL, NULL);
#line 3093 "gnome-chess.c"
	}
#line 464 "../src/gnome-chess.vala"
	self->priv->starting = FALSE;
#line 466 "../src/gnome-chess.vala"
	_tmp231_ = white_engine;
#line 466 "../src/gnome-chess.vala"
	if (_tmp231_ != NULL) {
#line 3101 "gnome-chess.c"
		ChessGame* _tmp232_;
		ChessPlayer* _tmp233_;
		ChessPlayer* _tmp234_;
#line 466 "../src/gnome-chess.vala"
		_tmp232_ = self->priv->game;
#line 466 "../src/gnome-chess.vala"
		_tmp233_ = chess_game_get_current_player (_tmp232_);
#line 466 "../src/gnome-chess.vala"
		_tmp234_ = _tmp233_;
#line 466 "../src/gnome-chess.vala"
		_tmp230_ = _tmp234_->color == COLOR_WHITE;
#line 3113 "gnome-chess.c"
	} else {
#line 466 "../src/gnome-chess.vala"
		_tmp230_ = FALSE;
#line 3117 "gnome-chess.c"
	}
#line 466 "../src/gnome-chess.vala"
	if (_tmp230_) {
#line 466 "../src/gnome-chess.vala"
		_tmp229_ = TRUE;
#line 3123 "gnome-chess.c"
	} else {
		gboolean _tmp235_ = FALSE;
		const gchar* _tmp236_;
#line 467 "../src/gnome-chess.vala"
		_tmp236_ = black_engine;
#line 467 "../src/gnome-chess.vala"
		if (_tmp236_ != NULL) {
#line 3131 "gnome-chess.c"
			ChessGame* _tmp237_;
			ChessPlayer* _tmp238_;
			ChessPlayer* _tmp239_;
#line 467 "../src/gnome-chess.vala"
			_tmp237_ = self->priv->game;
#line 467 "../src/gnome-chess.vala"
			_tmp238_ = chess_game_get_current_player (_tmp237_);
#line 467 "../src/gnome-chess.vala"
			_tmp239_ = _tmp238_;
#line 467 "../src/gnome-chess.vala"
			_tmp235_ = _tmp239_->color == COLOR_BLACK;
#line 3143 "gnome-chess.c"
		} else {
#line 467 "../src/gnome-chess.vala"
			_tmp235_ = FALSE;
#line 3147 "gnome-chess.c"
		}
#line 467 "../src/gnome-chess.vala"
		_tmp229_ = _tmp235_;
#line 3151 "gnome-chess.c"
	}
#line 466 "../src/gnome-chess.vala"
	if (_tmp229_) {
#line 3155 "gnome-chess.c"
		ChessEngine* _tmp240_;
		ChessEngine* _tmp241_;
#line 469 "../src/gnome-chess.vala"
		_tmp240_ = self->priv->opponent_engine;
#line 469 "../src/gnome-chess.vala"
		_vala_assert (_tmp240_ != NULL, "opponent_engine != null");
#line 470 "../src/gnome-chess.vala"
		chess_application_update_engine_timeout (self);
#line 471 "../src/gnome-chess.vala"
		_tmp241_ = self->priv->opponent_engine;
#line 471 "../src/gnome-chess.vala"
		chess_engine_move (_tmp241_);
#line 3168 "gnome-chess.c"
	}
#line 475 "../src/gnome-chess.vala"
	_tmp242_ = self->priv->game;
#line 475 "../src/gnome-chess.vala"
	if (_tmp242_->result != CHESS_RESULT_IN_PROGRESS) {
#line 3174 "gnome-chess.c"
		ChessGame* _tmp243_;
		ChessGame* _tmp244_;
#line 476 "../src/gnome-chess.vala"
		_tmp243_ = self->priv->game;
#line 476 "../src/gnome-chess.vala"
		_tmp244_ = self->priv->game;
#line 476 "../src/gnome-chess.vala"
		chess_game_stop (_tmp243_, _tmp244_->result, CHESS_RULE_UNKNOWN);
#line 3183 "gnome-chess.c"
	}
#line 253 "../src/gnome-chess.vala"
	_g_free0 (black_level);
#line 253 "../src/gnome-chess.vala"
	_g_free0 (black_engine);
#line 253 "../src/gnome-chess.vala"
	_g_free0 (white_level);
#line 253 "../src/gnome-chess.vala"
	_g_free0 (white_engine);
#line 253 "../src/gnome-chess.vala"
	moves = (_vala_array_free (moves, moves_length1, (GDestroyNotify) g_free), NULL);
#line 253 "../src/gnome-chess.vala"
	_g_free0 (fen);
#line 3197 "gnome-chess.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 511 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3206 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 511 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 511 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3213 "gnome-chess.c"
			gchar* _tmp0_;
#line 511 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 511 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3219 "gnome-chess.c"
		}
#line 511 "../src/gnome-chess.vala"
		return result;
#line 3223 "gnome-chess.c"
	}
#line 511 "../src/gnome-chess.vala"
	return NULL;
#line 3227 "gnome-chess.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 512 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3236 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 512 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 512 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3243 "gnome-chess.c"
			gchar* _tmp0_;
#line 512 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 512 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3249 "gnome-chess.c"
		}
#line 512 "../src/gnome-chess.vala"
		return result;
#line 3253 "gnome-chess.c"
	}
#line 512 "../src/gnome-chess.vala"
	return NULL;
#line 3257 "gnome-chess.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 513 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3266 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 513 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 513 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3273 "gnome-chess.c"
			gchar* _tmp0_;
#line 513 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 513 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3279 "gnome-chess.c"
		}
#line 513 "../src/gnome-chess.vala"
		return result;
#line 3283 "gnome-chess.c"
	}
#line 513 "../src/gnome-chess.vala"
	return NULL;
#line 3287 "gnome-chess.c"
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
#line 522 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3296 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 522 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 522 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3303 "gnome-chess.c"
			gchar* _tmp0_;
#line 522 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 522 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3309 "gnome-chess.c"
		}
#line 522 "../src/gnome-chess.vala"
		return result;
#line 3313 "gnome-chess.c"
	}
#line 522 "../src/gnome-chess.vala"
	return NULL;
#line 3317 "gnome-chess.c"
}

static gchar**
_vala_array_dup5 (gchar** self,
                  gssize length)
{
#line 523 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3326 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 523 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 523 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3333 "gnome-chess.c"
			gchar* _tmp0_;
#line 523 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 523 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3339 "gnome-chess.c"
		}
#line 523 "../src/gnome-chess.vala"
		return result;
#line 3343 "gnome-chess.c"
	}
#line 523 "../src/gnome-chess.vala"
	return NULL;
#line 3347 "gnome-chess.c"
}

static gchar**
_vala_array_dup6 (gchar** self,
                  gssize length)
{
#line 524 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3356 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 524 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 524 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3363 "gnome-chess.c"
			gchar* _tmp0_;
#line 524 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 524 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3369 "gnome-chess.c"
		}
#line 524 "../src/gnome-chess.vala"
		return result;
#line 3373 "gnome-chess.c"
	}
#line 524 "../src/gnome-chess.vala"
	return NULL;
#line 3377 "gnome-chess.c"
}

static gchar**
_vala_array_dup7 (gchar** self,
                  gssize length)
{
#line 517 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3386 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 517 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 517 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3393 "gnome-chess.c"
			gchar* _tmp0_;
#line 517 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 517 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3399 "gnome-chess.c"
		}
#line 517 "../src/gnome-chess.vala"
		return result;
#line 3403 "gnome-chess.c"
	}
#line 517 "../src/gnome-chess.vala"
	return NULL;
#line 3407 "gnome-chess.c"
}

static gchar**
_vala_array_dup8 (gchar** self,
                  gssize length)
{
#line 518 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3416 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 518 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 518 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3423 "gnome-chess.c"
			gchar* _tmp0_;
#line 518 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 518 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3429 "gnome-chess.c"
		}
#line 518 "../src/gnome-chess.vala"
		return result;
#line 3433 "gnome-chess.c"
	}
#line 518 "../src/gnome-chess.vala"
	return NULL;
#line 3437 "gnome-chess.c"
}

static gchar**
_vala_array_dup9 (gchar** self,
                  gssize length)
{
#line 519 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3446 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 519 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 519 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3453 "gnome-chess.c"
			gchar* _tmp0_;
#line 519 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 519 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3459 "gnome-chess.c"
		}
#line 519 "../src/gnome-chess.vala"
		return result;
#line 3463 "gnome-chess.c"
	}
#line 519 "../src/gnome-chess.vala"
	return NULL;
#line 3467 "gnome-chess.c"
}

static ChessEngine*
chess_application_get_engine (ChessApplication* self,
                              const gchar* name,
                              const gchar* difficulty)
{
	ChessEngine* engine = NULL;
	AIProfile* profile = NULL;
	GList* _tmp0_;
	AIProfile* _tmp8_;
	gchar** options = NULL;
	gint options_length1 = 0;
	gint _options_size_ = 0;
	gchar** uci_go_options = NULL;
	gint uci_go_options_length1 = 0;
	gint _uci_go_options_size_ = 0;
	gchar** args = NULL;
	gint args_length1 = 0;
	gint _args_size_ = 0;
	const gchar* _tmp13_;
	GQuark _tmp15_ = 0U;
#line 508 "../src/gnome-chess.vala"
	static GQuark _tmp14_label0 = 0;
#line 508 "../src/gnome-chess.vala"
	static GQuark _tmp14_label1 = 0;
#line 3494 "gnome-chess.c"
	AIProfile* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	ChessEngine* result;
#line 479 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 479 "../src/gnome-chess.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 479 "../src/gnome-chess.vala"
	g_return_val_if_fail (difficulty != NULL, NULL);
#line 482 "../src/gnome-chess.vala"
	profile = NULL;
#line 484 "../src/gnome-chess.vala"
	if (g_strcmp0 (name, "human") == 0) {
#line 485 "../src/gnome-chess.vala"
		result = NULL;
#line 485 "../src/gnome-chess.vala"
		_g_object_unref0 (profile);
#line 485 "../src/gnome-chess.vala"
		_g_object_unref0 (engine);
#line 485 "../src/gnome-chess.vala"
		return result;
#line 3517 "gnome-chess.c"
	}
#line 488 "../src/gnome-chess.vala"
	if (g_strcmp0 (name, "GNUchess") == 0) {
#line 489 "../src/gnome-chess.vala"
		name = "GNU Chess";
#line 3523 "gnome-chess.c"
	}
#line 491 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->ai_profiles;
#line 3527 "gnome-chess.c"
	{
		GList* p_collection = NULL;
		GList* p_it = NULL;
#line 491 "../src/gnome-chess.vala"
		p_collection = _tmp0_;
#line 491 "../src/gnome-chess.vala"
		for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
#line 3535 "gnome-chess.c"
			AIProfile* _tmp1_;
			AIProfile* p = NULL;
#line 491 "../src/gnome-chess.vala"
			_tmp1_ = _g_object_ref0 ((AIProfile*) p_it->data);
#line 491 "../src/gnome-chess.vala"
			p = _tmp1_;
#line 3542 "gnome-chess.c"
			{
				gboolean _tmp2_ = FALSE;
#line 493 "../src/gnome-chess.vala"
				if (g_strcmp0 (name, "") == 0) {
#line 493 "../src/gnome-chess.vala"
					_tmp2_ = TRUE;
#line 3549 "gnome-chess.c"
				} else {
					AIProfile* _tmp3_;
					const gchar* _tmp4_;
					const gchar* _tmp5_;
#line 493 "../src/gnome-chess.vala"
					_tmp3_ = p;
#line 493 "../src/gnome-chess.vala"
					_tmp4_ = ai_profile_get_name (_tmp3_);
#line 493 "../src/gnome-chess.vala"
					_tmp5_ = _tmp4_;
#line 493 "../src/gnome-chess.vala"
					_tmp2_ = g_strcmp0 (_tmp5_, name) == 0;
#line 3562 "gnome-chess.c"
				}
#line 493 "../src/gnome-chess.vala"
				if (_tmp2_) {
#line 3566 "gnome-chess.c"
					AIProfile* _tmp6_;
					AIProfile* _tmp7_;
#line 495 "../src/gnome-chess.vala"
					_tmp6_ = p;
#line 495 "../src/gnome-chess.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 495 "../src/gnome-chess.vala"
					_g_object_unref0 (profile);
#line 495 "../src/gnome-chess.vala"
					profile = _tmp7_;
#line 496 "../src/gnome-chess.vala"
					_g_object_unref0 (p);
#line 496 "../src/gnome-chess.vala"
					break;
#line 3581 "gnome-chess.c"
				}
#line 491 "../src/gnome-chess.vala"
				_g_object_unref0 (p);
#line 3585 "gnome-chess.c"
			}
		}
	}
#line 499 "../src/gnome-chess.vala"
	_tmp8_ = profile;
#line 499 "../src/gnome-chess.vala"
	if (_tmp8_ == NULL) {
#line 3593 "gnome-chess.c"
		GList* _tmp9_;
		GList* _tmp10_;
		gconstpointer _tmp11_;
		AIProfile* _tmp12_;
#line 501 "../src/gnome-chess.vala"
		g_warning ("gnome-chess.vala:501: Unknown AI profile %s", name);
#line 502 "../src/gnome-chess.vala"
		_tmp9_ = self->priv->ai_profiles;
#line 502 "../src/gnome-chess.vala"
		if (_tmp9_ == NULL) {
#line 503 "../src/gnome-chess.vala"
			result = NULL;
#line 503 "../src/gnome-chess.vala"
			_g_object_unref0 (profile);
#line 503 "../src/gnome-chess.vala"
			_g_object_unref0 (engine);
#line 503 "../src/gnome-chess.vala"
			return result;
#line 3612 "gnome-chess.c"
		}
#line 504 "../src/gnome-chess.vala"
		_tmp10_ = self->priv->ai_profiles;
#line 504 "../src/gnome-chess.vala"
		_tmp11_ = _tmp10_->data;
#line 504 "../src/gnome-chess.vala"
		_tmp12_ = _g_object_ref0 ((AIProfile*) _tmp11_);
#line 504 "../src/gnome-chess.vala"
		_g_object_unref0 (profile);
#line 504 "../src/gnome-chess.vala"
		profile = _tmp12_;
#line 3624 "gnome-chess.c"
	}
#line 508 "../src/gnome-chess.vala"
	_tmp13_ = difficulty;
#line 508 "../src/gnome-chess.vala"
	_tmp15_ = (NULL == _tmp13_) ? 0 : g_quark_from_string (_tmp13_);
#line 508 "../src/gnome-chess.vala"
	if (_tmp15_ == ((0 != _tmp14_label0) ? _tmp14_label0 : (_tmp14_label0 = g_quark_from_static_string ("easy")))) {
#line 508 "../src/gnome-chess.vala"
		switch (0) {
#line 3634 "gnome-chess.c"
			default:
			{
				AIProfile* _tmp16_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_ = 0;
				gchar** _tmp19_;
				gint _tmp19__length1;
				gchar** _tmp20_;
				gint _tmp20__length1;
				AIProfile* _tmp21_;
				gchar** _tmp22_;
				gint _tmp22__length1;
				gint _tmp23_ = 0;
				gchar** _tmp24_;
				gint _tmp24__length1;
				gchar** _tmp25_;
				gint _tmp25__length1;
				AIProfile* _tmp26_;
				gchar** _tmp27_;
				gint _tmp27__length1;
				gint _tmp28_ = 0;
				gchar** _tmp29_;
				gint _tmp29__length1;
				gchar** _tmp30_;
				gint _tmp30__length1;
#line 511 "../src/gnome-chess.vala"
				_tmp16_ = profile;
#line 511 "../src/gnome-chess.vala"
				_tmp17_ = ai_profile_get_easy_options (_tmp16_, &_tmp18_);
#line 511 "../src/gnome-chess.vala"
				_tmp17__length1 = _tmp18_;
#line 511 "../src/gnome-chess.vala"
				_tmp19_ = _tmp17_;
#line 511 "../src/gnome-chess.vala"
				_tmp19__length1 = _tmp17__length1;
#line 511 "../src/gnome-chess.vala"
				_tmp20_ = (_tmp19_ != NULL) ? _vala_array_dup1 (_tmp19_, _tmp19__length1) : _tmp19_;
#line 511 "../src/gnome-chess.vala"
				_tmp20__length1 = _tmp19__length1;
#line 511 "../src/gnome-chess.vala"
				options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 511 "../src/gnome-chess.vala"
				options = _tmp20_;
#line 511 "../src/gnome-chess.vala"
				options_length1 = _tmp20__length1;
#line 511 "../src/gnome-chess.vala"
				_options_size_ = options_length1;
#line 512 "../src/gnome-chess.vala"
				_tmp21_ = profile;
#line 512 "../src/gnome-chess.vala"
				_tmp22_ = ai_profile_get_easy_uci_go_options (_tmp21_, &_tmp23_);
#line 512 "../src/gnome-chess.vala"
				_tmp22__length1 = _tmp23_;
#line 512 "../src/gnome-chess.vala"
				_tmp24_ = _tmp22_;
#line 512 "../src/gnome-chess.vala"
				_tmp24__length1 = _tmp22__length1;
#line 512 "../src/gnome-chess.vala"
				_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup2 (_tmp24_, _tmp24__length1) : _tmp24_;
#line 512 "../src/gnome-chess.vala"
				_tmp25__length1 = _tmp24__length1;
#line 512 "../src/gnome-chess.vala"
				uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 512 "../src/gnome-chess.vala"
				uci_go_options = _tmp25_;
#line 512 "../src/gnome-chess.vala"
				uci_go_options_length1 = _tmp25__length1;
#line 512 "../src/gnome-chess.vala"
				_uci_go_options_size_ = uci_go_options_length1;
#line 513 "../src/gnome-chess.vala"
				_tmp26_ = profile;
#line 513 "../src/gnome-chess.vala"
				_tmp27_ = ai_profile_get_easy_args (_tmp26_, &_tmp28_);
#line 513 "../src/gnome-chess.vala"
				_tmp27__length1 = _tmp28_;
#line 513 "../src/gnome-chess.vala"
				_tmp29_ = _tmp27_;
#line 513 "../src/gnome-chess.vala"
				_tmp29__length1 = _tmp27__length1;
#line 513 "../src/gnome-chess.vala"
				_tmp30_ = (_tmp29_ != NULL) ? _vala_array_dup3 (_tmp29_, _tmp29__length1) : _tmp29_;
#line 513 "../src/gnome-chess.vala"
				_tmp30__length1 = _tmp29__length1;
#line 513 "../src/gnome-chess.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 513 "../src/gnome-chess.vala"
				args = _tmp30_;
#line 513 "../src/gnome-chess.vala"
				args_length1 = _tmp30__length1;
#line 513 "../src/gnome-chess.vala"
				_args_size_ = args_length1;
#line 514 "../src/gnome-chess.vala"
				break;
#line 3729 "gnome-chess.c"
			}
		}
	} else if (_tmp15_ == ((0 != _tmp14_label1) ? _tmp14_label1 : (_tmp14_label1 = g_quark_from_static_string ("hard")))) {
#line 508 "../src/gnome-chess.vala"
		switch (0) {
#line 3735 "gnome-chess.c"
			default:
			{
				AIProfile* _tmp31_;
				gchar** _tmp32_;
				gint _tmp32__length1;
				gint _tmp33_ = 0;
				gchar** _tmp34_;
				gint _tmp34__length1;
				gchar** _tmp35_;
				gint _tmp35__length1;
				AIProfile* _tmp36_;
				gchar** _tmp37_;
				gint _tmp37__length1;
				gint _tmp38_ = 0;
				gchar** _tmp39_;
				gint _tmp39__length1;
				gchar** _tmp40_;
				gint _tmp40__length1;
				AIProfile* _tmp41_;
				gchar** _tmp42_;
				gint _tmp42__length1;
				gint _tmp43_ = 0;
				gchar** _tmp44_;
				gint _tmp44__length1;
				gchar** _tmp45_;
				gint _tmp45__length1;
#line 522 "../src/gnome-chess.vala"
				_tmp31_ = profile;
#line 522 "../src/gnome-chess.vala"
				_tmp32_ = ai_profile_get_hard_options (_tmp31_, &_tmp33_);
#line 522 "../src/gnome-chess.vala"
				_tmp32__length1 = _tmp33_;
#line 522 "../src/gnome-chess.vala"
				_tmp34_ = _tmp32_;
#line 522 "../src/gnome-chess.vala"
				_tmp34__length1 = _tmp32__length1;
#line 522 "../src/gnome-chess.vala"
				_tmp35_ = (_tmp34_ != NULL) ? _vala_array_dup4 (_tmp34_, _tmp34__length1) : _tmp34_;
#line 522 "../src/gnome-chess.vala"
				_tmp35__length1 = _tmp34__length1;
#line 522 "../src/gnome-chess.vala"
				options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 522 "../src/gnome-chess.vala"
				options = _tmp35_;
#line 522 "../src/gnome-chess.vala"
				options_length1 = _tmp35__length1;
#line 522 "../src/gnome-chess.vala"
				_options_size_ = options_length1;
#line 523 "../src/gnome-chess.vala"
				_tmp36_ = profile;
#line 523 "../src/gnome-chess.vala"
				_tmp37_ = ai_profile_get_hard_uci_go_options (_tmp36_, &_tmp38_);
#line 523 "../src/gnome-chess.vala"
				_tmp37__length1 = _tmp38_;
#line 523 "../src/gnome-chess.vala"
				_tmp39_ = _tmp37_;
#line 523 "../src/gnome-chess.vala"
				_tmp39__length1 = _tmp37__length1;
#line 523 "../src/gnome-chess.vala"
				_tmp40_ = (_tmp39_ != NULL) ? _vala_array_dup5 (_tmp39_, _tmp39__length1) : _tmp39_;
#line 523 "../src/gnome-chess.vala"
				_tmp40__length1 = _tmp39__length1;
#line 523 "../src/gnome-chess.vala"
				uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 523 "../src/gnome-chess.vala"
				uci_go_options = _tmp40_;
#line 523 "../src/gnome-chess.vala"
				uci_go_options_length1 = _tmp40__length1;
#line 523 "../src/gnome-chess.vala"
				_uci_go_options_size_ = uci_go_options_length1;
#line 524 "../src/gnome-chess.vala"
				_tmp41_ = profile;
#line 524 "../src/gnome-chess.vala"
				_tmp42_ = ai_profile_get_hard_args (_tmp41_, &_tmp43_);
#line 524 "../src/gnome-chess.vala"
				_tmp42__length1 = _tmp43_;
#line 524 "../src/gnome-chess.vala"
				_tmp44_ = _tmp42_;
#line 524 "../src/gnome-chess.vala"
				_tmp44__length1 = _tmp42__length1;
#line 524 "../src/gnome-chess.vala"
				_tmp45_ = (_tmp44_ != NULL) ? _vala_array_dup6 (_tmp44_, _tmp44__length1) : _tmp44_;
#line 524 "../src/gnome-chess.vala"
				_tmp45__length1 = _tmp44__length1;
#line 524 "../src/gnome-chess.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 524 "../src/gnome-chess.vala"
				args = _tmp45_;
#line 524 "../src/gnome-chess.vala"
				args_length1 = _tmp45__length1;
#line 524 "../src/gnome-chess.vala"
				_args_size_ = args_length1;
#line 525 "../src/gnome-chess.vala"
				break;
#line 3830 "gnome-chess.c"
			}
		}
	} else {
#line 508 "../src/gnome-chess.vala"
		switch (0) {
#line 3836 "gnome-chess.c"
			default:
			{
				AIProfile* _tmp46_;
				gchar** _tmp47_;
				gint _tmp47__length1;
				gint _tmp48_ = 0;
				gchar** _tmp49_;
				gint _tmp49__length1;
				gchar** _tmp50_;
				gint _tmp50__length1;
				AIProfile* _tmp51_;
				gchar** _tmp52_;
				gint _tmp52__length1;
				gint _tmp53_ = 0;
				gchar** _tmp54_;
				gint _tmp54__length1;
				gchar** _tmp55_;
				gint _tmp55__length1;
				AIProfile* _tmp56_;
				gchar** _tmp57_;
				gint _tmp57__length1;
				gint _tmp58_ = 0;
				gchar** _tmp59_;
				gint _tmp59__length1;
				gchar** _tmp60_;
				gint _tmp60__length1;
#line 517 "../src/gnome-chess.vala"
				_tmp46_ = profile;
#line 517 "../src/gnome-chess.vala"
				_tmp47_ = ai_profile_get_normal_options (_tmp46_, &_tmp48_);
#line 517 "../src/gnome-chess.vala"
				_tmp47__length1 = _tmp48_;
#line 517 "../src/gnome-chess.vala"
				_tmp49_ = _tmp47_;
#line 517 "../src/gnome-chess.vala"
				_tmp49__length1 = _tmp47__length1;
#line 517 "../src/gnome-chess.vala"
				_tmp50_ = (_tmp49_ != NULL) ? _vala_array_dup7 (_tmp49_, _tmp49__length1) : _tmp49_;
#line 517 "../src/gnome-chess.vala"
				_tmp50__length1 = _tmp49__length1;
#line 517 "../src/gnome-chess.vala"
				options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 517 "../src/gnome-chess.vala"
				options = _tmp50_;
#line 517 "../src/gnome-chess.vala"
				options_length1 = _tmp50__length1;
#line 517 "../src/gnome-chess.vala"
				_options_size_ = options_length1;
#line 518 "../src/gnome-chess.vala"
				_tmp51_ = profile;
#line 518 "../src/gnome-chess.vala"
				_tmp52_ = ai_profile_get_normal_uci_go_options (_tmp51_, &_tmp53_);
#line 518 "../src/gnome-chess.vala"
				_tmp52__length1 = _tmp53_;
#line 518 "../src/gnome-chess.vala"
				_tmp54_ = _tmp52_;
#line 518 "../src/gnome-chess.vala"
				_tmp54__length1 = _tmp52__length1;
#line 518 "../src/gnome-chess.vala"
				_tmp55_ = (_tmp54_ != NULL) ? _vala_array_dup8 (_tmp54_, _tmp54__length1) : _tmp54_;
#line 518 "../src/gnome-chess.vala"
				_tmp55__length1 = _tmp54__length1;
#line 518 "../src/gnome-chess.vala"
				uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 518 "../src/gnome-chess.vala"
				uci_go_options = _tmp55_;
#line 518 "../src/gnome-chess.vala"
				uci_go_options_length1 = _tmp55__length1;
#line 518 "../src/gnome-chess.vala"
				_uci_go_options_size_ = uci_go_options_length1;
#line 519 "../src/gnome-chess.vala"
				_tmp56_ = profile;
#line 519 "../src/gnome-chess.vala"
				_tmp57_ = ai_profile_get_normal_args (_tmp56_, &_tmp58_);
#line 519 "../src/gnome-chess.vala"
				_tmp57__length1 = _tmp58_;
#line 519 "../src/gnome-chess.vala"
				_tmp59_ = _tmp57_;
#line 519 "../src/gnome-chess.vala"
				_tmp59__length1 = _tmp57__length1;
#line 519 "../src/gnome-chess.vala"
				_tmp60_ = (_tmp59_ != NULL) ? _vala_array_dup9 (_tmp59_, _tmp59__length1) : _tmp59_;
#line 519 "../src/gnome-chess.vala"
				_tmp60__length1 = _tmp59__length1;
#line 519 "../src/gnome-chess.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 519 "../src/gnome-chess.vala"
				args = _tmp60_;
#line 519 "../src/gnome-chess.vala"
				args_length1 = _tmp60__length1;
#line 519 "../src/gnome-chess.vala"
				_args_size_ = args_length1;
#line 520 "../src/gnome-chess.vala"
				break;
#line 3931 "gnome-chess.c"
			}
		}
	}
#line 528 "../src/gnome-chess.vala"
	_tmp61_ = profile;
#line 528 "../src/gnome-chess.vala"
	_tmp62_ = ai_profile_get_protocol (_tmp61_);
#line 528 "../src/gnome-chess.vala"
	_tmp63_ = _tmp62_;
#line 528 "../src/gnome-chess.vala"
	if (g_strcmp0 (_tmp63_, "cecp") == 0) {
#line 3943 "gnome-chess.c"
		gchar** _tmp64_;
		gint _tmp64__length1;
		AIProfile* _tmp65_;
		const gchar* _tmp66_;
		const gchar* _tmp67_;
		gchar** _tmp68_;
		gint _tmp68__length1;
		AIProfile* _tmp69_;
		guint _tmp70_;
		guint _tmp71_;
		gchar** _tmp72_;
		gint _tmp72__length1;
		ChessEngineCECP* _tmp73_;
#line 530 "../src/gnome-chess.vala"
		_tmp64_ = uci_go_options;
#line 530 "../src/gnome-chess.vala"
		_tmp64__length1 = uci_go_options_length1;
#line 530 "../src/gnome-chess.vala"
		g_warn_if_fail (_tmp64__length1 == 0);
#line 531 "../src/gnome-chess.vala"
		_tmp65_ = profile;
#line 531 "../src/gnome-chess.vala"
		_tmp66_ = ai_profile_get_binary (_tmp65_);
#line 531 "../src/gnome-chess.vala"
		_tmp67_ = _tmp66_;
#line 531 "../src/gnome-chess.vala"
		_tmp68_ = args;
#line 531 "../src/gnome-chess.vala"
		_tmp68__length1 = args_length1;
#line 531 "../src/gnome-chess.vala"
		_tmp69_ = profile;
#line 531 "../src/gnome-chess.vala"
		_tmp70_ = ai_profile_get_delay_seconds (_tmp69_);
#line 531 "../src/gnome-chess.vala"
		_tmp71_ = _tmp70_;
#line 531 "../src/gnome-chess.vala"
		_tmp72_ = options;
#line 531 "../src/gnome-chess.vala"
		_tmp72__length1 = options_length1;
#line 531 "../src/gnome-chess.vala"
		_tmp73_ = chess_engine_cecp_new (_tmp67_, _tmp68_, _tmp68__length1, _tmp71_, _tmp72_, _tmp72__length1);
#line 531 "../src/gnome-chess.vala"
		_g_object_unref0 (engine);
#line 531 "../src/gnome-chess.vala"
		engine = (ChessEngine*) _tmp73_;
#line 3989 "gnome-chess.c"
	} else {
		AIProfile* _tmp74_;
		const gchar* _tmp75_;
		const gchar* _tmp76_;
#line 533 "../src/gnome-chess.vala"
		_tmp74_ = profile;
#line 533 "../src/gnome-chess.vala"
		_tmp75_ = ai_profile_get_protocol (_tmp74_);
#line 533 "../src/gnome-chess.vala"
		_tmp76_ = _tmp75_;
#line 533 "../src/gnome-chess.vala"
		if (g_strcmp0 (_tmp76_, "uci") == 0) {
#line 4002 "gnome-chess.c"
			AIProfile* _tmp77_;
			const gchar* _tmp78_;
			const gchar* _tmp79_;
			gchar** _tmp80_;
			gint _tmp80__length1;
			AIProfile* _tmp81_;
			guint _tmp82_;
			guint _tmp83_;
			gchar** _tmp84_;
			gint _tmp84__length1;
			gchar** _tmp85_;
			gint _tmp85__length1;
			ChessEngineUCI* _tmp86_;
#line 535 "../src/gnome-chess.vala"
			_tmp77_ = profile;
#line 535 "../src/gnome-chess.vala"
			_tmp78_ = ai_profile_get_binary (_tmp77_);
#line 535 "../src/gnome-chess.vala"
			_tmp79_ = _tmp78_;
#line 535 "../src/gnome-chess.vala"
			_tmp80_ = args;
#line 535 "../src/gnome-chess.vala"
			_tmp80__length1 = args_length1;
#line 535 "../src/gnome-chess.vala"
			_tmp81_ = profile;
#line 535 "../src/gnome-chess.vala"
			_tmp82_ = ai_profile_get_delay_seconds (_tmp81_);
#line 535 "../src/gnome-chess.vala"
			_tmp83_ = _tmp82_;
#line 535 "../src/gnome-chess.vala"
			_tmp84_ = options;
#line 535 "../src/gnome-chess.vala"
			_tmp84__length1 = options_length1;
#line 535 "../src/gnome-chess.vala"
			_tmp85_ = uci_go_options;
#line 535 "../src/gnome-chess.vala"
			_tmp85__length1 = uci_go_options_length1;
#line 535 "../src/gnome-chess.vala"
			_tmp86_ = chess_engine_uci_new (_tmp79_, _tmp80_, _tmp80__length1, _tmp83_, _tmp84_, _tmp84__length1, _tmp85_, _tmp85__length1);
#line 535 "../src/gnome-chess.vala"
			_g_object_unref0 (engine);
#line 535 "../src/gnome-chess.vala"
			engine = (ChessEngine*) _tmp86_;
#line 4046 "gnome-chess.c"
		} else {
			AIProfile* _tmp87_;
			const gchar* _tmp88_;
			const gchar* _tmp89_;
#line 539 "../src/gnome-chess.vala"
			_tmp87_ = profile;
#line 539 "../src/gnome-chess.vala"
			_tmp88_ = ai_profile_get_protocol (_tmp87_);
#line 539 "../src/gnome-chess.vala"
			_tmp89_ = _tmp88_;
#line 539 "../src/gnome-chess.vala"
			g_warning ("gnome-chess.vala:539: Unknown AI protocol %s", _tmp89_);
#line 540 "../src/gnome-chess.vala"
			result = NULL;
#line 540 "../src/gnome-chess.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 540 "../src/gnome-chess.vala"
			uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 540 "../src/gnome-chess.vala"
			options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 540 "../src/gnome-chess.vala"
			_g_object_unref0 (profile);
#line 540 "../src/gnome-chess.vala"
			_g_object_unref0 (engine);
#line 540 "../src/gnome-chess.vala"
			return result;
#line 4073 "gnome-chess.c"
		}
	}
#line 543 "../src/gnome-chess.vala"
	result = engine;
#line 543 "../src/gnome-chess.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 543 "../src/gnome-chess.vala"
	uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 543 "../src/gnome-chess.vala"
	options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 543 "../src/gnome-chess.vala"
	_g_object_unref0 (profile);
#line 543 "../src/gnome-chess.vala"
	return result;
#line 4088 "gnome-chess.c"
}

static void
chess_application_do_engine_move (ChessApplication* self,
                                  const gchar* move)
{
	ChessPlayer* _tmp0_;
#line 546 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 546 "../src/gnome-chess.vala"
	g_return_if_fail (move != NULL);
#line 548 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent;
#line 548 "../src/gnome-chess.vala"
	if (!chess_player_move (_tmp0_, move, TRUE)) {
#line 4104 "gnome-chess.c"
		ChessGame* _tmp1_;
#line 550 "../src/gnome-chess.vala"
		g_warning ("gnome-chess.vala:550: Engine's move %s is illegal! Engine desync?", move);
#line 551 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->game;
#line 551 "../src/gnome-chess.vala"
		chess_game_stop (_tmp1_, CHESS_RESULT_BUG, CHESS_RULE_BUG);
#line 4112 "gnome-chess.c"
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 555 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 555 "../src/gnome-chess.vala"
	return _data3_;
#line 4123 "gnome-chess.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 555 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 4133 "gnome-chess.c"
		ChessApplication* self;
#line 555 "../src/gnome-chess.vala"
		self = _data3_->self;
#line 555 "../src/gnome-chess.vala"
		_g_object_unref0 (_data3_->original_state);
#line 555 "../src/gnome-chess.vala"
		_g_object_unref0 (_data3_->original_game);
#line 555 "../src/gnome-chess.vala"
		_g_free0 (_data3_->move);
#line 555 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 555 "../src/gnome-chess.vala"
		g_slice_free (Block3Data, _data3_);
#line 4147 "gnome-chess.c"
	}
}

static gboolean
___lambda32_ (Block3Data* _data3_)
{
	ChessApplication* self;
	ChessGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 573 "../src/gnome-chess.vala"
	self = _data3_->self;
#line 574 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 574 "../src/gnome-chess.vala"
	_tmp1_ = chess_game_get_is_paused (_tmp0_);
#line 574 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 574 "../src/gnome-chess.vala"
	if (_tmp2_) {
#line 576 "../src/gnome-chess.vala"
		result = G_SOURCE_CONTINUE;
#line 576 "../src/gnome-chess.vala"
		return result;
#line 4173 "gnome-chess.c"
	} else {
		ChessGame* _tmp3_;
		ChessGame* _tmp4_;
#line 584 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->game;
#line 584 "../src/gnome-chess.vala"
		_tmp4_ = _data3_->original_game;
#line 584 "../src/gnome-chess.vala"
		if (_tmp3_ == _tmp4_) {
#line 4183 "gnome-chess.c"
			ChessGame* _tmp5_;
			ChessState* _tmp6_;
			ChessState* _tmp7_;
			ChessState* _tmp8_;
#line 586 "../src/gnome-chess.vala"
			_tmp5_ = self->priv->game;
#line 586 "../src/gnome-chess.vala"
			_tmp6_ = chess_game_get_current_state (_tmp5_);
#line 586 "../src/gnome-chess.vala"
			_tmp7_ = _tmp6_;
#line 586 "../src/gnome-chess.vala"
			_tmp8_ = _data3_->original_state;
#line 586 "../src/gnome-chess.vala"
			_vala_assert (_tmp7_ == _tmp8_, "game.current_state == original_state");
#line 587 "../src/gnome-chess.vala"
			chess_application_do_engine_move (self, _data3_->move);
#line 4200 "gnome-chess.c"
		}
#line 589 "../src/gnome-chess.vala"
		result = G_SOURCE_REMOVE;
#line 589 "../src/gnome-chess.vala"
		return result;
#line 4206 "gnome-chess.c"
	}
}

static gboolean
____lambda32__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda32_ (self);
#line 573 "../src/gnome-chess.vala"
	return result;
#line 4217 "gnome-chess.c"
}

static void
chess_application_engine_move_cb (ChessApplication* self,
                                  ChessEngine* engine,
                                  const gchar* move)
{
	Block3Data* _data3_;
	gchar* _tmp0_;
	ChessGame* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessState* _tmp4_;
	ChessState* _tmp5_;
	ChessState* _tmp6_;
	ChessGame* _tmp7_;
	ChessGame* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 555 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 555 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 555 "../src/gnome-chess.vala"
	g_return_if_fail (move != NULL);
#line 555 "../src/gnome-chess.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 555 "../src/gnome-chess.vala"
	_data3_->_ref_count_ = 1;
#line 555 "../src/gnome-chess.vala"
	_data3_->self = g_object_ref (self);
#line 555 "../src/gnome-chess.vala"
	_tmp0_ = g_strdup (move);
#line 555 "../src/gnome-chess.vala"
	_g_free0 (_data3_->move);
#line 555 "../src/gnome-chess.vala"
	_data3_->move = _tmp0_;
#line 557 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 557 "../src/gnome-chess.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 557 "../src/gnome-chess.vala"
	_data3_->original_game = _tmp2_;
#line 558 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->game;
#line 558 "../src/gnome-chess.vala"
	_tmp4_ = chess_game_get_current_state (_tmp3_);
#line 558 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 558 "../src/gnome-chess.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 558 "../src/gnome-chess.vala"
	_data3_->original_state = _tmp6_;
#line 564 "../src/gnome-chess.vala"
	_tmp7_ = self->priv->game;
#line 564 "../src/gnome-chess.vala"
	if (!_tmp7_->is_started) {
#line 565 "../src/gnome-chess.vala"
		block3_data_unref (_data3_);
#line 565 "../src/gnome-chess.vala"
		_data3_ = NULL;
#line 565 "../src/gnome-chess.vala"
		return;
#line 4281 "gnome-chess.c"
	}
#line 567 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->game;
#line 567 "../src/gnome-chess.vala"
	_tmp9_ = chess_game_get_is_paused (_tmp8_);
#line 567 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 567 "../src/gnome-chess.vala"
	if (!_tmp10_) {
#line 569 "../src/gnome-chess.vala"
		chess_application_do_engine_move (self, _data3_->move);
#line 4293 "gnome-chess.c"
	} else {
#line 573 "../src/gnome-chess.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda32__gsource_func, block3_data_ref (_data3_), block3_data_unref);
#line 4297 "gnome-chess.c"
	}
#line 555 "../src/gnome-chess.vala"
	block3_data_unref (_data3_);
#line 555 "../src/gnome-chess.vala"
	_data3_ = NULL;
#line 4303 "gnome-chess.c"
}

static void
chess_application_engine_resigned_cb (ChessApplication* self,
                                      ChessEngine* engine)
{
	ChessPlayer* _tmp0_;
#line 595 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 595 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 597 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent;
#line 597 "../src/gnome-chess.vala"
	chess_player_resign (_tmp0_);
#line 4319 "gnome-chess.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 600 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 600 "../src/gnome-chess.vala"
	return _data4_;
#line 4329 "gnome-chess.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 600 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 4339 "gnome-chess.c"
		ChessApplication* self;
#line 600 "../src/gnome-chess.vala"
		self = _data4_->self;
#line 600 "../src/gnome-chess.vala"
		_g_object_unref0 (_data4_->original_game);
#line 600 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 600 "../src/gnome-chess.vala"
		g_slice_free (Block4Data, _data4_);
#line 4349 "gnome-chess.c"
	}
}

static gboolean
__lambda33_ (Block4Data* _data4_)
{
	ChessApplication* self;
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	gboolean result;
#line 615 "../src/gnome-chess.vala"
	self = _data4_->self;
#line 616 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 616 "../src/gnome-chess.vala"
	if (_tmp1_ == _data4_->original_game) {
#line 4366 "gnome-chess.c"
		ChessGame* _tmp2_;
#line 616 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->game;
#line 616 "../src/gnome-chess.vala"
		_tmp0_ = _tmp2_->is_started;
#line 4372 "gnome-chess.c"
	} else {
#line 616 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 4376 "gnome-chess.c"
	}
#line 616 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 4380 "gnome-chess.c"
		ChessGame* _tmp3_;
#line 617 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->game;
#line 617 "../src/gnome-chess.vala"
		chess_game_stop (_tmp3_, CHESS_RESULT_BUG, CHESS_RULE_BUG);
#line 4386 "gnome-chess.c"
	}
#line 618 "../src/gnome-chess.vala"
	result = G_SOURCE_REMOVE;
#line 618 "../src/gnome-chess.vala"
	return result;
#line 4392 "gnome-chess.c"
}

static gboolean
___lambda33__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda33_ (self);
#line 615 "../src/gnome-chess.vala"
	return result;
#line 4402 "gnome-chess.c"
}

static void
chess_application_engine_stopped_unexpectedly_cb (ChessApplication* self,
                                                  ChessEngine* engine)
{
	Block4Data* _data4_;
	ChessGame* _tmp0_;
	ChessGame* _tmp1_;
#line 600 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 600 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 600 "../src/gnome-chess.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 600 "../src/gnome-chess.vala"
	_data4_->_ref_count_ = 1;
#line 600 "../src/gnome-chess.vala"
	_data4_->self = g_object_ref (self);
#line 614 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 614 "../src/gnome-chess.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 614 "../src/gnome-chess.vala"
	_data4_->original_game = _tmp1_;
#line 615 "../src/gnome-chess.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ___lambda33__gsource_func, block4_data_ref (_data4_), block4_data_unref);
#line 600 "../src/gnome-chess.vala"
	block4_data_unref (_data4_);
#line 600 "../src/gnome-chess.vala"
	_data4_ = NULL;
#line 4434 "gnome-chess.c"
}

static void
chess_application_engine_error_cb (ChessApplication* self,
                                   ChessEngine* engine)
{
	ChessGame* _tmp0_;
#line 622 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 622 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 624 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 624 "../src/gnome-chess.vala"
	chess_game_stop (_tmp0_, CHESS_RESULT_BUG, CHESS_RULE_BUG);
#line 4450 "gnome-chess.c"
}

static void
chess_application_engine_claim_draw_cb (ChessApplication* self,
                                        ChessEngine* engine)
{
	ChessGame* _tmp0_;
#line 627 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 629 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 629 "../src/gnome-chess.vala"
	if (chess_game_can_claim_draw (_tmp0_)) {
#line 4466 "gnome-chess.c"
		ChessPlayer* _tmp1_;
#line 630 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->opponent;
#line 630 "../src/gnome-chess.vala"
		chess_player_claim_draw (_tmp1_);
#line 4472 "gnome-chess.c"
	} else {
		ChessGame* _tmp2_;
		ChessState* _tmp3_;
		ChessState* _tmp4_;
		ChessGame* _tmp5_;
		ChessState* _tmp6_;
		ChessState* _tmp7_;
		ChessPlayer* _tmp8_;
#line 631 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->game;
#line 631 "../src/gnome-chess.vala"
		_tmp3_ = chess_game_get_current_state (_tmp2_);
#line 631 "../src/gnome-chess.vala"
		_tmp4_ = _tmp3_;
#line 631 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->game;
#line 631 "../src/gnome-chess.vala"
		_tmp6_ = chess_game_get_current_state (_tmp5_);
#line 631 "../src/gnome-chess.vala"
		_tmp7_ = _tmp6_;
#line 631 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_->current_player;
#line 631 "../src/gnome-chess.vala"
		if (!chess_state_can_move (_tmp4_, _tmp8_)) {
#line 4497 "gnome-chess.c"
			ChessGame* _tmp9_;
#line 632 "../src/gnome-chess.vala"
			_tmp9_ = self->priv->game;
#line 632 "../src/gnome-chess.vala"
			chess_game_stop (_tmp9_, CHESS_RESULT_DRAW, CHESS_RULE_STALEMATE);
#line 4503 "gnome-chess.c"
		} else {
			ChessGame* _tmp10_;
#line 634 "../src/gnome-chess.vala"
			_tmp10_ = self->priv->game;
#line 634 "../src/gnome-chess.vala"
			chess_game_stop (_tmp10_, CHESS_RESULT_BUG, CHESS_RULE_BUG);
#line 4510 "gnome-chess.c"
		}
	}
}

static void
chess_application_engine_offer_draw_cb (ChessApplication* self,
                                        ChessEngine* engine)
{
	ChessGame* _tmp0_;
#line 637 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 637 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 639 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 639 "../src/gnome-chess.vala"
	if (chess_game_can_claim_draw (_tmp0_)) {
#line 4528 "gnome-chess.c"
		ChessPlayer* _tmp1_;
#line 640 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->opponent;
#line 640 "../src/gnome-chess.vala"
		chess_player_claim_draw (_tmp1_);
#line 4534 "gnome-chess.c"
	}
}

static void
chess_application_game_turn_cb (ChessApplication* self,
                                ChessGame* game,
                                ChessPlayer* player)
{
	ChessClock* _tmp0_;
	ChessClock* _tmp1_;
#line 651 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 651 "../src/gnome-chess.vala"
	g_return_if_fail (game != NULL);
#line 651 "../src/gnome-chess.vala"
	g_return_if_fail (player != NULL);
#line 666 "../src/gnome-chess.vala"
	if (!game->is_started) {
#line 667 "../src/gnome-chess.vala"
		return;
#line 4555 "gnome-chess.c"
	}
#line 669 "../src/gnome-chess.vala"
	_tmp0_ = chess_game_get_clock (game);
#line 669 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 669 "../src/gnome-chess.vala"
	if (_tmp1_ != NULL) {
#line 670 "../src/gnome-chess.vala"
		chess_application_enable_action (self, PAUSE_RESUME_ACTION_NAME);
#line 4565 "gnome-chess.c"
	}
}

static gboolean
___lambda29_ (ChessApplication* self)
{
	ChessEngine* _tmp0_;
	gboolean result;
#line 688 "../src/gnome-chess.vala"
	self->priv->engine_timeout_source = (guint) 0;
#line 689 "../src/gnome-chess.vala"
	g_warning ("gnome-chess.vala:689: Engine did not move for 30 seconds! Game over.");
#line 690 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent_engine;
#line 690 "../src/gnome-chess.vala"
	chess_application_engine_error_cb (self, _tmp0_);
#line 691 "../src/gnome-chess.vala"
	result = G_SOURCE_REMOVE;
#line 691 "../src/gnome-chess.vala"
	return result;
#line 4586 "gnome-chess.c"
}

static gboolean
____lambda29__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda29_ ((ChessApplication*) self);
#line 687 "../src/gnome-chess.vala"
	return result;
#line 4596 "gnome-chess.c"
}

static void
chess_application_update_engine_timeout (ChessApplication* self)
{
	ChessGame* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	PGNGame* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 673 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 675 "../src/gnome-chess.vala"
	if (self->priv->engine_timeout_source != ((guint) 0)) {
#line 677 "../src/gnome-chess.vala"
		g_source_remove (self->priv->engine_timeout_source);
#line 678 "../src/gnome-chess.vala"
		self->priv->engine_timeout_source = (guint) 0;
#line 4616 "gnome-chess.c"
	}
#line 681 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 681 "../src/gnome-chess.vala"
	if (!_tmp0_->is_started) {
#line 682 "../src/gnome-chess.vala"
		return;
#line 4624 "gnome-chess.c"
	}
#line 684 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->pgn_game;
#line 684 "../src/gnome-chess.vala"
	_tmp4_ = pgn_game_get_white_ai (_tmp3_);
#line 684 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 684 "../src/gnome-chess.vala"
	if (_tmp5_ != NULL) {
#line 4634 "gnome-chess.c"
		ChessGame* _tmp6_;
		ChessPlayer* _tmp7_;
		ChessPlayer* _tmp8_;
#line 684 "../src/gnome-chess.vala"
		_tmp6_ = self->priv->game;
#line 684 "../src/gnome-chess.vala"
		_tmp7_ = chess_game_get_current_player (_tmp6_);
#line 684 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_;
#line 684 "../src/gnome-chess.vala"
		_tmp2_ = _tmp8_->color == COLOR_WHITE;
#line 4646 "gnome-chess.c"
	} else {
#line 684 "../src/gnome-chess.vala"
		_tmp2_ = FALSE;
#line 4650 "gnome-chess.c"
	}
#line 684 "../src/gnome-chess.vala"
	if (_tmp2_) {
#line 684 "../src/gnome-chess.vala"
		_tmp1_ = TRUE;
#line 4656 "gnome-chess.c"
	} else {
		gboolean _tmp9_ = FALSE;
		PGNGame* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 685 "../src/gnome-chess.vala"
		_tmp10_ = self->priv->pgn_game;
#line 685 "../src/gnome-chess.vala"
		_tmp11_ = pgn_game_get_black_ai (_tmp10_);
#line 685 "../src/gnome-chess.vala"
		_tmp12_ = _tmp11_;
#line 685 "../src/gnome-chess.vala"
		if (_tmp12_ != NULL) {
#line 4670 "gnome-chess.c"
			ChessGame* _tmp13_;
			ChessPlayer* _tmp14_;
			ChessPlayer* _tmp15_;
#line 685 "../src/gnome-chess.vala"
			_tmp13_ = self->priv->game;
#line 685 "../src/gnome-chess.vala"
			_tmp14_ = chess_game_get_current_player (_tmp13_);
#line 685 "../src/gnome-chess.vala"
			_tmp15_ = _tmp14_;
#line 685 "../src/gnome-chess.vala"
			_tmp9_ = _tmp15_->color == COLOR_BLACK;
#line 4682 "gnome-chess.c"
		} else {
#line 685 "../src/gnome-chess.vala"
			_tmp9_ = FALSE;
#line 4686 "gnome-chess.c"
		}
#line 685 "../src/gnome-chess.vala"
		_tmp1_ = _tmp9_;
#line 4690 "gnome-chess.c"
	}
#line 684 "../src/gnome-chess.vala"
	if (_tmp1_) {
#line 687 "../src/gnome-chess.vala"
		self->priv->engine_timeout_source = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 30, ____lambda29__gsource_func, g_object_ref (self), g_object_unref);
#line 4696 "gnome-chess.c"
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 696 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 696 "../src/gnome-chess.vala"
	return _data5_;
#line 4707 "gnome-chess.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 696 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 4717 "gnome-chess.c"
		ChessApplication* self;
#line 696 "../src/gnome-chess.vala"
		self = _data5_->self;
#line 696 "../src/gnome-chess.vala"
		_g_object_unref0 (_data5_->game);
#line 696 "../src/gnome-chess.vala"
		_g_object_unref0 (_data5_->move);
#line 696 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 696 "../src/gnome-chess.vala"
		g_slice_free (Block5Data, _data5_);
#line 4729 "gnome-chess.c"
	}
}

static gboolean
__lambda27_ (Block5Data* _data5_)
{
	ChessApplication* self;
	gboolean _tmp0_ = FALSE;
	ChessEngine* _tmp1_;
	gboolean result;
#line 724 "../src/gnome-chess.vala"
	self = _data5_->self;
#line 725 "../src/gnome-chess.vala"
	if (chess_game_can_claim_draw (_data5_->game)) {
#line 725 "../src/gnome-chess.vala"
		_tmp0_ = _data5_->started;
#line 4746 "gnome-chess.c"
	} else {
#line 725 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 4750 "gnome-chess.c"
	}
#line 725 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 726 "../src/gnome-chess.vala"
		chess_application_present_claim_draw_dialog (self);
#line 4756 "gnome-chess.c"
	}
#line 728 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->opponent_engine;
#line 728 "../src/gnome-chess.vala"
	if (_tmp1_ != NULL) {
#line 4762 "gnome-chess.c"
		ChessEngine* _tmp2_;
		gboolean _tmp3_ = FALSE;
		ChessPiece* _tmp4_;
		Color _tmp5_;
		Color _tmp6_;
		ChessPlayer* _tmp7_;
#line 730 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->opponent_engine;
#line 730 "../src/gnome-chess.vala"
		chess_engine_report_move (_tmp2_, _data5_->move);
#line 732 "../src/gnome-chess.vala"
		_tmp4_ = _data5_->move->piece;
#line 732 "../src/gnome-chess.vala"
		_tmp5_ = chess_piece_get_color (_tmp4_);
#line 732 "../src/gnome-chess.vala"
		_tmp6_ = _tmp5_;
#line 732 "../src/gnome-chess.vala"
		_tmp7_ = self->priv->opponent;
#line 732 "../src/gnome-chess.vala"
		if (_tmp6_ != _tmp7_->color) {
#line 732 "../src/gnome-chess.vala"
			_tmp3_ = _data5_->started;
#line 4785 "gnome-chess.c"
		} else {
#line 732 "../src/gnome-chess.vala"
			_tmp3_ = FALSE;
#line 4789 "gnome-chess.c"
		}
#line 732 "../src/gnome-chess.vala"
		if (_tmp3_) {
#line 4793 "gnome-chess.c"
			ChessEngine* _tmp8_;
#line 733 "../src/gnome-chess.vala"
			_tmp8_ = self->priv->opponent_engine;
#line 733 "../src/gnome-chess.vala"
			chess_engine_move (_tmp8_);
#line 4799 "gnome-chess.c"
		}
	}
#line 736 "../src/gnome-chess.vala"
	result = G_SOURCE_REMOVE;
#line 736 "../src/gnome-chess.vala"
	return result;
#line 4806 "gnome-chess.c"
}

static gboolean
___lambda27__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda27_ (self);
#line 724 "../src/gnome-chess.vala"
	return result;
#line 4816 "gnome-chess.c"
}

static void
chess_application_game_move_cb (ChessApplication* self,
                                ChessGame* game,
                                ChessMove* move)
{
	Block5Data* _data5_;
	ChessGame* _tmp0_;
	ChessMove* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	PGNGame* _tmp6_;
	GList* _tmp7_;
	ChessWindow* _tmp10_;
	ChessWindow* _tmp11_;
	ChessWindow* _tmp12_;
	ChessView* _tmp13_;
	ChessView* _tmp14_;
	gboolean _tmp15_ = FALSE;
#line 696 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/gnome-chess.vala"
	g_return_if_fail (game != NULL);
#line 696 "../src/gnome-chess.vala"
	g_return_if_fail (move != NULL);
#line 696 "../src/gnome-chess.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 696 "../src/gnome-chess.vala"
	_data5_->_ref_count_ = 1;
#line 696 "../src/gnome-chess.vala"
	_data5_->self = g_object_ref (self);
#line 696 "../src/gnome-chess.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 696 "../src/gnome-chess.vala"
	_g_object_unref0 (_data5_->game);
#line 696 "../src/gnome-chess.vala"
	_data5_->game = _tmp0_;
#line 696 "../src/gnome-chess.vala"
	_tmp1_ = _g_object_ref0 (move);
#line 696 "../src/gnome-chess.vala"
	_g_object_unref0 (_data5_->move);
#line 696 "../src/gnome-chess.vala"
	_data5_->move = _tmp1_;
#line 701 "../src/gnome-chess.vala"
	self->priv->game_needs_saving = TRUE;
#line 704 "../src/gnome-chess.vala"
	if (_data5_->move->number == 1) {
#line 4865 "gnome-chess.c"
		ChessPlayer* _tmp4_;
#line 704 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->opponent;
#line 704 "../src/gnome-chess.vala"
		_tmp3_ = _tmp4_ != NULL;
#line 4871 "gnome-chess.c"
	} else {
#line 704 "../src/gnome-chess.vala"
		_tmp3_ = FALSE;
#line 4875 "gnome-chess.c"
	}
#line 704 "../src/gnome-chess.vala"
	if (_tmp3_) {
#line 4879 "gnome-chess.c"
		ChessPlayer* _tmp5_;
#line 704 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->opponent;
#line 704 "../src/gnome-chess.vala"
		_tmp2_ = _tmp5_->color == COLOR_WHITE;
#line 4885 "gnome-chess.c"
	} else {
#line 704 "../src/gnome-chess.vala"
		_tmp2_ = FALSE;
#line 4889 "gnome-chess.c"
	}
#line 704 "../src/gnome-chess.vala"
	if (_tmp2_) {
#line 705 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = FALSE;
#line 4895 "gnome-chess.c"
	}
#line 707 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->pgn_game;
#line 707 "../src/gnome-chess.vala"
	_tmp7_ = _tmp6_->moves;
#line 707 "../src/gnome-chess.vala"
	if (((guint) _data5_->move->number) > g_list_length (_tmp7_)) {
#line 4903 "gnome-chess.c"
		PGNGame* _tmp8_;
		gchar* _tmp9_;
#line 708 "../src/gnome-chess.vala"
		_tmp8_ = self->priv->pgn_game;
#line 708 "../src/gnome-chess.vala"
		_tmp9_ = chess_move_get_san (_data5_->move);
#line 708 "../src/gnome-chess.vala"
		_tmp8_->moves = g_list_append (_tmp8_->moves, _tmp9_);
#line 4912 "gnome-chess.c"
	}
#line 710 "../src/gnome-chess.vala"
	_tmp10_ = self->priv->_window;
#line 710 "../src/gnome-chess.vala"
	chess_window_move (_tmp10_, _data5_->move);
#line 712 "../src/gnome-chess.vala"
	chess_application_enable_action (self, SAVE_GAME_ACTION_NAME);
#line 713 "../src/gnome-chess.vala"
	chess_application_enable_action (self, SAVE_GAME_AS_ACTION_NAME);
#line 714 "../src/gnome-chess.vala"
	chess_application_update_action_status (self);
#line 715 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->_window;
#line 715 "../src/gnome-chess.vala"
	chess_window_update_history_panel (_tmp11_);
#line 716 "../src/gnome-chess.vala"
	_tmp12_ = self->priv->_window;
#line 716 "../src/gnome-chess.vala"
	chess_window_update_game_status (_tmp12_, NULL, NULL);
#line 718 "../src/gnome-chess.vala"
	_tmp13_ = chess_application_get_view (self);
#line 718 "../src/gnome-chess.vala"
	_tmp14_ = _tmp13_;
#line 718 "../src/gnome-chess.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp14_);
#line 723 "../src/gnome-chess.vala"
	if (!self->priv->starting) {
#line 723 "../src/gnome-chess.vala"
		_tmp15_ = _data5_->game->is_started;
#line 4942 "gnome-chess.c"
	} else {
#line 723 "../src/gnome-chess.vala"
		_tmp15_ = FALSE;
#line 4946 "gnome-chess.c"
	}
#line 723 "../src/gnome-chess.vala"
	_data5_->started = _tmp15_;
#line 724 "../src/gnome-chess.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda27__gsource_func, block5_data_ref (_data5_), block5_data_unref);
#line 739 "../src/gnome-chess.vala"
	if (_data5_->started) {
#line 740 "../src/gnome-chess.vala"
		chess_application_update_engine_timeout (self);
#line 4956 "gnome-chess.c"
	}
#line 696 "../src/gnome-chess.vala"
	block5_data_unref (_data5_);
#line 696 "../src/gnome-chess.vala"
	_data5_ = NULL;
#line 4962 "gnome-chess.c"
}

static void
chess_application_game_undo_cb (ChessApplication* self,
                                ChessGame* game)
{
	ChessEngine* _tmp0_;
	PGNGame* _tmp2_;
	PGNGame* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	PGNGame* _tmp6_;
	const gchar* _tmp7_;
	ChessWindow* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	ChessWindow* _tmp11_;
	ChessWindow* _tmp12_;
#line 743 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 743 "../src/gnome-chess.vala"
	g_return_if_fail (game != NULL);
#line 746 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent_engine;
#line 746 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 4989 "gnome-chess.c"
		ChessEngine* _tmp1_;
#line 747 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->opponent_engine;
#line 747 "../src/gnome-chess.vala"
		chess_engine_undo (_tmp1_);
#line 4995 "gnome-chess.c"
	}
#line 750 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->pgn_game;
#line 750 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->pgn_game;
#line 750 "../src/gnome-chess.vala"
	_tmp4_ = _tmp3_->moves;
#line 750 "../src/gnome-chess.vala"
	_tmp5_ = g_list_last (_tmp4_);
#line 750 "../src/gnome-chess.vala"
	_tmp2_->moves = g_list_remove_link (_tmp2_->moves, _tmp5_);
#line 751 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->pgn_game;
#line 751 "../src/gnome-chess.vala"
	_tmp7_ = pgn_game_RESULT_IN_PROGRESS;
#line 751 "../src/gnome-chess.vala"
	pgn_game_set_result (_tmp6_, _tmp7_);
#line 753 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->_window;
#line 753 "../src/gnome-chess.vala"
	chess_window_undo (_tmp8_);
#line 755 "../src/gnome-chess.vala"
	_tmp9_ = chess_game_get_n_moves (game);
#line 755 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 755 "../src/gnome-chess.vala"
	if (_tmp10_ > ((guint) 0)) {
#line 757 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = TRUE;
#line 758 "../src/gnome-chess.vala"
		chess_application_enable_action (self, SAVE_GAME_ACTION_NAME);
#line 759 "../src/gnome-chess.vala"
		chess_application_enable_action (self, SAVE_GAME_AS_ACTION_NAME);
#line 5029 "gnome-chess.c"
	} else {
#line 763 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = FALSE;
#line 764 "../src/gnome-chess.vala"
		chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 765 "../src/gnome-chess.vala"
		chess_application_disable_action (self, SAVE_GAME_AS_ACTION_NAME);
#line 5037 "gnome-chess.c"
	}
#line 768 "../src/gnome-chess.vala"
	chess_application_update_action_status (self);
#line 769 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->_window;
#line 769 "../src/gnome-chess.vala"
	chess_window_update_history_panel (_tmp11_);
#line 770 "../src/gnome-chess.vala"
	_tmp12_ = self->priv->_window;
#line 770 "../src/gnome-chess.vala"
	chess_window_update_game_status (_tmp12_, NULL, NULL);
#line 5049 "gnome-chess.c"
}

static void
chess_application_update_action_status (ChessApplication* self)
{
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gboolean can_resign = FALSE;
	gboolean _tmp7_ = FALSE;
	ChessGame* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	gboolean can_undo = FALSE;
	gboolean _tmp14_ = FALSE;
	ChessPlayer* _tmp15_;
#line 773 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 775 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 775 "../src/gnome-chess.vala"
	_tmp2_ = chess_game_get_n_moves (_tmp1_);
#line 775 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 775 "../src/gnome-chess.vala"
	if (_tmp3_ > ((guint) 0)) {
#line 5077 "gnome-chess.c"
		ChessGame* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 775 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->game;
#line 775 "../src/gnome-chess.vala"
		_tmp5_ = chess_game_get_is_paused (_tmp4_);
#line 775 "../src/gnome-chess.vala"
		_tmp6_ = _tmp5_;
#line 775 "../src/gnome-chess.vala"
		_tmp0_ = !_tmp6_;
#line 5089 "gnome-chess.c"
	} else {
#line 775 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 5093 "gnome-chess.c"
	}
#line 775 "../src/gnome-chess.vala"
	can_resign = _tmp0_;
#line 776 "../src/gnome-chess.vala"
	if (can_resign) {
#line 777 "../src/gnome-chess.vala"
		chess_application_enable_action (self, RESIGN_ACTION_NAME);
#line 5101 "gnome-chess.c"
	} else {
#line 779 "../src/gnome-chess.vala"
		chess_application_disable_action (self, RESIGN_ACTION_NAME);
#line 5105 "gnome-chess.c"
	}
#line 782 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->game;
#line 782 "../src/gnome-chess.vala"
	_tmp9_ = chess_game_get_n_moves (_tmp8_);
#line 782 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 782 "../src/gnome-chess.vala"
	if (_tmp10_ > ((guint) 0)) {
#line 5115 "gnome-chess.c"
		ChessGame* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 782 "../src/gnome-chess.vala"
		_tmp11_ = self->priv->game;
#line 782 "../src/gnome-chess.vala"
		_tmp12_ = chess_game_get_is_paused (_tmp11_);
#line 782 "../src/gnome-chess.vala"
		_tmp13_ = _tmp12_;
#line 782 "../src/gnome-chess.vala"
		_tmp7_ = !_tmp13_;
#line 5127 "gnome-chess.c"
	} else {
#line 782 "../src/gnome-chess.vala"
		_tmp7_ = FALSE;
#line 5131 "gnome-chess.c"
	}
#line 782 "../src/gnome-chess.vala"
	can_undo = _tmp7_;
#line 783 "../src/gnome-chess.vala"
	_tmp15_ = self->priv->opponent;
#line 783 "../src/gnome-chess.vala"
	if (_tmp15_ != NULL) {
#line 5139 "gnome-chess.c"
		ChessPlayer* _tmp16_;
#line 783 "../src/gnome-chess.vala"
		_tmp16_ = self->priv->opponent;
#line 783 "../src/gnome-chess.vala"
		_tmp14_ = _tmp16_->color == COLOR_WHITE;
#line 5145 "gnome-chess.c"
	} else {
#line 783 "../src/gnome-chess.vala"
		_tmp14_ = FALSE;
#line 5149 "gnome-chess.c"
	}
#line 783 "../src/gnome-chess.vala"
	if (_tmp14_) {
#line 5153 "gnome-chess.c"
		gboolean _tmp17_ = FALSE;
		ChessGame* _tmp18_;
		guint _tmp19_;
		guint _tmp20_;
#line 784 "../src/gnome-chess.vala"
		_tmp18_ = self->priv->game;
#line 784 "../src/gnome-chess.vala"
		_tmp19_ = chess_game_get_n_moves (_tmp18_);
#line 784 "../src/gnome-chess.vala"
		_tmp20_ = _tmp19_;
#line 784 "../src/gnome-chess.vala"
		if (_tmp20_ > ((guint) 1)) {
#line 5166 "gnome-chess.c"
			ChessGame* _tmp21_;
			gboolean _tmp22_;
			gboolean _tmp23_;
#line 784 "../src/gnome-chess.vala"
			_tmp21_ = self->priv->game;
#line 784 "../src/gnome-chess.vala"
			_tmp22_ = chess_game_get_is_paused (_tmp21_);
#line 784 "../src/gnome-chess.vala"
			_tmp23_ = _tmp22_;
#line 784 "../src/gnome-chess.vala"
			_tmp17_ = !_tmp23_;
#line 5178 "gnome-chess.c"
		} else {
#line 784 "../src/gnome-chess.vala"
			_tmp17_ = FALSE;
#line 5182 "gnome-chess.c"
		}
#line 784 "../src/gnome-chess.vala"
		can_undo = _tmp17_;
#line 5186 "gnome-chess.c"
	}
#line 786 "../src/gnome-chess.vala"
	if (can_undo) {
#line 787 "../src/gnome-chess.vala"
		chess_application_enable_action (self, UNDO_MOVE_ACTION_NAME);
#line 5192 "gnome-chess.c"
	} else {
#line 789 "../src/gnome-chess.vala"
		chess_application_disable_action (self, UNDO_MOVE_ACTION_NAME);
#line 5196 "gnome-chess.c"
	}
}

gchar*
chess_application_compute_current_title (ChessApplication* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ChessPlayer* _tmp2_;
	gchar* result;
#line 792 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 794 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->human_player;
#line 794 "../src/gnome-chess.vala"
	if (_tmp2_ != NULL) {
#line 5213 "gnome-chess.c"
		ChessPlayer* _tmp3_;
		ChessGame* _tmp4_;
		ChessPlayer* _tmp5_;
		ChessPlayer* _tmp6_;
#line 795 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->human_player;
#line 795 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->game;
#line 795 "../src/gnome-chess.vala"
		_tmp5_ = chess_game_get_current_player (_tmp4_);
#line 795 "../src/gnome-chess.vala"
		_tmp6_ = _tmp5_;
#line 795 "../src/gnome-chess.vala"
		_tmp1_ = _tmp3_->color == _tmp6_->color;
#line 5228 "gnome-chess.c"
	} else {
#line 794 "../src/gnome-chess.vala"
		_tmp1_ = FALSE;
#line 5232 "gnome-chess.c"
	}
#line 794 "../src/gnome-chess.vala"
	if (_tmp1_) {
#line 5236 "gnome-chess.c"
		ChessGame* _tmp7_;
		ChessState* _tmp8_;
		ChessState* _tmp9_;
		ChessGame* _tmp10_;
		ChessPlayer* _tmp11_;
		ChessPlayer* _tmp12_;
#line 796 "../src/gnome-chess.vala"
		_tmp7_ = self->priv->game;
#line 796 "../src/gnome-chess.vala"
		_tmp8_ = chess_game_get_current_state (_tmp7_);
#line 796 "../src/gnome-chess.vala"
		_tmp9_ = _tmp8_;
#line 796 "../src/gnome-chess.vala"
		_tmp10_ = self->priv->game;
#line 796 "../src/gnome-chess.vala"
		_tmp11_ = chess_game_get_current_player (_tmp10_);
#line 796 "../src/gnome-chess.vala"
		_tmp12_ = _tmp11_;
#line 796 "../src/gnome-chess.vala"
		_tmp0_ = chess_state_is_in_check (_tmp9_, _tmp12_);
#line 5257 "gnome-chess.c"
	} else {
#line 794 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 5261 "gnome-chess.c"
	}
#line 794 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 5265 "gnome-chess.c"
		ChessGame* _tmp13_;
		ChessPlayer* _tmp14_;
		ChessPlayer* _tmp15_;
#line 798 "../src/gnome-chess.vala"
		_tmp13_ = self->priv->game;
#line 798 "../src/gnome-chess.vala"
		_tmp14_ = chess_game_get_current_player (_tmp13_);
#line 798 "../src/gnome-chess.vala"
		_tmp15_ = _tmp14_;
#line 798 "../src/gnome-chess.vala"
		if (_tmp15_->color == COLOR_WHITE) {
#line 5277 "gnome-chess.c"
			gchar* _tmp16_;
#line 800 "../src/gnome-chess.vala"
			_tmp16_ = g_strdup (_ ("White is in Check"));
#line 800 "../src/gnome-chess.vala"
			result = _tmp16_;
#line 800 "../src/gnome-chess.vala"
			return result;
#line 5285 "gnome-chess.c"
		} else {
			gchar* _tmp17_;
#line 803 "../src/gnome-chess.vala"
			_tmp17_ = g_strdup (_ ("Black is in Check"));
#line 803 "../src/gnome-chess.vala"
			result = _tmp17_;
#line 803 "../src/gnome-chess.vala"
			return result;
#line 5294 "gnome-chess.c"
		}
	} else {
		ChessGame* _tmp18_;
		ChessPlayer* _tmp19_;
		ChessPlayer* _tmp20_;
#line 805 "../src/gnome-chess.vala"
		_tmp18_ = self->priv->game;
#line 805 "../src/gnome-chess.vala"
		_tmp19_ = chess_game_get_current_player (_tmp18_);
#line 805 "../src/gnome-chess.vala"
		_tmp20_ = _tmp19_;
#line 805 "../src/gnome-chess.vala"
		if (_tmp20_->color == COLOR_WHITE) {
#line 5308 "gnome-chess.c"
			gboolean _tmp21_ = FALSE;
			ChessPlayer* _tmp22_;
#line 807 "../src/gnome-chess.vala"
			_tmp22_ = self->priv->human_player;
#line 807 "../src/gnome-chess.vala"
			if (_tmp22_ == NULL) {
#line 807 "../src/gnome-chess.vala"
				_tmp21_ = TRUE;
#line 5317 "gnome-chess.c"
			} else {
				ChessPlayer* _tmp23_;
#line 807 "../src/gnome-chess.vala"
				_tmp23_ = self->priv->human_player;
#line 807 "../src/gnome-chess.vala"
				_tmp21_ = _tmp23_->color == COLOR_WHITE;
#line 5324 "gnome-chess.c"
			}
#line 807 "../src/gnome-chess.vala"
			if (_tmp21_) {
#line 5328 "gnome-chess.c"
				gchar* _tmp24_;
#line 809 "../src/gnome-chess.vala"
				_tmp24_ = g_strdup (_ ("White to Move"));
#line 809 "../src/gnome-chess.vala"
				result = _tmp24_;
#line 809 "../src/gnome-chess.vala"
				return result;
#line 5336 "gnome-chess.c"
			} else {
				gchar* _tmp25_;
#line 812 "../src/gnome-chess.vala"
				_tmp25_ = g_strdup (_ ("White is Thinking…"));
#line 812 "../src/gnome-chess.vala"
				result = _tmp25_;
#line 812 "../src/gnome-chess.vala"
				return result;
#line 5345 "gnome-chess.c"
			}
		} else {
			gboolean _tmp26_ = FALSE;
			ChessPlayer* _tmp27_;
#line 816 "../src/gnome-chess.vala"
			_tmp27_ = self->priv->human_player;
#line 816 "../src/gnome-chess.vala"
			if (_tmp27_ == NULL) {
#line 816 "../src/gnome-chess.vala"
				_tmp26_ = TRUE;
#line 5356 "gnome-chess.c"
			} else {
				ChessPlayer* _tmp28_;
#line 816 "../src/gnome-chess.vala"
				_tmp28_ = self->priv->human_player;
#line 816 "../src/gnome-chess.vala"
				_tmp26_ = _tmp28_->color == COLOR_BLACK;
#line 5363 "gnome-chess.c"
			}
#line 816 "../src/gnome-chess.vala"
			if (_tmp26_) {
#line 5367 "gnome-chess.c"
				gchar* _tmp29_;
#line 818 "../src/gnome-chess.vala"
				_tmp29_ = g_strdup (_ ("Black to Move"));
#line 818 "../src/gnome-chess.vala"
				result = _tmp29_;
#line 818 "../src/gnome-chess.vala"
				return result;
#line 5375 "gnome-chess.c"
			} else {
				gchar* _tmp30_;
#line 821 "../src/gnome-chess.vala"
				_tmp30_ = g_strdup (_ ("Black is Thinking…"));
#line 821 "../src/gnome-chess.vala"
				result = _tmp30_;
#line 821 "../src/gnome-chess.vala"
				return result;
#line 5384 "gnome-chess.c"
			}
		}
	}
}

gchar*
chess_application_compute_status_info (ChessApplication* self)
{
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	ChessState* _tmp2_;
	ChessState* _tmp3_;
	ChessMove* _tmp4_;
	gchar* result;
#line 825 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 827 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 827 "../src/gnome-chess.vala"
	_tmp2_ = chess_game_get_current_state (_tmp1_);
#line 827 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 827 "../src/gnome-chess.vala"
	_tmp4_ = _tmp3_->last_move;
#line 827 "../src/gnome-chess.vala"
	if (_tmp4_ != NULL) {
#line 5411 "gnome-chess.c"
		ChessGame* _tmp5_;
		ChessState* _tmp6_;
		ChessState* _tmp7_;
		ChessMove* _tmp8_;
#line 828 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->game;
#line 828 "../src/gnome-chess.vala"
		_tmp6_ = chess_game_get_current_state (_tmp5_);
#line 828 "../src/gnome-chess.vala"
		_tmp7_ = _tmp6_;
#line 828 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_->last_move;
#line 828 "../src/gnome-chess.vala"
		_tmp0_ = _tmp8_->en_passant;
#line 5426 "gnome-chess.c"
	} else {
#line 827 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 5430 "gnome-chess.c"
	}
#line 827 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 5434 "gnome-chess.c"
		ChessGame* _tmp9_;
		ChessPlayer* _tmp10_;
		ChessPlayer* _tmp11_;
#line 830 "../src/gnome-chess.vala"
		_tmp9_ = self->priv->game;
#line 830 "../src/gnome-chess.vala"
		_tmp10_ = chess_game_get_current_player (_tmp9_);
#line 830 "../src/gnome-chess.vala"
		_tmp11_ = _tmp10_;
#line 830 "../src/gnome-chess.vala"
		if (_tmp11_->color == COLOR_WHITE) {
#line 5446 "gnome-chess.c"
			gchar* _tmp12_;
#line 832 "../src/gnome-chess.vala"
			_tmp12_ = g_strdup (_ ("Black captured White's pawn <span font_style='italic'>en passant</span" \
">."));
#line 832 "../src/gnome-chess.vala"
			result = _tmp12_;
#line 832 "../src/gnome-chess.vala"
			return result;
#line 5454 "gnome-chess.c"
		} else {
			gchar* _tmp13_;
#line 835 "../src/gnome-chess.vala"
			_tmp13_ = g_strdup (_ ("White captured Black's pawn <span font_style='italic'>en passant</span" \
">."));
#line 835 "../src/gnome-chess.vala"
			result = _tmp13_;
#line 835 "../src/gnome-chess.vala"
			return result;
#line 5463 "gnome-chess.c"
		}
	}
#line 838 "../src/gnome-chess.vala"
	result = NULL;
#line 838 "../src/gnome-chess.vala"
	return result;
#line 5470 "gnome-chess.c"
}

static void
chess_application_game_end_cb (ChessApplication* self)
{
	gchar* what = NULL;
	gchar* _tmp0_;
	ChessGame* _tmp1_;
	gchar* why = NULL;
	gchar* _tmp12_;
	ChessGame* _tmp13_;
	ChessWindow* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	ChessWindow* _tmp44_;
#line 841 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 843 "../src/gnome-chess.vala"
	chess_application_disable_action (self, RESIGN_ACTION_NAME);
#line 844 "../src/gnome-chess.vala"
	chess_application_disable_action (self, PAUSE_RESUME_ACTION_NAME);
#line 846 "../src/gnome-chess.vala"
	self->priv->game_needs_saving = FALSE;
#line 848 "../src/gnome-chess.vala"
	_tmp0_ = g_strdup ("");
#line 848 "../src/gnome-chess.vala"
	what = _tmp0_;
#line 849 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 849 "../src/gnome-chess.vala"
	switch (_tmp1_->result) {
#line 849 "../src/gnome-chess.vala"
		case CHESS_RESULT_WHITE_WON:
#line 5504 "gnome-chess.c"
		{
			gchar* _tmp2_;
			PGNGame* _tmp3_;
			const gchar* _tmp4_;
#line 853 "../src/gnome-chess.vala"
			_tmp2_ = g_strdup (_ ("White Wins"));
#line 853 "../src/gnome-chess.vala"
			_g_free0 (what);
#line 853 "../src/gnome-chess.vala"
			what = _tmp2_;
#line 854 "../src/gnome-chess.vala"
			_tmp3_ = self->priv->pgn_game;
#line 854 "../src/gnome-chess.vala"
			_tmp4_ = pgn_game_RESULT_WHITE;
#line 854 "../src/gnome-chess.vala"
			pgn_game_set_result (_tmp3_, _tmp4_);
#line 855 "../src/gnome-chess.vala"
			break;
#line 5523 "gnome-chess.c"
		}
#line 849 "../src/gnome-chess.vala"
		case CHESS_RESULT_BLACK_WON:
#line 5527 "gnome-chess.c"
		{
			gchar* _tmp5_;
			PGNGame* _tmp6_;
			const gchar* _tmp7_;
#line 858 "../src/gnome-chess.vala"
			_tmp5_ = g_strdup (_ ("Black Wins"));
#line 858 "../src/gnome-chess.vala"
			_g_free0 (what);
#line 858 "../src/gnome-chess.vala"
			what = _tmp5_;
#line 859 "../src/gnome-chess.vala"
			_tmp6_ = self->priv->pgn_game;
#line 859 "../src/gnome-chess.vala"
			_tmp7_ = pgn_game_RESULT_BLACK;
#line 859 "../src/gnome-chess.vala"
			pgn_game_set_result (_tmp6_, _tmp7_);
#line 860 "../src/gnome-chess.vala"
			break;
#line 5546 "gnome-chess.c"
		}
#line 849 "../src/gnome-chess.vala"
		case CHESS_RESULT_DRAW:
#line 5550 "gnome-chess.c"
		{
			gchar* _tmp8_;
			PGNGame* _tmp9_;
			const gchar* _tmp10_;
#line 863 "../src/gnome-chess.vala"
			_tmp8_ = g_strdup (_ ("Game is Drawn"));
#line 863 "../src/gnome-chess.vala"
			_g_free0 (what);
#line 863 "../src/gnome-chess.vala"
			what = _tmp8_;
#line 864 "../src/gnome-chess.vala"
			_tmp9_ = self->priv->pgn_game;
#line 864 "../src/gnome-chess.vala"
			_tmp10_ = pgn_game_RESULT_DRAW;
#line 864 "../src/gnome-chess.vala"
			pgn_game_set_result (_tmp9_, _tmp10_);
#line 865 "../src/gnome-chess.vala"
			break;
#line 5569 "gnome-chess.c"
		}
#line 849 "../src/gnome-chess.vala"
		case CHESS_RESULT_BUG:
#line 5573 "gnome-chess.c"
		{
			gchar* _tmp11_;
#line 868 "../src/gnome-chess.vala"
			_tmp11_ = g_strdup (_ ("Oops!"));
#line 868 "../src/gnome-chess.vala"
			_g_free0 (what);
#line 868 "../src/gnome-chess.vala"
			what = _tmp11_;
#line 870 "../src/gnome-chess.vala"
			break;
#line 5584 "gnome-chess.c"
		}
		default:
		{
#line 872 "../src/gnome-chess.vala"
			break;
#line 5590 "gnome-chess.c"
		}
	}
#line 875 "../src/gnome-chess.vala"
	_tmp12_ = g_strdup ("");
#line 875 "../src/gnome-chess.vala"
	why = _tmp12_;
#line 876 "../src/gnome-chess.vala"
	_tmp13_ = self->priv->game;
#line 876 "../src/gnome-chess.vala"
	switch (_tmp13_->rule) {
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_CHECKMATE:
#line 5603 "gnome-chess.c"
		{
			ChessGame* _tmp14_;
#line 879 "../src/gnome-chess.vala"
			_tmp14_ = self->priv->game;
#line 879 "../src/gnome-chess.vala"
			if (_tmp14_->result == CHESS_RESULT_WHITE_WON) {
#line 5610 "gnome-chess.c"
				gchar* _tmp15_;
#line 881 "../src/gnome-chess.vala"
				_tmp15_ = g_strdup (_ ("Black is in check and cannot move."));
#line 881 "../src/gnome-chess.vala"
				_g_free0 (why);
#line 881 "../src/gnome-chess.vala"
				why = _tmp15_;
#line 5618 "gnome-chess.c"
			} else {
				ChessGame* _tmp16_;
#line 882 "../src/gnome-chess.vala"
				_tmp16_ = self->priv->game;
#line 882 "../src/gnome-chess.vala"
				if (_tmp16_->result == CHESS_RESULT_BLACK_WON) {
#line 5625 "gnome-chess.c"
					gchar* _tmp17_;
#line 884 "../src/gnome-chess.vala"
					_tmp17_ = g_strdup (_ ("White is in check and cannot move."));
#line 884 "../src/gnome-chess.vala"
					_g_free0 (why);
#line 884 "../src/gnome-chess.vala"
					why = _tmp17_;
#line 5633 "gnome-chess.c"
				} else {
#line 886 "../src/gnome-chess.vala"
					g_assert_not_reached ();
#line 5637 "gnome-chess.c"
				}
			}
#line 887 "../src/gnome-chess.vala"
			break;
#line 5642 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_STALEMATE:
#line 5646 "gnome-chess.c"
		{
			gchar* _tmp18_;
#line 890 "../src/gnome-chess.vala"
			_tmp18_ = g_strdup (_ ("Player cannot move."));
#line 890 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 890 "../src/gnome-chess.vala"
			why = _tmp18_;
#line 891 "../src/gnome-chess.vala"
			break;
#line 5657 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_FIFTY_MOVES:
#line 5661 "gnome-chess.c"
		{
			gchar* _tmp19_;
#line 894 "../src/gnome-chess.vala"
			_tmp19_ = g_strdup (_ ("No piece was taken or pawn moved in fifty moves."));
#line 894 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 894 "../src/gnome-chess.vala"
			why = _tmp19_;
#line 895 "../src/gnome-chess.vala"
			break;
#line 5672 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_SEVENTY_FIVE_MOVES:
#line 5676 "gnome-chess.c"
		{
			gchar* _tmp20_;
#line 898 "../src/gnome-chess.vala"
			_tmp20_ = g_strdup (_ ("No piece was taken or pawn moved in 75 moves."));
#line 898 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 898 "../src/gnome-chess.vala"
			why = _tmp20_;
#line 899 "../src/gnome-chess.vala"
			break;
#line 5687 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_TIMEOUT:
#line 5691 "gnome-chess.c"
		{
			ChessGame* _tmp21_;
#line 901 "../src/gnome-chess.vala"
			_tmp21_ = self->priv->game;
#line 901 "../src/gnome-chess.vala"
			if (_tmp21_->result == CHESS_RESULT_WHITE_WON) {
#line 5698 "gnome-chess.c"
				gchar* _tmp22_;
#line 903 "../src/gnome-chess.vala"
				_tmp22_ = g_strdup (_ ("Black has run out of time."));
#line 903 "../src/gnome-chess.vala"
				_g_free0 (why);
#line 903 "../src/gnome-chess.vala"
				why = _tmp22_;
#line 5706 "gnome-chess.c"
			} else {
				ChessGame* _tmp23_;
#line 904 "../src/gnome-chess.vala"
				_tmp23_ = self->priv->game;
#line 904 "../src/gnome-chess.vala"
				if (_tmp23_->result == CHESS_RESULT_BLACK_WON) {
#line 5713 "gnome-chess.c"
					gchar* _tmp24_;
#line 906 "../src/gnome-chess.vala"
					_tmp24_ = g_strdup (_ ("White has run out of time."));
#line 906 "../src/gnome-chess.vala"
					_g_free0 (why);
#line 906 "../src/gnome-chess.vala"
					why = _tmp24_;
#line 5721 "gnome-chess.c"
				} else {
#line 908 "../src/gnome-chess.vala"
					g_assert_not_reached ();
#line 5725 "gnome-chess.c"
				}
			}
#line 909 "../src/gnome-chess.vala"
			break;
#line 5730 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_THREE_FOLD_REPETITION:
#line 5734 "gnome-chess.c"
		{
			gchar* _tmp25_;
#line 912 "../src/gnome-chess.vala"
			_tmp25_ = g_strdup (_ ("The same board state has occurred three times."));
#line 912 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 912 "../src/gnome-chess.vala"
			why = _tmp25_;
#line 913 "../src/gnome-chess.vala"
			break;
#line 5745 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_FIVE_FOLD_REPETITION:
#line 5749 "gnome-chess.c"
		{
			gchar* _tmp26_;
#line 916 "../src/gnome-chess.vala"
			_tmp26_ = g_strdup (_ ("The same board state has occurred five times."));
#line 916 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 916 "../src/gnome-chess.vala"
			why = _tmp26_;
#line 917 "../src/gnome-chess.vala"
			break;
#line 5760 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_INSUFFICIENT_MATERIAL:
#line 5764 "gnome-chess.c"
		{
			gchar* _tmp27_;
#line 920 "../src/gnome-chess.vala"
			_tmp27_ = g_strdup (_ ("Neither player can checkmate."));
#line 920 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 920 "../src/gnome-chess.vala"
			why = _tmp27_;
#line 921 "../src/gnome-chess.vala"
			break;
#line 5775 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_RESIGN:
#line 5779 "gnome-chess.c"
		{
			ChessGame* _tmp28_;
#line 923 "../src/gnome-chess.vala"
			_tmp28_ = self->priv->game;
#line 923 "../src/gnome-chess.vala"
			if (_tmp28_->result == CHESS_RESULT_WHITE_WON) {
#line 5786 "gnome-chess.c"
				gchar* _tmp29_;
#line 925 "../src/gnome-chess.vala"
				_tmp29_ = g_strdup (_ ("Black has resigned."));
#line 925 "../src/gnome-chess.vala"
				_g_free0 (why);
#line 925 "../src/gnome-chess.vala"
				why = _tmp29_;
#line 5794 "gnome-chess.c"
			} else {
				ChessGame* _tmp30_;
#line 926 "../src/gnome-chess.vala"
				_tmp30_ = self->priv->game;
#line 926 "../src/gnome-chess.vala"
				if (_tmp30_->result == CHESS_RESULT_BLACK_WON) {
#line 5801 "gnome-chess.c"
					gchar* _tmp31_;
#line 928 "../src/gnome-chess.vala"
					_tmp31_ = g_strdup (_ ("White has resigned."));
#line 928 "../src/gnome-chess.vala"
					_g_free0 (why);
#line 928 "../src/gnome-chess.vala"
					why = _tmp31_;
#line 5809 "gnome-chess.c"
				} else {
#line 930 "../src/gnome-chess.vala"
					g_assert_not_reached ();
#line 5813 "gnome-chess.c"
				}
			}
#line 931 "../src/gnome-chess.vala"
			break;
#line 5818 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_ABANDONMENT:
#line 5822 "gnome-chess.c"
		{
			gchar* _tmp32_;
			PGNGame* _tmp33_;
			const gchar* _tmp34_;
#line 934 "../src/gnome-chess.vala"
			_tmp32_ = g_strdup (_ ("The game has been abandoned."));
#line 934 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 934 "../src/gnome-chess.vala"
			why = _tmp32_;
#line 935 "../src/gnome-chess.vala"
			_tmp33_ = self->priv->pgn_game;
#line 935 "../src/gnome-chess.vala"
			_tmp34_ = pgn_game_TERMINATE_ABANDONED;
#line 935 "../src/gnome-chess.vala"
			pgn_game_set_termination (_tmp33_, _tmp34_);
#line 936 "../src/gnome-chess.vala"
			break;
#line 5841 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_DEATH:
#line 5845 "gnome-chess.c"
		{
			gchar* _tmp35_;
			PGNGame* _tmp36_;
			const gchar* _tmp37_;
#line 939 "../src/gnome-chess.vala"
			_tmp35_ = g_strdup (_ ("The game log says a player died!"));
#line 939 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 939 "../src/gnome-chess.vala"
			why = _tmp35_;
#line 940 "../src/gnome-chess.vala"
			_tmp36_ = self->priv->pgn_game;
#line 940 "../src/gnome-chess.vala"
			_tmp37_ = pgn_game_TERMINATE_DEATH;
#line 940 "../src/gnome-chess.vala"
			pgn_game_set_termination (_tmp36_, _tmp37_);
#line 941 "../src/gnome-chess.vala"
			break;
#line 5864 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_BUG:
#line 5868 "gnome-chess.c"
		{
			gchar* _tmp38_;
#line 944 "../src/gnome-chess.vala"
			_tmp38_ = g_strdup (_ ("The computer player is confused. The game cannot continue."));
#line 944 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 944 "../src/gnome-chess.vala"
			why = _tmp38_;
#line 946 "../src/gnome-chess.vala"
			break;
#line 5879 "gnome-chess.c"
		}
#line 876 "../src/gnome-chess.vala"
		case CHESS_RULE_UNKNOWN:
#line 5883 "gnome-chess.c"
		{
			GFile* _tmp39_;
			gchar* _tmp40_;
#line 951 "../src/gnome-chess.vala"
			_tmp39_ = self->priv->game_file;
#line 951 "../src/gnome-chess.vala"
			_tmp40_ = g_file_get_basename (_tmp39_);
#line 951 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 951 "../src/gnome-chess.vala"
			why = _tmp40_;
#line 952 "../src/gnome-chess.vala"
			break;
#line 5897 "gnome-chess.c"
		}
		default:
#line 876 "../src/gnome-chess.vala"
		break;
#line 5902 "gnome-chess.c"
	}
#line 955 "../src/gnome-chess.vala"
	_tmp41_ = self->priv->_window;
#line 955 "../src/gnome-chess.vala"
	_tmp42_ = what;
#line 955 "../src/gnome-chess.vala"
	_tmp43_ = why;
#line 955 "../src/gnome-chess.vala"
	chess_window_update_game_status (_tmp41_, _tmp42_, _tmp43_);
#line 956 "../src/gnome-chess.vala"
	_tmp44_ = self->priv->_window;
#line 956 "../src/gnome-chess.vala"
	chess_window_end_game (_tmp44_);
#line 957 "../src/gnome-chess.vala"
	chess_application_update_engine_timeout (self);
#line 841 "../src/gnome-chess.vala"
	_g_free0 (why);
#line 841 "../src/gnome-chess.vala"
	_g_free0 (what);
#line 5922 "gnome-chess.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 961 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 961 "../src/gnome-chess.vala"
	return _data6_;
#line 5932 "gnome-chess.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 961 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 5942 "gnome-chess.c"
		ChessApplication* self;
#line 961 "../src/gnome-chess.vala"
		self = _data6_->self;
#line 961 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 961 "../src/gnome-chess.vala"
		g_slice_free (Block6Data, _data6_);
#line 5950 "gnome-chess.c"
	}
}

static void
____lambda24_ (Block6Data* _data6_,
               gboolean saved)
{
	ChessApplication* self;
#line 995 "../src/gnome-chess.vala"
	self = _data6_->self;
#line 996 "../src/gnome-chess.vala"
	_data6_->callback (!saved, _data6_->callback_target);
#line 5963 "gnome-chess.c"
}

static void
_____lambda24__chess_application_present_save_dialog_callback (gboolean saved,
                                                               gpointer self)
{
#line 995 "../src/gnome-chess.vala"
	____lambda24_ (self, saved);
#line 5972 "gnome-chess.c"
}

static void
__lambda21_ (Block6Data* _data6_,
             AdwAlertDialog* dialog,
             const gchar* response)
{
	ChessApplication* self;
	gboolean _tmp0_ = FALSE;
#line 988 "../src/gnome-chess.vala"
	self = _data6_->self;
#line 988 "../src/gnome-chess.vala"
	g_return_if_fail (dialog != NULL);
#line 988 "../src/gnome-chess.vala"
	g_return_if_fail (response != NULL);
#line 989 "../src/gnome-chess.vala"
	if (g_strcmp0 (response, "cancel") == 0) {
#line 989 "../src/gnome-chess.vala"
		_tmp0_ = TRUE;
#line 5992 "gnome-chess.c"
	} else {
#line 989 "../src/gnome-chess.vala"
		_tmp0_ = g_strcmp0 (response, "close") == 0;
#line 5996 "gnome-chess.c"
	}
#line 989 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 991 "../src/gnome-chess.vala"
		_data6_->callback (TRUE, _data6_->callback_target);
#line 6002 "gnome-chess.c"
	} else {
#line 993 "../src/gnome-chess.vala"
		if (g_strcmp0 (response, "yes") == 0) {
#line 995 "../src/gnome-chess.vala"
			chess_application_present_save_dialog (self, _____lambda24__chess_application_present_save_dialog_callback, block6_data_ref (_data6_), block6_data_unref);
#line 6008 "gnome-chess.c"
		} else {
#line 999 "../src/gnome-chess.vala"
			if (g_strcmp0 (response, "no") == 0) {
#line 1002 "../src/gnome-chess.vala"
				self->priv->game_needs_saving = FALSE;
#line 1003 "../src/gnome-chess.vala"
				chess_application_autosave (self);
#line 1005 "../src/gnome-chess.vala"
				_data6_->callback (FALSE, _data6_->callback_target);
#line 6018 "gnome-chess.c"
			}
		}
	}
}

static void
___lambda21__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                        const gchar* response,
                                        gpointer self)
{
#line 988 "../src/gnome-chess.vala"
	__lambda21_ (self, _sender, response);
#line 6031 "gnome-chess.c"
}

static void
chess_application_prompt_save_game (ChessApplication* self,
                                    const gchar* prompt_text,
                                    ChessApplicationPromptSaveGameCallback callback,
                                    gpointer callback_target)
{
	Block6Data* _data6_;
	AdwAlertDialog* prompt_save_game_dialog = NULL;
	AdwAlertDialog* _tmp0_;
	AdwAlertDialog* _tmp1_;
	ChessGame* _tmp2_;
	AdwAlertDialog* _tmp9_;
	AdwAlertDialog* _tmp10_;
	ChessWindow* _tmp11_;
#line 961 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 961 "../src/gnome-chess.vala"
	g_return_if_fail (prompt_text != NULL);
#line 961 "../src/gnome-chess.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 961 "../src/gnome-chess.vala"
	_data6_->_ref_count_ = 1;
#line 961 "../src/gnome-chess.vala"
	_data6_->self = g_object_ref (self);
#line 961 "../src/gnome-chess.vala"
	_data6_->callback = callback;
#line 961 "../src/gnome-chess.vala"
	_data6_->callback_target = callback_target;
#line 963 "../src/gnome-chess.vala"
	if (!self->priv->game_needs_saving) {
#line 965 "../src/gnome-chess.vala"
		_data6_->callback (FALSE, _data6_->callback_target);
#line 966 "../src/gnome-chess.vala"
		block6_data_unref (_data6_);
#line 966 "../src/gnome-chess.vala"
		_data6_ = NULL;
#line 966 "../src/gnome-chess.vala"
		return;
#line 6072 "gnome-chess.c"
	}
#line 969 "../src/gnome-chess.vala"
	_tmp0_ = (AdwAlertDialog*) adw_alert_dialog_new (_ ("Save Game?"), prompt_text);
#line 969 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp0_);
#line 969 "../src/gnome-chess.vala"
	prompt_save_game_dialog = _tmp0_;
#line 971 "../src/gnome-chess.vala"
	_tmp1_ = prompt_save_game_dialog;
#line 971 "../src/gnome-chess.vala"
	adw_alert_dialog_add_response (_tmp1_, "cancel", _ ("_Cancel"));
#line 973 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->game;
#line 973 "../src/gnome-chess.vala"
	if (_tmp2_->result == CHESS_RESULT_IN_PROGRESS) {
#line 6088 "gnome-chess.c"
		AdwAlertDialog* _tmp3_;
		AdwAlertDialog* _tmp4_;
		AdwAlertDialog* _tmp5_;
#line 975 "../src/gnome-chess.vala"
		_tmp3_ = prompt_save_game_dialog;
#line 975 "../src/gnome-chess.vala"
		adw_alert_dialog_add_responses (_tmp3_, "no", _ ("_Abandon Game"), "yes", _ ("Save game for later"), NULL);
#line 977 "../src/gnome-chess.vala"
		_tmp4_ = prompt_save_game_dialog;
#line 977 "../src/gnome-chess.vala"
		adw_alert_dialog_set_response_appearance (_tmp4_, "no", ADW_RESPONSE_DESTRUCTIVE);
#line 978 "../src/gnome-chess.vala"
		_tmp5_ = prompt_save_game_dialog;
#line 978 "../src/gnome-chess.vala"
		adw_alert_dialog_set_response_appearance (_tmp5_, "yes", ADW_RESPONSE_SUGGESTED);
#line 6104 "gnome-chess.c"
	} else {
		AdwAlertDialog* _tmp6_;
		AdwAlertDialog* _tmp7_;
		AdwAlertDialog* _tmp8_;
#line 982 "../src/gnome-chess.vala"
		_tmp6_ = prompt_save_game_dialog;
#line 982 "../src/gnome-chess.vala"
		adw_alert_dialog_add_responses (_tmp6_, "no", _ ("_Discard Game"), "yes", _ ("Save game log"), NULL);
#line 984 "../src/gnome-chess.vala"
		_tmp7_ = prompt_save_game_dialog;
#line 984 "../src/gnome-chess.vala"
		adw_alert_dialog_set_response_appearance (_tmp7_, "no", ADW_RESPONSE_DESTRUCTIVE);
#line 985 "../src/gnome-chess.vala"
		_tmp8_ = prompt_save_game_dialog;
#line 985 "../src/gnome-chess.vala"
		adw_alert_dialog_set_response_appearance (_tmp8_, "yes", ADW_RESPONSE_SUGGESTED);
#line 6121 "gnome-chess.c"
	}
#line 988 "../src/gnome-chess.vala"
	_tmp9_ = prompt_save_game_dialog;
#line 988 "../src/gnome-chess.vala"
	g_signal_connect_data (_tmp9_, "response", (GCallback) ___lambda21__adw_alert_dialog_response, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 1009 "../src/gnome-chess.vala"
	_tmp10_ = prompt_save_game_dialog;
#line 1009 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->_window;
#line 1009 "../src/gnome-chess.vala"
	adw_dialog_present ((AdwDialog*) _tmp10_, (GtkWidget*) _tmp11_);
#line 961 "../src/gnome-chess.vala"
	_g_object_unref0 (prompt_save_game_dialog);
#line 961 "../src/gnome-chess.vala"
	block6_data_unref (_data6_);
#line 961 "../src/gnome-chess.vala"
	_data6_ = NULL;
#line 6139 "gnome-chess.c"
}

static void
__lambda28_ (ChessApplication* self,
             AdwAlertDialog* dialog,
             const gchar* response)
{
	ChessGame* _tmp0_;
#line 1040 "../src/gnome-chess.vala"
	g_return_if_fail (dialog != NULL);
#line 1040 "../src/gnome-chess.vala"
	g_return_if_fail (response != NULL);
#line 1041 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1041 "../src/gnome-chess.vala"
	chess_game_unpause (_tmp0_);
#line 1043 "../src/gnome-chess.vala"
	if (g_strcmp0 (response, "accept") == 0) {
#line 6158 "gnome-chess.c"
		ChessGame* _tmp1_;
		ChessPlayer* _tmp2_;
		ChessPlayer* _tmp3_;
#line 1044 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->game;
#line 1044 "../src/gnome-chess.vala"
		_tmp2_ = chess_game_get_current_player (_tmp1_);
#line 1044 "../src/gnome-chess.vala"
		_tmp3_ = _tmp2_;
#line 1044 "../src/gnome-chess.vala"
		chess_player_claim_draw (_tmp3_);
#line 6170 "gnome-chess.c"
	}
}

static void
___lambda28__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                        const gchar* response,
                                        gpointer self)
{
#line 1040 "../src/gnome-chess.vala"
	__lambda28_ ((ChessApplication*) self, _sender, response);
#line 6181 "gnome-chess.c"
}

static void
chess_application_present_claim_draw_dialog (ChessApplication* self)
{
	ChessGame* _tmp0_;
	ChessGame* _tmp1_;
	AdwAlertDialog* claim_draw_dialog = NULL;
	AdwAlertDialog* _tmp2_;
	gchar* reason = NULL;
	ChessGame* _tmp3_;
	AdwAlertDialog* _tmp7_;
	const gchar* _tmp8_;
	AdwAlertDialog* _tmp9_;
	AdwAlertDialog* _tmp10_;
	AdwAlertDialog* _tmp11_;
	AdwAlertDialog* _tmp12_;
	AdwAlertDialog* _tmp13_;
	ChessWindow* _tmp14_;
#line 1012 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1012 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1012 "../src/gnome-chess.vala"
	_vala_return_if_fail (chess_game_can_claim_draw (_tmp0_), "game.can_claim_draw ()");
#line 1015 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 1015 "../src/gnome-chess.vala"
	chess_game_pause (_tmp1_, FALSE);
#line 1017 "../src/gnome-chess.vala"
	_tmp2_ = (AdwAlertDialog*) adw_alert_dialog_new (_ ("Would you like to claim a draw?"), "");
#line 1017 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp2_);
#line 1017 "../src/gnome-chess.vala"
	claim_draw_dialog = _tmp2_;
#line 1020 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->game;
#line 1020 "../src/gnome-chess.vala"
	if (chess_game_is_fifty_move_rule_fulfilled (_tmp3_)) {
#line 6221 "gnome-chess.c"
		gchar* _tmp4_;
#line 1023 "../src/gnome-chess.vala"
		_tmp4_ = g_strdup (_ ("You may claim a draw because fifty moves have passed without a capture" \
" or pawn advancement. (The computer player may still choose to claim a" \
" draw even if you choose to keep playing.)"));
#line 1023 "../src/gnome-chess.vala"
		_g_free0 (reason);
#line 1023 "../src/gnome-chess.vala"
		reason = _tmp4_;
#line 6229 "gnome-chess.c"
	} else {
		ChessGame* _tmp5_;
#line 1025 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->game;
#line 1025 "../src/gnome-chess.vala"
		if (chess_game_is_three_fold_repeat (_tmp5_)) {
#line 6236 "gnome-chess.c"
			gchar* _tmp6_;
#line 1028 "../src/gnome-chess.vala"
			_tmp6_ = g_strdup (_ ("You may claim a draw because the current board position has occurred t" \
"hree times. (The computer player may still choose to claim a draw even" \
" if you choose to keep playing.)"));
#line 1028 "../src/gnome-chess.vala"
			_g_free0 (reason);
#line 1028 "../src/gnome-chess.vala"
			reason = _tmp6_;
#line 6244 "gnome-chess.c"
		} else {
#line 1031 "../src/gnome-chess.vala"
			g_assert_not_reached ();
#line 6248 "gnome-chess.c"
		}
	}
#line 1033 "../src/gnome-chess.vala"
	_tmp7_ = claim_draw_dialog;
#line 1033 "../src/gnome-chess.vala"
	_tmp8_ = reason;
#line 1033 "../src/gnome-chess.vala"
	adw_alert_dialog_set_body (_tmp7_, _tmp8_);
#line 1035 "../src/gnome-chess.vala"
	_tmp9_ = claim_draw_dialog;
#line 1035 "../src/gnome-chess.vala"
	adw_alert_dialog_add_responses (_tmp9_, "reject", _ ("_Keep Playing"), "accept", _ ("_Claim Draw"), NULL);
#line 1037 "../src/gnome-chess.vala"
	_tmp10_ = claim_draw_dialog;
#line 1037 "../src/gnome-chess.vala"
	adw_alert_dialog_set_response_appearance (_tmp10_, "reject", ADW_RESPONSE_SUGGESTED);
#line 1038 "../src/gnome-chess.vala"
	_tmp11_ = claim_draw_dialog;
#line 1038 "../src/gnome-chess.vala"
	adw_alert_dialog_set_response_appearance (_tmp11_, "accept", ADW_RESPONSE_DESTRUCTIVE);
#line 1040 "../src/gnome-chess.vala"
	_tmp12_ = claim_draw_dialog;
#line 1040 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp12_, "response", (GCallback) ___lambda28__adw_alert_dialog_response, self, 0);
#line 1047 "../src/gnome-chess.vala"
	_tmp13_ = claim_draw_dialog;
#line 1047 "../src/gnome-chess.vala"
	_tmp14_ = self->priv->_window;
#line 1047 "../src/gnome-chess.vala"
	adw_dialog_present ((AdwDialog*) _tmp13_, (GtkWidget*) _tmp14_);
#line 1012 "../src/gnome-chess.vala"
	_g_free0 (reason);
#line 1012 "../src/gnome-chess.vala"
	_g_object_unref0 (claim_draw_dialog);
#line 6283 "gnome-chess.c"
}

static void
__lambda25_ (ChessApplication* self,
             gboolean cancelled)
{
#line 1053 "../src/gnome-chess.vala"
	if (!cancelled) {
#line 1054 "../src/gnome-chess.vala"
		chess_application_configure_new_game (self);
#line 6294 "gnome-chess.c"
	}
}

static void
___lambda25__chess_application_prompt_save_game_callback (gboolean cancelled,
                                                          gpointer self)
{
#line 1052 "../src/gnome-chess.vala"
	__lambda25_ ((ChessApplication*) self, cancelled);
#line 6304 "gnome-chess.c"
}

void
chess_application_new_game_cb (ChessApplication* self)
{
#line 1050 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1052 "../src/gnome-chess.vala"
	chess_application_prompt_save_game (self, _ ("By starting a new game now, unsaved progress would be lost."), ___lambda25__chess_application_prompt_save_game_callback, self);
#line 6314 "gnome-chess.c"
}

static void
__lambda37_ (ChessApplication* self,
             AdwAlertDialog* dialog,
             const gchar* response)
{
	ChessGame* _tmp0_;
#line 1070 "../src/gnome-chess.vala"
	g_return_if_fail (dialog != NULL);
#line 1070 "../src/gnome-chess.vala"
	g_return_if_fail (response != NULL);
#line 1071 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1071 "../src/gnome-chess.vala"
	chess_game_unpause (_tmp0_);
#line 1073 "../src/gnome-chess.vala"
	if (g_strcmp0 (response, "accept") == 0) {
#line 6333 "gnome-chess.c"
		ChessPlayer* _tmp1_;
#line 1075 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->human_player;
#line 1075 "../src/gnome-chess.vala"
		if (_tmp1_ != NULL) {
#line 6339 "gnome-chess.c"
			ChessPlayer* _tmp2_;
#line 1076 "../src/gnome-chess.vala"
			_tmp2_ = self->priv->human_player;
#line 1076 "../src/gnome-chess.vala"
			chess_player_resign (_tmp2_);
#line 6345 "gnome-chess.c"
		} else {
			ChessGame* _tmp3_;
			ChessPlayer* _tmp4_;
			ChessPlayer* _tmp5_;
#line 1078 "../src/gnome-chess.vala"
			_tmp3_ = self->priv->game;
#line 1078 "../src/gnome-chess.vala"
			_tmp4_ = chess_game_get_current_player (_tmp3_);
#line 1078 "../src/gnome-chess.vala"
			_tmp5_ = _tmp4_;
#line 1078 "../src/gnome-chess.vala"
			chess_player_resign (_tmp5_);
#line 6358 "gnome-chess.c"
		}
	}
}

static void
___lambda37__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                        const gchar* response,
                                        gpointer self)
{
#line 1070 "../src/gnome-chess.vala"
	__lambda37_ ((ChessApplication*) self, _sender, response);
#line 6370 "gnome-chess.c"
}

void
chess_application_resign_cb (ChessApplication* self)
{
	ChessGame* _tmp0_;
	AdwAlertDialog* resign_dialog = NULL;
	AdwAlertDialog* _tmp1_;
	ChessWindow* _tmp2_;
#line 1058 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1060 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1060 "../src/gnome-chess.vala"
	chess_game_pause (_tmp0_, FALSE);
#line 1062 "../src/gnome-chess.vala"
	_tmp1_ = (AdwAlertDialog*) adw_alert_dialog_new (_ ("Are you sure you want to resign?"), "");
#line 1062 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp1_);
#line 1062 "../src/gnome-chess.vala"
	resign_dialog = _tmp1_;
#line 1064 "../src/gnome-chess.vala"
	adw_alert_dialog_set_body (resign_dialog, _ ("This makes sense if you plan to save the game as a record of your loss" \
"."));
#line 1065 "../src/gnome-chess.vala"
	adw_alert_dialog_add_responses (resign_dialog, "reject", _ ("_Keep Playing"), "accept", _ ("_Resign"), NULL);
#line 1067 "../src/gnome-chess.vala"
	adw_alert_dialog_set_response_appearance (resign_dialog, "reject", ADW_RESPONSE_SUGGESTED);
#line 1068 "../src/gnome-chess.vala"
	adw_alert_dialog_set_response_appearance (resign_dialog, "accept", ADW_RESPONSE_DESTRUCTIVE);
#line 1070 "../src/gnome-chess.vala"
	g_signal_connect_object (resign_dialog, "response", (GCallback) ___lambda37__adw_alert_dialog_response, self, 0);
#line 1082 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->_window;
#line 1082 "../src/gnome-chess.vala"
	adw_dialog_present ((AdwDialog*) resign_dialog, (GtkWidget*) _tmp2_);
#line 1058 "../src/gnome-chess.vala"
	_g_object_unref0 (resign_dialog);
#line 6408 "gnome-chess.c"
}

void
chess_application_undo_move_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	ChessPlayer* _tmp4_;
#line 1085 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1088 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1088 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1088 "../src/gnome-chess.vala"
	_tmp1_->selected_rank = -1;
#line 1089 "../src/gnome-chess.vala"
	_tmp2_ = chess_application_get_scene (self);
#line 1089 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 1089 "../src/gnome-chess.vala"
	_tmp3_->selected_file = -1;
#line 1091 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->opponent;
#line 1091 "../src/gnome-chess.vala"
	if (_tmp4_ != NULL) {
#line 6437 "gnome-chess.c"
		ChessPlayer* _tmp5_;
#line 1092 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->human_player;
#line 1092 "../src/gnome-chess.vala"
		chess_player_undo (_tmp5_);
#line 6443 "gnome-chess.c"
	} else {
		ChessGame* _tmp6_;
		ChessPlayer* _tmp7_;
		ChessPlayer* _tmp8_;
#line 1094 "../src/gnome-chess.vala"
		_tmp6_ = self->priv->game;
#line 1094 "../src/gnome-chess.vala"
		_tmp7_ = chess_game_get_opponent (_tmp6_);
#line 1094 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_;
#line 1094 "../src/gnome-chess.vala"
		chess_player_undo (_tmp8_);
#line 6456 "gnome-chess.c"
	}
}

void
chess_application_pause_resume_cb (ChessApplication* self)
{
	ChessGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ChessWindow* _tmp5_;
	ChessWindow* _tmp6_;
#line 1097 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1099 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1099 "../src/gnome-chess.vala"
	_tmp1_ = chess_game_get_is_paused (_tmp0_);
#line 1099 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 1099 "../src/gnome-chess.vala"
	if (_tmp2_) {
#line 6478 "gnome-chess.c"
		ChessGame* _tmp3_;
#line 1100 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->game;
#line 1100 "../src/gnome-chess.vala"
		chess_game_unpause (_tmp3_);
#line 6484 "gnome-chess.c"
	} else {
		ChessGame* _tmp4_;
#line 1102 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->game;
#line 1102 "../src/gnome-chess.vala"
		chess_game_pause (_tmp4_, TRUE);
#line 6491 "gnome-chess.c"
	}
#line 1104 "../src/gnome-chess.vala"
	chess_application_update_action_status (self);
#line 1105 "../src/gnome-chess.vala"
	_tmp5_ = self->priv->_window;
#line 1105 "../src/gnome-chess.vala"
	chess_window_update_history_panel (_tmp5_);
#line 1106 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->_window;
#line 1106 "../src/gnome-chess.vala"
	chess_window_update_pause_resume_button (_tmp6_);
#line 6503 "gnome-chess.c"
}

void
chess_application_quit_cb (ChessApplication* self)
{
#line 1109 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1111 "../src/gnome-chess.vala"
	chess_application_quit_game (self);
#line 6513 "gnome-chess.c"
}

static void
chess_application_history_go_first_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
#line 1114 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1116 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1116 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1116 "../src/gnome-chess.vala"
	chess_scene_set_move_number (_tmp1_, 0);
#line 6529 "gnome-chess.c"
}

static void
chess_application_history_go_previous_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	ChessScene* _tmp4_;
	ChessScene* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 1119 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1121 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1121 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1121 "../src/gnome-chess.vala"
	_tmp2_ = chess_scene_get_move_number (_tmp1_);
#line 1121 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 1121 "../src/gnome-chess.vala"
	if (_tmp3_ == 0) {
#line 1122 "../src/gnome-chess.vala"
		return;
#line 6557 "gnome-chess.c"
	}
#line 1124 "../src/gnome-chess.vala"
	_tmp4_ = chess_application_get_scene (self);
#line 1124 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 1124 "../src/gnome-chess.vala"
	_tmp6_ = chess_scene_get_move_number (_tmp5_);
#line 1124 "../src/gnome-chess.vala"
	_tmp7_ = _tmp6_;
#line 1124 "../src/gnome-chess.vala"
	if (_tmp7_ == -1) {
#line 6569 "gnome-chess.c"
		ChessScene* _tmp8_;
		ChessScene* _tmp9_;
		ChessGame* _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
#line 1125 "../src/gnome-chess.vala"
		_tmp8_ = chess_application_get_scene (self);
#line 1125 "../src/gnome-chess.vala"
		_tmp9_ = _tmp8_;
#line 1125 "../src/gnome-chess.vala"
		_tmp10_ = self->priv->game;
#line 1125 "../src/gnome-chess.vala"
		_tmp11_ = chess_game_get_n_moves (_tmp10_);
#line 1125 "../src/gnome-chess.vala"
		_tmp12_ = _tmp11_;
#line 1125 "../src/gnome-chess.vala"
		chess_scene_set_move_number (_tmp9_, ((gint) _tmp12_) - 1);
#line 6587 "gnome-chess.c"
	} else {
		ChessScene* _tmp13_;
		ChessScene* _tmp14_;
		ChessScene* _tmp15_;
		ChessScene* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 1127 "../src/gnome-chess.vala"
		_tmp13_ = chess_application_get_scene (self);
#line 1127 "../src/gnome-chess.vala"
		_tmp14_ = _tmp13_;
#line 1127 "../src/gnome-chess.vala"
		_tmp15_ = chess_application_get_scene (self);
#line 1127 "../src/gnome-chess.vala"
		_tmp16_ = _tmp15_;
#line 1127 "../src/gnome-chess.vala"
		_tmp17_ = chess_scene_get_move_number (_tmp16_);
#line 1127 "../src/gnome-chess.vala"
		_tmp18_ = _tmp17_;
#line 1127 "../src/gnome-chess.vala"
		chess_scene_set_move_number (_tmp14_, _tmp18_ - 1);
#line 6609 "gnome-chess.c"
	}
}

static void
chess_application_history_go_next_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint move_number = 0;
	ChessScene* _tmp4_;
	ChessScene* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	ChessGame* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
#line 1130 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1132 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1132 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1132 "../src/gnome-chess.vala"
	_tmp2_ = chess_scene_get_move_number (_tmp1_);
#line 1132 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 1132 "../src/gnome-chess.vala"
	if (_tmp3_ == -1) {
#line 1133 "../src/gnome-chess.vala"
		return;
#line 6642 "gnome-chess.c"
	}
#line 1135 "../src/gnome-chess.vala"
	_tmp4_ = chess_application_get_scene (self);
#line 1135 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 1135 "../src/gnome-chess.vala"
	_tmp6_ = chess_scene_get_move_number (_tmp5_);
#line 1135 "../src/gnome-chess.vala"
	_tmp7_ = _tmp6_;
#line 1135 "../src/gnome-chess.vala"
	move_number = _tmp7_ + 1;
#line 1136 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->game;
#line 1136 "../src/gnome-chess.vala"
	_tmp9_ = chess_game_get_n_moves (_tmp8_);
#line 1136 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 1136 "../src/gnome-chess.vala"
	if (((guint) move_number) >= _tmp10_) {
#line 6662 "gnome-chess.c"
		ChessScene* _tmp11_;
		ChessScene* _tmp12_;
#line 1137 "../src/gnome-chess.vala"
		_tmp11_ = chess_application_get_scene (self);
#line 1137 "../src/gnome-chess.vala"
		_tmp12_ = _tmp11_;
#line 1137 "../src/gnome-chess.vala"
		chess_scene_set_move_number (_tmp12_, -1);
#line 6671 "gnome-chess.c"
	} else {
		ChessScene* _tmp13_;
		ChessScene* _tmp14_;
#line 1139 "../src/gnome-chess.vala"
		_tmp13_ = chess_application_get_scene (self);
#line 1139 "../src/gnome-chess.vala"
		_tmp14_ = _tmp13_;
#line 1139 "../src/gnome-chess.vala"
		chess_scene_set_move_number (_tmp14_, move_number);
#line 6681 "gnome-chess.c"
	}
}

static void
chess_application_history_go_last_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
#line 1142 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1144 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1144 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1144 "../src/gnome-chess.vala"
	chess_scene_set_move_number (_tmp1_, -1);
#line 6698 "gnome-chess.c"
}

static void
__lambda26_ (ChessApplication* self)
{
#line 1156 "../src/gnome-chess.vala"
	chess_application_start_new_game (self);
#line 6706 "gnome-chess.c"
}

static void
___lambda26__new_game_dialog_new_game_requested (NewGameDialog* _sender,
                                                 gpointer self)
{
#line 1156 "../src/gnome-chess.vala"
	__lambda26_ ((ChessApplication*) self);
#line 6715 "gnome-chess.c"
}

static void
chess_application_configure_new_game (ChessApplication* self)
{
	NewGameDialog* _tmp0_;
	Preferences* _tmp3_;
	GList* _tmp4_;
	NewGameDialog* _tmp5_;
	NewGameDialog* _tmp6_;
	NewGameDialog* _tmp7_;
	ChessWindow* _tmp8_;
#line 1147 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1149 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->new_game_dialog;
#line 1149 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 6734 "gnome-chess.c"
		NewGameDialog* _tmp1_;
		ChessWindow* _tmp2_;
#line 1151 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->new_game_dialog;
#line 1151 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->_window;
#line 1151 "../src/gnome-chess.vala"
		adw_dialog_present ((AdwDialog*) _tmp1_, (GtkWidget*) _tmp2_);
#line 1152 "../src/gnome-chess.vala"
		return;
#line 6745 "gnome-chess.c"
	}
#line 1155 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->preferences;
#line 1155 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->ai_profiles;
#line 1155 "../src/gnome-chess.vala"
	_tmp5_ = new_game_dialog_new (_tmp3_, _tmp4_);
#line 1155 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp5_);
#line 1155 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->new_game_dialog);
#line 1155 "../src/gnome-chess.vala"
	self->priv->new_game_dialog = _tmp5_;
#line 1156 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->new_game_dialog;
#line 1156 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp6_, "new-game-requested", (GCallback) ___lambda26__new_game_dialog_new_game_requested, self, 0);
#line 1157 "../src/gnome-chess.vala"
	_tmp7_ = self->priv->new_game_dialog;
#line 1157 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->_window;
#line 1157 "../src/gnome-chess.vala"
	adw_dialog_present ((AdwDialog*) _tmp7_, (GtkWidget*) _tmp8_);
#line 6769 "gnome-chess.c"
}

static void
chess_application_preferences_cb (ChessApplication* self)
{
	PreferencesDialog* _tmp0_;
	Preferences* _tmp3_;
	PreferencesDialog* _tmp4_;
	PreferencesDialog* _tmp5_;
	ChessWindow* _tmp6_;
#line 1160 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1162 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->preferences_dialog;
#line 1162 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 6786 "gnome-chess.c"
		PreferencesDialog* _tmp1_;
		ChessWindow* _tmp2_;
#line 1164 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->preferences_dialog;
#line 1164 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->_window;
#line 1164 "../src/gnome-chess.vala"
		adw_dialog_present ((AdwDialog*) _tmp1_, (GtkWidget*) _tmp2_);
#line 1165 "../src/gnome-chess.vala"
		return;
#line 6797 "gnome-chess.c"
	}
#line 1168 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->preferences;
#line 1168 "../src/gnome-chess.vala"
	_tmp4_ = preferences_dialog_new (_tmp3_);
#line 1168 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp4_);
#line 1168 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->preferences_dialog);
#line 1168 "../src/gnome-chess.vala"
	self->priv->preferences_dialog = _tmp4_;
#line 1169 "../src/gnome-chess.vala"
	_tmp5_ = self->priv->preferences_dialog;
#line 1169 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->_window;
#line 1169 "../src/gnome-chess.vala"
	adw_dialog_present ((AdwDialog*) _tmp5_, (GtkWidget*) _tmp6_);
#line 6815 "gnome-chess.c"
}

void
chess_application_help_cb (ChessApplication* self)
{
	ChessWindow* _tmp0_;
#line 1172 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1174 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 1174 "../src/gnome-chess.vala"
	gtk_show_uri ((GtkWindow*) _tmp0_, "help:gnome-chess", (guint32) GDK_CURRENT_TIME);
#line 6828 "gnome-chess.c"
}

void
chess_application_about_cb (ChessApplication* self)
{
	AdwAboutDialog* _tmp0_;
	AdwAboutDialog* _tmp3_;
	AdwAboutDialog* _tmp4_;
	AdwAboutDialog* _tmp5_;
	AdwAboutDialog* _tmp6_;
	const gchar* _tmp7_;
	AdwAboutDialog* _tmp8_;
	AdwAboutDialog* _tmp9_;
	AdwAboutDialog* _tmp10_;
	AdwAboutDialog* _tmp11_;
	AdwAboutDialog* _tmp12_;
	AdwAboutDialog* _tmp13_;
	ChessWindow* _tmp14_;
#line 1180 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1182 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->about_dialog;
#line 1182 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 6853 "gnome-chess.c"
		AdwAboutDialog* _tmp1_;
		ChessWindow* _tmp2_;
#line 1184 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->about_dialog;
#line 1184 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->_window;
#line 1184 "../src/gnome-chess.vala"
		adw_dialog_present ((AdwDialog*) _tmp1_, (GtkWidget*) _tmp2_);
#line 1185 "../src/gnome-chess.vala"
		return;
#line 6864 "gnome-chess.c"
	}
#line 1188 "../src/gnome-chess.vala"
	_tmp3_ = (AdwAboutDialog*) adw_about_dialog_new ();
#line 1188 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp3_);
#line 1188 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->about_dialog);
#line 1188 "../src/gnome-chess.vala"
	self->priv->about_dialog = _tmp3_;
#line 1189 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->about_dialog;
#line 1189 "../src/gnome-chess.vala"
	adw_about_dialog_set_application_name (_tmp4_, _ ("Chess"));
#line 1190 "../src/gnome-chess.vala"
	_tmp5_ = self->priv->about_dialog;
#line 1190 "../src/gnome-chess.vala"
	adw_about_dialog_set_version (_tmp5_, VERSION);
#line 1191 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->about_dialog;
#line 1191 "../src/gnome-chess.vala"
	_tmp7_ = self->priv->copyrights;
#line 1191 "../src/gnome-chess.vala"
	adw_about_dialog_set_copyright (_tmp6_, _tmp7_);
#line 1192 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->about_dialog;
#line 1192 "../src/gnome-chess.vala"
	adw_about_dialog_set_license_type (_tmp8_, GTK_LICENSE_GPL_3_0);
#line 1193 "../src/gnome-chess.vala"
	_tmp9_ = self->priv->about_dialog;
#line 1193 "../src/gnome-chess.vala"
	adw_about_dialog_set_developers (_tmp9_, CHESS_APPLICATION_authors);
#line 1194 "../src/gnome-chess.vala"
	_tmp10_ = self->priv->about_dialog;
#line 1194 "../src/gnome-chess.vala"
	adw_about_dialog_set_artists (_tmp10_, CHESS_APPLICATION_artists);
#line 1195 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->about_dialog;
#line 1195 "../src/gnome-chess.vala"
	adw_about_dialog_set_translator_credits (_tmp11_, _ ("translator-credits"));
#line 1196 "../src/gnome-chess.vala"
	_tmp12_ = self->priv->about_dialog;
#line 1196 "../src/gnome-chess.vala"
	adw_about_dialog_set_application_icon (_tmp12_, "org.gnome.Chess");
#line 1197 "../src/gnome-chess.vala"
	_tmp13_ = self->priv->about_dialog;
#line 1197 "../src/gnome-chess.vala"
	_tmp14_ = self->priv->_window;
#line 1197 "../src/gnome-chess.vala"
	adw_dialog_present ((AdwDialog*) _tmp13_, (GtkWidget*) _tmp14_);
#line 6914 "gnome-chess.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 1200 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 1200 "../src/gnome-chess.vala"
	return _data7_;
#line 6924 "gnome-chess.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 1200 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 6934 "gnome-chess.c"
		ChessApplication* self;
#line 1200 "../src/gnome-chess.vala"
		self = _data7_->self;
#line 1200 "../src/gnome-chess.vala"
		_g_object_unref0 (_data7_->promotion_type_selector_dialog);
#line 1200 "../src/gnome-chess.vala"
		(_data7_->handler_target_destroy_notify == NULL) ? NULL : (_data7_->handler_target_destroy_notify (_data7_->handler_target), NULL);
#line 1200 "../src/gnome-chess.vala"
		_data7_->handler = NULL;
#line 1200 "../src/gnome-chess.vala"
		_data7_->handler_target = NULL;
#line 1200 "../src/gnome-chess.vala"
		_data7_->handler_target_destroy_notify = NULL;
#line 1200 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1200 "../src/gnome-chess.vala"
		g_slice_free (Block7Data, _data7_);
#line 6952 "gnome-chess.c"
	}
}

static void
__lambda39_ (Block7Data* _data7_,
             PromotionTypeSelectorDialogSelectedType selected_type)
{
	ChessApplication* self;
#line 1206 "../src/gnome-chess.vala"
	self = _data7_->self;
#line 1207 "../src/gnome-chess.vala"
	switch (selected_type) {
#line 1207 "../src/gnome-chess.vala"
		case PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_QUEEN:
#line 6967 "gnome-chess.c"
		{
			PieceType _tmp0_;
#line 1210 "../src/gnome-chess.vala"
			_tmp0_ = PIECE_TYPE_QUEEN;
#line 1210 "../src/gnome-chess.vala"
			_data7_->handler (&_tmp0_, _data7_->handler_target);
#line 1211 "../src/gnome-chess.vala"
			break;
#line 6976 "gnome-chess.c"
		}
#line 1207 "../src/gnome-chess.vala"
		case PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_KNIGHT:
#line 6980 "gnome-chess.c"
		{
			PieceType _tmp1_;
#line 1213 "../src/gnome-chess.vala"
			_tmp1_ = PIECE_TYPE_KNIGHT;
#line 1213 "../src/gnome-chess.vala"
			_data7_->handler (&_tmp1_, _data7_->handler_target);
#line 1214 "../src/gnome-chess.vala"
			break;
#line 6989 "gnome-chess.c"
		}
#line 1207 "../src/gnome-chess.vala"
		case PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_ROOK:
#line 6993 "gnome-chess.c"
		{
			PieceType _tmp2_;
#line 1216 "../src/gnome-chess.vala"
			_tmp2_ = PIECE_TYPE_ROOK;
#line 1216 "../src/gnome-chess.vala"
			_data7_->handler (&_tmp2_, _data7_->handler_target);
#line 1217 "../src/gnome-chess.vala"
			break;
#line 7002 "gnome-chess.c"
		}
#line 1207 "../src/gnome-chess.vala"
		case PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_BISHOP:
#line 7006 "gnome-chess.c"
		{
			PieceType _tmp3_;
#line 1219 "../src/gnome-chess.vala"
			_tmp3_ = PIECE_TYPE_BISHOP;
#line 1219 "../src/gnome-chess.vala"
			_data7_->handler (&_tmp3_, _data7_->handler_target);
#line 1220 "../src/gnome-chess.vala"
			break;
#line 7015 "gnome-chess.c"
		}
		default:
		{
#line 1222 "../src/gnome-chess.vala"
			_data7_->handler (NULL, _data7_->handler_target);
#line 1223 "../src/gnome-chess.vala"
			break;
#line 7023 "gnome-chess.c"
		}
	}
#line 1226 "../src/gnome-chess.vala"
	adw_dialog_close ((AdwDialog*) _data7_->promotion_type_selector_dialog);
#line 1227 "../src/gnome-chess.vala"
	_g_object_unref0 (_data7_->promotion_type_selector_dialog);
#line 1227 "../src/gnome-chess.vala"
	_data7_->promotion_type_selector_dialog = NULL;
#line 7032 "gnome-chess.c"
}

static void
___lambda39__promotion_type_selector_dialog_piece_selected (PromotionTypeSelectorDialog* _sender,
                                                            PromotionTypeSelectorDialogSelectedType type,
                                                            gpointer self)
{
#line 1206 "../src/gnome-chess.vala"
	__lambda39_ (self, type);
#line 7042 "gnome-chess.c"
}

static void
chess_application_show_promotion_type_selector (ChessApplication* self,
                                                ChessScenePromotionTypeCompletionHandler handler,
                                                gpointer handler_target,
                                                GDestroyNotify handler_target_destroy_notify)
{
	Block7Data* _data7_;
	ChessGame* _tmp0_;
	ChessPlayer* _tmp1_;
	ChessPlayer* _tmp2_;
	ChessScene* _tmp3_;
	ChessScene* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	PromotionTypeSelectorDialog* _tmp7_;
	ChessWindow* _tmp8_;
#line 1200 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1200 "../src/gnome-chess.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 1200 "../src/gnome-chess.vala"
	_data7_->_ref_count_ = 1;
#line 1200 "../src/gnome-chess.vala"
	_data7_->self = g_object_ref (self);
#line 1200 "../src/gnome-chess.vala"
	(_data7_->handler_target_destroy_notify == NULL) ? NULL : (_data7_->handler_target_destroy_notify (_data7_->handler_target), NULL);
#line 1200 "../src/gnome-chess.vala"
	_data7_->handler = NULL;
#line 1200 "../src/gnome-chess.vala"
	_data7_->handler_target = NULL;
#line 1200 "../src/gnome-chess.vala"
	_data7_->handler_target_destroy_notify = NULL;
#line 1200 "../src/gnome-chess.vala"
	_data7_->handler = handler;
#line 1200 "../src/gnome-chess.vala"
	_data7_->handler_target = handler_target;
#line 1200 "../src/gnome-chess.vala"
	_data7_->handler_target_destroy_notify = handler_target_destroy_notify;
#line 1203 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1203 "../src/gnome-chess.vala"
	_tmp1_ = chess_game_get_current_player (_tmp0_);
#line 1203 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 1203 "../src/gnome-chess.vala"
	_tmp3_ = chess_application_get_scene (self);
#line 1203 "../src/gnome-chess.vala"
	_tmp4_ = _tmp3_;
#line 1203 "../src/gnome-chess.vala"
	_tmp5_ = chess_scene_get_theme_name (_tmp4_);
#line 1203 "../src/gnome-chess.vala"
	_tmp6_ = _tmp5_;
#line 1203 "../src/gnome-chess.vala"
	_tmp7_ = promotion_type_selector_dialog_new (_tmp2_->color, _tmp6_);
#line 1203 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp7_);
#line 1203 "../src/gnome-chess.vala"
	_data7_->promotion_type_selector_dialog = _tmp7_;
#line 1206 "../src/gnome-chess.vala"
	g_signal_connect_data (_data7_->promotion_type_selector_dialog, "piece-selected", (GCallback) ___lambda39__promotion_type_selector_dialog_piece_selected, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 1230 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->_window;
#line 1230 "../src/gnome-chess.vala"
	adw_dialog_present ((AdwDialog*) _data7_->promotion_type_selector_dialog, (GtkWidget*) _tmp8_);
#line 1200 "../src/gnome-chess.vala"
	block7_data_unref (_data7_);
#line 1200 "../src/gnome-chess.vala"
	_data7_ = NULL;
#line 7113 "gnome-chess.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 1233 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 1233 "../src/gnome-chess.vala"
	return _data8_;
#line 7123 "gnome-chess.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 1233 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 7133 "gnome-chess.c"
		ChessApplication* self;
#line 1233 "../src/gnome-chess.vala"
		self = _data8_->self;
#line 1233 "../src/gnome-chess.vala"
		_g_object_unref0 (_data8_->invalid_pgn_dialog);
#line 1233 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1233 "../src/gnome-chess.vala"
		g_slice_free (Block8Data, _data8_);
#line 7143 "gnome-chess.c"
	}
}

static void
__lambda36_ (Block8Data* _data8_,
             AdwAlertDialog* dialog,
             const gchar* response)
{
	ChessApplication* self;
#line 1238 "../src/gnome-chess.vala"
	self = _data8_->self;
#line 1238 "../src/gnome-chess.vala"
	g_return_if_fail (dialog != NULL);
#line 1238 "../src/gnome-chess.vala"
	g_return_if_fail (response != NULL);
#line 1238 "../src/gnome-chess.vala"
	g_signal_emit_by_name ((GtkWidget*) _data8_->invalid_pgn_dialog, "destroy");
#line 7161 "gnome-chess.c"
}

static void
___lambda36__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                        const gchar* response,
                                        gpointer self)
{
#line 1238 "../src/gnome-chess.vala"
	__lambda36_ (self, _sender, response);
#line 7171 "gnome-chess.c"
}

static void
chess_application_run_invalid_pgn_dialog (ChessApplication* self)
{
	Block8Data* _data8_;
	AdwAlertDialog* _tmp0_;
	ChessWindow* _tmp1_;
#line 1233 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1233 "../src/gnome-chess.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 1233 "../src/gnome-chess.vala"
	_data8_->_ref_count_ = 1;
#line 1233 "../src/gnome-chess.vala"
	_data8_->self = g_object_ref (self);
#line 1235 "../src/gnome-chess.vala"
	_tmp0_ = (AdwAlertDialog*) adw_alert_dialog_new (_ ("Error Loading PGN File"), _ ("This does not look like a valid PGN game."));
#line 1235 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp0_);
#line 1235 "../src/gnome-chess.vala"
	_data8_->invalid_pgn_dialog = _tmp0_;
#line 1237 "../src/gnome-chess.vala"
	adw_alert_dialog_add_response (_data8_->invalid_pgn_dialog, "okay", _ ("_OK"));
#line 1238 "../src/gnome-chess.vala"
	g_signal_connect_data (_data8_->invalid_pgn_dialog, "response", (GCallback) ___lambda36__adw_alert_dialog_response, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 1239 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->_window;
#line 1239 "../src/gnome-chess.vala"
	adw_dialog_present ((AdwDialog*) _data8_->invalid_pgn_dialog, (GtkWidget*) _tmp1_);
#line 1233 "../src/gnome-chess.vala"
	block8_data_unref (_data8_);
#line 1233 "../src/gnome-chess.vala"
	_data8_ = NULL;
#line 7206 "gnome-chess.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 1242 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 1242 "../src/gnome-chess.vala"
	return _data9_;
#line 7216 "gnome-chess.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 1242 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 7226 "gnome-chess.c"
		ChessApplication* self;
#line 1242 "../src/gnome-chess.vala"
		self = _data9_->self;
#line 1242 "../src/gnome-chess.vala"
		_g_object_unref0 (_data9_->invalid_move_dialog);
#line 1242 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1242 "../src/gnome-chess.vala"
		g_slice_free (Block9Data, _data9_);
#line 7236 "gnome-chess.c"
	}
}

static void
__lambda30_ (Block9Data* _data9_,
             AdwAlertDialog* dialog,
             const gchar* response)
{
	ChessApplication* self;
#line 1246 "../src/gnome-chess.vala"
	self = _data9_->self;
#line 1246 "../src/gnome-chess.vala"
	g_return_if_fail (dialog != NULL);
#line 1246 "../src/gnome-chess.vala"
	g_return_if_fail (response != NULL);
#line 1246 "../src/gnome-chess.vala"
	g_signal_emit_by_name ((GtkWidget*) _data9_->invalid_move_dialog, "destroy");
#line 7254 "gnome-chess.c"
}

static void
___lambda30__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                        const gchar* response,
                                        gpointer self)
{
#line 1246 "../src/gnome-chess.vala"
	__lambda30_ (self, _sender, response);
#line 7264 "gnome-chess.c"
}

static void
chess_application_show_invalid_move_dialog (ChessApplication* self,
                                            const gchar* error_message)
{
	Block9Data* _data9_;
	AdwAlertDialog* _tmp0_;
	ChessWindow* _tmp1_;
#line 1242 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1242 "../src/gnome-chess.vala"
	g_return_if_fail (error_message != NULL);
#line 1242 "../src/gnome-chess.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 1242 "../src/gnome-chess.vala"
	_data9_->_ref_count_ = 1;
#line 1242 "../src/gnome-chess.vala"
	_data9_->self = g_object_ref (self);
#line 1244 "../src/gnome-chess.vala"
	_tmp0_ = (AdwAlertDialog*) adw_alert_dialog_new (_ ("Invalid Move"), error_message);
#line 1244 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp0_);
#line 1244 "../src/gnome-chess.vala"
	_data9_->invalid_move_dialog = _tmp0_;
#line 1245 "../src/gnome-chess.vala"
	adw_alert_dialog_add_response (_data9_->invalid_move_dialog, "okay", _ ("_OK"));
#line 1246 "../src/gnome-chess.vala"
	g_signal_connect_data (_data9_->invalid_move_dialog, "response", (GCallback) ___lambda30__adw_alert_dialog_response, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 1247 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->_window;
#line 1247 "../src/gnome-chess.vala"
	adw_dialog_present ((AdwDialog*) _data9_->invalid_move_dialog, (GtkWidget*) _tmp1_);
#line 1242 "../src/gnome-chess.vala"
	block9_data_unref (_data9_);
#line 1242 "../src/gnome-chess.vala"
	_data9_ = NULL;
#line 7302 "gnome-chess.c"
}

static void
chess_application_update_pgn_time_remaining (ChessApplication* self)
{
	ChessGame* _tmp0_;
	ChessClock* _tmp1_;
	ChessClock* _tmp2_;
#line 1250 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1252 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1252 "../src/gnome-chess.vala"
	_tmp1_ = chess_game_get_clock (_tmp0_);
#line 1252 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 1252 "../src/gnome-chess.vala"
	if (_tmp2_ != NULL) {
#line 7321 "gnome-chess.c"
		PGNGame* _tmp3_;
		ChessGame* _tmp4_;
		ChessClock* _tmp5_;
		ChessClock* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		PGNGame* _tmp11_;
		ChessGame* _tmp12_;
		ChessClock* _tmp13_;
		ChessClock* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 1255 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->pgn_game;
#line 1255 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->game;
#line 1255 "../src/gnome-chess.vala"
		_tmp5_ = chess_game_get_clock (_tmp4_);
#line 1255 "../src/gnome-chess.vala"
		_tmp6_ = _tmp5_;
#line 1255 "../src/gnome-chess.vala"
		_tmp7_ = chess_clock_get_white_remaining_seconds (_tmp6_);
#line 1255 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_;
#line 1255 "../src/gnome-chess.vala"
		_tmp9_ = g_strdup_printf ("%i", _tmp8_);
#line 1255 "../src/gnome-chess.vala"
		_tmp10_ = _tmp9_;
#line 1255 "../src/gnome-chess.vala"
		pgn_game_set_white_time_left (_tmp3_, _tmp10_);
#line 1255 "../src/gnome-chess.vala"
		_g_free0 (_tmp10_);
#line 1256 "../src/gnome-chess.vala"
		_tmp11_ = self->priv->pgn_game;
#line 1256 "../src/gnome-chess.vala"
		_tmp12_ = self->priv->game;
#line 1256 "../src/gnome-chess.vala"
		_tmp13_ = chess_game_get_clock (_tmp12_);
#line 1256 "../src/gnome-chess.vala"
		_tmp14_ = _tmp13_;
#line 1256 "../src/gnome-chess.vala"
		_tmp15_ = chess_clock_get_black_remaining_seconds (_tmp14_);
#line 1256 "../src/gnome-chess.vala"
		_tmp16_ = _tmp15_;
#line 1256 "../src/gnome-chess.vala"
		_tmp17_ = g_strdup_printf ("%i", _tmp16_);
#line 1256 "../src/gnome-chess.vala"
		_tmp18_ = _tmp17_;
#line 1256 "../src/gnome-chess.vala"
		pgn_game_set_black_time_left (_tmp11_, _tmp18_);
#line 1256 "../src/gnome-chess.vala"
		_g_free0 (_tmp18_);
#line 7378 "gnome-chess.c"
	}
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 1262 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 1262 "../src/gnome-chess.vala"
	return _data10_;
#line 7389 "gnome-chess.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 1262 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 7399 "gnome-chess.c"
		ChessApplication* self;
#line 1262 "../src/gnome-chess.vala"
		self = _data10_->self;
#line 1262 "../src/gnome-chess.vala"
		(_data10_->callback_target_destroy_notify == NULL) ? NULL : (_data10_->callback_target_destroy_notify (_data10_->callback_target), NULL);
#line 1262 "../src/gnome-chess.vala"
		_data10_->callback = NULL;
#line 1262 "../src/gnome-chess.vala"
		_data10_->callback_target = NULL;
#line 1262 "../src/gnome-chess.vala"
		_data10_->callback_target_destroy_notify = NULL;
#line 1262 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1262 "../src/gnome-chess.vala"
		g_slice_free (Block10Data, _data10_);
#line 7415 "gnome-chess.c"
	}
}

static void
___lambda23_ (Block10Data* _data10_,
              AdwAlertDialog* dialog,
              const gchar* response)
{
	ChessApplication* self;
#line 1338 "../src/gnome-chess.vala"
	self = _data10_->self;
#line 1338 "../src/gnome-chess.vala"
	g_return_if_fail (dialog != NULL);
#line 1338 "../src/gnome-chess.vala"
	g_return_if_fail (response != NULL);
#line 1339 "../src/gnome-chess.vala"
	if (_data10_->callback != NULL) {
#line 1340 "../src/gnome-chess.vala"
		_data10_->callback (FALSE, _data10_->callback_target);
#line 7435 "gnome-chess.c"
	}
}

static void
____lambda23__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                         const gchar* response,
                                         gpointer self)
{
#line 1338 "../src/gnome-chess.vala"
	___lambda23_ (self, _sender, response);
#line 7446 "gnome-chess.c"
}

static void
__lambda22_ (Block10Data* _data10_,
             GObject* object,
             GAsyncResult* _result_)
{
	ChessApplication* self;
	GError* _inner_error0_ = NULL;
#line 1312 "../src/gnome-chess.vala"
	self = _data10_->self;
#line 1312 "../src/gnome-chess.vala"
	g_return_if_fail (_result_ != NULL);
#line 1313 "../src/gnome-chess.vala"
	chess_application_update_pgn_time_remaining (self);
#line 7462 "gnome-chess.c"
	{
		GFile* _tmp0_ = NULL;
		GtkFileDialog* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		PGNGame* _tmp4_;
		GFile* _tmp5_;
#line 1317 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->save_dialog;
#line 1317 "../src/gnome-chess.vala"
		_tmp2_ = gtk_file_dialog_save_finish (_tmp1_, _result_, &_inner_error0_);
#line 1317 "../src/gnome-chess.vala"
		_tmp0_ = _tmp2_;
#line 1317 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7478 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 1317 "../src/gnome-chess.vala"
		_tmp3_ = _tmp0_;
#line 1317 "../src/gnome-chess.vala"
		_tmp0_ = NULL;
#line 1317 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->game_file);
#line 1317 "../src/gnome-chess.vala"
		self->priv->game_file = _tmp3_;
#line 1318 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->pgn_game;
#line 1318 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->game_file;
#line 1318 "../src/gnome-chess.vala"
		pgn_game_write (_tmp4_, _tmp5_, &_inner_error0_);
#line 1318 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1318 "../src/gnome-chess.vala"
			_g_object_unref0 (_tmp0_);
#line 7499 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 1320 "../src/gnome-chess.vala"
		chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 1321 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = FALSE;
#line 1323 "../src/gnome-chess.vala"
		if (_data10_->callback != NULL) {
#line 1324 "../src/gnome-chess.vala"
			_data10_->callback (TRUE, _data10_->callback_target);
#line 7510 "gnome-chess.c"
		}
#line 1315 "../src/gnome-chess.vala"
		_g_object_unref0 (_tmp0_);
#line 7514 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		AdwAlertDialog* save_error_dialog = NULL;
		AdwAlertDialog* _tmp7_;
		AdwAlertDialog* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		AdwAlertDialog* _tmp11_;
		AdwAlertDialog* _tmp12_;
		AdwAlertDialog* _tmp13_;
		ChessWindow* _tmp14_;
#line 1315 "../src/gnome-chess.vala"
		e = _inner_error0_;
#line 1315 "../src/gnome-chess.vala"
		_inner_error0_ = NULL;
#line 1328 "../src/gnome-chess.vala"
		_tmp6_ = e;
#line 1328 "../src/gnome-chess.vala"
		if (g_error_matches (_tmp6_, gtk_dialog_error_quark (), GTK_DIALOG_ERROR_DISMISSED)) {
#line 1330 "../src/gnome-chess.vala"
			if (_data10_->callback != NULL) {
#line 1331 "../src/gnome-chess.vala"
				_data10_->callback (FALSE, _data10_->callback_target);
#line 7542 "gnome-chess.c"
			}
#line 1332 "../src/gnome-chess.vala"
			_g_error_free0 (e);
#line 1332 "../src/gnome-chess.vala"
			return;
#line 7548 "gnome-chess.c"
		}
#line 1335 "../src/gnome-chess.vala"
		_tmp7_ = (AdwAlertDialog*) adw_alert_dialog_new (_ ("Save Error"), "");
#line 1335 "../src/gnome-chess.vala"
		g_object_ref_sink (_tmp7_);
#line 1335 "../src/gnome-chess.vala"
		save_error_dialog = _tmp7_;
#line 1336 "../src/gnome-chess.vala"
		_tmp8_ = save_error_dialog;
#line 1336 "../src/gnome-chess.vala"
		_tmp9_ = e;
#line 1336 "../src/gnome-chess.vala"
		_tmp10_ = _tmp9_->message;
#line 1336 "../src/gnome-chess.vala"
		adw_alert_dialog_format_body (_tmp8_, _ ("Failed to save game: %s"), _tmp10_);
#line 1337 "../src/gnome-chess.vala"
		_tmp11_ = save_error_dialog;
#line 1337 "../src/gnome-chess.vala"
		adw_alert_dialog_add_response (_tmp11_, "ok", _ ("_OK"));
#line 1338 "../src/gnome-chess.vala"
		_tmp12_ = save_error_dialog;
#line 1338 "../src/gnome-chess.vala"
		g_signal_connect_data (_tmp12_, "response", (GCallback) ____lambda23__adw_alert_dialog_response, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 1342 "../src/gnome-chess.vala"
		_tmp13_ = save_error_dialog;
#line 1342 "../src/gnome-chess.vala"
		_tmp14_ = self->priv->_window;
#line 1342 "../src/gnome-chess.vala"
		adw_dialog_present ((AdwDialog*) _tmp13_, (GtkWidget*) _tmp14_);
#line 1315 "../src/gnome-chess.vala"
		_g_object_unref0 (save_error_dialog);
#line 1315 "../src/gnome-chess.vala"
		_g_error_free0 (e);
#line 7582 "gnome-chess.c"
	}
	__finally0:
#line 1315 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1315 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1315 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1315 "../src/gnome-chess.vala"
		return;
#line 7593 "gnome-chess.c"
	}
}

static void
___lambda22__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 1312 "../src/gnome-chess.vala"
	__lambda22_ (self, source_object, res);
#line 1312 "../src/gnome-chess.vala"
	block10_data_unref (self);
#line 7606 "gnome-chess.c"
}

static void
chess_application_present_save_dialog (ChessApplication* self,
                                       ChessApplicationPresentSaveDialogCallback callback,
                                       gpointer callback_target,
                                       GDestroyNotify callback_target_destroy_notify)
{
	Block10Data* _data10_;
	GtkFileDialog* _tmp0_;
	GtkFileDialog* _tmp28_;
	ChessWindow* _tmp29_;
#line 1262 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1262 "../src/gnome-chess.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 1262 "../src/gnome-chess.vala"
	_data10_->_ref_count_ = 1;
#line 1262 "../src/gnome-chess.vala"
	_data10_->self = g_object_ref (self);
#line 1262 "../src/gnome-chess.vala"
	(_data10_->callback_target_destroy_notify == NULL) ? NULL : (_data10_->callback_target_destroy_notify (_data10_->callback_target), NULL);
#line 1262 "../src/gnome-chess.vala"
	_data10_->callback = NULL;
#line 1262 "../src/gnome-chess.vala"
	_data10_->callback_target = NULL;
#line 1262 "../src/gnome-chess.vala"
	_data10_->callback_target_destroy_notify = NULL;
#line 1262 "../src/gnome-chess.vala"
	_data10_->callback = callback;
#line 1262 "../src/gnome-chess.vala"
	_data10_->callback_target = callback_target;
#line 1262 "../src/gnome-chess.vala"
	_data10_->callback_target_destroy_notify = callback_target_destroy_notify;
#line 1264 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->save_dialog;
#line 1264 "../src/gnome-chess.vala"
	if (_tmp0_ == NULL) {
#line 7645 "gnome-chess.c"
		GtkFileDialog* _tmp1_;
		GtkFileDialog* _tmp2_;
		gboolean set_file = FALSE;
		GFile* _tmp3_;
		GtkFileFilter* pgn_filter = NULL;
		GtkFileFilter* _tmp15_;
		GtkFileFilter* _tmp16_;
		GtkFileFilter* _tmp17_;
		GtkFileFilter* all_filter = NULL;
		GtkFileFilter* _tmp18_;
		GtkFileFilter* _tmp19_;
		GtkFileFilter* _tmp20_;
		GListStore* filters = NULL;
		GListStore* _tmp21_;
		GListStore* _tmp22_;
		GtkFileFilter* _tmp23_;
		GListStore* _tmp24_;
		GtkFileFilter* _tmp25_;
		GtkFileDialog* _tmp26_;
		GListStore* _tmp27_;
#line 1266 "../src/gnome-chess.vala"
		_tmp1_ = gtk_file_dialog_new ();
#line 1266 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->save_dialog);
#line 1266 "../src/gnome-chess.vala"
		self->priv->save_dialog = _tmp1_;
#line 1268 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->save_dialog;
#line 1268 "../src/gnome-chess.vala"
		gtk_file_dialog_set_title (_tmp2_, _ ("Save Chess Game"));
#line 1270 "../src/gnome-chess.vala"
		set_file = FALSE;
#line 1271 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->game_file;
#line 1271 "../src/gnome-chess.vala"
		if (_tmp3_ != NULL) {
#line 7682 "gnome-chess.c"
			gchar* path = NULL;
			GFile* _tmp4_;
			gchar* _tmp5_;
			gboolean _tmp6_ = FALSE;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
#line 1281 "../src/gnome-chess.vala"
			_tmp4_ = self->priv->game_file;
#line 1281 "../src/gnome-chess.vala"
			_tmp5_ = g_file_get_path (_tmp4_);
#line 1281 "../src/gnome-chess.vala"
			path = _tmp5_;
#line 1282 "../src/gnome-chess.vala"
			_tmp7_ = path;
#line 1282 "../src/gnome-chess.vala"
			_tmp8_ = self->priv->autosave_filename;
#line 1282 "../src/gnome-chess.vala"
			if (g_strcmp0 (_tmp7_, _tmp8_) != 0) {
#line 7701 "gnome-chess.c"
				const gchar* _tmp9_;
#line 1282 "../src/gnome-chess.vala"
				_tmp9_ = path;
#line 1282 "../src/gnome-chess.vala"
				_tmp6_ = !g_str_has_prefix (_tmp9_, "/run");
#line 7707 "gnome-chess.c"
			} else {
#line 1282 "../src/gnome-chess.vala"
				_tmp6_ = FALSE;
#line 7711 "gnome-chess.c"
			}
#line 1282 "../src/gnome-chess.vala"
			if (_tmp6_) {
#line 7715 "gnome-chess.c"
				GtkFileDialog* _tmp10_;
				GFile* _tmp11_;
#line 1284 "../src/gnome-chess.vala"
				_tmp10_ = self->priv->save_dialog;
#line 1284 "../src/gnome-chess.vala"
				_tmp11_ = self->priv->game_file;
#line 1284 "../src/gnome-chess.vala"
				gtk_file_dialog_set_initial_file (_tmp10_, _tmp11_);
#line 1285 "../src/gnome-chess.vala"
				set_file = TRUE;
#line 7726 "gnome-chess.c"
			}
#line 1271 "../src/gnome-chess.vala"
			_g_free0 (path);
#line 7730 "gnome-chess.c"
		}
#line 1289 "../src/gnome-chess.vala"
		if (!set_file) {
#line 7734 "gnome-chess.c"
			GtkFileDialog* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 1291 "../src/gnome-chess.vala"
			_tmp12_ = self->priv->save_dialog;
#line 1291 "../src/gnome-chess.vala"
			_tmp13_ = g_strconcat (_ ("Untitled Chess Game"), ".pgn", NULL);
#line 1291 "../src/gnome-chess.vala"
			_tmp14_ = _tmp13_;
#line 1291 "../src/gnome-chess.vala"
			gtk_file_dialog_set_initial_name (_tmp12_, _tmp14_);
#line 1291 "../src/gnome-chess.vala"
			_g_free0 (_tmp14_);
#line 7748 "gnome-chess.c"
		}
#line 1296 "../src/gnome-chess.vala"
		_tmp15_ = gtk_file_filter_new ();
#line 1296 "../src/gnome-chess.vala"
		pgn_filter = _tmp15_;
#line 1298 "../src/gnome-chess.vala"
		_tmp16_ = pgn_filter;
#line 1298 "../src/gnome-chess.vala"
		gtk_file_filter_set_name (_tmp16_, _ ("PGN files"));
#line 1299 "../src/gnome-chess.vala"
		_tmp17_ = pgn_filter;
#line 1299 "../src/gnome-chess.vala"
		gtk_file_filter_add_pattern (_tmp17_, "*.pgn");
#line 1301 "../src/gnome-chess.vala"
		_tmp18_ = gtk_file_filter_new ();
#line 1301 "../src/gnome-chess.vala"
		all_filter = _tmp18_;
#line 1303 "../src/gnome-chess.vala"
		_tmp19_ = all_filter;
#line 1303 "../src/gnome-chess.vala"
		gtk_file_filter_set_name (_tmp19_, _ ("All files"));
#line 1304 "../src/gnome-chess.vala"
		_tmp20_ = all_filter;
#line 1304 "../src/gnome-chess.vala"
		gtk_file_filter_add_pattern (_tmp20_, "*");
#line 1306 "../src/gnome-chess.vala"
		_tmp21_ = g_list_store_new (gtk_file_filter_get_type ());
#line 1306 "../src/gnome-chess.vala"
		filters = _tmp21_;
#line 1307 "../src/gnome-chess.vala"
		_tmp22_ = filters;
#line 1307 "../src/gnome-chess.vala"
		_tmp23_ = pgn_filter;
#line 1307 "../src/gnome-chess.vala"
		g_list_store_append (_tmp22_, (GObject*) _tmp23_);
#line 1308 "../src/gnome-chess.vala"
		_tmp24_ = filters;
#line 1308 "../src/gnome-chess.vala"
		_tmp25_ = all_filter;
#line 1308 "../src/gnome-chess.vala"
		g_list_store_append (_tmp24_, (GObject*) _tmp25_);
#line 1309 "../src/gnome-chess.vala"
		_tmp26_ = self->priv->save_dialog;
#line 1309 "../src/gnome-chess.vala"
		_tmp27_ = filters;
#line 1309 "../src/gnome-chess.vala"
		gtk_file_dialog_set_filters (_tmp26_, (GListModel*) _tmp27_);
#line 1264 "../src/gnome-chess.vala"
		_g_object_unref0 (filters);
#line 1264 "../src/gnome-chess.vala"
		_g_object_unref0 (all_filter);
#line 1264 "../src/gnome-chess.vala"
		_g_object_unref0 (pgn_filter);
#line 7802 "gnome-chess.c"
	}
#line 1312 "../src/gnome-chess.vala"
	_tmp28_ = self->priv->save_dialog;
#line 1312 "../src/gnome-chess.vala"
	_tmp29_ = self->priv->_window;
#line 1312 "../src/gnome-chess.vala"
	gtk_file_dialog_save (_tmp28_, (GtkWindow*) _tmp29_, NULL, ___lambda22__gasync_ready_callback, block10_data_ref (_data10_));
#line 1262 "../src/gnome-chess.vala"
	block10_data_unref (_data10_);
#line 1262 "../src/gnome-chess.vala"
	_data10_ = NULL;
#line 7814 "gnome-chess.c"
}

void
chess_application_save_game_cb (ChessApplication* self)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1347 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1349 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game_file;
#line 1349 "../src/gnome-chess.vala"
	if (_tmp1_ == NULL) {
#line 1349 "../src/gnome-chess.vala"
		_tmp0_ = TRUE;
#line 7831 "gnome-chess.c"
	} else {
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 1349 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->game_file;
#line 1349 "../src/gnome-chess.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 1349 "../src/gnome-chess.vala"
		_tmp4_ = _tmp3_;
#line 1349 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->autosave_filename;
#line 1349 "../src/gnome-chess.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, _tmp5_) == 0;
#line 1349 "../src/gnome-chess.vala"
		_g_free0 (_tmp4_);
#line 7849 "gnome-chess.c"
	}
#line 1349 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 1351 "../src/gnome-chess.vala"
		chess_application_present_save_dialog (self, NULL, NULL, NULL);
#line 1352 "../src/gnome-chess.vala"
		return;
#line 7857 "gnome-chess.c"
	}
#line 1355 "../src/gnome-chess.vala"
	chess_application_update_pgn_time_remaining (self);
#line 7861 "gnome-chess.c"
	{
		PGNGame* _tmp6_;
		GFile* _tmp7_;
#line 1359 "../src/gnome-chess.vala"
		_tmp6_ = self->priv->pgn_game;
#line 1359 "../src/gnome-chess.vala"
		_tmp7_ = self->priv->game_file;
#line 1359 "../src/gnome-chess.vala"
		pgn_game_write (_tmp6_, _tmp7_, &_inner_error0_);
#line 1359 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7873 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 1360 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = FALSE;
#line 1361 "../src/gnome-chess.vala"
		chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 7880 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1357 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1365 "../src/gnome-chess.vala"
		chess_application_present_save_dialog (self, NULL, NULL, NULL);
#line 7889 "gnome-chess.c"
	}
	__finally0:
#line 1357 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1357 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1357 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1357 "../src/gnome-chess.vala"
		return;
#line 7900 "gnome-chess.c"
	}
}

void
chess_application_save_game_as_cb (ChessApplication* self)
{
#line 1369 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1371 "../src/gnome-chess.vala"
	chess_application_present_save_dialog (self, NULL, NULL, NULL);
#line 7911 "gnome-chess.c"
}

static void
__lambda35_ (ChessApplication* self,
             GObject* object,
             GAsyncResult* _result_)
{
	GError* _inner_error0_ = NULL;
#line 1404 "../src/gnome-chess.vala"
	g_return_if_fail (_result_ != NULL);
#line 7922 "gnome-chess.c"
	{
		GFile* _tmp0_ = NULL;
		GtkFileDialog* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 1407 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->open_dialog;
#line 1407 "../src/gnome-chess.vala"
		_tmp2_ = gtk_file_dialog_open_finish (_tmp1_, _result_, &_inner_error0_);
#line 1407 "../src/gnome-chess.vala"
		_tmp0_ = _tmp2_;
#line 1407 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7937 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 1407 "../src/gnome-chess.vala"
		_tmp3_ = _tmp0_;
#line 1407 "../src/gnome-chess.vala"
		_tmp0_ = NULL;
#line 1407 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->game_file);
#line 1407 "../src/gnome-chess.vala"
		self->priv->game_file = _tmp3_;
#line 1408 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->game_file;
#line 1408 "../src/gnome-chess.vala"
		chess_application_load_game (self, _tmp4_);
#line 1405 "../src/gnome-chess.vala"
		_g_object_unref0 (_tmp0_);
#line 7954 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
#line 1405 "../src/gnome-chess.vala"
		e = _inner_error0_;
#line 1405 "../src/gnome-chess.vala"
		_inner_error0_ = NULL;
#line 1412 "../src/gnome-chess.vala"
		_tmp5_ = e;
#line 1412 "../src/gnome-chess.vala"
		if (!g_error_matches (_tmp5_, gtk_dialog_error_quark (), GTK_DIALOG_ERROR_DISMISSED)) {
#line 7969 "gnome-chess.c"
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 1413 "../src/gnome-chess.vala"
			_tmp6_ = e;
#line 1413 "../src/gnome-chess.vala"
			_tmp7_ = _tmp6_->message;
#line 1413 "../src/gnome-chess.vala"
			g_warning ("gnome-chess.vala:1413: Failed to open game: %s", _tmp7_);
#line 7978 "gnome-chess.c"
		}
#line 1405 "../src/gnome-chess.vala"
		_g_error_free0 (e);
#line 7982 "gnome-chess.c"
	}
	__finally0:
#line 1405 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1405 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1405 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1405 "../src/gnome-chess.vala"
		return;
#line 7993 "gnome-chess.c"
	}
}

static void
___lambda35__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 1404 "../src/gnome-chess.vala"
	__lambda35_ ((ChessApplication*) self, source_object, res);
#line 1404 "../src/gnome-chess.vala"
	g_object_unref (self);
#line 8006 "gnome-chess.c"
}

static void
__lambda34_ (ChessApplication* self,
             gboolean cancelled)
{
	GtkFileDialog* _tmp0_;
	GtkFileDialog* _tmp17_;
	ChessWindow* _tmp18_;
#line 1377 "../src/gnome-chess.vala"
	if (cancelled) {
#line 1378 "../src/gnome-chess.vala"
		return;
#line 8020 "gnome-chess.c"
	}
#line 1380 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->open_dialog;
#line 1380 "../src/gnome-chess.vala"
	if (_tmp0_ == NULL) {
#line 8026 "gnome-chess.c"
		GtkFileDialog* _tmp1_;
		GtkFileDialog* _tmp2_;
		GtkFileDialog* _tmp3_;
		GtkFileFilter* pgn_filter = NULL;
		GtkFileFilter* _tmp4_;
		GtkFileFilter* _tmp5_;
		GtkFileFilter* _tmp6_;
		GtkFileFilter* all_filter = NULL;
		GtkFileFilter* _tmp7_;
		GtkFileFilter* _tmp8_;
		GtkFileFilter* _tmp9_;
		GListStore* filters = NULL;
		GListStore* _tmp10_;
		GListStore* _tmp11_;
		GtkFileFilter* _tmp12_;
		GListStore* _tmp13_;
		GtkFileFilter* _tmp14_;
		GtkFileDialog* _tmp15_;
		GListStore* _tmp16_;
#line 1382 "../src/gnome-chess.vala"
		_tmp1_ = gtk_file_dialog_new ();
#line 1382 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->open_dialog);
#line 1382 "../src/gnome-chess.vala"
		self->priv->open_dialog = _tmp1_;
#line 1384 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->open_dialog;
#line 1384 "../src/gnome-chess.vala"
		gtk_file_dialog_set_title (_tmp2_, _ ("Load Chess Game"));
#line 1385 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->open_dialog;
#line 1385 "../src/gnome-chess.vala"
		gtk_file_dialog_set_modal (_tmp3_, TRUE);
#line 1388 "../src/gnome-chess.vala"
		_tmp4_ = gtk_file_filter_new ();
#line 1388 "../src/gnome-chess.vala"
		pgn_filter = _tmp4_;
#line 1390 "../src/gnome-chess.vala"
		_tmp5_ = pgn_filter;
#line 1390 "../src/gnome-chess.vala"
		gtk_file_filter_set_name (_tmp5_, _ ("PGN files"));
#line 1391 "../src/gnome-chess.vala"
		_tmp6_ = pgn_filter;
#line 1391 "../src/gnome-chess.vala"
		gtk_file_filter_add_pattern (_tmp6_, "*.pgn");
#line 1393 "../src/gnome-chess.vala"
		_tmp7_ = gtk_file_filter_new ();
#line 1393 "../src/gnome-chess.vala"
		all_filter = _tmp7_;
#line 1395 "../src/gnome-chess.vala"
		_tmp8_ = all_filter;
#line 1395 "../src/gnome-chess.vala"
		gtk_file_filter_set_name (_tmp8_, _ ("All files"));
#line 1396 "../src/gnome-chess.vala"
		_tmp9_ = all_filter;
#line 1396 "../src/gnome-chess.vala"
		gtk_file_filter_add_pattern (_tmp9_, "*");
#line 1398 "../src/gnome-chess.vala"
		_tmp10_ = g_list_store_new (gtk_file_filter_get_type ());
#line 1398 "../src/gnome-chess.vala"
		filters = _tmp10_;
#line 1399 "../src/gnome-chess.vala"
		_tmp11_ = filters;
#line 1399 "../src/gnome-chess.vala"
		_tmp12_ = pgn_filter;
#line 1399 "../src/gnome-chess.vala"
		g_list_store_append (_tmp11_, (GObject*) _tmp12_);
#line 1400 "../src/gnome-chess.vala"
		_tmp13_ = filters;
#line 1400 "../src/gnome-chess.vala"
		_tmp14_ = all_filter;
#line 1400 "../src/gnome-chess.vala"
		g_list_store_append (_tmp13_, (GObject*) _tmp14_);
#line 1401 "../src/gnome-chess.vala"
		_tmp15_ = self->priv->open_dialog;
#line 1401 "../src/gnome-chess.vala"
		_tmp16_ = filters;
#line 1401 "../src/gnome-chess.vala"
		gtk_file_dialog_set_filters (_tmp15_, (GListModel*) _tmp16_);
#line 1380 "../src/gnome-chess.vala"
		_g_object_unref0 (filters);
#line 1380 "../src/gnome-chess.vala"
		_g_object_unref0 (all_filter);
#line 1380 "../src/gnome-chess.vala"
		_g_object_unref0 (pgn_filter);
#line 8112 "gnome-chess.c"
	}
#line 1404 "../src/gnome-chess.vala"
	_tmp17_ = self->priv->open_dialog;
#line 1404 "../src/gnome-chess.vala"
	_tmp18_ = self->priv->_window;
#line 1404 "../src/gnome-chess.vala"
	gtk_file_dialog_open (_tmp17_, (GtkWindow*) _tmp18_, NULL, ___lambda35__gasync_ready_callback, g_object_ref (self));
#line 8120 "gnome-chess.c"
}

static void
___lambda34__chess_application_prompt_save_game_callback (gboolean cancelled,
                                                          gpointer self)
{
#line 1376 "../src/gnome-chess.vala"
	__lambda34_ ((ChessApplication*) self, cancelled);
#line 8129 "gnome-chess.c"
}

void
chess_application_open_game_cb (ChessApplication* self)
{
#line 1374 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1376 "../src/gnome-chess.vala"
	chess_application_prompt_save_game (self, _ ("Save this game before loading another one?"), ___lambda34__chess_application_prompt_save_game_callback, self);
#line 8139 "gnome-chess.c"
}

static void
chess_application_start_new_game (ChessApplication* self)
{
	PGNGame* _tmp0_;
	GDateTime* now = NULL;
	GDateTime* _tmp1_;
	PGNGame* _tmp2_;
	GDateTime* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	PGNGame* _tmp6_;
	GDateTime* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gint duration = 0;
	GSettings* _tmp10_;
	gchar* engine_name = NULL;
	GSettings* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* engine_level = NULL;
	GSettings* _tmp30_;
	gchar* _tmp31_;
	gboolean _tmp32_ = FALSE;
	const gchar* _tmp33_;
#line 1419 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1421 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->game_file);
#line 1421 "../src/gnome-chess.vala"
	self->priv->game_file = NULL;
#line 1423 "../src/gnome-chess.vala"
	chess_application_disable_action (self, SAVE_GAME_AS_ACTION_NAME);
#line 1425 "../src/gnome-chess.vala"
	_tmp0_ = pgn_game_new ();
#line 1425 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->pgn_game);
#line 1425 "../src/gnome-chess.vala"
	self->priv->pgn_game = _tmp0_;
#line 1426 "../src/gnome-chess.vala"
	_tmp1_ = g_date_time_new_now_local ();
#line 1426 "../src/gnome-chess.vala"
	now = _tmp1_;
#line 1427 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->pgn_game;
#line 1427 "../src/gnome-chess.vala"
	_tmp3_ = now;
#line 1427 "../src/gnome-chess.vala"
	_tmp4_ = g_date_time_format (_tmp3_, "%Y.%m.%d");
#line 1427 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 1427 "../src/gnome-chess.vala"
	pgn_game_set_date (_tmp2_, _tmp5_);
#line 1427 "../src/gnome-chess.vala"
	_g_free0 (_tmp5_);
#line 1428 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->pgn_game;
#line 1428 "../src/gnome-chess.vala"
	_tmp7_ = now;
#line 1428 "../src/gnome-chess.vala"
	_tmp8_ = g_date_time_format (_tmp7_, "%H:%M:%S");
#line 1428 "../src/gnome-chess.vala"
	_tmp9_ = _tmp8_;
#line 1428 "../src/gnome-chess.vala"
	pgn_game_set_time (_tmp6_, _tmp9_);
#line 1428 "../src/gnome-chess.vala"
	_g_free0 (_tmp9_);
#line 1429 "../src/gnome-chess.vala"
	_tmp10_ = self->priv->settings;
#line 1429 "../src/gnome-chess.vala"
	duration = g_settings_get_int (_tmp10_, DURATION_SETTINGS_KEY);
#line 1430 "../src/gnome-chess.vala"
	if (duration > 0) {
#line 8215 "gnome-chess.c"
		PGNGame* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		PGNGame* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		PGNGame* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 1432 "../src/gnome-chess.vala"
		_tmp11_ = self->priv->pgn_game;
#line 1432 "../src/gnome-chess.vala"
		_tmp12_ = g_strdup_printf ("%i", duration);
#line 1432 "../src/gnome-chess.vala"
		_tmp13_ = _tmp12_;
#line 1432 "../src/gnome-chess.vala"
		pgn_game_set_time_control (_tmp11_, _tmp13_);
#line 1432 "../src/gnome-chess.vala"
		_g_free0 (_tmp13_);
#line 1433 "../src/gnome-chess.vala"
		_tmp14_ = self->priv->pgn_game;
#line 1433 "../src/gnome-chess.vala"
		_tmp15_ = g_strdup_printf ("%i", duration);
#line 1433 "../src/gnome-chess.vala"
		_tmp16_ = _tmp15_;
#line 1433 "../src/gnome-chess.vala"
		pgn_game_set_white_time_left (_tmp14_, _tmp16_);
#line 1433 "../src/gnome-chess.vala"
		_g_free0 (_tmp16_);
#line 1434 "../src/gnome-chess.vala"
		_tmp17_ = self->priv->pgn_game;
#line 1434 "../src/gnome-chess.vala"
		_tmp18_ = g_strdup_printf ("%i", duration);
#line 1434 "../src/gnome-chess.vala"
		_tmp19_ = _tmp18_;
#line 1434 "../src/gnome-chess.vala"
		pgn_game_set_black_time_left (_tmp17_, _tmp19_);
#line 1434 "../src/gnome-chess.vala"
		_g_free0 (_tmp19_);
#line 8255 "gnome-chess.c"
	}
#line 1436 "../src/gnome-chess.vala"
	_tmp20_ = self->priv->settings;
#line 1436 "../src/gnome-chess.vala"
	_tmp21_ = g_settings_get_string (_tmp20_, OPPONENT_SETTINGS_KEY);
#line 1436 "../src/gnome-chess.vala"
	engine_name = _tmp21_;
#line 1437 "../src/gnome-chess.vala"
	_tmp22_ = engine_name;
#line 1437 "../src/gnome-chess.vala"
	if (g_strcmp0 (_tmp22_, "") == 0) {
#line 8267 "gnome-chess.c"
		GList* _tmp23_;
#line 1439 "../src/gnome-chess.vala"
		_tmp23_ = self->priv->ai_profiles;
#line 1439 "../src/gnome-chess.vala"
		if (_tmp23_ != NULL) {
#line 8273 "gnome-chess.c"
			GList* _tmp24_;
			gconstpointer _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
#line 1440 "../src/gnome-chess.vala"
			_tmp24_ = self->priv->ai_profiles;
#line 1440 "../src/gnome-chess.vala"
			_tmp25_ = _tmp24_->data;
#line 1440 "../src/gnome-chess.vala"
			_tmp26_ = ai_profile_get_name ((AIProfile*) _tmp25_);
#line 1440 "../src/gnome-chess.vala"
			_tmp27_ = _tmp26_;
#line 1440 "../src/gnome-chess.vala"
			_tmp28_ = g_strdup (_tmp27_);
#line 1440 "../src/gnome-chess.vala"
			_g_free0 (engine_name);
#line 1440 "../src/gnome-chess.vala"
			engine_name = _tmp28_;
#line 8293 "gnome-chess.c"
		} else {
			gchar* _tmp29_;
#line 1442 "../src/gnome-chess.vala"
			_tmp29_ = g_strdup ("human");
#line 1442 "../src/gnome-chess.vala"
			_g_free0 (engine_name);
#line 1442 "../src/gnome-chess.vala"
			engine_name = _tmp29_;
#line 8302 "gnome-chess.c"
		}
	}
#line 1444 "../src/gnome-chess.vala"
	_tmp30_ = self->priv->settings;
#line 1444 "../src/gnome-chess.vala"
	_tmp31_ = g_settings_get_string (_tmp30_, DIFFICULTY_SETTINGS_KEY);
#line 1444 "../src/gnome-chess.vala"
	engine_level = _tmp31_;
#line 1445 "../src/gnome-chess.vala"
	_tmp33_ = engine_name;
#line 1445 "../src/gnome-chess.vala"
	if (_tmp33_ != NULL) {
#line 8315 "gnome-chess.c"
		const gchar* _tmp34_;
#line 1445 "../src/gnome-chess.vala"
		_tmp34_ = engine_name;
#line 1445 "../src/gnome-chess.vala"
		_tmp32_ = g_strcmp0 (_tmp34_, "human") != 0;
#line 8321 "gnome-chess.c"
	} else {
#line 1445 "../src/gnome-chess.vala"
		_tmp32_ = FALSE;
#line 8325 "gnome-chess.c"
	}
#line 1445 "../src/gnome-chess.vala"
	if (_tmp32_) {
#line 8329 "gnome-chess.c"
		gchar* play_as = NULL;
		GSettings* _tmp35_;
		gchar* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp43_;
		GSettings* _tmp53_;
		const gchar* _tmp54_;
#line 1447 "../src/gnome-chess.vala"
		_tmp35_ = self->priv->settings;
#line 1447 "../src/gnome-chess.vala"
		_tmp36_ = g_settings_get_string (_tmp35_, PLAY_AS_SETTINGS_KEY);
#line 1447 "../src/gnome-chess.vala"
		play_as = _tmp36_;
#line 1449 "../src/gnome-chess.vala"
		_tmp37_ = play_as;
#line 1449 "../src/gnome-chess.vala"
		if (g_strcmp0 (_tmp37_, "alternate") == 0) {
#line 8347 "gnome-chess.c"
			gchar* last_side = NULL;
			GSettings* _tmp38_;
			gchar* _tmp39_;
			const gchar* _tmp40_ = NULL;
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 1451 "../src/gnome-chess.vala"
			_tmp38_ = self->priv->settings;
#line 1451 "../src/gnome-chess.vala"
			_tmp39_ = g_settings_get_string (_tmp38_, LAST_PLAYED_AS_SETTINGS_KEY);
#line 1451 "../src/gnome-chess.vala"
			last_side = _tmp39_;
#line 1452 "../src/gnome-chess.vala"
			_tmp41_ = last_side;
#line 1452 "../src/gnome-chess.vala"
			if (g_strcmp0 (_tmp41_, "white") == 0) {
#line 1452 "../src/gnome-chess.vala"
				_tmp40_ = "black";
#line 8366 "gnome-chess.c"
			} else {
#line 1452 "../src/gnome-chess.vala"
				_tmp40_ = "white";
#line 8370 "gnome-chess.c"
			}
#line 1452 "../src/gnome-chess.vala"
			_tmp42_ = g_strdup (_tmp40_);
#line 1452 "../src/gnome-chess.vala"
			_g_free0 (play_as);
#line 1452 "../src/gnome-chess.vala"
			play_as = _tmp42_;
#line 1449 "../src/gnome-chess.vala"
			_g_free0 (last_side);
#line 8380 "gnome-chess.c"
		}
#line 1455 "../src/gnome-chess.vala"
		_tmp43_ = play_as;
#line 1455 "../src/gnome-chess.vala"
		if (g_strcmp0 (_tmp43_, "white") == 0) {
#line 8386 "gnome-chess.c"
			PGNGame* _tmp44_;
			const gchar* _tmp45_;
			PGNGame* _tmp46_;
			const gchar* _tmp47_;
#line 1457 "../src/gnome-chess.vala"
			_tmp44_ = self->priv->pgn_game;
#line 1457 "../src/gnome-chess.vala"
			_tmp45_ = engine_name;
#line 1457 "../src/gnome-chess.vala"
			pgn_game_set_black_ai (_tmp44_, _tmp45_);
#line 1458 "../src/gnome-chess.vala"
			_tmp46_ = self->priv->pgn_game;
#line 1458 "../src/gnome-chess.vala"
			_tmp47_ = engine_level;
#line 1458 "../src/gnome-chess.vala"
			pgn_game_set_black_level (_tmp46_, _tmp47_);
#line 8403 "gnome-chess.c"
		} else {
			const gchar* _tmp48_;
#line 1460 "../src/gnome-chess.vala"
			_tmp48_ = play_as;
#line 1460 "../src/gnome-chess.vala"
			if (g_strcmp0 (_tmp48_, "black") == 0) {
#line 8410 "gnome-chess.c"
				PGNGame* _tmp49_;
				const gchar* _tmp50_;
				PGNGame* _tmp51_;
				const gchar* _tmp52_;
#line 1462 "../src/gnome-chess.vala"
				_tmp49_ = self->priv->pgn_game;
#line 1462 "../src/gnome-chess.vala"
				_tmp50_ = engine_name;
#line 1462 "../src/gnome-chess.vala"
				pgn_game_set_white_ai (_tmp49_, _tmp50_);
#line 1463 "../src/gnome-chess.vala"
				_tmp51_ = self->priv->pgn_game;
#line 1463 "../src/gnome-chess.vala"
				_tmp52_ = engine_level;
#line 1463 "../src/gnome-chess.vala"
				pgn_game_set_white_level (_tmp51_, _tmp52_);
#line 8427 "gnome-chess.c"
			} else {
#line 1467 "../src/gnome-chess.vala"
				g_assert_not_reached ();
#line 8431 "gnome-chess.c"
			}
		}
#line 1470 "../src/gnome-chess.vala"
		_tmp53_ = self->priv->settings;
#line 1470 "../src/gnome-chess.vala"
		_tmp54_ = play_as;
#line 1470 "../src/gnome-chess.vala"
		g_settings_set_string (_tmp53_, LAST_PLAYED_AS_SETTINGS_KEY, _tmp54_);
#line 1445 "../src/gnome-chess.vala"
		_g_free0 (play_as);
#line 8442 "gnome-chess.c"
	}
#line 1473 "../src/gnome-chess.vala"
	chess_application_start_game (self);
#line 1419 "../src/gnome-chess.vala"
	_g_free0 (engine_level);
#line 1419 "../src/gnome-chess.vala"
	_g_free0 (engine_name);
#line 1419 "../src/gnome-chess.vala"
	_g_date_time_unref0 (now);
#line 8452 "gnome-chess.c"
}

static void
chess_application_load_game (ChessApplication* self,
                             GFile* file)
{
	PGNGame* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 1476 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1476 "../src/gnome-chess.vala"
	g_return_if_fail (file != NULL);
#line 8465 "gnome-chess.c"
	{
		PGN* pgn = NULL;
		PGN* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
		PGNGame* _tmp3_;
#line 1480 "../src/gnome-chess.vala"
		_tmp0_ = pgn_new_from_file (file, &_inner_error0_);
#line 1480 "../src/gnome-chess.vala"
		pgn = _tmp0_;
#line 1480 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8478 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 1481 "../src/gnome-chess.vala"
		_tmp1_ = pgn->games;
#line 1481 "../src/gnome-chess.vala"
		_tmp2_ = g_list_nth_data (_tmp1_, (guint) 0);
#line 1481 "../src/gnome-chess.vala"
		_tmp3_ = _g_object_ref0 ((PGNGame*) _tmp2_);
#line 1481 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->pgn_game);
#line 1481 "../src/gnome-chess.vala"
		self->priv->pgn_game = _tmp3_;
#line 1478 "../src/gnome-chess.vala"
		_g_object_unref0 (pgn);
#line 8493 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1478 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1485 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->pgn_game);
#line 1485 "../src/gnome-chess.vala"
		self->priv->pgn_game = NULL;
#line 8504 "gnome-chess.c"
	}
	__finally0:
#line 1478 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1478 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1478 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1478 "../src/gnome-chess.vala"
		return;
#line 8515 "gnome-chess.c"
	}
#line 1488 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->pgn_game;
#line 1488 "../src/gnome-chess.vala"
	if (_tmp4_ == NULL) {
#line 8521 "gnome-chess.c"
		PGNGame* _tmp5_;
#line 1490 "../src/gnome-chess.vala"
		chess_application_run_invalid_pgn_dialog (self);
#line 1491 "../src/gnome-chess.vala"
		_tmp5_ = pgn_game_new ();
#line 1491 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->pgn_game);
#line 1491 "../src/gnome-chess.vala"
		self->priv->pgn_game = _tmp5_;
#line 1492 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->game_file);
#line 1492 "../src/gnome-chess.vala"
		self->priv->game_file = NULL;
#line 8535 "gnome-chess.c"
	} else {
		GFile* _tmp6_;
#line 1496 "../src/gnome-chess.vala"
		_tmp6_ = _g_object_ref0 (file);
#line 1496 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->game_file);
#line 1496 "../src/gnome-chess.vala"
		self->priv->game_file = _tmp6_;
#line 1497 "../src/gnome-chess.vala"
		chess_application_start_game (self);
#line 8546 "gnome-chess.c"
	}
}

void
chess_application_enable_action (ChessApplication* self,
                                 const gchar* name)
{
	GAction* _tmp0_;
#line 1501 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1501 "../src/gnome-chess.vala"
	g_return_if_fail (name != NULL);
#line 1503 "../src/gnome-chess.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, name);
#line 1503 "../src/gnome-chess.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), TRUE);
#line 8563 "gnome-chess.c"
}

void
chess_application_disable_action (ChessApplication* self,
                                  const gchar* name)
{
	GAction* _tmp0_;
#line 1506 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1506 "../src/gnome-chess.vala"
	g_return_if_fail (name != NULL);
#line 1508 "../src/gnome-chess.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, name);
#line 1508 "../src/gnome-chess.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), FALSE);
#line 8579 "gnome-chess.c"
}

static gint
chess_application_main (gchar** args,
                        gint args_length1)
{
	ChessApplication* _tmp0_;
	ChessApplication* _tmp1_;
	gint _tmp2_;
	gint result;
#line 1513 "../src/gnome-chess.vala"
	setlocale (LC_ALL, "");
#line 1514 "../src/gnome-chess.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 1515 "../src/gnome-chess.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 1516 "../src/gnome-chess.vala"
	textdomain (GETTEXT_PACKAGE);
#line 1518 "../src/gnome-chess.vala"
	g_set_application_name (_ ("Chess"));
#line 1519 "../src/gnome-chess.vala"
	gtk_window_set_default_icon_name ("org.gnome.Chess");
#line 1521 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_new ();
#line 1521 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1521 "../src/gnome-chess.vala"
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
#line 1521 "../src/gnome-chess.vala"
	_g_object_unref0 (_tmp1_);
#line 1521 "../src/gnome-chess.vala"
	result = _tmp2_;
#line 1521 "../src/gnome-chess.vala"
	return result;
#line 8614 "gnome-chess.c"
}

int
main (int argc,
      char ** argv)
{
#line 1511 "../src/gnome-chess.vala"
	return chess_application_main (argv, argc);
#line 8623 "gnome-chess.c"
}

ChessWindow*
chess_application_get_window (ChessApplication* self)
{
	ChessWindow* result;
	ChessWindow* _tmp0_;
#line 43 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 43 "../src/gnome-chess.vala"
	result = _tmp0_;
#line 43 "../src/gnome-chess.vala"
	return result;
#line 8639 "gnome-chess.c"
}

static void
chess_application_set_window (ChessApplication* self,
                              ChessWindow* value)
{
	ChessWindow* old_value;
#line 43 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/gnome-chess.vala"
	old_value = chess_application_get_window (self);
#line 43 "../src/gnome-chess.vala"
	if (old_value != value) {
#line 43 "../src/gnome-chess.vala"
		self->priv->_window = value;
#line 43 "../src/gnome-chess.vala"
		g_object_notify_by_pspec ((GObject *) self, chess_application_properties[CHESS_APPLICATION_WINDOW_PROPERTY]);
#line 8657 "gnome-chess.c"
	}
}

ChessView*
chess_application_get_view (ChessApplication* self)
{
	ChessView* result;
	ChessWindow* _tmp0_;
	ChessView* _tmp1_;
	ChessView* _tmp2_;
#line 48 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 48 "../src/gnome-chess.vala"
	_tmp1_ = chess_window_get_view (_tmp0_);
#line 48 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 48 "../src/gnome-chess.vala"
	result = _tmp2_;
#line 48 "../src/gnome-chess.vala"
	return result;
#line 8680 "gnome-chess.c"
}

ChessScene*
chess_application_get_scene (ChessApplication* self)
{
	ChessScene* result;
	ChessView* _tmp0_;
	ChessView* _tmp1_;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
#line 53 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_view (self);
#line 53 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/gnome-chess.vala"
	_tmp2_ = chess_view_get_scene (_tmp1_);
#line 53 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 53 "../src/gnome-chess.vala"
	result = _tmp3_;
#line 53 "../src/gnome-chess.vala"
	return result;
#line 8705 "gnome-chess.c"
}

static void
chess_application_class_init (ChessApplicationClass * klass,
                              gpointer klass_data)
{
#line 36 "../src/gnome-chess.vala"
	chess_application_parent_class = g_type_class_peek_parent (klass);
#line 36 "../src/gnome-chess.vala"
	g_type_class_adjust_private_offset (klass, &ChessApplication_private_offset);
#line 36 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->handle_local_options = (gint (*) (GApplication*, GVariantDict*)) chess_application_real_handle_local_options;
#line 36 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) chess_application_real_startup;
#line 36 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) chess_application_real_open;
#line 36 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) chess_application_real_activate;
#line 36 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->shutdown = (void (*) (GApplication*)) chess_application_real_shutdown;
#line 36 "../src/gnome-chess.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_application_get_property;
#line 36 "../src/gnome-chess.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_application_set_property;
#line 36 "../src/gnome-chess.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_application_finalize;
#line 36 "../src/gnome-chess.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_APPLICATION_WINDOW_PROPERTY, chess_application_properties[CHESS_APPLICATION_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", TYPE_CHESS_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../src/gnome-chess.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_APPLICATION_VIEW_PROPERTY, chess_application_properties[CHESS_APPLICATION_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_CHESS_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../src/gnome-chess.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_APPLICATION_SCENE_PROPERTY, chess_application_properties[CHESS_APPLICATION_SCENE_PROPERTY] = g_param_spec_object ("scene", "scene", "scene", TYPE_CHESS_SCENE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8738 "gnome-chess.c"
}

static void
chess_application_instance_init (ChessApplication * self,
                                 gpointer klass)
{
	gchar* _tmp0_;
#line 36 "../src/gnome-chess.vala"
	self->priv = chess_application_get_instance_private (self);
#line 56 "../src/gnome-chess.vala"
	self->priv->new_game_dialog = NULL;
#line 57 "../src/gnome-chess.vala"
	self->priv->preferences_dialog = NULL;
#line 58 "../src/gnome-chess.vala"
	self->priv->about_dialog = NULL;
#line 59 "../src/gnome-chess.vala"
	self->priv->open_dialog = NULL;
#line 60 "../src/gnome-chess.vala"
	self->priv->save_dialog = NULL;
#line 63 "../src/gnome-chess.vala"
	self->priv->game = NULL;
#line 66 "../src/gnome-chess.vala"
	self->priv->game_needs_saving = FALSE;
#line 67 "../src/gnome-chess.vala"
	self->priv->starting = TRUE;
#line 69 "../src/gnome-chess.vala"
	self->priv->opponent = NULL;
#line 70 "../src/gnome-chess.vala"
	self->priv->human_player = NULL;
#line 71 "../src/gnome-chess.vala"
	self->priv->opponent_engine = NULL;
#line 72 "../src/gnome-chess.vala"
	self->priv->engine_timeout_source = (guint) 0;
#line 73 "../src/gnome-chess.vala"
	_tmp0_ = g_strdup ("Copyright \302\251 2010\342\200\2232013 Robert Ancell\n" \
"Copyright \302\251 2013\342\200\2232024 Michael Catanzaro\n" \
"Copyright \302\251 2015\342\200\2232016 Sahil Sareen");
#line 73 "../src/gnome-chess.vala"
	self->priv->copyrights = _tmp0_;
#line 8776 "gnome-chess.c"
}

static void
chess_application_finalize (GObject * obj)
{
	ChessApplication * self;
#line 36 "../src/gnome-chess.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_APPLICATION, ChessApplication);
#line 38 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->settings);
#line 39 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->preferences);
#line 56 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->new_game_dialog);
#line 57 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->preferences_dialog);
#line 58 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->about_dialog);
#line 59 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->open_dialog);
#line 60 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->save_dialog);
#line 62 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->pgn_game);
#line 63 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->game);
#line 64 "../src/gnome-chess.vala"
	_g_free0 (self->priv->autosave_filename);
#line 65 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->game_file);
#line 68 "../src/gnome-chess.vala"
	(self->priv->ai_profiles == NULL) ? NULL : (self->priv->ai_profiles = (_g_list_free__g_object_unref0_ (self->priv->ai_profiles), NULL));
#line 69 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->opponent);
#line 70 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->human_player);
#line 71 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->opponent_engine);
#line 73 "../src/gnome-chess.vala"
	_g_free0 (self->priv->copyrights);
#line 36 "../src/gnome-chess.vala"
	G_OBJECT_CLASS (chess_application_parent_class)->finalize (obj);
#line 8819 "gnome-chess.c"
}

static GType
chess_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessApplication), 0, (GInstanceInitFunc) chess_application_instance_init, NULL };
	GType chess_application_type_id;
	chess_application_type_id = g_type_register_static (adw_application_get_type (), "ChessApplication", &g_define_type_info, 0);
	ChessApplication_private_offset = g_type_add_instance_private (chess_application_type_id, sizeof (ChessApplicationPrivate));
	return chess_application_type_id;
}

GType
chess_application_get_type (void)
{
	static volatile gsize chess_application_type_id__once = 0;
	if (g_once_init_enter (&chess_application_type_id__once)) {
		GType chess_application_type_id;
		chess_application_type_id = chess_application_get_type_once ();
		g_once_init_leave (&chess_application_type_id__once, chess_application_type_id);
	}
	return chess_application_type_id__once;
}

static void
_vala_chess_application_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	ChessApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_APPLICATION, ChessApplication);
#line 36 "../src/gnome-chess.vala"
	switch (property_id) {
#line 36 "../src/gnome-chess.vala"
		case CHESS_APPLICATION_WINDOW_PROPERTY:
#line 36 "../src/gnome-chess.vala"
		g_value_set_object (value, chess_application_get_window (self));
#line 36 "../src/gnome-chess.vala"
		break;
#line 36 "../src/gnome-chess.vala"
		case CHESS_APPLICATION_VIEW_PROPERTY:
#line 36 "../src/gnome-chess.vala"
		g_value_set_object (value, chess_application_get_view (self));
#line 36 "../src/gnome-chess.vala"
		break;
#line 36 "../src/gnome-chess.vala"
		case CHESS_APPLICATION_SCENE_PROPERTY:
#line 36 "../src/gnome-chess.vala"
		g_value_set_object (value, chess_application_get_scene (self));
#line 36 "../src/gnome-chess.vala"
		break;
#line 8872 "gnome-chess.c"
		default:
#line 36 "../src/gnome-chess.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../src/gnome-chess.vala"
		break;
#line 8878 "gnome-chess.c"
	}
}

static void
_vala_chess_application_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	ChessApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_APPLICATION, ChessApplication);
#line 36 "../src/gnome-chess.vala"
	switch (property_id) {
#line 36 "../src/gnome-chess.vala"
		case CHESS_APPLICATION_WINDOW_PROPERTY:
#line 36 "../src/gnome-chess.vala"
		chess_application_set_window (self, g_value_get_object (value));
#line 36 "../src/gnome-chess.vala"
		break;
#line 8898 "gnome-chess.c"
		default:
#line 36 "../src/gnome-chess.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../src/gnome-chess.vala"
		break;
#line 8904 "gnome-chess.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

